      SUBROUTINE CUMUMA (I,J,PMAT,COEF,   GMAT)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGELINE  DATE 02/10/95   AUTEUR GIBHHAY A.Y.PORTABILITE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C FONCTION: CUMULE LES ELEMENTS DE LA MATRICE PMAT, MULTIPLIES PAR COEF,
C           A CEUX DE LA MATRICE GMAT, SELON LA FORMULE:
C GMAT((I-1)*6+I1,(J-1)*6+J1) = GMAT((I-1)*6+I1,(J-1)*6+J1) +
C                               PMAT(I1,J1)
C
C     IN  : I,J       : POINTEURS SUR LA MATRICE GMAT
C           PMAT      : MATRICE D'ORDRE 6
C           COEF      : SCALAIRE
C
C     OUT : GMAT      : MATRICE D'ORDRE 18
C ------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 PMAT(6,6),GMAT(18,18)
C
      I1 = (I-1) * 6
      J1 = (J-1) * 6
      DO 12 J2=1,6
      JJ = J1 + J2
      DO 11 I2=1,6
      II = I1 + I2
      GMAT(II,JJ) = GMAT(II,JJ) + COEF*PMAT(I2,J2)
   11 CONTINUE
   12 CONTINUE
 9999 CONTINUE
      END
