      SUBROUTINE DIAGHR (N, A, LDA, EVAL, EVEC, LDEVEC, ACOPY, RWK,
     &                   CWK)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER    N, LDA, LDEVEC
      REAL *8 EVAL(*), RWK(*)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGELINE  DATE 08/04/2008   AUTEUR MEUNIER S.MEUNIER 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C-----------------------------------------------------------------------
C    CALCUL DES VALEURS PROPRES ET DES VECTEURS PROPRES D'UNE MATRICE
C                       COMPLEXE HERMITIENNE.
C-----------------------------------------------------------------------
C IN  : N    : DIMENSION DES MATRICES.
C       A    : MATRICE INITIALE.
C OUT : EVAL : VALEURS PROPRES DE LA MATRICE A.
C       EVEC : VECTEURS PROPRES ASSOCIES AUX VALEURS PROPRES.
C IN  : LDA  : DIMENSION DE LA MATRICE A.
C     :LDEVEC: DIMENSION DE LA MATRICE EVEC.
C      ACOPY : MATRICE DE TRAVAIL.
C      RWK   : VECTEUR DE TRAVAIL.
C      CWK   : VECTEUR DE TRAVAIL.
C-----------------------------------------------------------------------
      COMPLEX*16 A(LDA,*), EVEC(LDEVEC,*), ACOPY(N,*), CWK(*)
      INTEGER    I, J
      COMPLEX*16 SCALE
      REAL*8     DBLE
      INTEGER    IZAMAX
C
      IF (N .LT. 1) THEN
CC         WRITE(6,*) 'THE ARGUMENT N = %(I1).  THE '//
CC     &               'ORDER OF THE MATRIX MUST BE AT LEAST 1.'
         CALL ASSERT(.FALSE.)
      END IF
C
      IF (LDA .LT. N) THEN
CC          WRITE(6,*) 'THE ARGUMENT LDA = %(I1).  THE '//
CC     &               'LEADING DIMENSION OF THE MATRIX MUST BE AT '//
CC     &               'LEAST EQUAL TO THE ORDER, N = %(I2).'
         CALL ASSERT(.FALSE.)
      END IF
C
      IF (LDEVEC .LT. N) THEN
CC         WRITE(6,*)  'THE ARGUMENT LDEVEC = %(I1).  THE '//
CC     &               'LEADING DIMENSION OF THE EIGENVECTOR MATRIX '//
CC     &               'MUST BE AT LEAST EQUAL TO THE ORDER, N = '//
CC     &               '%(I2).'
         CALL ASSERT(.FALSE.)
      END IF
C    --- A EST COPIEE DANS ACOPY
      DO 10  I=1, N
         CALL ZCOPY (I, A(1,I), 1, ACOPY(1,I), 1)
   10 CONTINUE
C
      CALL MEXTHR (N, ACOPY, N)
C
      CALL R8INIR (N*N, 0.0D0, RWK(N+1), 1)
      CALL R8INIR (N, 1.0D0, RWK(N+1), N+1)
C
C   --- REDUCTION EN UNE MATRICE SYMETRIQUE TRIDIAGONALE ---
      CALL TRIDIA (N, ACOPY, N, EVAL, RWK, CWK, CWK(N+1))
C
C   --- CALCUL DES VECTEURS ET DES VALEURS PROPRES ---
      CALL DIATRI (N, EVAL, RWK, .TRUE., RWK(N+1), N)
C
C   --- LES VECTEURS PROPRES SONT STOCKES DANS UNE MATRICE COMPLEXE ---
      CALL CVRMZM (N, RWK(N+1), N, EVEC, LDEVEC)
C
C   --- TRANSFORMATION DES VECTEURS PROPRES ---
      CALL DIARES (N, N, ACOPY, N, CWK, EVEC, LDEVEC, CWK(N+1))
C
C   --- NORMALISATION DES VECTEURS PROPRES ---
      DO 20  J=1, N
         SCALE = EVEC(IZAMAX(N,EVEC(1,J),1),J)
         IF (DBLE(SCALE).NE.0.0D0 .OR. DIMAG(SCALE).NE.0.0D0)
     &       CALL ZMULT (N, 1.0D0/SCALE, EVEC(1,J), 1)
   20 CONTINUE
C
      END
