      SUBROUTINE DIARES (N, NEVEC, A, LDA, TAU, EVEC, LDEVEC, WORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER    N, NEVEC, LDA, LDEVEC
      COMPLEX    *16 A(LDA,*), TAU(*), EVEC(LDEVEC,*), WORK(*)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGELINE  DATE 02/10/95   AUTEUR GIBHHAY A.Y.PORTABILITE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C-----------------------------------------------------------------------
C      REDUCTION D'UNE MATRICE HERMITIENNE EN UNE MATRICE TRIDIAGONALE
C          SYMETRIQUE (METHODE DE HOUSEHOLDER).
C-----------------------------------------------------------------------
C IN  : N    : DIMENSION DES MATRICES.
C     : NEVEC: NOMBRE DE VECTEURS PROPRES A DETERMINER
C     : A    : MATRICE COMPLEXE D'ORDRE N. SEULE LA PARTIE TIANGULAIRE
C              INFERIEURE DE LA MATRICE DE HOUSEHOLDER EST STOCKEE.
C     : LDA  : DIMENSION DE A
C     : TAU  : VECTEUR COMPLXE DE DIMENSION N, CONTENANT LA DIAGONALE
C              DE LA MATRICE UNITAIRE T.
C I/O : EVEC : MATRICE COMPLEXE D'ORDRE N.
C         IN : CONTIENT LES VECTEURS PROPRES DE LA MATRICE TRIDIAGONALE
C        OUT : CONTIENT LES VECTEURS PROPRES DE LA MATRICE INITIALE.
C IN  :LDEVEC: DIMENSION DE LA MATRICE EVEC.
C OUT : WORK : VECTEUR COMPLEXE (ZONE DE TRAVAIL).
C-----------------------------------------------------------------------
      INTEGER    J, NR
      REAL *8 DELTA
      REAL *8 AIMAG, CABS
      COMPLEX    *16 CMPLX, CONJG
C
      DO 10  J=2, N
         CALL ZMULT (NEVEC, DCONJG(TAU(J)), EVEC(J,1), LDEVEC)
   10 CONTINUE
C
C  --- STOCKAGE DE LA MATRICE DE HOUSEHOLDER DANS L'ORDRE INVERSE ---
      DO 20  NR=N - 1, 2, -1
         DELTA = DIMAG(A(NR,NR))*ABS(A(NR,NR-1))
         IF (DELTA .NE. 0.0D0) THEN
            CALL ZMULMV ('CONJUGATE', N-NR+1, NEVEC, (1.0D0,0.0D0),
     &                  EVEC(NR,1), LDEVEC, A(NR,NR-1), 1,
     &                  (0.0D0,0.0D0), WORK, 1)
            CALL ZADDRC (N-NR+1, NEVEC, DCMPLX(-1.0D0/DELTA,0.0D0),
     &                  A(NR,NR-1), 1, WORK, 1, EVEC(NR,1), LDEVEC)
         END IF
   20 CONTINUE
 9999 CONTINUE
      END
