      SUBROUTINE RESOU2(MATR,LMAT,NSECM,RSOLU,CSOLU)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGELINE  DATE 13/10/2010   AUTEUR BOITEAU O.BOITEAU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2008  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================

C-----------------------------------------------------------------------
C BUT : RESOUDRE UN SYSTEME LINEAIRE D'EQUATIONS (REEL OU COMPLEXE)
C CETTE ROUTINE EST UN "CHAPEAU" A RESOUD POUR AVOIR MOINS D'ARGUMENTS
C-----------------------------------------------------------------------
C
C ARGUMENTS:
C-----------
C
C IN/JXIN  K19 MATR   : MATR_ASSE PREMIER MEMBRE DU SYSTEME LINEAIRE
C IN       I   LMAT   : ADRESSE DU DESCRIPTEUR DE LA MATRICE
C
C REMARQUE : ON UTILISE (AU CHOIX) L'UN DES 2 ARGUMENTS MATR OU LMAT
C
C IN       I   NSECM  : NOMBRE DE SECONDS MEMBRES
C IN/OUT   R   RSOLU(*,NSECM)  :
C        EN ENTREE : VECTEUR DE REELS CONTENANT LES SECONDS MEMBRES
C        EN SORTIE : VECTEUR DE REELS CONTENANT LES SOLUTIONS
C IN/OUT   C   CSOLU(*,NSECM)  : IDEM RSOLU POUR LES COMPLEXES.
C-----------------------------------------------------------------------
      IMPLICIT NONE

      CHARACTER*(*) MATR
      INTEGER NSECM,LMAT
      REAL*8 RSOLU(*)
      COMPLEX*16 CSOLU(*)

C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      CHARACTER*32 JEXNUM,JEXNOM,JEXATR
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC,CBID
      COMMON /CVARJE/ZC(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
      CHARACTER*19 MATR2
      INTEGER IBID
C ----------------------------------------------------------------------

      IF (MATR.NE.' ') THEN
        CALL ASSERT(LMAT.EQ.0)
        MATR2=MATR
      ELSE
        CALL ASSERT(LMAT.NE.0)
        MATR2=ZK24(ZI(LMAT+1))
      ENDIF
      CALL ASSERT(MATR2.NE.' ')

      CALL RESOUD(MATR2,' ',' ',' ',' ',' ',' ',
     &                  ' ',NSECM,RSOLU,CSOLU,.TRUE.)
      END
