      FUNCTION TYPMAT(NBMAT,TLIMAT)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGELINE  DATE 26/05/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
      CHARACTER*(*) TLIMAT(*)
      INTEGER NBMAT
      CHARACTER*1 TYPMAT
C-----------------------------------------------------------------------
C
C  BUT : CETTE FONCTION RETOURNE LE TYPE SYMETRIQUE : 'S'
C                                     OU PLEINE     : 'N'
C        DE LA MATRICE GLOBALE RESULTANTE DE L'ASSEMBLAGE
C        DES MATR_ELEM TLIMAT
C  ATTENTION :
C    SI ON EST EN PARALLELE MPI, LA REPONSE EST GLOBALE.
C    CETTE ROUTINE FAIT DU MPI_ALLREDUCE. IL FAUT DONC L'APPELER
C    DE LA MEME FACON SUR TOUS LES PROCS.
C
C-----------------------------------------------------------------------
C --- DESCRIPTION DES PARAMETRES
C IN  I  NBMAT  : NOMBRE DE MATR_ELEM DE LA LISTE TLIMAT
C IN  K* TLIMAT : LISTE DES MATR_ELEM
C ----------------------------------------------------------------------
      REAL*8 RBID
      COMPLEX*16 CBID
C----------------------------------------------------------------------
      CHARACTER*8 SYM,PARTIT,ZERO
      CHARACTER*19 MATEL
      INTEGER I,ITYMAT
      INTEGER IBID, IERD
      INTEGER IEXI,IEXIAV
C----------------------------------------------------------------------
C     ITYMAT =  0 -> SYMETRIQUE
C            =  1 -> NON-SYMETRIQUE
C
C     --  PAR DEFAUT LE TYPE DE MATRICE EST SYMETRIQUE
      ITYMAT = 0

      DO 10 I =1, NBMAT
        MATEL = TLIMAT(I)
        CALL JEEXIN(MATEL//'.RELR',IEXI)
        IEXI=MIN(1,ABS(IEXI))
        IEXIAV=IEXI
        CALL MPICM1('MPI_MAX','I',1,IEXI,RBID)
        IEXI=MIN(1,ABS(IEXI))
        CALL ASSERT(IEXI.EQ.IEXIAV)
        IF (IEXI.EQ.0) GOTO 10

C       -- LA LOGIQUE CI-DESSOUS N'EST VALABLE QUE SI LE MATR_ELEM
C          A ETE EXPURGE DE SES RESUELEM NULS => CALL REDETR()
        CALL REDETR(MATEL)

        CALL DISMOI('F','TYPE_MATRICE',MATEL,'MATR_ELEM',IBID,SYM,IERD)
        IF (SYM.EQ.'NON_SYM') THEN
          CALL DISMOI('F','ZERO',MATEL,'MATR_ELEM',IBID,ZERO,IERD)
          IF (ZERO.EQ.'NON') THEN
            ITYMAT = 1
          ENDIF
        ENDIF

        CALL MPICM1('MPI_MAX','I',1,ITYMAT,RBID)
        IF (ITYMAT.EQ.1)  GOTO 11

   10 CONTINUE
   11 CONTINUE

      IF (ITYMAT.EQ.0) THEN
         TYPMAT='S'
      ELSE
         TYPMAT='N'
      ENDIF
      END
