      SUBROUTINE VPSTUR(LMATK,VALSHI,LMATM,LMATSH,MANTIS,EXPO,
     &                  PIVOT,IER,SOLVEU)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8          VALSHI,MANTIS
      INTEGER         LMATK,LMATM,LMATSH,EXPO,PIVOT,IER
      CHARACTER*19    SOLVEU
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGELINE  DATE 13/10/2010   AUTEUR BOITEAU O.BOITEAU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C     ------------------------------------------------------------------
C     EFFECTUE L'OPERATION DE STURM
C        1) COMBINAISON LINEAIRE MSH =  K - W * M    (W ETANT LE SHIFT)
C        2) DECOMPOSITION DE  MSH
C        3) NOMBRE DE PIVOT NEGATIF
C        4) CALCUL DU DETERMINANT
C     ------------------------------------------------------------------
C IN  VALSHI : R8 : VALEUR DU DECALAGE
C IN  LMATK  : IS : ADRESSE ATTRIBUT MATRICE K
C IN  LMATM  : IS : ADRESSE ATTRIBUT MATRICE M
C IN  LMATSH : IS : ADRESSE ATTRIBUT MATRICE SHIFTEE
C OUT MANTIS : R8 : MANTISSE DU DETERMINANT
C IN/OUT EXPO: IS : EXPOSANT DU DETERMINANT
C              SI EN INPUT EXPO=-9999, ON NE FAIT PAS LA CALCUL DU DET
C OUT PIVOT  : IS : NOMBRE DE TERMES DIAGONAUX NEGATIFS
C OUT IER    : IS : CODE RETOUR  /= 0 ==> LE SHIFT EST UNE VALEUR PROPRE
C IN  SOLVEU : K19 : SD SOLVEUR POUR PARAMETRER LE SOLVEUR LINEAIRE
C     ------------------------------------------------------------------
C
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER          ZI
      COMMON  /IVARJE/ ZI(1)
      REAL*8           ZR
      COMMON  /RVARJE/ ZR(1)
      COMPLEX*16       ZC
      COMMON  /CVARJE/ ZC(1)
      LOGICAL          ZL
      COMMON  /LVARJE/ ZL(1)
      CHARACTER*8      ZK8
      CHARACTER*16              ZK16
      CHARACTER*24                        ZK24
      CHARACTER*32                                  ZK32
      CHARACTER*80                                            ZK80
      COMMON  /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
C
      INTEGER          IRET,NPVNEG,ISLVK
      REAL*8           EPS,FREQOM,VALR
      CHARACTER*16     RBID,NOMCMD
      CHARACTER*19     MATPRE,MATASS
      CHARACTER*24     METRES
C     ------------------------------------------------------------------
C
      CALL JEMARQ()
     
C     --- DECALAGE SPECTRAL  K - W * M    (W ETANT LE SHIFT) ---
      CALL VPSHIF(LMATK,VALSHI,LMATM,LMATSH)
C
C     --- FACTORISATION LDLT DE LA MATRICE SHIFTEE---
      IER=0
C
      MATPRE=' '
      MATASS=ZK24(ZI(LMATSH+1))
      CALL PRERES(SOLVEU,'V',IRET,MATPRE,MATASS,NPVNEG,2)
C
      IF (IRET.GE.1) IER = 1
      IF (IRET.GT.1) THEN
        CALL GETRES(RBID,RBID,NOMCMD)
        VALR = FREQOM(VALSHI)
        CALL U2MESG('A','ALGELINE5_27',0,' ',0,0,1,VALR)
      ENDIF
      PIVOT = - NPVNEG
C
C     --- CALCUL DU DETERMINANT ---
      IF (EXPO.NE.-9999) THEN
        CALL JEVEUO(SOLVEU//'.SLVK','L',ISLVK)
        METRES=ZK24(ISLVK)
        IF ((METRES(1:8).NE.'MULT_FRO').AND.(METRES(1:4).NE.'LDLT'))
     &    CALL U2MESS('F','ALGELINE5_73')
        CALL MTDETE(LMATSH,MANTIS,EXPO )
      ENDIF
      CALL JEDEMA()
      END
