      SUBROUTINE VRREFE  ( OBJET1, OBJET2, IER )
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*(*)        OBJET1, OBJET2
      INTEGER                              IER
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGELINE  DATE 29/09/2006   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C     ------------------------------------------------------------------
C     VERIFICATION QUE DEUX CONCEPTD ONT MEME DOMAINE DE DEFINITION
C         ==> COMPARAISON DES "REFE"
C     LES CONCEPTS DOIVENT ETRE DE TYPE MATR_ASSE_GD, CHAM_NO
C     OU CHAM_ELEM
C     ------------------------------------------------------------------
C IN  OBJET1  : CH*19 : NOM DU 1-ER CONCEPT
C IN  OBJET2  : CH*19 : NOM DU 2-ND CONCEPT
C OUT IER     : IS   : CODE RETOUR
C                = 0 PAS D'ERREUR
C                > 0 NOMBRE DE DESCRIPTEURS DIFFERENTS
C     ------------------------------------------------------------------
C
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER          ZI
      COMMON  /IVARJE/ ZI(1)
      REAL*8           ZR
      COMMON  /RVARJE/ ZR(1)
      COMPLEX*16       ZC
      COMMON  /CVARJE/ ZC(1)
      LOGICAL          ZL,OK,IDENSD
      COMMON  /LVARJE/ ZL(1)
      CHARACTER*8      ZK8
      CHARACTER*16              ZK16
      CHARACTER*24                        ZK24
      CHARACTER*32                                  ZK32
      CHARACTER*80                                            ZK80
      COMMON  /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
C
      INTEGER      NBVAL, IVAL1, IVAL2
      CHARACTER*8  CTYP , CBID
      CHARACTER*19  NOM1, NOM2
      CHARACTER*24  REFE1, REFE2
      LOGICAL REFA,CELK,LGENE
C     ------------------------------------------------------------------
      CALL JEMARQ()
C
      IER    = 0
      NOM1   = OBJET1
      NOM2   = OBJET2

C  SI OBJET1 ET OBJET2 SONT DES CHAM_NO : ON COMPARE LEUR .REFE
C  SI OBJET1 ET OBJET2 SONT DES MATR_ASSE : ON COMPARE LEUR .REFA
      REFA=.FALSE.
      CELK=.FALSE.
      REFE1 = NOM1//'.REFE'
      CALL JEEXIN(REFE1,IRET)
      IF (IRET.GT.0) THEN
        REFE2 = NOM2//'.REFE'
      ELSE
         REFE1 = NOM1//'.REFA'
         CALL JEEXIN(REFE1,IRET)
         IF (IRET.GT.0) THEN
           REFE2 = NOM2//'.REFA'
           REFA=.TRUE.
         ELSE
           REFE1 = NOM1//'.CELK'
           CALL JEEXIN(REFE1,IRET)
           IF (IRET.GT.0) THEN
             REFE2 = NOM2//'.CELK'
             CELK=.TRUE.
           ELSE
             CALL U2MESS('F','ALGELINE3_90')
           ENDIF
         ENDIF
      ENDIF

C
C     --- RECUPERATION DES LONGUEURS DES TABLEAUX DE REFERENCE ---
      CALL JELIRA(REFE1,'LONMAX',IVAL1,CBID)
      CALL JELIRA(REFE2,'LONMAX',IVAL2,CBID)
      IF ( IVAL1 .NE. IVAL2 )  IER   = IER + ABS(IVAL1-IVAL2)
C
C     --- RECUPERATION DES TABLEAUX D'INFORMATIONS DE REFERENCE ---
      CALL JEVEUO(REFE1,'L',IREFE1)
      CALL JEVEUO(REFE2,'L',IREFE2)
C
C     --- CONTROLE DES REFERENCES ---

      IF (REFA) THEN
        LGENE=ZK24(IREFE1-1+10).EQ.'GENE'
        IF (.NOT.LGENE) THEN
C         -- CAS DES MATR_ASSE :
          IF (ZK24(IREFE1-1+1).NE.ZK24(IREFE2-1+1)) IER=IER+1
          IF (ZK24(IREFE1-1+2).NE.ZK24(IREFE2-1+2)) IER=IER+1
        ELSE
C         -- CAS DES MATR_ASSE_GENE :
          IF (ZK24(IREFE1-1+2).NE.ZK24(IREFE2-1+2)) IER=IER+1
        ENDIF

      ELSE IF (CELK) THEN
C       -- cas des cham_elem :
C       POUR LES CHAM_ELEM ON NE VERIFIE PAS L OPTION
C       CAR QUELQUES OPTIONS METALLURGIQUES PRODUISENT
C       DES CHAMPS QUE L ON SOUHAITE COMBINER
C       ON VERIFIE DONC LE LIGREL ET LE TYPE DE CHAMP
        IF (ZK24(IREFE1).NE.ZK24(IREFE2)) IER=IER+1
        CALL JEVEUO(NOM1//'.CELD','L',IREFE1)
        CALL JEVEUO(NOM2//'.CELD','L',IREFE2)
        IF (ZI(IREFE1).NE.ZI(IREFE2)) IER=IER+1

      ELSE
C       -- cas des cham_no :
        IF (ZK24(IREFE1).NE.ZK24(IREFE2)) IER=IER+1
        OK=IDENSD('PROF_CHNO',ZK24(IREFE1+1),ZK24(IREFE2+1))
        IF (.NOT.OK) IER=IER+1
      END IF

      CALL JEDEMA()
      END
