      SUBROUTINE VTCOPY(CHIN,CHOUT)
      IMPLICIT NONE
      CHARACTER*(*)       CHIN,CHOUT
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGELINE  DATE 04/10/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C     RECOPIE LES VALEURS DU CHAM_NO CHIN DANS LE CHAM_NO CHOUT
C     CETTE ROUTINE PERMET DE CHANGER LA NUMEROTATION D'UN CHAM_NO
C
C     PRECAUTIONS D'EMPLOI :
C     - LES CHAM_NOS DOIVENT EXISTER.
C     - LES DDLS DE "LAGRANGE" SONT MIS A ZERO DANS CHOUT.
C
C     ------------------------------------------------------------------
C
C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------
C
      CHARACTER*32       JEXNUM , JEXNOM , JEXR8 , JEXATR
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
C
      INTEGER        IRET,NBSD,ILIMPI,IRET1,IFETC1,IFETC2,IDD
      CHARACTER*8    K8BID
      CHARACTER*19   CH1,CH2
      CHARACTER*24   CH1ESC,CH2ESC
C     ------------------------------------------------------------------
C
      CALL JEMARQ ( )
      CH1 = CHIN
      CH2 = CHOUT

C --- RECOPIE DES CHAM_NOS "MAITRE"

      CALL VTCOP1(CH1,CH2)
      CALL JEEXIN(CH1(1:19)//'.FETC',IRET)

C --- SI FETI, ON DUPLIQUE AUSSI LES CHAM_NO ESCLAVES
      IF (IRET.NE.0) THEN
        CALL JELIRA(CH1(1:19)//'.FETC','LONMAX',NBSD,K8BID)
        CALL JEVEUO('&FETI.LISTE.SD.MPI','L',ILIMPI)
        CALL JEVEUO(CH1(1:19)//'.FETC','L',IFETC1)
        CALL JEEXIN(CH2(1:19)//'.FETC',IRET1)
C --- SI LE CHAM_NO CHOUT N'EST PAS FETI, ON S'ARRETE EN ERREUR FATALE
        IF (IRET1.EQ.0) THEN
          CALL U2MESS('F','ALGELINE3_96')
        ELSE
          CALL JEVEUO(CH2(1:19)//'.FETC','L',IFETC2)
        ENDIF
C --- BOUCLE SUR LES SOUS-DOMAINES
        DO 10 IDD=1,NBSD
          IF (ZI(ILIMPI+IDD).EQ.1)  THEN
            CH1ESC=ZK24(IFETC1+IDD-1)
            CH2ESC=ZK24(IFETC2+IDD-1)
            CALL VTCOP1(CH1ESC,CH2ESC)
          ENDIF
   10   CONTINUE
      ENDIF

      CALL JEDEMA ( )
      END
