      SUBROUTINE ZADDRC (M, N, ALPHA, X, INCX, Y, INCY, A, LDA)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER    M, N, INCX, INCY, LDA
      COMPLEX    *16 ALPHA, X(*), Y(*)
      COMPLEX    *16 A(*)
      INTEGER    I1X
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGELINE  DATE 29/09/95   AUTEUR GIBHHAY A.Y.PORTABILITE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C-----------------------------------------------------------------------
C    CALCUL DE ALPHA*CONJG(Y)'
C-----------------------------------------------------------------------
C IN  : M    : NOMBRE DE LIGNE DE A.
C     : N    : NOMBRE DE COLONNE DE A.
C     : ALPHA: COMPLEXE.
C     : X    : VECTEUR COMPLEXE DE LONGUEUR (M-1)*IABS(INCX)+1.
C     : INCX : DEPLACEMENT ENTRE LES ELEMENTS DE X.
C     : Y    : VECTEUR COMPLEXE DE LONGUEUR (N-1)*IABS(INCY)+1.
C     : INCY : DEPLACEMENT ENTRE LES ELEMENTS DE Y.
C I/O : A    : MATRICE COMPLEXE DE DIMENSION M*N.
C IN  : LDA  : DIMENSION DE A.
C-----------------------------------------------------------------------
      INTEGER    IY, J
      COMPLEX    *16 CONJG
      IF (M.EQ.0 .OR. N.EQ.0 .OR. ALPHA.EQ.(0.0D0,0.0D0)) GO TO 9000
C
      IY = 1
      IF (INCY .LT. 0) IY = (-N+1)*INCY + 1
C
      I1X = 1
      DO 130  J=1, N
         CALL ZAXPY (M, ALPHA*DCONJG(Y(IY)), X, INCX, A(I1X), 1)
         IY = IY + INCY
         I1X = I1X + LDA
  130 CONTINUE
C
 9000 CONTINUE
      GOTO 9999
 9999 CONTINUE
      END
