      SUBROUTINE ALIMRS(MATE,MA1,MA2,MOINT,NDBLE,NUM,CN1,CHNO,CMP,ICOR)
      IMPLICIT REAL*8  (A-H,O-Z)
      CHARACTER*(*) MOINT,CMP,CHNO,MATE
C---------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 14/01/98   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C---------------------------------------------------------------------
C     AUTEUR : G. ROUSSEAU
C     BUT : IMMERGER UN CHAMP AUX NOEUDS DE DEPLACEMENT
C           D UNE STRUCTURE APPARTENANT A UN MAILLAGE
C           DANS UN MODELE D INTERFACE THERMIQUE APPARTENANT
C           A UN AUTRE MAILLAGE
C     IN: MATE: NOM DU MATERIAU FLUIDE
C     IN: MA1 : MAILLAGE DE LA STRUCTURE
C     IN: MA2 : MAILLAGE DU FLUIDE
C     IN: MOINT: NOM DU MODELE THERMIQUE D INTERFACE
C     IN: NDBLE: INDICATEUR DE NOEUDS DOUBLES
C     IN: NUM: NUMEDDL ASSOCIE A L INTERFACE
C     IN: CN1: CHAMP AUX NOEUDS DE DEPL_R MODAL DE LA STRUCTURE
C     IN: CHNO: NOM DU CHAMP THERMIQUE A CREER
C     IN: CMP: COMPOSANTE DE DEPL_R A PLONGER
C     IN: ICOR(1):  ADRESSE JEVEUX D UN TABLEAU DE CORRESPONDANCE
C               NOEUDS FLUIDES - NOEUDS STRUCTURES (NOEUDS SIMPLES)
C     IN: ICOR(2):  ADRESSE JEVEUX D UN TABLEAU DE CORRESPONDANCE
C               NOEUDS FLUIDES - NOEUDS STRUCTURES (NOEUDS DOUBLES)
C
C
C
C---------------------------------------------------------------------
C--------- DEBUT DES COMMUNS JEVEUX ----------------------------------
      CHARACTER*32     JEXNUM, JEXNOM, JEXR8, JEXATR
      INTEGER          ZI
      COMMON  /IVARJE/ ZI(1)
      REAL*8           ZR
      COMMON  /RVARJE/ ZR(1)
      COMPLEX*16       ZC
      COMMON  /CVARJE/ ZC(1)
      LOGICAL          ZL
      COMMON  /LVARJE/ ZL(1)
      CHARACTER*8      ZK8
      CHARACTER*16           ZK16
      CHARACTER*24                    ZK24
      CHARACTER*32                            ZK32
      CHARACTER*80                                    ZK80
      COMMON  /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C     --- FIN DES COMMUNS JEVEUX ------------------------------------
      LOGICAL       TEST, EXISDG
      INTEGER       NBVALE,NBREFE,NBDESC,IBID,NBDDL
      INTEGER       I,J,INO1,INO2,NOCMP,ICOR(2),ICHNUL,NDBLE
      REAL*8        R8BID
      REAL*8        TAILMI,DISTAN
      CHARACTER*8   GD1,GD2,MA1,MA2
      CHARACTER*8   K8BID,REPK
      CHARACTER*14  NUM
      CHARACTER*19  CHNUL,CN1,CN2,PCHNO1,PCHNO2
      CHARACTER*24  PRCHNO
      CHARACTER*1 K1BID
C -----------------------------------------------------------------
C---------------------------------------------------------------------
C TESTS PRELIMINAIRES : NUMERO DE COMPOSANTE A TRAITER
C
      CALL JEMARQ()
         IF (CMP.EQ.'DX') NOCMP=1
         IF (CMP.EQ.'DY') NOCMP=2
         IF (CMP.EQ.'DZ') NOCMP=3

C RECUPERATION DE LA TAILLE DE REFERENCE

      CALL GETVR8(' ','DIST_REFE',0,1,1,TAILMI,NBID)


C ON CREE UN CHAMNO BIDON SUR L INTERFACE THERMIQUE

        CALL DISMOI('F','NB_NO_MAILLA',MA2,'MAILLAGE',NBNO2,REPK,IERD)
        CHNUL='&&ALIMRS.CHNUL'
        CALL DISMOI('F','NB_EQUA',NUM,'NUME_DDL',NEQ,K8BID,IERD)
        PRCHNO = NUM//'.NUME'
        CALL CRCHNO(CHNUL,PRCHNO,'TEMP_R',MA2,'V','R',NBNO2,NEQ)
        CALL JEVEUO(CHNUL//'.VALE','E',ICHNUL)
C
        CN2=CHNO
        CALL CALFLU(CHNUL,MOINT,MATE,NUM,CN2,NBDESC,NBREFE,
     +                 NBVALE,'X')


C
C PARCOURS DU MAILLAGE STRUCTURE
C

      CALL DISMOI('F','NOM_GD',CN2,'CHAM_NO',IBID,GD2,IERD)
      CALL DISMOI('F','NOM_GD',CN1,'CHAM_NO',IBID,GD1,IERD)

      CALL DISMOI('F','NB_NO_MAILLA',MA1,'MAILLAGE',NBNO1,REPK,IERD)
      CALL DISMOI('F','PROF_CHNO',CN2,'CHAM_NO',IBID,PCHNO2,IERD)





      CALL DISMOI('F','PROF_CHNO',CN1,'CHAM_NO',IBID,PCHNO1,IERD)

      CALL JENONU(JEXNOM(PCHNO1//'.LILI','&MAILLA'),IBID)
      CALL JEVEUO(JEXNUM(PCHNO1//'.PRNO',IBID),'L',IPRN1)
      CALL JENONU(JEXNOM(PCHNO1//'.LILI','&MAILLA'),IBID)
      CALL JEVEUO(JEXNUM(PCHNO2//'.PRNO',IBID),'L',IPRN2)

      CALL DISMOI('F','NB_EC',GD1,'GRANDEUR',NEC1,REPK,IERD)
      CALL DISMOI('F','NB_EC',GD2,'GRANDEUR',NEC2,REPK,IERD)

      CALL JEVEUO(PCHNO1//'.NUEQ','L',INUEQ1)
      CALL JEVEUO(PCHNO2//'.NUEQ','L',INUEQ2)

      CALL JEVEUO(CN1//'.VALE','L',IAVAL1)
      CALL JEVEUO(CN2//'.VALE','E',IAVAL2)


      CALL JEVEUO(MA2//'.COORDO    .VALE','L',IGEOM2)
      CALL JEVEUO(MA1//'.COORDO    .VALE','L',IGEOM1)

C PARCOURS SUR LES NOEUDS DU MAILLAGE STRUCTURE
C ON REPERE LES NOEUDS COINCIDENTS GEOMETRIQUEMENT
C AVEC LES NOEUDS DE L INTERFACE FLUIDE

           DO 10, INO1 =1,NBNO1

               IF (ZI(ICOR(1)+INO1-1).EQ.0) GOTO 10

               NCMP2= ZI(IPRN2-1+ (ZI(ICOR(1)+INO1-1)-1)* (NEC2+2)+2)
               IF (NCMP2.EQ.0) GOTO 20

               IVAL2 = ZI(IPRN2-1+(ZI(ICOR(1)+INO1-1)-1)* (NEC2+2)+1)
               IEQ2  = ZI(INUEQ2-1+IVAL2-1+1)

               IVAL1 = ZI(IPRN1-1+ (INO1-1)* (NEC1+2)+1)
               IADG1 = IPRN1 - 1 + (INO1-1)* (NEC1+2) + 3

C EXISTENCE DE LA COMPOSANTE A PLONGER DANS LE CHAMNO
C DE DEPL_R DE LA STRUCTURE : SI ELLE EXISTE, ON LA
C RECOPIE DANS LE CHAMNO DE TEMP_R CREE SUR
C L INTERFACE
                  TEST = EXISDG(ZI(IADG1),NOCMP)

                  IF (TEST) THEN

                    IEQ1  = ZI(INUEQ1-1+IVAL1-1+NOCMP)

C RECOPIE DE LA VALEUR DE DX, DY
C OU DZ DANS LA CMP DE TEMP DE CN2 DU NOEUD
C GEOMETRIQUEMENT COINCIDENT

                    ZR(IAVAL2-1+IEQ2) = ZR(IAVAL1-1+IEQ1)
                    GOTO 20

                  ENDIF

C PRECHERCHE DE NOEUDS DOUBLES

20             CONTINUE
               IF (NDBLE.EQ.1) THEN

               IF (ZI(ICOR(2)+INO1-1).EQ.0) GOTO 10

               NCMP2= ZI(IPRN2-1+ (ZI(ICOR(2)+INO1-1)-1)* (NEC2+2)+2)
               IF (NCMP2.EQ.0) GOTO 10

               IVAL2 = ZI(IPRN2-1+(ZI(ICOR(2)+INO1-1)-1)* (NEC2+2)+1)
               IEQ2  = ZI(INUEQ2-1+IVAL2-1+1)

               IVAL1 = ZI(IPRN1-1+ (INO1-1)* (NEC1+2)+1)
               IADG1 = IPRN1 - 1 + (INO1-1)* (NEC1+2) + 3

C EXISTENCE DE LA COMPOSANTE A PLONGER DANS LE CHAMNO
C DE DEPL_R DE LA STRUCTURE : SI ELLE EXISTE, ON LA
C RECOPIE DANS LE CHAMNO DE TEMP_R CREE SUR
C L INTERFACE
                  TEST = EXISDG(ZI(IADG1),NOCMP)

                  IF(TEST) THEN

                    IEQ1  = ZI(INUEQ1-1+IVAL1-1+NOCMP)

C RECOPIE DE LA VALEUR DE DX, DY
C OU DZ DANS LA CMP DE TEMP DE CN2 DU NOEUD
C GEOMETRIQUEMENT COINCIDENT

                    ZR(IAVAL2-1+IEQ2) = ZR(IAVAL1-1+IEQ1)
                    GOTO 10

                  ENDIF
               ENDIF


10    CONTINUE
          CALL JEDETC('V',CHNUL,1)

      CALL JEDEMA()
      END
