      SUBROUTINE APCHOI(DIST  ,DISTM ,POSMAI,POSMAM,TAU1  ,
     &                  TAU1M ,TAU2  ,TAU2M ,KSI1  ,KSI1M ,
     &                  KSI2  ,KSI2M ,IPROJ ,IPROJM,VECT  ,
     &                  VECTM )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 14/09/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INTEGER      IPROJ,IPROJM
      REAL*8       DIST,DISTM
      INTEGER      POSMAI,POSMAM
      REAL*8       TAU1(3),TAU1M(3)
      REAL*8       TAU2(3),TAU2M(3)
      REAL*8       VECT(3),VECTM(3)
      REAL*8       KSI1,KSI1M
      REAL*8       KSI2,KSI2M
C      
C ----------------------------------------------------------------------
C
C ROUTINE APPARIEMENT (ALGO)
C
C CHOIX DE LA MAILLE LA PLUS PROCHE 
C
C ----------------------------------------------------------------------
C
C
C IN  DIST   : DISTANCE COURANTE
C I/O DISTM  : DISTANCE MINIMALE
C IN  POSMAI : POSITION DE LA MAILLE MAITRE APPARIEE
C I/O POSMAM : POSITION DE LA MAILLE MAITRE CORRESPONDANT A LA 
C               DISTANCE MINIMALE
C IN  IPROJ  : VAUT 0 SI POINT PROJETE DANS L'ELEMENT
C                   1 SI POINT PROJETE DANS LA ZONE DEFINIE PAR TOLEOU
C                   2 SI POINT PROJETE EN DEHORS (EXCLUS)
C I/O IPROJM : TYPE DE PROJECTION CORRESPONDANT AU DIST MINIMUM
C IN  TAU1   : PREMIER VECTEUR TANGENT
C IN  TAU2   : SECOND VECTEUR TANGENT
C I/O TAU1M  : PREMIER VECTEUR TANGENT CORRESPONDANT A LA DISTANCE
C              MINIMALE
C I/O TAU2M  : SECOND VECTEUR TANGENT CORRESPONDANT A LA DISTANCE 
C              MINIMALE
C IN  KSI1   : COORD. PARAM. 1 DE LA PROJECTION SUR MAILLE MAITRE
C IN  KSI2   : COORD. PARAM. 2 DE LA PROJECTION SUR MAILLE MAITRE
C I/O KSI1M  : COORD. PARAM. 1 DE LA PROJECTION SUR MAILLE MAITRE 
C               CORRESPONDANT A LA DISTANCE MINIMALE
C I/O KSI2M  : COORD. PARAM. 2 DE LA PROJECTION SUR MAILLE MAITRE 
C               CORRESPONDANT A LA DISTANCE MINIMALE
C IN  VECT   : VECTEUR E->M COURANT
C OUT VECTM  : VECTEUR E->M (CORRESPONDANT AU JEU MINIMUM)
C
C ----------------------------------------------------------------------
C
      INTEGER      IFM,NIV        
      REAL*8       ECAN,R8PREM
C
C ----------------------------------------------------------------------
C
      CALL INFDBG('APPARIEMENT',IFM,NIV)  
C
C --- ECART ANCIEN/NOUVEAU
C
      IF ((DISTM.EQ.0.D0).OR.(DIST.EQ.DISTM)) THEN
        ECAN = 0.D0
      ELSE
        ECAN = ABS((DIST - DISTM)/DISTM)
      ENDIF    
      


C PREMIERE PROJECTION
      IF (IPROJM.EQ.-1) THEN
        DISTM  = DIST
        POSMAM = POSMAI
        IPROJM = IPROJ
        CALL DCOPY(3,TAU1,1,TAU1M,1)
        CALL DCOPY(3,TAU2,1,TAU2M,1)
        CALL DCOPY(3,VECT,1,VECTM,1)
        KSI1M = KSI1
        KSI2M = KSI2
      ELSE
C PROJECTION SUIVANTES
        IF (IPROJM.NE.0) THEN
C ON N'A PAS ENCORE PROJETE DANS UN ELEMENT
          IF (IPROJ.EQ.0) THEN
C UN POINT SE PROJETE DANS UN ELEMENT
            DISTM  = DIST
            POSMAM = POSMAI
            IPROJM = IPROJ
            CALL DCOPY(3,TAU1,1,TAU1M,1)
            CALL DCOPY(3,TAU2,1,TAU2M,1)
            CALL DCOPY(3,VECT,1,VECTM,1)
            KSI1M  = KSI1
            KSI2M  = KSI2
          ELSE
            IF (DIST.LT.DISTM) THEN
              DISTM  = DIST
              POSMAM = POSMAI
              IPROJM = IPROJ
              CALL DCOPY(3,TAU1,1,TAU1M,1)
              CALL DCOPY(3,TAU2,1,TAU2M,1)
              CALL DCOPY(3,VECT,1,VECTM,1)
              KSI1M  = KSI1
              KSI2M  = KSI2
            ENDIF
          ENDIF
        ELSE
C ON A DEJA PROJETE DANS UN ELEMENT
          IF (IPROJ.EQ.0) THEN
            IF (DIST.LT.DISTM.AND.ECAN.GT.R8PREM()) THEN
C ON SELECTIONNE LE PROJETE MINIMISANT LA DISTANCE
              DISTM  = DIST
              POSMAM = POSMAI
              IPROJM = IPROJ
              CALL DCOPY(3,TAU1,1,TAU1M,1)
              CALL DCOPY(3,TAU2,1,TAU2M,1)
              CALL DCOPY(3,VECT,1,VECTM,1)
              KSI1M  = KSI1
              KSI2M  = KSI2
                      
            ENDIF
          ENDIF
        ENDIF
      ENDIF
C 
      END
