      SUBROUTINE BRAG00(FAMI,KPG,KSP,NDIM,TYPMOD,IMATE,COMPOR,
     &                 INSTAM,INSTAP,TM,TP,TREF,EPSM,DEPS,SIGM,VIM,
     &                 OPTION,SIGP,VIP,DSIDEP)

C    ROUTINE ANCIENNEMENT NOMMEE BETRAG

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/12/2009   AUTEUR DEBONNIERES P.DE-BONNIERES 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================

C
C ATTENTION : LE CHAMP D'AVANCEMENT DE LA RAG EST CALCUL?DANS LA ROUTINE
C       A.SELLIER LMDC FEVRIER 2004/E.GRIMAL LMDC-EDF AVRIL 2004

C       INSTAM TEMPS AU DEBUT DU PAS
C       INSTAP TEMPS FIN DU PAS

C IN  NDIM    : DIMENSION DE L'ESPACE
C IN  TYPMOD  : TYPE DE MODELISATION
C IN  IMATE   : ADRESSE DU MATERIAU CODE
C IN  COMPOR  : COMPORTEMENT : RELCOM ET DEFORM
C IN  INSTAM  : INSTANT DU CALCUL PRECEDENT
C IN  INSTAP  : INSTANT DU CALCUL
C IN  TM      : TEMPERATURE A L'INSTANT PRECEDENT
C IN  TP      : TEMPERATURE A L'INSTANT DU CALCUL
C IN  SECHM   : DEGRE DE SATURATION A L'INSTANT PRECEDENT
C IN  SECHP   : DEGRE DE SATURATION A L'INSTANT DU CALCUL
C IN  EPSM    : DEFORMATION PAS AVANT (ATTENTION 4 A 6 SQRT(2)*EPS)
C IN  TREF    : TEMPERATURE DE REFERENCE
C IN  DEPS    : INCREMENT DE DEFORMATION
C               SI C_PLAN DEPST(3) EST EN FAIT INCONNU (ICI:0)
C                 =>  ATTENTION LA PLACE DE DEPST(3) EST ALORS UTILISEE.
C IN  SIGM    : CONTRAINTES A L'INSTANT DU CALCUL PRECEDENT
C IN  VIM     : VARIABLES INTERNES A L'INSTANT DU CALCUL PRECEDENT
C IN  OPTION  : OPTION DEMANDEE : RIGI_MECA_TANG , FULL_MECA , RAPH_MECA
C OUT SIGP    : CONTRAINTES A L'INSTANT ACTUEL
C OUT VIP     : VARIABLES INTERNES A L'INSTANT ACTUEL
C OUT DSIDEP  : MATRICE CARREE (INUTILISE POUR RAPH_MECA)
C
C               ATTENTION LES TENSEURS ET MATRICES SONT RANGES DANS
C               L'ORDRE :  XX,YY,ZZ,SQRT(2)*XY,SQRT(2)*XZ,SQRT(2)*YZ
C
C       COMPORTEMENT VISCO-ELASTIQUE ENDOMMGEABLE ANISOTROPE
C       TRIDIMENSIONNEL DU BETON (MODELE SIMPLIFIE TOTALEMENT EXPLICITE)

       IMPLICIT NONE
      INTEGER         NDIM,IMATE
      CHARACTER*16    COMPOR(3),OPTION
      CHARACTER*8     TYPMOD(*)
      REAL*8          VIM(65),VIP(65)
      REAL*8          INSTAM,INSTAP
C      REAL*8          HYDRM,HYDRP,SECHM,SECHP
      REAL*8          TM,TP,TREF
      REAL*8          SIGM(6),DEPS(6),EPSM(6)
      REAL*8          SIGP(6),DSIDEP(6,6)

      CHARACTER*8     NOMRES(2)
      REAL*8          VALRES(2)
      CHARACTER*2     CODRET(2)
      REAL*8          RBID
C      REAL*8          SECH0
C      REAL*8          T0
C      REAL*8          DEPS0(6),EPS0(6)
      REAL*8          SIG0(6)
      REAL*8          DEVPT(6)
C      REAL*8          INSTA0
      REAL*8          E0,NU0
C      REAL*8          MU0,K0
      REAL*8          COEF1,COEF2
      REAL*8          VI0(64)
      INTEGER         J,K,L
      LOGICAL         FLUAGE
C MODIFI MARS 2006 "NOUVELLE" VARIABLE DE COMMANDE HYDR ET SECH
      CHARACTER*(*)    FAMI
      INTEGER IRET,KPG,KSP
      REAL*8   SECHM,SECHP,SREF

C       RECUPERATION DE L HYDRATATION ET DU SECHAGE
        CALL RCVARC(' ','SECH','+',FAMI,KPG,KSP,SECHP,IRET)
        IF ( IRET.NE.0) SECHP=0.D0
        CALL RCVARC(' ','SECH','-',FAMI,KPG,KSP,SECHM,IRET)
        IF ( IRET.NE.0) SECHM=0.D0
        CALL RCVARC(' ','SECH','REF',FAMI,KPG,KSP,SREF,IRET)
        IF ( IRET.NE.0) SREF=0.D0
C  ------- CARACTERISTIQUES ELASTIQUES (A CHARGER
C          CAUSE CHARGEMENT DSIDEP AU 1 PAS)
      NOMRES(1)='E'
      NOMRES(2)='NU'
      CALL RCVALB(FAMI,KPG,KSP,'-',IMATE,' ', 'ELAS', 0,' ', 0.D0,
     &             2, NOMRES, VALRES, CODRET, 'F ' )

      E0    = VALRES(1)
      NU0   = VALRES(2)
C     MU0   = E0/2.0D0/(1.D0+NU0)
C     K0    = E0/3.0D0/(1.D0-2.D0*NU0)

C     TEST SUR PRISE EN COMPTE DU FLUAGE
      NOMRES(1)  = 'ACTIV_FL'

      CALL RCVALB(FAMI,KPG,KSP,'-',IMATE,' ', 'BETON_RAG', 0,' ', RBID,
     &             1, NOMRES, VALRES, CODRET, 'F ' )

      IF (VALRES(1).EQ.1.0D0) THEN
      FLUAGE=.TRUE.
      ELSE
      FLUAGE=.FALSE.
      ENDIF

C--  CALCUL DE DSIDEP POUR LA MATRICE TANGENTE
C   -------------------------------------------

      IF ( (OPTION(1:14) .EQ. 'RIGI_MECA_TANG').OR.
     &     (OPTION(1:9)  .EQ. 'FULL_MECA' )        ) THEN

      CALL BRDSDE(E0,NU0,DSIDEP,VIM,SIGM)

      END IF

      IF ( (OPTION(1:9) .EQ. 'RAPH_MECA') .OR.
     &     (OPTION(1:9) .EQ. 'FULL_MECA')     ) THEN

C CALCUL A DT/2 (RUNGE-KUTTA)

C     INSTA0=(INSTAM+INSTAP)/2.
C     T0=(TM+TP)/2.
C     SECH0=(SECHM+SECHP)/2.

C     DO 20 J=1,6
C      DEPS0(J)=DEPS(J)/2.
C      EPS0(J)=EPSM(J)+DEPS0(J)
C20   CONTINUE

       IF (FLUAGE)  GOTO 10


      CALL BRAG01(FAMI,KPG,KSP,
     &             NDIM,TYPMOD,IMATE,COMPOR,INSTAM,INSTAP,
     &             SECHM,SECHP,TM,TP,TREF,EPSM,DEPS,SIGM,
     &             VIM,OPTION,SIGP,VIP,DSIDEP,DEVPT,3)
C
10    CONTINUE
      CALL BRAG01(FAMI,KPG,KSP,
     &             NDIM,TYPMOD,IMATE,COMPOR,INSTAM,INSTAP,
     &             SECHM,SECHP,TM,TP,TREF,EPSM,DEPS,SIGM,
     &             VIM,OPTION,SIGP,VIP,DSIDEP,DEVPT,1)

      END IF
      END
