      SUBROUTINE BRFLUO(SUT,SUT6,XMT,SIGE6,EPS0,
     #TAU0,DT,EVP06,EVP16,DEVPT6,EVPMAX,BGPGMX,ERAGMX)

C     ROUTINE ANCIENNEMENT NOMMEE FLU_ORTO

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/12/2009   AUTEUR DEBONNIERES P.DE-BONNIERES 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================

        IMPLICIT REAL*8(A-Z) 
      REAL*8 SIGE6(6),SIGE3(3),SIGET3(3),SIGED6(6)
      REAL*8 EVP06(6),EVP16(6),EVPD06(6)
      REAL*8 SIGE33(3,3),VSE33(3,3),VSE33T(3,3)
      REAL*8 X33(3,3),Z33(3,3),Y33(3,3),SUT33(3,3)
      REAL*8 SUT3(3),VDT33(3,3),VDT33T(3,3),DT3(3),SUT6(6)
      REAL*8 SMECA,DMECA,DRAG3(3),ST,DRG3MX,TRAV(3,3)
      REAL*8 SIGEC3(3),PSIT3(3),EVPL3F(3),DEVPT6(6),DEVPT3(3)
      REAL*8 EVPMAX,SGEDT6(6),AA,BGPGMX,ERAGMX
      INTEGER I,J
      REAL*8 XMT

C        CLASSEMENT DES CONTRAINTES ET DES DEFORMATION:
C      I=1,3 => SIGMA II
C      I=4   => SIGMA 12
C      I=5   => SIGMA 13
C      I=6   => SIGMA 23
C        PARTITION DES CONTRAINTES EN PARTIE POSITIVE ET PARTIE NGATIVE
C        CONTRAINTES EFFECTIVES PRINCIPALES ET MATRICE DE
C        PASSAGE  LA BASE PRINCIPALE
C        RANGEMENT DES CONTRAINTES EFFECTIVES EN TABLEAU 3*3

      ZZ = 0.D0

      SIGE33(1,1)=SIGE6(1)
      SIGE33(2,2)=SIGE6(2)
      SIGE33(3,3)=SIGE6(3)
      SIGE33(1,2)=SIGE6(4)
      SIGE33(1,3)=SIGE6(5)
      SIGE33(2,3)=SIGE6(6)
      SIGE33(2,1)=SIGE33(1,2)
      SIGE33(3,1)=SIGE33(1,3)
      SIGE33(3,2)=SIGE33(2,3)
      DO 10 I=1,3
       DO 20 J=1,3
        X33(I,J)=SIGE33(I,J)
 20    CONTINUE
 10   CONTINUE
C        DIAGONALISATION ET VALEURS PROPRES PAR LA METHODE DE JACOBI
      CALL BRVP33(X33,SIGE3,VSE33)
C        TRANSPOSITION DE DE LA MATRICE DE PASSAGE
        CALL TRANSP(VSE33,3,3,3,VSE33T,3)
C        PARTIE POSITIVE ET NEGATIVES DES CONTRAINTES EFFECTIVES 
      DO 30 I=1,3
C      SIGET3(I)=0.5D0*(SIGE3(I)+ABS(SIGE3(I)))
C      SIGEC3(I)=0.5D0*(SIGE3(I)-ABS(SIGE3(I)))
 30   CONTINUE
C     DEFORMATION VISCOPLASTIQUE POSITIVES LIMITES ASSOCIES AUX
C     CONTRAINTES EFFECTIVES ACTUELLES
C     DIRECTIONS PRINCIPALE DE ENDOMMAGEMENT
       SUT33(1,1)=SUT6(1)
       SUT33(2,2)=SUT6(2)
       SUT33(3,3)=SUT6(3)
       SUT33(1,2)=SUT6(4)
       SUT33(1,3)=SUT6(5)
       SUT33(2,3)=SUT6(6)
       SUT33(2,1)=SUT33(1,2)
       SUT33(3,1)=SUT33(1,3)
       SUT33(3,2)=SUT33(2,3)
C       DIRECTIONS PRINCIPALES DES ENDOMMAGEMENTS DE TRACTION
C       CONTRAINTES EFFECTIVES PRINCIPALES ET MATRICE DE PASSAGE 
C       LA BASE PRINCIPALE
      DO 40 I=1,3
       DO 50 J=1,3
        X33(I,J)=SUT33(I,J)
 50    CONTINUE
 40   CONTINUE
C        DIAGONALISATION ET VALEURS PROPRES PAR LA METHODE DE JACOBI
       CALL BRVP33(X33,SUT3,VDT33)
       CALL TRANSP(VDT33,3,3,3,VDT33T,3)

C      CALCUL DES ENDOMMAGEMENTS PRINCIPAUX
C       DRG3MX=ERAGMX/(3*EPS0+ERAGMX)

       DO 60 I=1,3
         IF (SUT3(I).LT.0.0D0) THEN
           SUT3(I)=0.0D0
         ENDIF
         DT3(I)=1.D0-EXP(-(1.D0/XMT)*((SUT3(I)/SUT)**XMT))
         DRAG3(I)=1.D0-EXP(-(1.D0/XMT)*(BGPGMX/SUT)**XMT)
         DRAG3(I)=MIN(DRAG3(I),DT3(I))
 60    CONTINUE
       DO 70 I=1,3
        X=(1.D0-DRAG3(I))
        IF(X.LE.0.0D0)THEN
          IF (EPS0.EQ.0) THEN
            Y=0.0D0
          ELSE
            Y=EVPMAX/EPS0
          END IF
        ELSE
          Y=(1.D0-X)/X
          Y=MIN(Y,EVPMAX/EPS0)
        END IF
        EVPL3F(I)=EPS0*Y
 70   CONTINUE
C     PASSAGE DES DEFORMATION VDTM DANS LA
C       BASE PRINCIPALE D'ENDOMMAGEMENT
      CALL MATINI(3,3,ZZ,X33)
      DO 80 I=1,3
       X33(I,I)=EVP06(I)
 80   CONTINUE
       X33(1,2)=EVP06(4)/2.D0
       X33(1,3)=EVP06(5)/2.D0
       X33(2,3)=EVP06(6)/2.D0
       X33(2,1)=X33(1,2)
       X33(3,1)=X33(1,3)
       X33(3,2)=X33(2,3)

      CALL UTBTAB('ZERO',3,3,X33,VDT33,TRAV,Y33)
      EVPD06(1)=Y33(1,1)
      EVPD06(2)=Y33(2,2)
      EVPD06(3)=Y33(3,3)
      EVPD06(4)=Y33(1,2)
      EVPD06(5)=Y33(1,3)
      EVPD06(6)=Y33(2,3)

C     PASSAGE DES CONTRAINTES EFFECTIVES DANS LA
C       BASE PRINCIPALE D'ENDOMMAGEMENT
      CALL MATINI(3,3,ZZ,X33)
      DO 90 I=1,3
       X33(I,I)=SIGE6(I)
 90   CONTINUE
       X33(1,2)=SIGE6(4)
       X33(1,3)=SIGE6(5)
       X33(2,3)=SIGE6(6)
       X33(2,1)=X33(1,2)
       X33(3,1)=X33(1,3)
       X33(3,2)=X33(2,3)

      CALL UTBTAB('ZERO',3,3,X33,VDT33,TRAV,Y33)
      SIGED6(1)=Y33(1,1)
      SIGED6(2)=Y33(2,2)
      SIGED6(3)=Y33(3,3)
      SIGED6(4)=Y33(1,2)
      SIGED6(5)=Y33(1,3)
      SIGED6(6)=Y33(2,3)

      SOMME1=0.D0
      DO 100 I=1,3    
C       VITESSE DE FLUAGE
        A=(EVPL3F(I)-EVPD06(I))*(1.D0-EXP(-DT/TAU0))/DT
        IF (A.LT.0.D0) THEN
          A=0
        END IF
        AA=A*SIGED6(I)
        SOMME1=SOMME1+AA

        DEVPT3(I)=A
 100  CONTINUE
       IF (SOMME1.LT.0.D0) THEN
       DO 110 I=1,3
       DEVPT3(I)=0.D0
 110   CONTINUE
      END IF

C REPASSAGE DES VITESSES DANS LA BASE FIXE
      CALL MATINI(3,3,ZZ,X33)
      DO 120 I=1,3
       X33(I,I)=DEVPT3(I)
 120  CONTINUE


      CALL UTBTAB('ZERO',3,3,X33,VDT33T,TRAV,Y33)
      DEVPT6(1)=Y33(1,1)
      DEVPT6(2)=Y33(2,2)
      DEVPT6(3)=Y33(3,3)
      DEVPT6(4)=Y33(1,2)*2.D0
      DEVPT6(5)=Y33(1,3)*2.D0
      DEVPT6(6)=Y33(2,3)*2.D0

      END
