      SUBROUTINE CAFFVF(TKL,DIFU,DIFU1,DIFU2,
     &                  DIFU1V,DIFU2V,CV, C,
     &                  DCV1,DCV2,DC1,DC2,FLUX,DFXP1,
     &                  DFXP2,DFXP1V,DFXP2V )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 23/03/2010   AUTEUR ANGELINI O.ANGELINI 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C  *** IN      
C      
C   DIFU   : DIFFUSIVITE
C   DIFU1  : DERIVEE DE DIFU PAR RAPPORT A 
C            LA PREMIERE VARIABLE
C   DIFU2  : DERIVEE DE DIFU PAR RAPPORT A 
C            LA SECONDE VARIABLE 
C   DIFU1V : DERIVEE DE DIFU PAR RAPPORT A 
C            LA PREMIERE VARIABLE DU VOISIN
C   DIFU2V : DERIVEE DE DIFU PAR RAPPORT A 
C            LA SECONDE VARIABLE DU VOISIN
C    CV    : UNE VALEUR AU VOISIN
C    C     : UNE VALEUR AU CENTRE
C   DCV1   : DERIVEE DE CV PAR RAPPORT A 
C            LA PREMIERE VARIABLE DU VOISIN
C   DCV2   : DERIVEE DE CV PAR RAPPORT A 
C            LA SECONDE VARIABLE DU VOISIN
C   DC1    : DERIVEE DE C PAR RAPPORT A 
C            LA PREMIERE VARIABLE 
C   DC2    : DERIVEE DE C PAR RAPPORT A 
C            LA SECONDEE VARIABLE 
C
C  *** OUT
C
C  FLUX    :  FLUX 
C  DFXP1   : DERIVEE DE FLUX PAR RAPPORT A 
C            LA PREMIERE VARIABLE
C  DFXP2   : DERIVEE DE FLUX PAR RAPPORT A 
C            LA SECONDE VARIABLE
C  DFXP1V  : DERIVEE DE FLUX PAR RAPPORT A 
C            LA PREMIERE VARIABLE DU VOISIN
C  DFXP2V  : DERIVEE DE FLUX PAR RAPPORT A 
C            LA SECONDE VARIABLE DU VOISIN

      IMPLICIT NONE
      REAL*8 TKL
      REAL*8 CV,C,DCV1,DCV2,DC1,DC2
      REAL*8 DIFU,DIFU1,DIFU2,DIFU1V,DIFU2V
      REAL*8 FLUX,DFXP1,DFXP2,DFXP1V,DFXP2V
C
      FLUX  = -TKL*DIFU*(CV-C)
C    
      DFXP1  = -TKL*(DIFU1 *(CV-C)-DIFU*DC1)
      DFXP2  = -TKL*(DIFU2 *(CV-C)-DIFU*DC2)
      DFXP1V = -TKL*(DIFU1V*(CV-C)+DIFU*DCV1)
      DFXP2V = -TKL*(DIFU2V*(CV-C)+DIFU*DCV2)      
      END         
