      SUBROUTINE CAFHVF(KFA,TKL,MOBFA,DMOB1,DMOB2,DMOB1V,DMOB2V,UV,
     &                  U,DU1,DU2,FLUX,DFXP1,DFXP2,DFXP1V,DFXP2V)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 23/03/2010   AUTEUR ANGELINI O.ANGELINI 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C  *** IN      
C      
C   KFA    : PERMEABILITE SUR L ARETE
C   MOBFA  : MOBILITE SUR L ARETE
C   DMOB1  : DERIVEE DE MOBFA PAR RAPPORT A 
C            LA PREMIERE VARIABLE
C   DMOB2  : DERIVEE DE MOBFA PAR RAPPORT A 
C            LA SECONDE VARIABLE 
C   DMOB1V : DERIVEE DE MOBFA PAR RAPPORT A 
C            LA PREMIERE VARIABLE DU VOISIN
C   DMOB2V : DERIVEE DE MOBFA PAR RAPPORT A 
C            LA SECONDE VARIABLE DU VOISIN
C    UV    : UNE VALEUR AU VOISIN
C    U     : UNE VALEUR AU CENTRE
C   DU1    : DERIVEE DE U PAR RAPPORT A 
C            LA PREMIERE VARIABLE
C   DU2    : DERIVEE DE U PAR RAPPORT A 
C            LA SECONDE VARIABLE
C  *** OUT
C
C  FLUX    :  FLUX MASSIQUE
C  DFXP1   : DERIVEE DE FLUX PAR RAPPORT A 
C            LA PREMIERE VARIABLE
C  DFXP2   : DERIVEE DE FLUX PAR RAPPORT A 
C            LA SECONDE VARIABLE
C  DFXP1V  : DERIVEE DE FLUX PAR RAPPORT A 
C            LA PREMIERE VARIABLE DU VOISIN
C  DFXP2V  : DERIVEE DE FLUX PAR RAPPORT A 
C            LA SECONDE VARIABLE DU VOISIN
      IMPLICIT NONE
C    
      REAL*8 KFA 
      REAL*8 TKL
      REAL*8 UV,U,DU1,DU2
      REAL*8 MOBFA,DMOB1,DMOB2,DMOB1V,DMOB2V
      REAL*8 FLUX,DFXP1,DFXP2,DFXP1V,DFXP2V,FLUXS
C
      FLUXS  =-KFA*TKL*(UV-U)
      FLUX  = MOBFA*FLUXS
C    
      DFXP1  = -KFA*TKL*(DMOB1 *(UV-U)-MOBFA*DU1)
      DFXP2  = -KFA*TKL*(DMOB2 *(UV-U)-MOBFA*DU2)
      DFXP1V = -KFA*TKL*(DMOB1V*(UV-U)+MOBFA*DU1)
      DFXP2V = -KFA*TKL*(DMOB2V*(UV-U)+MOBFA*DU2)     
      END       
