      SUBROUTINE CAFVES(CONT,TANGE,MAXFA,NFACE,FKS,DFKS1,DFKS2,
     &     MOBFA,DMOB1,DMOB2,MOB1F,MOB2F,FLUX,DFLX1,DFLX2)
      
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 23/03/2010   AUTEUR ANGELINI O.ANGELINI 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C TOLE CRP_20
C TOLE CRP_21
C ======================================================================
C
C =========================================================
C  CETTE SUBROUTINE PERMET DE CALCULER D UNE MANIERE 
C  GENERIQUE LE FLUX TOTALVOLUMIQUE
C =========================================================
C ****IN :
C     FKS(IFA)          : FLUX SUR IFA
C     DFKS1(1,IFA)      : DERIVEE DE FKS(IFA) PAR RAPPORT A LA PREMIERE
C                         INCONNUE AU CENTRE
C     DFKS1(JFA+1,IFA)  : DERIVEE DE FKS(IFA) PAR RAPPORT A LA PREMIERE
C                         INCONNUE FACE
C     DFKS2(1,IFA)     : DERIVEE DE FKS(IFA) PAR RAPPORT A LA DEUXIEME
C                        INCONNUE AU CENTRE
C     DFKS2(JFA+1,IFA) : DERIVEE DE FKS(IFA) PAR RAPPORT A LA DEUXIEME
C                        INCONNUE FACE
C     MOBFA            : MOBILITE  
C     DMOB1            : DERIVEE DE LA MOBILITE PAR RAPPORT A LA 
C                        PREMIERE VARIABLE AU CENTRE
C     DMOB2            : DERIVEE DE LA MOBILITE PAR RAPPORT A LA 
C                        SECONDE VARIABLE AU CENTRE
C     MOB1F            : DERIVEE DE LA MOBILITE PAR RAPPORT A LA 
C                        PREMIERE VARIABLE A L ARETE
C     MOB2F           : DERIVEE DE LA MOBILITE PAR RAPPORT A LA 
C                        SECONDE VARIABLE A L ARETE
C ****IN-OUT :  
C     FLUX            : SOMME DES FLUX DE DARCY ENTRANT DASN MAILLE
C     DFLX1           : DERIVEE DU FLUX PAR RAPPORT A LA PREMIERE
C                       VARIABLE
C     DFLX1(1)   = DFLUX/ VARIABLE 1 AU CENTRE MAILLE COURANTE
C     DFLX1(I+1) = DFLUX/ VARIABLE 1 SUR FACE I
C
C     DFLX2          :DERIVEE DU FLUX PAR RAPPORT A LA SECONDE 
C                      VARIABLE
C     DFLX2(1)   = DFLUX/ VARIABLE 2 AU CENTRE MAILLE COURANTE
C     DFLX2(I+1) = DFLUX/ VARIABLE 2 SUR FACE I
C ================================================
C     FLUX = SOMME ( MOBFA * F_{K,SIGMA})
C                           
C================================================      
      IMPLICIT NONE
      LOGICAL       CONT,TANGE
      INTEGER       MAXFA
      INTEGER       NFACE
      REAL*8        FLUX
      REAL*8        FKS(1:MAXFA)
      REAL*8        MOBFA(1:MAXFA),DMOB1(1:MAXFA),DMOB2(1:MAXFA),
     >              MOB1F(1:MAXFA),MOB2F(1:MAXFA)
      REAL*8        DFLX1(1:MAXFA+1),DFLX2(1:MAXFA+1)
      REAL*8        DFKS1(1:MAXFA+1,MAXFA), DFKS2(1:MAXFA+1,MAXFA)
      INTEGER       IFA,JFA
C      
      IF (CONT) THEN
         DO 2 IFA=1,NFACE
            FLUX = FLUX +MOBFA(IFA) * FKS(IFA)
   2     CONTINUE
      ENDIF
      IF ( TANGE) THEN
         DO 3 JFA=1,NFACE
            DFLX1(1) = DFLX1(1) + DMOB1(JFA) * FKS(JFA) +
     >                 MOBFA(JFA) * DFKS1(1,JFA)
            DFLX2(1) = DFLX2(1) + DMOB2(JFA) * FKS(JFA) + 
     >                 MOBFA(JFA) * DFKS2(1,JFA)
   3     CONTINUE    
         DO 4 IFA=1,NFACE
            DFLX1(1+IFA) = DFLX1(1+IFA) + MOB1F(IFA)* FKS(IFA)
            DFLX2(1+IFA) = DFLX2(1+IFA) + MOB2F(IFA)* FKS(IFA)
            DO 4 JFA=1,NFACE         
            DFLX1(1+IFA) = DFLX1(1+IFA) + MOBFA(JFA) * DFKS1(IFA+1,JFA)
            DFLX2(1+IFA) = DFLX2(1+IFA) + MOBFA(JFA) * DFKS2(IFA+1,JFA)
   4     CONTINUE           
      ENDIF
      END
