      SUBROUTINE CALCFP(MUTRBE,RPRIM,SEUIL,DT,DP,SIGM0,EPSI0,COEFM, 
     &                 FPLAS,FPRIM,DFPRIM)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 06/09/2004   AUTEUR SMICHEL S.MICHEL-PONNELLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
      IMPLICIT NONE
      REAL*8  MUTRBE, RPRIM, SEUIL, DT, DP, SIGM0,EPSI0,COEFM
      REAL*8  FPLAS, FPRIM, DFPRIM
      
C-------------------------------------------------------------------
C  FONCTION FPRIM(X) POUR LOI VISCOPLASTIQUE EN SINH
C  CALCUL DE DP ==> RESOLUTION DE L'EQUATION SCALAIRE NON LINEAIRE
C                   FPRIM + FPLAS + SIGM0* ARGSH((DP/DT/EPSI0)^(1/M))
C  IN MUTRBE : MU * TR(Bel)
C  IN RPRIM  : ECROUISSAGE
C  IN SEUIL  : VALEUR DE F=SIGEQ-SIGY - R
C  IN DT     : PAS DE TEMPS
C  IN  DP    : DP RECHERCHE LORS DE LA RESOLUTION SCALAIRE
C  IN SIGM0,EPSI0, COEFM : PARAMETRE LOI VISQUEUSE 
C  OUT FPLAS : VALEUR DE LA COMPOSANTE PLASTIQUE DE FPRIM
C  OUT FPRIM : VALEUR DE FPRIM
C  OUT DFPRIM : DERIVEE DE FPRIM PAR RAPPORT A DP (SI DP>0)
C--------------------------------------------------------------------
C
      REAL*8    R0,ARG,ASINH


      R0  = MUTRBE + RPRIM
      FPLAS  = SEUIL - R0*DP
      ARG = (DP/DT/EPSI0)**(1.D0/COEFM)
      ASINH = LOG(ARG+SQRT(ARG**2+1))
      FPRIM = FPLAS - SIGM0 * ASINH

C    CALCUL DE LA DERIVEE DE FPRIM 
          
        IF (DP.GT.0.D0) THEN
        DFPRIM = - R0 + SIGM0 / SQRT(ARG**2+1.D0) / COEFM /
     &  (DT*EPSI0)**(1.D0/COEFM) * DP**(1.D0/COEFM - 1)
        ENDIF

      END
