      SUBROUTINE CALJAC(NP3,IC,TYPCH,NBSEG,CHOCKC,RC,THETA,
     &                  VLOC,XLOC,VLOC0,XLOC0,TETAJ,JACOBC,JACOBK)
      IMPLICIT NONE
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 16/05/2000   AUTEUR KXBADNG T.KESTENS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C-----------------------------------------------------------------------
C DESCRIPTION : CALCUL DES MATRICES JACOBIENNES LIEES A LA FORCE  
C -----------   NON-LINEAIRE DE CHOC F(X,DX)
C
C               APPELANTS : MDCHOE, MDCHOF
C
C-------------------   DECLARATION DES VARIABLES   ---------------------
C
C ARGUMENTS
C ---------
      INTEGER   NP3, IC, TYPCH(*), NBSEG(*)
      REAL*8    CHOCKC(*), RC(NP3,*), THETA(NP3,*),
     &          VLOC(*), XLOC(*), VLOC0(*), XLOC0(*), TETAJ,
     &          JACOBC(3,*), JACOBK(3,*) 
C
C VARIABLES LOCALES
C -----------------
      INTEGER   I
      REAL*8    CN, KN, VLOCJ(3), XLOCJ(3)
C
C ROUTINES EXTERNES
C -----------------
C     EXTERNAL  JACBCI, JACBPY, JACBPZ, JACBQU
C
C-------------------   DEBUT DU CODE EXECUTABLE    ---------------------
C
      KN = CHOCKC(1)
      CN = CHOCKC(2)
C 
      IF ( TYPCH(IC).EQ.0 ) THEN
C
C ------ BUTEE PLANE SUIVANT Y
         CALL JACBPY(KN,CN,JACOBC,JACOBK)
C
      ELSE IF ( TYPCH(IC).EQ.1 ) THEN
C
C ------ BUTEE PLANE SUIVANT Z
         CALL JACBPZ(KN,CN,JACOBC,JACOBK)
C
      ELSE IF ( TYPCH(IC).EQ.2 ) THEN
C
C ------ BUTEE CIRCULAIRE
         DO 20 I = 1, 3
            VLOCJ(I) = (TETAJ*VLOC(I)) + ((1.0D0-TETAJ)*VLOC0(I))
            XLOCJ(I) = (TETAJ*XLOC(I)) + ((1.0D0-TETAJ)*XLOC0(I))
  20     CONTINUE
         CALL JACBCI(NP3,RC,VLOCJ,XLOCJ,KN,CN,IC,JACOBC,JACOBK)
C
      ELSE IF ( TYPCH(IC).EQ.3 ) THEN

C ------ BUTEE QUELCONQUE 
         DO 30 I = 1, 3
            XLOCJ(I) = (TETAJ*XLOC(I)) + ((1.0D0-TETAJ)*XLOC0(I))
  30     CONTINUE
         CALL JACBQU(NP3,NBSEG,RC,THETA,XLOCJ,KN,CN,IC,JACOBC,JACOBK)
C
      ENDIF
C
C --- FIN DE CALJAC.
      END
