      SUBROUTINE CALKBP( NNO, NDIM, AXI, R, KPG, GEOM, IVF,
     &                   IPOIDS, IDFDE, KBP )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 11/01/2011   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE SFAYOLLE S.FAYOLLE
C TOLE CRS_1404
      IMPLICIT NONE

      LOGICAL AXI

      INTEGER NDIM, NNO, IPOIDS, IDFDE, IVF

      REAL*8 GEOM(NDIM,NNO), KBP(NDIM,NNO), R

C......................................................................
C     BUT:  CALCUL LE TERME DE COUPLAGE KBP
C     ON UTILISE UNE FORMULATION AVEC UN SEULE POINT DE GAUSS
C     SITUE AU BARYCENTRE DE L ELEMENT ET DONT LE POIDS EST EGAL
C......................................................................
C IN  NNO     : NOMBRE DE NOEUDS DE L'ELEMENT
C IN  NDIM    : DIMENSION DE L'ESPACE
C IN  AXI     : CALCUL AXISYMETRIQUE OU NON
C IN  R       : DISTANCE DU POINT DE GAUSS A L'AXE (EN AXISYMETRIQUE)*
C IN  KGP     : NOMBRE DE POINTS DE GAUSS
C IN  GEOM    : COORDONEES DES NOEUDS
C IN  DEPL    : DEPLACEMENTS
C IN  IVF     : VALEUR  DES FONCTIONS DE FORME LIES A LA PRESSION
C IN  IPOIDS  : POIDS DES POINTS DE GAUSS
C IN  IDFDE   : DERIVEE DES FONCTIONS DE FORME ELEMENT DE REFERENCE
C OUT KBP     : MATRICE KBP
C......................................................................

C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      INTEGER  ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------

      INTEGER I, N, M, KPG

      REAL*8  DFDX(NNO), DFDY(NNO), DFDZ(NNO), POIDS
      REAL*8  DFDI(NDIM), TMP


C - INITIALISATION
      CALL R8INIR(NNO*NDIM, 0.D0, KBP,1)

C - CAS 3D
C - CALCUL DE DNb/Dx,DNb/Dy,DNb/Dz POUR TOUS LES SOUS ELEMENTS

      IF (NDIM .EQ. 3) THEN

        CALL DFDM3B(NNO,KPG,IPOIDS,IDFDE, GEOM, DFDX, DFDY, DFDZ, POIDS)

C - TERME KBP
C - BOUCLE SUR LES SOUS ELEMENTS
        DO 100 N = 1, NNO
          DFDI(1)=DFDX(N)
          DFDI(2)=DFDY(N)
          DFDI(3)=DFDZ(N)
C - BOUCLE SUR LA DIMENSION
          DO 99 I = 1, NDIM
C - BOUCLE SUR LES FONCTION DE FORME LINEAIRE
            DO 98 M = 1, NNO
              TMP = DFDI(I)*ZR(IVF+M-1+(KPG-1)*NNO)
              KBP(I,N) = KBP(I,N) + POIDS*TMP
 98         CONTINUE
 99       CONTINUE
 100    CONTINUE

C - CAS 2D
C - CALCUL DE DNb/Dx,DNb/Dy,DNb/Dz POUR TOUS LES SOUS ELEMENTS
      ELSE IF (NDIM .EQ. 2) THEN 
        CALL DFDM2B(NNO,KPG,IPOIDS, IDFDE, GEOM, DFDX, DFDY, POIDS)

        IF (AXI) THEN
          POIDS=POIDS*R
        END IF

C - TERME KBP
C - BOUCLE SUR LES SOUS ELEMENTS
        DO 90 N = 1, NNO
          DFDI(1)=DFDX(N)
          DFDI(2)=DFDY(N)
C - BOUCLE SUR LA DIMENSION
          DO 89 I = 1, NDIM
C - BOUCLE SUR LES FONCTION DE FORME LINEAIRE
            DO 88 M = 1, NNO
              TMP = DFDI(I)*ZR(IVF+M-1+(KPG-1)*NNO)
              KBP(I,N) = KBP(I,N) + POIDS*TMP
 88         CONTINUE
 89       CONTINUE
 90     CONTINUE
      ELSE
        CALL ASSERT(.FALSE.)
      END IF

      END
