      SUBROUTINE CALKCE ( NNO, NDIM, KBP, KBB, PM, DP, KCE, RCE )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 11/01/2011   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE SFAYOLLE S.FAYOLLE
C TOLE CRS_1404
      IMPLICIT NONE

      INTEGER NNO, NDIM

      REAL*8 KBP(NDIM,NNO), KBB(NDIM,NDIM), RCE(NNO)
      REAL*8 KCE(NNO,NNO), PM(NNO), DP(NNO)

C......................................................................
C     BUT:  CALCUL  DE LA MATRICE CE POUR LA CONDENSATION STATIQUE
C           ET DU PRODUIT CEP
C......................................................................
C IN  NNO     : NOMBRE DE NOEUDS DE L'ELEMENT
C IN  NDIM    : DIMENSION DE L'ESPACE 
C IN  KBP     : DISTANCE DU POINT DE GAUSS A L'AXE (EN AXISYMETRIQUE)
C IN  KBB     : COORDONEES DES NOEUDS
C IN  PM      : P A L'INSTANT PRECEDENT
C IN  DP      : INCREMENT POUR P
C OUT  CE     : MATRICE DE CONDENSATION STATIQUE
C OUT  RCE    : PRODUIT MATRICE DE CONDENSATION-PRESSION
C......................................................................

      INTEGER I

      REAL*8 KPB(NNO,NDIM), KBBI(NDIM,NDIM)
      REAL*8 DET, PP(NNO,1), PROD(NDIM,NNO)

      CALL R8INIR(NNO*NNO, 0.D0, KCE, 1)
      CALL R8INIR(NNO, 0.D0, RCE, 1)
      CALL R8INIR(NDIM*NNO, 0.D0, PROD, 1)

C - TRANSPOSITION DE LA MATRICE KBP

      CALL TRANSP(KBP,NDIM,NDIM,NNO,KPB,NNO)

C - INVERSE DE LA MATRICE KBB

      CALL MATINV('S',NDIM,KBB,KBBI,DET)

C - PRODUIT DE L'INVERSE DE LA MATRICE KBB ET DE LA MATRICE KBP

      CALL MATMUL(KBBI,KBP,NDIM,NDIM,NNO,PROD)

C - CALCUL DE KCE

      CALL  MATMUL(KPB,PROD,NNO,NDIM,NNO,KCE)

C - CALCUL DU PRODUIT RCE

      DO 1 I=1,NNO
        PP(I,1)=PM(I)+DP(I)
 1    CONTINUE

      CALL MATMUL(KCE,PP,NNO,NNO,1,RCE)

      END
