      SUBROUTINE CALPF(NDIM,NNO,AXI,NPG,GEOMM,G,IW,VFF,IDFF,
     &                 DEPLD,GRAND,ALPHA,R,DFF,FD,DEPLDA,FDA)
                      
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/12/2009   AUTEUR PROIX J-M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
      IMPLICIT NONE
      LOGICAL AXI, GRAND
      INTEGER NDIM,NNO,G,IW,IDFF,I,NPG
      REAL*8  GEOMM(NDIM,NNO),VFF(NNO,NPG)
      REAL*8  R,DFF(NNO,NDIM),DEPLD(3*27),DEPLT(3*27)
      REAL*8 ALPHA

C ----------------------------------------------------------------------
C   NDIM    : DIMENSION DE L'ESPACE
C   NNO     : NOMBRE DE NOEUDS (FAMILLE E-BARRE)
C   AXI     : .TRUE. SI AXISYMETRIQUE
C   GRAND   : .TRUE.  --> CALCUL DE F(3,3)
C             .FALSE. --> CALCUL DE EPS(6)
C   GEOMI   : COORDONNEES DES NOEUDS A L'INSTANT T-
C   G       : NUMERO DU POINT DE GAUSS COURANT
C   IW      : ACCES AUX POIDS DES POINTS DE GAUSS DE REFERENCE
C   VFF     : VALEURS DES FONCTIONS DE FORME (POINT DE GAUSS COURANT)
C   IDFF    : DERIVEES DES FONCTIONS DE FORME DE REFERENCE
C   R       : RAYON DU POINT DE GAUSS COURANT (EN AXI)
C   W       : POIDS DU POINT DE GAUSS COURANT (Y COMPRIS R EN AXI)
C   DFF     : DERIVEE DES FONCTIONS DE FORME (POINT DE GAUSS COURANT)
C   DEPLM   : DEPLACEMENT EN T-
C   DEPLT   : INCREMENT DE DEPLACEMENT ENTRE T- ET T+
C   ALPHA   : PARAMETRE D INTEGRATION COMPRIS ENTRE 0 ET 1 


C   SORTIE:
C   FD      : TENSEUR DE DEFORMATION ENTRE CONFIGURATION T- ET T+ 
C   DEPLDA  : INCREMENT DE DEPLACEMENT ENTRE CONFIGURATION T- ET 
C             CONFIGURATION INTERMEDIAIRE
C   FDA    :  TENSEUR DE DEFORMATION ENTRE CONFIGURATION T- ET 
C             CONFIGURATION INTERMEDIAIRE

C ----------------------------------------------------------------------
C
C     CALCUL DES TENSEURS DE DEFORMATIONS ENTRE CONFIGURATION T- ET T+ 
C     CALCUL DES TENSEURS DE DEFORMATIONS ENTRE CONFIGURATION T- ET 
C     CONFIGURATION INTERMEDIAIRE
C
C----------------------------------------------------------------------

      REAL*8 FD(3,3),FDA(3,3),FMA(3,3),DEPLDA(3*27), TBID(6)
      REAL*8 RBID

C----------------------INTIALISATION DES MATRICES ------------------
      CALL R8INIR(9,0.D0,FD,1)
      CALL R8INIR(9,0.D0,FDA,1)
      CALL R8INIR(3*27,0.D0,DEPLDA,1)
      CALL R8INIR(6,0.D0,TBID,1)
      CALL R8INIR(NNO*NDIM,0.D0,DFF,1)
      R=0.D0
      RBID=0.D0
      
C----------------CALCUL DE f_(n+1) ET f_(n+alpha) PAR RAPPORT A GEOM T-
C      CALCUL DE f_(n+1) = FD
       CALL DFDMIP(NDIM,NNO,AXI,GEOMM,G,IW,VFF(1,G),IDFF,R,RBID,DFF)
       CALL NMEPSI(NDIM,NNO,AXI,GRAND,VFF(1,G),R,DFF,DEPLD,FD,TBID)
          
C      CALCUL DU DEPLACEMENT MULTIPLIE PAR ALPHA
       DO 10 I=1,NNO*NDIM 
          DEPLDA(I)=ALPHA*DEPLD(I)
 10    CONTINUE 
         
C      CALCUL DE  FDA = f_(n+alpha)              
       CALL DFDMIP(NDIM,NNO,AXI,GEOMM,G,IW,VFF(1,G),IDFF,R,RBID,DFF)
       CALL NMEPSI(NDIM,NNO,AXI,GRAND,VFF(1,G),R,DFF,DEPLDA,FDA,TBID)
      END
