      SUBROUTINE CFALGO(NOMA  ,RESIGR,DEFICO,RESOCO,MATASS,
     &                  DDEPLA,DEPDEL,CTCCVG,CTCFIX)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 19/10/2010   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE MABBAS M.ABBAS
C
      IMPLICIT     NONE
      LOGICAL      CTCFIX
      CHARACTER*8  NOMA
      REAL*8       RESIGR
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*19 DDEPLA,DEPDEL
      CHARACTER*19 MATASS
      INTEGER      CTCCVG(2)
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES DISCRETES - APPARIEMENT)
C
C ROUTINE D'AIGUILLAGE POUR LA RESOLUTION DU CONTACT
C
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  ITERAT : ITERATION DE NEWTON
C IN  RESIGR : RESI_GLOB_RELA
C IN  DEFICO : SD DE DEFINITION DU CONTACT (ISSUE D'AFFE_CHAR_MECA)
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  MATASS : NOM DE LA MATRICE DU PREMIER MEMBRE ASSEMBLEE
C IN  DDEPLA : INCREMENT DE DEPLACEMENTS CALCULE EN IGNORANT LE CONTACT
C IN  DEPDEL : INCREMENT DE DEPLACEMENT CUMULE
C OUT CTCFIX : .TRUE.  SI ATTENTE POINT FIXE CONTACT
C OUT CTCCVG : CODES RETOURS D'ERREUR DU COTNACT
C                (1) NOMBRE MAXI D'ITERATIONS
C                (2) MATRICE SINGULIERE
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      CFDISI
      CHARACTER*19 MATR
      INTEGER      LDSCON,LMAT
      INTEGER      IFM,NIV,ICONT,IFROT,NDIMG
      LOGICAL      CFDISL,LMATRC,LGLISS
C
C ----------------------------------------------------------------------
C
      CALL INFDBG('CONTACT',IFM,NIV) 
      CALL JEMARQ()
C
C --- METHODE DE CONTACT ET DE FROTTEMENT
C
      ICONT  = CFDISI(DEFICO,'ALGO_CONT')
      IFROT  = CFDISI(DEFICO,'ALGO_FROT')      
      LMATRC = CFDISL(DEFICO,'MATR_CONT')
      LGLISS = CFDISL(DEFICO,'CONT_DISC_GLIS')
      NDIMG  = CFDISI(DEFICO,'NDIM'     )     
C
C --- INITIALISATION DES VARIABLES DE CONVERGENCE DU CONTACT
C
      CTCCVG(1) = 0
      CTCCVG(2) = 0
C
C --- RECUPERATION DU DESCRIPTEUR DE LA MATRICE DE CONTACT
C
      IF (LMATRC) THEN
        MATR = RESOCO(1:14)//'.MATR'
        CALL MTDSC3 ( MATR )
        CALL JEVEUO ( MATR(1:19)//'.&INT', 'E', LDSCON )
      ENDIF
C
C --- RECUPERATION DU DESCRIPTEUR DE LA MATRICE MECANIQUE
C
      CALL JEVEUO(MATASS//'.&INT', 'E', LMAT)
C
C --- INITIALISATION POUR LA DETERMINATION DE POINTS FIXE
C
      CTCFIX = .FALSE.
C      
C --- CALCUL DES JEUX INITIAUX      
C      
      CALL CFJEIN(NOMA  ,DEFICO,RESOCO,DDEPLA,LMAT  )
C
C --- ARRET OU NON SI MATRICE DE CONTACT SINGULIERE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<CONTACT> ALGORITHME DE RECHERCHE DE CONTACT'
      ENDIF
C
C --- CHOIX DE L'ALGO DE CONTACT/FROTTEMENT
C
      IF (ICONT.EQ.4) THEN
        IF (IFROT.EQ.0) THEN
          CALL ALGOCP(RESOCO,LMAT  ,DDEPLA)
        ELSEIF (IFROT.EQ.1) THEN
          CALL FROGDP(DEFICO,RESOCO,LMAT  ,DDEPLA,RESIGR,
     &                DEPDEL)
        ELSE
          CALL ASSERT(.FALSE.)
        ENDIF    
      ELSE IF (ICONT.EQ.1) THEN
        IF (LGLISS) THEN
          CALL ALGOGL(DEFICO,RESOCO,LMAT  ,LDSCON,NOMA  ,
     &                DDEPLA,CTCCVG)
        ELSE
          CALL ALGOCO(DEFICO,RESOCO,LMAT  ,LDSCON,NOMA  ,
     &                DDEPLA,CTCCVG)
        ENDIF
      ELSE IF (ICONT.EQ.2) THEN
        IF (IFROT.EQ.0) THEN      
          CALL ALGOCG(DEFICO,RESOCO,MATASS,NOMA  ,DDEPLA,
     &                CTCCVG)
        ELSE
          CALL ASSERT(.FALSE.)
        ENDIF
           
      ELSE IF (ICONT.EQ.5) THEN
        IF (IFROT.EQ.0) THEN
          CALL ALGOCL(DEFICO,RESOCO,LMAT  ,LDSCON,NOMA  ,
     &                DDEPLA,CTCCVG,CTCFIX)             
        ELSEIF (IFROT.EQ.1) THEN
          CALL FROPGD(DEFICO,RESOCO,LMAT  ,LDSCON,NOMA  ,
     &                DDEPLA,RESIGR,DEPDEL,CTCCVG,CTCFIX)
        ELSEIF (IFROT.EQ.2) THEN
          IF (NDIMG.EQ.2) THEN
            CALL FRO2GD(DEFICO,RESOCO,LMAT  ,LDSCON,NOMA  ,
     &                  DEPDEL,DDEPLA,CTCCVG)
          ELSEIF (NDIMG.EQ.3) THEN
            CALL FROLGD(DEFICO,RESOCO,LMAT  ,LDSCON,NOMA  ,
     &                  DDEPLA,RESIGR,DEPDEL,CTCCVG)
          ELSE
            CALL ASSERT(.FALSE.)
          ENDIF
        ELSE
          CALL ASSERT(.FALSE.)
        ENDIF    
      ELSE
         CALL ASSERT(.FALSE.)
      ENDIF
C 
C --- CALCUL DES JEUX FINAUX
C 
      CALL CFJEFI(NOMA  ,DEFICO,RESOCO,DDEPLA)
C
      CALL JEDEMA()
      END
