      SUBROUTINE CFAPMA(NOMA  ,NEWGEO,DEFICO,RESOCO,LCTFD ,
     &                  LCTF3D,NDIMG ,IZONE ,POSNOE,NUMNOE,
     &                  COORNE,POSMAM,KSIPR1,KSIPR2,TAU1M,
     &                  TAU2M ,IP    ,ILIAI )
C     
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 03/01/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*8  NOMA
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*19 NEWGEO
      REAL*8       COORNE(3),KSIPR1,KSIPR2
      REAL*8       TAU1M(3),TAU2M(3)
      INTEGER      IZONE,NDIMG
      INTEGER      POSMAM
      INTEGER      POSNOE,NUMNOE
      INTEGER      IP,ILIAI
      LOGICAL      LCTFD ,LCTF3D
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES DISCRETES - APPARIEMENT)
C
C RECOPIE DE LA SD APPARIEMENT - CAS MAIT_ESCL
C      
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  NEWGEO : NOUVELLE GEOMETRIE (AVEC DEPLACEMENT GEOMETRIQUE)
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  LCTFD  : FROTTEMENT
C IN  LCTF3D : FROTTEMENT EN 3D
C IN  NDIMG  : DIMENSION DE L'ESPACE
C IN  IZONE  : NUMERO DE LA ZONE DE CONTACT
C IN  POSNOE : INDICES DANS CONTNO DU NOEUD ESCLAVE
C IN  NUMNOE : NUMERO ABSOLU DU NOEUD ESCLAVE
C IN  COORNE : COORDONNEES DU NOEUD ESCLAVE
C IN  POSMAM : INDICES DANS CONTNO DE LA MAILLE MAITRE
C IN  KSIPR1 : COORDONNEE PARAMETRIQUE SUR MAITRE DU POINT ESCLAVE
C              PROJETE
C IN  KSIPR2 : COORDONNEE PARAMETRIQUE SUR MAITRE DU POINT ESCLAVE
C              PROJETE
C IN  TAU1M  : PREMIERE TANGENTE SUR LA MAILLE MAITRE
C IN  TAU2M  : SECONDE TANGENTE SUR LA MAILLE MAITRE 
C IN  KSI2   : SECONDE COORD. DE LA PROJECTION 
C IN  IP     : INDICE DU POINT DANS LA SD APPARIEMENT
C IN  ILIAI  : INDICE DE LA LIAISON COURANTE
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*32  JEXNUM
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      IFM,NIV
      REAL*8       TAU1(3),TAU2(3)
      REAL*8       NORM(3),NOOR
      REAL*8       R8PREM,JEU
      REAL*8       COORNP(3) 
      CHARACTER*8  NOMNOE
      INTEGER      NBNOM,NUMMAM
      INTEGER      POSNSM(9)
      REAL*8       COEFNO(9)
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('CONTACT',IFM,NIV)
C
C --- NUMERO DE LA MAILLE MAITRE
C
      CALL CFNUMM(DEFICO,1     ,POSMAM,NUMMAM)  
C
C --- CARACTERISTIQUES DE LA MAILLE MAITRE
C      
      CALL CFPOSN(DEFICO,POSMAM,POSNSM,NBNOM )    
C
C --- COORDONNEES PROJECTION DU NOEUD ESCLAVE SUR LA MAILLE MAITRE
C
      CALL CFCOOR(NOMA  ,DEFICO,NEWGEO,POSMAM,KSIPR1,
     &            KSIPR2,COORNP) 
C          
C --- RE-DEFINITION BASE TANGENTE SUIVANT OPTIONS    
C
      CALL CFTANR(NOMA  ,NDIMG ,DEFICO,RESOCO,IZONE ,
     &            POSNOE,'MAIL',POSMAM,NUMMAM,KSIPR1,
     &            KSIPR2,TAU1M ,TAU2M ,TAU1  ,TAU2  )    
C
C --- CALCUL DE LA NORMALE INTERIEURE
C
      CALL MMNORM(NDIMG ,TAU1  ,TAU2  ,NORM  ,NOOR  )
      IF (NOOR.LE.R8PREM()) THEN
        CALL JENUNO(JEXNUM(NOMA//'.NOMNOE',NUMNOE),NOMNOE)
        CALL U2MESK('F','CONTACT3_26',1,NOMNOE)
      ENDIF                       
C
C --- CALCUL DU JEU 
C
      CALL CFNEWJ(NDIMG ,COORNE,COORNP,NORM  ,JEU   )     
C
C --- COEFFICIENT DE LA RELATION LINEAIRE SUR NOEUD MAITRE
C       
      CALL CFRELI(NOMA  ,NUMMAM,NBNOM ,KSIPR1,KSIPR2,
     &            COEFNO)
C
C --- AJOUT DE LA LIAISON NODALE
C
      CALL CFADDM(RESOCO,LCTFD ,LCTF3D,IP    ,POSNOE,
     &            NUMNOE,ILIAI ,NDIMG ,NBNOM ,POSNSM,
     &            COEFNO,TAU1  ,TAU2  ,NORM  ,JEU   )
C
      CALL JEDEMA()
      END
