      SUBROUTINE CFIMP3(DEFICO,RESOCO,NOMA  ,IFM   ,NUMORD,
     &                  INSTAP,NBLIAI,NBLIAC,JCNSVR)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 14/09/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      CHARACTER*24 DEFICO,RESOCO
      INTEGER      IFM
      INTEGER      NUMORD
      INTEGER      NBLIAI
      INTEGER      NBLIAC
      INTEGER      JCNSVR
      CHARACTER*8  NOMA
      REAL*8       INSTAP
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE DISCRETE - APPARIEMENT - UTILITAIRE)
C
C IMPRESSION DES INFOS SUR LES LIAISONS DE CONTACT/FROTTEMENT
C
C ----------------------------------------------------------------------
C
C
C IN  IFM    : UNITE D'IMPRESSION DU MESSAGE
C IN  NOMA   : NOM DU MAILLAGE
C IN  DEFICO : SD DE DEFINITION DU CONTACT (ISSUE D'AFFE_CHAR_MECA)
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  NUMORD : NUMERO D'INSTANT
C IN  INSTAP : INSTANT DE CALCUL
C IN  NBLIAI : NOMBRE DE LIAISONS DE CONTACT POSSIBLES
C IN  NBLIAC : NOMBRE DE LIAISONS DE CONTACT ACTIVES
C IN  JCNSVR : POINTEUR SUR OBJET CHAM_NO VALE_CONT
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*24 NUMLIA
      INTEGER      JNUMLI
      INTEGER      CFMMVD,ZRESU
      INTEGER      ILIAI,IZONE,IP
      INTEGER      ENTAPP
      CHARACTER*8  NOMAPP
      INTEGER      NUMNOE,TYPAPP 
      CHARACTER*4  TYPE2
      CHARACTER*24 APJEU
      INTEGER      JAPJEU
      CHARACTER*16 NOMPT
      REAL*8       RN,R,COE,PROD,VARC,AJEUFT
      CHARACTER*19 SDAPPA
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ ()
C
C --- ACCES SD CONTACT
C      
      APJEU  = RESOCO(1:14)//'.APJEU'    
      CALL JEVEUO(APJEU, 'L',JAPJEU)
      ZRESU  = CFMMVD('ZRESU')     
C
C --- ACCES SD CONTACT
C
      NUMLIA = RESOCO(1:14)//'.NUMLIA' 
      CALL JEVEUO(NUMLIA,'L',JNUMLI)

C 
C --- PREMIERS AFFICHAGES      
C  
      WRITE(IFM,1000)
      WRITE(IFM,1001) NUMORD
      WRITE(IFM,1002) INSTAP
      WRITE(IFM,1003) NBLIAI
      WRITE(IFM,1004) NBLIAC
C
C --- SD APPARIEMENT
C
      SDAPPA = RESOCO(1:14)//'.APPA'          
C
C --- BOUCLE SUR LES LIAISONS
C
      DO 120 ILIAI = 1,NBLIAI
C
C ----- POINT DE CONTACT
C      
        IP     = ZI(JNUMLI+3*(ILIAI-1)+1-1)
C
C ----- NOEUS ESCLAVE
C      
        NUMNOE = ZI(JNUMLI+3*(ILIAI-1)+3-1)
C
C ----- NOM DU NOEUD ESCLAVE
C
        CALL APNOMP(SDAPPA,IP    ,NOMPT )
C
C ----- INFOS APPARIEMENT
C
        CALL APINFI(SDAPPA,'APPARI_TYPE'  ,IP    ,TYPAPP )
        CALL APINFI(SDAPPA,'APPARI_ENTITE',IP    ,ENTAPP )
        CALL APINFI(SDAPPA,'APPARI_ZONE'  ,IP    ,IZONE  )
C
C ----- NOM ET TYPE DU MAITRE
C
        CALL CFNOAP(NOMA  ,DEFICO,TYPAPP,ENTAPP,
     &              NOMAPP,TYPE2 )
C
C ----- VALEURS
C
        RN = ZR(JCNSVR-1+(NUMNOE-1)*ZRESU+3 )
        R  = ZR(JCNSVR-1+(NUMNOE-1)*ZRESU+19)

        COE = 0.0D0
        IF ( RN.NE.0.D0 ) THEN
          PROD = (ABS(R)-ABS(RN))
          COE = PROD/RN
        ENDIF

        VARC   = ZR(JCNSVR-1+ (NUMNOE-1)*ZRESU+1 )
        AJEUFT = ZR(JCNSVR-1+ (NUMNOE-1)*ZRESU+9 )
        IF (VARC.NE.0.0D0) THEN
          WRITE (IFM,2000) ILIAI,' (   ',NOMPT ,TYPE2,NOMAPP,
     &                   ') * JEU:',ZR(JAPJEU+ILIAI-1),' * RN:',RN,
     &                   ' * GLI:',AJEUFT,' * R:',R,
     &                   ' * RT/RN:',COE
        ELSE
          WRITE (IFM,2001) ILIAI,' (   ',NOMPT ,TYPE2,NOMAPP,
     &                   ') * JEU:',ZR(JAPJEU+ILIAI-1),' * RN:',RN,
     &                   ' * GLI:',AJEUFT,' * R:',R,
     &                   ' * RT/RN:',COE
        ENDIF
 120  CONTINUE
C    
1000  FORMAT (' <CONTACT> LISTE DES LIAISONS DE CONTACT')
1001  FORMAT (' <CONTACT>   NUMERO D''ORDRE  : ',I6)
1002  FORMAT (' <CONTACT>   INSTANT          : ',1PE12.5)
1003  FORMAT (' <CONTACT>   LIAISONS         : ',I6)
1004  FORMAT (' <CONTACT>   LIAISONS ACTIVES : ',I6)
2000  FORMAT (' <CONTACT>   * LIAISON ACTIVE   ',I6,A5,A16,A4,A8,
     &        A8,1PE12.5,A6,1PE12.5,
     &        A7,1PE12.5,A5,1PE12.5,
     &        A9,1PE12.5)
2001  FORMAT (' <CONTACT>   * LIAISON INACTIVE ',I6,A5,A16,A4,A8,
     &        A8,1PE12.5,A6,1PE12.5,
     &        A7,1PE12.5,A5,1PE12.5,
     &        A9,1PE12.5)     
C
      CALL JEDEMA()
      END
