      SUBROUTINE CFJEFI(NOMA  ,DEFICO,RESOCO,RESU  )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 19/10/2010   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      CHARACTER*8  NOMA
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*19 RESU
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE DISCRETE - ALGORITHME)
C
C CALCUL DES JEUX FINAUX
C
C ----------------------------------------------------------------------
C 
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  DEFICO : SD DE DEFINITION DU CONTACT
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  RESU   : INCREMENT "DDEPLA" DE DEPLACEMENT DEPUIS L'ITERATION
C              DE NEWTON PRECEDENTE (CORRIGEE PAR LE CONTACT)
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      ILIAI,JDECAL,JRESU,NBDDL
      REAL*8       VAL
      INTEGER      IFM,NIV
      LOGICAL      CFDISL,LCTFD,LPENAC,LPENAF,LLAGRF
      CHARACTER*24 APCOEF,APDDL ,APPOIN
      INTEGER      JAPCOE,JAPDDL,JAPPTR
      CHARACTER*24 APJEU,APCOFR,APJEFX
      INTEGER      JAPJEU,JAPCOF,JAPJFX
      INTEGER      CFDISD,NBLIAI,NEQ,NBLIAC,LLF,LLF1,LLF2,NDIMG
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ ()
      CALL INFDBG('CONTACT',IFM,NIV)
      IF (NIV.EQ.2) THEN
        WRITE(IFM,*)'<CONTACT> LIAISONS FINALES '
      ENDIF       
C
C --- LECTURE DES STRUCTURES DE DONNEES DE CONTACT
C
      APPOIN = RESOCO(1:14)//'.APPOIN'
      APCOEF = RESOCO(1:14)//'.APCOEF'
      APJEU  = RESOCO(1:14)//'.APJEU'
      APDDL  = RESOCO(1:14)//'.APDDL'
      APCOFR = RESOCO(1:14)//'.APCOFR'
      APJEFX = RESOCO(1:14)//'.APJEFX'
      CALL JEVEUO(APPOIN,'L',JAPPTR)
      CALL JEVEUO(APCOEF,'L',JAPCOE)
      CALL JEVEUO(APDDL ,'L',JAPDDL)
      CALL JEVEUO(APJEU ,'E',JAPJEU)
      CALL JEVEUO(RESU(1:19)//'.VALE','L',JRESU) 
C            
      NBLIAI = CFDISD(RESOCO,'NBLIAI'  )
      NBLIAC = CFDISD(RESOCO,'NBLIAC'  ) 
      LLF    = CFDISD(RESOCO,'LLF'     ) 
      LLF1   = CFDISD(RESOCO,'LLF1'    ) 
      LLF2   = CFDISD(RESOCO,'LLF2'    )                  
      NEQ    = CFDISD(RESOCO,'NEQ'     )
      NDIMG  = CFDISD(RESOCO,'NDIM'    )    
      LCTFD  = CFDISL(DEFICO,'FROT_DISCRET') 
      LPENAC = CFDISL(DEFICO,'CONT_PENA'   )
      LPENAF = CFDISL(DEFICO,'FROT_PENA'   ) 
      LLAGRF = CFDISL(DEFICO,'FROT_LAGR'   ) 
        
C      
C --- CONTACT PENALISE PUR: PAS DE SAUVEGARDE DES JEUX
C
      IF (LPENAC.AND.(.NOT.LCTFD)) THEN
        GOTO 99
      ENDIF   
C      
C --- CONTACT PENALISE ET FROTTEMENT PENALISE: PAS DE SAVE
C           
      IF (LPENAC.AND.LPENAF) THEN
        GOTO 99
      ENDIF 
C
      DO 10 ILIAI = 1,NBLIAI
          JDECAL = ZI(JAPPTR+ILIAI-1)
          NBDDL  = ZI(JAPPTR+ILIAI) - ZI(JAPPTR+ILIAI-1)
          CALL CALADU(NEQ,NBDDL,ZR(JAPCOE+JDECAL),ZI(JAPDDL+JDECAL),
     &                ZR(JRESU),VAL)
          ZR(JAPJEU-1+ILIAI) = ZR(JAPJEU-1+ILIAI) - VAL

          IF (LLAGRF.AND.NDIMG.EQ.2) THEN
            CALL JEVEUO(APCOFR,'L',JAPCOF)
            CALL JEVEUO(APJEFX,'E',JAPJFX)
            CALL CALADU(NEQ,NBDDL,ZR(JAPCOF+JDECAL),
     &                  ZI(JAPDDL+JDECAL),ZR(JRESU),VAL)
            ZR(JAPJFX-1+ILIAI)  = ZR(JAPJFX-1+ILIAI) + VAL  
          ENDIF
  10    CONTINUE
C
C --- AFFICHAGE
C
  99  CONTINUE
      IF ( NIV .GE. 2 ) THEN
        WRITE(IFM,1003) NBLIAC
        IF (LCTFD.AND.(.NOT.LPENAF)) THEN
          IF (NDIMG.EQ.2) THEN
            WRITE(IFM,1006) LLF
          ELSEIF (NDIMG.EQ.3) THEN
            WRITE(IFM,2006) LLF
            WRITE(IFM,3006) LLF1          
            WRITE(IFM,4006) LLF2
          ELSE
            CALL ASSERT(.FALSE.)     
          ENDIF 
        ENDIF 
               
        CALL CFIMP1(NOMA  ,DEFICO,RESOCO,IFM   )
      END IF  
C
 1003 FORMAT (' <CONTACT> <> NOMBRE DE LIAISONS CONTACT FINALES:',
     &       I6,')')    
 1006 FORMAT (' <CONTACT> <> NOMBRE DE LIAISONS ADH. FINALES:',
     &       I6,')')
 2006 FORMAT (' <CONTACT> <> NOMBRE DE LIAISONS ADH. '//
     &        'FINALES (1 ET 2):',I6,')')
 3006 FORMAT (' <CONTACT> <> NOMBRE DE LIAISONS ADH. '//
     &        'FINALES (1 UNIQ.):',I6,')')
 4006 FORMAT (' <CONTACT> <> NOMBRE DE LIAISONS ADH. '//
     &        'FINALES (2 UNIQ.):',I6,')')
C  
      CALL JEDEMA()
C
      END
