      SUBROUTINE CFMMAR(NOMA  ,DEFICO,NEWGEO,SDAPPA,NZOCO ,
     &                  NTPT  ,NDIMG ,NTMA  ,NTNO  ,NTMANO)
C      
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 03/01/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C 
      IMPLICIT NONE
      CHARACTER*8  NOMA
      CHARACTER*19 SDAPPA
      CHARACTER*24 DEFICO
      CHARACTER*19 NEWGEO
      INTEGER      NZOCO,NTPT,NDIMG,NTMA,NTMANO,NTNO
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES MAILLEES - SD APPARIEMENT)
C
C REMPLISSAGE DE LA SD POUR L'APPARIEMENT
C      
C ----------------------------------------------------------------------
C
C /!\ SAUF COORDONNNEES DES POINTS (VOIR MMPOIN ET CFPOIN)
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  SDAPPA : NOM DE LA SD APPARIEMENT
C IN  NEWGEO : GEOMETRIE ACTUALISEE
C IN  NZOCO  : NOMBRE DE ZONES
C IN  NTPT   : NOMBRE TOTAL DE POINT A APPARIER
C IN  NDIMG  : DIMENSION DE L'ESPACE
C IN  NTMA   : NOMBRE TOTAL DE MAILLES
C IN  NTNO   : NOMBRE TOTAL DE NOEUDS
C IN  NTMANO : NOMBRE TOTAL DE NOEUD AUX ELEMENTS (ELNO)
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*32 JEXNUM
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      IFM,NIV
      CHARACTER*24 NOMSD
      INTEGER      JNOMSD
      CHARACTER*24 APINZI,APINZR
      INTEGER      JPINZI,JPINZR      
      CHARACTER*24 APINFI,APINFR
      INTEGER      JPINFI,JPINFR   
      INTEGER      IZONE
      INTEGER      CFDISI,MMINFI
      REAL*8       CFDISR,MMINFR
      INTEGER      IAPPA,ITYPA,ITYPEE,ITYPEM
      INTEGER      NBPT,NBNOM,NBNOE,NBMAM,NBMAE
      INTEGER      JDECNM,JDECMM,JDECNE,JDECME
      CHARACTER*24 APTGEL
      INTEGER      LONGC,LONGT,NNOSD,IBID,POSMA,IMA
      CHARACTER*8  K8BID
      INTEGER      APMMVD,ZINZR,ZINZI
      LOGICAL      CFCALD
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('CONTACT',IFM,NIV)      
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<CONTACT> ...... REMPLISSAGE SD APPARIEMENT' 
      ENDIF                      
C
C --- SD NOMS
C
      NOMSD  = SDAPPA(1:19)//'.NOSD'        
      CALL JEVEUO(NOMSD ,'E',JNOMSD)               
C
      ZK24(JNOMSD+1 -1) = NOMA
      ZK24(JNOMSD+2 -1) = NEWGEO
      ZK24(JNOMSD+3 -1) = DEFICO
C
C --- SD INFORMATIONS GLOBALES
C
      APINFI = SDAPPA(1:19)//'.INFI'
      APINFR = SDAPPA(1:19)//'.INFR'
      CALL JEVEUO(APINFI,'E',JPINFI) 
      CALL JEVEUO(APINFR,'E',JPINFR)  
      ZINZR   = APMMVD('ZINZR')
      ZINZI   = APMMVD('ZINZI')
C      
      ZI(JPINFI+1-1) = NZOCO
      ZI(JPINFI+2-1) = NTPT
      ZI(JPINFI+3-1) = NTMA
      ZI(JPINFI+4-1) = CFDISI(DEFICO,'PROJ_NEWT_ITER')
      ZI(JPINFI+5-1) = NDIMG
      ZI(JPINFI+6-1) = NTNO
C
      ZR(JPINFR+1-1) = CFDISR(DEFICO,'PROJ_NEWT_RESI') 
C
C --- SD INFORMATIONS PAR ZONE
C
      APINZI = SDAPPA(1:19)//'.INZI'
      APINZR = SDAPPA(1:19)//'.INZR'     
      CALL JEVEUO(APINZI,'E',JPINZI)
      CALL JEVEUO(APINZR,'E',JPINZR)
      DO 30 IZONE = 1,NZOCO
C
C ----- DIMENSIONS GENERALES
C      
        NBPT   = MMINFI(DEFICO,'NBPT'  ,IZONE )
        NBNOM  = MMINFI(DEFICO,'NBNOM' ,IZONE )
        NBNOE  = MMINFI(DEFICO,'NBNOE' ,IZONE )
        NBMAM  = MMINFI(DEFICO,'NBMAM' ,IZONE )
        NBMAE  = MMINFI(DEFICO,'NBMAE' ,IZONE )
        JDECNM = MMINFI(DEFICO,'JDECNM',IZONE )
        JDECMM = MMINFI(DEFICO,'JDECMM',IZONE )
        JDECNE = MMINFI(DEFICO,'JDECNE',IZONE )
        JDECME = MMINFI(DEFICO,'JDECME',IZONE )
        ZI(JPINZI+ZINZI*(IZONE-1)+1 -1) = NBPT
        ZI(JPINZI+ZINZI*(IZONE-1)+2 -1) = NBNOM
        ZI(JPINZI+ZINZI*(IZONE-1)+3 -1) = NBNOE
        ZI(JPINZI+ZINZI*(IZONE-1)+4 -1) = NBMAM
        ZI(JPINZI+ZINZI*(IZONE-1)+5 -1) = NBMAE
        ZI(JPINZI+ZINZI*(IZONE-1)+6 -1) = JDECNM
        ZI(JPINZI+ZINZI*(IZONE-1)+7 -1) = JDECMM
        ZI(JPINZI+ZINZI*(IZONE-1)+8 -1) = JDECNE
        ZI(JPINZI+ZINZI*(IZONE-1)+9 -1) = JDECME
C
C ----- TOLERANCES ET TYPE APPARIEMENT
C
        ITYPA  = MMINFI(DEFICO,'TYPE_APPA'  ,IZONE )
        ZI(JPINZI+ZINZI*(IZONE-1)+10-1) = ITYPA
        IAPPA  = MMINFI(DEFICO,'APPARIEMENT',IZONE)
        ZI(JPINZI+ZINZI*(IZONE-1)+11-1) = IAPPA
        ZR(JPINZR+ZINZR*(IZONE-1)+4 -1) = 
     &    MMINFR(DEFICO,'TOLE_APPA'     ,IZONE )
        ZR(JPINZR+ZINZR*(IZONE-1)+5 -1)= 
     &    MMINFR(DEFICO,'TOLE_PROJ_EXT' ,IZONE )      
        IF (ITYPA.EQ.1) THEN
          ZR(JPINZR+ZINZR*(IZONE-1)+1 -1) = 
     &      MMINFR(DEFICO,'TYPE_APPA_DIRX',IZONE )
          ZR(JPINZR+ZINZR*(IZONE-1)+2 -1) = 
     &      MMINFR(DEFICO,'TYPE_APPA_DIRY',IZONE ) 
          ZR(JPINZR+ZINZR*(IZONE-1)+3 -1)= 
     &      MMINFR(DEFICO,'TYPE_APPA_DIRZ',IZONE )
        ENDIF
C
C ----- ORIENTATION BASE LOCALE (AUTO, FIXE, VECT_Y) - MAITRE
C
        ITYPEM = MMINFI(DEFICO,'VECT_MAIT',IZONE )
        ZI(JPINZI+ZINZI*(IZONE-1)+12-1) = ITYPEM
        IF (ITYPEM.NE.0) THEN
          ZR(JPINZR+ZINZR*(IZONE-1)+6 -1) = 
     &      MMINFR(DEFICO,'VECT_MAIT_DIRX',IZONE )
          ZR(JPINZR+ZINZR*(IZONE-1)+7 -1) = 
     &      MMINFR(DEFICO,'VECT_MAIT_DIRY',IZONE ) 
          ZR(JPINZR+ZINZR*(IZONE-1)+8 -1)= 
     &      MMINFR(DEFICO,'VECT_MAIT_DIRZ',IZONE )
        ENDIF
C
C ----- ORIENTATION BASE LOCALE (AUTO, FIXE, VECT_Y) - ESCLAVE
C
        ITYPEE = MMINFI(DEFICO,'VECT_ESCL',IZONE )
        ZI(JPINZI+ZINZI*(IZONE-1)+13-1) = ITYPEE
        IF (ITYPEE.NE.0) THEN
          ZR(JPINZR+ZINZR*(IZONE-1)+9 -1) = 
     &      MMINFR(DEFICO,'VECT_ESCL_DIRX',IZONE )
          ZR(JPINZR+ZINZR*(IZONE-1)+10-1) = 
     &      MMINFR(DEFICO,'VECT_ESCL_DIRY',IZONE ) 
          ZR(JPINZR+ZINZR*(IZONE-1)+11-1)= 
     &      MMINFR(DEFICO,'VECT_ESCL_DIRZ',IZONE )
        ENDIF
C
C ----- CALCUL AUTORISE MAITRE/ESCLAVE
C
        IF (CFCALD(DEFICO,IZONE,'ESCL')) THEN
          ZI(JPINZI+ZINZI*(IZONE-1)+14-1) = 1
        ENDIF
        IF (CFCALD(DEFICO,IZONE,'MAIT')) THEN
          ZI(JPINZI+ZINZI*(IZONE-1)+15-1) = 1
        ENDIF        
C
  30  CONTINUE
C
C --- TANGENTES AUX NOEUDS PAR ELEMENT
C        
      APTGEL = SDAPPA(1:19)//'.TGEL'
      LONGT  = 0
      DO 20 IMA = 1,NTMA
        POSMA  = IMA
        CALL CFNBEN(DEFICO,POSMA ,'CONNEX',NNOSD ,IBID  )
        LONGC  = 6*NNOSD
        CALL JEECRA(JEXNUM(APTGEL,IMA),'LONMAX',LONGC ,K8BID)
        CALL JECROC(JEXNUM(APTGEL,IMA))
        LONGT = LONGT + LONGC
 20   CONTINUE
      CALL ASSERT(LONGT.EQ.6*NTMANO)   
C      
      CALL JEDEMA()     
C
      END
