      SUBROUTINE CFMMVE(NOMA  ,DEFICO,RESOCO,VALINC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 03/01/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*8  NOMA
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*19 VALINC(*)
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE VERIF)
C
C ROUTINE PRINCIPALE
C      
C ----------------------------------------------------------------------
C
C
C IN  DEFICO : SD DE DEFINITION DU CONTACT
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  NOMA   : NOM DU MAILLAGE
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C
C ------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C --------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------
C
      INTEGER      IFM,NIV
      CHARACTER*19 SDAPPA,OLDGEO,NEWGEO,DEPPLU
      LOGICAL      CFDISL,LCTCC,LCTCD,LALLV
      CHARACTER*24 JEUX,LOCA,ENTI,ZONE
      INTEGER      NPT
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('CONTACT',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<CONTACT> MODE VERIF' 
      ENDIF 
C
C --- TYPE DE CONTACT      
C
      LCTCC  = CFDISL(DEFICO,'FORMUL_CONTINUE')
      LCTCD  = CFDISL(DEFICO,'FORMUL_DISCRETE')
      LALLV  = CFDISL(DEFICO,'ALL_VERIF')
C
C --- DECOMPACTION VARIABLES CHAPEAUX
C
      OLDGEO = NOMA(1:8)//'.COORDO'
      CALL NMCHEX(VALINC,'VALINC','DEPPLU',DEPPLU)
C
C --- NOM DES SDs
C
      SDAPPA = RESOCO(1:14)//'.APPA'
      NEWGEO = RESOCO(1:14)//'.NEWG'
C
C --- MAJ GEOMETRIE
C      
      IF (LALLV) THEN  
        CALL VTGPLD(OLDGEO,1.0D0,DEPPLU,'V',NEWGEO)
      ENDIF
C
C --- CREATION SD APPARIEMENT EN MODE ALL VERIF
C
      IF (LALLV) THEN
C
C ----- RE-REMPLISSAGE DE LA SD APPARIEMENT - POINTS (COORD. ET NOMS)
C       
        IF (LCTCC) THEN
          CALL MMPOIN(NOMA  ,DEFICO,NEWGEO,SDAPPA)
        ELSEIF (LCTCD) THEN
          CALL CFPOIN(NOMA  ,DEFICO,NEWGEO,SDAPPA)
        ELSE
          CALL ASSERT(.FALSE.)
        ENDIF
C
C ----- REALISATION DE L'APPARIEMENT
C
        CALL APCALC(SDAPPA)              
C      
      ENDIF
C 
C --- CREATION SD PROVISOIRES POUR VERIF
C      
      CALL CFMMVC(DEFICO,JEUX  ,LOCA  ,ENTI  ,ZONE  ,
     &            NPT   )
C 
C --- EVALUATION DES POINTS EN MODE VERIF
C
      IF (LCTCC) THEN
        CALL MMVERI(NOMA  ,DEFICO,RESOCO,NEWGEO,SDAPPA,
     &              NPT   ,JEUX  ,LOCA  ,ENTI  ,ZONE  )
      ELSEIF (LCTCD) THEN
        CALL CFVERI(NOMA  ,DEFICO,RESOCO,NEWGEO,SDAPPA,
     &              NPT   ,JEUX  ,LOCA  ,ENTI  ,ZONE  )
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF
C
C --- AFFICHAGE DES INTERPENETRATIONS EVENTUELLES
C
      CALL CFSANS(DEFICO,NPT   ,JEUX  ,ENTI  ,ZONE)
C
C --- SAUVEGARDE DANS LA SD RESULTAT
C
      CALL CFMMVS(RESOCO,NPT   ,JEUX  ,LOCA  )
C
C --- NETTOYAGE
C
      CALL JEDETR(JEUX  )
      CALL JEDETR(LOCA  )
      CALL JEDETR(ENTI  )
      CALL JEDETR(ZONE  )             
C
      CALL JEDEMA()

      END
