      SUBROUTINE CFMXME(NOMA  ,NUMEDD,DEFICO,RESOCO)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/12/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*8  NOMA
      CHARACTER*24 NUMEDD
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES CONTINUE)
C
C CREATION SD DE RESOLUTION RESOCO
C
C ----------------------------------------------------------------------
C
C
C IN  NUMEDD : NUME_DDL DE LA MATRICE TANGENTE GLOBALE
C IN  NOMA   : NOM DU MAILLAGE
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  RESOCO : SD POUR LA RESOLUTION DE CONTACT
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      IFM,NIV
      CHARACTER*8  K8BID
      INTEGER      IRET  ,NEQ   ,NTPC
      CHARACTER*24 MDECOL,ETATCT
      INTEGER      JMDECO,JETAT
      CHARACTER*24 TABFIN
      INTEGER      JTABF
      CHARACTER*24 VITINI,ACCINI
      CHARACTER*24 JEUSUR,FLIFLO
      INTEGER      JUSU  ,JFLIP
      INTEGER      CFDISI
      INTEGER      CFMMVD,ZTABF,ZETAT
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('CONTACT',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<CONTACT> ... CREATION DES SD POUR LA '//
     &                ' FORMULATION CONTINUE'
      ENDIF
C
C --- INITIALISATIONS
C
      CALL DISMOI('F','NB_EQUA',NUMEDD,'NUME_DDL',NEQ,K8BID,IRET)
C
C --- FONCTIONNALITES ACTIVEES
C
      NTPC   = CFDISI(DEFICO,'NTPC'     )
C
C --- TABLEAU CONTENANT LES INFORMATIONS DIVERSES
C
      TABFIN = RESOCO(1:14)//'.TABFIN'
      ZTABF  = CFMMVD('ZTABF')
      CALL WKVECT(TABFIN,'V V R',ZTABF*NTPC+1,JTABF)
      ZR(JTABF) = NTPC
C
C --- GESTION AUTOMATIQUE DES RELATIONS REDONDANTES
C
      CALL MMREDO(NUMEDD,DEFICO,RESOCO)
C
C --- CREATION DES CARTES D'USURE
C
      CALL MMUSUC(NOMA  ,DEFICO,RESOCO)
C
C --- CREATION INDICATEUR DE DECOLLEMENT DANS COMPLIANCE
C
      MDECOL = RESOCO(1:14)//'.MDECOL'
      CALL WKVECT(MDECOL,'V V L',1,JMDECO)
      ZL(JMDECO+1-1) = .FALSE.
C
C --- VECTEUR POUR LA DYNAMIQUE A L INSTANT MOINS
C --- UTILE UNIQUEMENT AFIN D ARCHIVER LE DERNIER INSTANT CALCULE
C --- SI PLANTE POUR LE NOUVEAU PAS DE TEMPS DANS
C --- LES ITERATIONS DE NEWTON
C
      VITINI = RESOCO(1:14)//'.VITI'
      ACCINI = RESOCO(1:14)//'.ACCI'
      CALL VTCREB(VITINI,NUMEDD,'V','R',NEQ   )
      CALL VTCREB(ACCINI,NUMEDD,'V','R',NEQ   )
C
C --- OBJET DE SAUVEGARDE DE L ETAT DE CONTACT
C
      ZETAT  = CFMMVD('ZETAT')
      ETATCT = RESOCO(1:14)//'.ETATCT'
      CALL WKVECT(ETATCT,'V V R',ZETAT*NTPC,JETAT)
C
C --- JEU SUPPLEMENTAIRE POUR USURE
C
      JEUSUR = RESOCO(1:14)//'.JEUSUR'
      CALL WKVECT(JEUSUR,'V V R',NTPC  ,JUSU  )
C
C --- CREATION SD POUR LE FLIP-FLOP
C
      FLIFLO = RESOCO(1:14)//'.FLIPFLOP '
      CALL WKVECT(FLIFLO,'V V I',NTPC  ,JFLIP )
C
      CALL JEDEMA()
      END
