      SUBROUTINE CFNBSF(DEFICO,ISURF ,TYPENT,NBENT ,JDEC  )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 14/09/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2008  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE    
      CHARACTER*24 DEFICO
      CHARACTER*4  TYPENT
      INTEGER      ISURF,JDEC
      INTEGER      NBENT
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES MAILLEES - UTILITAIRE)
C
C ACCES AUX NOEUDS/MAILLES D'UNE ZONE DONNEE
C
C ----------------------------------------------------------------------
C
C
C IN  DEFICO : SD DE DEFINITION DU CONTACT
C IN  TYPENT : TYPE D'ENTITE
C               NOEU  NBRE NOEUDS ATTACHES A LA SURFACE
C               MAIL  NBRE MAILLES ATTACHEES A LA SURFACE
C IN  ISURF  : NUMERO DE LA SURFACE
C OUT NBENT  : NOMBRE D'ENTITES
C OUT JDEC   : DECALAGE DANS LES VECTEURS POUR LE PREMIER DE LA SURFACE
C               NOEU  DEFICO(1:16)//'.NOEUCO'
C               MAIL  DEFICO(1:16)//'.MAILCO'
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*24 PSURNO,PSURMA
      INTEGER      JSUNO,JSUMA
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C      
C --- RECUPERATION DE QUELQUES DONNEES      
C
      PSURNO = DEFICO(1:16)//'.PSUNOCO'
      PSURMA = DEFICO(1:16)//'.PSUMACO'
      CALL JEVEUO(PSURNO,'L',JSUNO )
      CALL JEVEUO(PSURMA,'L',JSUMA )     
C
C --- INITIALISATIONS
C
      IF (TYPENT.EQ.'NOEU') THEN
        NBENT  = ZI(JSUNO+ISURF) - ZI(JSUNO+ISURF-1)
        JDEC   = ZI(JSUNO+ISURF-1)
      ELSEIF (TYPENT.EQ.'MAIL') THEN
        NBENT  = ZI(JSUMA+ISURF) - ZI(JSUMA+ISURF-1)
        JDEC   = ZI(JSUMA+ISURF-1)       
      ELSE    
        CALL ASSERT(.FALSE.)
      ENDIF
C
      CALL JEDEMA()
C
      END
