      SUBROUTINE CFPARZ(RESOCO,ILIAI ,COEFFF,COEFPN,COEFPT,
     &                  COEFTE,DISSUP)
C     
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 14/09/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*24 RESOCO
      REAL*8       COEFFF,COEFPN,COEFPT,COEFTE,DISSUP
      INTEGER      ILIAI
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES DISCRETES - APPARIEMENT)
C
C CARACTERISTIQUES DES LIAISONS POUR LA ZONE
C
C ----------------------------------------------------------------------
C
C
C IN  ILIAI  : INDICE DE LA LIAISON COURANTE
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  DISSUP : JEU FICTIF DE LA ZONE
C IN  COEFPN : COEFFICIENT DE PENALISATION DE CONTACT
C IN  COEFPT : COEFFICIENT DE PENALISATION DE FROTTEMENT      
C IN  COEFFF : COEFFICIENT DE FROTTEMENT
C IN  COEFTE : COEFFICIENT THETA POUR FROTTEMENT
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      IFM,NIV
      INTEGER      CFMMVD,ZTACF
      CHARACTER*24 APJEU
      INTEGER      JAPJEU
      CHARACTER*24 TACFIN,JEUSUP
      INTEGER      JTACF,JJSUP
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()      
      CALL INFDBG('CONTACT',IFM,NIV) 
C
C --- LECTURE DES SD POUR LE CONTACT POTENTIEL
C
      APJEU  = RESOCO(1:14)//'.APJEU'
      TACFIN = RESOCO(1:14)//'.TACFIN' 
      JEUSUP = RESOCO(1:14)//'.JSUPCO' 
C
      CALL JEVEUO(APJEU ,'E',JAPJEU)
      CALL JEVEUO(TACFIN,'E',JTACF )
      CALL JEVEUO(JEUSUP,'E',JJSUP )      
C
      ZTACF  = CFMMVD('ZTACF')  
C
C --- JEU FICTIF DE LA ZONE
C    
      ZR(JJSUP+ILIAI-1)  = DISSUP
C
C --- ADDITION DU JEU FICTIF DE LA ZONE DANS APJEU
C
      ZR(JAPJEU+ILIAI-1) = ZR(JAPJEU+ILIAI-1) - DISSUP
C
C --- RECOPIE CARACTERISTIQUES ZONE -> NOEUDS ESCLAVES
C           
      ZR(JTACF+ZTACF*(ILIAI-1)+0) = COEFFF
      ZR(JTACF+ZTACF*(ILIAI-1)+1) = COEFPN
      ZR(JTACF+ZTACF*(ILIAI-1)+2) = COEFPT
      ZR(JTACF+ZTACF*(ILIAI-1)+3) = COEFTE
C
      CALL JEDEMA
      END
