      SUBROUTINE CFSVFR(DEFICO,RESOCO,LCONV )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2011   AUTEUR MACOCCO K.MACOCCO 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
      IMPLICIT     NONE
      CHARACTER*24 DEFICO,RESOCO
      LOGICAL      LCONV
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES DISCRETES)
C
C SAUVEGARDE DU STATUT DE FROTTEMENT POUR PERMETTRE LE TRANSPORT
C D'UN APPARIEMENT A UN AUTRE
C
C ----------------------------------------------------------------------
C
C IN  DEFICO : SD DE DEFINITION DU CONTACT
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  LCONV  : SAUVEGARDE T-ON UN ETAT CONVERGE ?
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      INTEGER      IFM,NIV
      LOGICAL      CFDISL,LLAGRF
      INTEGER      CFDISI,CFDISD,NNOCO
      INTEGER      ILIAC,ILIAI,POSNOE
      INTEGER      NBLIAC,LLF,LLF1,LLF2,BTOTAL
      CHARACTER*19 STATFR,TYPL  ,LIAC  
      INTEGER      JSTFR ,JTYPL ,JLIAC 
      CHARACTER*24 NUMLIA
      INTEGER      JNUMLI
      CHARACTER*8  TYPLIA
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('CONTACT',IFM,NIV)
C
C --- LE STATUT DE FROTTEMENT N'EST SAUVEGARDE QU'EN LAGRANGIEN
C
      LLAGRF = CFDISL(DEFICO,'FROT_LAGR'   )
C
      IF (.NOT.LLAGRF) THEN
        GOTO 999
      ENDIF
C
C --- ACCES OBJETS
C
      IF (LCONV) THEN
        STATFR = RESOCO(1:14)//'.STF0'
      ELSE
        STATFR = RESOCO(1:14)//'.STFR'
      ENDIF
      CALL JEVEUO(STATFR,'E',JSTFR)
      TYPL   = RESOCO(1:14)//'.TYPL'
      CALL JEVEUO(TYPL  ,'L',JTYPL )
      LIAC   = RESOCO(1:14)//'.LIAC'
      CALL JEVEUO(LIAC  ,'L',JLIAC )
      NUMLIA = RESOCO(1:14)//'.NUMLIA'
      CALL JEVEUO(NUMLIA,'L',JNUMLI)
C
C --- INITIALISATIONS
C
      NNOCO = CFDISI(DEFICO,'NNOCO')
      CALL JERAZO(STATFR,NNOCO,1)
C
C --- INFORMATIONS
C
      NBLIAC = CFDISD(RESOCO,'NBLIAC')
      LLF    = CFDISD(RESOCO,'LLF'   )
      LLF1   = CFDISD(RESOCO,'LLF1'  )
      LLF2   = CFDISD(RESOCO,'LLF2'  )
C
      BTOTAL = NBLIAC + LLF + LLF1 + LLF2
C
C --- SAUVEGARDE DU STATUT DE FROTTEMENT
C
      DO 10 ILIAC = 1,BTOTAL
        TYPLIA = ZK8(JTYPL -1+ILIAC)
        IF (TYPLIA(1:1).NE.'F') GOTO 10
        ILIAI  =  ZI(JLIAC -1+ILIAC)
        POSNOE =  ZI(JNUMLI-1+3*(ILIAI-1)+2)
        CALL ASSERT(POSNOE.LE.NNOCO)
        CALL ASSERT(ZK8(JSTFR-1+POSNOE).EQ.' ')
        ZK8(JSTFR-1+POSNOE) = TYPLIA
  10  CONTINUE
C
 999  CONTINUE
C
      CALL JEDEMA()
      END
