      SUBROUTINE CHEDDL(IDEEQ,NEQ,INO,ITYP,IRAN,NBRAN)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 07/01/98   AUTEUR CIBHHLB L.BOURHRARA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
C
C***********************************************************************
C    P. RICHARD     DATE 27/11/90
C-----------------------------------------------------------------------
C  BUT:  CHERCHER LES RANG D'UN DDL A PARTIR DE SON TYPE ET DU NOEUD
C   SUR LEQUEL IL S'APPUIE
C
C
C  ATTENTION: S'APPUIE SUR UN DEEQ PARTICULIER:
C     IDEEQ(1,I) --> NUMERO DU NOEUD SUR LEQUEL PORTE LE DDL
C     IDEEQ(2,I) --> ENTIER DU TYPE DDL
C
C  AVEC LES TYPES SUIVANTS:
C
C    DX=1    (1)    LAG SUR UN DX=-1   (7)        () PRNO-NUMDDL ASTER
C    DY=2    (2)    LAG SUR UN DY=-2   (7)
C    DZ=3    (3)    LAG SUR UN DZ=-3   (7)
C    DRX=4    (4)    LAG SUR UN DRX=-4   (7)
C    DRY=5    (5)    LAG SUR UN DRY=-5   (7)
C    DRZ=6    (6)    LAG SUR UN DRZ=-6   (7)
C
C
C  DANS LE CAS D'UN LAGRANGE PORTANT SUR PLUSIEURS DDL ET NOEUDS
C  ( TYPIQUEMENT RESULTANT D'UN LIAISON DDL) LE NUMERO DU NOEUD AINSI
C   QUE LE TYPE DE DDL SONT A ZERO
C
C
C   IL PEUT Y AVOIR DEUX RANG POUR UN NOEUD ET UN TYPE DDL DANS LE CAS
C   D'UN LAGRANGE DE DDL-BLOQUE, D'OU LA PRESENCE EN ARGUMENT DU NOMBRE
C  DE RANGS RECHERCHE
C
C  SI NBRAN=1   DDL NON TROUVE--> 0
C               DDL TROUVE--> RANG DU DDL
C
C
C  SI NBRAN=2    AUCUN DDL TROUVE-->(0,0)
C                1 DDL TROUVE-->(RANG1,RANG1)
C                2DDL TROUVE-->(RANG1,RANG2)
C
C-----------------------------------------------------------------------
C
C IDEEQ    /I/: MATRICE DEEQ DU NUMDDL
C NEQ      /I/: NOMBRE DE DDL
C INO      /I/: NUMERO DU NOEUD PORTANT LE DDL
C ITYP     /I/: NUMERO DE TYPE DU DDL (COMME DECRIT PLUS HAUT)
C IRAN     /O/: RANGS DU DDL RECHERCHE(0 SI EXISTE PAS)
C NBRAN    /I/: NOMBRE DE RANGS RECHERCHES
C
C-----------------------------------------------------------------------
C
      INTEGER IDEEQ(2,NEQ),IRAN(NBRAN)
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C
C    MISE A ZERO PREALABLE DES RANGS
C
      DO 20 I=1,NBRAN
        IRAN(I)=0
 20   CONTINUE
C
C
      I=0
      ICOMP=0
 10   CONTINUE
      I=I+1
      INOBIS=IDEEQ(1,I)
      ITYBIS=IDEEQ(2,I)
      IF(INOBIS.EQ.INO.AND.ITYBIS.EQ.ITYP) THEN
        ICOMP=ICOMP+1
        DO 30 K=ICOMP,NBRAN
          IRAN(K)=I
 30     CONTINUE
      ENDIF
      IF(I.LT.NEQ.AND.ICOMP.LT.NBRAN) GOTO 10
C
 9999 CONTINUE
      END
