      SUBROUTINE CONPEN(MACOR,NBCOR,MACOC,NBCOC,
     &                  LFACE,LOCORR,LOREOR,MA)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/02/2008   AUTEUR MACOCCO K.MACOCCO 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
C  ROUTINE CONPEN
C    TRAITEMENT DE KTYC = PENTA6 , KTYR = PENTA6 , TETRA4
C            ET DE KTYC = PENTA15, KTYR = PENTA15, TETRA10
C  DECLARATIONS
C    MACOC  : TABLEAU DES NOMS DES NOEUDS   POUR UNE MAILLE FISSURE
C    MACOR  : TABLEAU DES NOMS DES NOEUDS   POUR UNE MAILLE REFERENCE
C    NBCOC  : NOMBRE DE CONNEX              POUR UNE MAILLE FISSURE
C    NBCOR  : NOMBRE DE CONNEX              POUR UNE MAILLE REFERENCE
C    NBLIC  : NOMBRE DE NOEUD TESTES        POUR UNE MAILLE FISSURE
C    NBLIR  : NOMBRE DE NOEUD TESTES        POUR UNE MAILLE REFERENCE
C    NBNOCO : NOMBRE DE NOEUD COMMUNS
C    NOCOC  : TABLEAU DE RANG DES NOEUDS    POUR UNE MAILLE FISSURE
C
C  MOT_CLEF : ORIE_FISSURE
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     ------------------------------------------------------------------
C
      INTEGER      NBNOCO
      INTEGER      NBLIR,NBCOR
      INTEGER      NBLIC,NBCOC,NOCOC(6)
      INTEGER VALI
C
      CHARACTER*8  MACOR(NBCOR+2),MACOC(NBCOC+2),MA
C
      LOGICAL      LOCORR,LFACE,QUADRA,LOREOR
      LOGICAL      FACE
      FACE(I1,I2,I3)=NOCOC(1).EQ.I1.AND.NOCOC(2).EQ.I2.AND.
     &               NOCOC(3).EQ.I3
C
C     ------------------------------------------------------------------
C
C
      QUADRA=NBCOC.EQ.15
      IF (QUADRA) THEN
        IF (NBCOR.EQ.15) NBLIR=6
        IF (NBCOR.EQ.10) NBLIR=4
      ELSE
        NBLIR  = NBCOR
      ENDIF
      NBLIC  = 6
C
C     -----------------------------------------------------------------
C
      CALL CONCOM(MACOR,NBLIR,MACOC,NBLIC,NBNOCO,NOCOC)
C
      IF (NBNOCO.EQ.3) THEN
        IF (FACE(1,2,3).OR.FACE(4,5,6)) THEN
          LOCORR=.TRUE.
          LFACE=FACE(1,2,3)
        ELSE
          CALL ASSERT(.FALSE.)
        ENDIF
        IF (LFACE) THEN
          I1=1
          I2=2
          I3=3
        ELSE
          I1=6
          I2=5
          I3=4
        ENDIF
        CALL CONORS(I1,I2,I3,MACOC,NBCOC,MACOR,NBCOR,LOREOR,MA)
        IF (LOREOR) THEN
          CALL CONECH(MACOC,1,4)
          CALL CONECH(MACOC,2,5)
          CALL CONECH(MACOC,3,6)
          IF (QUADRA) THEN
            CALL CONECH(MACOC, 7,13)
            CALL CONECH(MACOC, 8,14)
            CALL CONECH(MACOC, 9,15)
          ENDIF
        ENDIF
        CALL CONJAC(1,2,3,4,MACOC,NBCOC,MA)
        CALL CONJAC(2,3,1,5,MACOC,NBCOC,MA)
        CALL CONJAC(3,1,2,6,MACOC,NBCOC,MA)
        CALL CONJAC(4,6,5,1,MACOC,NBCOC,MA)
        CALL CONJAC(5,4,6,2,MACOC,NBCOC,MA)
        CALL CONJAC(6,5,4,3,MACOC,NBCOC,MA)
C
      ELSEIF (NBNOCO.GT.2) THEN
         VALI = NBNOCO
         CALL U2MESG('E', 'ALGORITH12_59',0,' ',1,VALI,0,0.D0)
      ENDIF
C
      END
