      SUBROUTINE CRSVL2(SOLVEU,NPREC,RAIDE)
      IMPLICIT NONE
      CHARACTER*19 SOLVEU,RAIDE
      INTEGER      NPREC
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 10/01/2011   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C ----------------------------------------------------------
C  BUT : REMPLISSAGE SD_SOLVEUR POUR UN CALCUL MODAL DONT LES MATRICES
C        NE S'APPUIENT PAS SUR DES NOEUDS D'UN MAILLAGE (NUME_DDL_GENE)
C        DANS CE CAS SEUL LDLT OU MUMPS SONT LICITES.
C        ON ECRASE DONC LES DONNEES SAISIES PAR L'UTILISATEUR, SAUF
C        CELLES DU BLOC COMMUN AUX SOLVEURS DIRECTS, ET ON IMPOSE MUMPS
C        AVEC LES MEMES VALEURS PAR DEFAUT QUE CELLE DU CATALOGUE STD
C --- ATTENTION A LA COHERENCE AVEC CRSMSP, CRSVMU ET CRSVLD
C
C IN K19 SOLVEU  : NOM DU SOLVEUR DONNE EN ENTREE
C OUT    SOLVEU  : LE SOLVEUR EST CREE ET INSTANCIE
C IN  IN NPREC   : PRECISION DE LA DETECTION DE SINGULARITE
C IN  K19 RAIDE  : NOM DE LA MATRICE DE RAIDEUR (POUR CRITERE DE CHOIX
C                  DU SOLVEUR)
C ----------------------------------------------------------

C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------

      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C --- FIN DECLARATIONS NORMALISEES JEVEUX --------------------

      INTEGER      ISLVK,ISLVI,ISLVR,IREFA,INEQU,NEQ
      REAL*8       JEVTBL
      CHARACTER*14 NU

C------------------------------------------------------------------
      CALL JEMARQ()

      CALL U2MESS('I','ALGELINE5_72')
      CALL JEVEUO(RAIDE//'.REFA','L',IREFA)
      NU = ZK24(IREFA+1)      
      CALL JEVEUO(NU//'.NUME.NEQU','L',INEQU)
      NEQ = ZI(INEQU)
      
C      WRITE(6,*)'<CRSVL2> TAILLE DU PB ',NEQ
     
C --- ON REMPLIT LA SD_SOLVEUR
      CALL JEVEUO(SOLVEU//'.SLVK','E',ISLVK)
      CALL JEVEUO(SOLVEU//'.SLVR','E',ISLVR)
      CALL JEVEUO(SOLVEU//'.SLVI','E',ISLVI)

      IF (NEQ.LE.100) THEN
C --- ATTENTION A LA COHERENCE AVEC CRSVLD
        ZK24(ISLVK-1+1) = 'LDLT'
        ZK24(ISLVK-1+2) = 'XXXX'
        ZK24(ISLVK-1+3) = 'XXXX'
        ZK24(ISLVK-1+4) = 'SANS'
        ZK24(ISLVK-1+5) = 'NON'
        ZK24(ISLVK-1+6) = 'XXXX'
        ZK24(ISLVK-1+7) = 'XXXX'
        ZK24(ISLVK-1+8) = 'XXXX'
        ZK24(ISLVK-1+9) = 'XXXX'
        ZK24(ISLVK-1+10)= 'XXXX'
        ZK24(ISLVK-1+11)= 'XXXX'
        ZK24(ISLVK-1+12)= 'XXXX'

        ZR(ISLVR-1+1) = 0.D0
        ZR(ISLVR-1+2) = 0.D0
        ZR(ISLVR-1+3) = JEVTBL()
        ZR(ISLVR-1+4) = 0.D0

        ZI(ISLVI-1+1) = NPREC
        ZI(ISLVI-1+2) = -9999
        ZI(ISLVI-1+3) = 0
        ZI(ISLVI-1+4) = -9999      
        ZI(ISLVI-1+5) = -9999      
        ZI(ISLVI-1+6) = -9999      
        ZI(ISLVI-1+7) = -9999  
      ELSE IF (NEQ.GT.100) THEN
C --- ATTENTION A LA COHERENCE AVEC CRSMSP ET CRSVMU
        ZK24(ISLVK-1+1) = 'MUMPS'
        ZK24(ISLVK-1+2) = 'AUTO'
        ZK24(ISLVK-1+3) = 'AUTO'
        ZK24(ISLVK-1+4) = 'AUTO'
        ZK24(ISLVK-1+5) = 'NON'
        ZK24(ISLVK-1+6) = 'OUI'
        ZK24(ISLVK-1+7) = 'NON'
        ZK24(ISLVK-1+8) = 'NON'
        ZK24(ISLVK-1+9) = 'NON'
        ZK24(ISLVK-1+10)= 'NON'
        ZK24(ISLVK-1+11)= 'AUTO'
        ZK24(ISLVK-1+12)= 'NON'

        ZR(ISLVR-1+1) = -1.D0
        ZR(ISLVR-1+2) = -1.D0
        ZR(ISLVR-1+3) = 0.D0
        ZR(ISLVR-1+4) = 0.D0

        ZI(ISLVI-1+1) = NPREC
        ZI(ISLVI-1+2) = 30
        ZI(ISLVI-1+3) = 0
        ZI(ISLVI-1+4) = -9999      
        ZI(ISLVI-1+5) = -9999      
        ZI(ISLVI-1+6) = -9999      
        ZI(ISLVI-1+7) = -9999
      ELSE
C DONNEE INVALIDE
        CALL ASSERT(.FALSE.)      
      ENDIF    

      CALL JEDEMA()
      END
