      SUBROUTINE DFDMIP(NDIM,NNO,AXI,GEOM,G,IW,VFF,IDFDE,R,W,DFDI)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 10/05/2005   AUTEUR GJBHHEL E.LORENTZ 
C ======================================================================
C COPYRIGHT (C) 1991 - 2005  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================

      IMPLICIT NONE

      LOGICAL AXI
      INTEGER NDIM,NNO,G,IW,IDFDE
      REAL*8  GEOM(NDIM,NNO),VFF(NNO),R,W,DFDI(NNO,NDIM)

C ----------------------------------------------------------------------
C     CALCUL DES DERIVEES DES FONCTIONS DE FORME ET DU JACOBIEN
C
C IN  NDIM    : DIMENSION DE L'ESPACE
C IN  NNO     : NOMBRE DE NOEUDS (FAMILLE E-BARRE)
C IN  AXI     : .TRUE. SI AXISYMETRIQUE
C IN  GEOM    : COORDONNEES DES NOEUDS
C IN  G       : NUMERO DU POINT DE GAUSS COURANT
C IN  IW      : ACCES AUX POIDS DES POINTS DE GAUSS DE REFERENCE
C IN  VFF     : VALEURS DES FONCTIONS DE FORME (POINT DE GAUSS COURANT)
C IN  IDFDE   : DERIVEES DES FONCTIONS DE FORME DE REFERENCE
C OUT R       : RAYON DU POINT DE GAUSS COURANT (EN AXI)
C OUT W       : POIDS DU POINT DE GAUSS COURANT (Y COMPRIS R EN AXI)
C OUT DFDI    : DERIVEE DES FONCTIONS DE FORME (POINT DE GAUSS COURANT)
C ----------------------------------------------------------------------

      REAL*8 DDOT
C ----------------------------------------------------------------------



C - CALCUL DES DERIVEES DES FONCTIONS DE FORME ET JACOBIEN
      IF (NDIM.EQ.3) THEN
        CALL DFDM3D(NNO,G,IW,IDFDE,GEOM,DFDI(1,1),DFDI(1,2),DFDI(1,3),W)
      ELSE
        CALL DFDM2D(NNO,G,IW,IDFDE,GEOM,DFDI(1,1),DFDI(1,2),W)
      ENDIF


C - CALCUL DE LA DISTANCE A L'AXE EN AXI
      IF (AXI) THEN
        R      = DDOT(NNO,VFF,1,GEOM,2)
        W  = W*R
      ENDIF

      END
