      REAL*8 FUNCTION EDGEQU (NDIMSI,TENS,ANI)
      
      IMPLICIT REAL*8 (A-H,O-Z)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 16/11/2009   AUTEUR DURAND C.DURAND 

      INTEGER            NDIMSI
      REAL*8             TENS(NDIMSI),ANI(6,6)

C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

C ----------------------------------------------------------------------
C     MODELE VISCOPLASTIQUE SANS SEUIL DE EDGAR
C     CALCUL DU TENSEUR EQUIVALENT AU SENS DE HILL
C     EQUI = DSQRT(TENS(I)*ANI(I,J)*TENS(J))
C IN  DIM  : DIMENSION DE L'ESPACE
C IN  TENS : TENSEUR
C IN  ANI  : MATRICE D ANISOTROPIE DE HILL

C OUT EQUI    : TENSEUR EQUIVALENT
C ----------------------------------------------------------------------

      INTEGER  I,J
      REAL*8   EQUI,PDTSCA(6)
      DATA     PDTSCA/1.D0,1.D0,1.D0,2.D0,2.D0,2.D0/

      EQUI = 0.D0
      DO 5 I=1,NDIMSI
        DO 10 J=1,NDIMSI
          EQUI=EQUI+PDTSCA(I)*TENS(I)*ANI(I,J)*PDTSCA(J)*TENS(J)
 10     CONTINUE
 5    CONTINUE

      EQUI     = SQRT(EQUI)
      EDGEQU = EQUI
      
      END
