      SUBROUTINE EDGISO (DP,PM,EQSITR,MU,GAMMA,M,N,SEUIL,DSEUIL)
      IMPLICIT REAL*8 (A-H,O-Z)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 16/11/2009   AUTEUR DURAND C.DURAND 

      REAL*8          DP,PM,EQSITR
      REAL*8          MU,GAMMA(3),M(3),N(3)
      REAL*8          SEUIL,DSEUIL
            
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

C ----------------------------------------------------------------------
C     MODELE VISCOPLASTIQUE SANS SEUIL DE EDGAR
C    CALCUL DE LA FONCTION SEUIL ET DE SA DERIVEE
C    SEUIL(DP)=EQSITR-3*MU*DP-GAMMA(K)*((PM+DP)**M(K))*(DP**N(K))
C  IN  DP      : INCREMENT DE DEFORMATION PLASTIQUE CUMULEE
C  IN  PM      : DEFORMATION PLASTIQUE CUMULEE A L INSTANT MOINS
C  IN  EQSITR : CONTRAINTE EQUIVALENTE ESSAI
C  IN  MU      : COEFFICIENT DE MATERIAU ELASTIQUE
C  IN  GAMMA   : COEFFICIENT VISQUEUX A MULTIPLIER PAR 2*MU
C  IN  M       : COEFFICIENT VISQUEUX
C  IN  N       : COEFFICIENT VISQUEUX

C  OUT SEUIL   : FONCTION SEUIL
C  OUT DSEUIL  : DERIVEE DE SEUIL
C ----------------------------------------------------------------------

      INTEGER  K
      
C 1 - FONCTION F

      SEUIL = EQSITR-3.D0*MU*DP
      DO 10 K=1,3
        SEUIL=SEUIL-2.D0*MU*GAMMA(K)*((PM+DP)**M(K))*(DP**N(K))
 10   CONTINUE

C 2 - DERIVEE DE LA FONCTION F
 
      DSEUIL = -3.D0*MU
      DO 20 K=1,3
        DSEUIL=DSEUIL
     1       -2.D0*MU*GAMMA(K)*M(K)*((PM+DP)**(M(K)-1.D0))*(DP**N(K))
     2       -2.D0*MU*GAMMA(K)*N(K)*((PM+DP)**M(K))*(DP**(N(K)-1.D0))
 20   CONTINUE
 
      END
