      SUBROUTINE GENECY(CMOD1,CMOD2,NEQ,LMAT,PARA,NBSEC,
     &                  BETA1,BETA2,CTRAV)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 07/01/98   AUTEUR CIBHHLB L.BOURHRARA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C***********************************************************************
C    C. VARE     DATE 20/01/94
C-----------------------------------------------------------------------
C  BUT: CALCULER LES PARAMETRES GENERALISES DES MODES CALCULES
      IMPLICIT REAL*8 (A-H,O-Z)
C       PAR UNE METHODE CYCLIQUE
C
C       LES MODES ETANT A PRIORI DOUBLES, IL Y A DEUX PARAMETRES
C       EN SORTIE
C-----------------------------------------------------------------------
C
C CMOD1    /I/: VECTEUR DU PREMIER MODE COMPLEXE
C CMOD2    /I/: VECTEUR DU DEUXIEME MODE COMPLEXE
C NEQ      /I/: NOMBRE D'EQUATIONS ASSEMBLEES
C LMAT     /I/: ADRESSE DESCRIPTEUR MATRICE
C PARA     /O/: VECTEUR DES DEUX PARAMETRES GENERALISES
C NBSEC    /I/: NOMBRE DE SECTEURS
C BETA1    /I/: DEPHASAGE INTER-SECTEUR DU PREMIER MODE
C BETA2    /I/: DEPHASAGE INTER-SECTEUR DU DEUXIEME MODE
C CTRAV    /M/: VECTEUR DE TRAVAIL (NEQ)
C
C-----------------------------------------------------------------------
C
      REAL*8       PARA(2),ZERO
      COMPLEX*16   CMOD1(NEQ),CMOD2(NEQ),CTRAV(NEQ),CFACT1,CFACT2
C
C-----------------------------------------------------------------------
      DATA ZERO /0.D+00/
C-----------------------------------------------------------------------
C
      PARA(1)=ZERO
      PARA(2)=ZERO
      DO 5 I=1,NEQ
         CTRAV(I) = DCMPLX(0.D0,0.D0)
5     CONTINUE
C
C------CALCUL DU PRODUIT MATRICE ASSEMBLEE REELLE-MODE COMPLEXE---------
C
      CALL MCMULT('ZERO',LMAT,CMOD2,'C',CTRAV,1)
C
C-------------------BOUCLE SUR LES SECTEURS-----------------------------
C
      DO 10 I=1,NBSEC
C
C  CALCUL DU DEPHASAGE DU SECTEUR COURANT (ET DU CONJUGUE)
C
        CFACT1=DCMPLX(COS((I-1)*BETA1),SIN((I-1)*BETA1))
        CFACT2=DCMPLX(COS((I-1)*BETA2),SIN((I-1)*BETA2))
C
        XREA=ZERO
        XIMA=ZERO
C
C  BOUCLE SUR LES DDL ASSEMBLES POUR PRODUITS SCALAIRES
C
        DO 20 J=1,NEQ
          XREA=XREA+DBLE(CFACT1*CMOD1(J))*DBLE(CFACT2*CTRAV(J))
          XIMA=XIMA+DIMAG(CFACT1*CMOD1(J))*DIMAG(CFACT2*CTRAV(J))
20      CONTINUE
C
        PARA(1)=PARA(1)+XREA
        PARA(2)=PARA(2)+XIMA
C
10    CONTINUE
C
 9999 CONTINUE
      END
