      SUBROUTINE GEOLIS (MODGEN,SST1,SST2,INTF1,INTF2,GEOM1,GEOM2,
     &                   LIMAIL,NMGA1)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 05/07/2005   AUTEUR CIBHHPD L.SALMONA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
      IMPLICIT NONE
C***********************************************************************
C  O. NICOLAS     DATE 01/08/04
C-----------------------------------------------------------------------
C  BUT:      < CALCULER DES TRANSFORMATIONS GEOMETRIQUES >
C
C  CALCUL DES TRANSFORMATIONS GEOMETRIQUES DES SOUS STRUCTURES DANS LE 
C  CAS DES INTERFACES INCOMPATIBLES  
C
C-----------------------------------------------------------------------
C
C MODGEN  /I/ : NOM K8 DU MODELE GENERALISE
C SST1    /I/ : NOM K8 DE LA PREMIERE SOUS-STRUCTURE DE LA LIAISON
C SST2    /I/ : NOM K8 DE LA SECONDE SOUS-STRUCTURE DE LA LIAISON
C INTF1   /I/ : NOM K8 DE L'INTERFACE DE SST1
C INTF2   /I/ : NOM K8 DE L'INTERFACE DE SST2
C GEOM1   /O/ : NOM K8 DE LA TRANSFORMATION GEOMETRIQUE DE LA SS 1
C GEOM2   /O/ : NOM K8 DE LA TRANSFORMATION GEOMETRIQUE DE LA SS 2
C LIMAIL  /I/ : NOM DU GROUPE DE MAILLE MAITRE
C NMGA1  /I/ : NOMBRE DE MAILLES DANS L'INTERFACE MAITRE
C
C-------- DEBUT COMMUNS NORMALISES  JEVEUX  ----------------------------
C
      INTEGER          ZI
      COMMON  /IVARJE/ ZI(1)
      REAL*8           ZR
      COMMON  /RVARJE/ ZR(1)
      COMPLEX*16       ZC
      COMMON  /CVARJE/ ZC(1)
      LOGICAL          ZL
      COMMON  /LVARJE/ ZL(1)
      CHARACTER*8      ZK8
      CHARACTER*16              ZK16
      CHARACTER*24                        ZK24
      CHARACTER*32                                  ZK32
      CHARACTER*80                                            ZK80
      COMMON  /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      CHARACTER*32 JEXNUM,JEXNOM
C
C----------  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
C
C
      INTEGER       NTRAN,NANGL,NCENTR,NANGMX,IAGEO2,IAGEO1,
     &              IGEOM2,NBNO2,INO2,NUNO2,NNO2,
     &              IGEOM1,NBNO1,INO1,NUNO1,NNO1,IAGMA1,NMGA1,
     &              NMA1,I,K,KK,IBID,IER,LNUNO1,
     &              NUSST1,NUSST2,LLROT1,LLROT2,LLTRA1,LLTRA2,
     &              LLINT1,LLINT2,LNUNO2,IALINO
      REAL*8        TRA1(3),ANGL1(3),CENTR1(3),TRA2(3),ANGL2(3),
     &              CENTR2(3),COOR1(3),COOR2(3),ZERO,UN,R8DGRD,
     &              ROT1(3,3),ROT2(3,3)
      CHARACTER*1   KB
      CHARACTER*8   MODGEN,LINT1,LINT2,CRITER,TEMP,
     &              SST1,SST2,INTF1,INTF2,MAIL1,MAIL2,K8BID
      CHARACTER*24  REPNOM,INT1,INT2,TOTO,GEOM2,GEOM1
      CHARACTER*(*) LIMAIL
      
C-----------------------------------------------------------------------
C
      CALL JEMARQ()
C --- INITIALISATIONS :
C     ---------------
      ZERO   = 0.0D0
      UN     = 1.0D0

      DO 1 K = 1,3
C
        TRA1(K)  = ZERO
        TRA2(K)  = ZERO
        ANGL1(K)= ZERO
        ANGL2(K)= ZERO
        CENTR1(K) = ZERO
        CENTR2(K) = ZERO
C
        DO 2 KK = 1,3
          IF (K .EQ. KK) THEN
            ROT1(K,K) = UN
            ROT2(K,K) = UN
          ELSE
            ROT1(K,KK) = ZERO
            ROT1(KK,K) = ZERO
            ROT2(K,KK) = ZERO
            ROT2(KK,K) = ZERO
          ENDIF
 2     CONTINUE
 1    CONTINUE



C-----RECUPERATION DES ROTATIONS ET DES TRANSLATIONS
C
      REPNOM=MODGEN//'      .MODG.SSNO'
      CALL JENONU(JEXNOM(REPNOM,SST1),NUSST1)
      CALL JENONU(JEXNOM(REPNOM,SST2),NUSST2)
      CALL JEVEUO(JEXNUM(MODGEN//'      .MODG.SSOR',NUSST1),'L',LLROT1)
      CALL JEVEUO(JEXNUM(MODGEN//'      .MODG.SSOR',NUSST2),'L',LLROT2)
      DO 10 I=1,3
        ANGL1(I)=ZR(LLROT1+I-1)*R8DGRD()
        ANGL2(I)=ZR(LLROT2+I-1)*R8DGRD()
10    CONTINUE
      CALL JEVEUO(JEXNUM(MODGEN//'      .MODG.SSTR',NUSST1),'L',LLTRA1)
      CALL JEVEUO(JEXNUM(MODGEN//'      .MODG.SSTR',NUSST2),'L',LLTRA2)
      DO 110 I=1,3
        TRA1(I)=ZR(LLTRA1+I-1)
        TRA2(I)=ZR(LLTRA2+I-1)
110   CONTINUE
C
      CALL MATROT(ANGL1,ROT1)
      CALL MATROT(ANGL2,ROT2)
C
C-----RECUPERATION MAILLAGE
C
      CALL MGUTDM(MODGEN,SST1,IBID,'NOM_MAILLAGE',IBID,MAIL1)
      CALL MGUTDM(MODGEN,SST2,IBID,'NOM_MAILLAGE',IBID,MAIL2)
C

C --- DETERMINATION DES COORDONNEES TRANSFORMEES MAITRE :
C     --------------------------------------------------
      CALL DISMOI('F','NB_MA_MAILLA', MAIL1,'MAILLAGE',NMA1,KB,IER)
      CALL DISMOI ('F','NB_NO_MAILLA',MAIL1,'MAILLAGE',NNO1,KB,IER)
      CALL WKVECT(GEOM1,'V V R',3*NNO1,IGEOM1)
      CALL JEVEUO(MAIL1//'.COORDO    .VALE','L',IAGEO1)

      CALL JEVEUO(LIMAIL,'L',IAGMA1)

      TOTO='TUTU'
      CALL WKVECT(TOTO,'V V I',2*NNO1,IALINO)

      CALL GMGNRE(MAIL1,NNO1,ZI(IALINO),ZI(IAGMA1),NMGA1,
     &                  ZI(IALINO+NNO1),NBNO1,'TOUS')
C
      DO 40 INO1 = 1,NBNO1
        NUNO1 = ZI(IALINO+NNO1+INO1-1)
        CALL PAROTR(MAIL1,IAGEO1,NUNO1,0,CENTR1,ROT1,TRA1,COOR1)
        DO 50 K = 1,3
          ZR(IGEOM1+3*(NUNO1-1)+K-1) = COOR1(K)
 50     CONTINUE
 40   CONTINUE

C --- DETERMINATION DES COORDONNEES TRANSFORMEES ESCLAVE :
C     ---------------------------------------------------
      CALL MGUTDM(MODGEN,SST2,IBID,'NOM_LIST_INTERF',IBID,LINT2)
      INT2=LINT2//'.IDC_LINO'
      CALL JENONU(JEXNOM(INT2(1:13)//'NOMS',INTF2),IBID)
      CALL JELIRA(JEXNUM(INT2,IBID),'LONMAX',NBNO2,K8BID)
      CALL JEVEUO(JEXNUM(LINT2 //'.IDC_LINO',IBID),'L',LLINT2)
      CALL JEVEUO(LINT2//'.IDC_DEFO','L',LNUNO2)
      
      CALL DISMOI ('F','NB_NO_MAILLA',MAIL2,'MAILLAGE',NNO2,KB,IER)
      CALL WKVECT(GEOM2,'V V R',3*NNO2,IGEOM2)
      CALL JEVEUO(MAIL2//'.COORDO    .VALE','L',IAGEO2)

C     Recuperation des numeros des noeuds esclaves
      CALL JENONU(JEXNOM(LINT2 //'.IDC_NOMS',INTF2),IBID)
C
      DO 41 INO2 = 1,NBNO2
        NUNO2 = ZI(LNUNO2+INO2-1)
        CALL PAROTR(MAIL2,IAGEO2,NUNO2,0,CENTR2,ROT2,TRA2,COOR2)
        DO 51 K = 1,3
          ZR(IGEOM2+3*(NUNO2-1)+K-1) = COOR2(K)
 51     CONTINUE
 41   CONTINUE

 9999 CONTINUE
      CALL JEDETR(TOTO)
      CALL JEDEMA()
      END
