      SUBROUTINE HYP3DI(C11   ,C22   ,C33   ,C12   ,C13   ,
     &                  C23   ,C10   ,C01   ,C20   ,CISO  ,
     &                  CODRET)
C     
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/03/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 2005 UCBL LYON1 - T. BARANGER     WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      REAL*8  C11,C22,C33
      REAL*8  C12,C13,C23
      REAL*8  C10,C01,C20
      REAL*8  CISO(6,6)
      INTEGER CODRET
C
C ----------------------------------------------------------------------
C
C LOI DE COMPORTEMENT HYPERELASTIQUE DE SIGNORINI    
C 
C 3D - MATRICE TANGENTE - PARTIE ISOTROPIQUE
C
C ----------------------------------------------------------------------
C
C
C IN  C11,C22,C33,C12,C13,C23 : ELONGATIONS
C IN  C10,C01,C20             : CARACTERISTIQUES MATERIAUX
C OUT CISO : MATRICE TANGENTE ISOTROPIQUE
C OUT CODRET : CODE RETOUR ERREUR INTEGRATION (1 SI PROBLEME, 0 SINON)
C
C ----------------------------------------------------------------------
C
      REAL*8 DF(33)
      REAL*8 DFR0(33)
      REAL*8 DFR1(33)
      REAL*8 DFR2(33)
      REAL*8 DFR3(33)
      REAL*8 DFR4(33)
      REAL*8 GRD(6,6)
      REAL*8 T1,T3,T5,T7
      REAL*8 T10,T12,T13,T14,T15,T16,T17,T18,T19
      REAL*8 T20,T23,T24,T26,T27,T29,T32,T33
      REAL*8 T40,T43,T46,T47,T56,T59
      REAL*8 T60,T69,T72,T73,T82,T89
      REAL*8 T104,T114,T116,T117,T118,T119
      REAL*8 T125,T126,T129,T132,T134
      REAL*8 T141,T142,T147,T148,T149,T156
      REAL*8 T161,T166,T167,T169
      REAL*8 T170,T176,T178,T185,T196
      REAL*8 T201,T206,T208,T214,T216,T223,T234,T248,T252
      REAL*8 T260,T265,T271,T282,T293,T297
      REAL*8 T305,T310,T316,T327
      REAL*8 T338,T342,T350,T355
      REAL*8 T361,T372,T374,T379,T381,T383,T385,T386,T393
      REAL*8 T406,T408,T410,T412,T419
      REAL*8 T433,T435,T437,T444,T458
      REAL*8 T460,T462,T471,T474,T491,T493,T497
      REAL*8 T506,T525,T527,T529,T536
C
C ----------------------------------------------------------------------
C
      T1  = C11*C22
      T3  = C23**2
      T5  = C12**2
      T7  = C12*C13
      T10 = C13**2
      T12 = T1*C33-C11*T3-T5*C33+2*T7*C23-T10*C22
      T13 = T12**(1.D0/3.D0)
      IF ((T13.EQ.0.D0).OR.(T12.EQ.0.D0)) THEN
        CODRET=1
        GOTO 99
      ENDIF
      T14 = 1.D0/T13
      T15 = C11+C22+C33
      T16 = 1.D0/T12
      T17 = T14*T16
      T18 = T15*T17
      T19 = C22*C33
      T20 = T19-T3
      T23 = T14-T18*T20/3.D0
      T26 = T13**2.D0
      T27 = 1.D0/T26

      T29 = C11*C33
      T24 = T1+T29+T19-T5-T10-T3
      T33 = T24*T27*T16
      T40 = C20*(T15*T14-3.D0)
      T32 = C22+C33
      T43 = T29-T10
      T46 = T14-T18*T43/3.D0
      T47 = C11+C33
      T56 = T1-T5
      T59 = T14-T18*T56/3.D0
      T60 = C11+C22
      T69 = C10*T15
      T73 = -2.D0*C12*C33+2.D0*C13*C23
      T72 = T69*T17
      T82 = T40*T18
      T89 = 2.D0*C12*C23-2.D0*C13*C22

      T104   = -2.D0*C11*C23+2.D0*T7
      DF(19) = 2.D0*T23
      DF(18) = -2.D0/3.D0*C01*T20
      T114   = DF(18)
      DF(17) = T114*T27*T16
      DF(16) = C01*T32
      T116   = T114*T24
      T117   = T26**2.D0
      T118   = 1.D0/T117
      T119   = T118*T16
      DF(15) = -T116*T119-DF(16)*T118
      DF(14) = C10+2.D0*T40
      T125   = 2.D0/3.D0*C01*T33
      T126   = DF(14)
      DF(13) = -T125-T126*T18/3.D0
      T129   = DF(13)
      DF(12) = DF(17)+T129
      DF(11) = -T126*T20/3.D0

      T132   = DF(11)
      DF(10) = T132*T15
      T134   = DF(19)*C20
      DF(9)  = T134*T14+T132*T17
      DF(8)  = T134*T15+T126
      T141   = DF(10)
      T142   = 1.D0/T26
      DF(7)  = 2.D0*DF(15)*T13-T141*T142*T16-DF(8)*T142
      T147   = T12**2.D0
      T148   = 1.D0/T147
      T149   = T27*T148
      DF(6)  = -T116*T149-T141*T14*T148+DF(7)*T142/3.D0
      T156   = DF(6)
      DF(5)  = -DF(17)-T156*C22
      DF(4)  = 2.D0*T156*C23
      DF(3)  = -DF(17)-T156*C33
      DF(2)  = -DF(17)-T129-T156*C11
      DF(1)  = -DF(3)

      DFR0(22) = DF(14)
      T161     = DFR0(22)
      DFR0(21) = -T125-T161*T18/3.D0
      DFR0(19) = 2.D0*T46
      DFR0(18) = -2.D0/3.D0*C01*T43
      T166     = DFR0(21)
      T167     = DFR0(18)
      T169     = T167*T27*T16
      DFR0(17) = T166+T169
      DFR0(16) = C01*T47
      T170     = T167*T24
      DFR0(15) = -T170*T119-DFR0(16)*T118
      DFR0(12) = T169
      DFR0(11) = -T161*T43/3.D0
      T176     = DFR0(11)
      DFR0(10) = T176*T15
      T178     = DFR0(19)*C20
      DFR0(9)  = T178*T14+T176*T17
      DFR0(8)  = T161+T178*T15
      T185     = DFR0(10)
      DFR0(7)  = 2.D0*DFR0(15)*T13-T185*T142*T16-DFR0(8)*T142
      DFR0(6)  = -T170*T149-T185*T14*T148+DFR0(7)*T142/3.D0
      T196     = DFR0(6)
      DFR0(5)  = -T166-DFR0(12)-T196*C22
      DFR0(4)  = 2.D0*T196*C23
      DFR0(3)  = -DFR0(12)-T196*C33
      DFR0(2)  = -DFR0(12)-T196*C11
      DFR0(1)  = -DFR0(3)
      DFR1(25) = DFR0(22)
      T201     = DFR1(25)
      DFR1(24) = -T125-T201*T18/3.D0
      DFR1(19) = 2.D0*T59
      DFR1(18) = -2.D0/3.D0*C01*T56
      T206     = DFR1(18)
      DFR1(17) = T206*T27*T16
      DFR1(16) = C01*T60
      T208     = T206*T24
      DFR1(15) = -T208*T119-DFR1(16)*T118
      DFR1(12) = DFR1(17)
      DFR1(11) = -T201*T56/3.D0
      T214     = DFR1(11)
      DFR1(10) = T214*T15
      T216     = DFR1(19)*C20
      DFR1(9)  = T216*T14+T214*T17
      DFR1(8)  = T201+T216*T15
      T223     = DFR1(10)
      DFR1(7)  = 2.D0*DFR1(15)*T13-T223*T142*T16-DFR1(8)*T142
      DFR1(6)  = -T208*T149-T223*T14*T148+DFR1(7)*T142/3.D0
      T234     = DFR1(6)
      DFR1(5)  = -DFR1(12)-T234*C22
      DFR1(4)  = 2.D0*T234*C23
      DFR1(3)  = -DFR1(24)-DFR1(12)-T234*C33
      DFR1(2)  = -DFR1(12)-T234*C11
      DFR1(1)  = -DFR1(3)
      DFR2(28) = -T72/3.D0-T125-2.D0/3.D0*T82
      DFR2(27) = -T17*T73/3.D0
      DFR2(19) = -2.D0/3.D0*T18*T73
      DFR2(18) = -2.D0/3.D0*C01*T73
      T248     = DFR2(18)
      DFR2(17) = T248*T27*T16
      DFR2(16) = -2.D0*C01*C12
      T252     = T248*T24
      DFR2(15) = -T252*T119-DFR2(16)*T118
      DFR2(12) = DFR2(17)
      DFR2(11) = -2.D0/3.D0*T40*T73
      T260     = DFR2(11)
      DFR2(10) = -T69*T73/3+T260*T15
      T265     = DFR2(19)*C20
      DFR2(9)  = DFR2(27)*C10+T265*T14+T260*T17
      DFR2(8)  = T265*T15
      T271     = DFR2(10)
      DFR2(7)  = 2.D0*DFR2(15)*T13-T271*T142*T16-DFR2(8)*T142
      DFR2(6)  = -T252*T149-T271*T14*T148+DFR2(7)*T142/3.D0
      T282     = DFR2(6)
      DFR2(5)  = -DFR2(12)-T282*C22
      DFR2(4)  = 2.D0*T282*C23
      DFR2(3)  = -DFR2(12)-T282*C33
      DFR2(2)  = -DFR2(12)-T282*C11
      DFR2(1)  = -DFR2(3)
      DFR3(30) = DFR2(28)
      DFR3(27) = -T17*T89/3.D0
      DFR3(19) = -2.D0/3.D0*T18*T89
      DFR3(18) = -2.D0/3.D0*C01*T89
      T293     = DFR3(18)
      DFR3(17) = T293*T27*T16
      DFR3(16) = -2.D0*C01*C13
      T297     = T293*T24
      DFR3(15) = -T297*T119-DFR3(16)*T118
      DFR3(12) = DFR3(17)
      DFR3(11) = -2.D0/3.D0*T40*T89
      T305     = DFR3(11)
      DFR3(10) = -T69*T89/3.D0+T305*T15
      T310     = DFR3(19)*C20
      DFR3(9)  = DFR3(27)*C10+T310*T14+T305*T17
      DFR3(8)  = T310*T15
      T316     = DFR3(10)
      DFR3(7)  = 2.D0*DFR3(15)*T13-T316*T142*T16-DFR3(8)*T142
      DFR3(6)  = -T297*T149-T316*T14*T148+DFR3(7)*T142/3.D0
      T327 = DFR3(6)
      DFR3(5) = -DFR3(12)-T327*C22
      DFR3(4) = 2.D0*T327*C23
      DFR3(3) = -DFR3(12)-T327*C33
      DFR3(2) = -DFR3(12)-T327*C11
      DFR3(1) = -DFR3(3)
      DFR4(32) = DFR3(30)
      DFR4(27) = -T17*T104/3.D0
      DFR4(19) = -2.D0/3.D0*T18*T104
      DFR4(18) = -2.D0/3.D0*C01*T104
      T338 = DFR4(18)
      DFR4(17) = T338*T27*T16
      DFR4(16) = -2.D0*C01*C23
      T342 = T338*T24
      DFR4(15) = -T342*T119-DFR4(16)*T118
      DFR4(12) = DFR4(17)
      DFR4(11) = -2.D0/3.D0*T40*T104
      T350 = DFR4(11)
      DFR4(10) = -T69*T104/3+T350*T15
      T355 = DFR4(19)*C20
      DFR4(9) = DFR4(27)*C10+T355*T14+T350*T17
      DFR4(8) = T355*T15
      T361 = DFR4(10)
      DFR4(7) = 2.D0*DFR4(15)*T13-T361*T142*T16-DFR4(8)*T142
      DFR4(6) = -T342*T149-T361*T14*T148+DFR4(7)*T142/3.D0
      T372 = DFR4(6)
      DFR4(5) = -DFR4(12)-T372*C22
      T374 = DFR4(32)
      DFR4(4) = 2.D0*T374+2*T372*C23
      DFR4(3) = -DFR4(12)-T372*C33
      DFR4(2) = -DFR4(12)-T372*C11
      DFR4(1) = -DFR4(3)
      T379 = DF(17)
      T381 = DF(9)
      T383 = DF(1)
      GRD(1,1) = T379*C33+T381-T156*T3+T383*C22
      T385 = C01*T27
      T386 = DF(12)
      GRD(1,2) = T385+T386*C33+T381-T156*T10+T383*C11
      GRD(1,3) = T385+T379*C11+T386*C22+T381+T156*T56
      T393 = DF(4)
      GRD(1,4) = T393*C13+2*DF(3)*C12
      GRD(1,5) = 2*DF(5)*C13+T393*C12
      GRD(1,6) = 2*T156*T7+2*DF(2)*C23
      T406 = DFR0(17)
      T408 = DFR0(9)
      T410 = DFR0(1)
      GRD(2,1) = T385+T406*C33+T408-T196*T3+T410*C22
      T412 = DFR0(12)
      GRD(2,2) = T412*C33+T408-T196*T10+T410*C11
      GRD(2,3) = T385+T406*C11+T412*C22+T408+T196*T56
      T419 = DFR0(4)
      GRD(2,4) = T419*C13+2*DFR0(3)*C12
      GRD(2,5) = 2*DFR0(5)*C13+T419*C12
      GRD(2,6) = 2*T196*T7+2*DFR0(2)*C23
      T433 = DFR1(9)
      T435 = DFR1(1)
      GRD(3,1) = T385+DFR1(12)*C33+T433-T234*T3+T435*C22
      T437 = DFR1(12)
      GRD(3,2) = T385+T437*C33+T433-T234*T10+T435*C11
      GRD(3,3) = DFR1(12)*C11+T437*C22+T433+T234*T56
      T444 = DFR1(4)
      GRD(3,4) = T444*C13+2*DFR1(3)*C12
      GRD(3,5) = 2*DFR1(5)*C13+T444*C12
      GRD(3,6) = 2*T234*T7+2*DFR1(2)*C23
      T458 = DFR2(9)
      T460 = DFR2(1)
      GRD(4,1) = DFR2(12)*C33+T458-T282*T3+T460*C22
      T462 = DFR2(12)
      GRD(4,2) = T462*C33+T458-T282*T10+T460*C11
      GRD(4,3) = -2*DFR3(30)*C12+DFR2(12)*C11+T462*C22+T458+T282*T56
      T471 = 2*T385
      T474 = DFR2(4)
      GRD(4,4) = -T471-2*DFR3(30)*C33+T474*C13+2*DFR2(3)*C12
      GRD(4,5) = 2*DFR3(30)*C23+2*DFR2(5)*C13+T474*C12
      GRD(4,6) = 2*DFR3(30)*C13+2*T282*T7+2*DFR2(2)*C23
      T491 = DFR3(9)
      T493 = DFR3(1)
      GRD(5,1) = DFR3(12)*C33+T491-T327*T3+T493*C22
      T497 = DFR3(12)
      GRD(5,2) = -2*DFR4(32)*C13+T497*C33+T491-T327*T10+T493*C11
      GRD(5,3) = DFR3(12)*C11+T497*C22+T491+T327*T56
      T506 = DFR3(4)
      GRD(5,4) = 2*DFR4(32)*C23+T506*C13+2*DFR3(3)*C12
      GRD(5,5) = -T471-2*DFR4(32)*C22+2*DFR3(5)*C13+T506*C12
      GRD(5,6) = 2*DFR4(32)*C12+2*T327*T7+2*DFR3(2)*C23
      T525 = DFR4(9)
      T527 = DFR4(1)
      GRD(6,1) = -2*T374*C23+DFR4(12)*C33+T525-T372*T3+T527*C22
      T529 = DFR4(12)
      GRD(6,2) = T529*C33+T525-T372*T10+T527*C11
      GRD(6,3) = DFR4(12)*C11+T529*C22+T525+T372*T56
      T536 = DFR4(4)
      GRD(6,4) = T536*C13+2.D0*DFR4(3)*C12
      GRD(6,5) = 2.D0*DFR4(5)*C13+T536*C12
      GRD(6,6) = -2.D0*T385-2.D0*T374*C11+2.D0*T372*T7+2.D0*DFR4(2)*C23

      CISO(1,1) = 4.D0*GRD(1,1)
      CISO(1,2) = 4.D0*GRD(1,2)
      CISO(1,3) = 4.D0*GRD(1,3)
      CISO(1,4) = 4.D0*GRD(1,4)
      CISO(1,5) = 4.D0*GRD(1,5)
      CISO(1,6) = 4.D0*GRD(1,6)
      CISO(2,1) = 4.D0*GRD(2,1)
      CISO(2,2) = 4.D0*GRD(2,2)
      CISO(2,3) = 4.D0*GRD(2,3)
      CISO(2,4) = 4.D0*GRD(2,4)
      CISO(2,5) = 4.D0*GRD(2,5)
      CISO(2,6) = 4.D0*GRD(2,6)
      CISO(3,1) = 4.D0*GRD(3,1)
      CISO(3,2) = 4.D0*GRD(3,2)
      CISO(3,3) = 4.D0*GRD(3,3)
      CISO(3,4) = 4.D0*GRD(3,4)
      CISO(3,5) = 4.D0*GRD(3,5)
      CISO(3,6) = 4.D0*GRD(3,6)
      CISO(4,1) = 4.D0*GRD(4,1)
      CISO(4,2) = 4.D0*GRD(4,2)
      CISO(4,3) = 4.D0*GRD(4,3)
      CISO(4,4) = 4.D0*GRD(4,4)
      CISO(4,5) = 4.D0*GRD(4,5)
      CISO(4,6) = 4.D0*GRD(4,6)
      CISO(5,1) = 4.D0*GRD(5,1)
      CISO(5,2) = 4.D0*GRD(5,2)
      CISO(5,3) = 4.D0*GRD(5,3)
      CISO(5,4) = 4.D0*GRD(5,4)
      CISO(5,5) = 4.D0*GRD(5,5)
      CISO(5,6) = 4.D0*GRD(5,6)
      CISO(6,1) = 4.D0*GRD(6,1)
      CISO(6,2) = 4.D0*GRD(6,2)
      CISO(6,3) = 4.D0*GRD(6,3)
      CISO(6,4) = 4.D0*GRD(6,4)
      CISO(6,5) = 4.D0*GRD(6,5)
      CISO(6,6) = 4.D0*GRD(6,6)

 99   CONTINUE
      END
