      SUBROUTINE IMPINI(SDIMPR,SDSUIV,COLACT,UNITE ,NCOL  ,
     &                  NCOLCV)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 17/01/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*24 SDIMPR
      CHARACTER*19 COLACT,SDSUIV
      INTEGER      NCOL,UNITE,NCOLCV
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (AFFICHAGE)
C
C CREATION SD
C
C ----------------------------------------------------------------------
C
C
C IN  SDIMPR : NOM DE LA SD POUR L'AFFICHAGE
C IN  SDSUIV : NOM DE LA SD POUR LE SUIVI
C IN  COLACT : VECTEUR D'ACTIVATION DES COLONNES
C IN  NCOL   : NOMBRE DE COLONNES ACTIVEES
C IN  UNITE  : UNITE DU FICHIER POUR AFFICHAGE TABLEAU EN PLUS DE .MESS
C IN  NCOLCV : NOMBRE DE COLONNES AVEC TESTS DE CONVERGENCE
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      ZIMP,ZLIG,ZCOL,ZLAR,ZDEF
      PARAMETER    (ZIMP=3,ZLIG=255,ZCOL=16,ZLAR=16,ZDEF=40)
      CHARACTER*24 IMPCOL,IMPTIT,IMPTYP,IMPINF
      INTEGER      JIMPCO,JIMPTI,JIMPTY,JIMPIN
      CHARACTER*24 IMPMAR
      INTEGER      JIMPMA     
      INTEGER      JIMPRR,JIMPRK,JIMPRI
      CHARACTER*24 IMPRER,IMPREK,IMPREI
      CHARACTER*24 IMPCNT,IMPCNV,IMPCNA,IMPCNL
      INTEGER      JIMPCT,JIMPCV,JIMPCA,JIMPCL   
      INTEGER      LARGE
C
C ----------------------------------------------------------------------
C      
      CALL JEMARQ()
C
      IF (ZDEF.NE.40) THEN
        CALL ASSERT(.FALSE.)
      ENDIF
C
C --- INFORMATIONS GENERALES
C
      IMPINF = SDIMPR(1:14)//'.INFO'
      CALL WKVECT(IMPINF,'V V I'  ,ZIMP  ,JIMPIN)
C
C --- CODE DES COLONNES 
C      
      IMPCOL = SDIMPR(1:14)//'.DEFI.COL'
      CALL WKVECT(IMPCOL,'V V I'  ,ZCOL  ,JIMPCO)
C
C --- TYPE DES COLONNES 
C            
      IMPTYP = SDIMPR(1:14)//'.DEFI.TYP'
      CALL WKVECT(IMPTYP,'V V I'  ,ZCOL  ,JIMPTY)
C
C --- TITRE DES COLONNES
C
      IMPTIT = SDIMPR(1:14)//'.DEFI.TIT'
      CALL WKVECT(IMPTIT,'V V K16',3*ZCOL,JIMPTI)
C
C --- COLONNES POUR STOCKER LES VALEURS
C
      IMPRER = SDIMPR(1:14)//'.DEFI.RER'
      IMPREI = SDIMPR(1:14)//'.DEFI.REI'
      IMPREK = SDIMPR(1:14)//'.DEFI.REK'
      CALL WKVECT(IMPRER,'V V R'  ,ZCOL,JIMPRR)
      CALL WKVECT(IMPREI,'V V I'  ,ZCOL,JIMPRI)
      CALL WKVECT(IMPREK,'V V K16',ZCOL,JIMPRK)
C
C --- LISTE ET VALEURS DES TESTS DE CONVERGENCE
C
      IMPCNT = SDIMPR(1:14)//'.CONV.TYP'
      IMPCNL = SDIMPR(1:14)//'.CONV.LIE'
      IMPCNV = SDIMPR(1:14)//'.CONV.VAL'
      IMPCNA = SDIMPR(1:14)//'.CONV.ACT'
      CALL WKVECT(IMPCNT,'V V K16',NCOLCV,JIMPCT)
      CALL WKVECT(IMPCNL,'V V K16',NCOLCV,JIMPCL)
      CALL WKVECT(IMPCNV,'V V R'  ,NCOLCV,JIMPCV)
      CALL WKVECT(IMPCNA,'V V L'  ,NCOLCV,JIMPCA)      
C
C --- MARQUAGE DANS LES COLONNES (X OU B PAR EXEMPLE)
C
      IMPMAR = SDIMPR(1:14)//'.DEFI.MAR'
      CALL WKVECT(IMPMAR,'V V K8' ,ZCOL  ,JIMPMA)
C
C --- LARGEUR DE LA LIGNE (UNE COLONNE FAIT ZLAR+SEPARATEUR VERTICAL)
C
      LARGE  = 1+NCOL*(ZLAR+1)
C
C --- INITIALISATIONS DES VARIABLES
C            
      ZI(JIMPIN+1-1)  = NCOL
      ZI(JIMPIN+2-1)  = LARGE
      IF (NCOL.GT.ZCOL) THEN
        CALL ASSERT(.FALSE.)
      ENDIF
      IF (LARGE.GT.ZLIG) THEN
        CALL ASSERT(.FALSE.)
      ENDIF
      ZI(JIMPIN+3-1)  = UNITE
C
C --- ACTIVATION DES COLONNES
C
      CALL IMPDEF(SDIMPR,SDSUIV,COLACT,NCOL  )
C
C --- OUVERTURE DU FICHIER
C
      IF (UNITE.NE.0) THEN
        CALL ULOPEN(UNITE ,' '   ,' '   ,'NEW','O'   ) 
      ENDIF                    
C
C --- MENAGE
C
      CALL JEDEMA()

      END
