      SUBROUTINE IMPSDA(SDIMPR,OPER  ,ICOL  ,ICOD  ,TITCOL,
     &                  FORCOL)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/12/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT NONE
      CHARACTER*24  SDIMPR
      INTEGER       ICOL,ICOD
      CHARACTER*4   OPER
      CHARACTER*16  TITCOL(3)
      INTEGER       FORCOL
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (AFFICHAGE - ACCES SD)
C
C AFFECTATION PROPRIETES POUR LA COLONNE
C
C ----------------------------------------------------------------------
C
C
C IN SDIMPR : SD SUR L'AFFICHAGE DES COLONNES
C IN OPER   : OPERATION SUR LA COLONNE
C              'AJOU': AJOUTER UNE COLONNE
C              'LIRE': LIRE UNE COLONNE
C IN ICOL   : NUMERO DE LA COLONNE
C IN ICOD   : CODE TYPE DE LA COLONNE (VOIR LISTE DANS IMPREF)
C IN TITCOL : TITRE DE LA COLONNE
C IN FORCOL : FORMAT DE LA COLONNE
C              1: ENTIER
C              2: REEL
C              3: CHAINE
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      JIMPCO,JIMPTI,JIMPTY
      CHARACTER*24 IMPCOL,IMPTIT,IMPTYP
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- ACCES SD
C
      IMPCOL = SDIMPR(1:14)//'.DEFI.COL'
      IMPTIT = SDIMPR(1:14)//'.DEFI.TIT'
      IMPTYP = SDIMPR(1:14)//'.DEFI.TYP'
      CALL JEVEUO(IMPCOL,'E',JIMPCO)
      CALL JEVEUO(IMPTIT,'E',JIMPTI)
      CALL JEVEUO(IMPTYP,'E',JIMPTY)
C
C --- OPERATIONS
C
      IF (OPER.EQ.'LIRE') THEN
        ICOD      = ZI(JIMPCO-1+ICOL)
        TITCOL(1) = ZK16(JIMPTI+3*(ICOL-1))
        TITCOL(2) = ZK16(JIMPTI+3*(ICOL-1)+1)
        TITCOL(3) = ZK16(JIMPTI+3*(ICOL-1)+2)
        FORCOL    = ZI(JIMPTY-1+ICOL)
      ELSE IF (OPER.EQ.'AJOU') THEN
        ZI(JIMPCO-1+ICOL)         = ICOD
        ZK16(JIMPTI+3*(ICOL-1))   = TITCOL(1)
        ZK16(JIMPTI+3*(ICOL-1)+1) = TITCOL(2)
        ZK16(JIMPTI+3*(ICOL-1)+2) = TITCOL(3)
        ZI(JIMPTY-1+ICOL)         = FORCOL
      ELSE
        CALL ASSERT(.FALSE.)   
      ENDIF    
C
      CALL JEDEMA()

      END
