      SUBROUTINE IMPSTD(FONACT,LINFRE,LUNITE,ZDEF  ,COLACT,
     &                  ICOL  )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 17/01/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INTEGER       FONACT(*)
      CHARACTER*19  COLACT
      LOGICAL       LINFRE,LUNITE
      INTEGER       ZDEF,ICOL
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (AFFICHAGE)
C
C VALEURS PAR DEFAUT DE L'AFFICHAGE DU TABLEAU DE CONVERGENCE
C
C ----------------------------------------------------------------------
C
C
C IN  LINFRE : .TRUE. SI INFO_RESIDU
C IN  LUNITE : .TRUE. SI SORTIE FICHIER
C IN  ZDEF   : NOMBRE MAXI DE COLONNES DISPONIBLES POUR L'AFFICHAGE
C IN  FONACT : FONCTIONNALITES ACTIVEES
C IN  COLACT : VECTEUR D'ACTIVATION DES COLONNES
C I/O ICOL   : INDICE DE LA PROCHAINE COLONNE DANS COLACT
C
C COLACT CONTIENT LA LISTE DES CODES D'AFFICHAGES
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      LOGICAL      ISFONC,LRELI,LPILO,LCTCD
      LOGICAL      LBORST,LREFE,LFETI,LCOMP
      LOGICAL      LBOUCC,LBOUCF,LBOUCG,LALLV
      INTEGER      JIMCOL
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- FONCTIONNALITES ACTIVEES
C
      LRELI  = ISFONC(FONACT,'RECH_LINE')
      LPILO  = ISFONC(FONACT,'PILOTAGE')
      LCTCD  = ISFONC(FONACT,'CONT_DISCRET')
      LREFE  = ISFONC(FONACT,'RESI_REFE')
      LBORST = ISFONC(FONACT,'DEBORST')
      LFETI  = ISFONC(FONACT,'FETI') 
      LBOUCF = ISFONC(FONACT,'BOUCLE_EXT_FROT')   
      LBOUCG = ISFONC(FONACT,'BOUCLE_EXT_GEOM')
      LBOUCC = ISFONC(FONACT,'BOUCLE_EXT_CONT')   
      LCOMP  = ISFONC(FONACT,'RESI_COMP')
      LALLV  = ISFONC(FONACT,'CONT_ALL_VERIF') 
C
C --- ACCES
C
      CALL JEVEUO(COLACT,'E',JIMCOL)                            
C
C --- PAS DE TEMPS
C
      IF (LUNITE) THEN
        CALL IMPDEA(ZDEF,'INCR_TPS ',ZI(JIMCOL),ICOL)
      ENDIF
C
C --- CONTACT - BOUCLE GEOMETRIQUE
C
      IF (LBOUCG) THEN
        CALL IMPDEA(ZDEF,'BOUC_GEOM',ZI(JIMCOL),ICOL)
      ENDIF
C
C --- CONTACT - BOUCLE FROTTEMENT
C
      IF (LBOUCF) THEN
        CALL IMPDEA(ZDEF,'BOUC_FROT',ZI(JIMCOL),ICOL)
      ENDIF
C
C --- CONTACT - BOUCLE CONTACT
C
      IF (LBOUCC) THEN
        CALL IMPDEA(ZDEF,'BOUC_CONT',ZI(JIMCOL),ICOL)
      ENDIF
C
C --- ITERATIONS DE NEWTON
C
      CALL IMPDEA(ZDEF,'ITER_NEWT',ZI(JIMCOL),ICOL)
C
C --- RESI_GLOB_RELA
C
      CALL IMPDEA(ZDEF,'RESI_RELA',ZI(JIMCOL),ICOL)
      IF (LINFRE) THEN
        CALL IMPDEA(ZDEF,'RELA_NOEU',ZI(JIMCOL),ICOL)
      ENDIF
C
C --- RESI_GLOB_MAXI
C
      CALL IMPDEA(ZDEF,'RESI_MAXI',ZI(JIMCOL),ICOL)
      IF (LINFRE) THEN
        CALL IMPDEA(ZDEF,'MAXI_NOEU',ZI(JIMCOL),ICOL)
      ENDIF
C
C --- RESIDU PAR REFERENCE
C
      IF (LREFE) THEN
        CALL IMPDEA(ZDEF,'RESI_REFE',ZI(JIMCOL),ICOL)
        IF (LINFRE) THEN
          CALL IMPDEA(ZDEF,'REFE_NOEU',ZI(JIMCOL),ICOL)
        ENDIF
      ENDIF
C
C --- RESIDU PAR FORCES NODALES CMP (THM)
C
      IF (LCOMP) THEN
        CALL IMPDEA(ZDEF,'RESI_COMP',ZI(JIMCOL),ICOL)
        IF (LINFRE) THEN
          CALL IMPDEA(ZDEF,'COMP_NOEU',ZI(JIMCOL),ICOL)
        ENDIF
      ENDIF
C
C --- BOUCLES CONTACT 
C
      IF (LBOUCG.OR.LBOUCF.OR.LBOUCC) THEN
        CALL IMPDEA(ZDEF,'BOUC_VALE',ZI(JIMCOL),ICOL)
        IF (LINFRE) THEN
          CALL IMPDEA(ZDEF,'BOUC_NOEU',ZI(JIMCOL),ICOL)
        ENDIF
      ENDIF
C
C --- METHODE DE BORST
C
      IF (LBORST) THEN
        CALL IMPDEA(ZDEF,'ITER_DEBO',ZI(JIMCOL),ICOL)
      ENDIF
C
C --- RECHERCHE LINEAIRE
C
      IF (LRELI) THEN
        CALL IMPDEA(ZDEF,'RELI_ITER',ZI(JIMCOL),ICOL)
        CALL IMPDEA(ZDEF,'RELI_COEF',ZI(JIMCOL),ICOL)
      ENDIF
C
C --- PILOTAGE
C
      IF (LPILO) THEN
        CALL IMPDEA(ZDEF,'PILO_PARA',ZI(JIMCOL),ICOL)
      ENDIF
C
C --- OPTION D'ASSEMBLAGE
C
      CALL IMPDEA(ZDEF,'MATR_ASSE',ZI(JIMCOL),ICOL)
C
C --- CONTACT DISCRET - COLONNES SUP.
C
      IF (LCTCD.AND.(.NOT.LALLV)) THEN    
        CALL IMPDEA(ZDEF,'CTCD_ITER',ZI(JIMCOL),ICOL)
      ENDIF
C
C --- FETI
C
      IF (LFETI) THEN
        CALL IMPDEA(ZDEF,'ITER_FETI',ZI(JIMCOL),ICOL)
      ENDIF
C
      CALL JEDEMA()

      END
