      SUBROUTINE IRRCVG( DY, DDY, NR, NMAT, MATER, ITMAX, TOLER,
     &                   ITER, R, RINI, IRTETI)
        IMPLICIT NONE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 06/10/2008   AUTEUR PROIX J-M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2006  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE FLEJOU J-L.FLEJOU
C       IRRAD3M        : CONTROLE DE LA CONVERGENCE
C                        DE LA CONFORMITE DE LA SOLUTION DP
C                        ET DE LA RE-INTEGRATION
C                        ET DU REDECOUPAGE DU PAS DE TEMPS
C                        SUR LA NORME DU RESIDU
C       ----------------------------------------------------------------
C       IN
C            DY     :  VECTEUR SOLUTION DY = ( DSIG DVINT)
C            DDY    :  VECTEUR CORRECTION SUR LA SOLUTION
C            NR     :  DIMENSION DY DDY
C            NMAT   :  DIMENSION  DE MATER
C            MATER  :  COEFFICIENTS MATERIAU
C            ITMAX  :  NB MAXI D ITERATIONS LOCALES
C            TOLER  :  TOLERANCE A CONVERGENCE
C            ITER   :  NUMERO ITERATION COURANTE
C            R      :  R(Y) RESIDU A L'ITERATION COURANTE
C            RINI   :  R(Y0) RESIDU A L'ITERATION 1
C       OUT  IRTETI  :  =0 CONVERGENCE
C                       =1 ITERATIONS SUPPLEMENTAIRE (ITER<ITMAX)
C                       =3 ITMAX ATTEINT REDECOUPAGE LOCAL
C                       =4 ITMAX ATTEINT REDECOUPAGE GLOBAL
C       ----------------------------------------------------------------
        INTEGER  ITMAX,ITER,NR,IRTETI,II,NMAT
        REAL*8   TOLER,DDY(NR),DY(NR),R(NR),RINI(NR),MATER(NMAT,2)

        REAL*8   ER,VALRM(2)
C       ----------------------------------------------------------------
C
C     CALCUL DE LA NORME DE RINI ET DE R(Y)
      ER = 0.0D0
      DO 10 II=1,NR
         ER = ER + R(II)*R(II)
10    CONTINUE
      ER = SQRT(ER)
C     ER < TOLER , ON A CONVERGE
      IF ( ER .LT. TOLER ) THEN
C        VERIFICATION SUR LE FRANCHISSEMENT DU SEUIL
         IF ( ABS(MATER(21,2)) .GT. MATER(20,2) ) THEN
            VALRM(1) = MATER(20,2)
            VALRM(2) = MATER(21,2)
            CALL U2MESR('I','COMPOR1_58',2,VALRM)
C           REDECOUPAGE GLOBAL
            IRTETI = 4
            GOTO 9999
         ENDIF
         IRTETI = 0
         GOTO 9999
      ENDIF

      IF ( ITER .LT. ITMAX ) THEN
C         CALL LCNRVN(NR,RINI,ERINI)
C          WRITE(*,*) 'ER ERINI', ER,ERINI,ER/ERINI,TOLER
C        SI ER/ERINI < TOLER ON A CONVERGE
C         IF ( (ER/ERINI) .LE. TOLER ) THEN
C            IRTETI = 0
C            GOTO 9999
C         ENDIF
C -      EVALUATION DE :  ERRR(1)  = MAX( ABS(R(I)/RINI(I)) )
C         CALL LCVERR(RINI,R,NR,0,ERREUR)
C -      CONVERGENCE    MAX(R,RINI)
C         IF ( ERREUR(1) .LE. TOLER ) THEN
C            IRTETI = 0
C            GOTO 9999
C         ENDIF
C -      NON CONVERGENCE ITERATION SUIVANTE
         IRTETI = 1
         GOTO 9999
C      ELSE
C -      EVALUATION DE :  ERRR(1)  = MAX( ABS(R(I)/RINI(I)) )
C         CALL LCVERR(RINI,R,NR,0,ERREUR)
C        RESIDU NON NUL MAIS STABLE. ON ACCEPTE
C         IF ( ERREUR(1) .LE. TOLER ) THEN
C            IRTETI = 0
C            GOTO 9999
C         ENDIF
C -      EVALUATION DE :  ERRDY(1)  = MAX( ABS(DDY(I)/DY(I)) )
C         CALL LCVERR(DY,DDY,NR,0,ERREUR)
C        RESIDU NON NUL MAIS SOLUTION STABLE. ON ACCEPTE : MAX(DDY,DY)
C         IF ( ERREUR(1) .LE. TOLER ) THEN
C            IRTETI = 0
C            GOTO 9999
C         ENDIF
      ENDIF
C -   NON CONVERGENCE ET ITMAX ATTEINT : REDECOUPAGE LOCAL
      IRTETI = 3
C
 9999 CONTINUE
      END
