      SUBROUTINE IRRCVX ( FAMI, KPG, KSP, NMAT, MATER, SIG ,VIN,
     &                    SEUIL )
      IMPLICIT  NONE

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 06/10/2008   AUTEUR PROIX J-M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2006  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE FLEJOU J-L.FLEJOU
      CHARACTER*(*) FAMI
      INTEGER       KPG, KSP, NMAT
      REAL*8        MATER(NMAT,2),SIG(6),VIN(*),SEUIL

C CONVEXE ELASTO PLASTIQUE A T+DT POUR (SIGF , VIND) DONNES
C ----------------------------------------------------------------------
C IN  :  FAMI   :  FAMILLE DES POINTS DE GAUSS
C        KPG    :  NUMERO DU POINT DE GAUSS
C        KSP    :  NUMERO DU SOUS POINT DE GAUSS
C        SIG    :  CONTRAINTE A T+DT
C        VIN    :  VARIABLES INTERNES A T
C        NMAT   :  DIMENSION MATER
C        MATER  :  COEFFICIENTS MATERIAU A T+DT
C OUT :  SEUIL  :  SEUIL  ELASTICITE  A T+DT
C
C ======================================================================

      REAL*8  IRRAD,IRRAF,P,DEV(6),K,N,P0,LCNRTS
      REAL*8  PK,PENPE,KAPPA,R02,PE,SPE,R8PREM
      INTEGER IRET

      REAL*8  VALRM(2)

C     RECUPERATION DE L IRRADIATION
      CALL RCVARC('F','IRRA','-',FAMI,KPG,KSP,IRRAD,IRET)
      CALL RCVARC('F','IRRA','+',FAMI,KPG,KSP,IRRAF,IRET)
C VARIABLES INTERNES
      P     = VIN(1)
C PARAMETRES MATERIAUX
      K     = MATER(7,2)
      N     = MATER(8,2)
      P0    = MATER(9,2)
      KAPPA = MATER(10,2)
      R02   = MATER(11,2)
      PENPE = MATER(13,2)
      PK    = MATER(14,2)
      PE    = MATER(15,2)
      SPE   = MATER(16,2)

      IF      ( IRRAF .GT. IRRAD) THEN
         SEUIL = 1.D0
         GOTO 9999
      ELSE IF ( IRRAD .GT. IRRAF*1.00001D0 ) THEN
         VALRM(1) = IRRAD
         VALRM(2) = IRRAF
         CALL U2MESR('I','COMPOR1_56',2,VALRM)
      ELSE
         CALL LCDEVI( SIG, DEV )
         IF      (P.LT.PK) THEN
            SEUIL = LCNRTS(DEV) - KAPPA*R02
         ELSE IF (P.LT.PE) THEN
            SEUIL = LCNRTS(DEV) - ( SPE + PENPE*(P - PE) )
         ELSE
            SEUIL = LCNRTS(DEV) - K*((P + P0)**N)
         ENDIF
      ENDIF

9999  CONTINUE
      END
