      SUBROUTINE LCPLNF(LOI,VIND,NBCOMM,NMAT,CPMONO,
     &                  MATERF,ITER,NVI,ITMAX,TOLER,
     &                  PGL,TOUTMS,HSR,DT,DY,
     &                  YF,VINF,TAMPON)

C RESPONSABLE PROIX J-M.PROIX
        IMPLICIT NONE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 20/09/2010   AUTEUR FLEJOU J-L.FLEJOU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2008  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

C ----------------------------------------------------------------
C   POST-TRAITEMENTS SPECIFIQUES AUX LOIS
C
C   CORRESPONDANCE ENTRE LES VARIABLES INTERNES ET LES EQUATIONS
C          DU SYSTEME DIFFERENTIEL APRES INTEGRATION
C
C   CAS GENERAL :
C      COPIE DES YF DANS VINF
C      LA DERNIERE C'EST TOUJOURS L'INDICATEUR PLASTIQUE
C
C   CAS PARTICULIER DU  MONOCRISTAL  :
C       ON GARDE 1 VARIABLE INTERNE PAR SYSTEME DE GLISSEMENT SUR 3
C       DEFORMATION PLASTIQUE EQUIVALENTE CUMULEE MACROSCOPIQUE
C ----------------------------------------------------------------
C  IN
C     LOI    :  NOM DE LA LOI
C     VIND   :  VARIABLE INTERNES A T
C     MATERF :  COEF MATERIAU
C     NBCOMM :  INCIDES DES COEF MATERIAU
C     NMAT   :  DIMENSION MATER ET DE NBCOMM
C     NVI    :  NOMBRE DE VARIABLES INTERNES
C     DT     : INCREMENT DE TEMPS
C     YF     : EQUATIONS DU COMPORTEMENT INTEGRES A T+DT
C     DY     : INCREMENT DES VARIABLES INTERNES
C  OUT
C     VINF   :  VARIABLES INTERNES A T+DT
C       ----------------------------------------------------------------
      INTEGER      NDT,NVI,NMAT,NDI,NS,I,NBCOMM(NMAT,3),ITER,ITMAX
      REAL*8       MATERF(NMAT,2),VIND(*),TOLER,PGL(3,3),DT,TAMPON(*)
      REAL*8       TOUTMS(5,24,6),HSR(5,24,24),DY(*),YF(*),VINF(*)
      CHARACTER*16 LOI,CPMONO(5*NMAT+1)
      REAL*8       EPSEQ,Q(3,3),OMEGAE(3,3)

      COMMON /TDIM/   NDT  , NDI
C --- -------------------------------------------------------------
C
      IF (LOI(1:8).EQ.'MONOCRIS') THEN
C ---    DEFORMATION PLASTIQUE EQUIVALENTE CUMULEE MACROSCOPIQUE
         CALL LCDPEC(VIND,NBCOMM,NMAT,NDT,CPMONO,MATERF,
     &               ITER,NVI,ITMAX, TOLER,PGL,TOUTMS,HSR,
     &               DT,DY,YF,VINF,EPSEQ,TAMPON)
      ELSEIF (LOI(1:7).EQ.'IRRAD3M') THEN
         CALL IRRLNF(NMAT,MATERF,YF(NDT+1),1.0D0,VINF)
      ELSE
C        CAS GENERAL :
         CALL LCEQVN( NVI-1 , YF(NDT+1) , VINF )
         VINF(NVI) = 1.D0
      ENDIF

      END
