      REAL*8 FUNCTION LCROTY (T, PREC, ITEMAX)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 16/11/2009   AUTEUR DURAND C.DURAND 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
      INTEGER ITEMAX
      REAL*8  T, PREC

C *****************************************************
C       INTEGRATION DE LA LOI DE ROUSSELIER LOCAL     *
C           RESOLUTION Y.EXP(Y) = T                   *
C *****************************************************

C IN  T       : SECOND MEMBRE CONSTANT
C IN  PREC    : PRECISION RELATIVE SOUHAITEE
C IN  ITEMAX  : NOMBRE MAX D'ITERATIONS

      INTEGER ITER
      REAL*8  Y, U, H, DH

C 1 - NEWTON SANS CHANGEMENT DE VARIABLE

      IF (T .LE. EXP(1.D0)) THEN

        Y = 0.D0
        DO 10 ITER = 1, ITEMAX
          H  = Y*EXP(Y) - T
          DH = (1+Y) * EXP(Y)
          IF (ABS(H) .LE. PREC*T) GOTO 100
          Y = Y - H/DH
 10     CONTINUE


C 2 - NEWTON AVEC CHANGEMENT DE VARIABLE U=EXP(Y)

      ELSE
        U = T
        DO 20 ITER = 1, ITEMAX
          H  = U*LOG(U) - T
          DH = 1 + LOG(U)
          IF (ABS(H) .LE. PREC*T) THEN
            Y = LOG(U)
            GOTO 100
          END IF
          U = U - H/DH
 20     CONTINUE
      END IF

      CALL U2MESS('F','ALGORITH3_55')


 100  CONTINUE
      LCROTY = Y
      END
