      SUBROUTINE LCUMFB(SIGI,NSTRS,VARI,NVARI,CMAT,NMAT,TDT,HINI,HFIN,
     *                  AFD,BFD,CFD)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 24/03/2009   AUTEUR REZETTE C.REZETTE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
      IMPLICIT NONE
      INTEGER   NSTRS,NVARI,NMAT
      REAL*8    SIGI(6),VARI(NVARI),CMAT(NMAT)
      REAL*8    TDT,HINI,HFIN,AFD(6),BFD(6,6),CFD(6,6)
C_______________________________________________________________________
C
C SOUS PROGRAMME QUI CALCUL LES MATRICE DE DEFORMATION DE FLUAGE
C   DE DESSICCATION D APRES LE MODELE DE BAZANT OU UMLV
C
C     - MODELE DE BAZANT : IDES = 1 => EQUATION (3.3-2)
C     - MODELE DE UMLV   : IDES = 2 => EQUATION (3.3-4)
C
C   DFDES(N+1) = AFD + BFD * SIGMA(N) + CFD * SIGMA(N+1)
C
C    => EQUATION (3.3-1)
C_______________________________________________________________________
C
      INTEGER  I,J,IDES
      REAL*8   A,B,C,EFDE(6)
      REAL*8   VDES,DH,DEFDEF
C
C RECUPERATION DES VALEURS DES PARAMETRES MATERIAU
C
C  25 AOUT 2004 - YLP
C LE MODELE DE BAZANT NE COMPREND QU'UN PARAMETRE
C      RDES = CMAT(10)
      VDES = CMAT(11)
      IDES = NINT(CMAT(14))
C
C TEST SI TDT = 0
C
      IF (TDT.EQ.0.D0) THEN
C        CALL ZERO(AFD,NSTRS,1)
C        CALL ZERO(BFD,NSTRS,NSTRS)
C        CALL ZERO(CFD,NSTRS,NSTRS)
        DO 1 I=1,NSTRS
          AFD(I) = 0.0D0
          DO 2 J=1,NSTRS
            BFD(I,J) = 0.0D0
            CFD(I,J) = 0.0D0
2         CONTINUE
1       CONTINUE
        GOTO 30
      ENDIF
C
C RECUPERATION DES VARIABLES INTERNES INITIALES
C
      EFDE(1) = VARI(9)
      EFDE(2) = VARI(10)
      EFDE(3) = VARI(11)
      EFDE(4) = VARI(18)
      EFDE(5) = VARI(19)
      EFDE(6) = VARI(20)
C
C INITIALISATION DES VARIABLES
C
      DH = ABS(HFIN-HINI)
C
C AIGUILLAGE SUIVANT LA VALEUR DE IDES
C
      IF (IDES.EQ.1) THEN
C
C MODELE DE BAZANT : STRESS-INDUCED SHRINKAGE => EQUATION (3.3-3)
C
        A = 0.D0
        B = DH / (2.D0*VDES)
        C = B
C
C MODELE UMLV => EQUATION (3.3-5)
C
C      ELSEIF (IDES.EQ.2) THEN
C        TEQ = VDES / RDES
C        TQEXP = DEXP(-TDT/TEQ)
C        A = (TQEXP - 1.D0)
C        B = 2.*DH/RDES*((1.D0 - TQEXP) * (1.D0 + TEQ / TDT) - 1.D0)
C        C = 0.D0
C
      ENDIF
C
C CONSTRUCTION DE LA MATRICE DE FLUAGE DE DESSICCATION
C
      DO 10 I=1,NSTRS
        AFD(I)   = A * EFDE(I)
        BFD(I,I) = B
        CFD(I,I) = C
  10  CONTINUE
C
C VERIFICATION DE LA CROISSANCE DE LA DEFORMATION
C
      IF (IDES.EQ.2) THEN
        DO 20 I=1,NSTRS
        DEFDEF = AFD(I) + BFD(I,I) * SIGI(I)
          IF (DEFDEF.GT.0.D0) THEN
            AFD(I) = 0.D0
            BFD(I,I) = 0.D0
            CFD(I,I) = 0.D0
          ENDIF
  20    CONTINUE
      ENDIF
C
  30  CONTINUE
C
      END
