      SUBROUTINE LCUMMD(VARI,NVARI,CMAT,NMAT,SIGM,
     &                 NSTRS,ISPH,TDT,HINI,
     &                 HFIN,AN,BN,CN,CFPS,CFPD)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 24/03/2009   AUTEUR REZETTE C.REZETTE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2002  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE YLEPAPE Y.LEPAPE
C
C ROUTINE APPELE DANS NCUMLVFP
C LCUMMD     SOURCE    BENBOU   01/03/26
C-----------------------------------------------------------------------
C_______________________________________________________________________
C
C ROUTINE QUI CALCUL LA MATRICE DE DEFORMATION
C   DE FLUAGE DE DESSICCATION ET DE FLUAGE PROPRE
C
C LA VARIATION DE DEFORMATION DE FLUAGE EST CALCULEE
C AVEC LA RELATION SUIVANTE
C      EPS_N+1 - EPS_N = AN + BN:SIG_N+1 + CN:SIG_N
C
C     EQUATION (3.9-1)
C
C IN  VARI     : VARIABLES INTERNES INITIALES
C IN  NVARI    : DIMENSION DES VECTEURS VARIABLES INTERNES
C IN  CMAT     : VECTEUR DE PARAMETRES (MATERIAU ET AUTRE)
C IN  NMAT     : DIMENSION DE CMAT
C IN  NSTRS    : DIMENSION DES VECTEURS CONTRAINTE ET DEFORMATION
C IN  ISPH     : MODE DE CALCUL DE LA PARTIE SPHERIQUE
C IN  TDT      : PAS DE TEMPS
C IN  HINI     : HUMIDITE INITIALE
C IN  HFIN     : HUMIDITE FINALE
C OUT AN       : CF EQUATION CI-DESSUS
C OUT BN       : CF EQUATION CI-DESSUS
C OUT CN       : CF EQUATION CI-DESSUS
C OUT CFPS     : COEFFICICIENT DE CN SPHERIQUE    (MATRICE TANGENTE)
C OUT CFPD     : COEFFICICIENT DE CN DEVIATORIQUE (MATRICE TANGENTE)
C_______________________________________________________________________
C
      IMPLICIT NONE
      INTEGER NVARI,NMAT,NSTRS,IFPO,ISPH,IDES,I,J
C MODIFI DU 6 JANVIER 2003 - YLP SUPPRESSION DES DECLARATIONS
C IMPLICITES DES TABLEAUX      
C      REAL*8 VARI(NVARI),CMAT(NMAT)
      REAL*8 VARI(NVARI),CMAT(NMAT)
C MODIFI DU 6 JANVIER 2003 - YLP SUPPRESSION DES DECLARATIONS
C IMPLICITES DES TABLEAUX
C      REAL*8 AN(NSTRS),BN(NSTRS,NSTRS),CN(NSTRS,NSTRS)
C      REAL*8 AFD(NSTRS),BFD(NSTRS,NSTRS),CFD(NSTRS,NSTRS)
C      REAL*8 AFP(NSTRS),BFP(NSTRS,NSTRS),CFP(NSTRS,NSTRS)
      REAL*8 SIGM(6)
      REAL*8 AN(6),BN(6,6),CN(6,6)
      REAL*8 AFD(6),BFD(6,6),CFD(6,6)
      REAL*8 AFP(6),BFP(6,6),CFP(6,6)
      REAL*8 CFPD,CFPS,HFIN,HINI,TDT
C
C RECUPERATION DES VALEURS DES PARAMETRES MATERIAU
C
      IFPO = NINT(CMAT(13))
      IDES = NINT(CMAT(14))
C
C INITIALISATION DES VARIABLES
C
C MODIFI DU 6 JANVIER 2003 6 YLP NSTRS --> 6
C      DO 11 I=1,NSTRS
      DO 11 I=1,6
        AFD(I) = 0.D0
        AFP(I) = 0.D0
C        DO 12 J=1,NSTRS
        DO 12 J=1,6
          BFP(I,J) = 0D0
          BFD(I,J)  = 0D0
          CFP(I,J)  = 0D0
          CFD(I,J)  = 0D0
12      CONTINUE
11    CONTINUE
C
C_______________________________________________________________________
C
C  FLUAGE DE DESSICCATION
C
C --> DEBRANCHE le 11 octobre 2002 - ylp.
C
C      IF ((IDES.EQ.1).OR.(IDES.EQ.2)) THEN
C        CALL FLUDES(SIGI,NSTRS,VARI,NVARI,CMAT,NMAT,TDT,HINI,HFIN,
C     $              AFD,BFD,CFD)
C      ENDIF
C --> REBRANCHE le 25 aout 2004 - ylp.
      IF ((IDES.EQ.1).OR.(IDES.EQ.2)) THEN
        CALL LCUMFB(SIGM,NSTRS,VARI,NVARI,CMAT,NMAT,TDT,HINI,HFIN,
     $              AFD,BFD,CFD)
      ENDIF
C
C  FLUAGE PROPRE
C
      IF (IFPO.NE.0) THEN
        CALL LCUMSD(VARI,NVARI,CMAT,NMAT,NSTRS,ISPH,TDT,HINI,HFIN,
     $              AFP,BFP,CFP,CFPS,CFPD)
      ENDIF
C
C  CONSTRUCTION DE LA MATRICE DE FLUAGE TOTAL : EQUATION (3.9-2)
C
      DO 10 I=1,NSTRS
        AN(I) = AFD(I) + AFP(I)
        DO 10 J=1,NSTRS
          BN(I,J) = BFD(I,J) + BFP(I,J)
          CN(I,J) = CFD(I,J) + CFP(I,J)
  10  CONTINUE
C
      END
