      SUBROUTINE LCUMP1(CMAT,NMAT,AMBDA1,AMBDA2,X1,X2)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 16/12/2002   AUTEUR YLEPAPE Y.LEPAPE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2002  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE YLEPAPE Y.LEPAPE
C
C ROUTINE APPELE DANS LCUMFS
C LCUMP1     SOURCE    BENBOU   01/03/26
C
C_______________________________________________________________________
C
C CALCUL DE PARAMETRE DE LA LOI DE FLUAGE PROPRE SPHERIQUE
C IN  CMAT     : VECTEUR DE PARAMETRES (MATERIAU ET AUTRE)
C IN  NMAT     : DIMENSION DE CMAT
C OUT AMBDA1   : PARAMETRE MATERIAU LAMBDA1
C OUT AMBDA2   : PARAMETRE MATERIAU LAMBDA2
C OUT X1       : PARAMETRE MATERIAU X1
C OUT X2       : PARAMETRE MATERIAU X2
C_______________________________________________________________________
C
C     IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT NONE
      INTEGER  NMAT
      REAL*8  CMAT(NMAT)
      REAL*8  AMBDA1,AMBDA2,DELTA,RISP,RRSP,UII,URI
      REAL*8  URR,VISP,VRSP,X1,X2
C
C RECUPERATION DES VALEURS DES PARAMETRES MATERIAU
C
      RRSP = CMAT(3)
      VRSP = CMAT(4)
      RISP = CMAT(5)
      VISP = CMAT(6)
C
C PARAMETRES INTERMEDIAIRES => EQUATION (3.10-1)
C
      URR = RRSP/VRSP
      UII = RISP/VISP
      URI = RRSP/VISP
C
C PARAMETRE INTERMEDIAIRE => EQUATION (3.10-2)
C
      DELTA = (URR - UII)**2 + 8*URI*(URR + UII) + 16*URI**2
C
C INVERSE DES TEMPS CARACTERISTIQUES => EQUATION (3.10-4)
C
      AMBDA1 = - (URR + 4*URI + UII + SQRT(DELTA))/2
      AMBDA2 = - (URR + 4*URI + UII - SQRT(DELTA))/2
C
C PARAMETRES INTERMEDIAIRES => EQUATION (3.10-3)
C
      X1 = (AMBDA1 + UII)/(2*URI)
      X2 = 2*URI/(AMBDA2 + UII)
C
      END
