      SUBROUTINE MATRAN( NBM, S0, Z0, OMEGA, OMEGAD, TRANS )
C
C ********************************************************************
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/05/96   AUTEUR KXBADNG T.FRIOU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C ********************************************************************
C DESCRIPTION : ALGORITHME D'INTEGRATION TEMPORELLE
C -----------    CALCUL DE LA MATRICE DE TRANSFERT
C
C ****************** DECLARATION DES VARIABLES ***********************
C
      IMPLICIT NONE
C
C ARGUMENTS
C ---------
      INTEGER NBM
      REAL*8 OMEGA(*), OMEGAD(*), TRANS(2,2,*)
      COMPLEX*16 S0(*), Z0(*)
C
C VARIABLES LOCALES
C -----------------
      INTEGER I
C
C ****************** DEBUT DU CODE EXECUTABLE ************************
C
      DO 10 I=1,NBM
C
        TRANS(1,1,I) = DIMAG(S0(I)*Z0(I))/OMEGAD(I)
        TRANS(1,2,I) = DIMAG(OMEGA(I)*OMEGA(I)*DCONJG(Z0(I)))/OMEGAD(I)
        TRANS(2,1,I) = DIMAG(Z0(I))/OMEGAD(I)
        TRANS(2,2,I) = DIMAG(S0(I)*DCONJG(Z0(I)))/OMEGAD(I)
C
 10   CONTINUE
C
      END
