      SUBROUTINE MDFDAS( DNORM,VNORM,VITLOC,COST,SINT,COEFK1,
     +                   COEFK2,COEFPY,COEFC,COEFAD,XMAX,FDISPO,FLOCAL)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/12/98   AUTEUR T8BHHFW FE.WAECKEL 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C***********************************************************************
C    CALCULE LA FORCE DUE A LA PRESENCE D'UN DISPOSITIF ANTI SISMIQUE
C
C-----------------------------------------------------------------------
C   IN :  DNORM : DISTANCE NORMALE
C   OUT :  VNORM : VITESSE  NORMALE 
C   IN :  VITLOC : VITESSE DANS LE REPERE LOCAL
C   IN :  ACCLOC : ACCELERATION DANS LE REPERE LOCAL
C   IN :  COST,SINT : DIRECTION DE LA NORMALE A L'OBSTACLE
C   IN :  COEFK1 : VALEUR DE RIGI_K1
C   IN :  COEFK2 : VALEUR DE RIGI_K2
C   IN :  COEFPY : VALEUR DE SEUIL_FX
C   IN :  COEFC : VALEUR DE C
C   IN :  COEFAD : VALEUR DE PUIS_ALPHA
C   IN :  XMAX : VALEUR DE DX_MAX
C   IN :  CNORM : AMORTISSEUR NORMALE DE CHOC
C   OUT :  FDISPO : FORCE NORMALE DUE AU DISPO ANTI SISMIQUE
C   OUT :  FLOCAL : FORCE NORMALE DE CHOC REP. LOCAL
C-----------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 VITLOC(6),FLOCAL(3),FDISPO
      REAL*8 COEFK1, COEFK2, COEFPY, COEFC, COEFAD,XMAX, COST, SINT
      VNORM = VITLOC(2)*COST + VITLOC(3)*SINT
      IF (VNORM.EQ.0.D0) THEN
          FDISPO = -COEFK2*DNORM -
     &         (COEFK1-COEFK2)*DNORM/SQRT(1.D0+(COEFK1*DNORM/COEFPY)**2)
      ELSE
          FDISPO = -COEFK2*DNORM -
     &         (COEFK1-COEFK2)*DNORM/SQRT(1.D0+(COEFK1*DNORM/COEFPY)**2)
     &        - COEFC*SIGN(1.D0,VNORM)*ABS(VNORM*DNORM/XMAX)**COEFAD
      ENDIF
      FLOCAL(1)=0.D0
      FLOCAL(2)=FDISPO*COST
      FLOCAL(3)=FDISPO*SINT
 9999 CONTINUE
      END
