      SUBROUTINE MMALGO(XA    ,XS    ,LVITES,LCOMPL,LGLINI,
     &                  JEU   ,JEUVIT,ASPERI,LAMBDC,COEFCR,
     &                  MMCVCA,SCOTCH,XANEW ,XSNEW )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 19/10/2010   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2006  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INTEGER  XA    ,XS
      INTEGER  XANEW ,XSNEW
      LOGICAL  LVITES,LCOMPL,MMCVCA,LGLINI,SCOTCH
      REAL*8   JEU   ,JEUVIT,ASPERI,LAMBDC,COEFCR
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - CONTRAINTES ACTIVES)
C
C TRAITEMENT DES DIFFERENTS CAS
C
C ----------------------------------------------------------------------
C
C
C IN  XS     : INDICATEUR DE CONTACT
C                - XS = 0: PAS DE CONTACT
C                - XS = 1: CONTACT
C IN  XA     : INDICATEUR POUR LA COMPLIANCE
C                - XA = 0: ON N'EST PAS "DANS" LES ASPERITES
C                - XA = 1: ON EST DANS LES ASPERITES
C                SI PAS DE COMPLIANCE ACTIVEE: XA VAUT TOUJOURS 1
C IN  XS     : INDICATEUR DE CONTACT (XS=0: PAS DE CONTACT)
C IN  LVITES : .TRUE. SI FORMULATION EN VITESSE
C IN  LGLINI : .TRUE. SI CONTACT GLISSIERE AVEC CONTACT_INIT AU PREMIER
C               PAS DE TEMPS
C IN  LCOMPL : .TRUE. SI COMPLIANCE
C              .FALSE. => XA = 1
C IN  JEU    : VALEUR DU JEU
C IN  JEUVIT : VALEUR DU GAP DES VITESSES NORMALES
C IN  ASPERI : COEFFICIENT POUR LES ASPERITES (COMPLIANCE)
C IN  LAMBDC : MULTIPLICATEUR DE CONTACT DU POINT DE CONTACT
C IN  COEFCR : COEFFICIENT DE REGULARISATION DU CONTACT RHO_N
C OUT XAEND  : NOUVEL INDICATEUR POUR COMPLIANCE
C                 XA = 0 ON N'EST PAS "DANS" LES ASPERITES
C              SI PAS DE COMPLIANCE ACTIVEE: XA VAUT TOUJOURS 1
C OUT XSEND  : NOUVEL INDICATEUR DE CONTACT (XS=0: PAS DE CONTACT)
C OUT MMCVCA : INDICATEUR DE CONVERGENCE POUR BOUCLE DES
C              CONTRAINTES ACTIVES
C               .TRUE. SI LA BOUCLE DES CONTRAINTES ACTIVES A CONVERGE
C OUT SCOTCH : VAUT .TRUE. SI LE NOEUD EST COLLE DANS LE MODELE
C              DE COMPLIANCE
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      REAL*8  R8PREM
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
      SCOTCH = .FALSE.
      XANEW  = XA
      XSNEW  = XS
C
      IF (LCOMPL) THEN
C
C --- COMPLIANCE
C
        IF (XA.EQ.0) THEN
C ----- LE PC NE TOUCHAIT PAS LES ASPERITES (XA=0)
          CALL ASSERT(XS.EQ.0)
          IF (JEU.LE.ASPERI) THEN
C ------- ET NE LES TOUCHE TOUJOURS PAS
            GOTO 999
          ENDIF
        ENDIF
      ENDIF
C
C --- LE PC TOUCHAIT LES ASPERITES
C --- (C'EST TOUJOURS LE CAS QUAND IL N'Y A PAS DE COMPLIANCE)
C
      XANEW = 1
C
C --- VERIFICATION DU SIGNE DU MULTIPLICATEUR AUGMENTE
C
      IF ((LAMBDC-COEFCR*JEU).LE.R8PREM()) THEN
        XSNEW = 1
      ELSE
        XSNEW = 0
      ENDIF
C
C --- CAS GLISSIERE
C
      IF (LGLINI) THEN
C ----- XS=0 EST POSSIBLE SI LE POINT A ETE EXCLUS PAR TOLE_*
        IF (XS.EQ.0) THEN
          XSNEW = 1
        ENDIF
C ----- PAS DE DECOLLEMENT AUTORISE
        IF (XS.EQ.1) THEN
          XSNEW = 1
        ENDIF
      ENDIF
C
C --- THETA-METHODE
C
      IF (XS.EQ.1) THEN
C ----- UN POINT EST EN CONTACT
        SCOTCH = .TRUE.
      ENDIF
C
C --- FORMULATION EN VITESSE
C
      IF (LVITES) THEN
        IF ((XS.EQ.0).AND.(JEUVIT.LE.0.D0)) THEN
          XSNEW = 0
        END IF
      ENDIF
C
C --- COMPLIANCE
C
      IF (LCOMPL) THEN
        IF ((XS.EQ.0).AND.(JEU.LE.ASPERI)) THEN
C ----- LE PC NE TOUCHE PLUS LES ASPERITES
          XANEW = 0
        ENDIF
      ENDIF
C
C --- CONVERGENCE ?
C
      IF (XS.NE.XSNEW) THEN
        MMCVCA=.FALSE.
      ENDIF
C
 999  CONTINUE
      CALL JEDEMA()
      END
