      SUBROUTINE MMEXFR(NOMA  ,DEFICO,IZONE ,POSMAM,TAU1  ,
     &                  TAU2  )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2011   AUTEUR MACOCCO K.MACOCCO 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE MACOCCO K.MACOCCO
      IMPLICIT NONE
      CHARACTER*8  NOMA
      CHARACTER*24 DEFICO
      INTEGER      IZONE  ,POSMAM
      REAL*8       TAU1(3),TAU2(3)
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - APPARIEMENT - UTILITAIRE)
C
C REDEFINIT LA BASE TANGENTE LOCALE POUR SANS_GROUP_NO_FR
C      
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  DEFICO : SD POUR LA DEFINITION DU CONTACT
C IN  IZONE  : NUMERO DE LA ZONE DE CONTACT
C IN  POSMAM : POSITION DE LA MAILLE MAITRE DANS LES SD CONTACT
C OUT TAU1   : PREMIER VECTEUR TANGENT
C OUT TAU2   : SECOND VECTEUR TANGENT
C
      INTEGER     CFDISI,NDIMG,MMINFI,NDIREX
      REAL*8      VDIREX(3),NORM(3),NORME
      REAL*8      TAU1FR(3),TAU2FR(3)
      REAL*8      EXTAU1,EXTAU2
      REAL*8      MMINFR,DDOT,R8PREM
      CHARACTER*8 NOMMAM
C
C ----------------------------------------------------------------------
C
C --- INITIALISATIONS 
C
      NDIMG = CFDISI(DEFICO,'NDIM')
C
C --- NOMBRE DE DIRECTIONS A EXCLURE POUR LA ZONE
C
      NDIREX = MMINFI(DEFICO,'EXCL_DIR',IZONE)
C
C --- REDEFINITION DU REPERE SI NECESSAIRE (UNE DIRECTION EXCLUE EN 3D)
C
      IF ((NDIMG.EQ.3).AND.(NDIREX.EQ.1)) THEN
C ----- DIRECTION D'EXCLUSION
        VDIREX(1) = MMINFR(DEFICO,'EXCL_FROT_DIRX',IZONE )
        VDIREX(2) = MMINFR(DEFICO,'EXCL_FROT_DIRY',IZONE )
        VDIREX(3) = MMINFR(DEFICO,'EXCL_FROT_DIRZ',IZONE )
C ----- ON LA PROJETTE SUR LE PLAN TANGENT
        CALL DCOPY(3,TAU1,1,TAU1FR,1)
        CALL DCOPY(3,TAU2,1,TAU2FR,1)
        EXTAU1 = DDOT(3,VDIREX,1,TAU1,1)
        EXTAU2 = DDOT(3,VDIREX,1,TAU2,1)
        CALL DSCAL(3,EXTAU1,TAU1FR,1)
        CALL DAXPY(3,EXTAU2,TAU2FR,1,TAU1FR,1)
        CALL NORMEV(TAU1FR,NORME)
        IF (NORME.LE.R8PREM()) THEN
          CALL CFNOMM(NOMA  ,DEFICO,'MAIL',POSMAM,NOMMAM)
          CALL U2MESG('F','CONTACT3_18',1,NOMMAM,1,IZONE ,3,VDIREX)
        ENDIF
C ----- ON CALCULE TAU2FR PAR PROD. VECT.
        CALL MMNORM(NDIMG ,TAU1  ,TAU2  ,NORM,NORME)
        CALL PROVEC(TAU1FR,NORM  ,TAU2FR)
C ----- RECOPIE
        CALL DCOPY(3,TAU1FR,1,TAU1,1)
        CALL DCOPY(3,TAU2FR,1,TAU2,1)
      ENDIF
C
      END
