      SUBROUTINE MMGEOM(NDIM  ,NNE   ,NNM   ,FFE   ,FFM   ,
     &                  GEOMAE,GEOMAM,GEOME ,GEOMM )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/12/2009   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2006  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INTEGER      NDIM,NNE,NNM
      REAL*8       FFE(9),FFM(9)
      REAL*8       GEOMM(3),GEOME(3)
      REAL*8       GEOMAE(9,3),GEOMAM(9,3)
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - UTILITAIRE)
C
C CALCUL DES INCREMENTS - GEOMETRIE
C
C ----------------------------------------------------------------------
C
C
C DEPDEL - INCREMENT DE DEPLACEMENT DEPUIS DEBUT DU PAS DE TEMPS
C DEPMOI - DEPLACEMENT DEBUT DU PAS DE TEMPS
C GEOMAx - GEOMETRIE ACTUALISEE GEOM_INIT + DEPMOI 
C
C
C IN  NDIM   : DIMENSION DU PROBLEME
C IN  NNE    : NOMBRE DE NOEUDS DE LA MAILLE ESCLAVE
C IN  NNM    : NOMBRE DE NOEUDS DE LA MAILLE MAITRE
C IN  FFE    : FONCTIONS DE FORMES DEPL. ESCL.
C IN  FFM    : FONCTIONS DE FORMES DEPL. MAIT.
C IN  GEOMAE : GEOMETRIE ACTUALISEE SUR NOEUDS ESCLAVES
C IN  GEOMAM : GEOMETRIE ACTUALISEE SUR NOEUDS MAITRES
C OUT GEOME  : COORDONNEES ACTUALISEES DU POINT DE CONTACT
C OUT GEOMM  : COORDONNEES ACTUALISEES DU PROJETE DU POINT DE CONTACT
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER   IDIM,INOE
C
C ----------------------------------------------------------------------
C
      DO 9 IDIM = 1,3
        GEOME(IDIM)  = 0.D0
        GEOMM(IDIM)  = 0.D0
 9    CONTINUE
C
C --- COORDONNEES ACTUALISEES DU POINT DE CONTACT
C 
      DO 11 IDIM = 1,NDIM
        DO 12 INOE = 1,NNE
          GEOME(IDIM) = GEOME(IDIM) + FFE(INOE)*GEOMAE(INOE,IDIM)
12      CONTINUE
11    CONTINUE
C
C --- COORDONNEES ACTUALISEES DE LA PROJECTION DU POINT DE CONTACT
C 
      DO 21 IDIM = 1,NDIM
        DO 22 INOE = 1,NNM
          GEOMM(IDIM) = GEOMM(IDIM) + FFM(INOE)*GEOMAM(INOE,IDIM)
22      CONTINUE
21    CONTINUE
C
      END
