      SUBROUTINE MMMJEC(NDIM  ,NORM  ,BETA  ,GAMMA ,DELTAT,
     &                  DDEPLE,DDEPLM,DEPLME,DEPLMM,VITME ,
     &                  VITMM ,ACCME ,ACCMM ,JEVITP)

C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 19/10/2010   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INTEGER NDIM
      REAL*8  NORM(3)
      REAL*8  BETA,GAMMA,DELTAT
      REAL*8  DDEPLE(3),DEPLME(3)
      REAL*8  DDEPLM(3),DEPLMM(3)
      REAL*8  ACCME(3),ACCMM(3)
      REAL*8  VITME(3),VITMM(3)
      REAL*8  JEVITP
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - UTILITAIRE)
C
C CALCUL DU JEU ACTUALISE - SAUT DE VITESSE POUR COMPLIANCE
C
C ----------------------------------------------------------------------
C
C
C IN  NDIM   : DIMENSION DU PROBLEME
C IN  NORM   : VALEUR DE LA NORMALE
C IN  BETA   : PARAMETRE SCHEMA NEWMARK
C IN  GAMMA  : PARAMETRE SCHEMA NEWMARK
C IN  DELTA  : INCREMENT DE TEMPS
C IN  DDEPLE : DEPLACEMENTS DEPDEL DU POINT DE CONTACT
C IN  DDEPLM : DEPLACEMENTS DEPDEL DU PROJETE DU POINT DE CONTACT
C IN  DEPLME : DEPLACEMENTS PRECEDENTS DU POINT DE CONTACT
C IN  DEPLMM : DEPLACEMENTS PRECEDENTS DU PROJETE DU POINT DE CONTACT
C IN  VITME  : VITESSE DU POINT DE CONTACT
C IN  ACCME  : ACCELERATION DU POINT DU CONTACT
C IN  VITMM  : VITESSE DU PROJETE DU POINT DE CONTACT
C IN  ACCMM  : ACCELERATION DU PROJETE DU POINT DU CONTACT
C OUT JEVITP : VALEUR DU JEU (SAUT DE VITESSE NORMALE POUR COMPLIANCE)
C
C ----------------------------------------------------------------------
C
      INTEGER IDIM
      REAL*8  JDEPP,JDEPM,JEVITM,JEACCM
C
C ----------------------------------------------------------------------
C
      JDEPP  = 0.D0
      JDEPM  = 0.D0
      JEVITM = 0.D0
      JEACCM = 0.D0
      JEVITP = 0.D0
      DO 20 IDIM = 1,NDIM
        JDEPP  = JDEPP  + (DDEPLE(IDIM)-DDEPLM(IDIM))*NORM(IDIM)
        JDEPM  = JDEPM  + (DEPLME(IDIM)-DEPLMM(IDIM))*NORM(IDIM)
        JEVITM = JEVITM + (VITME(IDIM) -VITMM(IDIM)) *NORM(IDIM)
        JEACCM = JEACCM + (ACCME(IDIM) -ACCMM(IDIM)) *NORM(IDIM)
 20   CONTINUE
      IF (BETA.NE.0.D0) THEN
        JEVITP = (JDEPP-JDEPM)*GAMMA/(BETA*DELTAT) +
     &            JEVITM*(BETA-GAMMA)/BETA +
     &            JEACCM*DELTAT*(2*BETA-GAMMA)/(2*BETA)
      ELSE
        JEVITP = 0.D0
      ENDIF
      END
