        SUBROUTINE  MMPROJ(ALIAS ,NNO   ,NDIM  ,COORMA,COORPT,
     &                     ITEMAX,EPSMAX,TOLEOU,DIRAPP,DIR   ,
     &                     KSI1  ,KSI2  ,TAU1  ,TAU2  ,IPROJ ,
     &                     NIVERR)
C     
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 14/09/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2006  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*8  ALIAS      
      INTEGER      NDIM
      INTEGER      NNO
      REAL*8       COORMA(27)
      REAL*8       COORPT(3)
      LOGICAL      DIRAPP
      REAL*8       DIR(3)
      REAL*8       KSI1,KSI2
      REAL*8       TAU1(3),TAU2(3) 
      REAL*8       TOLEOU
      INTEGER      IPROJ
      INTEGER      NIVERR
      INTEGER      ITEMAX
      REAL*8       EPSMAX
C      
C ----------------------------------------------------------------------
C
C ROUTINE APPARIEMENT
C
C FAIRE LA PROJECTION D'UN POINT SUR UNE MAILLE DONNEE
C      
C ----------------------------------------------------------------------
C
C
C IN  ALIAS  : TYPE DE MAILLE
C IN  NNO    : NOMBRE DE NOEUD SUR LA MAILLE
C IN  NDIM   : DIMENSION DE LA MAILLE (2 OU 3)
C IN  COORMA : COORDONNEES DES NOEUDS DE LA MAILLE
C IN  COORPT : COORDONNEES DU NOEUD A PROJETER SUR LA MAILLE
C IN  ITEMAX : NOMBRE MAXI D'ITERATIONS DE NEWTON POUR LA PROJECTION
C IN  EPSMAX : RESIDU POUR CONVERGENCE DE NEWTON POUR LA PROJECTION 
C IN  TOLEOU : TOLERANCE POUR LE PROJETE HORS MAILLE
C IN  DIRAPP : VAUT .TRUE. SI APPARIEMENT DANS UNE DIRECTION DE 
C              RECHERCHE DONNEE (PAR DIR)
C IN  DIR    : DIRECTION D'APPARIEMENT
C OUT KSI1   : PREMIERE COORDONNEE PARAMETRIQUE DU POINT PROJETE
C OUT KSI2   : SECONDE COORDONNEE PARAMETRIQUE DU POINT PROJETE
C OUT TAU1   : PREMIER VECTEUR TANGENT EN (KSI1,KSI2)
C OUT TAU2   : SECOND VECTEUR TANGENT EN (KSI1,KSI2)
C OUT IPROJ  : VAUT 0 SI POINT PROJETE DANS L'ELEMENT
C                   1 SI POINT PROJETE DANS LA ZONE DEFINIE PAR TOLEOU
C                   2 SI POINT PROJETE EN DEHORS (EXCLUS)
C OUT NIVERR : RETOURNE UN CODE ERREUR
C                0  TOUT VA BIEN
C                1  ECHEC DE NEWTON
C
C ----------------------------------------------------------------------
C
      NIVERR = 0
C 
C --- ALGO DE NEWTON POUR LA PROJECTION SUIVANT UNE DIRECTION DONNEE
C
      IF (DIRAPP) THEN
        CALL MMNEWD(ALIAS ,NNO   ,NDIM  ,COORMA,COORPT,
     &              ITEMAX,EPSMAX,DIR   ,KSI1  ,KSI2  ,
     &              TAU1  ,TAU2  ,NIVERR)
      ELSE 
        CALL MMNEWT(ALIAS ,NNO   ,NDIM  ,COORMA,COORPT,
     &              ITEMAX,EPSMAX,KSI1  ,KSI2  ,TAU1  ,
     &              TAU2  ,NIVERR)     
      ENDIF 
      IF (NIVERR.GT.0) THEN  
        GOTO 999  
      ENDIF    
C
C --- AJUSTEMENT PROJECTION HORS ZONE
C
      CALL MMTOLE(ALIAS ,NNO   ,NDIM  ,COORMA,TOLEOU,
     &            KSI1  ,KSI2  ,TAU1  ,TAU2  ,IPROJ )
C      
  999 CONTINUE         
  
      END
