      SUBROUTINE MMSAUV(RESOCO,IZONE ,IPTC  ,NUMMAM,KSIPR1,
     &                  KSIPR2,TAU1  ,TAU2  ,NUMMAE,NUMNOE,
     &                  KSIPC1,KSIPC2,WPC   )
C     
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 14/09/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*24 RESOCO
      INTEGER      IPTC,IZONE
      INTEGER      NUMMAM,NUMMAE,NUMNOE
      REAL*8       KSIPR1,KSIPR2
      REAL*8       KSIPC1,KSIPC2
      REAL*8       TAU1(3),TAU2(3)
      REAL*8       WPC      
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES CONTINUES - APPARIEMENT)
C
C SAUVEGARDE APPARIEMENT - CAS MAIT_ESCL
C      
C ----------------------------------------------------------------------
C
C
C IN  RESOCO : SD POUR LA RESOLUTION DE CONTACT
C IN  IPTC   : NUMERO DE LA LIAISON DE CONTACT
C IN  IZONE  : NUMERO DE LA ZONE
C IN  NUMMAM : NUMERO ABSOLU MAILLE MAITRE QUI RECOIT LA PROJECTION
C IN  NUMMAE : NUMERO ABSOLU MAILLE ESCLAVE
C IN  NUMNOE : NUMERO ABSOLU DU PT INTEG DANS LES SD CONTACT SI
C              INTEG.NOEUDS
C IN  KSIPR1 : PREMIERE COORDONNEE PARAMETRIQUE PT CONTACT PROJETE 
C              SUR MAILLE MAITRE
C IN  KSIPR2 : SECONDE COORDONNEE PARAMETRIQUE PT CONTACT PROJETE 
C              SUR MAILLE MAITRE
C IN  TAU1   : PREMIERE TANGENTE
C IN  TAU2   : SECONDE TANGENTE
C IN  KSIPC1 : PREMIERE COORDONNEE PARAMETRIQUE PT CONTACT
C IN  KSIPC2 : SECONDE COORDONNEE PARAMETRIQUE PT CONTACT
C IN  WPC    : POIDS INTEGRATION
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      CFMMVD,ZTABF
      CHARACTER*24 TABFIN
      INTEGER      JTABF 
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- ACCES SD CONTACT
C
      TABFIN = RESOCO(1:14)//'.TABFIN'
      CALL JEVEUO(TABFIN,'E',JTABF)
      ZTABF = CFMMVD('ZTABF')
      CALL ASSERT(IZONE.GT.0)
C
C --- STOCKAGE DES VALEURS POUR LE CHAM_ELEM (VOIR MMCHML)
C
      ZR(JTABF+ZTABF*(IPTC-1)+2)  = NUMMAM
      ZR(JTABF+ZTABF*(IPTC-1)+5)  = KSIPR1
      ZR(JTABF+ZTABF*(IPTC-1)+6)  = KSIPR2
      ZR(JTABF+ZTABF*(IPTC-1)+7)  = TAU1(1)
      ZR(JTABF+ZTABF*(IPTC-1)+8)  = TAU1(2)
      ZR(JTABF+ZTABF*(IPTC-1)+9)  = TAU1(3)
      ZR(JTABF+ZTABF*(IPTC-1)+10) = TAU2(1)
      ZR(JTABF+ZTABF*(IPTC-1)+11) = TAU2(2)
      ZR(JTABF+ZTABF*(IPTC-1)+12) = TAU2(3)     
      ZR(JTABF+ZTABF*(IPTC-1)+13) = IZONE
C      
C --- STOCKAGE DES VALEURS POUR LE CHAM_ELEM (VOIR MMCHML)
C
      ZR(JTABF+ZTABF*(IPTC-1)+1)  = NUMMAE
      ZR(JTABF+ZTABF*(IPTC-1)+3)  = KSIPC1
      ZR(JTABF+ZTABF*(IPTC-1)+4)  = KSIPC2
      ZR(JTABF+ZTABF*(IPTC-1)+14) = WPC
      ZR(JTABF+ZTABF*(IPTC-1)+24) = NUMNOE
C
      CALL JEDEMA()
      END
