      SUBROUTINE MMTOLE(ALIAS ,NNO   ,NDIM  ,COORMA,TOLEOU,
     &                  KSI1  ,KSI2  ,TAU1  ,TAU2  ,IPROJ )
C     
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/06/2009   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2007  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*8  ALIAS      
      INTEGER      NNO
      INTEGER      NDIM
      REAL*8       COORMA(27)
      REAL*8       KSI1,KSI2
      REAL*8       TAU1(3),TAU2(3) 
      REAL*8       TOLEOU
      INTEGER      IPROJ
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - APPARIEMENT)
C
C RAMENE POINT PROJETE HORS DE LA MAILLE
C      
C ----------------------------------------------------------------------
C
C IN  ALIAS  : TYPE DE MAILLE
C IN  NNO    : NOMBRE DE NOEUD SUR LA MAILLE
C IN  NDIM   : DIMENSION DE LA MAILLE (2 OU 3)
C IN  COORMA : COORDONNEES DES NOEUDS DE LA MAILLE
C IN  TOLEOU : TOLERANCE POUR LE PROJETE HORS SURFACE MAITRE
C I/O KSI1   : PREMIERE COORDONNEE PARAMETRIQUE DU POINT PROJETE
C I/O KSI2   : SECONDE COORDONNEE PARAMETRIQUE DU POINT PROJETE
C OUT TAU1   : PREMIER VECTEUR TANGENT EN (KSI1,KSI2)
C OUT TAU2   : SECOND VECTEUR TANGENT EN (KSI1,KSI2)
C OUT IPROJ  : VAUT 0 SI POINT PROJETE DANS L'ELEMENT
C                   1 SI POINT PROJETE DANS LA ZONE DEFINIE PAR TOLEOU
C                   2 SI POINT PROJETE EN DEHORS (EXCLUS)
C      
C ----------------------------------------------------------------------
C
      REAL*8      DFF(2,9)
C      
C ----------------------------------------------------------------------
C

C
C --- AJUSTEMENT PROJECTION HORS ZONE
C
      CALL CFADJU(ALIAS,KSI1,KSI2,TOLEOU,IPROJ)              
C       
C --- CALCUL DES DERIVEES DES FONCTIONS DE FORME 
C
      CALL MMDONF(NDIM  ,NNO   ,ALIAS  ,KSI1   ,KSI2  ,
     &            DFF   )       
C      
C --- RE-CALCUL DES TANGENTES APRES AJUSTEMENT
C
      CALL MMTANG(NDIM  ,NNO   ,COORMA,DFF   ,
     &            TAU1  ,TAU2)
C
      END
