      SUBROUTINE MMUSUM(NDIM  ,MPROJT,DDEPLE,DDEPLM,PRFUSU,
     &                  DELUSU,DISSIP)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/12/2009   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C        
      IMPLICIT NONE
      INTEGER      NDIM
      REAL*8       DDEPLE(3),DDEPLM(3)
      REAL*8       MPROJT(3,3)     
      REAL*8       DELUSU(3),DISSIP,PRFUSU
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - UTILITAIRE)
C
C CALCUL DES PARAMETRES ACTUALISEES POUR L'USURE
C
C ----------------------------------------------------------------------
C
C
C IN  NDIM   : DIMENSION DU PROBLEME
C IN  MPROJT : MATRICE DE PROJECTION TANGENTE
C IN  DDEPLE : INCREMENT DEPDEL DU DEPL. DU POINT DE CONTACT
C IN  DDEPLM : INCREMENT DEPDEL DU DEPL. DU PROJETE DU POINT DE CONTACTT
C OUT PRFUSU : JEU SUPPLEMENTAIRE PAR PROFONDEUR D'USURE
C OUT DELUSU : SAUT TGT DE L'INCREMENT DE DEPLACEMENT [[DELTA_U]]_TAU
C OUT DISSIP : DISSIPATION USURE
C
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX --------------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX --------------------
C
      INTEGER  I,J,K
      INTEGER  IUSUP
      REAL*8   DELTAU(3),DELTAT(3)
C
C ----------------------------------------------------------------------
C  
      CALL JEVECH('PUSULAR','L',IUSUP)
      PRFUSU = ZR(IUSUP-1+1)
C
C --- INITIALISATIONS
C      
      DISSIP = 0.D0
      DO 10 I = 1,3
        DELTAU(I)= 0.D0
        DELTAT(I)= 0.D0
        DELUSU(I)= 0.D0
 10   CONTINUE      
C     
      DO 312 I = 1,NDIM
        DELTAU(I)= (DDEPLE(I)-DDEPLM(I))
312   CONTINUE
C
      DO 332 I=1,NDIM
        DO 342  K=1,NDIM
          DELTAT(I) = MPROJT(I,K)*DELTAU(K) + DELTAT(I)
342     CONTINUE
332   CONTINUE
C
C --- DISSIPATION
C      
      DO 352 K = 1,NDIM
        DISSIP = DISSIP + (DELTAT(K)*DELTAT(K))
352   CONTINUE
      DISSIP = SQRT(DISSIP)
C
C --- CALCUL DE NORME([[U]]_TAU)
C
      DO 372 I=1,NDIM
        DO 382  J=1,NDIM
          DELUSU(I)=MPROJT(I,J)*DELTAT(J)+DELUSU(I)
382     CONTINUE
372   CONTINUE
C
      END
