      SUBROUTINE MXMAJD(DELTAT,SDDYNA)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/12/2009   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2003  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*19 SDDYNA
      REAL*8       DELTAT
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME - EXPLICITE)
C
C MET A JOUR LES VITESSES ET LES DEPL/VITE/ACCE GENERALISEES
C (PROJ_MODAL)
C      
C ----------------------------------------------------------------------
C
C
C IN  SDDYNA : SD DEDIEE A LA DYNAMIQUE (CF NDLECT)
C IN  DELTAT : INCREMENT DE TEMPS 
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      CHARACTER*19 DEPGEP,VITGEP,ACCGEP
      INTEGER      JDEPGP,JVITGP,JACCGP       
      CHARACTER*19 DEPGEM,VITGEM,ACCGEM
      INTEGER      JDEPGM,JVITGM,JACCGM
      INTEGER      IMODE
      REAL*8       COEVI1,COEVI2 
      LOGICAL      NDYNLO
      INTEGER      NDYNIN,NBMODP
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- COEFFICIENTS
C
      IF (NDYNLO(SDDYNA,'DIFF_CENT')) THEN
        COEVI1 = 0.5D0*DELTAT
        COEVI2 = 0.5D0*DELTAT
      ELSEIF (NDYNLO(SDDYNA,'TCHAMWA')) THEN
        COEVI1 = 0.D0
        COEVI2 = DELTAT
      ENDIF       
C
C --- NOM DES OBJETS POUR PROJECTION MODALE
C
      CALL NDYNKK(SDDYNA,'PRMO_DEPGEM',DEPGEM)
      CALL NDYNKK(SDDYNA,'PRMO_VITGEM',VITGEM)
      CALL NDYNKK(SDDYNA,'PRMO_ACCGEM',ACCGEM)
      CALL NDYNKK(SDDYNA,'PRMO_DEPGEP',DEPGEP)
      CALL NDYNKK(SDDYNA,'PRMO_VITGEP',VITGEP)
      CALL NDYNKK(SDDYNA,'PRMO_ACCGEP',ACCGEP)
      NBMODP = NDYNIN(SDDYNA,'NBRE_MODE_PROJ')
                   
      CALL JEVEUO(DEPGEP,'E',JDEPGP)      
      CALL JEVEUO(DEPGEM,'E',JDEPGM)
      CALL JEVEUO(VITGEP,'E',JVITGP)      
      CALL JEVEUO(VITGEM,'E',JVITGM)
      CALL JEVEUO(ACCGEP,'E',JACCGP)      
      CALL JEVEUO(ACCGEM,'E',JACCGM)            

      DO 11 IMODE = 1,NBMODP
        ZR(JVITGP+IMODE-1) = ZR(JVITGM+IMODE-1) + 
     &                       COEVI1*ZR(JACCGP+IMODE-1) +
     &                       COEVI2*ZR(JACCGM+IMODE-1)
        ZR(JDEPGM+IMODE-1) = ZR(JDEPGP+IMODE-1)
        ZR(JVITGM+IMODE-1) = ZR(JVITGP+IMODE-1)
        ZR(JACCGM+IMODE-1) = ZR(JACCGP+IMODE-1)
                        
        
11    CONTINUE

C
      CALL JEDEMA()
      END
