      SUBROUTINE NMAINT(NUMEDD,FONACT,DEFICO,VEASSE,VEFINT,
     &                  CNFINT,SDNUME)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 15/02/2011   AUTEUR FLEJOU J-L.FLEJOU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE     
      INTEGER       FONACT(*)
      CHARACTER*24  NUMEDD
      CHARACTER*19  VEASSE(*)
      CHARACTER*19  VEFINT,CNFINT
      CHARACTER*19  SDNUME
      CHARACTER*24  DEFICO
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C ASSEMBLAGE DU VECTEUR DES FORCES INTERNES
C      
C ----------------------------------------------------------------------
C
C
C IN  NUMEDD : NOM DE LA NUMEROTATION
C IN  DEFICO : SD DEFINITION CONTACT
C IN  FONACT : FONCTIONNALITES ACTIVEES
C IN  VEASSE : VARIABLE CHAPEAU POUR NOM DES VECT_ASSE
C IN  VEFINT : VECT_ELEM FORCES INTERNES
C IN  CNFINT : VECT_ASSE FORCES INTERNES
C IN  SDNUME : SD NUMEROTATION
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      INTEGER      IFM,NIV
      CHARACTER*1  BASE    
      LOGICAL      ISFONC,LCONT,LMACR
      CHARACTER*19 CNCONT,CNSSTR
      CHARACTER*8  K8BID
      INTEGER      NEQ,IRET,I,ENDO
      INTEGER      ENDOP1,ENDOP2
      INTEGER      JFINT
      LOGICAL      LENDO
C 
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> ... ASSEMBLAGE DES FORCES INTERNES'
      ENDIF
C
C --- INITIALISATIONS
C  
      BASE   = 'V' 
      LCONT  = ISFONC(FONACT,'CONTACT')
      LMACR  = ISFONC(FONACT,'MACR_ELEM_STAT')       
      CNCONT = '&&CNCHAR.DUMM'
      CALL VTZERO(CNFINT)  
      CALL VTZERO(CNCONT)        
C
C --- CONTRIBUTIONS DU CONTACT
C
      IF (LCONT) THEN
        CALL NMASCO('CNFINT',FONACT,DEFICO,VEASSE,CNCONT)    
      ENDIF
C
C --- ASSEMBLAGE DES FORCES INTERIEURES
C     
      CALL ASSVEC(BASE  ,CNFINT,1,VEFINT,1.D0,NUMEDD,' ','ZERO',1)
C
      LENDO = ISFONC(FONACT,'ENDO_NO')       
C      
      IF (LENDO) THEN
        CALL JEVEUO(SDNUME(1:19)//'.ENDO','L',ENDO)
        CALL JEVEUO(CNFINT(1:19)//'.VALE','E',JFINT)
C      
        CALL DISMOI('F','NB_EQUA',NUMEDD,'NUME_DDL',
     &               NEQ,K8BID,IRET)
C      
        ENDOP1 = 0
        ENDOP2 = 0   
C      
        DO 5 I = 1,NEQ
C       
          IF (ZI(ENDO+I-1).EQ.2) THEN
            IF (ZR(JFINT+I-1).GE.0.D0) THEN    
              ENDOP2 = ENDOP2+1                   
              ZR(JFINT+I-1) = 0.D0  
            ELSE
              ENDOP1 = ENDOP1+1
            ENDIF
          ENDIF
C
  5     CONTINUE             
C        WRITE(6,*) 'NB_ENDO_NPROJ=', ENDOP1
C        WRITE(6,*) 'NB_ENDO_PROJ=', ENDOP2
      ENDIF
C
C --- CONTRIBUTIONS DU CONTACT
C          
      IF (LCONT) THEN
        CALL VTAXPY(1.D0,CNCONT,CNFINT)
      ENDIF
C
C --- FORCES ISSUES DES MACRO-ELEMENTS STATIQUES
C         
      IF (LMACR) THEN
        CALL NMCHEX(VEASSE,'VEASSE','CNSSTR',CNSSTR) 
        CALL VTAXPY(1.D0,CNSSTR,CNFINT)        
      ENDIF        
C
C --- AFFICHAGE
C      
      IF (NIV.GE.2) THEN
        CALL NMDEBG('VECT',CNFINT,6)
      ENDIF        
C
      CALL JEDEMA()
      END
