      SUBROUTINE NMASSE(FAMI,KPG,KSP,POUM,ICODMA,MATERI,
     &                  INST,E,NU,DEUXMU,TROISK)

      IMPLICIT NONE
      INTEGER  KPG,KSP,ICODMA
      REAL*8   INST
      REAL*8   E,NU,DEUXMU,TROISK
      CHARACTER*(*) MATERI,FAMI,POUM
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 16/10/2007   AUTEUR SALMONA L.SALMONA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C ----------------------------------------------------------------------
C      VISCO_PLASTICITE FLUAGE SOUS IRRADIATION
C      RECUPERATION DU PARAMETRE VARIABLE (TEMPS)
C      CARACTERISTIQUES ELASTIQUES: YOUNG, POISSON, ALPHA
C
C IN  ICODMA  : ADRESSE DU MATERIAU CODE
C IN  INST    : INSTANT CONSIDERE
C OUT E       : MODULE DE YOUNG
C OUT NU      : COEFFICIENT DE POISSON
C OUT ALPHA   : COEFFICIENT DE DILATATION
C OUT DEUXMU  : COEFFICIENT DE LAME 1
C OUT TROISK  : COEFFICIENT DE LAME 2

      CHARACTER*8       NOMRES(2),NOMPAR
      REAL*8            VALRES(2),VALPAR
      CHARACTER*2       CODRET(2)

      NOMPAR='INST'
      VALPAR=INST
C CARACTERISTIQUES: MODULE D'YOUNG, COEFFICIENT DE POISSON
      NOMRES(1)='E'
      NOMRES(2)='NU'

      CALL RCVALB(FAMI,KPG,KSP,POUM,ICODMA,MATERI,'ELAS',1,NOMPAR,
     +              VALPAR,2,NOMRES,VALRES,CODRET, 'F ' )

      E     = VALRES(1)
      NU    = VALRES(2)

      DEUXMU = E/(1.D0+NU)
      TROISK = E/(1.D0-2.D0*NU)


      END
