      SUBROUTINE NMCMAT(OPER  ,TYPMAZ,OPTCAZ,OPTASZ,LCALC ,
     &                  LASSE ,NBMATR,LTYPMA,LOPTME,LOPTMA,
     &                  LCALME,LASSME)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/12/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*4   OPER      
      CHARACTER*(*) OPTCAZ,OPTASZ,TYPMAZ
      LOGICAL       LASSE,LCALC
      INTEGER       NBMATR    
      CHARACTER*6   LTYPMA(20)
      CHARACTER*16  LOPTME(20),LOPTMA(20)
      LOGICAL       LASSME(20),LCALME(20)
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (CALCUL - UTILITAIRE)
C
C GESTION DE LA LISTE DES MATR_ELEM A CALCULER ET ASSEMBLER
C      
C ----------------------------------------------------------------------
C
C
C IN  OPER   : OPERATION SUR LA LISTE
C                INIT
C                AJOU 
C IN  TYPMAT : TYPE DES MATRICES CONCERNEES
C                MERIGI  - MATRICE POUR RIGIDITE
C                MEDIRI  - MATRICE POUR CL DIRICHLET LAGRANGE
C                MEGEOM  - MATRICE POUR NON-LIN. GEOMETRIQUE
C                MEAMOR  - MATRICE POUR AMORTISSEMENT
C                MEMASS  - MATRICE POUR MASSE    
C                MESUIV  - MATRICE POUR CHARGEMENT SUIVEUR 
C                MESSTR  - MATRICE POUR SOUS-STRUCTURES
C                MECTCC  - MATRICE POUR CONTACT CONTINU 
C                MECTCF  - MATRICE POUR FROTTEMENT CONTINU
C                MEXFEC  - MATRICE POUR CONTACT XFEM
C                MEXFEF  - MATRICE POUR FROTTEMENT XFEM 
C                MEXFTC  - MATRICE POUR CONTACT XFEM (GRD GLIS)
C                MEXFTF  - MATRICE POUR FROTT. XFEM (GRD GLIS)
C IN  OPTCAL : OPTION DE CALCUL DU MATR_ELEM 
C IN  OPTASS : OPTION D'ASSEMBLAGE DU MATR_ASSS 
C IN  LCALC  : LE MATR_ELEM SERA A CALCULER
C IN  LASSE  : LE MATR_ELEM SERA A ASSEMBLER
C I/O NBMATR : NOMBRE DE MATR_ELEM DANS LA LISTE
C I/O LTYPMA : LISTE DES NOMS DES MATR_ELEM 
C I/O LOPTME : LISTE DES OPTIONS DES MATR_ELEM 
C I/O LOPTMA : LISTE DES OPTIONS DES MATR_ASSE
C I/O LCALME : SI MATR_ELEM A CALCULER
C I/O LASSME : SI MATR_ELEM A ASSEMBLER
C      
C ----------------------------------------------------------------------
C
      CHARACTER*16 OPTCAL,OPTASS 
      CHARACTER*6  K6BLA,TYPMAT 
      INTEGER      I
C      
C ----------------------------------------------------------------------
C
         
C
C --- INITIALISATIONS
C
      OPTCAL = OPTCAZ
      OPTASS = OPTASZ
      TYPMAT = TYPMAZ
      K6BLA  = ' '
C
C --- OPERATIONS
C      
      IF (OPER.EQ.'INIT')   THEN
        DO 10 I=1,20
          LTYPMA(I) = K6BLA
  10    CONTINUE      
        NBMATR = 0
      ELSEIF (OPER.EQ.'AJOU')   THEN  
        NBMATR = NBMATR + 1
        IF (NBMATR.EQ.21) THEN
          CALL ASSERT(.FALSE.)
        ENDIF  
        LTYPMA(NBMATR) = TYPMAT
        LOPTME(NBMATR) = OPTCAL
        LOPTMA(NBMATR) = OPTASS
        LASSME(NBMATR) = LASSE   
        LCALME(NBMATR) = LCALC    
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF   
C
      END
