      SUBROUTINE NMCOEF(NOEU1,NOEU2,TYPPIL,NBNO,CNSLN,
     &                  COMPO,VECT,I,N,COEF1,COEF2,COEFI)
     
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 01/02/2011   AUTEUR MASSIN P.MASSIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C TOLE CRS_1404

      IMPLICIT NONE
      INTEGER         NOEU1,NOEU2,NBNO,I,N
      REAL*8          COEF1,COEF2,COEFI
      CHARACTER*8     COMPO      
      CHARACTER*19    CNSLN
C
C ----------------------------------------------------------------------
C CALCUL COEFFICIENT PILOTAGE DU VECTEUR INITIALISATION <S>
C FORMULATION XFEM
C ----------------------------------------------------------------------
C
C
C IN  NOEU1  : EXTREMITE 1 ARETE PILOTEE
C IN  NOEU1  : EXTREMITE 2 ARETE PILOTEE
C IN  TYPPIL : TYPE PILOTAGE
C IN  NBNO   : NOMBRE ARETES EFFECTIVEMENT PILOTEES
C IN  CNSLSN : NOM CHAM_NO_S LEVEL SET NORMALE
C IN  COMPO  : DIRECTION A PILOTER
C IN  VECT   : VECTEUR NORME DE CETTE DIRECTION DANS LA BASE FIXE
C IN  I      : NUMERO COMPOSANTE
C IN  N      : NUMERO ARETE
C OUT  COEF1 : COEF NOEUD 1
C OUT  COEF2 : COEF NOEUD 2
C OUT  COEFI : COEF REPERAGE
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------

      CHARACTER*32       JEXNOM
      INTEGER VALI(2)
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      INTEGER            JLSN,COEFII
      REAL*8             LSN1,LSN2,VECT(3),NBNOR,DENO,R8PREM,EPS
      CHARACTER*32       JEXATR,JEXNUM
      CHARACTER*24       TYPPIL
      LOGICAL            ISDT,ISDN
      
      CALL JEVEUO(CNSLN//'.CNSV','E',JLSN)
      LSN1 = ZR(JLSN-1+NOEU1)
      LSN2 = ZR(JLSN-1+NOEU2)
      EPS  = R8PREM()
      NBNOR=1.D0*NBNO
      IF((ABS(LSN1).LE.EPS).AND.(ABS(LSN2).LE.EPS)) THEN
         COEF1=1.D0
         COEF2=1.D0
         COEFI=0.D0
      ELSE
         DENO = ABS(LSN1) + ABS(LSN2)   
         COEF1= ABS(LSN2)/DENO
         COEF2= ABS(LSN1)/DENO
         COEFII=NBNO*(I-1)+N
         COEFI=COEFII*1.D0
      ENDIF

      IF(TYPPIL.EQ.'SAUT_IMPO') THEN
       IF(COMPO.EQ.'DNOR'.OR.COMPO(1:4).EQ.'DTAN') THEN
            COEF2=2*COEF2*VECT(I)/NBNOR
            COEF1=2*COEF1*VECT(I)/NBNOR
         ELSE
            COEF2=2*COEF2/NBNOR
            COEF1=2*COEF1/NBNOR
         ENDIF
      ELSE IF(TYPPIL.EQ.'SAUT_LONG_ARC') THEN
       IF(COMPO.EQ.'DNOR'.OR.COMPO(1:4).EQ.'DTAN') THEN        
            COEF2=2*COEF2*VECT(I)/SQRT(NBNOR)
            COEF1=2*COEF1*VECT(I)/SQRT(NBNOR)
         ELSE
            COEF2=2*COEF2/SQRT(NBNOR)
            COEF1=2*COEF1/SQRT(NBNOR)    
         ENDIF
      ENDIF
      END
