      SUBROUTINE NMCPL3(COMPOR,OPTION,CRIT,DEPS,DSIDEP,NDIM,SIGP,VIP,
     &                  CPL,ICP,CONV)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/09/2009   AUTEUR PROIX J-M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C ----------------------------------------------------------------------
C     CONTRAINTES PLANES PAR LA METHODE DE BORST / CONDENSATION STATIQUE
C     POUR LES COMPORTEMENTS QUI N'INTEGRENT PAS LES CONTRAINTES PLANES
C     ATTENTION : POUR BIEN CONVERGER, IL FAUT REACTUALISER LA MATRICE
C     TANGENTE. DE PLUS, IL FAUT AJOUTER 4 VARIABLES INTERNES
C
C IN  CRIT    : CRITERES DE CONVERGENCE LOCAUX
C                               (3) = VALEUR TOLERANCE DE CONVERGENCE
C                                     (RESI_INTE_RELA == RESCREL)
C     DEPS    : INCREMENT DE DEFORMATION TOTALE :
C               DEPS(T) = DEPS(MECANIQUE(T)) + DEPS(DILATATION(T))
C     ICP     : NUMERO DE L'ITERATION
C VAR DSIDEP  : MATRICE TANGENTE CARREE
C VAR SIGP    : CONTRAINTES A L'INSTANT ACTUEL
C VAR VIP     : LES 4 DERNIERES SONT RELATIVES A LA METHODE DE BORST 

      IMPLICIT NONE
      CHARACTER*16 OPTION,COMPOR(*)
      INTEGER      K,L,NDIM,NCPMAX,ICP,CPL
      LOGICAL      CONV,VECTEU
      REAL*8       VIP(*),DEPS(*),CRIT(*),DSIDEP(6,6),SIGP(4),SIGPEQ
      REAL*8       PREC,SIGNUL,PRECR,DDEZZ

      VECTEU = OPTION(1:9) .EQ. 'FULL_MECA' .OR. 
     &         OPTION(1:9) .EQ. 'RAPH_MECA'
     
      NCPMAX = NINT(CRIT(9))

      SIGNUL=CRIT(3)
      PREC=CRIT(8)

      CONV = .TRUE.
      
      IF (VECTEU) THEN
      
C       DANS LE CAS D=1 ON NE FAIT RIEN CAR LES CONTRAINTES SONT NULLES
        IF (COMPOR(1).EQ.'ENDO_ISOT_BETON') THEN
           IF (VIP(2).GT.1.5D0) GOTO 9999
        ENDIF
      
        IF (PREC.GT.0.D0) THEN
C PRECISION RELATIVE        
           SIGPEQ=0.D0
           DO 141 K = 1,2*NDIM
             SIGPEQ = SIGPEQ + SIGP(K)**2
 141       CONTINUE
           SIGPEQ = SQRT(SIGPEQ)
           IF (SIGPEQ.LT.SIGNUL) THEN
             PRECR=PREC
           ELSE
             PRECR=PREC*SIGPEQ
           ENDIF
        ELSE
C PRECISION ABSOLUE        
            PRECR=ABS(PREC)
        ENDIF
        CONV = (ICP.GE.NCPMAX .OR. ABS(SIGP(3)).LT.PRECR)   

        IF(.NOT. CONV) THEN
          IF (CPL .EQ. 2) THEN
             IF (ABS(DSIDEP(3,3)).GT.PRECR) THEN 
                DEPS(3) = DEPS(3) - SIGP(3)/DSIDEP(3,3)
             ELSE
                CONV=.TRUE.
             ENDIF
          ELSEIF (CPL .EQ. 1) THEN
             IF (ABS(DSIDEP(2,2)).GT.PRECR) THEN 
                DDEZZ = -(SIGP(3) - DSIDEP(3,2)/DSIDEP(2,2)*SIGP(2))
     &              /(DSIDEP(3,3)- DSIDEP(3,2)*DSIDEP(2,3)/DSIDEP(2,2))
                DEPS(3) = DEPS(3) + DDEZZ
                DEPS(2)=DEPS(2)-(SIGP(2)+DSIDEP(2,3)*DDEZZ)/DSIDEP(2,2)
             ELSE
                CONV=.TRUE.
             ENDIF
          ENDIF  
        ENDIF     
      
      ENDIF
 9999 CONTINUE      
      END
