      FUNCTION NMCRI5(DP)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 27/03/2002   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     ARGUMENTS:
C     ----------
      REAL*8 NMCRI5,DP
C ----------------------------------------------------------------------
C    BUT:  EVALUER LA FONCTION DONT ON CHERCHE LE ZERO
C          POUR LA PLASTICITE DE VON_MISES ISOTROPE + CINEMATIQUE C_PLAN
C
C     IN:  DP     : DEFORMATION PLASTIQUE CUMULEE
C    OUT:  NMCRI5 : CRITERE NON LINEAIRE A RESOUDRE EN DP
C                   (DONT ON CHERCHE LE ZERO)
C                   ICI ON SUPPOSE LE CRITERE DE VON_MISES EN C_PLAN
C
C ----------------------------------------------------------------------
C
C----- COMMONS NECESSAIRES A VON_MISES ISOTROPE + CINEMATIQUE C_PLAN :
C      COMMONS COMMUNS A NMCRI1 ET NMECMI
      COMMON /RCONM5/DEUXMU,TROISK,SIGY,RPRIM,PM,SIGEL,TP2,LINE,PRAG,XM
      COMMON /KCONM1/IMATE2, JPROL2, JVALE2,NBVAL2
C     VARIABLES LOCALES:
C     ------------------
      INTEGER        IMATE2, JPROL2, JVALE2,NBVAL2
      REAL*8         DRDP,PRAG,DUM,HP,FP,GP,HSG,DX,RPP,DEMUC,XM(6)
      REAL*8         DEUXMU,TROISK,SIGY,RPRIM,PM,SIGEL(6),TP2,LINE
C
C DEB-------------------------------------------------------------------
C
      IF (LINE.GE.0.5D0) THEN
        RPP = SIGY +RPRIM*(PM+DP)
      ELSE
        CALL RCFON2('V',JPROL2,JVALE2,NBVAL2,DUM,DUM,DUM,PM+DP,RPP,
     &                  DRDP,PRAG,DUM,DUM)
      END IF
      GP=1.D0+1.5D0*PRAG*DP/RPP
      HP=GP+1.5D0*DEUXMU*DP/RPP
      HSG=HP/GP
      DEMUC=DEUXMU+PRAG
C
      DX=  (HSG-1.D0)* SIGEL(3)
      DX=DX/( DEUXMU/1.5D0 + TROISK*HSG/3.D0 )
C
      FP= (SIGEL(1)-DEUXMU/3.D0*DX)**2 + (SIGEL(2)-DEUXMU/3.D0*DX)**2 +
     +    (SIGEL(3)+DEUXMU/3.D0*2.D0*DX)**2 + SIGEL(4)**2
C
      NMCRI5= 1.5D0*DEMUC*DP - SQRT(1.5D0*FP) + RPP
C
      END
