      FUNCTION NMCRI6(DP)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 15/01/2008   AUTEUR PROIX J-M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2008  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
      IMPLICIT NONE
C
C     ARGUMENTS:
C     ----------
      REAL*8 NMCRI6,DP
C ----------------------------------------------------------------------
C   BUT: EVALUER LA FONCTION DONT ON CHERCHE LE ZERO POUR LA PLASTICITE 
C        DE VON_MISES ISOTROPE AVEC ECROUISSAGE EN PUISSANCE SIMO_MIEHE
C
C    IN: DP     : DEFORMATION PLASTIQUE CUMULEE
C   OUT: NMCRI6 : CRITERE NON LINEAIRE A RESOUDRE EN DP
C                   (DONT ON CHERCHE LE ZERO)
C                   ICI ON SUPPOSE LE CRITERE DE VON_MISES 
C                   AVEC ECROUISSAGE ISOTROPE EN PUISSANCE
C
C ----------------------------------------------------------------------
C     VARIABLES LOCALES:
C     ------------------
      REAL*8 UNSURN,RPP,RPRIM
C
C----- COMMONS NECESSAIRES A VON_MISES ISOTROPE PUISSANCE :
C      COMMONS COMMUNS A NMCRI2 ET NMISOT

      COMMON /RCONM6/MUTRBE,TAUTEQ
      REAL*8  MUTRBE,TAUTEQ

      INTEGER JPROL,JVALE,NBVAL
      REAL*8  PM,YOUNG,NU,MU,UNK,TROISK,COTHER,SIGY
      REAL*8  SIGM0,EPSI0,DT,COEFM,RPM,PENTE,APUI,NPUI
      COMMON /LCPIM/
     &          PM,YOUNG,NU,MU,UNK,TROISK,COTHER,
     &          SIGM0,EPSI0,DT,COEFM,RPM,PENTE,
     &          APUI,NPUI,SIGY,JPROL,JVALE,NBVAL
C
C DEB-------------------------------------------------------------------
C
      UNSURN=1.D0/NPUI
      CALL ECPUIS(YOUNG,SIGY,APUI,UNSURN,PM,DP,RPP,RPRIM)
      NMCRI6= RPP + MUTRBE*DP - TAUTEQ
C
      END
