      SUBROUTINE NMCROB(NOMA  ,NOMO  ,RESULT,FONACT,VALINC,
     &                  SDDYNA,SDOBSE)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 17/01/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      CHARACTER*8  RESULT,NOMA,NOMO
      CHARACTER*19 SDOBSE,SDDYNA    
      CHARACTER*19 VALINC(*)
      INTEGER      FONACT(*)
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (STRUCTURES DE DONNES)
C
C CREATION SD OBSERVATION
C
C ----------------------------------------------------------------------
C
C
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  FONACT : FONCTIONNALITES ACTIVEES (VOIR NMFONC)
C IN  SDDYNA : SD DYNAMIQUE
C IN  NOMA   : NOM DU MAILLAGE 
C IN  NOMO   : NOM DU MODELE
C IN  SDOBSE : NOM DE LA SD POUR OBSERVATION
C IN  RESULT : NOM UTILISATEUR DU RESULTAT
C
C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------
C
      INTEGER      ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8       ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16   ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL      ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8  ZK8
      CHARACTER*16    ZK16
      CHARACTER*24        ZK24
      CHARACTER*32            ZK32
      CHARACTER*80                ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
C
      INTEGER      NMAX
      PARAMETER    (NMAX=99)
      INTEGER      IFM,NIV       
      LOGICAL      NDYNLO,LSTAT,LMUAP,LDYNA
      LOGICAL      ISFONC,LCONT
      INTEGER      NTOBS,NBOCC,VALI(2)
      CHARACTER*19 DEPL,SIGM,VARI,TEMP
      CHARACTER*16 PHENOM
      CHARACTER*16 MOTFAC
C      
C ----------------------------------------------------------------------
C      
      CALL JEMARQ()        
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> ... CREATION SD OBSERVATION'
      ENDIF
C
C --- FONCTIONNALITES ACTIVEES
C
      LSTAT  = NDYNLO(SDDYNA,'STATIQUE')
      LDYNA  = NDYNLO(SDDYNA,'DYNAMIQUE')      
      LMUAP  = NDYNLO(SDDYNA,'MULTI_APPUI')
      LCONT  = ISFONC(FONACT,'CONTACT')      
C
C --- INITIALISATIONS
C
      NTOBS  = 0
      MOTFAC = 'OBSERVATION'
C
C --- NOMBRE OCCURRENCES
C
      CALL GETFAC(MOTFAC,NBOCC)
      IF (NBOCC.GT.NMAX) THEN
        VALI(1) = NBOCC
        VALI(2) = NMAX
        CALL U2MESI('F','OBSERVATION_4',2,VALI)
      ENDIF      
C      
C --- VARIABLES CHAPEAUX
C
      CALL NMCHEX(VALINC,'VALINC','DEPMOI',DEPL  )
      CALL NMCHEX(VALINC,'VALINC','SIGMOI',SIGM  )
      CALL NMCHEX(VALINC,'VALINC','VARMOI',VARI  )
C
C --- PHENOMENE ACTIF
C
      IF (LSTAT) THEN
        PHENOM = 'MEST'
      ELSEIF (LDYNA) THEN
        PHENOM = 'MEDY'
        IF (LMUAP) THEN
          PHENOM = 'MEDY_MUAP'
        ENDIF
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF  
      IF (LCONT) THEN
        PHENOM(10:14) = '_CONT'
      ENDIF      
C
C --- LECTURE DES DONNEES
C
      CALL NMEXTR(NOMA  ,NOMO  ,SDOBSE,PHENOM,DEPL  ,
     &            SIGM  ,VARI  ,TEMP  ,MOTFAC,NBOCC ,
     &            NTOBS ) 
C
C --- CONTROLE
C
      IF (NTOBS.GT.NMAX) THEN
        VALI(1) = NTOBS
        VALI(2) = NMAX
        CALL U2MESI('F','OBSERVATION_4',2,VALI)
      ELSE
        IF (NTOBS.NE.0) THEN
          CALL U2MESI('I','OBSERVATION_3',1,NTOBS)
        ENDIF  
      ENDIF
C
C --- LECTURE LISTES INSTANTS
C
      CALL NMCROI(SDOBSE,MOTFAC,NBOCC )
C 
C --- CREATION DE LA TABLE D'OBSERVATION
C
      CALL NMCROT(RESULT,SDOBSE)
C
      CALL JEDEMA()      

      END
