      SUBROUTINE NMCRTI(SDTIME)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 07/10/2008   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2008  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*24  SDTIME      
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME - INITIALISATIONS)
C
C CREATION DE LA SD TIMER
C      
C ----------------------------------------------------------------------
C 
C
C IN  SDTIME : SD TIMER
C   TIMTMP - TIMER TEMPORAIRE 
C   TIMPAS - TIMER POUR LES PAS DE TEMPS
C   TIMITE - TIMER POUR LES ITERATIONS DE NEWTON
C   TIMARC - TIMER POUR L'ARCHIVAGE
C   TIMCTC - TIMER POUR CONTACT
C   TIMDEB - OBJET CONTENANT LE TEMPS A CHAQUE ARRET D'UN TIMER 
C   TIMVAL - OBJET STOCKANT LES TEMPS MESURES PAR CHACUN DES TIMERS
C   TIMINF - OBJET STOCKANT TEMPS PASSES
C   TIMNBR - OBJET STOCKANT NOMBRE D'OPERATIONS
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      INTEGER      NBTIME,NBINFR,NBINFI
      PARAMETER    (NBTIME=4,NBINFR=20,NBINFI=22)
C
      INTEGER      IFM,NIV
      CHARACTER*24 TIMPAS,TIMITE,TIMARC,TIMVAL,TIMTMP,TIMDEB
      INTEGER      JTPAS,JTITE,JTARC,JTVAL,JTTMP,JTDEB      
      CHARACTER*24 TIMINR,TIMINI
      INTEGER      JTINFR,JTINFI 
      LOGICAL      LBID
      REAL*8       R8BID                 
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> ... CREATION SD TIMER' 
      ENDIF   
C
C --- NOM DES SDS
C
      TIMTMP = SDTIME(1:19)//'.TEMP'
      TIMPAS = SDTIME(1:19)//'.TPAS'
      TIMITE = SDTIME(1:19)//'.TITE'
      TIMARC = SDTIME(1:19)//'.TARC'
      TIMDEB = SDTIME(1:19)//'.TDEB'      
      TIMVAL = SDTIME(1:19)//'.TVAL'
      TIMINR = SDTIME(1:19)//'.TINR'       
      TIMINI = SDTIME(1:19)//'.TINI'                
C
C --- CREATION SD 
C --- TIMERS: PAS/ITERATION/ARCHIVAGE/AUTRES
C 
      CALL WKVECT(TIMPAS,'V V R',4,JTPAS)
      CALL WKVECT(TIMITE,'V V R',4,JTITE)
      CALL WKVECT(TIMARC,'V V R',4,JTARC)
      CALL WKVECT(TIMTMP,'V V R',4,JTTMP)
C
C --- STOCKAGE TEMPS INITIAL POUR LES NBTIME TIMERS
C             
      CALL WKVECT(TIMDEB,'V V R',NBTIME,JTDEB) 
C
C --- STOCKAGE VALEUR POUR LES NBTIME TIMERS
C           
      CALL WKVECT(TIMVAL,'V V R',NBTIME,JTVAL) 
C
C --- STOCKAGE INFOS DIVERSES REELS 
C --- TIMINR(1) : TEMPS SUR LE PAS COURANT DANS LA CREATION NUME_DDL
C --- TIMINR(2) : TEMPS SUR LE PAS COURANT DANS LA FACTORISATION
C --- TIMINR(3) : TEMPS SUR LE PAS COURANT DANS L'INTEGRATION LDC
C --- TIMINR(4) : TEMPS SUR LE PAS COURANT DANS LA RESOLUTION
C --- TIMINR(5) : TEMPS SUR LE PAS COURANT DANS LE CONTACT/GEOM
C --- TIMINR(6) : TEMPS SUR LE PAS COURANT DANS LA CONTACT/ALGO
C --- TIMINR(7-12) : IDEM (1->6), CUMULE SUR TOUS LES PAS DE TEMPS
C       
      CALL WKVECT(TIMINR,'V V R',NBINFR,JTINFR) 
C
C --- STOCKAGE INFOS DIVERSES ENTIERS 
C --- TIMINI(1) : NOMBRE (PAS COURANT) DE CREATION NUME_DDL
C --- TIMINI(2) : NOMBRE (PAS COURANT) DE FACTORISATION
C --- TIMINI(3) : NOMBRE (PAS COURANT) D'INTEGRATION LDC
C --- TIMINI(4) : NOMBRE (PAS COURANT) DE RESOLUTION
C --- TIMINI(5) : NOMBRE (PAS COURANT) D'ITERATIONS DE NEWTON
C --- TIMINI(6) : NOMBRE (PAS COURANT) D'ITERATIONS DE RECH. LINEAIRE
C --- TIMINI(7) : NOMBRE (PAS COURANT) D'ITERATIONS DE FETI
C --- TIMINI(8) : NOMBRE (PAS COURANT) D'ITERATIONS DE CONT. GEOM.
C --- TIMINI(9) : NOMBRE (PAS COURANT) D'ITERATIONS DE CONT. ALGO.
C --- TIMINI(10): NOMBRE (PAS COURANT) D'ITERATIONS DE CONT. FROT.
C --- TIMINI(11-20) : IDEM (1->10), CUMULE SUR TOUS LES PAS DE TEMPS
C --- TIMINI(21): NOMBRE DE PAS DE TEMPS
C         
      CALL WKVECT(TIMINI,'V V I',NBINFI,JTINFI)      
C
C --- INITIALISATION DES TIMERS
C
      CALL NMTIME('INIT','ALL',SDTIME,LBID  ,R8BID )     
C
      CALL JEDEMA()
      END
