      SUBROUTINE NMCTCG(MODELE,NOMA  ,DEFICO,RESOCO,SDDISC,
     &                  NUMEDD,LNOPRE)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2011   AUTEUR MACOCCO K.MACOCCO 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      LOGICAL      LNOPRE
      CHARACTER*8  NOMA
      CHARACTER*24 MODELE
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*19 SDDISC
      CHARACTER*24 NUMEDD
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGO - BOUCLE CONTACT)
C
C BOUCLE GEOMETRIQUE: REALISE L'APPARIEMENT ENTRE SURFACE ESCLAVE ET
C SURFACE MAITRE
C
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  MODELE : NOM DU MODELE
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  RESOCO : SD POUR LA RESOLUTION DE CONTACT
C IN  NUMEDD : NOM DU NUME_DDL
C IN  LNOPRE : .TRUE. SI ON DOIT SAUTER LA PREDICTION
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      IFM,NIV
      LOGICAL      PREMIE
      INTEGER      IRET
      CHARACTER*8  NOMO
      INTEGER      CFDISI,IFORM
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECANONLINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*)
     &     '<MECANONLINE> BOUCLE DE REACTUALISATION GEOMETRIQUE'
      ENDIF
C
C --- PREMIER INSTANT ?
C
      CALL DIBCLE(SDDISC,'PREMIE','L',IRET  )
      PREMIE = IRET.EQ.0
C
C --- INITIALISATIONS
C
      NOMO   = MODELE(1:8)
C
C --- TYPE DE CONTACT
C
      IFORM  = CFDISI(DEFICO,'FORMULATION')
C
C --- REACTUALISATION DE LA GEOMETRIE
C
      IF (IFORM.EQ.3) THEN
        CALL XREACG(NOMO  ,NOMA  ,DEFICO,RESOCO)
        CALL XAPPAR(PREMIE,NOMA  ,NOMO,DEFICO,RESOCO)
      ELSEIF (IFORM.EQ.2) THEN
        CALL MREACG(NOMA  ,RESOCO)
        CALL MMAPPA(PREMIE,NOMA  ,NUMEDD,DEFICO,RESOCO)
      ELSEIF (IFORM.EQ.1) THEN
        CALL CFINIG(RESOCO,LNOPRE)
      ENDIF
C
      CALL JEDEMA()
      END
