      SUBROUTINE NMDCEA(SDDISC,NUMINS,NBRPAS,FREARC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/02/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*19 SDDISC
      INTEGER      NBRPAS,NUMINS,FREARC
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME - DECOUPE)
C
C EXTENSION D'ARCHIVAGE
C
C ----------------------------------------------------------------------
C
C
C IN  SDDISC : SD DISCRETISATION
C IN  NUMINS : NUMERO D'INSTANT
C IN  NBRPAS : NOMBRE DE PAS A CREER
C IN  FREARC : FREQUENCE ARCHIVAGE
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C 
      INTEGER      INSPAS,LGINI,NBINI,LGTEMP,I,NBTEMP,IBID
      CHARACTER*24 TPSDIA
      INTEGER      JARCH
      CHARACTER*8  K8BID      
      CHARACTER*16 METLIS      
      REAL*8       R8B
C      
C ----------------------------------------------------------------------
C
      CALL JEMARQ()

      CALL UTDIDT('L',SDDISC,'LIST',IBID,'METHODE',R8B,IBID,METLIS)
C
C --- ACCES SD LISTE D'INSTANTS
C         
      TPSDIA = SDDISC(1:19)//'.DIAL'               
C
C --- LONGUEUR INITIALE DE LA LISTE D'INSTANTS
C
      CALL JELIRA(TPSDIA,'LONMAX',LGINI,K8BID)
      NBINI  = LGINI  - 1
C
C --- NOUVEAU NOMBRE D'INSTANTS
C    
      INSPAS = NBRPAS - 1
      IF (METLIS.EQ.'AUTO') INSPAS = 1
      LGTEMP = LGINI  + INSPAS
      NBTEMP = LGTEMP - 1
C
C --- ALLONGEMENT DE LA LISTE D'ARCHIVAGE
C
      CALL JUVECA(TPSDIA,LGTEMP)
      CALL JEVEUO(TPSDIA,'E',JARCH)         
C      
C --- AUCUN ARCHIVAGE SUPPLEMENTAIRE SI PAS_ARCH == 0
C
      IF (FREARC .EQ. 0) THEN
        DO 30 I = NBINI, NUMINS, -1
          ZL(JARCH+I+INSPAS) = ZL(JARCH+I)
30      CONTINUE
        DO 40 I = NUMINS, NUMINS+INSPAS-1
          ZL(JARCH+I) = .FALSE.
40      CONTINUE
C
C --- ON RECONSTRUIT LA LISTE D'ARCHIVAGE SI PAS_ARCH <> 0
C
      ELSE
        DO 50 I = 0, NBTEMP
          ZL(JARCH+I) = .FALSE.
50      CONTINUE
        DO 60 I = FREARC, NBTEMP, FREARC
          ZL(JARCH+I) = .TRUE.
60      CONTINUE
      END IF       
C
      CALL JEDEMA()
      END
