      SUBROUTINE NMDOCT(LISCHA,DEFICO,DEFICU,LCONT ,LUNIL ,
     &                  LIGRCF,LIGRXF)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 19/10/2010   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*24 DEFICO
      CHARACTER*24 DEFICU     
      CHARACTER*19 LISCHA
      LOGICAL      LCONT,LUNIL
      CHARACTER*19 LIGRCF,LIGRXF
C
C ----------------------------------------------------------------------
C
C ROUTINE UTILITAIRE
C
C SAISIE ET VERIFICATION DE LA COHERENCE DU CHARGEMENT CONTACT
C
C ----------------------------------------------------------------------
C
C
C OUT DEFICO : NOM DE LA SD DEFINITION DU CONTACT
C OUT DEFICU : NOM DE LA SD DEFINITION DE LIAISON_UNILATER
C I/O LISCHA : LISTE DES CHARGES
C OUT LCONT  : IL Y A DU CONTACT
C OUT LUNIL  : IL Y A LIAISON_UNILATER
C OUT LIGRCF : NOM DU LIGREL TARDIF POUR ELEMENTS DE CONTACT CONTINUE
C OUT LIGRXF : NOM DU LIGREL TARDIF POUR ELEMENTS DE CONTACT XFEM GG
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      CHARACTER*16 MOTCLE
      INTEGER      NOCC,NCHAR1,NCHAR2,ICH,IER,IATYPE
      CHARACTER*8  CHARCO
      INTEGER      IFORM,CFDISI,IVAL1,IVAL2
      CHARACTER*8  LIGRET,LIGREL,LIGRXT
      CHARACTER*19 LISCH2
      CHARACTER*24 INFCH1
      INTEGER      JINFC1
      CHARACTER*8  NOMCH1,NOMFC1,FCTCST
      CHARACTER*24 INFOC2
      REAL*8       COEF 
      LOGICAL      LTFCM,CFDISL    
C --- NOMBRE MAXIMUM DE TYPE_INFO
      INTEGER      NBINMX,NBINFO
      PARAMETER   (NBINMX=99) 
      CHARACTER*24 LISINF(NBINMX)              
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      MOTCLE = 'CONTACT'
      LISCH2 = '&&NMDOCT.LISCHA'
      LIGRCF = ' '
      LIGRXF = ' '
      LCONT  = .FALSE.
      LUNIL  = .FALSE.
C     
C --- ANCIENNE SD L_CHARGES
C
      INFCH1 = LISCHA(1:19)//'.INFC'
      CALL JEVEUO(INFCH1,'L',JINFC1)       
      NCHAR1 = ZI(JINFC1)
      NCHAR2 = NCHAR1
C
C --- FONCTION CONSTANTE
C
      FCTCST = '&&NMDOCT' 
      COEF   = 1.D0
      CALL FOCSTE(FCTCST,'TOUTRESU',COEF  ,'V')    
C
C --- RECUPERATION DU NOM DU CHARGEMENT DE CONTACT
C      
      CALL GETVID(' ',MOTCLE,1,1,1,CHARCO,NOCC  )
      IF (NOCC.LE.0) THEN
        DEFICO = '&&OP0070.DEFIC'
        GOTO 999
      ENDIF     
C
C --- NOM DE LA SD DE DEFINITION DU CONTACT
C
      DEFICO = CHARCO(1:8)//'.CONTACT' 
      DEFICU = CHARCO(1:8)//'.UNILATE'
C
C --- FORMULATION
C
      IFORM  = CFDISI(DEFICO,'FORMULATION')
      IF (IFORM.EQ.4) THEN
        LUNIL  = .TRUE.
      ELSE
        LCONT  = .TRUE.
      ENDIF
      LTFCM  = CFDISL(DEFICO,'CONT_XFEM_GG')
C
C --- LIGREL ELEMENTS TARDIFS - METHODE CONTINUE
C
      IF (IFORM.EQ.2) THEN
        LIGRET = CHARCO(1:8)
        LIGRCF = '&&LIGRCF.CHME.LIGRE'
        CALL WKVECT(LIGRCF(1:8)//'.TYPE','V V K8',1,IATYPE)
        ZK8(IATYPE) = 'ME'
        NCHAR2 = NCHAR2+2
      ENDIF
C
C --- LIGREL ELEMENTS TARDIFS - XFEM GRANDS GLISSEMENTS
C
      IF (LTFCM) THEN
        LIGRXT = CHARCO(1:8)
        LIGRXF = '&&LIGRXF.CHME.LIGRE'
        CALL WKVECT(LIGRXF(1:8)//'.TYPE','V V K8',1,IATYPE)
        ZK8(IATYPE) = 'ME'
        NCHAR2 = NCHAR2+2
      ENDIF      
C
C --- EVENTUELLES RELATIONS LINEAIRES - METHODES DISCRETES
C
      IF (IFORM.EQ.1) THEN
        LIGREL = CHARCO(1:8)
        CALL JEEXIN(LIGREL//'.CHME.LIGRE.LGRF',IER   )
        IF (IER.NE.0) THEN
          NCHAR2 = NCHAR2+1
        ENDIF
      ENDIF 
C
      IF (NCHAR2.NE.NCHAR1) THEN      
        CALL LISCCR(LISCH2,NCHAR2,'V')

        DO 24 ICH=1,NCHAR1
          NBINFO = NBINMX
          CALL LISCLI(LISCHA,ICH   ,NOMCH1,NOMFC1,NBINFO,
     &                LISINF,IVAL1 )
          CALL LISCAD(LISCH2,ICH   ,NOMCH1,NOMFC1,NBINFO,
     &                LISINF,IVAL1 )
   24   CONTINUE
C   
        IF (IFORM.EQ.2) THEN
          INFOC2 = 'ELEM_TARDIF'
          IVAL2  = 0
          NBINFO = 1
          CALL LISCAD(LISCH2,NCHAR1+1 ,LIGRET,FCTCST,NBINFO,
     &                INFOC2,IVAL2 )
                      
          CALL LISCAD(LISCH2,NCHAR1+2 ,LIGRCF(1:8),FCTCST,NBINFO,
     &                INFOC2,IVAL2 )     
        ENDIF
C
        IF (IFORM.EQ.1) THEN
          IF (IER.NE.0) THEN
            INFOC2 = 'DIRI_CSTE'
            IVAL2  = 0
            NBINFO = 1
            CALL LISCAD(LISCH2,NCHAR1+1 ,LIGREL,FCTCST,NBINFO,
     &                  INFOC2,IVAL2 )
          ENDIF        
        ENDIF
C   
        IF (IFORM.EQ.3) THEN
          IF (LTFCM) THEN
            INFOC2 = 'ELEM_TARDIF'
            IVAL2  = 0
            NBINFO = 1
            CALL LISCAD(LISCH2,NCHAR1+1 ,LIGRXT,FCTCST,NBINFO,
     &                  INFOC2,IVAL2 )
            CALL LISCAD(LISCH2,NCHAR1+2 ,LIGRXF(1:8),FCTCST,NBINFO,
     &                  INFOC2,IVAL2 )  
          ENDIF    
        ENDIF        
        
        
        CALL LISCCR(LISCHA,NCHAR2,'V')
        CALL COPISD(' ','V',LISCH2,LISCHA)
        CALL DETRSD('LISTE_CHARGES',LISCH2)
        
      ENDIF    
C      
  999 CONTINUE 
C
      CALL JEDEMA()
      END
