      SUBROUTINE NMEXTD(NOMCHA,RESOCO,DEPPLU,VITPLU,ACCPLU,
     &                  SIGPLU,VARPLU,DEPENT,VITENT,ACCENT,
     &                  TEMP  ,CNFINT,CHAMP )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 28/03/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE 
      CHARACTER*24 NOMCHA
      CHARACTER*24 RESOCO
      CHARACTER*19 CHAMP
      CHARACTER*19 DEPPLU,SIGPLU,VARPLU,ACCPLU,VITPLU
      CHARACTER*19 DEPENT,VITENT,ACCENT,CNFINT
      CHARACTER*19 TEMP     
C 
C ----------------------------------------------------------------------
C
C ROUTINE *_NON_LINE (EXTRACTION - UTILITAIRE)
C
C CHOISIR LE CHAMP ACTIF POUR L'EXTRACTION 
C      
C ----------------------------------------------------------------------
C
C
C IN  NOMCHA : NOM DU CHAMP
C IN  RESOCO : SD POUR LA RESOLUTION DE CONTACT
C IN  DEPPLU : DEPLACEMENT
C IN  VITPLU : VITESSE
C IN  ACCPLU : ACCELERATION
C IN  SIGPLU : CONTRAINTES
C IN  VARPLU : VARIABLES INTERNES
C IN  DEPENT : DEPLACEMENT D'ENTRAINEMENT (MULTI-APPUI)
C IN  VITENT : VITESSE D'ENTRAINEMENT (MULTI-APPUI)
C IN  ACCENT : ACCELERATION D'ENTRAINEMENT (MULTI-APPUI)
C IN  CNFINT : VECT_ASSE DES FORCES INTERNES
C IN  TEMP   : TEMPERATURE
C OUT CHAMP  : NOM DU CHAMP
C
C ----------------------------------------------------------------------
C
      IF ( NOMCHA .EQ. 'DEPL' ) THEN
        CHAMP  = DEPPLU
      ELSEIF ( NOMCHA .EQ. 'VITE' ) THEN
        CHAMP  = VITPLU
      ELSEIF ( NOMCHA .EQ. 'ACCE' ) THEN
        CHAMP  = ACCPLU
      ELSEIF ( NOMCHA .EQ. 'FORC_NODA' ) THEN
        CHAMP  = CNFINT       
      ELSEIF ( NOMCHA .EQ. 'DEPL_ABSOLU' ) THEN
        CHAMP  = DEPENT
      ELSEIF ( NOMCHA .EQ. 'VITE_ABSOLU' ) THEN
        CHAMP  = VITENT
      ELSEIF ( NOMCHA .EQ. 'ACCE_ABSOLU' ) THEN
        CHAMP  = ACCENT
      ELSEIF ( NOMCHA .EQ. 'VALE_CONT' ) THEN
        CHAMP = RESOCO(1:14)//'.CONT'
      ELSEIF ( NOMCHA .EQ. 'SIEF_ELGA' ) THEN
        CHAMP  = SIGPLU
      ELSEIF ( NOMCHA .EQ. 'VARI_ELGA' ) THEN
        CHAMP  = VARPLU
      ELSEIF ( NOMCHA .EQ. 'TEMP' ) THEN
        CHAMP  = TEMP
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF

      END
