      SUBROUTINE NMFCOR(MODELE,NUMEDD,MATE  ,CARELE,COMREF,
     &                  COMPOR,LISCHA,FONACT,PARMET,CARCRI,
     &                  METHOD,NUMINS,ITERAT,SDDISC,SDDYNA,
     &                  SDSENS,SDTIME,SDNUME,DEFICO,RESOCO,
     &                  RESOCU,PARCON,VALINC,SOLALG,VEELEM,
     a                  VEASSE,MEELEM,MEASSE,LICCVG)
C     
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/02/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C TOLE CRP_21
C
      IMPLICIT NONE
      INTEGER      FONACT(*)
      INTEGER      ITERAT,LICCVG(*),NUMINS
      REAL*8       PARMET(*)
      REAL*8       PARCON(8)
      CHARACTER*16 METHOD(*)
      CHARACTER*19 SDDISC,SDDYNA,SDNUME
      CHARACTER*19 LISCHA
      CHARACTER*24 MODELE,NUMEDD,MATE,CARELE,COMREF,COMPOR
      CHARACTER*24 CARCRI,SDTIME,SDSENS
      CHARACTER*19 MEELEM(*),VEELEM(*),MEASSE(*),VEASSE(*)
      CHARACTER*19 SOLALG(*),VALINC(*)
      CHARACTER*24 DEFICO,RESOCU,RESOCO
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C MISE A JOUR DES EFFORTS APRES CALCUL DE LA CORRECTION DES CHAMPS
C DEPLACEMENTS/VITESSES ACCELERATIONS
C      
C ----------------------------------------------------------------------
C
C
C IN  MODELE : MODELE
C IN  NUMEDD : NUME_DDL
C IN  MATE   : CHAMP MATERIAU
C IN  CARELE : CARACTERISTIQUES DES ELEMENTS DE STRUCTURE
C IN  COMREF : VARI_COM DE REFERENCE
C IN  COMPOR : COMPORTEMENT
C IN  LISCHA : L_CHARGES
C IN  FONACT : FONCTIONNALITES ACTIVEES
C IN  SDTIME : SD TIMER
C IN  PARMET : PARAMETRES DES METHODES DE RESOLUTION
C IN  CARCRI : PARAMETRES DES METHODES D'INTEGRATION LOCALES
C IN  METHOD : INFORMATIONS SUR LES METHODES DE RESOLUTION
C IN  ITERAT : NUMERO D'ITERATION DE NEWTON
C IN  NUMINS : NUMERO D'INSTANT
C IN  SDDISC : SD DISCRETISATION
C IN  SDDYNA : SD DYNAMIQUE
C IN  SDSENS : SD SENSIBILITE
C IN  DEFICO : SD DEFINITION CONTACT
C IN  RESOCO : SD RESOLUTION CONTACT
C IN  RESOCU : SD RESOLUTION LIAISON_UNILATERALE
C IN  PARCON : PARAMETRES DU CRITERE DE CONVERGENCE REFERENCE
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C IN  VEELEM : VARIABLE CHAPEAU POUR NOM DES VECT_ELEM
C IN  VEASSE : VARIABLE CHAPEAU POUR NOM DES VECT_ASSE
C IN  MEELEM : VARIABLE CHAPEAU POUR NOM DES MATR_ELEM
C IN  MEASSE : VARIABLE CHAPEAU POUR NOM DES MATR_ASSE
C IN  SDNUME : SD NUMEROTATION
C OUT LICCVG : CODES RETOURS 
C                  (2) LOI DE COMPORTEMENT
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      LOGICAL      LCFINT,LCRIGI,LCDIRI  
      CHARACTER*24 CODERE
      CHARACTER*19 VEFINT,VEDIRI,CNFINT,CNDIRI
      CHARACTER*19 DEPPLU,VITPLU,ACCPLU
      CHARACTER*16 OPTION
      LOGICAL      ISFONC,LCTCD,LUNIL 
      INTEGER      LDCCVG
      INTEGER      IFM,NIV  
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> CORRECTION DES FORCES' 
      ENDIF 
C
C --- INITIALISATIONS
C       
      LDCCVG = LICCVG(2)
C
C --- FONCTIONNALITES ACTIVEES
C    
      LUNIL  = ISFONC(FONACT,'LIAISON_UNILATER')
      LCTCD  = ISFONC(FONACT,'CONT_DISCRET')               
      LDCCVG = 0
C
C --- DECOMPACTION DES VARIABLES CHAPEAUX
C
      CALL NMCHEX(VALINC,'VALINC','DEPPLU',DEPPLU)
      CALL NMCHEX(VALINC,'VALINC','VITPLU',VITPLU)
      CALL NMCHEX(VALINC,'VALINC','ACCPLU',ACCPLU)
      CALL NMCHEX(VEELEM,'VEELEM','CNDIRI',VEDIRI)
      CALL NMCHEX(VEELEM,'VEELEM','CNFINT',VEFINT)
      CALL NMCHEX(VEASSE,'VEASSE','CNDIRI',CNDIRI)
      CALL NMCHEX(VEASSE,'VEASSE','CNFINT',CNFINT)
C
C --- CALCUL DES CHARGEMENTS VARIABLES AU COURS DU PAS DE TEMPS
C
      CALL NMCHAR('VARI','CORRECTION'   ,
     &            MODELE,NUMEDD,MATE  ,CARELE,COMPOR,
     &            LISCHA,CARCRI,NUMINS,SDDISC,PARCON,
     &            FONACT,DEFICO,RESOCO,RESOCU,COMREF,
     &            VALINC,SOLALG,VEELEM,MEASSE,VEASSE,
     &            SDSENS,SDDYNA)      
C
C --- OPTION POUR MERIMO
C
      CALL NMCHFI(PARMET,METHOD,FONACT,SDDISC,SDDYNA,
     &            NUMINS,ITERAT,DEFICO,LCFINT,LCDIRI,
     &            LCRIGI,OPTION)
C
C --- CALCUL DES FORCES DE CONTACT ET LIAISON_UNILATER
C
      IF (LCTCD.OR.LUNIL) THEN
        CALL NMCTCD(MODELE,MATE  ,CARELE,FONACT,COMPOR,
     &              CARCRI,SDDISC,SDDYNA,NUMINS,VALINC,
     &              SOLALG,LISCHA,COMREF,DEFICO,RESOCO,
     &              RESOCU,NUMEDD,PARCON,SDSENS,VEELEM,
     &              VEASSE,MEASSE)
      ENDIF            
C
C --- CALCUL DES FORCES INTERNES ET DE LA RIGIDITE SI NECESSAIRE
C
      IF (LCFINT) THEN       
        IF (LCRIGI) THEN                
          CALL NMRIGI(MODELE,MATE  ,CARELE,COMPOR,CARCRI,
     &                SDDYNA,SDTIME,FONACT,ITERAT,VALINC,
     &                SOLALG,LISCHA,COMREF,MEELEM,VEELEM,
     &                OPTION,LDCCVG,CODERE)    
        ELSE 
          CALL NMFINT(MODELE,MATE  ,CARELE,COMREF,COMPOR,
     &                LISCHA,CARCRI,FONACT,ITERAT,SDDYNA,
     &                SDTIME,VALINC,SOLALG,LDCCVG,CODERE,
     &                VEFINT)                  
C       RECOPIE CODE RETOUR ERREUR LOI DE COMPORTEMENT
        LICCVG(2) = LDCCVG
        ENDIF             
      ENDIF
C
C --- ASSEMBLAGE DES FORCES INTERIEURES 
C     
      IF (LCFINT) THEN      
        CALL NMAINT(NUMEDD,FONACT,DEFICO,VEASSE,VEFINT,
     &              CNFINT,SDNUME)
      ENDIF           
C
C --- CALCUL ET ASSEMBLAGE DES REACTIONS D'APPUI BT.LAMBDA
C      
      IF (LCDIRI) THEN  
        CALL NMDIRI(MODELE,MATE  ,CARELE,LISCHA,SDDYNA,
     &              DEPPLU,VITPLU,ACCPLU,VEDIRI)
        CALL NMADIR(NUMEDD,FONACT,DEFICO,VEASSE,VEDIRI,
     &              CNDIRI)              
      ENDIF         
C
C --- RECOPIE CODE RETOUR ERREUR LOI DE COMPORTEMENT
C 
      LICCVG(2) = LDCCVG
C      
      CALL JEDEMA()
      END
