      FUNCTION NMFEDD(DR)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 02/02/2010   AUTEUR SELLENET N.SELLENET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
      IMPLICIT NONE
C
C     ARGUMENTS:
C     ----------
      REAL*8 NMFEDD,DR
C ----------------------------------------------------------------------
C    BUT:  EVALUER LA DERIVEE DE LA FONCTION DONT ON CHERCHE LE ZERO
C          POUR VENDOCHAB
C
C     IN:  DR     : DEFORMATION PLASTIQUE CUMULEE*(1-D)
C    OUT:  NMFEDD : DERIVEE
C
C ----------------------------------------------------------------------
C     VARIABLES LOCALES:
C     ------------------
C TOLE CRP_4
C----- COMMONS NECESSAIRES A VENDOCHAB
      COMMON   /FVENDO/MU,SYVP,KVP,RM,DM,SEQE,AD,DT,RD,IR,UNSURN,UNSURM
      REAL*8    MU,SYVP,KVP,RM,DM,SEQE,AD,DT,UNSURN,UNSURM
      REAL*8    DD,RD,R8MIEM,ARG,RMAX,UNMD,DTN,PUIS,EPSI,R8PREM
      REAL*8    GPRIME, DPRIME, COEF,GDER
      INTEGER*8 IR
C      EPSI=R8PREM()
      EPSI=1.D-8
C
      DTN=DT**UNSURN
C
      IF (DR.LT.R8MIEM()) THEN
         GDER=0.D0
         GPRIME=0.D0
         DD=0.D0
         DPRIME=0.D0
      ELSE
         GDER=KVP*(DR**UNSURN)*((RM+DR)**UNSURM)+SYVP*DTN
         PUIS=1.D0-RD*UNSURN
         DD=(DT**PUIS)*((GDER/AD)**RD)
         IF (UNSURM.GT.EPSI) THEN
            GPRIME=(KVP*UNSURN)*(DR**(UNSURN-1.D0))*((RM+DR)**UNSURM)
     &             +KVP*(DR**UNSURN)*((RM+DR)**(UNSURM-1.D0))*UNSURM
         ELSE
            GPRIME=(KVP*UNSURN)*(DR**(UNSURN-1.D0))
         ENDIF
         COEF=RD*(DT**(1.D0-RD*UNSURN))/(AD**RD)
         DPRIME=COEF*GDER**(RD-1.D0)*GPRIME
      ENDIF
      UNMD=1.D0-DM-DD
      NMFEDD= GPRIME*UNMD-DPRIME*GDER+3.D0*MU*DTN+DPRIME*SEQE*DTN
C
 9999 CONTINUE
      END
