      SUBROUTINE NMFIFN(NNO,NDDL,NPG,WREF,VFF,DFDE,
     &                  GEOM,SIGMA,FINT)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 12/03/2007   AUTEUR LAVERNE J.LAVERNE 
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C ======================================================================
C COPYRIGHT (C) 2007 NECS - BRUNO ZUBER   WWW.NECS.FR
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

      IMPLICIT NONE
      INTEGER NNO,NDDL,NPG
      REAL*8  WREF(NPG),VFF(NNO,NPG),DFDE(2,NNO,NPG)
      REAL*8  GEOM(NDDL),FINT(NDDL),SIGMA(3,NPG)
C-----------------------------------------------------------------------
C  FORCES NODALES POUR LES JOINTS 3D (TE0207)
C-----------------------------------------------------------------------
C IN  NNO    NOMBRE DE NOEUDS DE LA FACE (*2 POUR TOUT L'ELEMENT)
C IN  NDDL   NOMBRE DE DEGRES DE LIBERTE EN DEPL TOTAL (3 PAR NOEUDS)
C IN  NPG    NOMBRE DE POINTS DE GAUSS 
C IN  WREF   POIDS DE REFERENCE DES POINTS DE GAUSS
C IN  VFF    VALEUR DES FONCTIONS DE FORME (DE LA FACE)
C IN  DFDE   DERIVEE DES FONCTIONS DE FORME (DE LA FACE)
C IN  GEOM   COORDONNEES DES NOEUDS
C IN  SIGMA  CONTRAINTES LOCALES AUX POINTS DE GAUSS (SIGN, SITX, SITY)
C OUT FINT   FORCES NODALES
C-----------------------------------------------------------------------
      INTEGER NI,KPG
      REAL*8  B(3,60),POIDS
      REAL*8  DDOT
C-----------------------------------------------------------------------


      CALL R8INIR(NDDL,0.D0,FINT,1)


      DO 10 KPG=1,NPG
      
        CALL NMFICI(NNO,NDDL,WREF(KPG),VFF(1,KPG),
     &              DFDE(1,1,KPG),GEOM,POIDS,B)
        
        DO 20 NI=1,NDDL
        
          FINT(NI) = FINT(NI) + POIDS*DDOT(3,B(1,NI),1,SIGMA(1,KPG),1)
          
 20     CONTINUE
 
 10   CONTINUE

      END
