      SUBROUTINE NMIMP0(SDIMPR,SEPARA,LIGNE ,COLONN,TITRE )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/12/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT      NONE
      CHARACTER*24  SDIMPR
      CHARACTER*(*) LIGNE,COLONN,TITRE(3)
      CHARACTER*1   SEPARA  
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (AFFICHAGE)
C
C CREATION DES OBJETS D'AFFICHAGE
C      
C ----------------------------------------------------------------------
C      
C
C IN  SDIMPR : SD AFFICHAGE
C IN  SEPARA : SEPARATEUR ENTRE LES COLONNES
C OUT LIGNE  : LIGNE DE SEPARATION DANS LE TABLEAU
C OUT COLONN : LIGNE DU TABLEAU AVEC SEPARATION COLONNES
C OUT TITRE  : LIGNE DE TITRE DU TABLEAU AVEC SEPARATION COLONNES
C
C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
C
      INTEGER          ZLAR,ZLIG
      PARAMETER       (ZLAR = 16,ZLIG = 255)
C 
      INTEGER          POS
      INTEGER          I,K,ICOL,IBID 
      CHARACTER*24     IMPINF
      INTEGER          JIMPIN
      INTEGER          NCOL,LARGE
      CHARACTER*(ZLAR) TITCOL(3)    
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- RECUPERATION DES PARAMETRES
C
      IMPINF = SDIMPR(1:14)//'.INFO'
      CALL JEVEUO(IMPINF,'L',JIMPIN)
C
      NCOL   = ZI(JIMPIN-1+1)
      LARGE  = ZI(JIMPIN-1+2)
      CALL ASSERT(ZLAR.EQ.16)
      CALL ASSERT(ZLIG.EQ.255)
C
C --- INITIALISATIONS
C
      DO 21 I = 1,ZLIG
        TITRE(1)(I:I)  = ' '
        TITRE(2)(I:I)  = ' '
        TITRE(3)(I:I)  = ' '
        COLONN(I:I)    = ' '
        LIGNE(I:I)     = ' '
 21   CONTINUE
C
C --- LIGNE DE SEPARATION
C
      DO 22 I = 1,LARGE
        LIGNE(I:I) = '-'
 22   CONTINUE
C
C --- MARQUAGE DES COLONNES PAR LES TRAITS VERTICAUX
C --- (LARGEUR D'UNE COLONNE FIXEE PAR ZLAR)
C
      DO 23 I = 1,LARGE
       IF (MOD(I-1,ZLAR+1) .EQ. 0) THEN
         COLONN(I:I) = SEPARA
       ELSE
         COLONN(I:I) = ' '
       END IF
 23   CONTINUE
C
C --- TITRE DES COLONNES
C
      POS = 2
      DO 30 ICOL = 1,NCOL
        CALL IMPSDA(SDIMPR,'LIRE',ICOL  ,IBID  ,TITCOL,
     &              IBID  )
        DO 32 K = 1,3
          TITRE(K)(POS:POS+ZLAR-1) = TITCOL(K)
 32     CONTINUE
        POS = POS+ZLAR+1
 30   CONTINUE
C
      DO 35 I = 1,LARGE
        IF (MOD(I-1,ZLAR+1) .EQ. 0) THEN
          DO 34 K = 1,3
            TITRE(K)(I:I) = SEPARA
 34       CONTINUE
        END IF
 35   CONTINUE
C
      CALL JEDEMA()
      END
