      SUBROUTINE NMIMPM(PHASE ,NATURZ,ARGZ  ,ARGR  ,ARGI  )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/12/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C TOLE CRP_20
C RESPONSABLE MABBAS M.ABBAS
C
      IMPLICIT      NONE
      CHARACTER*4   PHASE
      CHARACTER*(*) NATURZ
      CHARACTER*(*) ARGZ(*)
      REAL*8        ARGR(*)
      INTEGER       ARGI(*)
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (AFFICHAGE)
C
C GESTION DES IMPRESSIONS DE LA COMMANDE MECA_NON_LINE
C      
C ----------------------------------------------------------------------
C      
C
C IN  PHASE  : 'INIT' INITIALISATION
C              'TITR' AFFICHAGE DE L'EN TETE DES PAS DE TEMPS
C              'IMPR' IMPRESSION DES MESSAGES
C              'TABL' IMPRESSION DU TABLEAU DE CONVERGENCE
C IN  NATURE : VOIR NMIMP0/NMIMPL/NMIMPT
C IN  ARGZ   : ARGUMENTS EVENTUELS DE TYPE TEXTE
C IN  ARGR   : ARGUMENTS EVENTUELS DE TYPE REEL
C IN  ARGI   : ARGUMENTS EVENTUELS DE TYPE ENTIER
C
C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------
C

      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
C
      CHARACTER*24  SDIMPR
      CHARACTER*24  IMPINF
      INTEGER       JIMPIN      
      INTEGER       LARGE ,UNITE,ILIGNE,UIMPR,IUNIFI
      CHARACTER*255 TITFIC(3)
      CHARACTER*255 LIGNE,COLONN,TITRE(3),COLFIC
      SAVE          LIGNE,COLONN,TITRE,COLFIC
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      SDIMPR  = '&&OP0070.IMPR.'   
C
C --- RECUPERATION DES PARAMETRES
C
      IMPINF = SDIMPR(1:14)//'.INFO'
      CALL JEVEUO(IMPINF,'L',JIMPIN)
      LARGE  = ZI(JIMPIN-1+2)
      UNITE  = ZI(JIMPIN-1+3)    
C
C --- IMPRESSIONS
C
      IF (PHASE.EQ.'INIT') THEN
        CALL NMIMP0(SDIMPR,'|',LIGNE ,COLONN,TITRE)
        IF (UNITE.NE.0) THEN
          CALL NMIMP0(SDIMPR,',',LIGNE ,COLFIC,TITFIC)
          DO 10 ILIGNE = 1,3
            CALL IMPFOK(TITFIC(ILIGNE),LARGE,UNITE )
 10       CONTINUE
        ENDIF
      ELSEIF (PHASE .EQ. 'TITR') THEN
        CALL NMIMPT(SDIMPR,NATURZ,TITRE ,LIGNE ,ARGR  )
      ELSEIF (PHASE .EQ. 'IMPR') THEN
        CALL NMIMPL(SDIMPR,NATURZ,LIGNE ,ARGZ  ,ARGR  ,
     &              ARGI  )
      ELSEIF (PHASE .EQ. 'TABL') THEN
        UIMPR  = IUNIFI('MESSAGE') 
        CALL IMPSDL(SDIMPR,COLONN,UIMPR ) 
        IF (UNITE.NE.0) THEN
          UIMPR  = UNITE
          CALL IMPSDL(SDIMPR,COLFIC,UIMPR ) 
        ENDIF  
      ELSE
        WRITE(6,*) 'PHASE: ',PHASE
        CALL ASSERT(.FALSE.)
      ENDIF
C
      CALL JEDEMA()
      END
