      SUBROUTINE NMINMA(FONACT,LISCHA,SDDYNA,SOLVEU,NUMEDD,
     &                  NUMFIX,MEELEM,MEASSE)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/12/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INTEGER      FONACT(*)
      CHARACTER*19 LISCHA,SDDYNA,SOLVEU
      CHARACTER*24 NUMEDD,NUMFIX
      CHARACTER*19 MEELEM(*),MEASSE(*)
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (CALCUL)
C
C PRE-CALCUL DES MATRICES ASSEMBLEES CONSTANTES AU COURS DU CALCUL
C      
C ----------------------------------------------------------------------
C
C
C IN  FONACT : FONCTIONNALITES ACTIVEES (VOIR NMFONC)
C IN  LISCHA : LISTE DES CHARGEMENTS
C IN  SDDYNA : SD DYNAMIQUE
C IN  SOLVEU : SOLVEUR
C IN  NUMEDD : NUME_DDL (VARIABLE AU COURS DU CALCUL)
C IN  NUMFIX : NUME_DDL (FIXE AU COURS DU CALCUL)
C IN  MEELEM : MATRICES ELEMENTAIRES
C OUT MEASSE : MATRICES ASSEMBLEES
C      
C ----------------------------------------------------------------------
C
      LOGICAL      NDYNLO,LDYNA,LEXPL,LIMPL,LAMOR,LKTAN
      INTEGER      IFM,NIV
      CHARACTER*16 OPTASS
      CHARACTER*19 MASSE,AMORT      
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> PRECALCUL DES MATR_ASSE CONSTANTES'
      ENDIF
C
C --- INITIALISATIONS
C
      LDYNA  = NDYNLO(SDDYNA,'DYNAMIQUE')
      LEXPL  = NDYNLO(SDDYNA,'EXPLICITE')
      LIMPL  = NDYNLO(SDDYNA,'IMPLICITE')
      LAMOR  = NDYNLO(SDDYNA,'MAT_AMORT')
      LKTAN  = NDYNLO(SDDYNA,'RAYLEIGH_KTAN') 
C
C --- DECOMPACTION DES VARIABLES CHAPEAUX
C
      CALL NMCHEX(MEASSE,'MEASSE','MEMASS',MASSE )
      CALL NMCHEX(MEASSE,'MEASSE','MEAMOR',AMORT )
C
C --- ASSEMBLAGE DE LA MATRICE MASSE
C
      IF (LDYNA) THEN 
        IF (LIMPL) THEN
          OPTASS = ' '
        ELSEIF (LEXPL) THEN
          OPTASS = 'AVEC_DIRICHLET'
        ELSE
          CALL ASSERT(.FALSE.)
        ENDIF       
        IF (NIV.GE.2) THEN
          WRITE (IFM,*) '<MECANONLINE> ... MATR_ASSE DE MASSE'
        ENDIF    
        CALL NMASSM(FONACT  ,LISCHA,SOLVEU,NUMEDD,NUMFIX,
     &              'MEMASS',OPTASS,MEELEM,MASSE)
      ENDIF
C
C --- ASSEMBLAGE DE LA MATRICE AMORTISSEMENT
C
      IF (LAMOR.AND..NOT.LKTAN) THEN    
        IF (NIV.GE.2) THEN
          WRITE (IFM,*) '<MECANONLINE> ... MATR_ASSE AMORTISSEMENT'
        ENDIF 
        OPTASS = ' '
        CALL NMASSM(FONACT  ,LISCHA,SOLVEU,NUMEDD,NUMFIX,
     &              'MEAMOR',OPTASS,MEELEM,AMORT ) 
      ENDIF     
C
      CALL JEDEMA()
      END
