      SUBROUTINE NMLECT(RESULT,MODELE,MATE  ,CARELE,COMPOR,
     &                  LISCHA,SOLVEU,NBPASE,BASENO,INPSCO)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/12/2009   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE MABBAS M.ABBAS
C
      IMPLICIT NONE
      INTEGER      NBPASE
      CHARACTER*8  RESULT
      CHARACTER*8  BASENO
      CHARACTER*19 LISCHA, SOLVEU
      CHARACTER*24 MODELE, MATE, CARELE, COMPOR
      CHARACTER*(*) INPSCO
C
C ----------------------------------------------------------------------
C
C COMMANDES MECA_STATIQUE & STAT_NON_LINE
C
C LECTURE DES OPERANDES
C
C ----------------------------------------------------------------------
C
C OUT RESULT : NOM UTILISATEUR DU RESULTAT DE STAT_NON_LINE
C OUT MODELE : NOM DU MODELE
C OUT MATE   : NOM DU CHAMP DE MATERIAU
C OUT CARELE : CARACTERISTIQUES DES ELEMENTS DE STRUCTURE
C OUT COMPOR : CARTE DECRIVANT LE TYPE DE COMPORTEMENT
C OUT LISCHA : SD L_CHARGES
C OUT SOLVEU : NOM DU SOLVEUR
C OUT NBPASE : NOMBRE DE PARAMETRES SENSIBLES
C IN  BASENO : BASE DU NOM DES STRUCTURES DERIVEES
C OUT INPSCO : SD CONTENANT LA LISTE DES NOMS POUR LA SENSIBILITE
C
C ----------------------------------------------------------------------
C
      INTEGER      IBID, IAUX, IRET
      CHARACTER*16 K16BID,NOMCMD
      CHARACTER*8  K8BLA
C
C ----------------------------------------------------------------------
C
      K8BLA  = ' '
C
C -- NOM UTILISATEUR DU CONCEPT RESULTAT CREE PAR LA COMMANDE
C
      CALL GETRES(RESULT,K16BID,NOMCMD)
C
C -- SENSIBILITE : LECTURE DES NOMS DES PARAMETRES
C
      IAUX = 1
      CALL PSLECT(' '   ,0     ,BASENO,RESULT,IAUX  ,
     &            NBPASE,INPSCO,IRET  )
C
C -- DONNEES MECANIQUES
C
      MODELE = ' '
      CALL NMDOME(MODELE,MATE  ,CARELE,LISCHA,
     &            NBPASE,INPSCO,K8BLA ,IBID  )
C
C -- PARAMETRES DONNES APRES LE MOT-CLE FACTEUR SOLVEUR
C
      CALL CRESOL(SOLVEU,' ')
C
C -- CALCUL EVENTUEL DE L'INDICATEUR D'ERREUR EN TEMPS
C
      CALL NMETDO(NOMCMD)
C
C -- DANS LE CAS MECA_STATIQUE ON UTILISE LA CARTE COMPOR
C    STOCKEE DANS LE MATERIAU POUR LES POU_D_EM
C    (PAS UTILISEE PAR LES AUTRES ELEMENTS)
C
      IF ( NOMCMD(1:13).EQ.'MECA_STATIQUE' ) THEN
        COMPOR = MATE(1:8)//'.COMPOR'
      ENDIF

      END
