      SUBROUTINE NMNOLI(COMPOR,SDDISC,SDERRO,CARCRI,SDCRIT,
     &                  FONACT,SDDYNA,SDPOST,MODELE,VALINC,
     &                  MATE  ,SDSENS,CARELE,LISCH2,DEFICO,
     &                  RESOCO,SDPILO)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION 
C MODIF ALGORITH  DATE 21/02/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*19 SDDISC,SDCRIT,LISCH2,SDDYNA,SDPOST,SDPILO
      CHARACTER*24 COMPOR,SDERRO,CARCRI
      CHARACTER*24 MODELE,MATE,CARELE
      CHARACTER*24 DEFICO,RESOCO,SDSENS
      INTEGER      FONACT(*)
      CHARACTER*19 VALINC(*)
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (SD EVOL_NOLI)
C
C PREPARATION DE LA SD EVOL_NOLI
C
C ----------------------------------------------------------------------
C
C
C IN  MAILLA : NOM DU MAILLAGE
C IN  FONACT : FONCTIONNALITES ACTIVEES
C IN  COMPOR : COMPORTEMENT
C IN  SDDISC : SD DISC_INST
C IN  SDPOST : SD POUR POST-TRAITEMENTS (CRIT_FLAMB ET MODE_VIBR)
C IN  SDDYNA : SD DYNAMIQUE
C IN  SDCRIT : INFORMATIONS RELATIVES A LA CONVERGENCE
C IN  SDPILO : SD PILOTAGE
C IN  SDERRO : SD ERREUR
C IN  MODELE : NOM DU MODELE
C IN  MATE   : CHAMP DE MATERIAU
C IN  CARELE : CARACTERISTIQUES DES ELEMENTS DE STRUCTURE
C IN  SDSENS : SD SENSIBILITE
C IN  CARCRI : PARAMETRES DES METHODES D'INTEGRATION LOCALES
C IN  DEFICO : SD POUR LA DEFINITION DU CONTACT
C IN  RESOCO : SD DE RESOLUTION DU CONTACT
C IN  LISCH2 : NOM DE LA SD INFO CHARGE POUR STOCKAGE DANS LA SD
C              RESULTAT
C
C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
C
      CHARACTER*24 ARCINF
      INTEGER      JARINF
      CHARACTER*19 SDARCH
      INTEGER      NUMARC,NUMINS
      INTEGER      IFM,NIV
      CHARACTER*8  RESULT
      CHARACTER*24 NOOBJ      
      LOGICAL      ISFONC,LREUSE,FORCE
      INTEGER      NRPASE,NBPASE,NMSENN
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> PREPARATION DE LA SD EVOL_NOLI'
      ENDIF   
C
C --- FONCTIONNALITES ACTIVEES
C
      LREUSE = ISFONC(FONACT,'REUSE')
C
C --- INSTANT INITIAL
C
      NUMINS = 0
      FORCE  = .FALSE.
C      
C --- NOMBRE PARAMETRES SENSIBLES
C
      NBPASE = NMSENN(SDSENS)
C
C --- DETERMINATION DU NOM DE LA SD INFO_CHARGE STOCKEE
C --- DANS LA SD RESULTAT
C       
      NOOBJ  = '12345678'//'.1234'//'.EXCIT'           
      CALL GNOMSD(NOOBJ,10,13)
      LISCH2 = NOOBJ(1:19) 
C
C --- ACCES SD ARCHIVAGE
C
      SDARCH = SDDISC(1:14)//'.ARCH'
      ARCINF = SDARCH(1:19)//'.AINF'
C
C --- NUMERO ARCHIVAGE COURANT
C
      CALL JEVEUO(ARCINF,'L',JARINF)
      NUMARC = ZI(JARINF+1 -1)
C
C --- CREATION DE LA SD EVOL_NOLI OU NETTOYAGE DES ANCIENS NUMEROS
C
      DO 20 NRPASE = 0,NBPASE
        CALL NMNSLE(SDSENS,NRPASE,'RESULT',RESULT)
        IF (LREUSE) THEN
          CALL ASSERT(NUMARC.NE.0)
          CALL RSRUSD(RESULT,NUMARC)
        ELSE
          CALL ASSERT(NUMARC.EQ.0)
          CALL RSCRSD('G',RESULT,'EVOL_NOLI',100)
        ENDIF
 20   CONTINUE
C 
C --- ARCHIVAGE ETAT INITIAL
C
      IF (.NOT.LREUSE) THEN
        CALL NMIMPR('IMPR','ARCH_INIT',' ',0.D0,0)
        CALL NMARCH(NUMINS,MODELE,MATE  ,CARELE,FONACT,
     &              COMPOR,CARCRI,SDDISC,SDPOST,SDCRIT,
     &              SDERRO,SDSENS,SDDYNA,SDPILO,DEFICO,
     &              RESOCO,VALINC,LISCH2,FORCE )
      ENDIF     
C
      CALL JEDEMA()

      END
