      SUBROUTINE NMOBSV(NOMA  ,SDDISC,SDOBSE,SDDYNA,RESOCO,
     &                  VALINC,VEASSE,NUMINS)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 28/03/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE 
      INTEGER      NUMINS
      CHARACTER*8  NOMA
      CHARACTER*19 VALINC(*),VEASSE(*)
      CHARACTER*24 RESOCO
      CHARACTER*19 SDDYNA,SDDISC,SDOBSE     
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C REALISER UNE OBSERVATION 
C      
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  SDOBSE : SD OBSERVATION
C IN  SDDYNA : SD DYNAMIQUE
C IN  RESOCO : SD POUR LA RESOLUTION DE CONTACT
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  VEASSE : VARIABLE CHAPEAU POUR NOM DES VECT_ASSE
C IN  NUMINS : NUMERO DE L'INSTANT COURANT
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C      
C ----------------------------------------------------------------------
C 
      REAL*8       DIINST,INST
      LOGICAL      LOBSV
      CHARACTER*19 DEPPLU,SIGPLU,VARPLU,ACCPLU,VITPLU
      CHARACTER*19 DEPENT,VITENT,ACCENT,K19BLA,CNFINT
      LOGICAL      NDYNLO,LMUAP   
C      
C ----------------------------------------------------------------------
C 
C
C --- FONCTIONNALITES ACTIVEES
C
      LMUAP  = NDYNLO(SDDYNA,'MULTI_APPUI')
C
C --- INITIALISATIONS
C
      DEPENT = ' '
      VITENT = ' '
      ACCENT = ' '
      K19BLA = ' '
      LOBSV  = .FALSE.
C
C --- DECOMPACTION DES VARIABLES CHAPEAUX
C
      CALL NMCHEX(VALINC,'VALINC','DEPPLU',DEPPLU)
      CALL NMCHEX(VALINC,'VALINC','VITPLU',VITPLU)
      CALL NMCHEX(VALINC,'VALINC','ACCPLU',ACCPLU)
      CALL NMCHEX(VALINC,'VALINC','SIGPLU',SIGPLU)
      CALL NMCHEX(VALINC,'VALINC','VARPLU',VARPLU) 
      CALL NMCHEX(VEASSE,'VEASSE','CNFINT',CNFINT)
      IF (LMUAP) THEN
        CALL NDYNKK(SDDYNA,'DEPENT',DEPENT)
        CALL NDYNKK(SDDYNA,'VITENT',VITENT)
        CALL NDYNKK(SDDYNA,'ACCENT',ACCENT) 
      ENDIF
C
C --- TEMPS COURANT
C
      INST   = DIINST(SDDISC,NUMINS)
C
C --- DOIT-ON FAIRE UNE OBSERVATION  ?
C
      CALL LOBS  (SDOBSE,NUMINS,INST  ,LOBSV )
C
C --- AU MOINS UNE OBSERVATION
C
      IF (LOBSV) THEN
        CALL NMOBSE(NOMA  ,SDOBSE,RESOCO,NUMINS,INST  ,
     &              DEPPLU,VITPLU,ACCPLU,SIGPLU,VARPLU,
     &              DEPENT,VITENT,ACCENT,CNFINT,K19BLA)
      ENDIF
C
      END
