      SUBROUTINE NMRESD(FONACT,SDDYNA,SDTIME,SOLVEU,NUMEDD,
     &                  INSTAN,MAPREC,MATASS,CNDONN,CNPILO,
     &                  CNCINE,SOLALG)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/12/2009   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2008  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INTEGER       FONACT(*)
      CHARACTER*19  SOLALG(*)     
      CHARACTER*19  MAPREC,MATASS 
      CHARACTER*19  SOLVEU,SDDYNA
      CHARACTER*19  CNCINE,CNDONN,CNPILO
      CHARACTER*24  NUMEDD,SDTIME
      REAL*8        INSTAN
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME - CALCUL)
C
C RESOLUTION DU SYSTEME LINEAIRE K.dU = F
C      
C ----------------------------------------------------------------------
C
C
C IN  FONACT : FONCTIONNALITES ACTIVEES (VOIR NMFONC)
C IN  SDDYNA : SD DYNAMIQUE
C IN  SDTIME : SD TIMER
C IN  SOLVEU : SOLVEUR
C IN  NUMEDD : NUME_DDL
C IN  INSTAN : INSTANT COURANT
C IN  MAPREC : MATRICE DE PRECONDITIONNEMENT (GCPC)
C IN  MATASS : MATRICE ASSEMBLEE
C IN  CNDONN : CHAM_NO DE CHARGE DONNEE
C IN  CNPILO : CHAM_NO DE CHARGE PILOTEE
C IN  CNCINE : CHAM_NO DE CHARGE CINEMATIQUE
C OUT DEPSOL : SOLUTION DU DU SYSTEME K.DU = DF 
C                      DEPSOL(1) EN L'ABSENCE DE PILOTAGE
C                      DEPSOL(1) ET DEPSOL(2) AVEC PILOTAGE
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      LOGICAL      NDYNLO,LPRMO
      CHARACTER*19 DEPSO1,DEPSO2
      INTEGER      IFM,NIV
      LOGICAL      LBID
      REAL*8       R8BID      
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C      
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> ... RESOLUTION' 
      ENDIF
C
C --- EXTRACTION VARIABLES CHAPEAUX
C    
      CALL NMCHEX(SOLALG,'SOLALG','DEPSO1',DEPSO1)   
      CALL NMCHEX(SOLALG,'SOLALG','DEPSO2',DEPSO2)            
C
C --- FONCTIONNALITES ACTIVEES
C          
      LPRMO  = NDYNLO(SDDYNA,'PROJ_MODAL')      
C
C --- RESOLUTION GENERALISEE OU PHYSIQUE
C   
      CALL NMTIME('INIT' ,'TMP',SDTIME,LBID  ,R8BID )
      CALL NMTIME('DEBUT','TMP',SDTIME,LBID  ,R8BID )
C         
      IF (LPRMO) THEN
        CALL NMRESG(NUMEDD,SDDYNA,INSTAN,CNDONN,DEPSO1)
      ELSE
        CALL NMRESO(FONACT,CNDONN,CNPILO,CNCINE,SOLVEU,
     &              MAPREC,MATASS,DEPSO1,DEPSO2)
      ENDIF 
C
      CALL NMTIME('FIN'  ,'TMP',SDTIME,LBID  ,R8BID )
      CALL NMTIME('RESOL','TMP',SDTIME,LBID  ,R8BID ) 
C      
      CALL JEDEMA()
      END
