      SUBROUTINE NMTAAC(TYPE,NDIMSI,MAT,SIGEL,VIM,EPM,DP,SP,XI,
     &                  SIGP,VIP)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 18/02/97   AUTEUR GJBHHEL E.LORENTZ 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================

      IMPLICIT NONE
      INTEGER  NDIMSI,TYPE
      REAL*8   MAT(14),SIGEL(NDIMSI),VIM(9),EPM(NDIMSI),DP,SP,XI
      REAL*8   SIGP(NDIMSI),VIP(9)

C ----------------------------------------------------------------------
C  TAHERI : ACTUALISATION DES VARIABLES INTERNES ET DES CONTRAINTES
C ----------------------------------------------------------------------
C IN  TYPE   0: ELAS, 1:PSEUDO-ELAS, 2: PLAS, 3: PLAS+G
C IN  NDIMSI DIMENSION DES TENSEURS
C IN  SIGEL  DEVIATEUR DES CONTRAINTES ELASTIQUES
C IN  VIM    VARIABLES INTERNES EN T-
C IN  EPM    DEFORMATION PLASTIQUE EN T-
C IN  DP     INCREMENT DE DEFORMATION PLASTIQUE CUMULEE
C IN  SP     CONTRAINTE DE PIC
C IN  XI     PILOTAGE DE EPN
C VAR SIGP   CONTRAINTE EN T+
C OUT VIP    VARIABLES INTERNES EN T+
C ----------------------------------------------------------------------

      INTEGER K
      REAL*8  SIG(6)
      REAL*8  F,G,FDP,GDP,FDS,GDS,FDX,GDX,DPMAX,TANG(6,6)


C    ACTUALISATION DES CONTRAINTES
      IF (TYPE.GE.2) THEN
        CALL NMTACR(4,NDIMSI,MAT,SIGEL,VIM,EPM,DP,SP,XI,
     &                  F,G,FDS,GDS,FDP,GDP,FDX,GDX,DPMAX,SIG,TANG)
        DO 5 K = 1,NDIMSI
          SIGP(K) = SIGP(K) - SIG(K)
 5      CONTINUE
      END IF


C    ACTUALISATION DES VARIABLES INTERNES
      VIP(1) = VIM(1) + DP
      VIP(2) = SP
      DO 10 K = 1,NDIMSI
        VIP(K+2) = EPM(K) - XI * (EPM(K) - VIM(K+2))
 10   CONTINUE
      VIP(9) = TYPE


      END
