      SUBROUTINE NMTARI(TYPE,NDIMSI,MAT,SIGEL,VIM,EPM,DP,SP,XI,DSIDEP)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 03/08/2009   AUTEUR MEUNIER S.MEUNIER 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

      IMPLICIT NONE
      INTEGER  NDIMSI,TYPE
      REAL*8   MAT(14),SIGEL(NDIMSI),VIM(9),EPM(NDIMSI),DP,SP,XI
      REAL*8   DSIDEP(6,6)

C ----------------------------------------------------------------------
C  TAHERI : CALCUL DE LA RIGIDITE TANGENTE
C ----------------------------------------------------------------------
C IN  TYPE   0: ELAS, 1:PSEUDO-ELAS, 2: PLAS, 3: PLAS+G
C IN  NDIMSI DIMENSION DES TENSEURS
C IN  SIGEL  DEVIATEUR DES CONTRAINTES ELASTIQUES
C IN  VIM    VARIABLES INTERNES EN T-
C IN  EPM    DEFORMATION PLASTIQUE EN T-
C IN  DP     INCREMENT DE DEFORMATION PLASTIQUE CUMULEE
C IN  SP     CONTRAINTE DE PIC
C IN  XI     PILOTAGE DE EPN
C OUT DSIDEP MATRICE TANGENTE
C ----------------------------------------------------------------------

      INTEGER I,J,MODE
      REAL*8  TMP
      REAL*8  TANG(6,6)
      REAL*8  F,G,FDP,GDP,FDS,GDS,FDX,GDX,DPMAX,SIG(6)


C    MATRICE ELASTIQUE

      CALL MATINI(6,6,0.D0,DSIDEP)

      TMP = (MAT(1) - MAT(2)) / 3.D0
      DO 30 I = 1,3
        DO 40 J = 1,3
          DSIDEP(I,J) = TMP
 40     CONTINUE
 30   CONTINUE

      DO 50 I = 1,NDIMSI
        DSIDEP(I,I) = DSIDEP(I,I) + MAT(2)
 50   CONTINUE


C    CONTRIBUTION NON LINEAIRE SYMETRISEE

      IF (TYPE.GE.2) THEN
        IF (TYPE.EQ.2) MODE = 5
        IF (TYPE.EQ.3) MODE = 6
        CALL NMTACR(MODE,NDIMSI,MAT,SIGEL,VIM,EPM,DP,SP,XI,
     &                  F,G,FDS,GDS,FDP,GDP,FDX,GDX,DPMAX,SIG,TANG)
        DO 60 I = 1,NDIMSI
          DO 70 J = 1,NDIMSI
            DSIDEP(I,J)=DSIDEP(I,J)-MAT(2)**2*(TANG(I,J)+TANG(J,I))/2.D0
 70       CONTINUE
 60     CONTINUE
      END IF


      END
