      SUBROUTINE NMTASP(NDIMSI,CRIT,MAT,SIGEL,VIM,EPM,DP,SP,XI,F,IRET)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/02/2008   AUTEUR MACOCCO K.MACOCCO 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

      IMPLICIT NONE
      INTEGER  NDIMSI
      REAL*8   CRIT(3),MAT(14),SIGEL(*),VIM(9),EPM(*),DP,XI
      REAL*8   SP,F
C ----------------------------------------------------------------------
C TAHERI :  RESOLUTION DE L'EQUATION SCALAIRE G(P,SP,XI) = 0 PAR RT A SP
C ----------------------------------------------------------------------
C IN  NDIMSI DIMENSION DES TENSEURS
C IN  CRIT   CRITERES DE CONVERGENCE LOCAUX
C IN  MAT    TABLEAU DES CONSTANTES MATERIAUX
C IN  SIGEL  DEVIATEUR DES CONTRAINTES ELASTIQUES
C IN  VIM    VARIABLES INTERNES EN T-
C IN  EPM    DEFORMATION PLASTIQUE EN T-
C IN  DP     INCREMENT DE DEFORMATION PLASTIQUE CUMULEE
C OUT SP     CONTRAINTE DE PIC (SIGMA P) TEL QUE G(P,SP,XI)=0
C IN  XI     PILOTAGE DE EPN
C OUT F      VALEUR DU CRITERE DE PLASTICITE     F(P,SP,XI)
C OUT IRET   CODE RETOUR DE LA RESOLUTION DE L'EQUATION SCALAIRE
C               IRET=0 => PAS DE PROBLEME
C               IRET=1 => ECHEC
C ----------------------------------------------------------------------

      INTEGER NITER, IRET
      REAL*8  G,FDS,GDS,FDP,GDP,FDX,GDX,DPMAX,SIG(6),TANG(6,6)
      REAL*8  X(4),Y(4),FF(4)


C    EXAMEN DE LA SOLUTION SP = SP-

      SP = VIM(2)
      CALL NMTACR(1,NDIMSI,MAT,SIGEL,VIM,EPM,DP,SP,XI,
     &                  F,G,FDS,GDS,FDP,GDP,FDX,GDX,DPMAX,SIG,TANG)
      IF (G.LE.0.D0) GOTO 9999
      X(2)  = SP
      Y(2)  = G
      FF(2) = F

C    EXAMEN DE LA SOLUTION SP = S

      SP = MAT(11)
      CALL NMTACR(1,NDIMSI,MAT,SIGEL,VIM,EPM,DP,SP,XI,
     &                F,G,FDS,GDS,FDP,GDP,FDX,GDX,DPMAX,SIG,TANG)
      IF (G.GE.0.D0) GOTO 9999
      X(1)  = MAT(11)
      Y(1)  = G
      FF(1) = F

C    CALCUL DE SP : EQUATION SCALAIRE G=0 AVEC  SP- < SP < S

      X(3)  = X(1)
      Y(3)  = Y(1)
      FF(3) = FF(1)
      X(4)  = X(2)
      Y(4)  = Y(2)
      FF(4) = FF(2)

      DO 100 NITER = 1,INT(CRIT(1))
        IF ( ABS(Y(4))/MAT(4) .LT. CRIT(3)) GOTO 110
        CALL ZEROCO(X,Y)
        CALL NMTACR(1,NDIMSI,MAT,SIGEL,VIM,EPM,DP,X(4),XI,
     &                FF(4),Y(4),FDS,GDS,FDP,GDP,FDX,GDX,DPMAX,SIG,TANG)
 100  CONTINUE
      IRET = 1
      GOTO 9999
 110  CONTINUE
      SP = X(4)
      F  = FF(4)

 9999 CONTINUE
      END
