      SUBROUTINE NMUNIL(DEPPLU,DDEPLA,MATASS,DEFICU,RESOCU,
     &                  CNCINE,ITERAT,INST  ,CTCCVG)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 14/03/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      CHARACTER*19 DEPPLU
      CHARACTER*19 DDEPLA,CNCINE
      CHARACTER*24 DEFICU
      CHARACTER*24 RESOCU
      CHARACTER*19 MATASS
      INTEGER      ITERAT
      REAL*8       INST
      INTEGER      CTCCVG(2)      
C      
C ----------------------------------------------------------------------
C
C ROUTINE LIAISON_UNILATER
C
C TRAITEMENT DES CONDITIONS UNILATERALES (SAUF CONTACT MECANIQUE)
C      
C ----------------------------------------------------------------------
C
C
C IN  DEPPLU : CHAMP DE DEPLACEMENTS A L'ITERATION DE NEWTON PRECEDENTE
C IN  DEPPLA : INCREMENT DE DEPLACEMENTS CALCULE EN IGNORANT LE CONTACT
C IN  DEFICU : SD DE DEFINITION (ISSUE D'AFFE_CHAR_MECA)
C IN  RESOCU : SD DE TRAITEMENT NUMERIQUE
C IN  CNCINE : CHAM_NO CINEMATIQUE
C IN  ITERAT : ITERATION DE NEWTON
C IN  INST   : VALEUR DE L'INSTANT DE CALCUL
C OUT CTCCVG : CODES RETOURS D'ERREUR
C                (1) NOMBRE MAXI D'ITERATIONS
C                (2) MATRICE SINGULIERE
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      CHARACTER*19 MATR
      INTEGER      LDSCON,LMAT
      INTEGER      IFM,NIV,NEQ
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFNIV(IFM,NIV)
C
C --- RECUPERATION DU DESCRIPTEUR DE LA MATRICE DE LIAISON UNIL
C
      MATR = RESOCU(1:14)//'.MATR'
      CALL MTDSC3( MATR )
      CALL JEVEUO( MATR(1:19)//'.&INT', 'E', LDSCON )
C
C --- INITIALISATION DES VARIABLES DE CONVERGENCE
C
      CTCCVG(1) = 0
      CTCCVG(2) = 0      
C
C --- RECUPERATION DU DESCRIPTEUR DE LA MATRICE MECANIQUE
C
      CALL JEVEUO( MATASS//'.&INT', 'E', LMAT )
C
C --- PRE-TRAITEMENT DES CONDITIONS UNILATERALES
C
      IF (ITERAT.EQ.0)  THEN
        NEQ = ZI(LMAT+2)
        CALL CUPREP(NEQ,DEFICU,RESOCU,DEPPLU,INST)
      ENDIF
C
C --- CHOIX DE L'ALGO DE RESOLUTION
C
      CALL ALGOCU(DEFICU,RESOCU,LMAT  ,LDSCON,CNCINE,
     &            DDEPLA,CTCCVG)

C ----------------------------------------------------------------------
      CALL JEDEMA()
      END
