      SUBROUTINE NMVCCC(MODELE,NBIN  ,NBOUT ,LPAIN ,LCHIN ,
     &                  LPAOUT,LCHOUT,EXITEM,EXIHYD,EXISEC,
     &                  EXIEPA,EXIPHA,VECEL )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 07/02/2011   AUTEUR MEUNIER S.MEUNIER 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INTEGER      NBOUT,NBIN
      CHARACTER*8  LPAOUT(NBOUT),LPAIN(NBIN)
      CHARACTER*19 LCHOUT(NBOUT),LCHIN(NBIN)
      CHARACTER*8  MODELE
      LOGICAL      EXITEM,EXIHYD,EXISEC,EXIEPA,EXIPHA
      CHARACTER*19 VECEL
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (CALCUL)
C
C CALCUL DES VECT_ELEM DES VARIABLES DE COMMANDES
C
C ----------------------------------------------------------------------
C
C
C IN  MODELE : NOM DU MODELE
C IN  NBIN   : NOMBRE MAXI DE CHAMPS IN POUR CALCUL
C IN  LPAIN  : NOM DES TYPES DE CHAMP D'ENTREE
C IN  LCHIN  : NOM DES CHAMPS D'ENTREE
C IN  NBOUT  : NOMBRE MAXI DE CHAMPS OUT POUR CALCUL
C IN  LPAOUT : NOM DES TYPES DE CHAMP DE SORTIE
C IN  LCHOUT : NOM DES CHAMPS DE SORTIE
C IN  EXITEM : VARIABLE DE COMMANDE TEMPERATURE PRESENTE OU NON
C IN  EXIHYD : VARIABLE DE COMMANDE HYDRATATION PRESENTE OU NON
C IN  EXISEC : VARIABLE DE COMMANDE SECHAGE PRESENTE OU NON
C IN  EXIEPA : VARIABLE DE COMMANDE DEFO. ANEL. PRESENTE OU NON
C IN  EXIPHA : VARIABLE DE COMMANDE PHASES META. PRESENTE OU NON
C OUT VECEL  : NOM DU VECT_ELEM
C
C
C ----------------------------------------------------------------------
      INTEGER      IFM,NIV
      CHARACTER*6  MASQUE
      CHARACTER*16 OPTION
      CHARACTER*24 LIGRMO
      INTEGER      IRET,NBR
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN

      ENDIF
C
C --- INITIALISATIONS
C
      NBR    = 0
      MASQUE = '.VEXXX'
      LIGRMO = MODELE(1:8)//'.MODELE'
C
C --- THERMIQUE
C
      IF (EXITEM) THEN
        NBR       = NBR+1
        CALL CODENT(NBR,'D0',MASQUE(4:6))
        LCHOUT(1) =  VECEL(1:8)// MASQUE
        OPTION    = 'CHAR_MECA_TEMP_R'
        CALL CALCUL('C',OPTION,LIGRMO,NBIN  ,LCHIN ,LPAIN,
     &                                NBOUT ,LCHOUT,LPAOUT,'V','OUI')
        CALL JEEXIN(LCHOUT(1)//'.RESL',IRET)
        CALL REAJRE(VECEL,LCHOUT(1),'V')
      END IF
C
C --- HYDRATATION
C
      IF (EXIHYD) THEN
        NBR       = NBR+1
        CALL CODENT(NBR,'D0',MASQUE(4:6))
        LCHOUT(1) =  VECEL(1:8)// MASQUE
        OPTION    = 'CHAR_MECA_HYDR_R'
        CALL CALCUL('S',OPTION,LIGRMO,NBIN  ,LCHIN ,LPAIN,
     &                                NBOUT ,LCHOUT,LPAOUT,'V','OUI')
        CALL REAJRE(VECEL,LCHOUT(1),'V')
      END IF
C
C --- SECHAGE
C
      IF (EXISEC) THEN
        NBR       = NBR+1
        CALL CODENT(NBR,'D0',MASQUE(4:6))
        LCHOUT(1) =  VECEL(1:8)// MASQUE
        OPTION    = 'CHAR_MECA_SECH_R'
        CALL CALCUL('S',OPTION,LIGRMO,NBIN  ,LCHIN ,LPAIN,
     &                                NBOUT ,LCHOUT,LPAOUT,'V','OUI')
        CALL REAJRE(VECEL,LCHOUT(1),'V')
      END IF
C
C --- DEFORMATION ANELASTIQUE
C
      IF (EXIEPA) THEN
        NBR       = NBR+1
        CALL CODENT(NBR,'D0',MASQUE(4:6))
        LCHOUT(1) =  VECEL(1:8)// MASQUE
        OPTION    = 'CHAR_MECA_EPSA_R'
        CALL CALCUL('S',OPTION,LIGRMO,NBIN  ,LCHIN ,LPAIN,
     &                                NBOUT ,LCHOUT,LPAOUT,'V','OUI')
        CALL REAJRE(VECEL,LCHOUT(1),'V')
      END IF
C
C --- PHASES METALLURGIQUES
C
      IF (EXIPHA) THEN
        NBR       = NBR+1
        CALL CODENT(NBR,'D0',MASQUE(4:6))
        LCHOUT(1) =  VECEL(1:8)// MASQUE
        OPTION    = 'CHAR_MECA_META_Z'
        CALL CALCUL('S',OPTION,LIGRMO,NBIN  ,LCHIN ,LPAIN,
     &                                NBOUT ,LCHOUT,LPAOUT,'V','OUI')
        CALL REAJRE(VECEL,LCHOUT(1),'V')
      END IF
C
      CALL JEDEMA()
      END
