      SUBROUTINE NMVCFO(MODELZ,MATE  ,CARELE,
     &                  COMPOR,COMREF,COMVAL,VECELZ)
C
C MODIF ALGORITH  DATE 08/11/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE MABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*(*) MODELZ,VECELZ
      CHARACTER*24  MATE  ,COMREF,CARELE,COMPOR
      CHARACTER*19  COMVAL
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (CALCUL)
C
C ESTIMATION D'UNE FORCE DE REFERENCE LIEE A L'ACTION DES VAR. COMM.
C
C ----------------------------------------------------------------------
C
C
C IN  MODELE : MODELE
C IN  MATE   : CHAMP MATERIAU
C IN  CARELE : CARACTERISTIQUES DES ELEMENTS DE STRUCTURE
C IN  COMREF : VARI_COM DE REFERENCE
C IN  COMVAL : VARI_COM A L'INSTANT COURANT
C IN  COMPOR : CARTE DECRIVANT LE TYPE DE COMPORTEMENT
C OUT VECELE : VECT_ELEM FORCE DE REFERENCE (DFINT/DA * A)
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      INTEGER      NBOUT,NBIN
      PARAMETER    (NBOUT=1, NBIN=20)
      CHARACTER*8  LPAOUT(NBOUT),LPAIN(NBIN)
      CHARACTER*19 LCHOUT(NBOUT),LCHIN(NBIN)
C
      LOGICAL      EXITEM, EXIHYD, EXISEC, EXIEPA
      LOGICAL      EXIGEO, EXICAR,LBID
      INTEGER      NBRES, IRET
      CHARACTER*6  MASQUE
      CHARACTER*8  MODELE
      CHARACTER*19 VECELE
      CHARACTER*19 CHVREF,VRCPLU,INSPLU
      CHARACTER*24 LIGRMO,CHGEOM,CHCARA(18)
      CHARACTER*16 OPTION
      INTEGER      IFMDBG,NIVDBG
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('PRE_CALCUL',IFMDBG,NIVDBG)
C
C --- INITIALISATIONS
C
      MODELE = MODELZ
      LIGRMO = MODELE(1:8)//'.MODELE'
      MASQUE = '.VEXXX'
      VECELE = VECELZ
C
C --- INITIALISATION DES CHAMPS POUR CALCUL
C
      CALL INICAL(NBIN  ,LPAIN ,LCHIN ,
     &            NBOUT ,LPAOUT,LCHOUT)
C
C --- CHAMP DE GEOMETRIE
C
      CALL MEGEOM(MODELE,' ' , EXIGEO, CHGEOM)
C
C --- CHAMP DE CARACTERISTIQUES ELEMENTAIRES
C
      CALL MECARA(CARELE(1:8), EXICAR, CHCARA)
C
C --- LECTURE DES VARIABLES DE COMMANDE EN T+ ET VAL. DE REF
C
      CALL NMVCEX('TOUT',COMREF,CHVREF)
      CALL NMVCEX('TOUT',COMVAL,VRCPLU)
      CALL NMVCEX('INST',COMVAL,INSPLU)
C
C --- VARIABLES DE COMMANDE PRESENTES
C
      CALL NMVCD2('TEMP',MATE,EXITEM,LBID)
      CALL NMVCD2('HYDR',MATE,EXIHYD,LBID)
      CALL NMVCD2('SECH',MATE,EXISEC,LBID)
      CALL NMVCD2('EPSA',MATE,EXIEPA,LBID)
C
C --- CHAMPS D'ENTREE
C
      LPAIN(1)  = 'PGEOMER'
      LCHIN(1)  =  CHGEOM(1:19)
      LPAIN(2)  = 'PMATERC'
      LCHIN(2)  =  MATE(1:19)
      LPAIN(3)  = 'PCACOQU'
      LCHIN(3)  =  CHCARA(7)(1:19)
      LPAIN(4)  = 'PCAGNPO'
      LCHIN(4)  =  CHCARA(6)(1:19)
      LPAIN(5)  = 'PCAORIE'
      LCHIN(5)  =  CHCARA(1)(1:19)
      LPAIN(6)  = 'PCAGNBA'
      LCHIN(6)  =  CHCARA(11)(1:19)
      LPAIN(7)  = 'PCAARPO'
      LCHIN(7)  =  CHCARA(9)(1:19)
      LPAIN(8)  = 'PCAMASS'
      LCHIN(8)  =  CHCARA(12)(1:19)
      LPAIN(9)  = 'PCAGEPO'
      LCHIN(9)  =  CHCARA(5)(1:19)
      LPAIN(10) = 'PTEMPSR'
      LCHIN(10) =  INSPLU
      LPAIN(11) = 'PVARCPR'
      LCHIN(11) =  VRCPLU
      LPAIN(12) = 'PVARCRR'
      LCHIN(12) =  CHVREF
      LPAIN(13) = ' '
      LCHIN(13) = ' '
      LPAIN(14) = 'PNBSP_I'
      LCHIN(14) = CHCARA(1) (1:8)//'.CANBSP'
      LPAIN(15) = 'PFIBRES'
      LCHIN(15) =  CHCARA(1) (1:8)//'.CAFIBR'
      LPAIN(16) = 'PCOMPOR'
      LCHIN(16) =  COMPOR(1:19)
C
C --- PREPARATION DES VECT_ELEM
C
      CALL JEEXIN(VECELE(1:19)// '.RELR',IRET)
      IF (IRET.EQ.0) THEN
        CALL MEMARE('V',VECELE,MODELE,MATE,CARELE,'CHAR_MECA')
      END IF
      CALL JEDETR(VECELE(1:19)// '.RELR')
      CALL REAJRE(VECELE,' ','V')
C
C --- CALCUL DES OPTIONS EN T+
C
      NBRES = 0
C
C --- THERMIQUE
C
      IF (EXITEM) THEN
        NBRES     = NBRES+1
        CALL CODENT(NBRES,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECELE(1:8)//MASQUE
        OPTION    = 'CHAR_MECA_TEMP_R'
        CALL CALCUL('C',OPTION,LIGRMO,NBIN ,LCHIN,LPAIN,
     &                                NBOUT,LCHOUT,LPAOUT,'V','OUI')
        CALL JEEXIN(LCHOUT(1)//'.RESL',IRET)
        IF (IRET.GT.0) THEN
          CALL REAJRE(VECELE,LCHOUT(1),'V')
        ELSE
          NBRES = NBRES-1
        ENDIF
      END IF
C
C --- HYDRATATION
C
      IF (EXIHYD) THEN
        NBRES     = NBRES+1
        CALL CODENT(NBRES,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECELE(1:8)//MASQUE
        OPTION    = 'CHAR_MECA_HYDR_R'
        CALL CALCUL('C',OPTION,LIGRMO,NBIN ,LCHIN,LPAIN,
     &                                NBOUT,LCHOUT,LPAOUT,'V','OUI')
        CALL REAJRE(VECELE,LCHOUT(1),'V')
      END IF
C
C --- SECHAGE
C
      IF (EXISEC) THEN
        NBRES     = NBRES+1
        CALL CODENT(NBRES,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECELE(1:8)// MASQUE
        OPTION = 'CHAR_MECA_SECH_R'
        CALL CALCUL('C',OPTION,LIGRMO,NBIN ,LCHIN,LPAIN,
     &                                NBOUT,LCHOUT,LPAOUT,'V','OUI')
        CALL REAJRE(VECELE,LCHOUT(1),'V')
      END IF
C
C --- DEFORMATION ANELASTIQUE
C
      IF (EXIEPA) THEN
        NBRES     = NBRES+1
        CALL CODENT (NBRES,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECELE(1:8)// MASQUE
        OPTION = 'CHAR_MECA_EPSA_R'
        CALL CALCUL('C',OPTION,LIGRMO,NBIN ,LCHIN,LPAIN,
     &                                NBOUT,LCHOUT,LPAOUT,'V','OUI')
        CALL REAJRE(VECELE,LCHOUT(1),'V')
      END IF
C
C --- MENAGE
C
      CALL JEDEMA()
      END
