      SUBROUTINE NMVMPM(COMPOR,ICODMA,ITEMP,TEMP,E,XNU,LOI346)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 04/04/2011   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT NONE
      INTEGER ICODMA,ITEMP
      REAL*8 TEMP,LOI346(21)
      CHARACTER*16 COMPOR(*)
C
C    - FONCTION REALISEE: LECTURE DES COMPORTEMENTS VMIS_POUTRE
C      ECRO_LINE ET ECRO_FLEJOU ET ECRO_LINE_FO ET VMIS_POUTRE_FO
C
C    - ARGUMENTS IN:
C      ICODMA : ADRESSE MATERIAU CODE
C      ITEMP  : PRESENCE OU NON D'UN CHAMP DE TEMPERATURE
C      TEMPP  : VALEUR DE LA TEMPERATURE
C    - ARGUMENTS OUT:
C      E , XNU : COEFFICIENTS ELASTIQUES
C      LOI346  : TABLEAU DE CARACTERISTIQUES
C
C     VARIABLES NECESSAIRE AUX LOIS DE COMPORTEMENT
C
      REAL*8   ZERO
      PARAMETER (ZERO = 0.0D0)

      REAL*8   XNP,XMPY,XMEY,XAY,XBY,XMPZ,XMEZ,XMPX,XAZ,XBZ,
     &         SU, SY , E , EP , PUISS, XNU
      INTEGER  NUMLOI,NBPAR
      REAL*8       VALPAR,VALRES(10)
      CHARACTER*2  CODRET(10)
      CHARACTER*8  NOPAR,NOMRE2(4),NOMRE3(10),NOMRE4(2)

C     POUR LES MESSAGES
      REAL*8       VALRM(2)
      INTEGER      VALIM(2)
      CHARACTER*15 VALKM(5)
C
C     DATA NOMRE2/'EP','SY','SU','PUISS'/
      DATA NOMRE2 /'EP','SY','SU','PUISS'/
C     DATA NOMRE3/'NP','MEY','MPY','CAY','CBY','MEZ','MPZ','CAZ','CBZ',
      DATA NOMRE3 /'NP','MEY','MPY','CAY','CBY','MEZ','MPZ','CAZ','CBZ',
     &            'MPX'/
C     DATA NOMRE4/'D_SIGM_EPSI','SY'/
      DATA NOMRE4 /'D_SIGM_E','SY'/


      IF ( COMPOR(1) .EQ. 'ELAS' ) THEN
         LOI346(1) = 0
         GOTO 9999
      ENDIF

      IF (ITEMP.EQ.0) THEN
         NBPAR  = 0
         NOPAR  = ' '
         VALPAR = 0.D0
      ELSE
         NBPAR  = 1
         NOPAR  = 'TEMP'
         VALPAR = TEMP
      ENDIF

      NUMLOI = 0
      XMPY = ZERO
      XMEY = ZERO
      XAY  = ZERO
      XBY  = ZERO
      XMPZ = ZERO
      XMEZ = ZERO
      XMPX = ZERO
      XAZ  = ZERO
      XBZ  = ZERO
      XNP  = ZERO
      EP   = ZERO
      SY   = ZERO
      SU   = ZERO
      PUISS= ZERO

C     LE TYPE D'ECROUISSAGE
      IF ( COMPOR(1) .EQ. 'VMIS_POU_LINE' ) THEN
         NUMLOI = 1
         CALL RCVALA(ICODMA,' ','ECRO_LINE',NBPAR,NOPAR,VALPAR,2,
     &               NOMRE4,VALRES,CODRET,'FM')
         EP = VALRES(1)
         SY = VALRES(2)
         IF (EP .GE. E) THEN
            VALKM(1) = 'EP'
            VALKM(2) = 'E'
            VALKM(3) = 'VMIS_POU_LINE'
            VALKM(4) = 'ECRO_LINE'
            VALRM(1) = EP
            VALRM(2) = E
            CALL U2MESG('F','ALGORITH8_80',4,VALKM,0,VALIM,2,VALRM)
         ENDIF

      ELSE IF ( COMPOR(1) .EQ. 'VMIS_POU_FLEJOU' ) THEN
         NUMLOI = 2
         CALL RCVALA(ICODMA,' ','ECRO_FLEJOU',NBPAR,NOPAR,VALPAR,4,
     &               NOMRE2,VALRES,CODRET,'FM')
         EP    = VALRES(1)
         SY    = VALRES(2)
         SU    = VALRES(3)
         PUISS = VALRES(4)
C
         IF (SY .GE. SU) THEN
            VALKM(1) = 'SY'
            VALKM(2) = 'SU'
            VALKM(3) = 'VMIS_POU_FLEJOU'
            VALKM(4) = 'ECRO_FLEJOU'
            VALRM(1) = SY
            VALRM(2) = SU
            CALL U2MESG('F','ALGORITH8_80',4,VALKM,0,VALIM,2,VALRM)
         ENDIF
         IF (EP .GE. E) THEN
            VALKM(1) = 'EP'
            VALKM(2) = 'E'
            VALKM(3) = 'VMIS_POU_FLEJOU'
            VALKM(4) = 'ECRO_FLEJOU'
            VALRM(1) = EP
            VALRM(2) = E
            CALL U2MESG('F','ALGORITH8_80',4,VALKM,0,VALIM,2,VALRM)
         ENDIF
      ENDIF
      IF ( NUMLOI .EQ. 0 ) THEN
         VALKM(1) = 'VMIS_POU_LINE'
         VALKM(2) = 'ECRO_LINE'
         VALKM(3) = 'VMIS_POU_FLEJOU'
         VALKM(4) = 'ECRO_FLEJOU'
         VALKM(5) = 'VMIS_POUTRE'
         CALL U2MESK('F','ALGORITH8_81',5,VALKM)
      ENDIF

C     CALCUL DU EP : MODULE PLASTIQUE TANGENT
      EP = E*EP/(E-EP)

C     NP,MEY,CAY,...,MPX
      CALL RCVALA(ICODMA,' ','VMIS_POUTRE',NBPAR,NOPAR,VALPAR,10,
     &            NOMRE3,VALRES,CODRET,'FM')
      XNP  = VALRES(1)
      XMEY = VALRES(2)
      XMPY = VALRES(3)
      XAY  = VALRES(4)
      XBY  = VALRES(5)
      XMEZ = VALRES(6)
      XMPZ = VALRES(7)
      XAZ  = VALRES(8)
      XBZ  = VALRES(9)
      XMPX = VALRES(10)

      IF (XMEY .GT. XMPY) THEN
         VALKM(1) = 'MEY'
         VALKM(2) = 'MPY'
         IF ( NUMLOI .EQ. 1 ) THEN
            VALKM(3) = 'VMIS_POU_LINE'
         ELSE
            VALKM(3) = 'VMIS_POU_FLEJOU'
         ENDIF
         VALKM(4) = 'VMIS_POUTRE'
         VALRM(1) = XMEY
         VALRM(2) = XMPY
         CALL U2MESG('F','ALGORITH8_80',4,VALKM,0,VALIM,2,VALRM)
      ENDIF
      IF (XMEZ .GT. XMPZ) THEN
         VALKM(1) = 'MEZ'
         VALKM(2) = 'MPZ'
         IF ( NUMLOI .EQ. 1 ) THEN
            VALKM(3) = 'VMIS_POU_LINE'
         ELSE
            VALKM(3) = 'VMIS_POU_FLEJOU'
         ENDIF
         VALKM(4) = 'VMIS_POUTRE'
         VALRM(1) = XMEZ
         VALRM(2) = XMPZ
         CALL U2MESG('F','ALGORITH8_80',4,VALKM,0,VALIM,2,VALRM)
      ENDIF
C     VARIABLES NECESSAIRES A LA LOI DE COMPORTEMENT PLASTIQUE
C     XNP,XMPY,XMEY,XAY,XBY,XMPZ,XMEZ,XMPX,XAZ,XBZ,
C     SU, SY , E , EP , PUISS, AA,XIY,XIZ,XJX,XNU
      LOI346(1    ) = NUMLOI
      LOI346(1+ 1 ) = XMPY
      LOI346(1+ 2 ) = XMEY
      LOI346(1+ 3 ) = XAY
      LOI346(1+ 4 ) = XBY
      LOI346(1+ 5 ) = XMPZ
      LOI346(1+ 6 ) = XMEZ
      LOI346(1+ 7 ) = XMPX
      LOI346(1+ 8 ) = XAZ
      LOI346(1+ 9 ) = XBZ
      LOI346(1+10 ) = SU
      LOI346(1+11 ) = SY
      LOI346(1+12 ) = E
      LOI346(1+13 ) = EP
      LOI346(1+14 ) = PUISS
C     LOI346(1+15 ) = AA
C     LOI346(1+16 ) = XIY
C     LOI346(1+17 ) = XIZ
C     LOI346(1+18 ) = XJX
      LOI346(1+19 ) = XNU
      LOI346(1+20 ) = XNP

9999  CONTINUE
      END
