      SUBROUTINE NTARC0(RESULT,MODELE,MATE  ,CARELE,SDCRIT,
     &                  LISCH2,LNONL ,PARA  ,NUMARC,INSTAN)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/02/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*8   RESULT
      INTEGER       NUMARC
      LOGICAL       LNONL
      REAL*8        INSTAN,PARA(*)
      CHARACTER*19  LISCH2,SDCRIT
      CHARACTER*24  MODELE,MATE,CARELE
C
C ----------------------------------------------------------------------
C
C ROUTINE THER_* (ALGORITHME - ARCHIVAGE)
C
C ARCHIVAGE DES PARAMETRES
C
C ----------------------------------------------------------------------
C
C
C IN  RESULT : NOM UTILISATEUR DU CONCEPT RESULTAT
C IN  MODELE : NOM DU MODELE
C IN  MATE   : CHAMP DE MATERIAU
C IN  CARELE : CARACTERISTIQUES DES ELEMENTS DE STRUCTURE
C IN  LNONL  : .TRUE. SI NON-LINEAIRE
C IN  PARA   : PARAMETRES DU CALCUL
C               (1) THETA
C               (2) DELTAT
C IN  SDCRIT : VALEUR DES CRITERES DE CONVERGENCE
C IN  LISCH2 : NOM DE LA SD INFO CHARGE POUR STOCKAGE DANS LA SD
C IN  NUMARC : NUMERO D'ARCHIVAGE
C IN  INSTAN : VALEUR DE L'INSTANT
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      CHARACTER*8  K8BID
      INTEGER      JPARA,JCRR,JCRK,JINST
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()  
C
C --- ARCHIVAGE DE L'INSTANT
C
      CALL RSADPA(RESULT,'E',1,'INST',NUMARC,0,JINST,K8BID)
      ZR(JINST) = INSTAN
C
C --- ARCHIVAGE DE DELTAT ET PARM_THETA
C
      CALL RSADPA (RESULT,'E',1,'PARM_THETA' ,NUMARC,0,JPARA,K8BID)
      ZR(JPARA) = PARA(1)
      CALL RSADPA (RESULT,'E',1,'DELTAT'     ,NUMARC,0,JPARA,K8BID)
      ZR(JPARA) = PARA(2)
C
C --- ARCHIVAGE DES CRITERES DE CONVERGENCE
C           
      IF (LNONL) THEN
        CALL JEVEUO(SDCRIT(1:19)//'.CRTR','L',JCRR)
        CALL JEVEUO(SDCRIT(1:19)//'.CRDE','L',JCRK)
        CALL RSADPA(RESULT,'E',1,ZK16(JCRK),NUMARC,0,JPARA,K8BID)
        ZI(JPARA) = NINT(ZR(JCRR))
        CALL RSADPA(RESULT,'E',1,ZK16(JCRK+1),NUMARC,0,JPARA,K8BID)
        ZI(JPARA) = NINT(ZR(JCRR+1))
        CALL RSADPA(RESULT,'E',1,ZK16(JCRK+2),NUMARC,0,JPARA,K8BID)
        ZR(JPARA) = ZR(JCRR+2)
        CALL RSADPA(RESULT,'E',1,ZK16(JCRK+3),NUMARC,0,JPARA,K8BID)
        ZR(JPARA) = ZR(JCRR+3)
      ENDIF 
C
C --- ARCHIVAGE DU MODELE, MATERIAU, CARA_ELEM ET DE LA SD CHARGE
C
      CALL RSSEPA(RESULT,NUMARC,MODELE(1:8),MATE(1:8),CARELE(1:8),
     &            LISCH2)
C
      CALL JEDEMA()
      END
