      SUBROUTINE NTARCE(RESULT,SDDISC,LNONL ,INSTAN,NUMARC,
     &                  FORCE ,COMPOR,VTEMP ,VHYDR)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/02/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*8  RESULT
      CHARACTER*19 SDDISC
      INTEGER      NUMARC
      REAL*8       INSTAN
      CHARACTER*19 VTEMP,VHYDR,COMPOR
      LOGICAL      FORCE,LNONL
C
C ----------------------------------------------------------------------
C
C ROUTINE THER_* (ALGORITHME - ARCHIVAGE )
C
C ARCHIVAGE DES CHAMPS
C
C ----------------------------------------------------------------------
C
C
C IN  RESULT : NOM UTILISATEUR DU CONCEPT RESULTAT
C IN  COMPOR : CARTE DECRIVANT LE TYPE DE COMPORTEMENT
C IN  VTEMP  : VECTEUR TEMPERATURE
C IN  VHYDR  : VECTEUR HYDRATATION
C IN  LNONL  : .TRUE. SI NON-LINEAIRE
C IN  FORCE  : VRAI SI ON SOUHAITE FORCER L'ARCHIVAGE DE TOUS LES CHAMPS
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  INSTAN : INSTANT D'ARCHIVAGE
C IN  NUMARC : NUMERO D'ARCHIVAGE
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      INTEGER      NBCHMX
      PARAMETER    (NBCHMX = 99)
C
      CHARACTER*24 TYPECH(NBCHMX)
      CHARACTER*19 NOMSCH(NBCHMX)
      LOGICAL      DIINCL,LHYDR
      INTEGER      NBCHEF,ICHAMP
      CHARACTER*19 K19BLA
      CHARACTER*24 TYPCHA
      CHARACTER*19 NOMCHA
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      K19BLA = ' '
      LHYDR  = .FALSE.   
      IF (LNONL) CALL NTHYDR(LHYDR)
C      
      CALL NMARCZ(' ',K19BLA,TYPECH,NOMSCH,NBCHEF)
      CALL ASSERT(NBCHEF.EQ.1)
C
C --- CHAMPS STANDARDS
C
      CALL NMARCZ('TEMP'        ,VTEMP ,TYPECH,NOMSCH,NBCHEF)
C
C --- CHAMPS EN NON-LINEAIRE
C      
      IF (LNONL) THEN
        CALL NMARCZ('COMPORTHER',COMPOR,TYPECH,NOMSCH,NBCHEF)
        IF (LHYDR) THEN
          CALL NMARCZ('HYDR_ELNO',VHYDR ,TYPECH,NOMSCH,NBCHEF)
        ENDIF
      ENDIF
C
C --- ARCHIVAGE DES CHAMPS
C
      DO 10 ICHAMP = 1, NBCHEF - 1
        TYPCHA = TYPECH(ICHAMP)
        NOMCHA = NOMSCH(ICHAMP)
        IF (DIINCL(SDDISC,TYPCHA,FORCE )) THEN
          CALL U2MESG('I','ARCHIVAGE_6',1,TYPCHA,1,NUMARC,1,INSTAN)
          CALL NMARCC(RESULT,NUMARC,TYPCHA,NOMCHA)
        ENDIF
  10  CONTINUE
C
      CALL JEDEMA()
      END
