      SUBROUTINE NTARCH(NUMINS,MODELE,MATE  ,CARELE,COMPOZ,
     &                  LNONL ,PARA  ,SDDISC,SDCRIT,NBPASE,
     &                  INPSCO,VHYDR ,LISCH2,FORCE )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/02/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
      IMPLICIT NONE
      INTEGER       NUMINS,NBPASE
      REAL*8        PARA(*)
      LOGICAL       LNONL,FORCE
      CHARACTER*(*) INPSCO
      CHARACTER*19  SDDISC,SDCRIT
      CHARACTER*24  VHYDR,COMPOZ
      CHARACTER*24  MODELE,MATE  ,CARELE
      CHARACTER*19  LISCH2
C
C ----------------------------------------------------------------------
C
C ROUTINE THER_* (ALGORITHME)
C
C ARCHIVAGE
C
C ----------------------------------------------------------------------
C
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      LOGICAL      DIDERN,LSENS
      REAL*8       INSTAM,INSTAN
      REAL*8       DIINST
      INTEGER      IRET,IAUX,JAUX
      INTEGER      NUMARC
      INTEGER      JINST 
      INTEGER      NRPASE
      CHARACTER*19 K19BID,VTEMP,TEMP,HYDR,COMPOR
      CHARACTER*8  K8BID,NOPASE,RESULT    
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C      
      COMPOR = COMPOZ(1:19)
C
C --- FONCTIONNALITES ACTIVEES
C    
      LSENS  = NBPASE.GT.0
C
C --- IMPRESSION EVENTUELLE DES MESURES DE TEMPS
C
      CALL UTTCPG('IMPR','INCR')      
C
C --- DERNIER PAS : ON ARCHIVE TOUS LES CHAMPS
C
      IF (DIDERN(SDDISC,NUMINS)) THEN
        FORCE = .TRUE.
      ENDIF 
C
C --- NUMERO D'ARCHIVAGE
C
      CALL DINUAR(SDDISC,NUMINS,FORCE ,NUMARC)
C
C --- INSTANT COURANT
C
      INSTAN = DIINST(SDDISC,NUMINS)
C
C ----------------------------------------------------------------------
C
      IF (NUMARC.GE.0) THEN
C
C ----- NOM SD RESULTAT
C
        IAUX   = 0
        JAUX   = 3
        CALL PSNSLE(INPSCO,IAUX  ,JAUX  ,RESULT )
C
C ----- INSTANT DEJA ARCHIVE ?
C
        IF (NUMARC.GE.2) THEN
          CALL RSADPA(RESULT,'L',1,'INST',NUMARC-1,0,JINST,K8BID)
          INSTAM = ZR(JINST)
          IF (INSTAN.EQ.INSTAM) THEN
            GOTO 999
          ENDIF
        ENDIF
C
C ----- AFFICHAGE
C
        CALL U2MESS('I','ARCHIVAGE_5')
C
C ----- NOM DES CHAMPS
C
        IAUX   = 0
        JAUX   = 4
        CALL PSNSLE(INPSCO,IAUX  ,JAUX  ,VTEMP  )
        TEMP   = VTEMP(1:19)
        HYDR   = VHYDR(1:19)
        JAUX   = 3
        CALL PSNSLE(INPSCO,IAUX  ,JAUX  ,RESULT )
C
C ----- EXTENSION DE RESULT SI TROP PETIT (DOUBLEMENT)
C
        CALL RSEXCH(RESULT,'TEMP',NUMARC,K19BID,IRET  )
        IF (IRET.EQ.110) THEN
          CALL RSAGSD(RESULT,0)
        ENDIF               
C
C ----- ARCHIVAGE DES PARAMETRES
C
        CALL NTARC0(RESULT,MODELE,MATE  ,CARELE,SDCRIT,
     &              LISCH2,LNONL ,PARA  ,NUMARC,INSTAN)        
C
C ----- ARCHIVAGE DES CHAMPS
C
        CALL NTARCE(RESULT,SDDISC,LNONL ,INSTAN,NUMARC,
     &              FORCE ,COMPOR,TEMP  ,HYDR  )       
C
C ----- CAS SENSIBLE
C
        IF (LSENS) THEN
C
C ------- BOUCLE SUR LES PARAMETRES SENSIBLES
C
          DO 10 NRPASE = 1,NBPASE  
C
C --------- NOM DES CHAMPS SENSIBLES
C
             IAUX = NRPASE
             JAUX = 1
             CALL PSNSLE(INPSCO,IAUX  ,JAUX  ,NOPASE)
             JAUX = 3
             CALL PSNSLE(INPSCO,IAUX  ,JAUX  ,RESULT)
             JAUX = 4
             CALL PSNSLE(INPSCO,IAUX  ,JAUX  ,VTEMP )
             TEMP   = VTEMP(1:19)
             HYDR   = VHYDR(1:19)
C
C --------- AFFICHAGE
C
            CALL U2MESK('I','ARCHIVAGE_7',1,NOPASE)
C
C --------- ARCHIVAGE DES PARAMETRES
C
            CALL NTARC0(RESULT,MODELE,MATE  ,CARELE,SDCRIT,
     &                  LISCH2,LNONL ,PARA  ,NUMARC,INSTAN)
C
C --------- ARCHIVAGE DES CHAMPS SENSIBLES
C
            CALL NTARCE(RESULT,SDDISC,LNONL ,INSTAN,NUMARC,
     &                  FORCE ,COMPOR,TEMP  ,HYDR  )       
  10      CONTINUE              
        ENDIF
      ENDIF
C
  999 CONTINUE
C      
      CALL JEDEMA()

      END
