      SUBROUTINE NTINIT(RESULT,MODELE,MATE  ,CARELE,COMPOR,
     &                  INFCHA,INFCH2,SOLVEU,PARA  ,NUMEDD,
     &                  LOSTAT,LEVOL ,LNONL ,SDDISC,NBPASE,
     &                  INPSCO,MAILLA,SDCRIT,TIME  )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/02/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE                            DURAND C.DURAND
C TOLE CRP_21
C
      IMPLICIT NONE      
      LOGICAL       LOSTAT,LEVOL,LNONL
      INTEGER       NBPASE
      CHARACTER*19  INFCHA,INFCH2,SOLVEU
      CHARACTER*19  SDDISC,SDCRIT
      CHARACTER*24  MODELE,MATE  ,CARELE
      CHARACTER*24  RESULT,NUMEDD,COMPOR,TIME
      CHARACTER*(*) INPSCO
      CHARACTER*8   MAILLA
      REAL*8        PARA(*)
C
C ---------------------------------------------------------------------
C     THERMIQUE : INITIALISATIONS.
C     *           ****
C   -------------------------------------------------------------------
C     SUBROUTINES APPELLEES:
C       JEVEUX: JEDETR,COPISD,UTCRRE.
C       PARAMETRE DE CMD: GETRES,NTINST.
C       SENSIBILITE: PSNSLE,PSGENC.
C       MSG: INFNIV.
C       MANIP SD: VTCREB.
C       LECTURE DONNEES: NTDOET,NTDOED.
C       MATRICE: NUMERO.
C
C     FONCTIONS INTRINSEQUES:
C       AUCUNE.
C   -------------------------------------------------------------------
C     ASTER INFORMATIONS:
C       30/11/01 (OB): MODIFICATIONS DES MODES D'INITIALISATIONS DES
C                      CALCULS DE SENSIBILITE. DESORMAIS, IL EST FIXE
C                      PAR LE MOT-CLE 'ETAT_INIT' DU PB STD.
C       12/02/02 (OB): ACCEPTATION DES SENSIBILITES EN NON-LINEAIRE.
C
C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------
C
      INTEGER      ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8       ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16   ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL      ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8  ZK8
      CHARACTER*16    ZK16
      CHARACTER*24        ZK24
      CHARACTER*32            ZK32
      CHARACTER*80                ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
C
      INTEGER      NEQ,IRET,NRPASE,INITPR,IAUX,JAUX,IBID
      INTEGER      NIV,IFM
      CHARACTER*14 NUPOSS
      CHARACTER*19 K19BLA
      CHARACTER*24 VTEMP,NOOJB,K24BLA
      REAL*8       INSTIN
      LOGICAL      LREUSE
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFNIV(IFM,NIV)
C
C --- INITIALISATIONS
C
      LREUSE = .FALSE.
      K24BLA = ' '
      K19BLA = ' '
      LOSTAT = .FALSE.
      LNONL  = .FALSE.
      LEVOL  = .FALSE.
      TIME   = RESULT(1:8)//'.CHTPS'
      CALL DISMOI('F','NOM_MAILLA',MODELE,'MODELE',IBID,MAILLA,IBID)
C
C --- CONCEPT REENTRANT ?
C      
      CALL GCUCON(RESULT,'EVOL_THER', IRET)
      IF (IRET.GT.0) THEN
        LREUSE = .TRUE.
      ENDIF
C
C --- NUMEROTATION ET CREATION DU PROFIL DE LA MATRICE
C
      NUMEDD = '12345678.NUMED'
      NOOJB  = '12345678.00000.NUME.PRNO'
      CALL GNOMSD ( NOOJB,10,14 )
      NUMEDD = NOOJB(1:14)
      CALL RSNUME(RESULT,'TEMP',NUPOSS)
      CALL NUMERO(NUPOSS,MODELE,INFCHA,SOLVEU,'VG',NUMEDD )
C
C --- CREATION DES CHAMPS
C
      DO 30  NRPASE = 0 , NBPASE
        IAUX = NRPASE
        JAUX = 4
        CALL PSNSLE(INPSCO,IAUX  ,JAUX  ,VTEMP )
        CALL VTCREB(VTEMP ,NUMEDD,'V','R',NEQ)
   30 CONTINUE
C 
C --- LECTURE ETAT INITIAL
C
      CALL NXDOET(MODELE,NUMEDD,LREUSE,LOSTAT,LNONL ,
     &            INPSCO,NBPASE,INITPR,VTEMP ,K24BLA,
     &            INSTIN)   
C
C --- CREATION SD DISCRETISATION, ARCHIVAGE ET OBSERVATION
C
      CALL TIINIT(MAILLA,MODELE,RESULT,LOSTAT,LREUSE,
     &            LNONL ,VTEMP ,INSTIN,SDDISC,K19BLA,
     &            LEVOL  )
C
C --- CREATION DE LA SD EVOL_THER
C
      CALL NXNOLI(MODELE,MATE  ,CARELE,COMPOR,LOSTAT,
     &            LREUSE,LNONL ,LEVOL ,PARA  ,SDDISC,
     &            SDCRIT,NBPASE,INPSCO,K24BLA,INFCH2)
      CALL COPISD('LISTE_CHARGES','G',INFCHA,INFCH2)
C 
C --- CREATION DE LA SD POUR ARCHIVAGE DES INFORMATIONS DE CONVERGENCE
C 
      CALL NTCRCV(SDCRIT)
C  
      CALL JEDEMA()
      END
