      SUBROUTINE NUEQCH(ERREUR,CHAMNO,NOMA,NBNO  ,NUMNO ,NOMCMP,
     &                  NUEQ  )
C      
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 03/11/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C 
      IMPLICIT     NONE
      CHARACTER*19 CHAMNO
      CHARACTER*8  NOMCMP(*),NOMA
      CHARACTER*1  ERREUR
      INTEGER      NBNO,NUMNO(*),NUEQ(*)
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME - PILOTAGE)
C
C PERMET DE RECUPERER LES NUMEROS DES EQUATIONS DANS LE .VALE A
C PARTIR DES NOMS DE NOEUD ET DES NOMS DE COMPOSANTE
C      
C ----------------------------------------------------------------------
C
C      
C IN  CHAMNO  : CHAM_NO A MODIFIER
C IN  ERREUR  : 'F' SI UNE COMPOSANTE ABSENTE -> ERREUR
C               'A' SI UNE COMPOSANTE ABSENTE -> ALARME
C               ' ' SI UNE COMPOSANTE ABSENTE -> RIEN
C IN  NBNO    : NOMBRE DE NOEUDS
C IN  NUMNO   : LISTE DES NUMEROS DE NOEUD
C IN  NOMCMP  : LISTE DES NOMS DE COMPOSANTE
C OUT NUEQ    : LISTE DES POSITIONS DANS LE .VALE
C
C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ---------------------------
C
      CHARACTER*32       JEXNOM,JEXNUM
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C ---------- FIN  DECLARATIONS  NORMALISEES  JEVEUX -------------------
C
      CHARACTER*19 PFCHNO
      CHARACTER*8  NOMGD
      INTEGER      IBID,IER,NBCMPX,NCMP,ICO,ITROU
      INTEGER      ICMP,INO,IDC,NEC,INDIK8
      INTEGER      JCMP,JNUEQ,JPRNO
      LOGICAL      EXIS,EXISDG
      CHARACTER*8  K8BID,NOM,NOMNOE
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
      CALL DISMOI('F','NOM_GD',CHAMNO,'CHAM_NO' ,IBID  ,NOMGD,IER)
      CALL DISMOI('F','NB_EC' ,NOMGD, 'GRANDEUR',NEC   ,K8BID,IER)
      CALL DISMOI('F','NB_CMP_MAX',  NOMGD, 'GRANDEUR',NBCMPX,K8BID,IER)
      CALL JEVEUO(JEXNOM('&CATA.GD.NOMCMP',NOMGD),'L',JCMP)
      CALL JELIRA(JEXNOM('&CATA.GD.NOMCMP',NOMGD),'LONMAX',NCMP, K8BID)
C      
      CALL DISMOI('F','PROF_CHNO',CHAMNO,'CHAM_NO',IBID,PFCHNO, IER)
      CALL JEVEUO(PFCHNO//'.PRNO','L',JPRNO)
      CALL JEVEUO(PFCHNO//'.NUEQ','L',JNUEQ)
C
      DO 10 INO = 1,NBNO
        NOM    = NOMCMP(INO)
        IDC    = INDIK8(ZK8(JCMP),NOM   ,1,NCMP)
        ICO    = 0
        DO 100 ICMP = 1,NBCMPX
          IF (EXISDG(ZI(JPRNO-1+(NEC+2)*(NUMNO(INO)-1)+2+1),ICMP)) THEN
            ICO    = ICO + 1
            EXIS   = .TRUE.
          ELSE
            EXIS   = .FALSE.
          ENDIF
          IF ( ICMP .EQ. IDC ) THEN
            IF ( EXIS ) THEN
              ITROU = ICO
              GOTO 101
            ELSE
              ITROU = 0
              IF (ERREUR.NE. ' ') THEN 
                CALL U2MESK(ERREUR, 'MECANONLINE5_50',1,NOM)
              ENDIF
            ENDIF
          ENDIF
 100    CONTINUE
        IF (ERREUR.NE. ' ') THEN 
          CALL U2MESK(ERREUR, 'MECANONLINE5_50',1,NOM)
        ENDIF  
 101    CONTINUE
        IF (ITROU.EQ.0) THEN
          NUEQ(INO) = 0
        ELSE
          NUEQ(INO) = ZI(JNUEQ-1+ZI(JPRNO-1+
     &               (NEC+2)*(NUMNO(INO)-1)+1)+ITROU-1)
        ENDIF  
 10   CONTINUE
C 
      CALL JEDEMA()
      END
