      SUBROUTINE NUMGCY(NUGENE,MODGEN)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/02/2008   AUTEUR ANDRIAM H.ANDRIAMBOLOLONA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2005  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C***********************************************************************
C    O. NICOLAS
C-----------------------------------------------------------------------
C  BUT:      < NUMEROTATION GENERALISEE >
      IMPLICIT REAL*8(A-H,O-Z)
C
C  DETERMINER LA NUMEROTATION DES DEGRES DE LIBERTE GENERALISES
C   A PARTIR D'UN MODELE GENERALISE CAS CYCLIQUE POUR DESACORDAGE
C
C-----------------------------------------------------------------------
C
C NUGENE   /I/: NOM K14 DU NUME_DDL_GENE
C MODGEN   /I/: NOM K8 DU MODELE GENERALISE
C
C-------- DEBUT COMMUNS NORMALISES  JEVEUX  ----------------------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
      CHARACTER*32 JEXNUM,JEXNOM
C
C----------  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
C
      CHARACTER*8 MODGEN,NOMCOU,KBID
      CHARACTER*14 NUGENE
      CHARACTER*19 PRGENE,STOMOR
      CHARACTER*24 DEFLI,FPROFL,NOMSST
      INTEGER IBID,JREFN,LDDESC,LDNEQU,LDORS,LDPRS,LDORL,LDPRL,LDDEEQ,
     &        LDNUEQ,I,J,LDDELG
C
C-----------------------------------------------------------------------
C
      CALL JEMARQ()
      IFIMES=IUNIFI('MESSAGE')
C-----------------------------------------------------------------------
C
      KBID=' '
      DEFLI=MODGEN//'      .MODG.LIDF'
      FPROFL=MODGEN//'      .MODG.LIPR'
      NOMSST=MODGEN//'      .MODG.SSNO'
      PRGENE=NUGENE//'.NUME'
      STOMOR=NUGENE//'.SMOS'
C
C-----CREATION DU .REFN
C
      CALL WKVECT(PRGENE//'.REFN','G V K24',4,JREFN)
      ZK24(JREFN)=MODGEN
      ZK24(JREFN+1)='DEPL_R'
C
C-----CREATION DU .DESC
C
      CALL WKVECT(PRGENE//'.DESC','G V I',1,LDDESC)
      ZI(LDDESC)=2
C
C---------------------------DECLARATION JEVEUX--------------------------
C
C     CREATION DE LA COLLECTION .LILI
C
      CALL JECREO(PRGENE//'.LILI','G N K8')
      CALL JEECRA(PRGENE//'.LILI','NOMMAX',2,' ')
      CALL JECROC(JEXNOM(PRGENE//'.LILI','&SOUSSTR'))
      CALL JECROC(JEXNOM(PRGENE//'.LILI','LIAISONS'))
C
C     CREATION DES COLLECTIONS
C
      CALL JECREC(PRGENE//'.PRNO','G V I','NU','DISPERSE','VARIABLE',2)
      CALL JECREC(PRGENE//'.ORIG','G V I','NU','DISPERSE','VARIABLE',2)
C
C------RECUPERATION DES DIMENSIONS PRINCIPALES
      CALL WKVECT(PRGENE//'.NEQU','G V I',1,LDNEQU)
C ON RECUPERE LE NOMBRE DE LIAISON
      CALL JELIRA(DEFLI,'NMAXOC',NBLIA,KBID)
C ON RECUPERE LE NOMBRE DE SOUS-STRUCTURE
      CALL JELIRA(NOMSST,'NOMMAX',NBSST,KBID)
C
C----------------------BOUCLES DE COMPTAGE DES DDL----------------------
C
C ICOMPS EST LE NOMBRE TOTAL DE MODES DANS LES SOUS-STRUCTURES
      ICOMPS=0
C ICOMPS EST LE NOMBRE TOTAL DE MODES D'INTERFACE DANS LES
C SOUS-STRUCTURES
      ICOMPL=0
C
C   BOUCLE SUR LES SOUS-STRUCTURES
C
      DO 10 I=1,NBSST
        CALL MGUTDM(MODGEN,KBID,I,'NOM_MACR_ELEM',IBID,NOMCOU)
        CALL JEVEUO(NOMCOU//'.MAEL_RAID_DESC','L',LLDESC)
        NBMOD=ZI(LLDESC+1)
        ICOMPS=ICOMPS+NBMOD
   10 CONTINUE
C
C   BOUCLE SUR LES LIAISONS
C
      CALL JEVEUO(FPROFL,'L',LLPROF)
      DO 20 I=1,NBLIA
        NBLIG=ZI(LLPROF+(I-1)*9)
        ICOMPL=ICOMPL+NBLIG
   20 CONTINUE
C
      NEQ=ICOMPS-ICOMPL
C
      ZI(LDNEQU)=NEQ
C
      WRITE (IFIMES,*)'+++ NOMBRE DE SOUS-STRUSTURES: ',NBSST
      WRITE (IFIMES,*)'+++ NOMBRE DE LIAISONS: ',NBLIA
      WRITE (IFIMES,*)'+++ NOMBRE TOTAL D''EQUATIONS: ',NEQ
      WRITE (IFIMES,*)'+++ DONT NOMBRE D''EQUATIONS STRUCTURE: ',ICOMPS
      WRITE (IFIMES,*)'+++ DONT NOMBRE D''EQUATIONS LIAISON: ',ICOMPL

C-----ECRITURE DIMENSIONS
C
      CALL JENONU(JEXNOM(PRGENE//'.LILI','&SOUSSTR'),IBID)

      CALL JEECRA(JEXNUM(PRGENE//'.PRNO',IBID),'LONMAX',2,' ')
      CALL JEVEUO(JEXNUM(PRGENE//'.PRNO',IBID),'E',LDPRS)

      CALL JEECRA(JEXNUM(PRGENE//'.ORIG',IBID),'LONMAX',2,' ')
      CALL JEVEUO(JEXNUM(PRGENE//'.ORIG',IBID),'E',LDORS)

      CALL JENONU(JEXNOM(PRGENE//'.LILI','LIAISONS'),IBID)

      CALL JEECRA(JEXNUM(PRGENE//'.PRNO',IBID),'LONMAX',1,' ')
      CALL JEVEUO(JEXNUM(PRGENE//'.PRNO',IBID),'E',LDPRL)

      CALL JEECRA(JEXNUM(PRGENE//'.ORIG',IBID),'LONMAX',1,' ')
      CALL JEVEUO(JEXNUM(PRGENE//'.ORIG',IBID),'E',LDORL)
C
      ZI(LDORS)=1
      ZI(LDPRS)=1
      ZI(LDPRS+1)=NEQ
      ZI(LDORL)=1
      ZI(LDPRL)=0
C
C-----ALLOCATIONS DIVERSES
C
      CALL WKVECT(PRGENE//'.DEEQ','G V I',NEQ*2,LDDEEQ)
      CALL WKVECT(PRGENE//'.NUEQ','G V I',NEQ,LDNUEQ)
      CALL WKVECT(PRGENE//'.DELG','G V I',NEQ,LDDELG)
C
C     REMPLISSAGE DU .DEEQ ET DU .NUEQ
C
      DO 30 J=1,NEQ
        ZI(LDNUEQ+J-1)=J
        ZI(LDDELG+J-1)=0
        ZI(LDDEEQ+2*J-1)=1
        ZI(LDDEEQ+2*J-2)=J
   30 CONTINUE


C     CREATION DU STOCKAGES MORSE :
      CALL CRSMOS(STOMOR,'PLEIN',NEQ)

C
   40 CONTINUE
      CALL JEDEMA()
      END
