      SUBROUTINE NXLECT (RESULT,MODELE,MATE,CARELE,MATCST,COECST,
     >                   FOMULT,INFCHA,CHARGE,INFOCH,
     >                   PARMEI,PARMER,SOLVEU,PARCRI,PARCRR,
     >                   LISOPT,NOPT,COMPOR,EVOLSC,
     >                   NBPASE, BASENO, INPSCO )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/02/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C RESPONSABLE                            DURAND C.DURAND
C TOLE CRP_21
C
      IMPLICIT NONE
C
      CHARACTER*8  EVOLSC
      LOGICAL      MATCST,COECST
      INTEGER      PARMEI(2),PARCRI(3),NOPT
      INTEGER      NBPASE
      REAL*8       PARMER(2),PARCRR(2)
      CHARACTER*8 BASENO, BLAN8
      CHARACTER*19 INFCHA,SOLVEU
      CHARACTER*24 RESULT,MODELE,MATE,CARELE,COMPOR
      CHARACTER*24 FOMULT,CHARGE,INFOCH,LISOPT
      CHARACTER*(*) INPSCO
C
C ----------------------------------------------------------------------
C
C COMMANDES DE THERMIQUE THER_LINEAIRE ET THER_NON_LINE :
C  LECTURE DES OPERANDES.
C
C ----------------------------------------------------------------------
C
      INTEGER IBID, IAUX, CODRET
      CHARACTER*5  SUFFIX
      CHARACTER*16 K16BID,NOMCMD
      CHARACTER*24 K24BID
C
C               1234567890123456789
      BLAN8  = '        '
C ----------------------------------------------------------------------
C
C --- NOM UTILISATEUR DU CONCEPT RESULTAT CREE PAR LA COMMANDE
C
      CALL GETRES (RESULT,K16BID,NOMCMD)
      SUFFIX = '     '
C
C --- SENSIBILITE : LECTURE DES NOMS DES PARAMETRES
C
      IAUX = 1
      CALL PSLECT ( ' ', 1, BASENO, RESULT, IAUX,
     >              NBPASE, INPSCO, CODRET )
C
C --- DONNEES THERMIQUES
C
      CHARGE = INFCHA//'.LCHA'
      INFOCH = INFCHA//'.INFC'
      FOMULT = INFCHA//'.FCHA'
      CALL NTDOTH ( MODELE, MATE, CARELE, FOMULT, MATCST,
     >              COECST, INFCHA,
     >              NBPASE, INPSCO,BLAN8,IBID)
C
C --- COMPORTEMENT
C
      IF (NOMCMD(1:13).NE.'THER_LINEAIRE') THEN
         CALL NMDORC (MODELE,COMPOR,K24BID)
      ENDIF
C
C --- PARAMETRES DONNES APRES LE MOT-CLE FACTEUR SOLVEUR
C
      CALL CRESOL (SOLVEU,SUFFIX)
C
      IF (NOMCMD(1:13).EQ.'THER_NON_LINE') THEN
C
C ---   PARAMETRE DE RESOLUTION
C
        CALL NXDOMT (PARMEI,PARMER)
C
C ---   CHAMP THERMIQUE DU SECHAGE, ET VERIFICATION SYNTAXIQUE
C
        CALL NTDCOM (EVOLSC)
C
C ---   CRITERES DE CONVERGENCE
C
        CALL NXDOCN (PARCRI,PARCRR)
C
C ---   OPTIONS DE CALCUL DE SORTIE
C
        CALL NTDOOP (LISOPT,NOPT)

      ELSE
C
C ---   PARAMETRE DE RESOLUTION
C
        CALL NTDOMT (PARMER)

      ENDIF
C
C-----------------------------------------------------------------------
      END
