      SUBROUTINE NXPRED (MODELE,MATE,CARELE,CHARGE,INFOCH,NUMEDD,
     &                   SOLVEU,LOSTAT,TIME,LONCH,MATASS,MAPREC,
     &                   VTEMP,VTEMPM,VTEMPP,VHYDR,VHYDRP,TMPCHI,TMPCHF,
     &                   COMPOR,CNDIRP,CNCHCI,VEC2ND,VEC2NI,PREM)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/10/2010   AUTEUR BOITEAU O.BOITEAU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE                            DURAND C.DURAND
C TOLE CRP_21
C
      IMPLICIT NONE
      INTEGER      LONCH
      CHARACTER*19 SOLVEU,MAPREC
      CHARACTER*24 MODELE,MATE,CARELE,CHARGE,INFOCH,NUMEDD,TIME
      CHARACTER*24 MATASS,CNDIRP,CNCHCI,CNRESI
      CHARACTER*24 VTEMPM,VTEMPP,VTEMP,VEC2ND,VEC2NI
      CHARACTER*24 VHYDR,VHYDRP,COMPOR,TMPCHI,TMPCHF
      LOGICAL      PREM,LOSTAT
C
C ----------------------------------------------------------------------
C
C COMMANDE THER_NON_LINE : PHASE DE PREDICTION
C
C ----------------------------------------------------------------------
C
C     VAR VTEMPM : ITERE PRECEDENT DU CHAMP DE TEMPERATURE
C     OUT VTEMPP : ITERE COURANT   DU CHAMP DE TEMPERATURE
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      CHARACTER*32       JEXNUM , JEXNOM , JEXR8 , JEXATR
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC,CBID
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      INTEGER      K,J2ND,JDIRP,J2NI
      INTEGER      JTEMP,JTEMPM,JTEMPP
      INTEGER      JVARE,JBTL,JBTLA,JBTT,JBUU,JBUEM
      REAL*8       RBID ,VNORM
      CHARACTER*1  TYPRES
      CHARACTER*8  K8BID
      CHARACTER*16 K16BID,NOMCMD
      CHARACTER*19 CHSOL
      CHARACTER*24 BIDON,VERESI,VARESI,VABTLA,VEBTLA,CRITER
      CHARACTER*24 VEBUEM,VABUEM,CNVABT,CNVABU
C
      DATA TYPRES        /'R'/
      DATA CHSOL         /'&&NXPRED.SOLUTION'/
      DATA BIDON         /'&&FOMULT.BIDON'/
      DATA VERESI        /'&&VERESI           .RELR'/
      DATA VEBTLA        /'&&VETBTL           .RELR'/
      DATA VABTLA        /' '/
      DATA VEBUEM        /'&&VEBUEM           .RELR'/
      DATA VABUEM        /' '/
      DATA CNRESI        /' '/
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      VARESI = '&&VARESI'
      CRITER = '&&RESGRA_GCPC'
      CNVABT = ' '
      CNVABU = ' '
C
C --- RECUPERATION D'ADRESSES
C
      CALL JEVEUO (VEC2ND(1:19)//'.VALE','L',J2ND)
      CALL JEVEUO (VEC2NI(1:19)//'.VALE','L',J2NI)
      CALL JEVEUO (CNDIRP(1:19)//'.VALE','L',JDIRP)
      CALL JEVEUO (VTEMPP(1:19)//'.VALE','E',JTEMPP)
      CALL JEVEUO (VTEMPM(1:19)//'.VALE','E',JTEMPM)
      CALL JEVEUO ( VTEMP(1:19)//'.VALE','L',JTEMP)
C
      IF (LOSTAT) THEN
C
C=======================================================================
C  INITIALISATION POUR LE PREMIER PAS DE CALCUL
C=======================================================================
C
C --- VECTEURS RESIDUS ELEMENTAIRES - CALCUL ET ASSEMBLAGE
C
      CALL VERSTP (MODELE,CHARGE,INFOCH,CARELE,MATE,TIME,COMPOR,
     &             VTEMP,VTEMP,VHYDR,VHYDRP,TMPCHI,TMPCHF,VERESI)
      CALL ASASVE (VERESI,NUMEDD,TYPRES,VARESI)
      CALL ASCOVA('D',VARESI,BIDON,'INST',RBID ,TYPRES,CNRESI)
      CALL JEVEUO (CNRESI(1:19)//'.VALE','L',JVARE)
C
C --- BT LAMBDA - CALCUL ET ASSEMBLAGE
C
      CALL VETHBT (MODELE,CHARGE,INFOCH,CARELE,MATE,VTEMP,VEBTLA)
      CALL ASASVE (VEBTLA,NUMEDD,TYPRES,VABTLA)
      CALL ASCOVA('D',VABTLA,BIDON,'INST',RBID ,TYPRES,CNVABT)
      CALL JEVEUO (CNVABT(1:19)//'.VALE','L',JBTLA)
C
C --- B . TEMPERATURE - CALCUL ET ASSEMBLAGE
C
      CALL VETHBU (MODELE,CHARGE,INFOCH,CARELE,MATE,VTEMP,VEBUEM)
      CALL ASASVE (VEBUEM,NUMEDD,TYPRES,VABUEM)
      CALL ASCOVA('D',VABUEM,BIDON,'INST',RBID ,TYPRES,CNVABU)
      CALL JEVEUO (CNVABU(1:19)//'.VALE','L',JBUEM)
C
      DO 130 K = 1,LONCH
        ZR(JTEMPP+K-1) = ZR(J2ND+K-1) - ZR(JVARE+K-1) + ZR(JDIRP+K-1)
     &                 - ZR(JBTLA+K-1)- ZR(JBUEM+K-1)
 130  CONTINUE
C
C --- RESOLUTION (VTEMPP CONTIENT LE SECOND MEMBRE, CHSOL LA SOLUTION)
C
      CALL RESOUD(MATASS,MAPREC,VTEMPP,SOLVEU,CNCHCI,'V',CHSOL,CRITER,0,
     &            RBID,CBID,.TRUE.)
C
C --- RECOPIE DANS VTEMPM DU CHAMP SOLUTION CHSOL
C
      CALL COPISD('CHAMP_GD','V',CHSOL,VTEMPM(1:19))
      CALL JEVEUO(VTEMPM(1:19)//'.VALE','E',JTEMPM)
      DO 140 K = 1,LONCH
        ZR(JTEMPM+K-1) = ZR(JTEMPM+K-1) + ZR(JTEMP+K-1)
 140  CONTINUE
C
      ELSE
C
C=======================================================================
C  INITIALISATION POUR LE PREMIER PAS, CALCUL TRANSITOIRE, PAS COURANT
C=======================================================================
C
      DO 150 K = 1,LONCH
        ZR(JTEMPP+K-1) = ZR(J2NI+K-1) + ZR(JDIRP+K-1)
 150  CONTINUE
C
C --- RESOLUTION (VTEMPP CONTIENT LE SECOND MEMBRE, CHSOL LA SOLUTION)
C
      CALL RESOUD(MATASS,MAPREC,VTEMPP,SOLVEU,CNCHCI,'V',CHSOL,CRITER,0,
     &            RBID,CBID,.TRUE.)
C
C --- RECOPIE DANS VTEMPM DU CHAMP SOLUTION CHSOL
C
      CALL COPISD('CHAMP_GD','V',CHSOL,VTEMPM(1:19))
C
      ENDIF
C
      CALL JEDEMA()
      END
