      SUBROUTINE PERMEA(IMATE,HYDR,PHI,T,SAT,NCON,COND)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 29/09/2006   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C TOLE CRP_20
C TOLE CRP_21
C ARGUMENTS DE SORTIE
C   COND(1) : KINT
C   COND(2) : PERMLIQ
C   COND(3) : D(PERMLIQ)/DSAT
C   COND(4) : PERMGAZ
C   COND(5) : D(PERMGAZ)/DSAT
C   COND(6) : D(PERMGAZ)/DPGAZ
C   COND(7) : FICK
C   COND(8) : D(FICK)/DTEMP
C   COND(9) : D(FICK)/DPGAZ
C   COND(10) : CONDSOLI = CONDUCTIVITE THERMIQUE SOLIDE
C   COND(11) : D(CONDSOLI)/DTEMP
C   COND(12) : CONDLIQ= CONDUCTIVITE THERMIQUE LIQUIDE
C   COND(13) : D(CONDLIQ)/DTEMP
C   COND(14) : CONDGAZ= CONDUCTIVITE THERMIQUE GAZ
C   COND(15) : D(CONDGAZ)/DTEMP
C
      IMPLICIT NONE
C
      INTEGER IMATE, NCON , NC
      PARAMETER     ( NC = 1)
      REAL*8         T,PHI,VALPAR(2),SAT
      CHARACTER*16   HYDR
      CHARACTER*8    NOMPAR(2)
      REAL*8         COND(NCON),CONRED(NC)

      CHARACTER*2   CODRET(NC)
      CHARACTER*8   NCRA1(NC),NCRA2(NC),NCRA3(NC),NCRA4(NC)
      DATA NCRA1 / 'PERM_IN' /
C     LAMBDA SOLIDE :
      DATA NCRA2 / 'LAMBDA' /
C     LAMBDA LIQUIDE :
      DATA NCRA3 / 'LAMBDA' /
C     LAMBDA GAZ :
      DATA NCRA4 / 'LAMBDA' /

      IF (HYDR.EQ.'HYDR') THEN

         CALL U2MESS('F','ALGORITH9_80')

         NOMPAR(1)='PORO'
         NOMPAR(2)='TEMP'
         VALPAR(1)=PHI
         VALPAR(2)=T
         CALL RCVALA(IMATE,' ','THM_DIFFU',2,NOMPAR,VALPAR,
     &             NC,NCRA1,CONRED,CODRET,'FM')
         COND(1)=CONRED(1)
         COND(2)=SAT
         COND(3)=1.D0
         COND(4)=1.D0-SAT
         COND(5)=-1.D0
         COND(6)=0.D0
         COND(7)=1.D-7
         COND(8)=0.D0
         COND(9)=0.D0
         CALL RCVALA(IMATE,' ','THM_DIFFU',2,NOMPAR,VALPAR,
     &             NC,NCRA2,CONRED,CODRET,'FM')
         COND(10)=CONRED(1)
         COND(11)=0.D0
         CALL RCVALA(IMATE,' ','THM_LIQU',2,NOMPAR,VALPAR,
     &             NC,NCRA3,CONRED,CODRET,'FM')
         COND(12)=CONRED(1)
         COND(13)=0.D0
         CALL RCVALA(IMATE,' ','THM_GAZ',2,NOMPAR,VALPAR,
     &             NC,NCRA4,CONRED,CODRET,'FM')
         COND(14)=CONRED(1)
         COND(15)=0.D0
      ENDIF

      END
