      SUBROUTINE PJELGA(NOMO2,CHAM1,LIGRE1,PROL0,
     &             CORRES,LERES1,LIGRE2,IRET)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 04/11/2011   AUTEUR MACOCCO K.MACOCCO 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
C RESPONSABLE BERARD A.BERARD
C
C  COMMANDE:  PROJ_CHAMP
C  ROUTINE "CHAPEAU" CONCERNANT LA PROJECTION DE CHAM_ELEM (ELGA)
C                                  *  *                     ****
C
C  ELLE EST CONSTITUEE DE TROIS TEMPS
C    APPEL A ECLPGC (ECLATEMENT DU CHAMP)
C    APPEL A PJXXCH (USUEL POUR TOUS LES CHAMPS, CF. OP0166 OU PJXXPR)
C    APPEL A PJCORR (RETOUR AUX POINTS DE GAUSS)

C
      IMPLICIT   NONE
C
C 0.1. ==> ARGUMENTS
C
      CHARACTER*8 NOMO2,PROL0
      CHARACTER*16 CORRES
      CHARACTER*19 CHAM1,LIGRE1
      CHARACTER*19 LERES1,LIGRE2
      INTEGER IRET
C
C 0.3. ==> VARIABLES LOCALES
C
C
      INTEGER NNCP
      CHARACTER*8 MA1P
      CHARACTER*8 NOMPAR
      CHARACTER*16 OPTION
      CHARACTER*19 CHAM1E,CHAUXS,CHBID
      CHARACTER*19 PRFCHN
      CHARACTER*19 CNS1,CH2S
      CHARACTER*24 NOMFPG

      INTEGER JCNSV,IBID


C DEB ------------------------------------------------------------------
      CALL JEMARQ()
      CALL INFMAJ()
      CALL TITRE

      CHBID=CHAM1
      NOMFPG='&&OP0166.NOMFPG'
      CALL CELFPG(CHAM1,NOMFPG,IRET)

C     -- ON RECUPERE LE NOM DE L'OPTION ET LE NOM DU PARAMETRE
C        POUR LE CHAM_ELEM VIVANT SUR LE MAILLAGE 1

      CALL DISMOI ( 'F', 'NOM_OPTION', CHAM1, 'CHAM_ELEM',
     &              IBID, OPTION, IBID )

      CALL DISMOI ( 'F', 'NOM_PARAM', CHAM1, 'CHAM_ELEM',
     &              IBID, NOMPAR, IBID )


C     -- ECLATEMENT DU CHAMP VIVANT SUR LE MAILLAGE 1
C        EN UN CHAMP VIVANT SUR LE MAILLAGE 1 PRIME (MAILLAGE ECLATE)

      MA1P='&&PJELC1'
      CHAM1E='&&PJELGA'//'.CHAM1E'

      PRFCHN = '&&PJELGA.PRFCHN'
      CALL ECLPGC(CHAM1,CHAM1E,LIGRE1,MA1P,PRFCHN,NOMFPG)

      CHAUXS = '&&PJELGA'//'.CHAS'
      CALL PJXXCH(CORRES,CHAM1E,
     &            CHAUXS,' ',PROL0,' ','G',IRET)

C     -- ON TRANSFORME LE CHAMP_NO PROJETE EN UN CHAM_NO_S

      CNS1 = '&&OP0166'//'.CH1S'
      CALL CNOCNS(CHAUXS,'G',CNS1)
      CALL JEVEUO(CNS1//'.CNSV','L',JCNSV)


C IL FAUT MAINTENANT REVENIR AUX CHAM_ELEM (ELGA)

      CH2S = '&&OP0166'//'.CH2S'

      CALL PJCORR(NOMO2,CHBID,CNS1,CH2S,
     &      LIGRE2,CORRES,OPTION,NOMPAR,IRET)

      CALL CESCEL(CH2S,LIGRE2,OPTION,NOMPAR,PROL0,
     &           NNCP,'G',LERES1,'A',IRET)


      CALL DETRSD('MAILLAGE',MA1P)
      CALL DETRSD('CHAM_NO_S',CNS1)

      CALL DISMOI('F','PROF_CHNO',CHAM1E,'CHAM_NO',IBID,PRFCHN,IBID)
      CALL DETRSD('PROF_CHNO',PRFCHN)
      CALL DETRSD('CHAM_NO',CHAM1E)

      CALL DISMOI('F','PROF_CHNO',CHAUXS,'CHAM_NO',IBID,PRFCHN,IBID)
      CALL DETRSD('PROF_CHNO',PRFCHN)
      CALL DETRSD('CHAM_NO',CHAUXS)

      CALL JEDEMA()
      END
