      SUBROUTINE PLOINT(VESTO,MODMEC,CHAMNO,NUM,
     &                  I,VRAI,MODEL,VEPRJ,MODX,MODY,MODZ)
C------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/03/2004   AUTEUR REZETTE C.REZETTE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
C
C ROUTINE PROJETANT LA PRESSION ET LES DEPLACEMENTS SUR L'INTERFACE
C
C IN : MODMEC : NOM DU CONCEPT MODE_MECA
C IN : CHAMNO : CHAMNO DE DEPL_R
C IN : NUM : NUMEROTATION DES DDLS SUR MODELE INTERFACE
C IN: I : INDICE DE BOUCLES
C IN : VRAI : LOGICAL DISTINGUANT MODAL ET CHAMNO IMPOSE
C IN : MODEL : K2 :CHARACTER DISTINGUANT LE TYPE DE MODELE 2D OU 3D
C OUT :  VEPRJ : CHAMP DE PRESSION PROJETE
C OUT : MODX : CHAMP DES DEPLACEMENTS SUIVANT X
C OUT :  MODY : CHAMP DES DEPLACEMENTS SUIVANT Y
C OUT :  MODZ : CHAMP DES DEPLACEMENTS SUIVANT Z
C
C------------------------------------------------------------------
C----------- DEBUT DES COMMUNS JEVEUX -----------------------------
      CHARACTER*32     JEXNUM, JEXNOM, JEXR8, JEXATR
      INTEGER          ZI
      COMMON  /IVARJE/ ZI(1)
      REAL*8           ZR
      COMMON  /RVARJE/ ZR(1)
      COMPLEX*16       ZC
      COMMON  /CVARJE/ ZC(1)
      LOGICAL          ZL
      COMMON  /LVARJE/ ZL(1)
      CHARACTER*8      ZK8
      CHARACTER*16           ZK16
      CHARACTER*24                    ZK24
      CHARACTER*32                            ZK32
      CHARACTER*80                                    ZK80
      COMMON  /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C----------- FIN DES COMMUNS JEVEUX ------------------------------

      LOGICAL       VRAI
      INTEGER       IPRES,I,IRET
      CHARACTER*8   K8BID,TCORX(2),TCORY(2),TCORZ(2)
      CHARACTER*(*) MODMEC,CHAMNO,MODEL
      CHARACTER*14  NUM
      CHARACTER*19  VESTO,MODX,MODY,MODZ,VEPRJ
      CHARACTER*24  NOMCHA,NOCHAM
C-----------------------------------------------------------------
C
C-- PLONGEMENT DES VECTEURS PRESSIONS  POUR CHAQUE MODE SUR LE
C                          MODELE INTERFACE
C

      CALL JEMARQ()
           MODZ=' '
           VEPRJ = 'VEPRJ'
           CALL CHNUCN(VESTO,NUM,0,K8BID,'V',VEPRJ)
           CALL JEVEUO(VEPRJ//'.VALE','L',IPRES)


C---------------- PLONGEMENT DES MODES OU CHAMNO
C-------------PAR COMPOSANTES SUR LE MODELE INTERFACE

           IF (VRAI) THEN

              CALL RSEXCH(MODMEC,'DEPL',I,NOMCHA,IRET)
              NOCHAM = NOMCHA

           ELSE

              NOCHAM = CHAMNO

           ENDIF

C----- PLONGEMENT DE LA COMPOSANTE DX QUI DEVIENT TEMPERATURE

           TCORX(1) = 'DX'
           TCORX(2) = 'TEMP'
           MODX = 'MODX'
           CALL CHNUCN(NOCHAM,NUM,2,TCORX,'V',MODX)

C----- PLONGEMENT DE LA COMPOSANTE DY QUI DEVIENT TEMPERATURE

           TCORY(1) = 'DY'
           TCORY(2) = 'TEMP'
           MODY = 'MODY'
           CALL CHNUCN(NOCHAM,NUM,2,TCORY,'V',MODY)

C----- PLONGEMENT DE LA COMPOSANTE DZ QUI DEVIENT TEMPERATURE

        IF(MODEL.EQ.'3D') THEN
           TCORZ(1) = 'DZ'
           TCORZ(2) = 'TEMP'
           MODZ = 'MODZ'
           CALL CHNUCN(NOCHAM,NUM,2,TCORZ,'V',MODZ)
        ENDIF

      CALL JEDEMA()
          END
