      SUBROUTINE PMDECO(PARCRI,SDDISC,ITERAT,NUMINS,ITEMAX,LICCVG,
     &                                                       ACTION)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 19/10/2010   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE PROIX J-M.PROIX
C
      IMPLICIT NONE
      INTEGER      ACTION,ITERAT
      INTEGER      NUMINS,LICCVG(5)
      CHARACTER*19 SDDISC   
      REAL*8       PARCRI(*)  
      LOGICAL      ITEMAX
C
C ----------------------------------------------------------------------
C
C ROUTINE OP0033 (CALC_POINT_MAT)
C
C GESTION DE LA DECOUPE DU PAS DE TEMPS, IDEM NMDECO MAIS SANS SDTIME
C      
C ----------------------------------------------------------------------
C
C
C IN  PARCRI : CRITERES DE CONVERGENCE
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  ITERAT : NUMERO D'ITERATION DE NEWTON
C IN  NUMINS : NUMERO D'INSTANTS
C IN  ITEMAX : NOMBRE D'ITERATIONS MAXI ATTEINT
C IN  LICCVG : CODES RETOURS D'ERREUR
C              (2) : INTEGRATION DE LA LOI DE COMPORTEMENT
C                  = 0 OK
C                  = 1 ECHEC DANS L'INTEGRATION : PAS DE RESULTATS
C                  = 3 SIZZ NON NUL (DEBORST) ON CONTINUE A ITERER
C              (5) : MATRICE DU SYSTEME 
C                  = 0 OK
C                  = 1 MATRICE SINGULIERE
C OUT ACTION : CODE RETOUR ACTION
C               0 ARRET DU CALCUL
C               1 NOUVEAU PAS DE TEMPS
C               2 ON FAIT DES ITERATIONS DE NEWTON EN PLUS
C               3 ON FINIT LE PAS DE TEMPS
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C 
      INTEGER  RETOUR,IBID,NOCC,IOCC,IFM,NIV,I,IDIV
      LOGICAL  ARRET,ERROR
      REAL*8   R8B
      CHARACTER*8 K8B,TXT,LCRIT
      CHARACTER*16 NOMDIV(2),EVEN
C 
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFMAJ
      CALL INFNIV(IFM,NIV)
C
C --- INITIALISATIONS
C
      ARRET  = (NINT(PARCRI(4)).EQ.0)
      ACTION = 0

      ERROR=.FALSE.
      IF (LICCVG(2).EQ.1) THEN
        CALL U2MESS('I','COMPOR1_9')
        ERROR = .TRUE.
      ELSEIF (LICCVG(5).EQ.1) THEN
        CALL U2MESS('I','COMPOR2_4')
        ERROR = .TRUE.
      ENDIF

C     ENREGISTREMENT DES ERREURS
C          'DIVERGENCE_ITER' SI ITEMAX 
C          'DIVERGENCE_ERRE' SI ERROR
      CALL UTDIDT('L',SDDISC,'ECHE',IBID,'NB_OCC',R8B,NOCC,K8B)
      NOMDIV(1)='DIVERGENCE_ITER'
      NOMDIV(2)='DIVERGENCE_ERRE'
      DO 444 I=1,2
C       RECHERCHE DU N D'OCCURENCE DE L'EVENEMENT NOMDIV(I)
        DO 30 IOCC=1,NOCC
          CALL UTDIDT('L',SDDISC,'ECHE',IOCC,'NOM_EVEN',R8B,IBID,EVEN)
          IF (EVEN.EQ.NOMDIV(I)) IDIV = IOCC
 30     CONTINUE
        TXT = 'NON'
        IF (I.EQ.1.AND.ITEMAX.OR.I.EQ.2.AND.ERROR) TXT = 'OUI'
C       ECRITURE DE LA VERIFICATION DE CET EVENEMENT
        CALL UTDIDT('E',SDDISC,'ECHE',IDIV,'VERIF_EVEN',R8B,IBID,TXT)
 444  CONTINUE

C

C     A LA 1ERE CAUSE D'ECHEC VERIFIEE, ON SORT DE LA BOUCLE -> IOCC
      DO 10 IOCC =1,NOCC
        CALL UTDIDT('L',SDDISC,'ECHE',IOCC,'VERIF_EVEN',R8B,IBID,LCRIT)
        IF (LCRIT.EQ.'OUI') GOTO 20
 10   CONTINUE

 20   CONTINUE

C     VERIFICATION QU'IL A EU AU MOINS UNE CAUSE D'ECHEC
      CALL ASSERT(LCRIT.EQ.'OUI')
C
C --- DECOUPE DU PAS DE TEMPS
      CALL DIDECO(SDDISC,NUMINS,ITERAT,IOCC,RETOUR)

      IF (RETOUR.EQ.0)  THEN
C      
C ---   LA SUBDIVISION S'EST BIEN PASSEE
        ACTION = 1

      ELSE IF (RETOUR.EQ.3) THEN
C      
C ---   AUTORISATION DE FAIRE DES ITERATIONS DE NEWTON EN PLUS  
        ACTION = 2
        ITEMAX = .FALSE.

      ELSEIF ((RETOUR.EQ.1).AND.(.NOT.ARRET).AND.ITEMAX) THEN
C
C ---   ON VA A LA SUBDIVISION OU AU PAS DE TEMPS SUIVANT
        ACTION = 3

      ELSEIF ((RETOUR.EQ.2).AND.(.NOT.ARRET)) THEN
C
C ---   ON VA A LA SUBDIVISION OU AU PAS DE TEMPS SUIVANT 
        ACTION = 3

      ELSE
C
C ---  ARRET DU CALCUL        
        ACTION = 0
        CALL U2MESS('A','MECANONLINE_83')        
      ENDIF      
C
      CALL JEDEMA()
      END
