      SUBROUTINE PREP2(NDIM,NPG,G,RPA,ETDPN1,SIGM,JM,FDA,
     &            RP,RPAT,ETDM,ETDV,SIGMAM,RPT,EPSM,EPSMM)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 03/05/2010   AUTEUR PROIX J-M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
      IMPLICIT NONE
      INTEGER NDIM,NPG,G,I,J
      REAL*8 RPA(3,3),RPAT(3,3),ETDPN1(3,3)
      REAL*8 WORK(9),ETDM(3,3),RAC2,ETDV(6)
      REAL*8 SIGM(2*NDIM,NPG),SIGMM(3,3),JM
      REAL*8 TAU(3,3),FDA(3,3),FDAT(3,3)
      REAL*8 RP(3,3),RPT(3,3),CONTM(3,3)
      REAL*8 SIGMAM(6),EPSM(6),EPSMM(6),EPSMT(3,3),EPSMP(3,3)

C ----------------------------------------------------------------------
C   G       : NUMERO DU POINT DE GAUSS COURANT
C   NDIM    : DIMENSION DE L'ESPACE
C   NPG     : NOMBRE DE POINTS DE GAUSS
C   JM      : DETERMINANT DE FM
C   RPA     : 
C   SIGM    : CONTRAINTES DE CAUCHY EN T-
C   FDA     :  TENSEUR DE DEFORMATION ENTRE CONFIGURATION T- ET 
C             CONFIGURATION INTERMEDIAIRE
C   ETDPN1  : 
C   TAU     : CONTRAINTYE DE CAUCHY



C   SORTIE:
C   RPAT    : TRANSPOSEE DE RPA
C   SIGMM   : MATRICE CORRESPONDANT AU VECTEUR SIGM
C   FDAT    : TRANSPOSEE DU TENSEUR DE DEFORMATION ENTRE CONFIGURATION 
C             T- ET CONFIGURATION INTERMEDIAIRE
C   CONTM   : TENSEUR DES CONTRAINTES TRANSFORME POUR ENTREE DE NMCOMP
C   SIGMAM  : TENSEUR DE DEFORMATION TRANSFORME POUR ENTREE DE NMCOMP
C ----------------------------------------------------------------------
C
C     CALCUL DES ENTREE DE NMCOMP CONTM ET SIGMAM POUR GDEF_HYPO_ELAS
C
C ----------------------------------------------------------------------

C--------------------------INITIALISATION-------------------------------
      CALL R8INIR(9,0.D0,RPAT,1)
      CALL R8INIR(9,0.D0,ETDM,1)
      CALL R8INIR(9,0.D0,SIGMM,1)
      CALL R8INIR(9,0.D0,TAU,1)
      CALL R8INIR(9,0.D0,RPT,1)
      CALL R8INIR(9,0.D0,CONTM,1)
      CALL R8INIR(6,0.D0,ETDV,1)
      CALL R8INIR(6,0.D0,SIGMAM,1)
      
      RAC2=SQRT(2.D0)
C     TRANSPOSITION DE R~_N+ALPHA=RPA EN RPAT
      CALL LCTR2M(3,RPA,RPAT)
      CALL UTBTAB('ZERO',3,3,ETDPN1,RPAT,WORK,ETDM)      
      
C     TRANSFORMATION MATRICE EN VECTEUR DE e~_(n+ALPHA)
      CALL TNSVEC(3,NDIM,ETDM,ETDV,RAC2)

C     TRANSF MATRICE EN VECTEUR DES CONTRAINTES 

      CALL TNSVEC(6,NDIM,SIGMM, SIGM(1,G),1.D0)
      
C     TENSEUR DE KIRCHHOFF
      DO 300 I=1,3
         DO 310 J=1,3
            TAU(I,J)= JM*SIGMM(I,J)
 310     CONTINUE
 300  CONTINUE

      CALL LCTR2M(3,FDA,FDAT)

C     TRANSPOSITION DE R_N+1=RPT
      CALL LCTR2M(3,RP,RPT)
      
C  CALCUL DE CONTRAINTE ENTREE DE NMCOMP ET TRANSFORMATION EN VECTEUR
      CALL UTBTAB('ZERO',3,3,TAU,RPT,WORK,CONTM)
      CALL TNSVEC(3,NDIM,CONTM,SIGMAM,RAC2)

C ajout transforation de EPSM (pour certaines lois comme vendochab)
      CALL TNSVEC(6,NDIM,EPSMT,EPSM,1.D0)
      CALL UTBTAB('ZERO',3,3,EPSMT,RPT,WORK,EPSMP)
      CALL TNSVEC(3,NDIM,EPSMP,EPSMM,RAC2)

      END
