        SUBROUTINE RDIF01( FAMI,KPG,KSP,
     &                     COMP,   MOD,   IMAT,   MATCST,NBCOMM,
     &                     CPMONO,NBFSYM,TOUTMS, NVI,    NMAT, VINI,
     &                     COTHE, COEFF, DCOTHE, DCOEFF,PGL,NBPHAS, E,
     &                     NU,    ALPHA, COEL,X,   DTIME,  SIGI,
     &                     EPSD,  DETOT,
     &                     DVIN, HSR, ITMAX, TOLER, IRET )
        IMPLICIT NONE
C       ================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 20/12/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C TOLE CRP_21 CRS_1404
C       ----------------------------------------------------------------
C       ROUTINE D AIGUILLAGE
C       ----------------------------------------------------------------
C       INTEGRATION DE LOIS DE COMPORTEMENT ELASTO-VISCOPLASTIQUE
C       PAR UNE METHODE DE RUNGE KUTTA
C       ----------------------------------------------------------------
C       IN  FAMI    FAMILLE DE POINT DE GAUSS (RIGI,MASS,...)
C       IN  KPG,KSP NUMERO DU (SOUS)POINT DE GAUSS
C       IN  COMP     :  NOM DU MODELE DE COMPORTEMENT
C           MOD     :  TYPE DE MODELISATION
C           IMAT    :  ADRESSE DU MATERIAU CODE
C           MATCST  :  NATURE DES PARAMETRES INELASTIQUES
C           NVI     :  NOMBRE DE VARIABLES INTERNES
C           NMAT    :  NOMBRE DE PARAMETRES MATERIAU INELASTIQUE
C           VINI    :  VARIABLES INTERNES A T
C           COTHE   :  COEFFICIENTS MATERIAU ELASTIQUE A T
C           COEFF   :  COEFFICIENTS MATERIAU INELASTIQUE A T
C           DCOTHE  :  DELTA COEFFICIENTS MATERIAU ELASTIQUE A T+DT
C           DCOEFF  :  DELTA COEFFICIENTS MATERIAU INELASTIQUE A T+DT
C           E       :  COEFFICIENT MODULE D'YOUNG
C           NU      :  COEFFICIENT DE POISSON
C           ALPHA   :  COEFFICIENT DE DILATION THERMIQUE
C           X       :  INTERVALE DE TEMPS ADAPTATIF
C           DTIME   :  INTERVALE DE TEMPS
C           SIGI    :  CONTRAINTES A L'INSTANT COURANT
C           EPSD    :  DEFORMATION TOTALE A T
C           DETOT   :  INCREMENT DE DEFORMATION TOTALE
C           DVIN    :  DERIVEES DES VARIABLES INTERNES A T
C       ----------------------------------------------------------------
        INTEGER KPG,KSP,IMAT,I,NMAT,NVI,NBCOMM(NMAT,3),NCOE,
     &          NBPHAS,NBFSYM,IRET,ITMAX
        CHARACTER*16 LOI,COMP(*),CPMONO(5*NMAT+1)
        CHARACTER*8 MOD
        CHARACTER*(*) FAMI
        CHARACTER*3 MATCST
        REAL*8 E, NU, ALPHA,PGL(3,3),TOLER
        REAL*8 X, DTIME,COEL(NMAT)
        REAL*8 COTHE(NMAT),DCOTHE(NMAT)
        REAL*8 COEFF(NMAT),DCOEFF(NMAT)
        REAL*8 SIGI(6),EPSD(6),DETOT(6)
        REAL*8 COEFT(NMAT)
        REAL*8 VINI(NVI)
        REAL*8 DVIN(NVI),HSR(5,24,24)
C       POUR GAGNER EN TEMPS CPU
        REAL*8 TOUTMS(NBPHAS,NBFSYM,24,6)
C
        LOI=COMP(1)
        IF (LOI(1:8).EQ.'MONOCRIS') THEN
           NCOE=NBCOMM(NMAT,3)
          CALL COEFFT(NCOE,COTHE,COEFF,DCOTHE,DCOEFF,X,DTIME,COEFT,
     &                E,NU,ALPHA,NMAT,COEL)
          CALL LCMMON(FAMI,KPG,KSP,COMP,NBCOMM,CPMONO,NMAT,NVI,VINI,
     &     X,DTIME,E,NU,ALPHA,PGL,MOD,COEFT,SIGI,EPSD,DETOT,
     &     COEL,DVIN,HSR,ITMAX,TOLER,IRET)

        ELSEIF (LOI(1:8).EQ.'POLYCRIS') THEN
           NCOE=NBCOMM(NMAT,3)
          CALL COEFFT(NCOE,COTHE,COEFF,DCOTHE,DCOEFF,X,DTIME,COEFT,
     &                E,NU,ALPHA,NMAT,COEL)
          CALL LCMMOP(FAMI,KPG,KSP,COMP,NBCOMM,CPMONO,NMAT,NVI,
     &     VINI,X,DTIME,E,NU,ALPHA,PGL,MOD,COEFT,SIGI,EPSD,DETOT,
     &     COEL,NBPHAS,NBFSYM,TOUTMS,DVIN,HSR,ITMAX,TOLER,IRET)

        ELSEIF (LOI(1:9).EQ.'VISCOCHAB') THEN
          NCOE=25
            CALL COEFFT(NCOE,COTHE,COEFF,DCOTHE,DCOEFF,X,DTIME,COEFT,
     &                E,NU,ALPHA,NMAT,COEL)
          CALL RKDCHA(FAMI,KPG,KSP,MOD,NVI,VINI,COEFT,E,NU,ALPHA,X,
     &                DTIME,NMAT,COEL,SIGI,EPSD,DETOT,DVIN)
        ELSE  IF (LOI(1:9).EQ.'VENDOCHAB') THEN
          NCOE=9
            CALL COEFFT(NCOE,COTHE,COEFF,DCOTHE,DCOEFF,X,DTIME,COEFT,
     &                E,NU,ALPHA,NMAT,COEL)
          CALL RKDVEC(FAMI,KPG,KSP,MOD,IMAT,MATCST,NVI,VINI,COEFT,E,NU,
     &                ALPHA,X,DTIME,NMAT,COEL,SIGI,EPSD,DETOT,
     &                DVIN)
        END IF
        END
