      SUBROUTINE REDNEX(NUMEDD,NEQ   ,RESOCO)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/12/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT  NONE
      INTEGER      NEQ
      CHARACTER*24 NUMEDD,RESOCO
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - APPARIEMENT - UTILITAIRE)
C
C STOCKER LES NOM DES NOEUDS ET DES DDLS IMPLIQUES DANS
C UNE EQUATION DE SYSTEME LINEAIRE DE TYPE DDL_IMPO
C EN VUE DU TRAITEMENT AUTOMATIQUE DES
C RELATIONS SURABONDANTES AVEC LE CONTACT
C
C ----------------------------------------------------------------------
C
C
C IN  NUMEDD : NOM DE LA NUMEROTATION MECANIQUE
C IN  NEQ    : NOMBRE D'EQUATIONS DU SYSTEME
C IN  RESOCO : SD POUR LA RESOLUTION DE CONTACT
C    OUT: VECNOD = RESOCO(1:14)//'.VECNOD'
C    OUT: VECNOX = RESOCO(1:14)//'.VECNOX'
C    OUT: VECNOY = RESOCO(1:14)//'.VECNOY'
C    OUT: VECNOZ = RESOCO(1:14)//'.VECNOZ'
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER       IDEEQ,I,II,ITYP
      CHARACTER*24   DEEQ
      CHARACTER*24  VECNOD,VECNOX,VECNOY,VECNOZ
      INTEGER       JVECNO,JVECNX,JVECNY,JVECNZ
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- ACCES AUX STRUCTURES DE DONNEES POUR LA
C --- GESTION AUTOMATIQUE DES RELATIONS REDONDANTES
C
      VECNOD = RESOCO(1:14)//'.VECNOD'
      VECNOX = RESOCO(1:14)//'.VECNOX'
      VECNOY = RESOCO(1:14)//'.VECNOY'
      VECNOZ = RESOCO(1:14)//'.VECNOZ'
      CALL JEVEUO(VECNOD,'E',JVECNO)
      CALL JEVEUO(VECNOX,'E',JVECNX)
      CALL JEVEUO(VECNOY,'E',JVECNY)
      CALL JEVEUO(VECNOZ,'E',JVECNZ)
C
C --- INITIALISATIONS
C
      DO 10 I = 1, NEQ
        ZI(JVECNX-1+I) = 0
        ZI(JVECNY-1+I) = 0
        ZI(JVECNZ-1+I) = 0
        ZI(JVECNO-1+I) = 0
 10   CONTINUE
C
C --- ACCES NUME_DDL
C
      DEEQ = NUMEDD(1:14)//'.NUME.DEEQ'
      CALL JEVEUO(DEEQ,'L',IDEEQ)
C
C -- DETECTION
C
      DO 20 II = 1,NEQ
        ITYP = ZI(IDEEQ-1+2*II)
        IF (ITYP.LT.0) THEN
          ZI(JVECNO+II-1) = ZI(IDEEQ-1+2*II-1)
          IF(ITYP.EQ.-1) ZI(JVECNX+II-1)=1
          IF(ITYP.EQ.-2) ZI(JVECNY+II-1)=1
          IF(ITYP.EQ.-3) ZI(JVECNZ+II-1)=1
        ENDIF
 20   CONTINUE
C
C --- MENAGE
C
      CALL JEDEMA()
      END
