      SUBROUTINE RIGFLU(MODELE,TIME,NOMCMP,TPS,NBCHAR,CHAR,
     +                  MATE,SOLVEZ,MA,NU)
      IMPLICIT NONE
      INTEGER           NBCHAR
      CHARACTER*(*)     MATE,SOLVEZ

C---------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/10/2010   AUTEUR BOITEAU O.BOITEAU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C---------------------------------------------------------------------
C
C
C BUT : CETTE ROUTINE CALCULE LA MATRICE ASSEMBLEE DE RIGIDITE
C       FLUIDE S'APPUYANT SUR UN MODELE THERMIQUE
C     IN : MODELE : NOM DU MODELE FLUIDE UTILISE
C        : TIME   : INSTANT DU CALCUL
C        : NBCHAR : NOMBRE DE CHARGE
C        : CHAR   : NOM DE LA CHARGE
C        : MATE   : CHAMP DE MATERIAU
C        : SOLVEZ : METHODE DE RESOLUTION 'MULT_FRONT','LDLT' OU 'GCPC'
C     OUT: MA     : MATRICE ASSEMBLEE DE RIGIDITE FLUIDE
C        : NU     : NUMEROTATION ASSOCIEE
C----------------------------------------------------------------------
C      ---- DEBUT DES COMMUNS JEVEUX ----------------------------------
      CHARACTER*32     JEXNUM, JEXNOM, JEXR8, JEXATR
      INTEGER          ZI
      COMMON  /IVARJE/ ZI(1)
      REAL*8           ZR
      COMMON  /RVARJE/ ZR(1)
      COMPLEX*16       ZC
      COMMON  /CVARJE/ ZC(1)
      LOGICAL          ZL
      COMMON  /LVARJE/ ZL(1)
      CHARACTER*8      ZK8
      CHARACTER*16           ZK16
      CHARACTER*24                    ZK24
      CHARACTER*32                            ZK32
      CHARACTER*80                                    ZK80
      COMMON  /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C      ---- FIN DES COMMUNS JEVEUX ------------------------------------
      INTEGER       IBID,IALICH,JINF,IERR,NCHAR,IALIFC,NH
      REAL*8        TPS(6),EPS,R8BID
      CHARACTER*16  TYPE(3)
      CHARACTER*14  NU
      CHARACTER*8   K8B,MODELE,NOMCMP(6),CHAR,MA,MEL
      CHARACTER*24  TIME,MODL24,NU24,FOMULT,CARELE
      CHARACTER*72  K72B
      CHARACTER*19  SOLVEU,INFCHA,MAPREC
      COMPLEX*16    C16B
      DATA MAPREC   /'&&OP0152.MAPREC'/
      DATA INFCHA   /'&&OP0152.INFCHA'/
      DATA FOMULT   /'&&OP0152.LIFCTS'/
C   ------------------------------------------------------------------

      MA = '&MATAS'
      NU = '&&RIGFLU.NUM'
      MEL = '&MATEL'
      SOLVEU = SOLVEZ

C-----  CALCUL DE LA MATRICE ELEMENTAIRE DE RAIDEUR DU FLUIDE

      CALL MECACT('V',TIME,'MODELE',MODELE//'.MODELE','INST_R',6,
     +            NOMCMP,IBID,TPS,C16B,K8B)

      CALL MERITH(MODELE,NBCHAR,CHAR,MATE,' ',TIME,
     +            MEL,NH,'V')
C
      CALL GETVID(' ','CHARGE',0,1,1,CHAR,NCHAR)
      CALL WKVECT(INFCHA//'.LCHA','V V K24',NCHAR,IALICH)
      CALL WKVECT(INFCHA//'.INFC','V V IS',4*NCHAR+5,JINF)
      ZI(JINF) = NCHAR
      ZK24(IALICH) = CHAR
      CALL WKVECT(FOMULT,'V V K24',NCHAR,IALIFC)

C----------------  NUMEROTATION

      MODL24 = MODELE
      NU24   = NU
      CALL NUMERO(' ',MODL24,INFCHA,SOLVEU,'VV',NU24)

C---------------- ASSEMBLAGE

      CALL ASMATR(1,MEL,' ',NU,SOLVEU,INFCHA,'ZERO','V',1,MA)

C------- FACTORISATION LDLT DE LA MATRICE DE RAIDEUR

      CALL PRERES(SOLVEU,'V',IERR,MAPREC,MA,IBID,-9999)


C-----------------------------------------------------
 9999 CONTINUE
      END
