      SUBROUTINE SESQUI ( MAT, VECT, NDIM, NORMEC )
      IMPLICIT   NONE
      INTEGER             NDIM
      COMPLEX*16          MAT(*), VECT(NDIM), NORMEC
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/1999   AUTEUR SABJLMA P.LATRUBESSE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C  BUT:  < NORME CARREE >
C
C   CETTE ROUTINE CALCULE LA NORME D'UNE VECTEUR COMPLEXE AU SENS DU
C   PRODUIT SCALAIRE COMPLEXE DEFINI PAR LA MATRICE COMPLEXE MAT
C
C-----------------------------------------------------------------------
C
C MAT      /I/: MATRICE COMPLEXE DEFINISSANT LE PRODUIT SCALAIRE
C VECT     /I/: VECTEUR COMPLEXE A NORMER
C NDIM     /I/: DIMENSION DU VECTEUR ET DE LA MATRICE
C NOR      /O/: NORME CARREE DU VECTEUR
C
C-----------------------------------------------------------------------
      INTEGER     I , J , IDIAG , JDIAG
C-----------------------------------------------------------------------
C
       NORMEC = DCMPLX(0.D0,0.D0)
       DO 10 I = 1, NDIM
          IDIAG = I*(I-1)/2+1
          DO 20 J = 1, NDIM
             IF (J.GE.I) THEN
                JDIAG = J*(J-1)/2+1
                NORMEC = NORMEC + VECT(J)*MAT(JDIAG+J-I)*DCONJG(VECT(I))
             ELSE
                NORMEC = NORMEC + 
     &                   VECT(J)*DCONJG(MAT(IDIAG+I-J))*DCONJG(VECT(I))
             ENDIF
  20      CONTINUE
  10   CONTINUE
C
       END
