      SUBROUTINE SUBAC1(NDIM,AXI,NNO,IPG,IVF,IDFDE,GEOM,COVA)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 29/09/2006   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

      IMPLICIT NONE

      LOGICAL AXI
      INTEGER NDIM,NNO,IVF,IDFDE,IPG
      REAL*8  GEOM(2,NNO)
      REAL*8  COVA(3,3)
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
C.......................................................................
C     CALCUL DE LA BASE COVARIANTE POUR UN ELEMENT LINEIQUE
C.......................................................................
C IN  AXI     TRUE SI AXI, FALSE SI D_PLAN OU C_PLAN
C IN  NNO     NOMBRE DE NOEUDS
C IN  VFF     VALEUR DES FONCTIONS DE FORMES
C IN  DFF     DERIVEE DES F. DE FORME
C IN  GEOM    COORDONNEES DES NOEUDS
C OUT COVA    COORDONNEES DES VECTEURS DE LA BASE COVARAINTE
C.......................................................................

      INTEGER N,I,II,K
      REAL*8  NORME

      DO 10 I = 1,3
        COVA(I,1) = 0.D0
        COVA(I,2) = 0.D0
 10   CONTINUE

      K = NDIM*(IPG-1)*NNO

C    CALCUL DU PREMIER VECTEUR TANGENT
      DO 20 N = 1,NNO
        II = NDIM*(N-1)
        DO 25 I=1,2
          COVA(I,1)=COVA(I,1)+ZR(IDFDE-1+K+II+1)*GEOM(I,N)
 25     CONTINUE
 20   CONTINUE

C    CALCUL DU SECOND VECTEUR TANGENT
      IF (AXI) THEN
        DO 30 N = 1,NNO
          COVA(3,2) = COVA(3,2) + GEOM(1,N)*ZR(IVF-1+N+(IPG-1)*NNO)
 30     CONTINUE
      ELSE
        COVA(3,2) = 1.D0
      END IF

C    CALCUL DE LA NORMALE (PRODUIT VECTORIEL DES VECTEURS TANGENTS)
      COVA(1,3) = COVA(2,1)*COVA(3,2) - COVA(3,1)*COVA(2,2)
      COVA(2,3) = COVA(3,1)*COVA(1,2) - COVA(1,1)*COVA(3,2)
      COVA(3,3) = COVA(1,1)*COVA(2,2) - COVA(2,1)*COVA(1,2)

      NORME = SQRT(COVA(1,3)**2 + COVA(2,3)**2 + COVA(3,3)**2)
      IF (NORME.EQ.0.D0) CALL U2MESS('F','ALGORITH10_77')

      COVA(1,3) = COVA(1,3) / NORME
      COVA(2,3) = COVA(2,3) / NORME
      COVA(3,3) = COVA(3,3) / NORME

      END
