      SUBROUTINE SUBACV(COVA,METR,JAC,CNVA,A)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 30/04/96   AUTEUR WABINSK J.WABINSKI 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================

      IMPLICIT NONE

      REAL*8  COVA(3,3),METR(2,2),JAC
      REAL*8  CNVA(3,2),A(2,2)

C.......................................................................
C     CALCUL DE LA BASE CONTRAVARIANTE (EN DIMENSION 3)
C.......................................................................
C IN  COVA    COORDONNEES DES VECTEURS DE LA BASE COVARAINTE
C IN  METR    TENSEUR METRIQUE (2X2)
C IN  JAC     JACOBIEN DE LA METRIQUE
C OUT CNVA    COORDONNEES DES DEUX VECTEURS CONTRAVARIANTS
C     A       MATRICE PRODUIT SCALAIRE
C.......................................................................

      INTEGER I,J
      REAL*8  R8DOT,DET


C    CALCUL DE LA METRIQUE CONTRAVARIANTE
      DET = JAC**2
      A(1,1) =   METR(2,2) / DET
      A(2,2) =   METR(1,1) / DET
      A(1,2) = - METR(2,1) / DET
      A(2,1) =   A(1,2)


C    CALCUL DES VECTEURS CONTRAVARIANTS
      DO 10 I = 1,3
        CNVA(I,1) = A(1,1)*COVA(I,1) + A(1,2)*COVA(I,2)
        CNVA(I,2) = A(2,1)*COVA(I,1) + A(2,2)*COVA(I,2)
 10   CONTINUE


      END
