      SUBROUTINE TABCOR(MODEL,MATE,MA1,MA2,MOINT,NUM,NDBLE,ICOR)
      IMPLICIT NONE
      CHARACTER*(*) MOINT,MATE
C---------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 14/01/98   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C---------------------------------------------------------------------
C     AUTEUR : G. ROUSSEAU
C     BUT : CREER UNE TABLE DE CORRESPONDANCE ENTRE NOEUDS FLUIDES
C           D'INTERFACE ET NOEUDS DE STRUCTURES POUR DES MAILLAGES
C           STRUCTURES ET FLUIDE DISTINCTS
C     IN: MATE: NOM DU MATERIAU FLUIDE
C     IN: MA1 : MAILLAGE DE LA STRUCTURE
C     IN: MA2 : MAILLAGE DU FLUIDE
C     IN: MOINT: NOM DU MODELE THERMIQUE D INTERFACE
C     IN: NUM: NUMEDDL ASSOCIE A L INTERFACE
C     IN: CMP: COMPOSANTE DE DEPL_R A PLONGER
C     IN: NDBLE: INDICATEUR DE NOEUDS DOUBLES
C     OUT:ICOR(2):ADRESSES JEVEUX DES TABLEAUX DE CORRESPONDANCES
C              NOEUDS SIMPLES
C
C
C---------------------------------------------------------------------
C--------- DEBUT DES COMMUNS JEVEUX ----------------------------------
      CHARACTER*32     JEXNUM, JEXNOM, JEXR8, JEXATR
      INTEGER          ZI
      COMMON  /IVARJE/ ZI(1)
      REAL*8           ZR
      COMMON  /RVARJE/ ZR(1)
      COMPLEX*16       ZC
      COMMON  /CVARJE/ ZC(1)
      LOGICAL          ZL
      COMMON  /LVARJE/ ZL(1)
      CHARACTER*8      ZK8,KBID
      CHARACTER*16           ZK16
      CHARACTER*24                    ZK24
      CHARACTER*32                            ZK32
      CHARACTER*80                                    ZK80
      COMMON  /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C     --- FIN DES COMMUNS JEVEUX ------------------------------------
      LOGICAL       TEST, EXISDG
      INTEGER       NBVALE,NBREFE,NBDESC,IBID,NEQ,IVAL,NBNO1
      INTEGER       I,J,INO1,INO2,ICOR(2),ITB1,ITB2,NCMP2,NBNO2,ICHNUL
      INTEGER       NEC2,IGEOM1,IGEOM2,IERD,IPRN2,INUEQ2,NBID
      INTEGER       NDBLE,NBPTR
      REAL*8        R8BID,EPSI,X1,Y1,Z1,X2,Y2,Z2
      REAL*8        TAILMI,DISTA2,TAILM2
      CHARACTER*2   MODEL
      CHARACTER*8   GD1,GD2,MA1,MA2
      CHARACTER*8   K8BID,REPK
      CHARACTER*14  NUM
      CHARACTER*19  CHNUL,CN1,CN2,PCHNO1,PCHNO2
      CHARACTER*24  PRCHNO
      CHARACTER*1   K1BID
C -----------------------------------------------------------------
       DATA EPSI    /1.D-2/
C---------------------------------------------------------------------
C
C RECUPERATION DE LA TAILLE DE REFERENCE

      CALL GETVR8(' ','DIST_REFE',0,1,1,TAILMI,NBID)
      CALL DISMOI('F','NB_NO_MAILLA',MA2,'MAILLAGE',NBNO2,REPK,IERD)
      TAILM2=(EPSI*TAILMI)**2
C ON CREE UN CHAMNO BIDON SUR L INTERFACE THERMIQUE

        CHNUL='&&TABCOR.CHNUL'
        CALL DISMOI('F','NB_EQUA',NUM,'NUME_DDL',NEQ,K8BID,IERD)
        PRCHNO = NUM//'.NUME'
        CALL CRCHNO(CHNUL,PRCHNO,'TEMP_R',MA2,'V','R',NBNO2,NEQ)
        CALL JEVEUO(CHNUL//'.VALE','E',ICHNUL)


        CN2='&&TABCOR.BIDON'
        CALL CALFLU(CHNUL,MOINT,MATE,NUM,CN2,NBDESC,NBREFE,
     +                 NBVALE,'X')


C
C PARCOURS DU MAILLAGE THERMIQUE D INTERFACE
C

      CALL DISMOI('F','NOM_GD',CN2,'CHAM_NO',IBID,GD2,IERD)

      CALL DISMOI('F','NB_NO_MAILLA',MA1,'MAILLAGE',NBNO1,REPK,IERD)

C CREATION D'UNE TABLE DE CORRESPONDANCES NOEUDS DE STRUCTURE
C AVEC NOEUDS DU FLUIDE DE L'INTERFACE (NOEUDS SIMPLES)

      CALL JECREO('&&TABCOR.CORRE1','V V I')
      CALL JEECRA('&&TABCOR.CORRE1','LONMAX',NBNO1,KBID)
      CALL JEECRA('&&TABCOR.CORRE1','LONUTI',NBNO1,KBID)
      CALL JEVEUT('&&TABCOR.CORRE1','E',ITB1)
      ICOR(1)=ITB1

C SI IL Y A DES NOEUDS DOUBLES

      IF (NDBLE.EQ.1) THEN
        CALL JECREO('&&TABCOR.CORRE2','V V I')
        CALL JEECRA('&&TABCOR.CORRE2','LONMAX',NBNO1,KBID)
        CALL JEECRA('&&TABCOR.CORRE2','LONUTI',NBNO1,KBID)
        CALL JEVEUT('&&TABCOR.CORRE2','E',ITB2)
        ICOR(2)=ITB2
      ENDIF



C      DO 2 I=1,NBRF

C2     CONTINUE


C RECUPERATION DES CARACTERISTIQUES DU CHAMP AUX NOEUDS DE
C L'INTERFACE

      CALL DISMOI('F','PROF_CHNO',CN2,'CHAM_NO',IBID,PCHNO2,IERD)
      CALL JENONU(JEXNOM(PCHNO2//'.LILI','&MAILLA'),IBID)
      CALL JEVEUO(JEXNUM(PCHNO2//'.PRNO',IBID),'L',IPRN2)
      CALL DISMOI('F','NB_EC',GD2,'GRANDEUR',NEC2,REPK,IERD)
      CALL JEVEUO(PCHNO2//'.NUEQ','L',INUEQ2)

C RECUPERATION DES COORDONNEES DU MAILLAGE

      CALL JEVEUO(MA2//'.COORDO    .VALE','L',IGEOM2)
      CALL JEVEUO(MA1//'.COORDO    .VALE','L',IGEOM1)

C PARCOURS SUR LES NOEUDS DU MAILLAGE STRUCTURE
C ON REPERE LES NOEUDS COINCIDENTS GEOMETRIQUEMENT
C AVEC LES NOEUDS DE L INTERFACE FLUIDE

      DO 10, INO1 =1,NBNO1

            X1 = ZR(IGEOM1 -1 + (INO1 -1)*3 +1)
            Y1 = ZR(IGEOM1 -1 + (INO1 -1)*3 +2)
            IF(MODEL.EQ.'3D')THEN
             Z1 = ZR(IGEOM1 -1 + (INO1 -1)*3 +3)
            ENDIF

C PARCOURS SUR LES NOEUDS DU MAILLAGE FLUIDE
C ON REPERE LES NOEUDS COINCIDENTS GEOMETRIQUEMENT
C AVEC LES NOEUDS DE LA STRUCTURE ET ON RECOPIE
C LE NOEUD COINCIDENT DS LE TABLEAU DE CORRESPONDANCE

           NBPTR=0
           DO 20, INO2 =1,NBNO2

              NCMP2= ZI(IPRN2-1+ (INO2-1)* (NEC2+2)+2)
              IF (NCMP2.EQ.0) GOTO 20

C CRITERE GEOMETRIQUE DE PROXIMITE

              X2 = ZR(IGEOM2 -1 + (INO2 -1)*3 +1)
              Y2 = ZR(IGEOM2 -1 + (INO2 -1)*3 +2)
            IF(MODEL.EQ.'3D')THEN
              Z2 = ZR(IGEOM2 -1 + (INO2 -1)*3 +3)
              DISTA2 = (X1-X2)**2 + (Y1-Y2)**2
     &         + (Z1-Z2)**2
            ELSE
              DISTA2 = (X1-X2)**2 + (Y1-Y2)**2
            ENDIF

              IF (DISTA2.LT.(TAILM2)) THEN


              NBPTR=NBPTR+1
              IF (NBPTR.EQ.1) THEN
                 ZI(ITB1+INO1-1)=INO2
                 IF (NDBLE.EQ.0) GOTO 10
              ELSE
                 ZI(ITB2+INO1-1)=INO2
                 GOTO 10
              ENDIF

C PAS DE RECHERCHE DE NOEUDS DOUBLES

C                 GOTO 10
              ENDIF

20        CONTINUE

10    CONTINUE


C      IF (NDBLE.EQ.1) THEN
C        DO 30 I=1,NBNO1

C30      CONTINUE
C      ELSE
C        DO 40 I=1,NBNO1

C40      CONTINUE
C      ENDIF


          CALL JEDETC('V',CHNUL,1)
          CALL JEDETC('V',CN2,1)

      END
