      SUBROUTINE TEMPEQ(Z,TDEQ,TFEQ,K,N,TEQ,DVTEQ)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/07/2008   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

      IMPLICIT NONE
      REAL*8   Z,TDEQ,TFEQ,K,N,TEQ,DVTEQ

C............................................
C CALCUL PHASE METALLURGIQUE POUR EDGAR
C CALCUL DE LA TEMPERTURE EQUIVALENTE
C............................................

C IN   Z    : PROPORTION DE PHASE BETA
C IN   TDEQ : TEMPERATURE QUASISTATIQUE DE DEBUT DE TRANSFORMATION
C IN   TFEQ : TEMPERATURE QUASISTATIQUE DE FIN DE TRANSFORMATION
C             CORRESPONDANT A 0.99 DE PHASE BETA
C IN   K    : PARAMETRE MATERIAU
C IN   N    : PARAMETRE MATERIAU
C OUT TEQ   : TEMPERATURE EQUIVALENTE
C OUT DVTEQ : DERIVEE DE TEQ PAR RAPPORT A Z
  
      IF ((Z.GE.0.D0).AND.(Z.LE.0.99D0)) THEN
        TEQ = LOG(1.D0/(1.D0-Z))
        TEQ=TEQ**(1.D0/N)
        TEQ=TEQ/K
        TEQ=TEQ+TDEQ        
        IF (Z.NE.0.D0) THEN
          DVTEQ=LOG(1.D0/(1.D0-Z))
          DVTEQ=DVTEQ**(1.D0/N)
          DVTEQ=-DVTEQ/(K*N*(1.D0-Z)*LOG(1.D0-Z))
        ELSE
         DVTEQ=1000.D0
        ENDIF
      ELSE
        TEQ=TFEQ
        DVTEQ=1000.D0
      ENDIF
      
      END
