      SUBROUTINE VECTFL(OPT,MODELE,CARELE,MATE,TEMPLU,INSTAP,VE)
      IMPLICIT REAL*8 (A-H,O-Z)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/11/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      CHARACTER*(*) MODELE,CARELE,MATE,TEMPLU,VE,OPT
      REAL*8 INSTAP
C ---------------------------------------------------------------------
C     CALCUL DES VECTEURS ELEMENTAIRES DES FLUX FLUIDES

C IN  MODELE  : NOM DU MODELE
C IN  CARELE  : CARACTERISTIQUES DES POUTRES ET COQUES
C IN  MATE    : MATERIAU
C IN  TEMPLU  : CHAM_NO DE TEMPERATURE OU DE DEPL
C IN  INSTAP  : INSTANT DU CALCUL
C VAR VE  : VECT_ELEM

C -- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------

      CHARACTER*32 JEXNUM,JEXNOM,JEXR8,JEXATR
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
      CHARACTER*8 LPAIN(4),LPAOUT(1),K8BID,KBID
      CHARACTER*8 NOMA
      CHARACTER*16 OPTION
      CHARACTER*19 VECEL
      CHARACTER*24 CHGEOM,CHMATE,CHCARA(18),CHTIME,CHTREF,CHDEPL
      CHARACTER*24 LIGRMO,LCHIN(4),LCHOUT(1),VE2
      INTEGER IBID,IRET,NBPARA
      LOGICAL EXIGEO
      COMPLEX*16 CBID

      CALL JEMARQ()

      VECEL = VE

      VE2 = VECEL//'.RELR'
      CALL DETRSD('VECT_ELEM',VECEL)
      CALL MEMARE('V',VECEL,MODELE(1:8),MATE,CARELE,'CHAR_THER')
      CALL WKVECT(VE2,'V V K24',1,JLVE)
      IF (TEMPLU(9:14).EQ.'.BIDON') THEN
        CALL JEECRA(VE2,'LONUTI',0,K8BID)
        GO TO 10
      END IF

      LIGRMO = MODELE(1:8)//'.MODELE'

      CALL MEGEOM(MODELE(1:8),TEMPLU,EXIGEO,CHGEOM)



      LPAIN(1) = 'PGEOMER'
      LCHIN(1) = CHGEOM
      CHTIME = '&&VECHME.CH_INST_R'
      CALL MECACT('V',CHTIME,'MODELE',LIGRMO,'INST_R  ',1,'INST   ',
     &            IBID,INSTAP,CBID,KBID)
      CALL MECACT('V','&VECTFL.VEC','MODELE',LIGRMO,'TEMP_R  ',1,
     &            'TEMP   ',IBID,0.D0,CBID,KBID)
      LPAIN(2) = 'PTEMPSR'
      LCHIN(2) = CHTIME
      LCHIN(3) = TEMPLU
      LPAIN(4) = 'PMATERC'
      LCHIN(4) = MATE
      IF (OPT.EQ.'R') THEN
        OPTION = 'CHAR_THER_ACCE_R'
        LPAIN(3) = 'PACCELR'
      ELSE
        IF (OPT.EQ.'X') THEN
          OPTION = 'CHAR_THER_ACCE_X'
          LPAIN(3) = 'PTEMPER'
        ELSE
          IF (OPT.EQ.'Y') THEN
            OPTION = 'CHAR_THER_ACCE_Y'
            LPAIN(3) = 'PTEMPER'
          ELSE
            IF (OPT.EQ.'Z') THEN
              OPTION = 'CHAR_THER_ACCE_Z'
              LPAIN(3) = 'PTEMPER'
            END IF
          END IF
        END IF
      END IF

      LPAOUT(1) = 'PVECTTR'

      LCHOUT(1) = '&&VECTFL.A'
      CALL CORICH('E',LCHOUT(1),-1,IBID)
      CALL CALCUL('S',OPTION,LIGRMO,4,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V',
     &               'OUI')
      ZK24(JLVE) = LCHOUT(1)
      CALL JEECRA(VE2,'LONUTI',1,K8BID)

   10 CONTINUE

      CALL JEDEMA()
      END
