      SUBROUTINE VECVME(OPTIO2,MODELZ,CARELZ,
     &                  MATE  ,COMPOR,COMPLZ,NUMEDD,CNCHTP)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/11/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
      CHARACTER*(*) MODELZ,CARELZ,COMPLZ,MATE,CNCHTP
      CHARACTER*16 OPTIO2
      CHARACTER*24 NUMEDD,COMPOR

C ----------------------------------------------------------------------
C     CALCUL DU VECTEUR ASSEMBLE DU CHARGEMENT
C     1. HYDRIQUE
C     2. SECHAGE

C IN  OPTIO2  : NOM DE L'OPTION
C IN  MODELZ  : NOM DU MODELE
C IN  CARELZ  : CARACTERISTIQUES DES POUTRES ET COQUES
C IN  MATE    : MATERIAU
C IN  COMPOR  : COMPORTEMENT
C IN  COMPLZ  : SD VARI_COM
C IN  NUMEDD  : NOM DE LA NUMEROTATION
C VAR CNCHTP  : VECTEUR ASSEMBLE DU CHARGEMENT

C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------

      INTEGER        ZI
      COMMON /IVARJE/ZI(1)
      REAL*8         ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16     ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL        ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8    ZK8
      CHARACTER*16          ZK16
      CHARACTER*24                  ZK24
      CHARACTER*32                          ZK32
      CHARACTER*80                                  ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------

      CHARACTER*6 NOMPRO
      PARAMETER ( NOMPRO = 'VECVME' )

      CHARACTER*1 TYPRES
      CHARACTER*8 LPAIN(13),LPAOUT(1)
      CHARACTER*8 K8BID,NEWNOM
      CHARACTER*14 COMPLU
      CHARACTER*16 OPTION
      CHARACTER*24 CHGEOM,CHCARA(18),CHTIME
      CHARACTER*24 LIGRMO,LCHIN(13),LCHOUT(1)
      CHARACTER*24 VECHVP,CNCHVP,VRCPLU,MODELE,CARELE
      CHARACTER*19 VECEL,CHVREF
      INTEGER      I,IBID,IRET,JLVE,JCHTP,JCHVP,JTP,JYP,LONCH
      LOGICAL EXIGEO,EXICAR
      DATA CNCHVP/' '/
      DATA TYPRES/'R'/

      CALL JEMARQ()
      NEWNOM = '.0000000'
      MODELE = MODELZ
      CARELE = CARELZ
      COMPLU = COMPLZ
      CHVREF='&&'//NOMPRO//'.CHVREF'

C    EXTRACTION DES VARIABLES DE COMMANDE
      CALL NMVCEX('INST',COMPLU,CHTIME)
      CALL NMVCEX('TOUT',COMPLU,VRCPLU)

      VECEL = '&&'//NOMPRO
      CALL DETRSD('VECT_ELEM',VECEL)
      VECHVP = VECEL//'.RELR'
      CALL MEMARE('V',VECEL,MODELE(1:8),MATE,CARELE,'CHAR_MECA')
      CALL WKVECT(VECHVP,'V V K24',1,JLVE)

      LIGRMO = MODELE(1:8)//'.MODELE'

      CALL MEGEOM(MODELE(1:8),VRCPLU,EXIGEO,CHGEOM)
      CALL MECARA(CARELE(1:8),EXICAR,CHCARA)

C    VARIABLE DE COMMANDE DE REFERENCE
      CALL VRCREF(MODELE(1:8),MATE(1:8),CARELE(1:8),CHVREF)

      LPAIN(1) = 'PGEOMER'
      LCHIN(1) = CHGEOM
      LPAIN(2) = 'PTEMPSR'
      LCHIN(2) = CHTIME
      LPAIN(3) = 'PMATERC'
      LCHIN(3) = MATE
      LPAIN(4) = 'PCACOQU'
      LCHIN(4) = CHCARA(7)
      LPAIN(5) = 'PCAGNPO'
      LCHIN(5) = CHCARA(6)
      LPAIN(6) = 'PCADISM'
      LCHIN(6) = CHCARA(3)
      LPAIN(7) = 'PCAORIE'
      LCHIN(7) = CHCARA(1)
      LPAIN(8) = 'PCAGNBA'
      LCHIN(8) = CHCARA(11)
      LPAIN(9) = 'PCAARPO'
      LCHIN(9) = CHCARA(9)
      LPAIN(10) = 'PCAMASS'
      LCHIN(10) = CHCARA(12)
      LPAIN(11) = 'PVARCPR'
      LCHIN(11) = VRCPLU
      LPAIN(12) = 'PVARCRR'
      LCHIN(12) = CHVREF
      LPAIN(13) = 'PCOMPOR'
      LCHIN(13) = COMPOR
      OPTION    = OPTIO2

      LPAOUT(1) = 'PVECTUR'
      LCHOUT(1) = '&&'//NOMPRO//'.???????'

      CALL GCNCO2(NEWNOM)
      LCHOUT(1) (10:16) = NEWNOM(2:8)
      CALL CORICH('E',LCHOUT(1),-1,IBID)
      CALL CALCUL('S',OPTION,LIGRMO,13,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V',
     &                'OUI')
      ZK24(JLVE) = LCHOUT(1)
      CALL JEECRA(VECHVP,'LONUTI',1,K8BID)

C ----- ASSEMBLAGE DU VECT_ELEM

      CALL ASASVE(VECHVP,NUMEDD,TYPRES,CNCHVP)

C ----- SOMMATION DES CHAMPS DE DEFORMATION ANELASTIQUE

      CALL JEEXIN(CNCHTP,IRET)
      IF (IRET.EQ.0) THEN
        CNCHTP = CNCHVP
      ELSE
        CALL JEVEUO(CNCHTP,'L',JTP)
        CALL JELIRA(ZK24(JTP) (1:19)//'.VALE','LONMAX',LONCH,K8BID)
        CALL JEVEUO(ZK24(JTP) (1:19)//'.VALE','E',JCHTP)
        CALL JEVEUO(CNCHVP,'L',JYP)
        CALL JEVEUO(ZK24(JYP) (1:19)//'.VALE','E',JCHVP)
        DO 10 I = 1,LONCH
          ZR(JCHTP+I-1) = ZR(JCHTP+I-1) + ZR(JCHVP+I-1)
   10   CONTINUE
      END IF

      CALL JEDEMA()
      END
