      SUBROUTINE VERSTP(MODELE,CHARGE,INFCHA,CARELE,MATE,INST,COMPOR,
     &                  CHTI,CHTIP,CHTHY,CHTHYP,CHTSCI,CHTSCF,VERES)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/11/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*24 MODELE,CHARGE,INFCHA,CARELE,INST,CHTI,CHTIP,VERES,
     &             MATE,CHTHY,CHTHYP,CHTSCI,CHTSCF,COMPOR
C ----------------------------------------------------------------------
C CALCUL DES VECTEURS ELEMENTAIRES RESIDU

C IN  MODELE  : NOM DU MODELE
C IN  CHARGE  : LISTE DES CHARGES
C IN  INFCHA  : INFORMATIONS SUR LES CHARGES
C IN  CARELE  : CHAMP DE CARA_ELEM
C IN  MATE    : CHAMP DE MATERIAU
C IN  COMPOR  : CHAMP DE COMPORTEMENT (POUR TESTER L HYDRATATION)
C IN  INST    : CARTE CONTENANT LA VALEUR DU TEMPS ET AUTRES PARAMETRES
C IN  CHTI    : TEMPERATURE AU TEMPS PRECEDENT
C IN  CHTIP   : I EME ITERE DU CHAMP DE TEMPERATURE
C IN  CHTHY   : HYDRATATION AU TEMPS PRECEDENT
C IN  CHTSCI  : CHAMP DE TEMPERAT. A T    (POUR LE CALCUL DE D-SECHAGE)
C IN  CHTSCF  : CHAMP DE TEMPERAT. A T+DT (POUR LE CALCUL DE D-SECHAGE)
C OUT CHTHYP  : I EME ITERE DU CHAMP D HYDRATATION
C OUT VERES   : VECTEURS ELEMENTAIRES (RESIDU)

C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------

      CHARACTER*32 JEXNUM,JEXNOM,JEXR8,JEXATR
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
      CHARACTER*1 C1
      CHARACTER*8 NOMCHA,LPAIN(9),LPAOUT(2),K8BID,NEWNOM
      CHARACTER*16 OPTION
      CHARACTER*24 LIGRMO,LCHIN(9),LCHOUT(2),LIGRCH
      CHARACTER*24 CHGEOM,CHCARA(18),CHHARM
      INTEGER IRET,JINF
      INTEGER IRT,ICHA,JCHAR,NCHAR
      LOGICAL EXIGEO,EXICAR,EXIMAT

      CALL JEMARQ()
      NEWNOM = '.0000000'
      LIGRMO = MODELE(1:8)//'.MODELE'
      CALL JEEXIN(CHARGE,IRET)
      IF (IRET.NE.0) THEN
        CALL JELIRA(CHARGE,'LONMAX',NCHAR,K8BID)
        CALL JEVEUO(CHARGE,'L',JCHAR)
        CALL JEVEUO(INFCHA,'L',JINF)
      ELSE
        NCHAR = 0
      END IF

      CALL MEGEOM(MODELE,'      ',EXIGEO,CHGEOM)
      CALL MECARA(CARELE,EXICAR,CHCARA)

      LPAOUT(1) = 'PRESIDU'
      LCHOUT(1) = '&&VERSTP.???????'
      LPAIN(1) = 'PGEOMER'
      LCHIN(1) = CHGEOM
      LPAIN(3) = 'PTEMPSR'
      LCHIN(3) = INST
      LPAIN(4) = 'PTEMPEI'
      LCHIN(4) = CHTIP

C --- TERME VOLUMIQUE PROVENANT DU COMPORTEMENT

      OPTION = 'RESI_RIGI_MASS'
      LPAIN(2) = 'PMATERC'
      LCHIN(2) = MATE
      LPAIN(5) = 'PHYDRPM'
      LCHIN(5) = CHTHY
      LPAIN(6) = 'PCOMPOR'
      LCHIN(6) = COMPOR
      LPAIN(7) = 'PTEMPER'
      LCHIN(7) = CHTI
      LPAIN(8) = 'PTMPCHI'
      LCHIN(8) = CHTSCI
      LPAIN(9) = 'PTMPCHF'
      LCHIN(9) = CHTSCF
      LPAOUT(2) = 'PHYDRPP'
      LCHOUT(2) = CHTHYP
      CALL GCNCO2(NEWNOM)
      LCHOUT(1) (10:16) = NEWNOM(2:8)
      CALL CORICH('E',LCHOUT(1),-1,IBID)
      CALL CALCUL('S',OPTION,LIGRMO,9,LCHIN,LPAIN,2,LCHOUT,LPAOUT,'V',
     &               'OUI')
      CALL REAJRE(VERES,LCHOUT(1),'V')

C --- TERME SURFACIQUE PROVENANT DES CONDITIONS AUX LIMITES

      IF (NCHAR.GT.0) THEN
        DO 10 ICHA = 1,NCHAR

          LPAIN(2) = 'PFLUXNL'
          LCHIN(2) = ZK24(JCHAR+ICHA-1) (1:8)//'.CHTH.FLUNL.DESC'
          CALL JEEXIN(LCHIN(2),IRET)
          IF (IRET.NE.0) THEN
            OPTION = 'RESI_THER_FLUXNL'
            CALL GCNCO2(NEWNOM)
            LCHOUT(1) (10:16) = NEWNOM(2:8)
            CALL CORICH('E',LCHOUT(1),-1,IBID)
            CALL CALCUL('S',OPTION,LIGRMO,4,LCHIN,LPAIN,1,LCHOUT,LPAOUT,
     &                  'V','OUI')
            CALL REAJRE(VERES,LCHOUT(1),'V')
          END IF

          LCHIN(2) = ZK24(JCHAR+ICHA-1) (1:8)//'.CHTH.T_EXT.DESC'
          CALL JEEXIN(LCHIN(2),IRET)
          IF (IRET.NE.0) THEN
            C1 = 'R'
            IF (ZI(JINF+NCHAR+ICHA).GT.1) THEN
              C1 = 'F'
            END IF
            OPTION = 'RESI_THER_COEF_'//C1
            LPAIN(2) = 'PCOEFH'//C1
            LCHIN(2) = ZK24(JCHAR+ICHA-1) (1:8)//'.CHTH.COEFH'
            CALL GCNCO2(NEWNOM)
            LCHOUT(1) (10:16) = NEWNOM(2:8)
            CALL CORICH('E',LCHOUT(1),-1,IBID)
            CALL CALCUL('S',OPTION,LIGRMO,4,LCHIN,LPAIN,1,LCHOUT,LPAOUT,
     &                  'V','OUI')
            CALL REAJRE(VERES,LCHOUT(1),'V')
          END IF

          LCHIN(2) = ZK24(JCHAR+ICHA-1) (1:8)//'.CHTH.RAYO .DESC'
          CALL JEEXIN(LCHIN(2),IRET)
          IF (IRET.NE.0) THEN
            C1 = 'R'
            IF (ZI(JINF+NCHAR+ICHA).GT.1) THEN
              C1 = 'F'
            END IF
            OPTION = 'RESI_THER_RAYO_'//C1
            LPAIN(2) = 'PRAYON'//C1
            LCHIN(2) = ZK24(JCHAR+ICHA-1) (1:8)//'.CHTH.RAYO'
            CALL GCNCO2(NEWNOM)
            LCHOUT(1) (10:16) = NEWNOM(2:8)
            CALL CORICH('E',LCHOUT(1),-1,IBID)
            CALL CALCUL('S',OPTION,LIGRMO,4,LCHIN,LPAIN,1,LCHOUT,LPAOUT,
     &                  'V','OUI')
            CALL REAJRE(VERES,LCHOUT(1),'V')
          END IF

          NOMCHA = ZK24(JCHAR+ICHA-1) (1:8)
          LIGRCH = NOMCHA//'.CHTH.LIGRE'
          LCHIN(2) = NOMCHA//'.CHTH.HECHP.DESC'
          CALL JEEXIN(LCHIN(2),IRET)
          IF (IRET.NE.0) THEN
            C1 = 'R'
            IF (ZI(JINF+NCHAR+ICHA).GT.1) THEN
              C1 = 'F'
            END IF
            OPTION = 'RESI_THER_PARO_'//C1
            LPAIN(2) = 'PHECHP'//C1
            LCHIN(2) = NOMCHA//'.CHTH.HECHP'
            CALL GCNCO2(NEWNOM)
            LCHOUT(1) (10:16) = NEWNOM(2:8)
            CALL CORICH('E',LCHOUT(1),-1,IBID)
            CALL CALCUL('S',OPTION,LIGRCH,4,LCHIN,LPAIN,1,LCHOUT,LPAOUT,
     &                  'V','OUI')
            CALL REAJRE(VERES,LCHOUT(1),'V')
          END IF

   10   CONTINUE
      END IF
C FIN ------------------------------------------------------------------
      CALL JEDEMA()
      END
