      SUBROUTINE VETHBT(MODELE,CHARGE,INFCHA,CARELE,MATE,CHTNI,VEBTLA)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/11/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*24 MODELE,CHARGE,INFCHA,CARELE,MATE,CHTNI,VEBTLA
C ----------------------------------------------------------------------
C CALCUL DES TERMES DE DIRICHLET EN THERMIQUE NON LINEAIRE

C IN  MODELE  : NOM DU MODELE
C IN  CHARGE  : LISTE DES CHARGES
C IN  INFCHA  : INFORMATIONS SUR LES CHARGEMENTS
C IN  CARELE  : CHAMP DE CARA_ELEM
C IN  MATE    : MATERIAU CODE
C IN  CHTNI   : IEME ITEREE DU CHAMP DE TEMPERATURE
C OUT VEBTLA  : VECTEURS ELEMENTAIRES PROVENANT DE BT LAMBDA

C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------

      CHARACTER*32 JEXNUM,JEXNOM,JEXR8,JEXATR
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
      CHARACTER*8 NOMCHA,LPAIN(2),LPAOUT(1),K8BID,NEWNOM
      CHARACTER*16 OPTION
      CHARACTER*19 VECEL
      CHARACTER*24 LCHIN(2),LCHOUT(1),LIGRCH
      INTEGER IRET,NCHAR,ICHA,JCHAR,JINF
      CALL JEMARQ()
      CALL JEEXIN(CHARGE,IRET)
      IF (IRET.NE.0) THEN
        CALL JELIRA(CHARGE,'LONMAX',NCHAR,K8BID)
        CALL JEVEUO(CHARGE,'L',JCHAR)
      ELSE
        NCHAR = 0
      END IF

      CALL JEEXIN(VEBTLA,IRET)
      VECEL = '&&VETBTL           '
      IF (IRET.EQ.0) THEN
        VEBTLA = VECEL//'.RELR'
        CALL MEMARE('V',VECEL,MODELE(1:8),MATE,CARELE,'CHAR_THER')
        CALL WKVECT(VEBTLA,'V V K24',NCHAR,JDIR)
      ELSE
        CALL JEVEUO(VEBTLA,'E',JDIR)
      END IF
      CALL JEECRA(VEBTLA,'LONUTI',0,K8BID)

      IF (NCHAR.GT.0) THEN
        CALL JEVEUO(INFCHA,'L',JINF)
        NDIR = 0
        DO 10 ICHA = 1,NCHAR

C ------- CALCUL DES TERMES DE DIRICHLET SOUS-OPTION BT LAMBDA

          OPTION = 'THER_BTLA_R'
          IF (ZI(JINF+ICHA).GT.0) THEN
            NOMCHA = ZK24(JCHAR+ICHA-1) (1:8)
            LIGRCH = NOMCHA//'.CHTH.LIGRE'
            LPAIN(1) = 'PDDLMUR'
            LCHIN(1) = NOMCHA//'.CHTH.CMULT'
            LPAIN(2) = 'PLAGRAR'
            LCHIN(2) = CHTNI
            LPAOUT(1) = 'PVECTTR'
            LCHOUT(1) = '&&VETHBT.???????'
            CALL GCNCON('.',NEWNOM)
            LCHOUT(1) (10:16) = NEWNOM(2:8)
            CALL CORICH('E',LCHOUT(1),-1,IBID)
            CALL CALCUL('S',OPTION,LIGRCH,2,LCHIN,LPAIN,1,LCHOUT,LPAOUT,
     &                  'V','OUI')
            NDIR = NDIR + 1
            ZK24(JDIR+NDIR-1) = LCHOUT(1)
          END IF

   10   CONTINUE
        CALL JEECRA(VEBTLA,'LONUTI',NDIR,K8BID)

      END IF
   20 CONTINUE
C FIN ------------------------------------------------------------------
      CALL JEDEMA()
      END
