         SUBROUTINE VFGETR(MAXDIM,NDIM,NBNOS,XS,T,XG,
     >    SURF,NORM,XGF,D)
C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 23/03/2010   AUTEUR ANGELINI O.ANGELINI 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C ======================================================================
C  CALCUL DES ELEMENTS GEOMETRIQUES D UNE FACE TRIANGULAIRE
C
C IDIM ( : 1,NDIM
C IN
C     MAXDIM
C     NDIM
C     NBNOS NBRE DE SOMMETS = NOMBRE DE ARETE
C     XS(1:MAXDIM,J) COORD SOMMET J 
C     T(1:MAXDIM,2)  COORD DU VECTEUR DES DEUX PREMIRES ARETES
C     XG  COORD D UN POINT QUI PEMET D ORIENTER LA FACE 
C        (XGF-XG).N >0 
C OUT
C     SURF SURFACE DE LA FACE
C     NORM NORMALE
C     XGF BARYCENTRE FACE
C     D = (XGF-XG).N  
      IMPLICIT NONE       
      INTEGER  MAXDIM,NDIM,NBNOS,IDIM,IS
      REAL*8   XS(1:MAXDIM,NBNOS),T(1:MAXDIM,2)
      REAL*8   XG(1:MAXDIM),SURF,NORM(1:MAXDIM),XGF(1:MAXDIM),D
      REAL*8   XNORM   
      CALL ASSERT(NDIM.EQ.3)
      CALL ASSERT (MAXDIM.GE.3)
      CALL ASSERT (NBNOS.EQ.3)
      DO 10 IDIM=1,NDIM
       XGF(IDIM)=0.D0
       DO 11 IS = 1 , NBNOS
        XGF(IDIM)=XGF(IDIM)+XS(IDIM,IS)
   11  CONTINUE
       XGF(IDIM)=XGF(IDIM)/NBNOS
   10 CONTINUE
C 
      CALL PROVEC(T(1,1),T(1,2),NORM)
      XNORM=SQRT(NORM(1)**2+NORM(2)**2+NORM(3)**2)
      NORM(1)=NORM(1)/XNORM
      NORM(2)=NORM(2)/XNORM 
      NORM(3)=NORM(3)/XNORM
      SURF=XNORM/2.D0
      D =(XGF(1)-XG(1))*NORM(1)+
     >   (XGF(2)-XG(2))*NORM(2)+
     >   (XGF(3)-XG(3))*NORM(3)
      IF ( D.LT.0.D0) THEN
         D=-D
         NORM(1)=-NORM(1)
         NORM(2)=-NORM(2)
         NORM(3)=-NORM(3)
      ENDIF
      END
