      SUBROUTINE VICIN2(NDIM,G,NPG,LGPG,VIM,RPT,NBCIN,NUMCIN) 
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/12/2009   AUTEUR PROIX J-M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
      IMPLICIT NONE
      INTEGER NDIM,G,NPG,LGPG,I,NBCIN,NUMCIN(2)
      REAL*8 VIM(LGPG,NPG),RPT(3,3),VIMM(3,3)
      REAL*8 VARI(3,3),VARIM(7),ESP(9)

C ---------------------------------
C   G       : NUMERO DU POINT DE GAUSS COURANT
C   NDIM    : DIMENSION DE L'ESPACE
C   NPG     : NOMBRE DE POINTS DE GAUSS
C   LGPG    : TAILLE DES VARIABLES INTERNES DEPEND DU COMPORTEMENT
C   VIM     : VARIABLE INTERNE EN T-
C   RPT     : TENSEUR ROTATION
C   NBCIN   : NOMBRE DE VARIABLES CINEMATIQUES
C   NUMCIN  : NUMEROS DES VARIABLES CINEMATIQUES

C   SORTIE:
C   VIM     : VECTEUR VIM MODIFIE
C ----------------------------
C
C   CALCUL DES ENTREES DE NMCOMP POUR GDEF_HYPO_ELAS
C
C -------------------------

C     PREMIERE VARIABLE CINEMATIQUE
      DO 1 I=1,3
         VIMM(I,I)=VIM(NUMCIN(1)-1+I,G)
 1    CONTINUE
      VIMM(1,2)=VIM(NUMCIN(1)-1+4,G)
      VIMM(2,1)=VIM(NUMCIN(1)-1+4,G)
      VIMM(1,3)=VIM(NUMCIN(1)-1+5,G)
      VIMM(3,1)=VIM(NUMCIN(1)-1+5,G)
      VIMM(2,3)=VIM(NUMCIN(1)-1+6,G)
      VIMM(3,2)=VIM(NUMCIN(1)-1+6,G)
      
C     MULTIPLICATION PAR f^T_{n+alpha}
      CALL UTBTAB('ZERO',3,3,VIMM,RPT,ESP,VARI)       
         
C     MODIFICATION DES VARIABLES INTERNES POUR NMCOMP
      DO 2 I=1,3
         VIM(NUMCIN(1)-1+I,G)=VARI(I,I)
 2    CONTINUE
      VIM(NUMCIN(1)-1+4,G)=VARI(1,2)
      VIM(NUMCIN(1)-1+5,G)=VARI(1,3)
      VIM(NUMCIN(1)-1+6,G)=VARI(2,3)
      
      IF (NBCIN.EQ.2) THEN
      
C        DEUXIEME VARIABLE CINEMATIQUE

         DO 11 I=1,3
            VIMM(I,I)=VIM(NUMCIN(2)-1+I,G)
            
 11      CONTINUE
         VIMM(1,2)=VIM(NUMCIN(2)-1+4,G)
         VIMM(2,1)=VIM(NUMCIN(2)-1+4,G)
         VIMM(1,3)=VIM(NUMCIN(2)-1+5,G)
         VIMM(3,1)=VIM(NUMCIN(2)-1+5,G)
         VIMM(2,3)=VIM(NUMCIN(2)-1+6,G)
         VIMM(3,2)=VIM(NUMCIN(2)-1+6,G)
         
C        MULTIPLICATION PAR f^T_{n+alpha}
         CALL UTBTAB('ZERO',3,3,VIMM,RPT,ESP,VARI)
         
C        MODIFICATION DES VARIABLES INTERNES POUR NMCOMP
         DO 12 I=1,3
            VIM(NUMCIN(2)-1+I,G)=VARI(I,I)
 12      CONTINUE
         VIM(NUMCIN(2)-1+4,G)=VARI(1,2)
         VIM(NUMCIN(2)-1+5,G)=VARI(1,3)
         VIM(NUMCIN(2)-1+6,G)=VARI(2,3)
      ENDIF
      END
