      SUBROUTINE VPZHEB(KL,L,M,A,IA,INTGER,ZVPS,IZ,N)
C
C***********************************************************************
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 14/11/2006   AUTEUR LEBOUVIER F.LEBOUVIER 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C***********************************************************************
C     PROCEDURE DIRBAK
C     (CF. WILKINSON & REINSCH LINEAR ALGEBRA PP.347)
C     ETANT DONNES LES M VECTEURS PROPRES (STOCKES EN COLONNES DANS LE
C     TABLEAU ZVPS(N,M)) DE LA MATRICE DE HESSENBERG HH, CONSTRUITE
C     DANS LA ROUTINE VPZHEA ET LES DETAILS DES TRANSFORMATIONS
C     EFFECTUEES PAR VPZHEA CONSERVES DANS LA PARTIE INFERIEURE DE 
C     LA MATRICE HH ET DANS LES ELEMENTS K A L DU TABLEAU INTGER(N),
C     CETTE ROUTINE FORME LES VECTEURS PROPRES DE LA MATRICE A 
C     ET LES REECRIT DANS LES VECTEURS PROPRES DONNES EN ENTREE.
C
C
C --- DECLARATIONS
C
      IMPLICIT NONE
C
C ARGUMENTS
C ---------
      INTEGER IA, IZ, KL, L, M, N
      REAL*8 A(IA,N), ZVPS(IZ,M)
      INTEGER INTGER(N)
C
C VARIABLES LOCALES
C -----------------
      REAL*8  X
      INTEGER I, II, J, K, M1
C
C
C***********************************************************************
C                     DEBUT DU CODE EXECUTABLE
C***********************************************************************
C
C --- INITIALISATION ET VERIFICATION DES DONNEES D ENTREE
C
      K = KL
C
      IF (M.LE.0) GO TO 9999
C
C --- FORMATION DES NOUVEAUX VECTEURS PROPRES
C
      IF (K+2.LE.L) THEN
       DO 20 J = 1, M
C
      CALL VPZTR3(L-K,IA,A(K+1,K),ZVPS(K+1,J))
C
   20  CONTINUE
      ENDIF
C
      K = K + 1
C
C --- INTERVERSION DE CES VECTEURS SI NECESSAIRE
C
      I = L + 1
      IF (K.GT.L) GO TO 9999
C
      DO 80 II = K, L
         I = I - 1
         M1 = INTGER(I)
         IF (M1.NE.I) THEN
          DO 60 J = 1, M
            X = ZVPS(M1,J)
            ZVPS(M1,J) = ZVPS(I,J)
            ZVPS(I,J) = X
   60     CONTINUE
         ENDIF
   80 CONTINUE
C
 9999 CONTINUE
      END
