      SUBROUTINE XCODEC(NOMA  ,MODELX,NDIM  ,CRIMAX,LINTER)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/12/2010   AUTEUR MASSIN P.MASSIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT NONE
      CHARACTER*8 NOMA,MODELX 
      INTEGER     NDIM    
      REAL*8      CRIMAX
      LOGICAL     LINTER
C      
C ----------------------------------------------------------------------
C
C ROUTINE XFEM (MODIF. DU MODELE)
C
C CALCUL DU DCOUPAGE EN SOUS-TETRAS, DES FACETTES DE CONTACT
C ET VERIFICATION DES CRITERES DE CONDITIONNEMENT
C
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE 
C IN  MODELX : NOM DU MODELE XFEM MODIFIE
C IN  NDIM   : DIMENSION DU PROBLEME
C IN  CRIMAX : CRITERE MAXIMUM
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER     IBID,NBMA
      CHARACTER*8  K8BID
      CHARACTER*19 LTNO,LNNO,STNO,BASLOC,GRLNNO,GRLTNO,LBNO
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- CONCATENER LES CHAMPS NODAUX POUR DES FISSURES DU MODELE
C
      LTNO   = MODELX(1:8)//'.LTNO'
      LNNO   = MODELX(1:8)//'.LNNO'
      STNO   = MODELX(1:8)//'.STNO'
      BASLOC = MODELX(1:8)//'.BASLOC'
      GRLNNO = MODELX(1:8)//'.GRLNNO'
      GRLTNO = MODELX(1:8)//'.GRLTNO'
      CALL XCONNO(MODELX,'.STNO      ','G','FULL_MECA','PSTANO',STNO)
      CALL XCONNO(MODELX,'.LNNO      ','G','FULL_MECA','PLSN',LNNO)
      CALL XCONNO(MODELX,'.LTNO      ','G','FULL_MECA','PLST',LTNO)
      CALL XCONNO(MODELX,'.BASLOC    ','G','FULL_MECA','PBASLOR',BASLOC)
      CALL XCONNO(MODELX,'.GRLNNO    ','V','TOPOFA','PGRADLN',GRLNNO)
      CALL XCONNO(MODELX,'.GRLTNO    ','V','TOPOFA','PGRADLT',GRLTNO)
C
C --- UTILE POUR LES INTERSECTIONS
C
      IF (LINTER) THEN
        CALL XFISNO(NOMA  ,MODELX)
        CALL XFISCO(NOMA  ,MODELX)
      ENDIF
C      
C --- CALCUL DES DONNEES UTILES POUR L'INTGRATION (SOUS-TETRAS...)
C
      CALL XTOPOI(NOMA, MODELX)  
C      
C --- ORIENTATION DES FACETTES DE PEAU X-FEM (COMME ORIE_PEAU)
C
      CALL XORIPE(MODELX)
C      
C --- CALCUL DE LA TOPOLOGIE DES FACETTES DE CONTACT
C
      CALL XTOPOC(MODELX)
C
C --- CREATION LISTE DE NOEUDS OU IL FAUDRA ANNULER LES DDLS HEAVISIDE
C 
      IF (NDIM .EQ.3) THEN
        CALL DISMOI('F','NB_MA_MAILLA',MODELX,'MODELE',NBMA,
     &              K8BID,IBID)
        CALL XSTAN2(CRIMAX,NOMA  ,NBMA  ,MODELX)
      ENDIF  
C
      CALL JEDEMA()
      END
