      SUBROUTINE XGECFI(MODELE,DEPGEO)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/11/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2005  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT NONE
      CHARACTER*8    MODELE
      CHARACTER*19   DEPGEO
C
C ----------------------------------------------------------------------
C
C ROUTINE XFEM-GG
C
C CREATION DES SD CONTENANT LA GEOMETRIE DES
C                FACETTES DE CONTACT (ESCLAVES ET MAITRE)
C
C ----------------------------------------------------------------------
C
C
C ----------------------------------------------------------------------
C ROUTINE SPECIFIQUE A L'APPROCHE <<GRANDS GLISSEMENTS AVEC XFEM>>,
C TRAVAIL EFFECTUE EN COLLABORATION AVEC I.F.P.
C ----------------------------------------------------------------------
C
C IN  MODELE : NOM DU MODELE
C IN  DEPGEO : CHAMP DE DEPLACEMENTS
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      NBOUT,NBIN
      PARAMETER    (NBOUT=2, NBIN=5)
      CHARACTER*8  LPAOUT(NBOUT),LPAIN(NBIN)
      CHARACTER*19 LCHOUT(NBOUT),LCHIN(NBIN)
C
      CHARACTER*16 OPTION
      CHARACTER*19 LIGREL,PINTER,FACLON,NEWGES,NEWGEM
      CHARACTER*19 GESCLO,LTNO
      CHARACTER*1  BASE
      LOGICAL      DEBUG
      INTEGER      IFMDBG,NIVDBG
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('PRE_CALCUL',IFMDBG,NIVDBG)
C
C --- INITIALISATIONS
C
      IF (NIVDBG.GE.2) THEN
        DEBUG  = .TRUE.
      ELSE
        DEBUG  = .FALSE.
      ENDIF
      BASE   = 'V'
      OPTION = 'GEOM_FAC'
      NEWGES = '&&XGECFI.GEOESCL'
      NEWGEM = '&&XGECFI.GEOMAIT'
C
C --- INITIALISATION DES CHAMPS POUR CALCUL
C
      CALL INICAL(NBIN  ,LPAIN ,LCHIN ,
     &            NBOUT ,LPAOUT,LCHOUT)
      LIGREL   = MODELE//'.MODELE'
      PINTER   = MODELE//'.TOPOFAC.PI'
      FACLON   = MODELE//'.TOPOFAC.LO'
      GESCLO   = MODELE//'.TOPOFAC.OE'
      LTNO     = MODELE//'.LTNO'
C
C --- CREATION DES LISTES DES CHAMPS IN ET OUT
C
      LPAIN(1)  = 'PDEPLA'
      LCHIN(1)  = DEPGEO
      LPAIN(2)  = 'PPINTER'
      LCHIN(2)  = PINTER
      LPAIN(3)  = 'PLONCHA'
      LCHIN(3)  = FACLON
      LPAIN(4)  = 'PGESCLO'
      LCHIN(4)  = GESCLO
      LPAIN(5)  = 'PLST'
      LCHIN(5)  = LTNO
C
      LPAOUT(1) = 'PNEWGES'
      LCHOUT(1) = NEWGES
      LPAOUT(2) = 'PNEWGEM'
      LCHOUT(2) = NEWGEM
C
C --- APPEL A CALCUL
C
      CALL CALCUL('C',OPTION,LIGREL,NBIN  ,LCHIN ,LPAIN ,
     &                              NBOUT ,LCHOUT,LPAOUT,BASE,'OUI')
      IF (DEBUG) THEN
        CALL DBGCAL(OPTION,IFMDBG,
     &              NBIN  ,LPAIN ,LCHIN ,
     &              NBOUT ,LPAOUT,LCHOUT)
      ENDIF
C
C --- ON COPIE LA NOUVELLE GEOMETRIE DANS LES SD DES FACETTES DE CONTACT
C
      CALL COPISD('CHAMP_GD','V',LCHOUT(1),MODELE//'.TOPOFAC.GE')
      CALL COPISD('CHAMP_GD','V',LCHOUT(2),MODELE//'.TOPOFAC.GM')

      CALL JEDETR(NEWGES)
      CALL JEDETR(NEWGEM)

      CALL JEDEMA()
      END
