      SUBROUTINE XLACTI(TYPMA,NINTER,JAINT,CONTAC,LACT,NLACT)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 19/01/2011   AUTEUR MASSIN P.MASSIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT NONE
      CHARACTER*8   TYPMA
      INTEGER       NINTER,JAINT,LACT(8),NLACT,CONTAC
C      
C ----------------------------------------------------------------------
C
C ROUTINE XFEM
C
C ACTIVATION DES LAGRANGES POUR LA FORMULATION LAGRANGES AUX NOEUDS
C POUR CHAQUE NOEUD SOMMET, 
C        LACT(INO)=0: LES DDL DE CONTACT DE CE NOEUD NE SONT PAS ACTIFS
C        LACT(INO)=NLI > 0: LES DDL DE CONTACT DE CE SOMMET SONT ACTIFS
C                       NLI EST LE NUMEROS DU PT D'INTERSECTION
C
C POUR OPTIMISER, ON PEUT SORTIR XLACTI DES TE'S, IL FAUT ALORS 
C PASSER UN CHAMP SUPPLMENTAIRE AUX TE'S
C
C ----------------------------------------------------------------------
C
C IN  TYPMA  : TYPE  DE MAILLE DE L'ELEMENT PARENT
C IN  NINTER : NOMBRE DE POINTS D'INTERSECTION
C IN  JAINT  : ADRESSE DES INFORMATIONS CONCERNANT LES ARETES COUPES
C OUT LACT   : LISTE DES LAGRANGES ACTIFS
C OUT NLACT  : NOMBRE TOTAL DE LAGRANGES ACTIFS
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER     ZXAIN,XXMMVD
      INTEGER     INO,INO1,INO2,IAR,AR(12,3),NBAR
      INTEGER     VIT(8),NVIT,NLI
C.......................................................................
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DO 30 INO = 1,8
        LACT(INO) = 0
        VIT(INO) = 0   
 30   CONTINUE
      NLACT = 0
      CALL CONARE(TYPMA,AR,NBAR)
      ZXAIN=XXMMVD('ZXAIN')
C
C --- ON ACTIVE LES NOEUDS CONNECTES AUX POINTS D'INTERSECTION
      DO 10 NLI=1,NINTER
        IAR=INT(ZR(JAINT-1+ZXAIN*(NLI-1)+1))
        INO=INT(ZR(JAINT-1+ZXAIN*(NLI-1)+2))
        NVIT=INT(ZR(JAINT-1+ZXAIN*(NLI-1)+5))
        IF (INO.GT.0) THEN
          LACT(INO)=NLI
        ELSEIF (IAR.GT.0) THEN
          INO1=AR(IAR,1)
          INO2=AR(IAR,2)
          IF (NVIT.EQ.1) THEN
            LACT(INO1)=NLI
            VIT(INO1)=1
            LACT(INO2)=NLI
            VIT(INO2)=1
          ELSE
           IF (VIT(INO1).EQ.0) LACT(INO1)=NLI
           IF (VIT(INO2).EQ.0) LACT(INO2)=NLI
          ENDIF
        ENDIF
 10   CONTINUE
C --- ON COMPTE LE NOMBRE DE NOEUDS ACTIFS
      DO 20 INO=1,8
        IF (LACT(INO).NE.0) NLACT=NLACT+1
 20   CONTINUE
C
      CALL JEDEMA()
      END
