      SUBROUTINE XMAFIS(NOMA,CNSLN,NXMAFI,MAFIS,NMAFIS,LISMA)
      IMPLICIT NONE

      INTEGER       NXMAFI,NMAFIS
      CHARACTER*8   NOMA
      CHARACTER*19  CNSLN
      CHARACTER*24  MAFIS,LISMA
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 16/10/2007   AUTEUR REZETTE C.REZETTE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE GENIAUT S.GENIAUT
C
C                      TROUVER LES MAILLES O LSN CHANGE DE SIGNE
C
C     ENTREE
C       NOMA     :  NOM DE L'OBJET MAILLAGE
C       CNSLN    :  LEVEL-SETS
C       NXMAFI   :  NOMBRE MAX DE MAILLES DE LA ZONE FISSURE
C       LISMA    :  LISTE DES MAILLES DE GROUP_MA_ENRI
C
C     SORTIE
C       MAFIS    :  MAILLES DE LA ZONE FISSURE
C       NMAFIS   :  NOMBRE DE MAILLES DE LA ZONE FISSURE
C     ------------------------------------------------------------------
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER          ZI
      COMMON  /IVARJE/ ZI(1)
      REAL*8           ZR
      COMMON  /RVARJE/ ZR(1)
      COMPLEX*16       ZC
      COMMON  /CVARJE/ ZC(1)
      LOGICAL          ZL
      COMMON  /LVARJE/ ZL(1)
      CHARACTER*8      ZK8
      CHARACTER*16             ZK16
      CHARACTER*24                      ZK24
      CHARACTER*32                               ZK32
      CHARACTER*80                                        ZK80
      COMMON  /KVARJE/ ZK8(1), ZK16(1), ZK24(1), ZK32(1), ZK80(1)
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
C
      INTEGER       JDLIMA,JCONX1,JCONX2,JLNSV,JMAFIS
      INTEGER       I,IMAE,IN,JMA,ITYPMA,NBNOTT(3)
      INTEGER       NMAABS,NUNO,NBMAE,NNOS
      REAL*8        LSNP,LSN
      CHARACTER*8   K8B
      CHARACTER*32  JEXATR,JEXNUM
      CHARACTER*19  MAI

C ----------------------------------------------------------------------

      CALL JEMARQ()

      CALL JELIRA(LISMA,'LONMAX',NBMAE,K8B)
      CALL JEVEUO(LISMA,'L',JDLIMA)

      CALL JEVEUO(NOMA//'.CONNEX','L',JCONX1)
      CALL JEVEUO(JEXATR(NOMA//'.CONNEX','LONCUM'),'L',JCONX2)

      MAI=NOMA//'.TYPMAIL'
      CALL JEVEUO(MAI,'L',JMA)

C     RCUPRATION DES LEVEL-SETS
      CALL JEVEUO(CNSLN//'.CNSV','L',JLNSV)

      CALL JEVEUO(MAFIS,'E',JMAFIS)

      I=0
C     BOUCLE SUR LES MAILLES DE GROUP_ENRI
      DO 100 IMAE=1,NBMAE
        NMAABS=ZI(JDLIMA-1+(IMAE-1)+1)
        IN=1
        NUNO=ZI(JCONX1-1+ZI(JCONX2+NMAABS-1)+IN-1)
        LSNP=ZR(JLNSV-1+(NUNO-1)+1)

        ITYPMA=ZI(JMA-1+NMAABS)
        CALL PANBNO(ITYPMA,NBNOTT)
        NNOS=NBNOTT(1)

        DO 101 IN=2,NNOS
          NUNO=ZI(JCONX1-1+ZI(JCONX2+NMAABS-1)+IN-1)
          LSN=ZR(JLNSV-1+(NUNO-1)+1)
          IF ((LSNP*LSN).LE.0) THEN
C           LSN A CHANG DE SIGNE DONC ON STOCKE LA MAILLE DANS MAFIS
            I=I+1
            ZI(JMAFIS-1+I)=NMAABS
C           AUGMENTEZ NXMAFI
            CALL ASSERT((I-1).LT.NXMAFI)
            GOTO 100
          ENDIF
 101    CONTINUE
 100  CONTINUE
      NMAFIS=I

      CALL JEDEMA()
      END
