      SUBROUTINE XMELEL(IIN,NTYELE,NTYELM,IORDR,NNDEL)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/12/2010   AUTEUR MASSIN P.MASSIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
      INTEGER      IIN
      CHARACTER*16  NTYELE,NTYELM
      INTEGER      NNDEL
      INTEGER      IORDR
C
C ----------------------------------------------------------------------
C ROUTINE APPELLEE PAR : XMLIGR
C ----------------------------------------------------------------------
C ROUTINE SPECIFIQUE A L'APPROCHE <<GRANDS GLISSEMENTS AVEC XFEM>>,
C TRAVAIL EFFECTUE EN COLLABORATION AVEC I.F.P.
C ----------------------------------------------------------------------
C RETOURNE DES INFOS SUR LES ELEMENTS DE CONTACT FORMES ENTRE
C DEUX ELEMENTS DE SURFACE
C
C IN  IIN    : NUMERO D'ORDRE EN ENTREE
C               SI ZERO: ON UTILISE NTYELE/NTYELM
C IN  NTYELE : ELEMENT X-FEM ESCLAVE
C IN  NTYELM : ELEMENT X-FEM MAITRE
C OUT IORDR  : ORDRE DANS LA LISTE DES ELEMENTS
C OUT NNDEL  : NOMBRE DE NOEUDS DE L'ELEMENT DE CONTACT
C
C
C ----------------------------------------------------------------------
C
      INTEGER      NBTYP
      PARAMETER    (NBTYP=47)
      CHARACTER*16 CPL(NBTYP,2)
      INTEGER      NPL(NBTYP)
      INTEGER      K
C
      DATA (CPL(K,1),K=1,NBTYP) /
     &      'MECPQU4_XHC','MECPQU4_XHC','MECPQU4_XHTC','MECPQU4_XHTC',
     &      'MECPTR3_XHC','MECPTR3_XHC','MECPTR3_XHTC','MECPTR3_XHTC',
     &      'MECPQU4_XHC','MECPTR3_XHC','MECPQU8_XHC_X','MECPTR6_XHC_X',
     &      'MEDPQU4_XHC','MEDPQU4_XHC','MEDPQU4_XHTC','MEDPQU4_XHTC',
     &      'MEDPTR3_XHC','MEDPTR3_XHC','MEDPTR3_XHTC','MEDPTR3_XHTC',
     &      'MEDPQU4_XHC','MEDPTR3_XHC','MEDPQU8_XHC_X','MEDPTR6_XHC_X',
     &      'MECA_XHC_HEXA8','MECA_XHC_HEXA8',
     &      'MECA_XHTC_HEXA8','MECA_XHTC_HEXA8',
     &      'MECA_XHC_PENTA6','MECA_XHC_PENTA6',
     &      'MECA_XHTC_PENTA6','MECA_XHTC_PENTA6',
     &      'MECA_XHC_TETRA4','MECA_XHC_TETRA4',
     &      'MECA_XHTC_TETRA4','MECA_XHTC_TETRA4',
     &      'MECPQU8_XHC','MEDPQU8_XHC','MECPTR6_XHC','MEDPTR6_XHC',
     &      'MECPQU4_XTC','MECPTR3_XTC','MEDPQU4_XTC','MEDPTR3_XTC',
     &      'MECA_XTC_HEXA8','MECA_XTC_PENTA6','MECA_XTC_TETRA4'/
      DATA (CPL(K,2),K=1,NBTYP) /
     &      'MECPQU4_XHC','MECPQU4_XHTC','MECPQU4_XHC','MECPQU4_XHTC',
     &      'MECPTR3_XHC','MECPTR3_XHTC','MECPTR3_XHC','MECPTR3_XHTC',
     &      'MECPTR3_XHC','MECPQU4_XHC','MECPQU8_XHC_X','MECPTR6_XHC_X',
     &      'MEDPQU4_XHC','MEDPQU4_XHTC','MEDPQU4_XHC','MEDPQU4_XHTC',
     &      'MEDPTR3_XHC','MEDPTR3_XHTC','MEDPTR3_XHC','MEDPTR3_XHTC',
     &      'MEDPTR3_XHC','MEDPQU4_XHC','MEDPQU8_XHC_X','MEDPTR6_XHC_X',
     &      'MECA_XHC_HEXA8','MECA_XHTC_HEXA8',
     &      'MECA_XHC_HEXA8','MECA_XHTC_HEXA8',
     &      'MECA_XHC_PENTA6','MECA_XHTC_PENTA6',
     &      'MECA_XHC_PENTA6','MECA_XHTC_PENTA6',
     &      'MECA_XHC_TETRA4','MECA_XHTC_TETRA4',
     &      'MECA_XHC_TETRA4','MECA_XHTC_TETRA4',
     &      'MECPQU8_XHC','MEDPQU8_XHC','MECPTR6_XHC','MEDPTR6_XHC',
     &      'MECPQU4_XTC','MECPTR3_XTC','MEDPQU4_XTC','MEDPTR3_XTC',
     &      'MECA_XTC_HEXA8','MECA_XTC_PENTA6','MECA_XTC_TETRA4'/
      DATA (NPL(K),K=1,NBTYP) /
     &      8, 8, 8, 8, 6, 6, 6, 6, 7, 7, 12, 9,
     &      8, 8, 8, 8, 6, 6, 6, 6, 7, 7, 12, 9,
     &      16, 16, 16, 16, 12, 12, 12, 12, 8, 8, 8, 8,
     &      16,16,12,12,
     &      4, 3, 4, 3, 8, 6, 4/

C
C ----------------------------------------------------------------------
C
      IORDR = 0
      NNDEL = 0
C
      IF (IIN.EQ.0) THEN
        DO 10 K=1,NBTYP
          IF (NTYELE.EQ.CPL(K,1)) THEN
            IF (NTYELM.EQ.CPL(K,2)) THEN
              NNDEL = NPL(K)
              IORDR = K
            ENDIF
          ENDIF
  10    CONTINUE
      ELSEIF ((IIN.GT.0).AND.(IIN.LE.NBTYP)) THEN
        IORDR = IIN
        NNDEL = NPL(IIN)
      ELSE
        IORDR = 0
      ENDIF
      CALL ASSERT(IORDR.NE.0)

      END
