      SUBROUTINE XMILAR(NDIM,JPTINT,JTABAR,AREINT,MILARA,MILARB)
      IMPLICIT NONE

      INTEGER       NDIM,JTABAR,AREINT,JPTINT
      REAL*8        MILARA(NDIM),MILARB(NDIM)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 20/12/2010   AUTEUR PELLET J.PELLET 
C TOLE CRS_1404
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C                      TROUVER LES PTS MILIEUX ENTRE LES EXTREMITES DE
C                      L'ARETE ET LE POINT D'INTERSECTION
C
C     ENTREE
C       NDIM    : DIMENSION TOPOLOGIQUE DU MAILLAGE
C       PINTER  : COORDONNES DES POINTS D'INTERSECTION
C       JTABAR  : COORDONNEES DES 3 NOEUDS DE L'ARETE
C       AREINT  : POSITION DU PT INTER DE L'ARETE DANS LA LISTE
C
C     SORTIE
C       MILARA  : COOR DU PT MILIEU ENTRE 1ER PT DE COORSG ET PT INTER
C       MILARB  : COOR DU PT MILIEU ENTRE 2EM PT DE COORSG ET PT INTER
C     ----------------------------------------------------------------
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  ------------------------
      REAL*8           ZR
      COMMON  /RVARJE/ ZR(1)
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  ------------------------
C
      REAL*8        C(NDIM)
      REAL*8        S,SC,S1
      REAL*8        KSI1,KSIA(NDIM),KSIB(NDIM)
      INTEGER       K,J,NNO
      CHARACTER*8   ELP
      PARAMETER     (ELP='SE3', NNO=3)
C
C --------------------------------------------------------------------
      CALL JEMARQ()

C     RECUPERATION DES COORDONNES DU PT INTER
      DO 100 J=1,3
        IF(AREINT.EQ.J) THEN
          DO 200 K=1,NDIM
            C(K)=ZR(JPTINT-1+(J-1)*NDIM+K)
 200      CONTINUE
        END IF
 100  CONTINUE

C     TABAR : KSI2=-1  /  KSI1= 1  /  KSI3= 0
C     KSI2 ETANT LE POINT D'ORIGINE

C --- ABSCISSE CURVILIGNE DU PT INTER SUR L'ARETE
      CALL ABSCVL(NDIM,JTABAR,C,SC)

C --- COORDONNES DU POINT MILARA DANS L'ELEMENT DE REFERENCE
C     TEL QUE ABSCISSE CURVILIGNE(D1)=ABSCISSE CURVILIGNE(I)/2
      S=SC/2
      CALL XINVAC(ELP,NDIM,JTABAR,S,KSIA)
      CALL ASSERT(KSIA(1).GE.-1 .AND. KSIA(1).LE.1)

C --- COORDONNES DU POINT MILARA DANS L'ELEMENT REEL
      CALL REEREL(ELP,NNO,NDIM,JTABAR,KSIA,MILARA)

C --- ABSCISSE CURVILIGNE DE KSI1
      KSI1=1
      CALL ABSCVF(NDIM,JTABAR,KSI1,S1)

C --- COORDONNES DU POINT MILARB DANS L'ELEMENT DE REFERENCE
C     TEL QUE ABSCURV(D2)=[ABSCURV(A)+ABSCURV(I)]/2
      S=(S1+SC)/2
      CALL XINVAC(ELP,NDIM,JTABAR,S,KSIB)
      CALL ASSERT(KSIB(1).GE.-1 .AND. KSIB(1).LE.1)

C --- COORDONNES DU POINT MILARB DANS L'ELEMENT REEL
      CALL REEREL(ELP,NNO,NDIM,JTABAR,KSIB,MILARB)

      CALL JEDEMA()
      END
