      SUBROUTINE XMMAB4(NDIM,NNO,NNOS,FFP,JAC,PTKNP,NFH,SEUIL,
     &                  MU,SINGU,RR,COEFBU,DDLS,DDLM,
     &                  MMAT)

      IMPLICIT NONE
      INTEGER     NDIM,NNO,NNOS
      INTEGER     NFH,DDLS,DDLM
      INTEGER     SINGU
      REAL*8      MMAT(204,204),PTKNP(3,3)
      REAL*8      FFP(27),JAC
      REAL*8      RR,SEUIL,MU,COEFBU

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 19/01/2011   AUTEUR MASSIN P.MASSIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================

C
C ROUTINE CONTACT (METHODE XFEM HPP - CALCUL ELEM.)
C
C --- CALCUL DE B_U
C      
C ----------------------------------------------------------------------
C
C IN  NDIM   : DIMENSION DE L'ESPACE
C IN  NNO    : NOMBRE DE NOEUDS DE L'ELEMENT DE REF PARENT
C IN  NNOS   : NOMBRE DE NOEUDS SOMMET DE L'ELEMENT DE REF PARENT
C IN  JAC    : PRODUIT DU JACOBIEN ET DU POIDS
C IN  PTKNP  : MATRICE PT.KN.P
C IN  NFH    : NOMBRE DE FONCTIONS HEAVYSIDE
C IN  SEUIL  : SEUIL
C IN  MU     : COEFFICIENT DE COULOMB
C IN  SINGU  : 1 SI ELEMENT SINGULIER, 0 SINON
C IN  RR     : DISTANCE AU FOND DE FISSURE
C IN  COEFBU : 
C IN  DDLS   : NOMBRE DE DDL (DEPL+CONTACT)  CHAQUE NOEUD SOMMET
C IN  DDLM   : NOMBRE DE DDL A CHAQUE NOEUD MILIEU
C I/O MMAT   : MATRICE ELEMENTAITRE DE CONTACT/FROTTEMENT 
C
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX --------------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX --------------------
C
      INTEGER I,J,K,L,JN,IN
C
C ----------------------------------------------------------------------

      DO 170 I = 1,NNO
        CALL INDENT(I,DDLS,DDLM,NNOS,IN)

        DO 171 J = 1,NNO
          CALL INDENT(J,DDLS,DDLM,NNOS,JN)

          DO 172 K = 1,NFH*NDIM
            DO 173 L = 1,NFH*NDIM
C
              MMAT(IN+NDIM+K,JN+NDIM+L) =
     &        MMAT(IN+NDIM+K,JN+NDIM+L) -
     &        4.D0*MU*SEUIL*COEFBU*FFP(I)*FFP(J)*
     &        PTKNP(K,L)*JAC
 173        CONTINUE
C
            DO 174 L = 1,SINGU*NDIM
C
              MMAT(IN+NDIM+K,JN+NDIM*(1+NFH)+L) =
     &        MMAT(IN+NDIM+K,JN+NDIM*(1+NFH)+L) -
     &        4.D0*RR*MU*SEUIL*COEFBU*FFP(I)*FFP(J)*
     &        PTKNP(K,L)*JAC
C
 174        CONTINUE
 172      CONTINUE

          DO 175 K = 1,SINGU*NDIM
            DO 176 L = 1,NFH*NDIM
C
              MMAT(IN+NDIM*(1+NFH)+K,JN+NDIM+L) =
     &        MMAT(IN+NDIM*(1+NFH)+K,JN+NDIM+L) -
     &        4.D0*RR*MU*SEUIL*COEFBU*FFP(I)*FFP(J)*
     &        PTKNP(K,L)*JAC
C
 176        CONTINUE
            DO 177 L = 1,SINGU*NDIM
C
              MMAT(IN+NDIM*(1+NFH)+K,JN+NDIM*(1+NFH)+L)
     &        =  MMAT(IN+NDIM*(1+NFH)+K,JN+NDIM*(1+NFH)+L)
     &        -  4.D0*RR*RR*MU*SEUIL*COEFBU*FFP(I)*FFP(J)*
     &        PTKNP(K,L)*JAC
C
 177        CONTINUE
 175      CONTINUE

 171    CONTINUE
 170  CONTINUE

      END
