      SUBROUTINE XMMRED(NDIMG ,DEPDEL,DEPDES,LAGCN ,DEPCN,
     &                  FCONT ,FCONTS,FCTCN,
     &                  FFROT ,FFROTS,FFROCN)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 28/09/2010   AUTEUR MASSIN P.MASSIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INTEGER      NDIMG
      CHARACTER*19 DEPDEL,DEPDES,LAGCN,DEPCN
      CHARACTER*19 FCONT,FCONTS,FCTCN
      CHARACTER*19 FFROT,FFROTS,FFROCN      
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE XFEM - POST-TRAITEMENT)
C
C REDUCTION DU CHAMP SUR LES DDL
C
C ----------------------------------------------------------------------
C
C
C IN  NDIMG  : DIMENSION DE L'ESPACE
C
C ------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C --------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------
C 
      CHARACTER*8  DDLC(3),DDLS2(4),DDLS3(6),DDLT2(6),DDLT3(9)   
C ----------------------------------------------------------------------
      DATA         DDLC  /'LAGS_C','LAGS_F1','LAGS_F2'/
      DATA         DDLS2 /'H1X','H1Y','E1X','E1Y'/
      DATA         DDLS3 /'H1X','H1Y','H1Z','E1X','E1Y','E1Z'/
      DATA         DDLT2 /'DX','DY','H1X','H1Y','E1X','E1Y'/
      DATA         DDLT3 /'DX','DY','DZ','H1X','H1Y','H1Z',
     &                    'E1X','E1Y','E1Z'/ 
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- TRANSFORMATION DES CHAM_NO EN CHAM_NO_S
C
      CALL CNOCNS(DEPDEL,'V',DEPDES)
      CALL CNOCNS(FCONT ,'V',FCONTS)
      CALL CNOCNS(FFROT ,'V',FFROTS)
C
C --- REDUCTION SUR LES DDLS DE CONTACT
C      
      CALL CNSRED(DEPDES,0,0,NDIMG,DDLC,'V',LAGCN)
C
C --- REDUCTION SUR LES DDLS DE SAUTS
C
      IF (NDIMG.EQ.3) CALL CNSRED(DEPDES,0,0,2*NDIMG,DDLS3,'V',DEPCN )
      IF (NDIMG.EQ.2) CALL CNSRED(DEPDES,0,0,2*NDIMG,DDLS2,'V',DEPCN )
C
C --- REDUCTION FORCE DE CONTACT 
C      
      IF (NDIMG.EQ.2) CALL CNSRED(FCONTS,0,0,3*NDIMG,DDLT2,'V',FCTCN )
      IF (NDIMG.EQ.3) CALL CNSRED(FCONTS,0,0,3*NDIMG,DDLT3,'V',FCTCN )
C
C --- REDUCTION FORCE DE FROTTEMENT
C      
      IF (NDIMG.EQ.2) CALL CNSRED(FFROTS,0,0,3*NDIMG,DDLT2,'V',FFROCN)
      IF (NDIMG.EQ.3) CALL CNSRED(FFROTS,0,0,3*NDIMG,DDLT3,'V',FFROCN)
C
      CALL JEDEMA()
      END
