       SUBROUTINE XMMSA4(NDIM,NNO,NNOS,FFP,NDDL,NVEC,V1,V2,V3,
     &                  NFH,SINGU,RR,DDLS,DDLM,SAUT)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 23/02/2011   AUTEUR MASSIN P.MASSIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
      IMPLICIT NONE
      INTEGER     NDIM,NNO,NNOS
      INTEGER     NFH,DDLS,DDLM
      INTEGER     SINGU,NVEC,NDDL
      REAL*8      SAUT(3),RR,FFP(27)
      REAL*8      V1(NDDL),V2(*),V3(*)
C      
C ROUTINE CONTACT (METHODE XFEM HPP - CALCUL ELEM.)
C
C CALCUL DU SAUT
C      
C ----------------------------------------------------------------------
C
C IN  NDIM   : DIMENSION DE L'ESPACE
C IN  NNO    : NOMBRE DE NOEUDS DE L'ELEMENT DE REF PARENT
C IN  NNOS   : NOMBRE DE NOEUDS SOMMET DE L'ELEMENT DE REF PARENT
C IN  FFP    : FONCTIONS DE FORME DE L'ELEMENT PARENT
C IN  NDDL   : NOMBRE TOTAL DE DDL DE L ELEMENT
C IN  NVEC   : NOMBRE VECTEURS DEPLACEMENT
C IN  VEC1   : PREMIER VECTEUR
C IN  VEC2   : DEUXIEME VECTEUR
C IN  VEC3   : TROISIEME VECTEUR
C IN  NFH    : NOMBRE DE FONCTIONS HEAVYSIDE
C IN  SINGU  : 1 SI ELEMENT SINGULIER, 0 SINON
C IN  RR     : DISTANCE AU FOND DE FISSURE
C IN  DDLS   : NOMBRE DE DDL (DEPL+CONTACT)  CHAQUE NOEUD SOMMET
C IN  DDLM   : NOMBRE DE DDL A CHAQUE NOEUD MILIEU
C I/O SAUT   : SAUT
C
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX --------------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX --------------------
C
      INTEGER I,J,IN
C
C ----------------------------------------------------------------------

      CALL VECINI(3,0.D0,SAUT)
      CALL ASSERT(NVEC.GT.0)
      DO 161 I = 1,NNO
        CALL INDENT(I,DDLS,DDLM,NNOS,IN)
        DO 162 J = 1,NFH*NDIM
           SAUT(J) = SAUT(J) - 2.D0*FFP(I)*V1(IN+NDIM+J)
           IF(NVEC.GE.2) 
     &        SAUT(J) = SAUT(J) - 2.D0*FFP(I)*V2(IN+NDIM+J)
           IF(NVEC.GE.3) 
     &        SAUT(J) = SAUT(J) - 2.D0*FFP(I)*V3(IN+NDIM+J)
 162    CONTINUE
        DO 163 J = 1,SINGU*NDIM
           SAUT(J) = SAUT(J)-2.D0*FFP(I)*RR*V1(IN+NDIM*(1+NFH)+J)
           IF(NVEC.GE.2) 
     &        SAUT(J) = SAUT(J)-2.D0*FFP(I)*RR*V2(IN+NDIM*(1+NFH)+J)
           IF(NVEC.GE.3) 
     &        SAUT(J) = SAUT(J)-2.D0*FFP(I)*RR*V3(IN+NDIM*(1+NFH)+J)
 163    CONTINUE
 161  CONTINUE

      END
