      SUBROUTINE XMVEC2(NDIM,NNO,NNOS,NNOL ,NNOF,PLA,IPGF,IVFF,
     &                  FFC,FFP,REAC,JAC,NFH,NOEUD,SAUT,
     &                  SINGU,ND,RR,E,CPENCO ,LPENAC,DDLS,DDLM,
     &                  VTMP )

      IMPLICIT NONE
      INTEGER     NDIM,NNO,NNOS,NNOL,NNOF
      INTEGER     IVFF,IPGF,PLA(27)
      INTEGER     NFH,SINGU,DDLS,DDLM
      REAL*8      VTMP(400),E,CPENCO,SAUT(3),ND(3)
      REAL*8      FFC(8),FFP(27),JAC,REAC,RR
      LOGICAL     NOEUD,LPENAC

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 19/01/2011   AUTEUR MASSIN P.MASSIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================

C TOLE CRP_21
C
C ROUTINE CONTACT (METHODE XFEM HPP - CALCUL ELEM.)
C
C --- CALCUL DU VECTEUR LN1 & LN2
C      
C ----------------------------------------------------------------------
C
C IN  NDIM   : DIMENSION DE L'ESPACE
C IN  NNO    : NOMBRE DE NOEUDS DE L'ELEMENT DE REF PARENT
C IN  NNOS   : NOMBRE DE NOEUDS SOMMET DE L'ELEMENT DE REF PARENT
C IN  NNOL   : NOMBRE DE NOEUDS PORTEURS DE DDLC
C IN  NNOF   : NOMBRE DE NOEUDS DE LA FACETTE DE CONTACT
C IN  PLA    : PLACE DES LAMBDAS DANS LA MATRICE
C IN  IPGF   : NUMRO DU POINTS DE GAUSS
C IN  IVFF   : ADRESSE DANS ZR DU TABLEAU FF(INO,IPG)
C IN  FFC    : FONCTIONS DE FORME DE L'ELEMENT DE CONTACT
C IN  FFP    : FONCTIONS DE FORME DE L'ELEMENT PARENT
C IN  IDEPD  :
C IN  IDEPM  :
C IN  NFH    : NOMBRE DE FONCTIONS HEAVYSIDE
C IN  NOEUD  : INDICATEUR FORMULATION (T=NOEUDS , F=ARETE)
C IN  TAU1   : TANGENTE A LA FACETTE AU POINT DE GAUSS
C IN  TAU2   : TANGENTE A LA FACETTE AU POINT DE GAUSS
C IN  SINGU  : 1 SI ELEMENT SINGULIER, 0 SINON
C IN  RR     : DISTANCE AU FOND DE FISSURE
C IN  IFA    : INDICE DE LA FACETTE COURANTE
C IN  CFACE  : CONNECTIVIT DES NOEUDS DES FACETTES
C IN  LACT   : LISTE DES LAGRANGES ACTIFS
C IN  DDLS   : NOMBRE DE DDL (DEPL+CONTACT)  CHAQUE NOEUD SOMMET
C IN  DDLM   : NOMBRE DE DDL A CHAQUE NOEUD MILIEU
C IN  RHOTK  :
C IN  CSTAFR : COEFFICIENTS DE STABILISATION DU FROTTEMENT
C IN  CPENFR : COEFFICIENTS DE PENALISATION DU FROTTEMENT
C IN  LPENAF : INDICATEUR DE PENALISATION DU FROTTEMENT
C IN  P      :
C OUT ADHER  :
C OUT KNP    : PRODUIT KN.P
C OUT PTKNP  : MATRICE PT.KN.P
C OUT IK     :
C
C
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX --------------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX --------------------
C
      INTEGER I,J,IN,PLI
      REAL*8  FFI,DN
C
C ----------------------------------------------------------------------
C
      DN = 0.D0
      DO 143 J = 1,NDIM
        DN = DN + SAUT(J)*ND(J)
 143  CONTINUE
C
C --- TERME LN1
C
      IF (LPENAC) THEN
C     PENALISATION DU CONTACT
        DO 153 I = 1,NNO
          CALL INDENT(I,DDLS,DDLM,NNOS,IN)

          DO 154 J = 1,NFH*NDIM
            VTMP(IN+NDIM+J) = VTMP(IN+NDIM+J) -
     &      (CPENCO*DN)*2.D0*FFP(I)*ND(J)*JAC
 154      CONTINUE
          DO 155 J = 1,SINGU*NDIM
            VTMP(IN+NDIM*(1+NFH)+J) = VTMP(IN+NDIM*(1+NFH)+J) -
     &      (CPENCO*DN)*2.D0*FFP(I)*RR*ND(J)*JAC
 155       CONTINUE
 153     CONTINUE
       ELSE
         DO 150 I = 1,NNO
           CALL INDENT(I,DDLS,DDLM,NNOS,IN)

           DO 151 J = 1,NFH*NDIM
             VTMP(IN+NDIM+J) = VTMP(IN+NDIM+J) +
     &       (REAC-CPENCO*DN)*2.D0*FFP(I)*ND(J)*JAC
 151       CONTINUE
           DO 152 J = 1,SINGU*NDIM
             VTMP(IN+NDIM*(1+NFH)+J) = VTMP(IN+NDIM*(1+NFH)+J) +
     &       (REAC-CPENCO*DN)*2.D0*FFP(I)*RR*ND(J)*JAC
 152       CONTINUE
 150     CONTINUE
       ENDIF
C
C --- TERME LN2
C
       DO 160 I = 1,NNOL

         PLI=PLA(I)
         IF (NOEUD) THEN
           FFI=FFC(I)
         ELSE
           FFI=ZR(IVFF-1+NNOF*(IPGF-1)+I)
         ENDIF

         VTMP(PLI) = VTMP(PLI) - DN * FFI * JAC * E
         IF (LPENAC) THEN
           VTMP(PLI) = VTMP(PLI) - REAC*FFI*JAC/CPENCO*E
         ENDIF

 160     CONTINUE

      END
