      SUBROUTINE XMVEF0(NDIM  ,JNNE ,NNC   ,NFAES ,
     &                  JPCAI ,HPG   ,FFC   ,JACOBI,COEFCA,
     &                  DLAGRF,CFACE ,TYPMAI,TAU1  ,TAU2  ,
     &                  JDDLE,NCONTA,VTMP  )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/12/2010   AUTEUR MASSIN P.MASSIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT NONE
      INTEGER  NDIM,NNC,JNNE(3),NFAES,JPCAI,CFACE(5,3),JDDLE(2)
      REAL*8   HPG,FFC(8),JACOBI,COEFCA
      REAL*8   DLAGRF(2)   
      REAL*8   TAU1(3),TAU2(3)     
      REAL*8   VTMP(168)
      CHARACTER*8  TYPMAI  
      INTEGER  NCONTA
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE XFEMGG - CALCUL ELEM.)
C
C CALCUL DU SECOND MEMBRE POUR LE FROTTEMENT
C CAS SANS CONTACT (XFEM)
C
C ----------------------------------------------------------------------
C ROUTINE SPECIFIQUE A L'APPROCHE <<GRANDS GLISSEMENTS AVEC XFEM>>,
C TRAVAIL EFFECTUE EN COLLABORATION AVEC I.F.P.
C ----------------------------------------------------------------------
C
C IN  NDIM   : DIMENSION DU PROBLEME
C IN  NNE    : NOMBRE DE NOEUDS DE LA MAILLE ESCLAVE
C IN  HPG    : POIDS DU POINT INTEGRATION DU POINT DE CONTACT
C IN  FFC    : FONCTIONS DE FORME DU POINT DE CONTACT
C IN  JACOBI : JACOBIEN DE LA MAILLE AU POINT DE CONTACT
C IN  LAMBD  : LAGRANGE DE CONTACT ET FROTTEMENT AU POINT D'INTGRATION
C IN  TAU1   : PREMIER VECTEUR TANGENT
C IN  TAU2   : DEUXIEME VECTEUR TANGENT
C IN  DDLES : NOMBRE DE DDLS D'UN NOEUD SOMMET ESCLAVE
C I/O VTMP   : VECTEUR SECOND MEMBRE ELEMENTAIRE DE CONTACT/FROTTEMENT
C ----------------------------------------------------------------------
C
      INTEGER I,L,II,IN,PL,XOULA,NNE,NNES,DDLES
      REAL*8  TT(3), T
C ----------------------------------------------------------------------
C
C --- INITIALISATIONS
C
      NNE=JNNE(1)
      NNES=JNNE(2)
      DDLES=JDDLE(1)
C
      DO 100 I = 1,2
        TT(I) = 0.D0
 100  CONTINUE           
C
C --- CALCUL DE T.T
C
      DO 200 I = 1,NDIM
        T = DLAGRF(1)*TAU1(I)+DLAGRF(2)*TAU2(I)
        TT(1) = T*TAU1(I)+TT(1)
        IF (NDIM.EQ.3) TT(2) = T*TAU2(I)+TT(2)
 200  CONTINUE
C
C --------------------- CALCUL DE [F]-----------------------------------
C
      DO 500 I=1,NNC
        IN=XOULA(CFACE,NFAES,I,JPCAI,TYPMAI,NCONTA)
        CALL XPLMA2(NDIM,NNE,NNES,DDLES,IN,PL)
        DO 600 L=1,NDIM-1
          II = PL+L
          VTMP(II)= JACOBI*HPG*FFC(I)*TT(L)/COEFCA
  600   CONTINUE
  500 CONTINUE
C     
      END
