      SUBROUTINE XTOPOI(NOMA, MODELE)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 21/12/2010   AUTEUR MASSIN P.MASSIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE GENIAUT S.GENIAUT
C
      IMPLICIT NONE 
      CHARACTER*8   NOMA, MODELE
C     
C ----------------------------------------------------------------------
C
C ROUTINE XFEM (METHODE XFEM - PREPARATION)
C
C AJOUTER  LA SD FISS_XFEM LES DONNES TOPOLOGIQUES CONCERNANT 
C LA DCOUPE DES LMENTS POUR L'INTGRATION 
C      
C ----------------------------------------------------------------------
C
C
C  IN  MODELE : NOM DE L'OBJET MODELE 
C  I/O FISS   : NOM DE LA SD FISS_XFEM
C
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      NBOUT,NBIN
      PARAMETER    (NBOUT=6, NBIN=4)
      CHARACTER*8  LPAOUT(NBOUT),LPAIN(NBIN),LICMP(2),K8BID
      CHARACTER*19 LCHOUT(NBOUT),LCHIN(NBIN)
C
      INTEGER      JNOMA
      CHARACTER*19 LIGREL,CHGEOM
      CHARACTER*19 PINTTO,CNSETO,HEAVTO,LONCHA,CRITER,PMILTO
      LOGICAL      DEBUG
      INTEGER      IFM,NIV,IFMDBG,NIVDBG,JNBSP,IBID,IMA,NBMA,IRET
      INTEGER     JCESD,JCESV,JCESL,IAD
      CHARACTER*16 OPTION 
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('XFEM',IFM,NIV)
      CALL INFDBG('PRE_CALCUL',IFMDBG,NIVDBG)      
C
C --- INITIALISATIONS
C 
      LIGREL = MODELE//'.MODELE'
      OPTION = 'TOPOSE'
      IF (NIVDBG.GE.2) THEN
        DEBUG  = .TRUE.
      ELSE
        DEBUG  = .FALSE.
      ENDIF
      CALL JEVEUO(MODELE//'.MODELE    .LGRF','L',JNOMA)
      CHGEOM = ZK8(JNOMA)//'.COORDO'
C
C --- INITIALISATION DES CHAMPS POUR CALCUL
C
      CALL INICAL(NBIN  ,LPAIN ,LCHIN ,
     &            NBOUT ,LPAOUT,LCHOUT)
C
C --- RECUPERATION DES DONNEES XFEM (TOPOSE)
C
      PINTTO = MODELE(1:8)//'.TOPOSE.PIN'
      CNSETO = MODELE(1:8)//'.TOPOSE.CNS'
      HEAVTO = MODELE(1:8)//'.TOPOSE.HEA'
      LONCHA = MODELE(1:8)//'.TOPOSE.LON'
      CRITER = MODELE(1:8)//'.TOPOSE.CRI'
      PMILTO = MODELE(1:8)//'.TOPOSE.PMI'
C
      LICMP(1) = 'NPG_DYN'
      LICMP(2) = 'NCMP_DYN'
      CALL CESCRE('V',HEAVTO,'ELEM',NOMA,'DCEL_I',2,LICMP,
     &              IBID,-1,-2)
      CALL JEVEUO(HEAVTO//'.CESD','L',JCESD)
      CALL JEVEUO(HEAVTO//'.CESV','E',JCESV)
      CALL JEVEUO(HEAVTO//'.CESL','E',JCESL)
C
C --- RECUPERATION DU NOMBRE DE FISSURES VUES
C
      CALL JEVEUO('&&XTYELE.NBSP','L',JNBSP)
C
C --- REMPLISSAGE DES SOUS POINT DE HEAVTO
C
      CALL DISMOI('F','NB_MA_MAILLA',NOMA,'MAILLAGE',NBMA,K8BID,IRET)
      DO 10 IMA=1,NBMA
        CALL CESEXI('S',JCESD,JCESL,IMA,1,1,1,IAD)
        ZL(JCESL-1-IAD) = .TRUE.
        ZI(JCESV-1-IAD) = ZI(JNBSP-1+IMA)
C
 10   CONTINUE
C       
C --- CREATION DES LISTES DES CHAMPS IN
C
      LPAIN(1)  = 'PGEOMER'
      LCHIN(1)  = CHGEOM
      LPAIN(2)  = 'PLEVSET'
      LCHIN(2)  = MODELE(1:8)//'.LNNO'
      LPAIN(3)  = 'PGRADLN'
      LCHIN(3)  = MODELE(1:8)//'.GRLNNO'
      LPAIN(4)  = 'PFISCO'
      LCHIN(4)  = MODELE(1:8)//'.FISSCO'
C       
C --- CREATION DES LISTES DES CHAMPS OUT
C
      LPAOUT(1) = 'PPINTTO'
      LCHOUT(1) = PINTTO
      LPAOUT(2) = 'PCNSETO'
      LCHOUT(2) = CNSETO
      LPAOUT(3) = 'PHEAVTO'
      LCHOUT(3) = HEAVTO
      LPAOUT(4) = 'PLONCHA'
      LCHOUT(4) = LONCHA
      LPAOUT(5) = 'PCRITER'
      LCHOUT(5) = CRITER
      LPAOUT(6) = 'PPMILTO'
      LCHOUT(6) = PMILTO
C
C --- APPEL A CALCUL
C      
      CALL CALCUL('C',OPTION,LIGREL,NBIN ,LCHIN ,LPAIN ,
     &                              NBOUT,LCHOUT,LPAOUT,'G','OUI')
C
      IF (DEBUG) THEN
        CALL DBGCAL(OPTION,IFMDBG,
     &              NBIN  ,LPAIN ,LCHIN ,
     &              NBOUT ,LPAOUT,LCHOUT)
      ENDIF 
C 
      CALL JEDEMA()
      END
