      SUBROUTINE ZREORD(ZMAT,NBDDG,NBMOD,NBMOB,NBDDR,AXOK,LIAX,NBLIAX,
     &                   ZVEC)
      IMPLICIT REAL*8 (A-H,O-Z)
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 11/03/98   AUTEUR CIBHHLV L.VIVAN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C  BUT:  < REMISE EN ORDRE DES COORDONNEES COMPLEXES >
C
C   CETTE ROUTINE MET EN ORDRE LES COORDONNEES COMPLEXES DES MODE
C  DANS LE CAS D'ASSEMBLAGE PARTIEL DU A  UNE INTEFACE AXE EN
C  CYCLIQUE CRAIG-BAMPTON 
C-----------------------------------------------------------------------
C
C ZMAT      /M/: MATRICE DES COORDONNEES GENERALISEES DES MODES PROPRES
C NBDDG     /I/: NOMBRE DE DEGRE DE LIBETE GENERALISE TOTAL
C NBMOD     /I/: NOMBRE DE MODE CYCLIQUES CALCULES
C NBMOB     /I/: NOMBRE DE MODE PROPRES DE LA BASE MODALE 
C NBDDR     /I/: NOMBRE DDL GENERALISE DE DROITE (=GAUCHE)
C AXOK      /I/: INDICATEUR ASSEMBLAGE AXE
C LIAX      /I/: LISTE NUMERO DDL AXE A ASSEMBLES 
C NBLIAX    /I/: NOMBRE DE DDL AXE A ASSEMBLES 
C ZVEC      /M/: VECTEUR DE TRAVAIL COMPLEXE DIMENSIONNE A NBDDG
C
C-----------------------------------------------------------------------
      INTEGER    LIAX(NBLIAX)
      COMPLEX*16 ZMAT(NBDDG,NBMOD),ZVEC(NBDDG)
      LOGICAL AXOK
C-----------------------------------------------------------------------
C
C  CAS DE PRESENCE DDL AXE
C
      IF(AXOK) THEN
        DO 10 J=1,NBMOD
C
          DO 20 I=1,NBLIAX
            ZVEC(I)=ZMAT(I+NBMOB+NBDDR,J)
20        CONTINUE
C
          IF((NBMOB+NBDDR).LT.NBDDG) THEN
            DO 30 I=NBMOB+NBDDR+1,NBDDG
              ZMAT(I,J)=DCMPLX(0.D0,0.D0)
30          CONTINUE
          ENDIF
C
          DO 40 I=1,NBLIAX
            ZMAT(NBMOB+NBDDR+LIAX(I),J)=ZVEC(I)
40        CONTINUE
C
10      CONTINUE
C
C  AUTRE CAS
C
      ELSE
        IF((NBMOB+NBDDR).LT.NBDDG) THEN
          DO 50 J=1,NBMOD
            DO 60 I=NBMOB+NBDDR+1,NBDDG
              ZMAT(I,J)=DCMPLX(0.D0,0.D0)
60          CONTINUE
50        CONTINUE
        ENDIF
C
      ENDIF
      END
