      SUBROUTINE NUGLLO(NU,BASE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ASSEMBLA  DATE 22/06/2010   AUTEUR SELLENET N.SELLENET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE SELLENET N.SELLENET
      IMPLICIT NONE
      CHARACTER*14 NU
      CHARACTER*2 BASE
C----------------------------------------------------------------------
C---- OBJET : CREATION D'UN CHAMP .NUML A LA S.D. NUME_DDL NU
C             CE .NUML DECRIT LA NUMEROTATION LOCALE UTILE POUR MUMPS
C             FONCTIONNANT EN AVEC UNE MATRICE ASSEMBLEE DISTRIBUEE
C----------------------------------------------------------------------
C IN K14 NU     : NOM DU NUME_DDL
C IN K2   BASE  : BASE(1:1) : BASE POUR CREER LE NUME_DDL
C                    (SAUF LE PROF_CHNO)
C               : BASE(2:2) : BASE POUR CREER LE PROF_CHNO
C----------------------------------------------------------------------

C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32,JEXATR
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      CHARACTER*32 JEXNUM
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------

      INTEGER NBMA,JCONX1,JCONX2,IER,IBID,DIME
      INTEGER JNUMSD,RANG,LONMAX,IMA,NUMA,NBNO,INO,NUNO
      INTEGER NEC,NLILI,NBDDL,IDPRN1,IDPRN2,ILI,NTOT
      INTEGER IDPR21,IDPR22,NUMINC,NUMEC,NDDL,JNUEQ
      INTEGER JTANO,ITANO,NBEQ,JNEQ,IEQ,IDDL,IDNEQU,INULOG
      INTEGER INUEQ,NUMDDL,JDELG,JDELGL
      INTEGER IADNEM,IADLIE,IGREL,IEL,IGR,NEL,NNOE,K1,N1,J,ILIB
      INTEGER JDELGT,JDDLP,NUMPRO,NBPROC,VALI(1),IDDLG,NDDLG

      CHARACTER*8 K8B,NOMA,PARTIT,MO
      CHARACTER*19 NOMLIG
      CHARACTER*24 KBID
C----------------------------------------------------------------------
      INTEGER ZZPRNO,IZZPR2,ZZPRN2,NUNOEL,L
      INTEGER ZZNGEL,ZZNELG,ZZLIEL,ZZNSUP,ZZNEMA

C---- FONCTION D ACCES AUX ELEMENTS DES CHAMPS PRNO DES S.D. LIGREL
C     REPERTORIEES DANS LE CHAMP LILI DE NUME_DDL ET A LEURS ADRESSES
C     ZZPRNO(ILI,NUNOEL,1) = NUMERO DE L'EQUATION ASSOCIEES AU 1ER DDL
C                            DU NOEUD NUNOEL DANS LA NUMEROTATION LOCALE
C                            AU LIGREL ILI DE .LILI
C     ZZPRNO(ILI,NUNOEL,2) = NOMBRE DE DDL PORTES PAR LE NOEUD NUNOEL
C     ZZPRNO(ILI,NUNOEL,2+1) = 1ER CODE
C     ZZPRNO(ILI,NUNOEL,2+NEC) = NEC IEME CODE

C      IZZPRN(ILI,NUNOEL,L) = (IDPRN1-1+ZI(IDPRN2+ILI-1)+
C     &                       (NUNOEL-1)* (NEC+2)+L-1)
      ZZPRNO(ILI,NUNOEL,L) = ZI(IDPRN1-1+ZI(IDPRN2+ILI-1)+
     &                       (NUNOEL-1)* (NEC+2)+L-1)

      IZZPR2(ILI,NUNOEL,L) = (IDPR21-1+ZI(IDPR22+ILI-1)+
     &                       (NUNOEL-1)* (NEC+2)+L-1)
      ZZPRN2(ILI,NUNOEL,L) = ZI(IDPR21-1+ZI(IDPR22+ILI-1)+
     &                       (NUNOEL-1)* (NEC+2)+L-1)

C---- NBRE DE GROUPES D'ELEMENTS (DE LIEL) DU LIGREL ILI

      ZZNGEL(ILI)=ZI(IADLIE+3*(ILI-1))

C---- NBRE D ELEMENTS DU LIEL IGREL DU LIGREL ILI DU REPERTOIRE TEMP.
C     .MATAS.LILI(DIM DU VECTEUR D'ENTIERS .LILI(ILI).LIEL(IGREL) )

      ZZNELG(ILI,IGREL)=ZI(ZI(IADLIE+3*(ILI-1)+2)+IGREL)-
     &                  ZI(ZI(IADLIE+3*(ILI-1)+2)+IGREL-1)-1

C---- FONCTION D ACCES AUX ELEMENTS DES CHAMPS LIEL DES S.D. LIGREL
C     REPERTORIEES DANS LE REPERTOIRE TEMPORAIRE .MATAS.LILI
C     ZZLIEL(ILI,IGREL,J) =
C      SI LA JIEME MAILLE DU LIEL IGREL DU LIGREL ILI EST:
C          -UNE MAILLE DU MAILLAGE : SON NUMERO DANS LE MAILLAGE
C          -UNE MAILLE TARDIVE : -POINTEUR DANS LE CHAMP .NEMA

      ZZLIEL(ILI,IGREL,J)=ZI(ZI(IADLIE+3*(ILI-1)+1)-1+
     &                    ZI(ZI(IADLIE+3*(ILI-1)+2)+IGREL-1)+J-1)

C---- NBRE DE NOEUDS DE LA MAILLE TARDIVE IEL ( .NEMA(IEL))
C     DU LIGREL ILI REPERTOIRE .LILI
C     (DIM DU VECTEUR D'ENTIERS .LILI(ILI).NEMA(IEL) )

      ZZNSUP(ILI,IEL)=ZI(ZI(IADNEM+3*(ILI-1)+2)+IEL)-
     &                ZI(ZI(IADNEM+3*(ILI-1)+2)+IEL-1)-1

C---- FONCTION D ACCES AUX ELEMENTS DES CHAMPS NEMA DES S.D. LIGREL
C     REPERTORIEES DANS LE REPERTOIRE TEMPO. .MATAS.LILI

      ZZNEMA(ILI,IEL,J)=ZI(ZI(IADNEM+3*(ILI-1)+1)-1+
     &                  ZI(ZI(IADNEM+3*(ILI-1)+2)+IEL-1)+J-1)

C----------------------------------------------------------------------

C---- SUPPRESSION DU .NUML
      CALL DETRSD('NUML_DDL',NU)

C---- RECHERCHE DU MAILLAGE ET DU NOMBRE DE MAILLES
      CALL DISMOI('F','NOM_MAILLA',NU,'NUME_DDL',IBID,NOMA,IER)
      CALL DISMOI('F','NB_MA_MAILLA',NOMA,'MAILLAGE',NBMA,K8B,IER)
      CALL DISMOI('F','NB_NO_MAILLA',NOMA,'MAILLAGE',NBNO,K8B,IER)

      CALL JEVEUO(NU//'     .ADNE','E',IADNEM)
      CALL JEVEUO(NU//'     .ADLI','E',IADLIE)

C---- ON CREE LE TABLEAU &&NUGLLO.TAB_NO DONT LE ROLE EST DE DIRE SI
C     ON A DEJA UN NOEUD DU MAILLAGE DONNE DANS LE .NUML.PRNO
      CALL WKVECT('&&NUGLLO.TAB_NO','V V I',NBNO,JTANO)

      DO 10 ITANO = 1,NBNO
        ZI(JTANO+ITANO-1)=0
   10 CONTINUE

C---- CREATION DU TABLEAU &&NUGLLO.TAB_EQ QUI SERVIRA A CREER LE .NUEQ
      CALL JEVEUO(NU//'.NUME.NEQU','L',JNEQ)
      NBEQ=ZI(JNEQ)
      CALL WKVECT('&&NUGLLO.TAB_EQ','V V I',NBEQ,JNEQ)
      CALL WKVECT(NU//'.NUML.NUGL',BASE(1:1)//' V I',NBEQ,IDDLG)

      DO 20 IEQ = 0,NBEQ-1
        ZI(JNEQ+IEQ)=0
        ZI(IDDLG+IEQ)=0
   20 CONTINUE

C---- RECHERCHE DU TABLEAU PARTITION
      CALL DISMOI('F','NOM_MODELE',NU,'NUME_DDL',IBID,MO,IER)
      CALL DISMOI('F','NOM_LIGREL',MO,'MODELE',IBID,NOMLIG,IER)
      CALL DISMOI('F','PARTITION',NOMLIG,'LIGREL',IBID,PARTIT,IER)
      IF (PARTIT.NE.' ') THEN
        CALL MPICM0(RANG,NBPROC)
        CALL JEVEUO(PARTIT//'.NUPROC.MAILLE','L',JNUMSD)
        CALL JELIRA(PARTIT//'.NUPROC.MAILLE','LONMAX',LONMAX,KBID)
      ELSE
        RANG=0
        JNUMSD=-1
      ENDIF

C---- ON VERIFIE QU'IL N'Y A PAS DE SUPER-MAILLES
      CALL JEVEUO(NOMA//'.DIME','L',DIME)
      CALL ASSERT(ZI(DIME+3).EQ.0)

C---- ALLOCATION DU PRNO DE NUML :
C     SI ON EST SUR LE PROC 0, ON DIMENSIONNE LA
C     COLLECTION A NULILI SINON A 1 PUISQUE TOUS
C     LES NOEUDS LAGRANGE SERONT SUR LE PROC 0
      IF ( RANG.EQ.0 ) THEN
        CALL JELIRA(NU//'.NUME.PRNO','NMAXOC',NLILI,KBID)
        CALL JECREC(NU//'.NUML.PRNO',BASE(1:1)//' V I ','NU','CONTIG',
     &              'VARIABLE',NLILI)
      ELSE
        CALL JECREC(NU//'.NUML.PRNO',BASE(1:1)//' V I ','NU','CONTIG',
     &              'VARIABLE',1)
        NLILI=1
      ENDIF

      CALL JELIRA(JEXNUM(NU//'.NUME.PRNO',1),'LONMAX',NTOT,KBID)

C---- POUR TOUS LES PROCS : ALLOCATION DE .NUML.PRNO(1)
      CALL JEECRA(JEXNUM(NU//'.NUML.PRNO',1),'LONMAX',NTOT,KBID)

C---- CALCUL DU NOMBRE D'ENTIERS CODES A PARTIR DE LONMAX
      NEC = NTOT/ZI(DIME)-2

C---- LES NOEUDS TARDIFS SONT POUR LE PROC 0
      IF ( RANG.EQ.0 ) THEN
        DO 30 ILI = 2,NLILI
          CALL JELIRA(JEXNUM(NU//'.NUME.PRNO',ILI),'LONMAX',
     &                NTOT,KBID)

          CALL JEECRA(JEXNUM(NU//'.NUML.PRNO',ILI),'LONMAX',
     &                NTOT,KBID)
   30   CONTINUE
      ENDIF

C---- LECTURE DE LA CONNECTIVITE
      CALL JEVEUO(NOMA//'.CONNEX','L',JCONX1)
      CALL JEVEUO(JEXATR(NOMA//'.CONNEX','LONCUM'),'L',JCONX2)

C---- RECHERCHE DES ADRESSES DU .PRNO DE .NUME
      CALL JEVEUO(NU//'.NUME.PRNO','E',IDPRN1)
      CALL JEVEUO(JEXATR(NU//'.NUME.PRNO','LONCUM'),'L',IDPRN2)

C---- RECHERCHE DES ADRESSES DU .PRNO DE .NUML
      CALL JEVEUO(NU//'.NUML.PRNO','E',IDPR21)
      CALL JEVEUO(JEXATR(NU//'.NUML.PRNO','LONCUM'),'L',IDPR22)

      CALL WKVECT('&&NUGLLO.DDL_PRES','V V I',NBEQ,JDDLP)
      CALL WKVECT('&&NUGLLO.DELG_TMP','V V I',NBEQ,JDELGT)

      DO 500 J=0,NBEQ-1
        ZI(JDELGT+J)=0
        ZI(JDDLP+J)=0
  500 CONTINUE

C---- REMPLISSAGE DU .PRNO, DU TABLEAU &&NUGLLO.TAB_EQ QUI SERVIRA A
C     CREER LE .NUEQ POUR LES DDL PHYSIQUES
      NUMINC=1
      DO 40 IMA=1,NBMA
        NUMA=IMA
        IF (JNUMSD.EQ.-1) THEN
          NUMPRO=0
        ELSE
          NUMPRO=ZI(JNUMSD+NUMA-1)
        ENDIF
        
C       SI NUMPRO < 0 ALORS CETTE MAILLE N'EST PAS UNE MAILLE DU MODELE
        IF ( NUMPRO.LT.0 ) GOTO 40
        
        IF ( NUMPRO.EQ.RANG ) THEN
          NBNO=ZI(JCONX2+NUMA)-ZI(JCONX2+NUMA-1)
          DO 50 INO=1,NBNO
            NUNO=ZI(JCONX1-1+ZI(JCONX2+NUMA-1)+INO-1)
            
            IF ( ZI(JTANO+NUNO-1).EQ.0 ) THEN
              NUMDDL=ZZPRNO(1,NUNO,1)
              NDDL=ZZPRNO(1,NUNO,2)

C----         REMPLISSAGE DE .NUML.PRNO
              ZI(IZZPR2(1,NUNO,1))=NUMINC
              ZI(IZZPR2(1,NUNO,2))=NDDL
              DO 60 NUMEC=1,NEC
                ZI(IZZPR2(1,NUNO,2+NUMEC))=ZZPRNO(1,NUNO,2+NUMEC)
   60         CONTINUE

              DO 70 IDDL=1,NDDL
                ZI(JDDLP+NUMDDL+IDDL-1)=1
                ZI(JNEQ+NUMINC-1+IDDL-1)=NUMDDL+IDDL-1
   70         CONTINUE
              NUMINC=NUMINC+NDDL
              ZI(JTANO+NUNO-1)=1
            ENDIF
   50     CONTINUE
        ELSE
          NBNO=ZI(JCONX2+NUMA)-ZI(JCONX2+NUMA-1)
          DO 80 INO=1,NBNO
            NUNO=ZI(JCONX1-1+ZI(JCONX2+NUMA-1)+INO-1)
            
            IF ( ZI(JTANO+NUNO-1).EQ.0 ) THEN
              ZI(IZZPR2(1,NUNO,1))=0
              ZI(IZZPR2(1,NUNO,2))=0
              DO 90 NUMEC=1,NEC
                ZI(IZZPR2(1,NUNO,2+NUMEC))=0
   90         CONTINUE
            ENDIF
   80     CONTINUE
        ENDIF
   40 CONTINUE

      CALL JEVEUO(NU//'.NUME.DELG','L',JDELG)

C---- REMPLISSAGE DU .PRNO, DU TABLEAU &&NUGLLO.TAB_EQ QUI SERVIRA A
C     CREER LE .NUEQ POUR LES DDL DE LAGRANGE
      DO 100 ILI = 2,NLILI
        CALL JENUNO(JEXNUM(NU//'.NUME.LILI',ILI),NOMLIG)

        DO 210 IGR=1,ZZNGEL(ILI)
          NEL=ZZNELG(ILI,IGR)
          DO 220 IEL=1,NEL
            NUMA=ZZLIEL(ILI,IGR,IEL)
            IF (NUMA.LT.0) THEN
C             -- MAILLES TARDIVES :
              NUMA=-NUMA
              NNOE=ZZNSUP(ILI,NUMA)
              DO 230 K1=1,NNOE
                N1=ZZNEMA(ILI,NUMA,K1)
                IF (N1.LT.0) THEN
                  N1=-N1
                  ILIB=ILI
                ELSE
                  ILIB=1
                  IF ( ZI(JTANO+N1-1).EQ.1 ) THEN
                    GOTO 230
                  ENDIF
                  ZI(JTANO+N1-1)=1
                ENDIF
                NUMDDL=ZZPRNO(ILIB,N1,1)
                NDDL=ZZPRNO(ILIB,N1,2)
                IF ( ZI(JDDLP+NUMDDL).EQ.1 ) GOTO 230
                ZI(IZZPR2(ILIB,N1,1))=NUMINC
                ZI(IZZPR2(ILIB,N1,2))=NDDL
                DO 120 NUMEC=1,NEC
                  ZI(IZZPR2(ILIB,N1,2+NUMEC))=
     &                                      ZZPRNO(ILIB,N1,2+NUMEC)
  120           CONTINUE
                DO 130 IDDL=1,NDDL
                  ZI(JDDLP+NUMDDL+IDDL-1)=1
                  ZI(JNEQ+NUMINC-1+IDDL-1)=NUMDDL+IDDL-1
                  ZI(JDELGT+NUMINC-1+IDDL-1)=ZI(JDELG+NUMDDL-1+IDDL-1)
  130           CONTINUE
                NUMINC=NUMINC+NDDL
  230         CONTINUE
            ENDIF
  220     CONTINUE
  210   CONTINUE
  100 CONTINUE

      NBDDL=NUMINC-1
      
C---- ON VERIFIE QUE CHAQUE PROC A AU MOINS UN DDL
      IF ( NBDDL.EQ.0 ) THEN
        VALI(1)=RANG
        CALL U2MESI('F', 'ASSEMBLA_4',1,VALI)
      ENDIF
      
C---- CREATION DU .NUML.DELG
      CALL WKVECT(NU//'.NUML.DELG',BASE(1:1)//' V I',NBDDL,JDELGL)

      DO 240 J=0,NBDDL-1
        ZI(JDELGL+J)=ZI(JDELGT+J)
  240 CONTINUE

C---- CREATION DU .NUML.NEQU
      CALL WKVECT(NU//'.NUML.NEQU',BASE(1:1)//' V I',2,IDNEQU)
      ZI(IDNEQU) = NBDDL

C---- CREATION DU .NUML.NULG ET DU .NUML.NUEQ
      CALL WKVECT(NU//'.NUML.NULG',BASE(1:1)//' V I',NBDDL,INULOG)
      CALL WKVECT(NU//'.NUML.NUEQ',BASE(1:1)//' V I',NBDDL,INUEQ)

      DO 150 ILI = 1,NLILI
        CALL JELIRA(JEXNUM(NU//'.NUML.PRNO',ILI),'LONMAX',
     &              NTOT,KBID)
        NTOT=NTOT/(NEC+2)

        DO 160 INO=1,NTOT
          NUMDDL=ZZPRN2(ILI,INO,1)
          NDDL=ZZPRN2(ILI,INO,2)
          DO 170 IDDL=1,NDDL
            NDDLG=ZI(JNEQ+NUMDDL-1+IDDL-1)
            
            ZI(INULOG+NUMDDL-1+IDDL-1)=NDDLG
            ZI(INUEQ+NUMDDL-1+IDDL-1)=NUMDDL+IDDL-1
            ZI(IDDLG+NDDLG-1)=NUMDDL-1+IDDL
            
            CALL ASSERT(NDDLG.NE.0)
  170     CONTINUE
  160   CONTINUE
  150 CONTINUE

      CALL JEDETR('&&NUGLLO.TAB_NO')
      CALL JEDETR('&&NUGLLO.TAB_EQ')
      CALL JEDETR('&&NUGLLO.DELG_TMP')
      CALL JEDETR('&&NUGLLO.DDL_PRES')

      END
