      SUBROUTINE PTEEQU(PRCHNO,BASZ,NEQ,GDS,NCMP,CORR2)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ASSEMBLA  DATE 01/03/2011   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
C
C     ARGUMENTS:
C     ----------
      CHARACTER*19 PRCHNO
      INTEGER NEQ,GDS,NCMP,CORR2(NCMP)
      CHARACTER*(*) BASZ
C ----------------------------------------------------------------------
C     BUT : CREER L'OBJET .DEEQ D'UN PROF_CHNO DANS LE CAS OU IL N'Y A
C           QUE DES NOEUDS PHYSIQUES (MAILLAGE)
C     IN:
C     PRCHNO : NOM D'UN PROF_CHNO
C     NEQ    : NOMBRE D'EQUATIONS (OU DE DDL) DU PROF_CHNO
C     GDS    : NUMERO DE LA GRANDEUR SIMPLE ASSOCIEE AU CHAMP.
C     NCMP   : NOMBRE DE CMPS DE PRCHNO (LONGUEUR DE CORR2)
C     CORR2  : CORRESPONDANCE KCMP_CH -> KCMP_GD
C
C     OUT:
C     PRCHNO EST COMPLETE DE L'OBJET ".DEEQ" V(I) DIM=2*NEQ
C         (CET OBJET EST DETRUIT S'IL EXISTE DEJA).
C     V((IDDL-1)*2+1)--> SI LE NOEUD SUPPORT DE L'EQUA. IDDL EST PHYS.:
C                           +NUMERO DU NOEUD
C                        SI LE NOEUD SUPPORT DE L'EQUA. IDDL EST UN
C                        LAGRANGE DE BLOCAGE :
C                           +NUMERO DU NOEUD PHYS. BLOQUE
C                        SI LE NOEUD SUPPORT DE L'EQUA. IDDL EST UN
C                        LAGRANGE DE LIAISON :
C                            0
C     V((IDDL-1)*2+2)--> SI LE NOEUD SUPPORT DE L'EQUA. IDDL EST PHYS.:
C                           + NUM. DANS L'ORDRE DU CATAL. DES GRAND.
C                           DE LA CMP CORRESPONDANT A L'EQUATION IDDL.
C                        SI LE NOEUD SUPPORT DE L'EQUA. IDDL EST UN
C                        LAGRANGE DE BLOCAGE :
C                           - NUM. DANS L'ORDRE DU CATAL. DES GRAND.
C                           DE LA CMP CORRESPONDANT AU BLOCAGE.
C                        SI LE NOEUD SUPPORT DE L'EQUA. IDDL EST UN
C                        LAGRANGE DE LIAISON :
C                            0
C ----------------------------------------------------------------------
C
C     FONCTIONS EXTERNES:
C     -------------------
      LOGICAL EXISDG
      INTEGER NBEC
C
C     VARIABLES LOCALES:
C     ------------------
      INTEGER IRET,JDEEQ,NCMPMX,NEC,JNUEQ,NBLIGR,N1,JPRNO,I2
      INTEGER NBNO,J,IDDL,IADG,K,IEQ

C --------------- COMMUNS NORMALISES  JEVEUX  --------------------------
      CHARACTER*32 JEXNUM,JEXNOM,JEXATR,JEXR8
      COMMON /IVARJE/ZI(1)
      COMMON /RVARJE/ZR(1)
      COMMON /CVARJE/ZC(1)
      COMMON /LVARJE/ZL(1)
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      INTEGER ZI
      REAL*8 ZR
      COMPLEX*16 ZC
      LOGICAL ZL
      CHARACTER*8 ZK8,K8BID
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24,LIGREL
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      CHARACTER*1  K1BID,BASE
C ---------------- FIN COMMUNS NORMALISES  JEVEUX  --------------------


      CALL JEMARQ()
      BASE=BASZ(1:1)

      CALL JEDETR(PRCHNO(1:19)//'.DEEQ')
      CALL WKVECT(PRCHNO(1:19)//'.DEEQ',BASE//' V I',2*NEQ,JDEEQ)

      CALL JELIRA(JEXNUM('&CATA.GD.NOMCMP',GDS),'LONMAX',NCMPMX,K1BID)
      NEC = NBEC(GDS)
      IF (NCMPMX.EQ.0) CALL U2MESS('F','ASSEMBLA_24')
      IF (NEC.EQ.0) CALL U2MESS('F','ASSEMBLA_25')

      CALL JEVEUO(PRCHNO(1:19)//'.NUEQ','L',JNUEQ)
      CALL JELIRA(PRCHNO(1:19)//'.PRNO','NMAXOC',NBLIGR,K1BID)
      IF (NBLIGR.NE.1) CALL U2MESS('F','ASSEMBLA_33')

      CALL JELIRA(JEXNUM(PRCHNO(1:19)//'.PRNO',1),'LONMAX',N1,K1BID)
      IF (N1.LE.0) CALL U2MESS('F','ASSEMBLA_34')
      CALL JEVEUO(JEXNUM(PRCHNO(1:19)//'.PRNO',1),'L',JPRNO)

      NBNO = N1/ (NEC+2)
      DO 1 J = 1,NBNO
        IDDL = ZI(JPRNO-1+ (J-1)* (NEC+2)+1) - 1
        IADG = JPRNO - 1 + (J-1)* (NEC+2) + 3
        DO 2 I2 = 1,NCMP
          K = CORR2(I2)
          IF (EXISDG(ZI(IADG),K)) THEN
            IDDL = IDDL + 1
            IEQ = ZI(JNUEQ-1+IDDL)
            ZI(JDEEQ-1+2* (IEQ-1)+1) = J
            ZI(JDEEQ-1+2* (IEQ-1)+2) = K
          END IF
2       CONTINUE
1     CONTINUE

      CALL JEDEMA()
      END
