       SUBROUTINE ANTECE(INO2,MAIL,TGEOM,TAILMI,EPSI,NBANTE,NUNO1)
       IMPLICIT REAL*8  (A-H,O-Z)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 21/02/96   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C AUTEUR : G. ROUSSEAU
C BUT: ROUTINE TROUVANT L ANTECEDENT, S IL EXISTE,
C      D UN NOEUD DU MAILLAGE
C      IMAGE  PAR UNE TRANSFORMATION GEOMETRIQUE TGEOM (ROTATION
C      + TRANSLATION) D UN NOEUD D UN
C      CHAMNO DEFINI PAR EXEMPLE SUR LE MODELE THERMIQUE
C      D INTERFACE- APPLICATION AU CALCUL DE MATRICE DE
C      MASSE AJOUTEE AVEC UN MODELE GENERALISE
C
C ARGUMENTS :
C     IN : INTEGER: INO2 : NUMERO DU NOEUD DU MAILLAGE
C     IN : K8 : MAIL : NOM DU MAILLAGE
C     IN : R8 : TGEOM : TABLEAU DE 6 REELS - 3 COMPOSANTES
C        DE TRANSLATION PUIS 3 ANGLES NAUTIQUES DE ROTATION
C     IN : R8 : TAILMI: TAILLE DE MAILLE MIN DANS LE MAILLAGE
C     IN : R8 : EPSI: PRECISION RELATIVE SUR DISTANCE INTER-NOEUDS
C     OUT: INTEGER : NBANTE : NOMBRE D ANTECEDENTS TROUVES
C     OUT: INTEGER : NUNO1 : NUMERO DU NOEUD ANTECEDENT
C
      CHARACTER*8 MAIL
      INTEGER NUNO1,INO2,NBANTE
      REAL*8  TGEOM(6),TAILMI,EPSI
C
C -- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------
C
      CHARACTER*32       JEXNUM , JEXNOM , JEXR8 , JEXATR
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL,EXISDG
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C -- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
C
      INTEGER IGEOM,NBNO
      REAL*8 X1,Y1,Z1,X2,Y2,Z2,XP1,YP1,ZP1,DISTAN
      REAL*8 CA(3),SA(3),ROT(3)
      CHARACTER*8 REPK

      CALL JEMARQ()
      CALL GETVR8(' ','DIST_REFE',0,1,1,TAILMI,NBID)

      CALL JEVEUO(MAIL//'.COORDO    .VALE','L',IGEOM)

      X2 = ZR(IGEOM -1 + (INO2 -1)*3 +1)
      Y2 = ZR(IGEOM -1 + (INO2 -1)*3 +2)
      Z2 = ZR(IGEOM -1 + (INO2 -1)*3 +3)

      CALL DISMOI('F','NB_NO_MAILLA',MAIL,'MAILLAGE',NBNO,REPK,IERD)

      CA(1)=COS(TGEOM(4))
      SA(1)=SIN(TGEOM(4))
      CA(2)=COS(TGEOM(5))
      SA(2)=SIN(TGEOM(5))
      CA(3)=COS(TGEOM(6))
      SA(3)=SIN(TGEOM(6))

      ROT(1)=0.0D0
      ROT(2)=0.0D0
      ROT(3)=0.0D0

      NBANTE=0

      DO 1 INO1 = 1,NBNO

           X1 = ZR(IGEOM -1 + (INO1 -1)*3 +1)
           Y1 = ZR(IGEOM -1 + (INO1 -1)*3 +2)
           Z1 = ZR(IGEOM -1 + (INO1 -1)*3 +3)


             ROT(1)=CA(2)*CA(1)*X1+Y1*(SA(3)*SA(2)*CA(1)
     &        -CA(3)*SA(1)) +Z1*(CA(3)*SA(2)*CA(1)+SA(3)*SA(1))

             ROT(2)=SA(1)*CA(2)*X1+Y1*(CA(3)*CA(1)+SA(2)*SA(1)*SA(3))
     &       +Z1*(CA(3)*SA(1)*SA(2)-SA(3)*CA(1))

             ROT(3)=-X1*SA(2)+Y1*SA(3)*CA(2)+Z1*CA(3)*CA(2)

           XP1 =TGEOM(1)+ROT(1)
           YP1 =TGEOM(2)+ROT(2)
           ZP1 =TGEOM(3)+ROT(3)

C           IF((X1.EQ.(1.5)).AND.(Y1.EQ.(0.0)).
C     &     AND.(Z1.EQ.(0.0))) THEN






C
C           ENDIF

            DISTAN = SQRT((XP1-X2)**2 + (YP1-Y2)**2
     &         + (ZP1-Z2)**2)




            IF (DISTAN.LT.(EPSI*TAILMI)) THEN
                NUNO1=INO1
                NBANTE= NBANTE+1










C               IF (NBANTE.GT.1) THEN




C               ENDIF

            ENDIF

1     CONTINUE

      CALL JEDEMA()
      END
