      SUBROUTINE DEBCA1(NOMOP,LIGREL)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 15/06/2010   AUTEUR GRANET S.GRANET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE                            VABHHTS J.PELLET
      IMPLICIT NONE
C     ARGUMENTS:
C     ----------
      CHARACTER*16 NOMOP
      CHARACTER*19 LIGREL
C ----------------------------------------------------------------------

C     BUT : INITIALISER LES COMMONS CAII02 ET CAII11
C     ENTREES:
C        NOMOP  :  NOM D'1 OPTION
C        LIGREL :  NOM DU LIGREL SUR LEQUEL ON DOIT FAIRE LE CALCUL
C     SORTIES:
C       ALLOCATION D'OBJETS DE TRAVAIL ET MISE A JOUR DE COMMONS

C ----------------------------------------------------------------------
C---------------- COMMUNS NORMALISES  JEVEUX  --------------------------
      COMMON /IVARJE/ZI(1)
      COMMON /RVARJE/ZR(1)
      COMMON /CVARJE/ZC(1)
      COMMON /LVARJE/ZL(1)
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      INTEGER ZI
      REAL*8 ZR
      COMPLEX*16 ZC
      LOGICAL ZL
      CHARACTER*8 ZK8,MA
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32,JEXNUM,JEXNOM,JEXATR
      CHARACTER*80 ZK80
C---------------- COMMUNS POUR CALCUL ----------------------------------
      INTEGER IAOPTT,LGCO,IAOPMO,ILOPMO,IAOPNO,ILOPNO,OPT,IER
      INTEGER IAOPDS,IAOPPA,IANBLC
      INTEGER NPARIO,NPARIN,IAMLOC,ILMLOC,IADSGD,IBID,IERD
      CHARACTER*3 EXIELE,KBID,EXIVF,BEVOIS
      COMMON /CAII02/IAOPTT,LGCO,IAOPMO,ILOPMO,IAOPNO,ILOPNO,IAOPDS,
     &       IAOPPA,NPARIO,NPARIN,IAMLOC,ILMLOC,IADSGD
      INTEGER NUTE,JNBELR,JNOELR,IACTIF,JPNLFP,JNOLFP,NBLFPG
      COMMON /CAII11/NUTE,JNBELR,JNOELR,IACTIF,JPNLFP,JNOLFP,NBLFPG
      INTEGER EVFINI,CALVOI,JREPE,JPTVOI,JELVOI
      COMMON /CAII19/EVFINI,CALVOI,JREPE,JPTVOI,JELVOI
C DEB-------------------------------------------------------------------

      CALL DISMOI('F','EXI_ELEM',LIGREL,'LIGREL',IBID,EXIELE,IERD)
      IF (EXIELE.NE.'OUI') CALL U2MESK('F','CALCULEL2_25',1,LIGREL)
      CALL JENONU(JEXNOM('&CATA.OP.NOMOPT',NOMOP),OPT)
      IF (OPT.EQ.0) CALL U2MESK('F','CALCULEL2_26',1,NOMOP)


C     INITIALISATION DU COMMON CAII02 :
C     ---------------------------------
      CALL JEVEUO('&CATA.TE.OPTTE','L',IAOPTT)
      CALL JEVEUO('&CATA.TE.NBLIGCOL','L',IANBLC)
      LGCO = ZI(IANBLC-1+1)
      CALL JEVEUO('&CATA.TE.OPTMOD','L',IAOPMO)
      CALL JEVEUO(JEXATR('&CATA.TE.OPTMOD','LONCUM'),'L',ILOPMO)
      CALL JEVEUO('&CATA.TE.OPTNOM','L',IAOPNO)
      CALL JEVEUO(JEXATR('&CATA.TE.OPTNOM','LONCUM'),'L',ILOPNO)
      CALL JEVEUO(JEXNUM('&CATA.OP.DESCOPT',OPT),'L',IAOPDS)
      CALL JEVEUO(JEXNUM('&CATA.OP.OPTPARA',OPT),'L',IAOPPA)

      NPARIN = ZI(IAOPDS-1+2)
      NPARIO = ZI(IAOPDS-1+2) + ZI(IAOPDS-1+3)
      CALL JEVEUO('&CATA.TE.MODELOC','L',IAMLOC)
      CALL JEVEUO(JEXATR('&CATA.TE.MODELOC','LONCUM'),'L',ILMLOC)
      CALL JEVEUO('&CATA.GD.DESCRIGD','L',IADSGD)


C     INITIALISATION DU COMMON CAII11 :
C     ---------------------------------
      CALL JEVEUO('&CATA.TE.NBELREFE','L',JNBELR)
      CALL JEVEUO('&CATA.TE.NOELREFE','L',JNOELR)
      CALL JEVEUO('&CATA.TE.PNLOCFPG','L',JPNLFP)
      CALL JEVEUO('&CATA.TE.NOLOCFPG','L',JNOLFP)
      CALL JELIRA('&CATA.TE.NOLOCFPG','LONMAX',NBLFPG,KBID)


C     INITIALISATION DU COMMON CAII19 :
C     ---------------------------------
      CALL DISMOI('F','EXI_VF',LIGREL,'LIGREL',IBID,EXIVF,IBID)
      CALL DISMOI('F','BESOIN_VOISIN',LIGREL,'LIGREL',IBID,BEVOIS,IBID)
      IF (EXIVF.EQ.'OUI') THEN
        EVFINI=1
        CALVOI=1
      ELSE
        EVFINI=0
        IF (BEVOIS.EQ.'OUI') THEN
          CALVOI=1
        ELSE
          CALVOI=0
        ENDIF
      ENDIF
      IF (CALVOI.EQ.1) THEN
        CALL JEEXIN(LIGREL//'.REPE',IER)
        IF (IER.EQ.0) CALL CORMGI('V', LIGREL)
        CALL JEVEUO(LIGREL//'.REPE','L',JREPE)
        CALL DISMOI('F','NOM_MAILLA',LIGREL,'LIGREL',IBID,MA,IBID)
        CALL JEVEUO(MA//'.VGE.PTVOIS','L',JPTVOI)
        CALL JEVEUO(MA//'.VGE.ELVOIS','L',JELVOI)
      ELSE
        JREPE=0
      ENDIF


      END
