      SUBROUTINE ECLA3D ( NOMTE, ELREFA, FAPG, NPG,
     &                    NPOINI, NTERM1, NSOMM1, CSOMM1,
     &                    TYMA, NBNO2, CONNX,
     &                    MXNBN2, MXNBPG, MXNBPI, MXNBTE )
      IMPLICIT   NONE        
      INTEGER      MXNBN2,MXNBPG,MXNBPI,MXNBTE
      INTEGER      NPG,CONNX(MXNBN2,MXNBPG),NSOMM1(MXNBPI,MXNBTE)
      INTEGER      NTERM1(MXNBPI),NBNO2(MXNBPG),NPOINI,TYMA(MXNBPG)
      REAL*8       CSOMM1(MXNBPI,MXNBTE)
      CHARACTER*16 NOMTE
      CHARACTER*8  ELREFA, FAPG
C ---------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 14/02/2011   AUTEUR MEUNIER S.MEUNIER 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C TOLE CRP_20
C ---------------------------------------------------------------------
C BUT : DECOMPOSER LES TYPE_ELEM 3D EN AUTANT DE SOUS-ELEMENTS QUE
C       DE POINTS DE GAUSS.
C
C     DECOUPAGE DU HE8, H20, H27 :
C       FPG1  :  8 NOEUDS,  1 HEXA8
C       FPG8  : 27 NOEUDS,  8 HEXA8
C       FPG27 : 64 NOEUDS, 27 HEXA8
C
C     DECOUPAGE DU TE4, T10 :
C       FPG1  :  4 NOEUDS,  1 TETRA4
C       FPG4  : 15 NOEUDS,  4 HEXA8
C       FPG15 : 32 NOEUDS, 10 HEXA8 ET 4 PENTA6 ET 1 TETRA4
C
C     DECOUPAGE DU PE6, P15, P18 :
C       FPG1  :  6 NOEUDS,  1 PENTA6
C       FPG6  : 12 NOEUDS,  6 PENTA6
C       FPG21 : 48 NOEUDS, 18 HEXA8 ET 3 PENTA6
C
C ---------------------------------------------------------------------
C DESCRIPTION DES POINTS INTERMEDIAIRES (POINT_I) :
C ------------------------------------------------
C UN POINT_I EST DEFINI COMME UNE COMBINAISON LINEAIRE DES NOEUDS
C DE LA MAILLE SOUS-JACENTE AU TYPE_ELEM :
C POINT_I = SOMME COEF(K)*NOEUD(K)  (1<= K <=NTERMES)
C           NTERMES <= 27 (HEXA27)
C
C ---------------------------------------------------------------------
      INTEGER       K, IHEXA8, IPENT6, ITETR4
      CHARACTER*32  JEXNOM
      CHARACTER*24 VALK(3)

C ---------------------------------------------------------------------
      CALL JEMARQ()

      CALL JENONU(JEXNOM('&CATA.TM.NOMTM','HEXA8' ),IHEXA8)
      CALL JENONU(JEXNOM('&CATA.TM.NOMTM','PENTA6'),IPENT6)
      CALL JENONU(JEXNOM('&CATA.TM.NOMTM','TETRA4'),ITETR4)

C     -----------------------------------------------------------------
C     HEXAEDRES
C     -----------------------------------------------------------------
      IF ( ELREFA .EQ. 'HE8' .OR.
     +     ELREFA .EQ. 'H20' .OR.
     +     ELREFA .EQ. 'H27' ) THEN
C
       IF ( FAPG .EQ. 'FPG1' ) THEN
C           -----------------
         NPOINI   = 8
         TYMA(1)  = IHEXA8
         NBNO2(1) = 8

C        -- DEFINITION DES POINT_I :
         NTERM1(1)=1
         CALL ECLAN1(1,MXNBPI,NSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         CALL ECLAC1(1,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(2)=1
         CALL ECLAN1(2,MXNBPI,NSOMM1,NTERM1,2,0,0,0,0,0,0,0)
         CALL ECLAC1(2,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(3)=1
         CALL ECLAN1(3,MXNBPI,NSOMM1,NTERM1,3,0,0,0,0,0,0,0)
         CALL ECLAC1(3,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(4)=1
         CALL ECLAN1(4,MXNBPI,NSOMM1,NTERM1,4,0,0,0,0,0,0,0)
         CALL ECLAC1(4,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(5)=1
         CALL ECLAN1(5,MXNBPI,NSOMM1,NTERM1,5,0,0,0,0,0,0,0)
         CALL ECLAC1(5,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(6)=1
         CALL ECLAN1(6,MXNBPI,NSOMM1,NTERM1,6,0,0,0,0,0,0,0)
         CALL ECLAC1(6,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(7)=1
         CALL ECLAN1(7,MXNBPI,NSOMM1,NTERM1,7,0,0,0,0,0,0,0)
         CALL ECLAC1(7,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(8)=1
         CALL ECLAN1(8,MXNBPI,NSOMM1,NTERM1,8,0,0,0,0,0,0,0)
         CALL ECLAC1(8,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         
C        -- CONNECTIVITE DES SOUS-ELEMENTS :
         CALL ECLACO(1,MXNBN2,CONNX,NBNO2,  1,2,3,4,5,6,7,8)

       ELSEIF ( FAPG .EQ. 'FPG8' ) THEN
C           -----------------
         NPOINI = 27
         DO 10, K = 1, NPG
           TYMA(K)  = IHEXA8
           NBNO2(K) = 8
 10      CONTINUE

C        -- DEFINITION DES POINT_I :
         NTERM1(1)=1
         CALL ECLAN1(1,MXNBPI,NSOMM1,NTERM1,5,0,0,0,0,0,0,0)
         CALL ECLAC1(1,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(3)=1
         CALL ECLAN1(3,MXNBPI,NSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         CALL ECLAC1(3,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(7)=1
         CALL ECLAN1(7,MXNBPI,NSOMM1,NTERM1,8,0,0,0,0,0,0,0)
         CALL ECLAC1(7,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(9)=1
         CALL ECLAN1(9,MXNBPI,NSOMM1,NTERM1,4,0,0,0,0,0,0,0)
         CALL ECLAC1(9,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(19)=1
         CALL ECLAN1(19,MXNBPI,NSOMM1,NTERM1,6,0,0,0,0,0,0,0)
         CALL ECLAC1(19,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(21)=1
         CALL ECLAN1(21,MXNBPI,NSOMM1,NTERM1,2,0,0,0,0,0,0,0)
         CALL ECLAC1(21,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(25)=1
         CALL ECLAN1(25,MXNBPI,NSOMM1,NTERM1,7,0,0,0,0,0,0,0)
         CALL ECLAC1(25,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(27)=1
         CALL ECLAN1(27,MXNBPI,NSOMM1,NTERM1,3,0,0,0,0,0,0,0)
         CALL ECLAC1(27,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)

         NTERM1(4)=2
         CALL ECLAN1(4,MXNBPI,NSOMM1,NTERM1,5,8,0,0,0,0,0,0)
         CALL ECLAC1(4,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(10)=2
         CALL ECLAN1(10,MXNBPI,NSOMM1,NTERM1,5,6,0,0,0,0,0,0)
         CALL ECLAC1(10,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(16)=2
         CALL ECLAN1(16,MXNBPI,NSOMM1,NTERM1,7,8,0,0,0,0,0,0)
         CALL ECLAC1(16,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(22)=2
         CALL ECLAN1(22,MXNBPI,NSOMM1,NTERM1,6,7,0,0,0,0,0,0)
         CALL ECLAC1(22,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(6)=2
         CALL ECLAN1(6,MXNBPI,NSOMM1,NTERM1,1,4,0,0,0,0,0,0)
         CALL ECLAC1(6,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(12)=2
         CALL ECLAN1(12,MXNBPI,NSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         CALL ECLAC1(12,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(24)=2
         CALL ECLAN1(24,MXNBPI,NSOMM1,NTERM1,2,3,0,0,0,0,0,0)
         CALL ECLAC1(24,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(18)=2
         CALL ECLAN1(18,MXNBPI,NSOMM1,NTERM1,3,4,0,0,0,0,0,0)
         CALL ECLAC1(18,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(8)=2
         CALL ECLAN1(8,MXNBPI,NSOMM1,NTERM1,4,8,0,0,0,0,0,0)
         CALL ECLAC1(8,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(2)=2
         CALL ECLAN1(2,MXNBPI,NSOMM1,NTERM1,1,5,0,0,0,0,0,0)
         CALL ECLAC1(2,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(20)=2
         CALL ECLAN1(20,MXNBPI,NSOMM1,NTERM1,6,2,0,0,0,0,0,0)
         CALL ECLAC1(20,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(26)=2
         CALL ECLAN1(26,MXNBPI,NSOMM1,NTERM1,3,7,0,0,0,0,0,0)
         CALL ECLAC1(26,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)

         NTERM1(13)=4
         CALL ECLAN1(13,MXNBPI,NSOMM1,NTERM1,5,6,7,8,0,0,0,0)
         CALL ECLAC1(13,MXNBPI,CSOMM1,NTERM1,1,1,1,1,0,0,0,0)
         NTERM1(15)=4
         CALL ECLAN1(15,MXNBPI,NSOMM1,NTERM1,1,2,3,4,0,0,0,0)
         CALL ECLAC1(15,MXNBPI,CSOMM1,NTERM1,1,1,1,1,0,0,0,0)
         NTERM1(5)=4
         CALL ECLAN1(5,MXNBPI,NSOMM1,NTERM1,1,4,8,5,0,0,0,0)
         CALL ECLAC1(5,MXNBPI,CSOMM1,NTERM1,1,1,1,1,0,0,0,0)
         NTERM1(23)=4
         CALL ECLAN1(23,MXNBPI,NSOMM1,NTERM1,2,3,7,6,0,0,0,0)
         CALL ECLAC1(23,MXNBPI,CSOMM1,NTERM1,1,1,1,1,0,0,0,0)
         NTERM1(11)=4
         CALL ECLAN1(11,MXNBPI,NSOMM1,NTERM1,1,2,6,5,0,0,0,0)
         CALL ECLAC1(11,MXNBPI,CSOMM1,NTERM1,1,1,1,1,0,0,0,0)
         NTERM1(17)=4
         CALL ECLAN1(17,MXNBPI,NSOMM1,NTERM1,3,4,8,7,0,0,0,0)
         CALL ECLAC1(17,MXNBPI,CSOMM1,NTERM1,1,1,1,1,0,0,0,0)

         NTERM1(14)=4
         CALL ECLAN1(14,MXNBPI,NSOMM1,NTERM1,1,3,7,5,0,0,0,0)
         CALL ECLAC1(14,MXNBPI,CSOMM1,NTERM1,1,1,1,1,0,0,0,0)

C        -- CONNECTIVITE DES SOUS-ELEMENTS :
         CALL ECLACO(1,MXNBN2,CONNX,NBNO2,  12,15,6,3,11,14,5,2)
         CALL ECLACO(2,MXNBN2,CONNX,NBNO2,  11,14,5,2,10,13,4,1)
         CALL ECLACO(3,MXNBN2,CONNX,NBNO2,  15,18,9,6,14,17,8,5)
         CALL ECLACO(4,MXNBN2,CONNX,NBNO2,  14,17,8,5,13,16,7,4)
         CALL ECLACO(5,MXNBN2,CONNX,NBNO2,  21,24,15,12,20,23,14,11)
         CALL ECLACO(6,MXNBN2,CONNX,NBNO2,  20,23,14,11,19,22,13,10)
         CALL ECLACO(7,MXNBN2,CONNX,NBNO2,  24,27,18,15,23,26,17,14)
         CALL ECLACO(8,MXNBN2,CONNX,NBNO2,  23,26,17,14,22,25,16,13)

C
       ELSEIF ( FAPG .EQ. 'FPG27' ) THEN
C               ------------------
         NPOINI = 64
         DO 20, K = 1, NPG
           TYMA(K)  = IHEXA8
           NBNO2(K) = 8
 20      CONTINUE

C        -- DEFINITION DES POINT_I :
         NTERM1(1)=1
         CALL ECLAN1(1,MXNBPI,NSOMM1,NTERM1,5,0,0,0,0,0,0,0)
         CALL ECLAC1(1,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(4)=1
         CALL ECLAN1(4,MXNBPI,NSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         CALL ECLAC1(4,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(13)=1
         CALL ECLAN1(13,MXNBPI,NSOMM1,NTERM1,8,0,0,0,0,0,0,0)
         CALL ECLAC1(13,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(16)=1
         CALL ECLAN1(16,MXNBPI,NSOMM1,NTERM1,4,0,0,0,0,0,0,0)
         CALL ECLAC1(16,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(49)=1
         CALL ECLAN1(49,MXNBPI,NSOMM1,NTERM1,6,0,0,0,0,0,0,0)
         CALL ECLAC1(49,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(52)=1
         CALL ECLAN1(52,MXNBPI,NSOMM1,NTERM1,2,0,0,0,0,0,0,0)
         CALL ECLAC1(52,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(61)=1
         CALL ECLAN1(61,MXNBPI,NSOMM1,NTERM1,7,0,0,0,0,0,0,0)
         CALL ECLAC1(61,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(64)=1
         CALL ECLAN1(64,MXNBPI,NSOMM1,NTERM1,3,0,0,0,0,0,0,0)
         CALL ECLAC1(64,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)

         NTERM1(9)=2
         CALL ECLAN1(9,MXNBPI,NSOMM1,NTERM1,5,8,0,0,0,0,0,0)
         CALL ECLAC1(9,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(5)=2
         CALL ECLAN1(5,MXNBPI,NSOMM1,NTERM1,5,8,0,0,0,0,0,0)
         CALL ECLAC1(5,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(2)=2
         CALL ECLAN1(2,MXNBPI,NSOMM1,NTERM1,5,1,0,0,0,0,0,0)
         CALL ECLAC1(2,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(3)=2
         CALL ECLAN1(3,MXNBPI,NSOMM1,NTERM1,5,1,0,0,0,0,0,0)
         CALL ECLAC1(3,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(8)=2
         CALL ECLAN1(8,MXNBPI,NSOMM1,NTERM1,1,4,0,0,0,0,0,0)
         CALL ECLAC1(8,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(12)=2
         CALL ECLAN1(12,MXNBPI,NSOMM1,NTERM1,1,4,0,0,0,0,0,0)
         CALL ECLAC1(12,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(15)=2
         CALL ECLAN1(15,MXNBPI,NSOMM1,NTERM1,4,8,0,0,0,0,0,0)
         CALL ECLAC1(15,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(14)=2
         CALL ECLAN1(14,MXNBPI,NSOMM1,NTERM1,4,8,0,0,0,0,0,0)
         CALL ECLAC1(14,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)

         NTERM1(57)=2
         CALL ECLAN1(57,MXNBPI,NSOMM1,NTERM1,6,7,0,0,0,0,0,0)
         CALL ECLAC1(57,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(53)=2
         CALL ECLAN1(53,MXNBPI,NSOMM1,NTERM1,6,7,0,0,0,0,0,0)
         CALL ECLAC1(53,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(50)=2
         CALL ECLAN1(50,MXNBPI,NSOMM1,NTERM1,6,2,0,0,0,0,0,0)
         CALL ECLAC1(50,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(51)=2
         CALL ECLAN1(51,MXNBPI,NSOMM1,NTERM1,6,2,0,0,0,0,0,0)
         CALL ECLAC1(51,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(56)=2
         CALL ECLAN1(56,MXNBPI,NSOMM1,NTERM1,2,3,0,0,0,0,0,0)
         CALL ECLAC1(56,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(60)=2
         CALL ECLAN1(60,MXNBPI,NSOMM1,NTERM1,2,3,0,0,0,0,0,0)
         CALL ECLAC1(60,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(63)=2
         CALL ECLAN1(63,MXNBPI,NSOMM1,NTERM1,3,7,0,0,0,0,0,0)
         CALL ECLAC1(63,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(62)=2
         CALL ECLAN1(62,MXNBPI,NSOMM1,NTERM1,3,7,0,0,0,0,0,0)
         CALL ECLAC1(62,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)

         NTERM1(17)=2
         CALL ECLAN1(17,MXNBPI,NSOMM1,NTERM1,5,6,0,0,0,0,0,0)
         CALL ECLAC1(17,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(20)=2
         CALL ECLAN1(20,MXNBPI,NSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         CALL ECLAC1(20,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(32)=2
         CALL ECLAN1(32,MXNBPI,NSOMM1,NTERM1,4,3,0,0,0,0,0,0)
         CALL ECLAC1(32,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(29)=2
         CALL ECLAN1(29,MXNBPI,NSOMM1,NTERM1,8,7,0,0,0,0,0,0)
         CALL ECLAC1(29,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(33)=2
         CALL ECLAN1(33,MXNBPI,NSOMM1,NTERM1,5,6,0,0,0,0,0,0)
         CALL ECLAC1(33,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(36)=2
         CALL ECLAN1(36,MXNBPI,NSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         CALL ECLAC1(36,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(48)=2
         CALL ECLAN1(48,MXNBPI,NSOMM1,NTERM1,4,3,0,0,0,0,0,0)
         CALL ECLAC1(48,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(45)=2
         CALL ECLAN1(45,MXNBPI,NSOMM1,NTERM1,8,7,0,0,0,0,0,0)
         CALL ECLAC1(45,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)

         NTERM1(6)=3
         CALL ECLAN1(6,MXNBPI,NSOMM1,NTERM1,1,5,8,0,0,0,0,0)
         CALL ECLAC1(6,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(7)=3
         CALL ECLAN1(7,MXNBPI,NSOMM1,NTERM1,1,4,5,0,0,0,0,0)
         CALL ECLAC1(7,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(11)=3
         CALL ECLAN1(11,MXNBPI,NSOMM1,NTERM1,1,4,8,0,0,0,0,0)
         CALL ECLAC1(11,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(10)=3
         CALL ECLAN1(10,MXNBPI,NSOMM1,NTERM1,4,5,8,0,0,0,0,0)
         CALL ECLAC1(10,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)

         NTERM1(54)=3
         CALL ECLAN1(54,MXNBPI,NSOMM1,NTERM1,2,6,7,0,0,0,0,0)
         CALL ECLAC1(54,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(55)=3
         CALL ECLAN1(55,MXNBPI,NSOMM1,NTERM1,3,2,6,0,0,0,0,0)
         CALL ECLAC1(55,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(59)=3
         CALL ECLAN1(59,MXNBPI,NSOMM1,NTERM1,2,3,7,0,0,0,0,0)
         CALL ECLAC1(59,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(58)=3
         CALL ECLAN1(58,MXNBPI,NSOMM1,NTERM1,3,6,7,0,0,0,0,0)
         CALL ECLAC1(58,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)

         NTERM1(24)=3
         CALL ECLAN1(24,MXNBPI,NSOMM1,NTERM1,1,4,2,0,0,0,0,0)
         CALL ECLAC1(24,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(28)=3
         CALL ECLAN1(28,MXNBPI,NSOMM1,NTERM1,1,4,3,0,0,0,0,0)
         CALL ECLAC1(28,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(44)=3
         CALL ECLAN1(44,MXNBPI,NSOMM1,NTERM1,2,3,4,0,0,0,0,0)
         CALL ECLAC1(44,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(40)=3
         CALL ECLAN1(40,MXNBPI,NSOMM1,NTERM1,1,2,3,0,0,0,0,0)
         CALL ECLAC1(40,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)

         NTERM1(19)=3
         CALL ECLAN1(19,MXNBPI,NSOMM1,NTERM1,1,5,2,0,0,0,0,0)
         CALL ECLAC1(19,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(18)=3
         CALL ECLAN1(18,MXNBPI,NSOMM1,NTERM1,1,5,6,0,0,0,0,0)
         CALL ECLAC1(18,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(34)=3
         CALL ECLAN1(34,MXNBPI,NSOMM1,NTERM1,2,5,6,0,0,0,0,0)
         CALL ECLAC1(34,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(35)=3
         CALL ECLAN1(35,MXNBPI,NSOMM1,NTERM1,1,2,6,0,0,0,0,0)
         CALL ECLAC1(35,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)

         NTERM1(30)=3
         CALL ECLAN1(30,MXNBPI,NSOMM1,NTERM1,4,7,8,0,0,0,0,0)
         CALL ECLAC1(30,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(31)=3
         CALL ECLAN1(31,MXNBPI,NSOMM1,NTERM1,3,4,8,0,0,0,0,0)
         CALL ECLAC1(31,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(47)=3
         CALL ECLAN1(47,MXNBPI,NSOMM1,NTERM1,3,4,7,0,0,0,0,0)
         CALL ECLAC1(47,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(46)=3
         CALL ECLAN1(46,MXNBPI,NSOMM1,NTERM1,3,7,8,0,0,0,0,0)
         CALL ECLAC1(46,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)

         NTERM1(21)=3
         CALL ECLAN1(21,MXNBPI,NSOMM1,NTERM1,5,6,8,0,0,0,0,0)
         CALL ECLAC1(21,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(25)=3
         CALL ECLAN1(25,MXNBPI,NSOMM1,NTERM1,5,7,8,0,0,0,0,0)
         CALL ECLAC1(25,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(41)=3
         CALL ECLAN1(41,MXNBPI,NSOMM1,NTERM1,6,7,8,0,0,0,0,0)
         CALL ECLAC1(41,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(37)=3
         CALL ECLAN1(37,MXNBPI,NSOMM1,NTERM1,5,6,7,0,0,0,0,0)
         CALL ECLAC1(37,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)

         NTERM1(22)=3
         CALL ECLAN1(22,MXNBPI,NSOMM1,NTERM1,4,5,6,0,0,0,0,0)
         CALL ECLAC1(22,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(27)=3
         CALL ECLAN1(27,MXNBPI,NSOMM1,NTERM1,3,4,5,0,0,0,0,0)
         CALL ECLAC1(27,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(43)=3
         CALL ECLAN1(43,MXNBPI,NSOMM1,NTERM1,3,4,6,0,0,0,0,0)
         CALL ECLAC1(43,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(38)=3
         CALL ECLAN1(38,MXNBPI,NSOMM1,NTERM1,3,5,6,0,0,0,0,0)
         CALL ECLAC1(38,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)

         NTERM1(23)=3
         CALL ECLAN1(23,MXNBPI,NSOMM1,NTERM1,1,2,8,0,0,0,0,0)
         CALL ECLAC1(23,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(26)=3
         CALL ECLAN1(26,MXNBPI,NSOMM1,NTERM1,1,7,8,0,0,0,0,0)
         CALL ECLAC1(26,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(42)=3
         CALL ECLAN1(42,MXNBPI,NSOMM1,NTERM1,2,7,8,0,0,0,0,0)
         CALL ECLAC1(42,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(39)=3
         CALL ECLAN1(39,MXNBPI,NSOMM1,NTERM1,1,2,7,0,0,0,0,0)
         CALL ECLAC1(39,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)

C        -- CONNECTIVITE DES SOUS-ELEMENTS :
         CALL ECLACO(1,MXNBN2,CONNX,NBNO2,   1, 5, 6, 2,17,21,22,18)
         CALL ECLACO(2,MXNBN2,CONNX,NBNO2,   5, 9,10, 6,21,25,26,22)
         CALL ECLACO(3,MXNBN2,CONNX,NBNO2,   9,13,14,10,25,29,30,26)
         CALL ECLACO(4,MXNBN2,CONNX,NBNO2,   2, 6, 7, 3,18,22,23,19)
         CALL ECLACO(5,MXNBN2,CONNX,NBNO2,   6,10,11, 7,22,26,27,23)
         CALL ECLACO(6,MXNBN2,CONNX,NBNO2,  10,14,15,11,26,30,31,27)
         CALL ECLACO(7,MXNBN2,CONNX,NBNO2,   3, 7, 8, 4,19,23,24,20)
         CALL ECLACO(8,MXNBN2,CONNX,NBNO2,   7,11,12, 8,23,27,28,24)
         CALL ECLACO(9,MXNBN2,CONNX,NBNO2,  11,15,16,12,27,31,32,28)

         CALL ECLACO(10,MXNBN2,CONNX,NBNO2, 17,21,22,18,33,37,38,34)
         CALL ECLACO(11,MXNBN2,CONNX,NBNO2, 21,25,26,22,37,41,42,38)
         CALL ECLACO(12,MXNBN2,CONNX,NBNO2, 25,29,30,26,41,45,46,42)
         CALL ECLACO(13,MXNBN2,CONNX,NBNO2, 18,22,23,19,34,38,39,35)
         CALL ECLACO(14,MXNBN2,CONNX,NBNO2, 22,26,27,23,38,42,43,39)
         CALL ECLACO(15,MXNBN2,CONNX,NBNO2, 26,30,31,27,42,46,47,43)
         CALL ECLACO(16,MXNBN2,CONNX,NBNO2, 19,23,24,20,35,39,40,36)
         CALL ECLACO(17,MXNBN2,CONNX,NBNO2, 23,27,28,24,39,43,44,40)
         CALL ECLACO(18,MXNBN2,CONNX,NBNO2, 27,31,32,28,43,47,48,44)

         CALL ECLACO(19,MXNBN2,CONNX,NBNO2, 33,37,38,34,49,53,54,50)
         CALL ECLACO(20,MXNBN2,CONNX,NBNO2, 37,41,42,38,53,57,58,54)
         CALL ECLACO(21,MXNBN2,CONNX,NBNO2, 41,45,46,42,57,61,62,58)
         CALL ECLACO(22,MXNBN2,CONNX,NBNO2, 34,38,39,35,50,54,55,51)
         CALL ECLACO(23,MXNBN2,CONNX,NBNO2, 38,42,43,39,54,58,59,55)
         CALL ECLACO(24,MXNBN2,CONNX,NBNO2, 42,46,47,43,58,62,63,59)
         CALL ECLACO(25,MXNBN2,CONNX,NBNO2, 35,39,40,36,51,55,56,52)
         CALL ECLACO(26,MXNBN2,CONNX,NBNO2, 39,43,44,40,55,59,60,56)
         CALL ECLACO(27,MXNBN2,CONNX,NBNO2, 43,47,48,44,59,63,64,60)

       ELSE
        VALK (1) = NOMTE
        VALK (2) = ELREFA
        VALK (3) = FAPG
        CALL U2MESK('F', 'CALCULEL5_76', 3, VALK)

       ENDIF

C     -----------------------------------------------------------------
C     TETRAEDRES
C     -----------------------------------------------------------------
      ELSEIF ( ELREFA .EQ. 'TE4' .OR.
     +         ELREFA .EQ. 'T10' ) THEN
C
       IF ( FAPG .EQ. 'FPG1' ) THEN
C           -----------------
         NPOINI   = 4
         TYMA(1)  = ITETR4
         NBNO2(1) = 4
         
C        -- DEFINITION DES POINT_I :
         NTERM1(1)=1
         CALL ECLAN1(1,MXNBPI,NSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         CALL ECLAC1(1,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(2)=1
         CALL ECLAN1(2,MXNBPI,NSOMM1,NTERM1,2,0,0,0,0,0,0,0)
         CALL ECLAC1(2,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(3)=1
         CALL ECLAN1(3,MXNBPI,NSOMM1,NTERM1,3,0,0,0,0,0,0,0)
         CALL ECLAC1(3,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(4)=1
         CALL ECLAN1(4,MXNBPI,NSOMM1,NTERM1,4,0,0,0,0,0,0,0)
         CALL ECLAC1(4,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         
C        -- CONNECTIVITE DES SOUS-ELEMENTS :
         CALL ECLACO(1,MXNBN2,CONNX,NBNO2,  1,2,3,4,0,0,0,0)


       ELSEIF ( FAPG .EQ. 'FPG4' ) THEN
C           -----------------
         NPOINI = 15
         DO 30, K = 1, NPG
           TYMA(K)  = IHEXA8
           NBNO2(K) = 8
 30      CONTINUE

C        -- DEFINITION DES POINT_I :
         NTERM1(1)=1
         CALL ECLAN1(1,MXNBPI,NSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         CALL ECLAC1(1,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(2)=1
         CALL ECLAN1(2,MXNBPI,NSOMM1,NTERM1,2,0,0,0,0,0,0,0)
         CALL ECLAC1(2,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(3)=1
         CALL ECLAN1(3,MXNBPI,NSOMM1,NTERM1,3,0,0,0,0,0,0,0)
         CALL ECLAC1(3,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(4)=1
         CALL ECLAN1(4,MXNBPI,NSOMM1,NTERM1,4,0,0,0,0,0,0,0)
         CALL ECLAC1(4,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)

         NTERM1(5)=2
         CALL ECLAN1(5,MXNBPI,NSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         CALL ECLAC1(5,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(6)=2
         CALL ECLAN1(6,MXNBPI,NSOMM1,NTERM1,2,3,0,0,0,0,0,0)
         CALL ECLAC1(6,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(7)=2
         CALL ECLAN1(7,MXNBPI,NSOMM1,NTERM1,3,1,0,0,0,0,0,0)
         CALL ECLAC1(7,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(8)=2
         CALL ECLAN1(8,MXNBPI,NSOMM1,NTERM1,1,4,0,0,0,0,0,0)
         CALL ECLAC1(8,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(9)=2
         CALL ECLAN1(9,MXNBPI,NSOMM1,NTERM1,2,4,0,0,0,0,0,0)
         CALL ECLAC1(9,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(10)=2
         CALL ECLAN1(10,MXNBPI,NSOMM1,NTERM1,3,4,0,0,0,0,0,0)
         CALL ECLAC1(10,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)

         NTERM1(11)=3
         CALL ECLAN1(11,MXNBPI,NSOMM1,NTERM1,1,2,3,0,0,0,0,0)
         CALL ECLAC1(11,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(12)=3
         CALL ECLAN1(12,MXNBPI,NSOMM1,NTERM1,1,2,4,0,0,0,0,0)
         CALL ECLAC1(12,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(13)=3
         CALL ECLAN1(13,MXNBPI,NSOMM1,NTERM1,2,3,4,0,0,0,0,0)
         CALL ECLAC1(13,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(14)=3
         CALL ECLAN1(14,MXNBPI,NSOMM1,NTERM1,1,3,4,0,0,0,0,0)
         CALL ECLAC1(14,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)

         NTERM1(15)=4
         CALL ECLAN1(15,MXNBPI,NSOMM1,NTERM1,1,2,3,4,0,0,0,0)
         CALL ECLAC1(15,MXNBPI,CSOMM1,NTERM1,1,1,1,1,0,0,0,0)

C        -- CONNECTIVITE DES SOUS-ELEMENTS :
         CALL ECLACO(1,MXNBN2,CONNX,NBNO2,  3,10,14,7,6,13,15,11)
         CALL ECLACO(2,MXNBN2,CONNX,NBNO2,  2,5,12,9,6,11,15,13)
         CALL ECLACO(3,MXNBN2,CONNX,NBNO2,  1,7,14,8,5,11,15,12)
         CALL ECLACO(4,MXNBN2,CONNX,NBNO2,  4,8,14,10,9,12,15,13)

C
       ELSEIF ( FAPG .EQ. 'FPG15' ) THEN
C               -----------------
         NPOINI = 32
         DO 40, K = 1, 10
           TYMA(K)  = IHEXA8
           NBNO2(K) = 8
 40      CONTINUE
         DO 42, K = 11, 14
           TYMA(K)  = IPENT6
           NBNO2(K) = 6
 42      CONTINUE
         TYMA(15)  = ITETR4
         NBNO2(15) = 4

C        -- DEFINITION DES POINT_I :
         NTERM1(1)=1
         CALL ECLAN1(1,MXNBPI,NSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         CALL ECLAC1(1,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(2)=1
         CALL ECLAN1(2,MXNBPI,NSOMM1,NTERM1,2,0,0,0,0,0,0,0)
         CALL ECLAC1(2,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(3)=1
         CALL ECLAN1(3,MXNBPI,NSOMM1,NTERM1,3,0,0,0,0,0,0,0)
         CALL ECLAC1(3,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(4)=1
         CALL ECLAN1(4,MXNBPI,NSOMM1,NTERM1,4,0,0,0,0,0,0,0)
         CALL ECLAC1(4,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)

         NTERM1(5)=2
         CALL ECLAN1(5,MXNBPI,NSOMM1,NTERM1,3,1,0,0,0,0,0,0)
         CALL ECLAC1(5,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(6)=2
         CALL ECLAN1(6,MXNBPI,NSOMM1,NTERM1,3,1,0,0,0,0,0,0)
         CALL ECLAC1(6,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(7)=2
         CALL ECLAN1(7,MXNBPI,NSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         CALL ECLAC1(7,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(8)=2
         CALL ECLAN1(8,MXNBPI,NSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         CALL ECLAC1(8,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(9)=2
         CALL ECLAN1(9,MXNBPI,NSOMM1,NTERM1,2,3,0,0,0,0,0,0)
         CALL ECLAC1(9,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(10)=2
         CALL ECLAN1(10,MXNBPI,NSOMM1,NTERM1,2,3,0,0,0,0,0,0)
         CALL ECLAC1(10,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)

         NTERM1(11)=3
         CALL ECLAN1(11,MXNBPI,NSOMM1,NTERM1,1,2,3,0,0,0,0,0)
         CALL ECLAC1(11,MXNBPI,CSOMM1,NTERM1,1,1,2,0,0,0,0,0)
         NTERM1(12)=3
         CALL ECLAN1(12,MXNBPI,NSOMM1,NTERM1,1,2,3,0,0,0,0,0)
         CALL ECLAC1(12,MXNBPI,CSOMM1,NTERM1,2,1,1,0,0,0,0,0)
         NTERM1(13)=3
         CALL ECLAN1(13,MXNBPI,NSOMM1,NTERM1,1,2,3,0,0,0,0,0)
         CALL ECLAC1(13,MXNBPI,CSOMM1,NTERM1,1,2,1,0,0,0,0,0)

         NTERM1(14)=2
         CALL ECLAN1(14,MXNBPI,NSOMM1,NTERM1,3,4,0,0,0,0,0,0)
         CALL ECLAC1(14,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(15)=2
         CALL ECLAN1(15,MXNBPI,NSOMM1,NTERM1,3,4,0,0,0,0,0,0)
         CALL ECLAC1(15,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(16)=2
         CALL ECLAN1(16,MXNBPI,NSOMM1,NTERM1,2,4,0,0,0,0,0,0)
         CALL ECLAC1(16,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(17)=2
         CALL ECLAN1(17,MXNBPI,NSOMM1,NTERM1,2,4,0,0,0,0,0,0)
         CALL ECLAC1(17,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)

         NTERM1(18)=3
         CALL ECLAN1(18,MXNBPI,NSOMM1,NTERM1,4,2,3,0,0,0,0,0)
         CALL ECLAC1(18,MXNBPI,CSOMM1,NTERM1,1,1,2,0,0,0,0,0)
         NTERM1(19)=3
         CALL ECLAN1(19,MXNBPI,NSOMM1,NTERM1,4,2,3,0,0,0,0,0)
         CALL ECLAC1(19,MXNBPI,CSOMM1,NTERM1,2,1,1,0,0,0,0,0)
         NTERM1(20)=3
         CALL ECLAN1(20,MXNBPI,NSOMM1,NTERM1,4,2,3,0,0,0,0,0)
         CALL ECLAC1(20,MXNBPI,CSOMM1,NTERM1,1,2,1,0,0,0,0,0)

         NTERM1(21)=2
         CALL ECLAN1(21,MXNBPI,NSOMM1,NTERM1,1,4,0,0,0,0,0,0)
         CALL ECLAC1(21,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(22)=2
         CALL ECLAN1(22,MXNBPI,NSOMM1,NTERM1,1,4,0,0,0,0,0,0)
         CALL ECLAC1(22,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)

         NTERM1(23)=3
         CALL ECLAN1(23,MXNBPI,NSOMM1,NTERM1,1,4,3,0,0,0,0,0)
         CALL ECLAC1(23,MXNBPI,CSOMM1,NTERM1,1,1,2,0,0,0,0,0)
         NTERM1(24)=3
         CALL ECLAN1(24,MXNBPI,NSOMM1,NTERM1,1,4,3,0,0,0,0,0)
         CALL ECLAC1(24,MXNBPI,CSOMM1,NTERM1,2,1,1,0,0,0,0,0)
         NTERM1(25)=3
         CALL ECLAN1(25,MXNBPI,NSOMM1,NTERM1,1,4,3,0,0,0,0,0)
         CALL ECLAC1(25,MXNBPI,CSOMM1,NTERM1,1,2,1,0,0,0,0,0)

         NTERM1(26)=3
         CALL ECLAN1(26,MXNBPI,NSOMM1,NTERM1,1,2,4,0,0,0,0,0)
         CALL ECLAC1(26,MXNBPI,CSOMM1,NTERM1,1,1,2,0,0,0,0,0)
         NTERM1(27)=3
         CALL ECLAN1(27,MXNBPI,NSOMM1,NTERM1,1,2,4,0,0,0,0,0)
         CALL ECLAC1(27,MXNBPI,CSOMM1,NTERM1,2,1,1,0,0,0,0,0)
         NTERM1(28)=3
         CALL ECLAN1(28,MXNBPI,NSOMM1,NTERM1,1,2,4,0,0,0,0,0)
         CALL ECLAC1(28,MXNBPI,CSOMM1,NTERM1,1,2,1,0,0,0,0,0)

         NTERM1(29)=4
         CALL ECLAN1(29,MXNBPI,NSOMM1,NTERM1,1,2,3,4,0,0,0,0)
         CALL ECLAC1(29,MXNBPI,CSOMM1,NTERM1,2,1,1,1,0,0,0,0)
         NTERM1(30)=4
         CALL ECLAN1(30,MXNBPI,NSOMM1,NTERM1,1,2,3,4,0,0,0,0)
         CALL ECLAC1(30,MXNBPI,CSOMM1,NTERM1,1,2,1,1,0,0,0,0)
         NTERM1(31)=4
         CALL ECLAN1(31,MXNBPI,NSOMM1,NTERM1,1,2,3,4,0,0,0,0)
         CALL ECLAC1(31,MXNBPI,CSOMM1,NTERM1,1,1,2,1,0,0,0,0)
         NTERM1(32)=4
         CALL ECLAN1(32,MXNBPI,NSOMM1,NTERM1,1,2,3,4,0,0,0,0)
         CALL ECLAC1(32,MXNBPI,CSOMM1,NTERM1,1,1,1,2,0,0,0,0)

C        -- CONNECTIVITE DES SOUS-ELEMENTS :
         CALL ECLACO(1,MXNBN2,CONNX,NBNO2,  3,5,11,10,14,23,31,18)
         CALL ECLACO(2,MXNBN2,CONNX,NBNO2,  5,6,12,11,23,24,29,31)
         CALL ECLACO(3,MXNBN2,CONNX,NBNO2,  6,1,7,12,24,21,27,29)
         CALL ECLACO(4,MXNBN2,CONNX,NBNO2,  14,23,31,18,15,25,32,19)
         CALL ECLACO(5,MXNBN2,CONNX,NBNO2,  15,25,32,19,4,22,26,16)
         CALL ECLACO(6,MXNBN2,CONNX,NBNO2,  18,31,11,10,20,30,13,9)
         CALL ECLACO(7,MXNBN2,CONNX,NBNO2,  20,30,13,9,17,28,8,2)
         CALL ECLACO(8,MXNBN2,CONNX,NBNO2,  22,21,27,26,25,24,29,32)
         CALL ECLACO(9,MXNBN2,CONNX,NBNO2,  7,8,28,27,12,13,30,29)
         CALL ECLACO(10,MXNBN2,CONNX,NBNO2, 16,26,28,17,19,32,30,20)

         CALL ECLACO(11,MXNBN2,CONNX,NBNO2, 11,12,13,31,29,30,0,0)
         CALL ECLACO(12,MXNBN2,CONNX,NBNO2, 18,20,19,31,30,32,0,0)
         CALL ECLACO(13,MXNBN2,CONNX,NBNO2, 23,25,24,31,32,29,0,0)
         CALL ECLACO(14,MXNBN2,CONNX,NBNO2, 26,27,28,32,29,30,0,0)

         CALL ECLACO(15,MXNBN2,CONNX,NBNO2, 29,30,31,32,0,0,0,0)

       ELSE
        VALK (1) = NOMTE
        VALK (2) = ELREFA
        VALK (3) = FAPG
        CALL U2MESK('F', 'CALCULEL5_76', 3, VALK)
       ENDIF

C     -----------------------------------------------------------------
C     PENTAEDRES
C     -----------------------------------------------------------------
      ELSEIF ( ELREFA .EQ. 'PE6' .OR.
     &         ELREFA .EQ. 'P15' .OR.
     &         ELREFA .EQ. 'P18') THEN
C
       IF ( FAPG .EQ. 'FPG1' ) THEN
C           -----------------
         NPOINI   = 6
         TYMA(1)  = IPENT6
         NBNO2(1) = 6
         
C        -- DEFINITION DES POINT_I :
         NTERM1(1)=1
         CALL ECLAN1(1,MXNBPI,NSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         CALL ECLAC1(1,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(2)=1
         CALL ECLAN1(2,MXNBPI,NSOMM1,NTERM1,2,0,0,0,0,0,0,0)
         CALL ECLAC1(2,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(3)=1
         CALL ECLAN1(3,MXNBPI,NSOMM1,NTERM1,3,0,0,0,0,0,0,0)
         CALL ECLAC1(3,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(4)=1
         CALL ECLAN1(4,MXNBPI,NSOMM1,NTERM1,4,0,0,0,0,0,0,0)
         CALL ECLAC1(4,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(5)=1
         CALL ECLAN1(5,MXNBPI,NSOMM1,NTERM1,5,0,0,0,0,0,0,0)
         CALL ECLAC1(5,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(6)=1
         CALL ECLAN1(6,MXNBPI,NSOMM1,NTERM1,6,0,0,0,0,0,0,0)
         CALL ECLAC1(6,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         
C        -- CONNECTIVITE DES SOUS-ELEMENTS :
         CALL ECLACO(1,MXNBN2,CONNX,NBNO2,  1,2,3,4,5,6,0,0)
C
       ELSEIF ( FAPG .EQ. 'FPG6' ) THEN
C           -----------------
         NPOINI = 12
         DO 50, K = 1, NPG
           TYMA(K)  = IPENT6
           NBNO2(K) = 6
 50      CONTINUE

C        -- DEFINITION DES POINT_I :
         NTERM1(1)=1
         CALL ECLAN1(1,MXNBPI,NSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         CALL ECLAC1(1,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(2)=1
         CALL ECLAN1(2,MXNBPI,NSOMM1,NTERM1,2,0,0,0,0,0,0,0)
         CALL ECLAC1(2,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(3)=1
         CALL ECLAN1(3,MXNBPI,NSOMM1,NTERM1,3,0,0,0,0,0,0,0)
         CALL ECLAC1(3,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(4)=1
         CALL ECLAN1(4,MXNBPI,NSOMM1,NTERM1,4,0,0,0,0,0,0,0)
         CALL ECLAC1(4,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(5)=1
         CALL ECLAN1(5,MXNBPI,NSOMM1,NTERM1,5,0,0,0,0,0,0,0)
         CALL ECLAC1(5,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(6)=1
         CALL ECLAN1(6,MXNBPI,NSOMM1,NTERM1,6,0,0,0,0,0,0,0)
         CALL ECLAC1(6,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)

         NTERM1(7)=2
         CALL ECLAN1(7,MXNBPI,NSOMM1,NTERM1,1,4,0,0,0,0,0,0)
         CALL ECLAC1(7,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(8)=2
         CALL ECLAN1(8,MXNBPI,NSOMM1,NTERM1,2,5,0,0,0,0,0,0)
         CALL ECLAC1(8,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)
         NTERM1(9)=2
         CALL ECLAN1(9,MXNBPI,NSOMM1,NTERM1,3,6,0,0,0,0,0,0)
         CALL ECLAC1(9,MXNBPI,CSOMM1,NTERM1,1,1,0,0,0,0,0,0)

         NTERM1(10)=3
         CALL ECLAN1(10,MXNBPI,NSOMM1,NTERM1,1,2,3,0,0,0,0,0)
         CALL ECLAC1(10,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)
         NTERM1(12)=3
         CALL ECLAN1(12,MXNBPI,NSOMM1,NTERM1,4,5,6,0,0,0,0,0)
         CALL ECLAC1(12,MXNBPI,CSOMM1,NTERM1,1,1,1,0,0,0,0,0)

         NTERM1(11)=6
         CALL ECLAN1(11,MXNBPI,NSOMM1,NTERM1,1,2,3,4,5,6,0,0)
         CALL ECLAC1(11,MXNBPI,CSOMM1,NTERM1,1,1,1,1,1,1,0,0)

C        -- CONNECTIVITE DES SOUS-ELEMENTS :
         CALL ECLACO(1,MXNBN2,CONNX,NBNO2,  1,2,10,7,8,11,0,0)
         CALL ECLACO(2,MXNBN2,CONNX,NBNO2,  2,3,10,8,9,11,0,0)
         CALL ECLACO(3,MXNBN2,CONNX,NBNO2,  3,1,10,9,7,11,0,0)
         CALL ECLACO(4,MXNBN2,CONNX,NBNO2,  7,8,11,4,5,12,0,0)
         CALL ECLACO(5,MXNBN2,CONNX,NBNO2,  8,9,11,5,6,12,0,0)
         CALL ECLACO(6,MXNBN2,CONNX,NBNO2,  9,7,11,6,4,12,0,0)

C
       ELSEIF ( FAPG .EQ. 'FPG21' ) THEN
C               ------------------
         NPOINI = 48
         DO 60, K = 1, 6
           TYMA(K)  = IHEXA8
           NBNO2(K) = 8
 60      CONTINUE
         TYMA(7)  = IPENT6
         NBNO2(7) = 6
         DO 62, K = 8, 13
           TYMA(K)  = IHEXA8
           NBNO2(K) = 8
 62      CONTINUE
         TYMA(14)=IPENT6
         NBNO2(14)=6
         DO 64, K = 15, 20
           TYMA(K)  = IHEXA8
           NBNO2(K) = 8
 64      CONTINUE
         TYMA(21)  = IPENT6
         NBNO2(21) = 6

C        -- DEFINITION DES POINT_I :
         NTERM1(1)=1
         CALL ECLAN1(1,MXNBPI,NSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         CALL ECLAC1(1,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(2)=1
         CALL ECLAN1(2,MXNBPI,NSOMM1,NTERM1,2,0,0,0,0,0,0,0)
         CALL ECLAC1(2,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(3)=1
         CALL ECLAN1(3,MXNBPI,NSOMM1,NTERM1,3,0,0,0,0,0,0,0)
         CALL ECLAC1(3,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(4)=1
         CALL ECLAN1(4,MXNBPI,NSOMM1,NTERM1,4,0,0,0,0,0,0,0)
         CALL ECLAC1(4,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(5)=1
         CALL ECLAN1(5,MXNBPI,NSOMM1,NTERM1,5,0,0,0,0,0,0,0)
         CALL ECLAC1(5,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)
         NTERM1(6)=1
         CALL ECLAN1(6,MXNBPI,NSOMM1,NTERM1,6,0,0,0,0,0,0,0)
         CALL ECLAC1(6,MXNBPI,CSOMM1,NTERM1,1,0,0,0,0,0,0,0)

         NTERM1(7)=2
         CALL ECLAN1(7,MXNBPI,NSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         CALL ECLAC1(7,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(8)=2
         CALL ECLAN1(8,MXNBPI,NSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         CALL ECLAC1(8,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(9)=2
         CALL ECLAN1(9,MXNBPI,NSOMM1,NTERM1,2,3,0,0,0,0,0,0)
         CALL ECLAC1(9,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(10)=2
         CALL ECLAN1(10,MXNBPI,NSOMM1,NTERM1,2,3,0,0,0,0,0,0)
         CALL ECLAC1(10,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(11)=2
         CALL ECLAN1(11,MXNBPI,NSOMM1,NTERM1,3,1,0,0,0,0,0,0)
         CALL ECLAC1(11,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(12)=2
         CALL ECLAN1(12,MXNBPI,NSOMM1,NTERM1,3,1,0,0,0,0,0,0)
         CALL ECLAC1(12,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(13)=3
         CALL ECLAN1(13,MXNBPI,NSOMM1,NTERM1,1,2,3,0,0,0,0,0)
         CALL ECLAC1(13,MXNBPI,CSOMM1,NTERM1,2,1,1,0,0,0,0,0)
         NTERM1(14)=3
         CALL ECLAN1(14,MXNBPI,NSOMM1,NTERM1,1,2,3,0,0,0,0,0)
         CALL ECLAC1(14,MXNBPI,CSOMM1,NTERM1,1,2,1,0,0,0,0,0)
         NTERM1(15)=3
         CALL ECLAN1(15,MXNBPI,NSOMM1,NTERM1,1,2,3,0,0,0,0,0)
         CALL ECLAC1(15,MXNBPI,CSOMM1,NTERM1,1,1,2,0,0,0,0,0)

         NTERM1(16)=2
         CALL ECLAN1(16,MXNBPI,NSOMM1,NTERM1,4,5,0,0,0,0,0,0)
         CALL ECLAC1(16,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(17)=2
         CALL ECLAN1(17,MXNBPI,NSOMM1,NTERM1,4,5,0,0,0,0,0,0)
         CALL ECLAC1(17,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(18)=2
         CALL ECLAN1(18,MXNBPI,NSOMM1,NTERM1,5,6,0,0,0,0,0,0)
         CALL ECLAC1(18,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(19)=2
         CALL ECLAN1(19,MXNBPI,NSOMM1,NTERM1,5,6,0,0,0,0,0,0)
         CALL ECLAC1(19,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(20)=2
         CALL ECLAN1(20,MXNBPI,NSOMM1,NTERM1,6,4,0,0,0,0,0,0)
         CALL ECLAC1(20,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(21)=2
         CALL ECLAN1(21,MXNBPI,NSOMM1,NTERM1,6,4,0,0,0,0,0,0)
         CALL ECLAC1(21,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(22)=3
         CALL ECLAN1(22,MXNBPI,NSOMM1,NTERM1,4,5,6,0,0,0,0,0)
         CALL ECLAC1(22,MXNBPI,CSOMM1,NTERM1,2,1,1,0,0,0,0,0)
         NTERM1(23)=3
         CALL ECLAN1(23,MXNBPI,NSOMM1,NTERM1,4,5,6,0,0,0,0,0)
         CALL ECLAC1(23,MXNBPI,CSOMM1,NTERM1,1,2,1,0,0,0,0,0)
         NTERM1(24)=3
         CALL ECLAN1(24,MXNBPI,NSOMM1,NTERM1,4,5,6,0,0,0,0,0)
         CALL ECLAC1(24,MXNBPI,CSOMM1,NTERM1,1,1,2,0,0,0,0,0)

         NTERM1(25)=2
         CALL ECLAN1(25,MXNBPI,NSOMM1,NTERM1,1,4,0,0,0,0,0,0)
         CALL ECLAC1(25,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(26)=2
         CALL ECLAN1(26,MXNBPI,NSOMM1,NTERM1,2,5,0,0,0,0,0,0)
         CALL ECLAC1(26,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(27)=2
         CALL ECLAN1(27,MXNBPI,NSOMM1,NTERM1,3,6,0,0,0,0,0,0)
         CALL ECLAC1(27,MXNBPI,CSOMM1,NTERM1,2,1,0,0,0,0,0,0)
         NTERM1(28)=4
         CALL ECLAN1(28,MXNBPI,NSOMM1,NTERM1,1,2,4,5,0,0,0,0)
         CALL ECLAC1(28,MXNBPI,CSOMM1,NTERM1,4,2,2,1,0,0,0,0)
         NTERM1(29)=4
         CALL ECLAN1(29,MXNBPI,NSOMM1,NTERM1,1,2,4,5,0,0,0,0)
         CALL ECLAC1(29,MXNBPI,CSOMM1,NTERM1,2,4,1,2,0,0,0,0)
         NTERM1(30)=4
         CALL ECLAN1(30,MXNBPI,NSOMM1,NTERM1,2,3,5,6,0,0,0,0)
         CALL ECLAC1(30,MXNBPI,CSOMM1,NTERM1,4,2,2,1,0,0,0,0)
         NTERM1(31)=4
         CALL ECLAN1(31,MXNBPI,NSOMM1,NTERM1,2,3,5,6,0,0,0,0)
         CALL ECLAC1(31,MXNBPI,CSOMM1,NTERM1,2,4,1,2,0,0,0,0)
         NTERM1(32)=4
         CALL ECLAN1(32,MXNBPI,NSOMM1,NTERM1,3,1,6,4,0,0,0,0)
         CALL ECLAC1(32,MXNBPI,CSOMM1,NTERM1,4,2,2,1,0,0,0,0)
         NTERM1(33)=4
         CALL ECLAN1(33,MXNBPI,NSOMM1,NTERM1,3,1,6,4,0,0,0,0)
         CALL ECLAC1(33,MXNBPI,CSOMM1,NTERM1,2,4,1,2,0,0,0,0)
         NTERM1(34)=6
         CALL ECLAN1(34,MXNBPI,NSOMM1,NTERM1,1,2,3,4,5,6,0,0)
         CALL ECLAC1(34,MXNBPI,CSOMM1,NTERM1,4,2,2,2,1,1,0,0)
         NTERM1(35)=6
         CALL ECLAN1(35,MXNBPI,NSOMM1,NTERM1,1,2,3,4,5,6,0,0)
         CALL ECLAC1(35,MXNBPI,CSOMM1,NTERM1,2,4,2,1,2,1,0,0)
         NTERM1(36)=6
         CALL ECLAN1(36,MXNBPI,NSOMM1,NTERM1,1,2,3,4,5,6,0,0)
         CALL ECLAC1(36,MXNBPI,CSOMM1,NTERM1,2,2,4,1,1,2,0,0)

         NTERM1(37)=2
         CALL ECLAN1(37,MXNBPI,NSOMM1,NTERM1,1,4,0,0,0,0,0,0)
         CALL ECLAC1(37,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(38)=2
         CALL ECLAN1(38,MXNBPI,NSOMM1,NTERM1,2,5,0,0,0,0,0,0)
         CALL ECLAC1(38,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(39)=2
         CALL ECLAN1(39,MXNBPI,NSOMM1,NTERM1,3,6,0,0,0,0,0,0)
         CALL ECLAC1(39,MXNBPI,CSOMM1,NTERM1,1,2,0,0,0,0,0,0)
         NTERM1(40)=4
         CALL ECLAN1(40,MXNBPI,NSOMM1,NTERM1,1,2,4,5,0,0,0,0)
         CALL ECLAC1(40,MXNBPI,CSOMM1,NTERM1,2,1,4,2,0,0,0,0)
         NTERM1(41)=4
         CALL ECLAN1(41,MXNBPI,NSOMM1,NTERM1,1,2,4,5,0,0,0,0)
         CALL ECLAC1(41,MXNBPI,CSOMM1,NTERM1,1,2,2,4,0,0,0,0)
         NTERM1(42)=4
         CALL ECLAN1(42,MXNBPI,NSOMM1,NTERM1,2,3,5,6,0,0,0,0)
         CALL ECLAC1(42,MXNBPI,CSOMM1,NTERM1,2,1,4,2,0,0,0,0)
         NTERM1(43)=4
         CALL ECLAN1(43,MXNBPI,NSOMM1,NTERM1,2,3,5,6,0,0,0,0)
         CALL ECLAC1(43,MXNBPI,CSOMM1,NTERM1,1,2,2,4,0,0,0,0)
         NTERM1(44)=4
         CALL ECLAN1(44,MXNBPI,NSOMM1,NTERM1,3,1,6,4,0,0,0,0)
         CALL ECLAC1(44,MXNBPI,CSOMM1,NTERM1,2,1,4,2,0,0,0,0)
         NTERM1(45)=4
         CALL ECLAN1(45,MXNBPI,NSOMM1,NTERM1,3,1,6,4,0,0,0,0)
         CALL ECLAC1(45,MXNBPI,CSOMM1,NTERM1,1,2,2,4,0,0,0,0)
         NTERM1(46)=6
         CALL ECLAN1(46,MXNBPI,NSOMM1,NTERM1,1,2,3,4,5,6,0,0)
         CALL ECLAC1(46,MXNBPI,CSOMM1,NTERM1,2,1,1,4,2,2,0,0)
         NTERM1(47)=6
         CALL ECLAN1(47,MXNBPI,NSOMM1,NTERM1,1,2,3,4,5,6,0,0)
         CALL ECLAC1(47,MXNBPI,CSOMM1,NTERM1,1,2,1,2,4,2,0,0)
         NTERM1(48)=6
         CALL ECLAN1(48,MXNBPI,NSOMM1,NTERM1,1,2,3,4,5,6,0,0)
         CALL ECLAC1(48,MXNBPI,CSOMM1,NTERM1,1,1,2,2,2,4,0,0)

C        -- CONNECTIVITE DES SOUS-ELEMENTS :
         CALL ECLACO(1,MXNBN2,CONNX,NBNO2,   2, 9,14, 8,26,30,35,29)
         CALL ECLACO(2,MXNBN2,CONNX,NBNO2,   9,10,15,14,30,31,36,35)
         CALL ECLACO(3,MXNBN2,CONNX,NBNO2,  10, 3,11,15,31,27,32,36)
         CALL ECLACO(4,MXNBN2,CONNX,NBNO2,  15,11,12,13,36,32,33,34)
         CALL ECLACO(5,MXNBN2,CONNX,NBNO2,  13,12, 1, 7,34,33,25,28)
         CALL ECLACO(6,MXNBN2,CONNX,NBNO2,  13, 7, 8,14,34,28,29,35)
         CALL ECLACO(7,MXNBN2,CONNX,NBNO2,  13,14,15,34,35,36, 0, 0)

         CALL ECLACO(8,MXNBN2,CONNX,NBNO2,  26,30,35,29,38,42,47,41)
         CALL ECLACO(9,MXNBN2,CONNX,NBNO2,  30,31,36,35,42,43,48,47)
         CALL ECLACO(10,MXNBN2,CONNX,NBNO2, 31,27,32,36,43,39,44,48)
         CALL ECLACO(11,MXNBN2,CONNX,NBNO2, 36,32,33,34,48,44,45,46)
         CALL ECLACO(12,MXNBN2,CONNX,NBNO2, 34,33,25,28,46,45,37,40)
         CALL ECLACO(13,MXNBN2,CONNX,NBNO2, 34,28,29,35,46,40,41,47)
         CALL ECLACO(14,MXNBN2,CONNX,NBNO2, 34,35,36,46,47,48, 0, 0)

         CALL ECLACO(15,MXNBN2,CONNX,NBNO2, 38,42,47,41,5,18,23,17)
         CALL ECLACO(16,MXNBN2,CONNX,NBNO2, 42,43,48,47,18,19,24,23)
         CALL ECLACO(17,MXNBN2,CONNX,NBNO2, 43,39,44,48,19,6,20,24)
         CALL ECLACO(18,MXNBN2,CONNX,NBNO2, 48,44,45,46,24,20,21,22)
         CALL ECLACO(19,MXNBN2,CONNX,NBNO2, 46,45,37,40,22,21,4,16)
         CALL ECLACO(20,MXNBN2,CONNX,NBNO2, 46,40,41,47,22,16,17,23)
         CALL ECLACO(21,MXNBN2,CONNX,NBNO2, 46,47,48,22,23,24, 0, 0)

       ELSE
        VALK (1) = NOMTE
        VALK (2) = ELREFA
        VALK (3) = FAPG
        CALL U2MESK('F', 'CALCULEL5_76', 3, VALK)
       ENDIF

      ELSE
        VALK (1) = NOMTE
        VALK (2) = ELREFA
        CALL U2MESK('F', 'CALCULEL5_78', 2, VALK)
      ENDIF

      CALL JEDEMA()

      END
