      SUBROUTINE ECLATY ( NOMTE, ELREFA, FAPG, NPG, NPOINI, 
     &                    NTERM1, NSOMM1, CSOMM1, TYMA, NBNO2, CONNX,
     &                    MXNBN2, MXNBPG, MXNBPI, MXNBTE )
      IMPLICIT   NONE
      INTEGER       MXNBN2,MXNBPG,MXNBPI,MXNBTE
      INTEGER       NDIM,NPG,CONNX(MXNBN2,MXNBPG),NSOMM1(MXNBPI,MXNBTE)
      INTEGER       NTERM1(MXNBPI),NBNO2(MXNBPG),NPOINI,TYMA(MXNBPG)
      REAL*8        CSOMM1(MXNBPI,MXNBTE)
      CHARACTER*8   ELREFA, FAPG
      CHARACTER*16  NOMTE
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 24/01/2006   AUTEUR CIBHHLV L.VIVAN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C --------------------------------------------------------------------
C BUT : DECOMPOSER LES TYPE_ELEM EN AUTANT DE SOUS-ELEMENTS QUE
C       DE POINTS DE GAUSS.
C * ON NE TRAITE PAS PYRAM13 CAR POINTS DE GAUSS EN DEHORS DU VOLUME
C   DE LA PYRAMIDE. 
C * ON NE TRAITE PAS PYRAM5 CAR IL N EST PAS NATUREL DE DECOUPER 
C   LA PYRAMIDE EN 5 ELEMENTS SIMPLES.
C ---------------------------------------------------------------------
C IN : NOMTE  : NOM D'UN TYPE_ELEM
C IN : ELREFA : NOM DE L'ELREFA
C IN : FAPG   : FAMILLE DE POINTS DE GAUSS
C      MXNBN2 : MAX DU NOMBRE DE NOEUDS D'UN SOUS-ELEMENT (HEXA8)
C      MXNBPG : MAX DU NOMBRE DE POINTS DE GAUSS D'UN TYPE_ELEM
C      MXNBPI : MAX DU NOMBRE DE POINT_I (HEXA A 27 POINTS DE GAUSS)
C      MXNBTE : MAX DU NOMBRE DE TERMES DE LA C.L. DEFINISSANT 1 POINT_I
C
C OUT : NPG    : NOMBRE DE POINTS DE GAUSS (ET DE SOUS-ELEMENTS)
C OUT : NPOINI : NOMBRE DE POINT_I POUR LE TYPE_ELEM/FAPG
C                    (NPOINI <= 64 : (HEXA20 A 27 POINTS DE GAUSS))
C OUT : NTERM1 : NTERM1(IPOINI) : NOMBRE DE TERMES DE LA COMBINAISON
C                POUR LE POINT_I IPOINI
C OUT : NSOMM1 : NSOMM1(IPOINI,K) NUMERO DU NOEUD DU KEME TERME.
C OUT : CSOMM1 : CSOMM1(IPOINI,K) COEF. DU NOEUD DU KEME TERME.
C
C ---------------------------------------------------------------------
C DESCRIPTION DES POINTS INTERMEDIAIRES (POINT_I) :
C ------------------------------------------------
C UN POINT_I EST DEFINI COMME UNE COMBINAISON LINEAIRE DES NOEUDS
C DE LA MAILLE SOUS-JACENTE AU TYPE_ELEM :
C POINT_I = SOMME COEF(K)*NOEUD(K)  (1<= K <=NTERMES)
C           NTERMES <= 27 (HEXA27)
C
C CONNECTIVITE DES SOUS-ELEMENTS :
C-------------------------------
C OUT : TYMA (I) : TYMA(IPG)-> TYPE_MAILLE ASSOCIE AU SOUS-ELEMENT IPG
C OUT : NBNO2 (I) : NBNO2(IPG) -> NNO2
C                    NNO2 : NOMBRE DE NOEUDS DU SOUS-ELEMENT IPG
C OUT : CONNX (I) : CONNX(INO2,IPG) -> IPOINI
C                    IPOINI= NUMERO DU POINT_I ASSOCIE AU
C                    SOMMET INO2 DU SOUS-ELEMENT IPG
C                    (1<= INO2 <= NNO2(IPG))
C                    (1<= IPOINI <= NPOINI)
C
C ---------------------------------------------------------------------
      INTEGER        NBNOMX,    NBFAMX
      PARAMETER    ( NBNOMX=27, NBFAMX=20)
      INTEGER      NNO, NNOS, NBFPG, NBPG(NBFAMX), NUFPG, INDIK8
      REAL*8       VOL, X(3*NBNOMX)
      CHARACTER*8  FAMG(NBFAMX)
C ---------------------------------------------------------------------
      CALL JEMARQ()
C
      NPG    = 0
      NPOINI = 0
C
      CALL ELRACA ( ELREFA, NDIM, NNO, NNOS, NBFPG, FAMG, NBPG, X, VOL )

      NUFPG = INDIK8( FAMG, FAPG, 1, NBFPG )
      CALL ASSERT(NUFPG.GT.0)
      NPG = NBPG(NUFPG)
C
      IF ( NDIM .EQ. 2 ) THEN
         CALL ECLA2D ( NOMTE, ELREFA, FAPG, NPG, NPOINI, 
     &                 NTERM1, NSOMM1, CSOMM1, TYMA, NBNO2, CONNX,
     &                 MXNBN2, MXNBPG, MXNBPI, MXNBTE )

      ELSEIF ( NDIM .EQ. 3 ) THEN
         CALL ECLA3D ( NOMTE, ELREFA, FAPG, NPG, NPOINI,
     &                 NTERM1, NSOMM1, CSOMM1, TYMA, NBNO2, CONNX,
     &                 MXNBN2, MXNBPG, MXNBPI, MXNBTE )

      ELSE
         NPG    = 0
         NPOINI = 0
      ENDIF

      CALL JEDEMA()

      END
