      SUBROUTINE ELREFV(NOMTE,FAMIL,NDIM,NNO,NNO2,NNOS,NPG,IPOIDS,
     &                  IVF,IVF2,IDFDE,IDFDE2,JGANO,JGANO2)
      IMPLICIT NONE
      CHARACTER*16 NOMTE
      CHARACTER*4  FAMIL
      INTEGER NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDE,JGANO
      INTEGER NNO2,IVF2,IDFDE2,JGANO2

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 15/02/2011   AUTEUR FLEJOU J-L.FLEJOU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================

C ---------------------------------------------------------------------
C BUT: RECUPERER DANS UNE ROUTINE TE00IJ LES ADRESSES DANS ZR
C      - DES POIDS DES POINTS DE GAUSS  : IPOIDS
C      - DES VALEURS DES FONCTIONS DE FORME : IVF
C      - DES VALEURS DES DERIVEES 1ERES DES FONCTIONS DE FORME : IDFDE
C      - DE LA MATRICE DE PASSAGE GAUSS -> NOEUDS : JGANO
C ---------------------------------------------------------------------
C   IN   NOMTE        -->  NOM DU TYPE ELEMENT
C        FAMIL  : NOM (LOCAL) DE LA FAMILLE DE POINTS DE GAUSS :
C                 'STD','RICH',...
C   OUT  NDIM   : DIMENSION DE L'ESPACE (=NB COORDONNEES)
C        NNO    : NOMBRE DE NOEUDS DU TYPE_MAILLE 1 
C                 (DEPLACEMENT QUADRATIQUE)
C        NNO2   : NOMBRE DE NOEUDS DU TYPE_MAILLE 2
C                 (VARIABLE INETERNE + LAGRANGE LINEAIRE)
C        NNOS   : NOMBRE DE NOEUDS SOMMETS DU TYPE_MAILLE
C        NPG    : NOMBRE DE POINTS DE GAUSS
C        IPOIDS : ADRESSE DANS ZR DU TABLEAU POIDS(IPG)
C        IVF    : ADRESSE DANS ZR DU TABLEAU FF(INO,IPG) TYPE_MAILLE 1
C        IVF2   : ADRESSE DANS ZR DU TABLEAU FF(INO2,IPG) TYPE_MAILLE 2
C        IDFDE  : ADRESSE DANS ZR DU TABLEAU DFF(IDIM,INO,IPG)
C        IDFDE2 : ADRESSE DANS ZR DU TABLEAU DFF(IDIM,INO2,IPG)
C        JGANO  : ADRESSE DANS ZR DE LA MATRICE DE PASSAGE
C                      GAUSS -> NOEUDS (DIM= 2+NNO*NPG)
C                 ATTENTION : LES 2 1ERS TERMES SONT LES
C                             DIMMENSIONS DE LA MATRICE: NNO ET NPG
C        JGANO2  : ADRESSE DANS ZR DE LA MATRICE DE PASSAGE
C                      GAUSS -> NOEUDS (DIM= 2+NNO2*NPG)
C                 ATTENTION : LES 2 1ERS TERMES SONT LES
C                             DIMMENSIONS DE LA MATRICE: NNO2 ET NPG
C   -------------------------------------------------------------------
      CHARACTER*8 ELREFE,ELREF2


      CALL ELREF1(ELREFE) 
C           
      CALL ELREF4(ELREFE,FAMIL,NDIM,NNO,NNOS,
     &            NPG,IPOIDS,IVF,IDFDE,JGANO) 
C     
      IF ( ELREFE.EQ.'TR3' .OR. ELREFE .EQ.'QU4') THEN
C  
C --- CAS LINEAIRE
C              
        CALL ELREF4(ELREFE,FAMIL,NDIM,NNO2,NNOS,
     &              NPG,IPOIDS,IVF2,IDFDE2,JGANO2)
      ELSE     
C       
C --- CAS QUADRATIQUE
C                         
        IF ( ELREFE.EQ.'TR6') THEN
          ELREF2 = 'TR3'
        ELSEIF ( ELREFE .EQ. 'QU8'  ) THEN
          ELREF2 = 'QU4'
        ELSEIF ( ELREFE .EQ. 'H20'  ) THEN
          ELREF2 = 'HE8'
        ELSEIF ( ELREFE .EQ. 'T10'  ) THEN
          ELREF2 = 'TE4'
        ELSEIF ( ELREFE .EQ. 'P15'  ) THEN
          ELREF2 = 'PE6'
        ELSEIF ( ELREFE .EQ. 'P13'  ) THEN
          ELREF2 = 'PY5'
        ENDIF
        CALL ELREF4(ELREF2,FAMIL,NDIM,NNO2,NNOS,
     &              NPG,IPOIDS,IVF2,IDFDE2,JGANO2)
      ENDIF


      END
