      SUBROUTINE MEMAME(OPTION,MODELE,NCHAR ,LCHAR ,MATE  ,
     &                  CARELE,EXITIM,INSTAN,COMPOR,MATELZ,
     &                  BASE  )

C
C MODIF CALCULEL  DATE 08/11/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INTEGER       NCHAR
      REAL*8        INSTAN
      CHARACTER*8   LCHAR(*)
      CHARACTER*1   BASE
      CHARACTER*(*) OPTION,MODELE,MATE,CARELE,COMPOR,MATELZ
      LOGICAL       EXITIM
C
C ----------------------------------------------------------------------
C
C ROUTINE CALCUL
C
C CALCUL DES MATRICES ELEMENTAIRES DE MASSE MECA
C
C ----------------------------------------------------------------------
C
C
C IN   OPTION : OPTION DE CALCUL
C IN   MODELE : NOM DU MODELE (OBLIGATOIRE)
C IN   NCHAR  : NOMBRE DE CHARGES
C IN   LCHAR  : LISTE DES CHARGES
C IN   MATE   : CARTE DE MATERIAUX
C IN   CARELE : CHAMP DE CARAC_ELEM
C IN   EXITIM : VRAI SI L'INSTANT EST DONNE
C IN   INSTAN : INSTANT DE CALCUL
C IN   COMPOR : CARTE DE COMPORTEMENT
C IN   BASEZ  : NOM DE LA BASE
C OUT  MATELE : NOM DU MATR_ELEM RESULTAT
C IN   BASE   : NOM DE LA BASE
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      INTEGER      NBOUT,NBIN
      PARAMETER    (NBOUT=2, NBIN=18)
      CHARACTER*8  LPAOUT(NBOUT),LPAIN(NBIN)
      CHARACTER*19 LCHOUT(NBOUT),LCHIN(NBIN)
      CHARACTER*19 PINTTO,CNSETO,HEAVTO,LONCHA,BASLOC,LSN,LST,STANO
      CHARACTER*19 PMILTO
C
      CHARACTER*2  CODRET
      CHARACTER*19 CHVARC,MATELE
      CHARACTER*24 LIGRMO
      CHARACTER*24 CHGEOM,CHCARA(18),CHHARM
      INTEGER      NBOUT2
      INTEGER      NH,IRET,ICODE,IAREFE
      INTEGER      IFMDBG,NIVDBG,IER
      LOGICAL      DEBUG
      DATA CHVARC /'&&MEMAME.VARC'/
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('PRE_CALCUL',IFMDBG,NIVDBG)
C
C --- INITIALISATIONS
C
      MATELE = MATELZ
      IF (NIVDBG.GE.2) THEN
        DEBUG  = .TRUE.
      ELSE
        DEBUG  = .FALSE.
      ENDIF
      NH    = 0
      IF (MODELE(1:1).EQ.' ') THEN
        CALL ASSERT(.FALSE.)
      ELSE
        LIGRMO = MODELE(1:8)//'.MODELE'
      ENDIF
C
C --- INITIALISATION DES CHAMPS POUR CALCUL
C
      CALL INICAL(NBIN  ,LPAIN ,LCHIN ,
     &            NBOUT ,LPAOUT,LCHOUT)
C
C --- CREATION DES CHAMPS GEOM. CARAC_ELEM ET HARM_FOURIER
C
      CALL MECHAM(OPTION,MODELE,NCHAR ,LCHAR ,CARELE,
     &            NH    ,CHGEOM,CHCARA,CHHARM,ICODE )
C
C --- CREATION DU CHAMP DE VARIABLES DE COMMANDE
C
      CALL VRCINS(MODELE,MATE  ,CARELE,INSTAN,CHVARC,
     &            CODRET)
C
C --- PREPARATION DES MATR_ELEM
C
      CALL MEMARE(BASE  ,MATELE,MODELE,MATE  ,CARELE,OPTION)
      CALL JEVEUO(MATELE(1:19)//'.RERR','E',IAREFE)
      ZK24(IAREFE-1+3) (1:3) = 'OUI'
      CALL JEEXIN(MATELE(1:19)//'.RELR',IRET)
      IF (IRET.GT.0) CALL JEDETR(MATELE(1:19)//'.RELR')
      IF (ICODE.EQ.2) GO TO 10

C  -----VERIFICATION DE L'EXISTENCE D'UN MODELE X-FEM------
      CALL EXIXFE(MODELE,IER)
      IF (IER.NE.0) THEN

C  -----CAS DU MODELE X-FEM-----------------------

        PINTTO = MODELE(1:8)//'.TOPOSE.PIN'
        CNSETO = MODELE(1:8)//'.TOPOSE.CNS'
        HEAVTO = MODELE(1:8)//'.TOPOSE.HEA'
        LONCHA = MODELE(1:8)//'.TOPOSE.LON'
        PMILTO = MODELE(1:8)//'.TOPOSE.PMI'
        BASLOC = MODELE(1:8)//'.BASLOC'
        LSN    = MODELE(1:8)//'.LNNO'
        LST    = MODELE(1:8)//'.LTNO'
        STANO  = MODELE(1:8)//'.STNO'

C ----- REMPLISSAGE DES CHAMPS D'ENTREE
C
        LPAIN(1)  = 'PGEOMER'
        LCHIN(1)  = CHGEOM
        LPAIN(2)  = 'PMATERC'
        LCHIN(2)  = MATE
        LPAIN(3) = 'PPINTTO'
        LCHIN(3) = PINTTO
        LPAIN(4) = 'PHEAVTO'
        LCHIN(4) = HEAVTO
        LPAIN(5) = 'PLONCHA'
        LCHIN(5) = LONCHA
        LPAIN(6) = 'PCNSETO'
        LCHIN(6) = CNSETO
        LPAIN(7) = 'PBASLOR'
        LCHIN(7) = BASLOC
        LPAIN(8) = 'PLSN'
        LCHIN(8) = LSN
        LPAIN(9) = 'PLST'
        LCHIN(9) = LST
        LPAIN(10) = 'PSTANO'
        LCHIN(10) = STANO
        LPAIN(11) = 'PPMILTO'
        LCHIN(11) = PMILTO
C
C --- CHAMPS DE SORTIE
C
        LPAOUT(1) = 'PMATUUR'
        LCHOUT(1) = MATELE(1:15)//'.M01'

        CALL CALCUL('S',OPTION,LIGRMO,10,LCHIN,LPAIN,1,
     &              LCHOUT,LPAOUT,BASE,'OUI')
        CALL REAJRE(MATELZ,LCHOUT(1),BASE)

      ELSEIF (IER.EQ.0) THEN
C
C----------CAS FEM CLASSIQUE-------------------------
C
C ----- CHAMPS D'ENTREE
C
        LPAIN(1)  = 'PGEOMER'
        LCHIN(1)  = CHGEOM
        LPAIN(2)  = 'PMATERC'
        LCHIN(2)  = MATE
        LPAIN(3)  = 'PCAORIE'
        LCHIN(3)  = CHCARA(1)
        LPAIN(4)  = 'PCADISM'
        LCHIN(4)  = CHCARA(3)
        LPAIN(5)  = 'PCAGNPO'
        LCHIN(5)  = CHCARA(6)
        LPAIN(6)  = 'PCACOQU'
        LCHIN(6)  = CHCARA(7)
        LPAIN(7)  = 'PCASECT'
        LCHIN(7)  = CHCARA(8)
        LPAIN(8)  = 'PVARCPR'
        LCHIN(8)  = CHVARC
        LPAIN(9)  = 'PCAARPO'
        LCHIN(9)  = CHCARA(9)
        LPAIN(10) = 'PCACABL'
        LCHIN(10) = CHCARA(10)
        LPAIN(11) = 'PCAGEPO'
        LCHIN(11) = CHCARA(5)
        LPAIN(12) = 'PABSCUR'
        LCHIN(12) = CHGEOM(1:8)//'.ABS_CURV'
        LPAIN(13) = 'PCAGNBA'
        LCHIN(13) = CHCARA(11)
        LPAIN(14) = 'PCAPOUF'
        LCHIN(14) = CHCARA(13)
        LPAIN(15) = 'PCOMPOR'
        LCHIN(15) = COMPOR
        LPAIN(16) = 'PNBSP_I'
        LCHIN(16) = CHCARA(16)
        LPAIN(17) = 'PFIBRES'
        LCHIN(17) = CHCARA(17)
        LPAIN(18) = 'PCINFDI'
        LCHIN(18) = CHCARA(15)
C
C ----- CHAMPS DE SORTIE
C
        LPAOUT(1) = 'PMATUUR'
        LCHOUT(1) = MATELE(1:15)//'.M01'
        LPAOUT(2) = 'PMATUNS'
        LCHOUT(2) = MATELE(1:15)//'.M02'
        IF (OPTION.EQ.'MASS_MECA') THEN
          NBOUT2 = 2
        ELSE
          NBOUT2 = 1
        END IF
C
C ----- APPEL A CALCUL
C
        IF (DEBUG) THEN
          CALL DBGCAL(OPTION,IFMDBG,
     &              NBIN  ,LPAIN ,LCHIN ,
     &              NBOUT2,LPAOUT,LCHOUT)
        ENDIF
C
        CALL CALCUL('S',OPTION,LIGRMO,NBIN  ,LCHIN ,LPAIN ,
     &                              NBOUT2,LCHOUT,LPAOUT,BASE,'OUI')
C
C ----- STOCKAGE DES RESU_ELEM
C
        CALL REAJRE(MATELZ,LCHOUT(1),BASE)
        CALL REAJRE(MATELZ,LCHOUT(2),BASE)
      ENDIF

   10 CONTINUE

C     -- DESTRUCTION DES RESUELEM NULS :
      CALL REDETR(MATELZ)

      CALL DETRSD('CHAMP_GD',CHVARC)

      CALL JEDEMA()
      END
