      SUBROUTINE MERIGE(MODELE,CARA,SIGG,MATEL,BASE,NH)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER NH
      CHARACTER*1 BASE
      CHARACTER*8 MODELE,CARA
      CHARACTER*(*) SIGG
      CHARACTER*19 MATEL
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 08/11/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C     CALCUL DES MATRICES ELEMENTAIRES DE RIGIDITE GEOMETRIQUE

C     ------------------------------------------------------------------
C IN  : MODELE : NOM DU MODELE
C IN  : CARA   : CHAMP DE CARAC_ELEM
C IN  : SIGG   : CHAMP DE CONTRAINTES AUX POINTS DE GAUSS
C IN  : NH     : NUMERO DE L'HARMONIQUE DE FOURIER
C VAR : MATEL  : NOM DU MATEL (N RESUELEM) PRODUIT
C IN  : BASE   : BASE POUR LA CREATION DE MATEL ('G'/'V')
C ----------------------------------------------------------------------
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      CHARACTER*32 JEXNUM,JEXNOM,JEXATR
C     ------------------------------------------------------------------
      CHARACTER*8 LPAIN(11),LPAOUT(1),CHARG
      CHARACTER*16 OPTION
      CHARACTER*24 LIGRMO,LCHIN(11),LCHOUT(1)
      CHARACTER*24 CHGEOM,CHCARA(18),CHTEMP,CHTREF,CHHARM
      CHARACTER*19 PINTTO,CNSETO,HEAVTO,LONCHA,BASLOC,LSN,LST,STANO
      CHARACTER*19 PMILTO

      CALL JEMARQ()
      IF (MODELE(1:1).EQ.' ') CALL U2MESS('F','CALCULEL2_82')

      CHARG = ' '
      OPTION = 'RIGI_GEOM'
      CALL MECHAM(OPTION,MODELE,0,CHARG,CARA,NH,CHGEOM,CHCARA,CHHARM,
     &            ICODE)

      CALL MEMARE(BASE,MATEL,MODELE,' ',CARA,OPTION)

C  -----CAS DU MODELE X-FEM-----------------------
      CALL EXIXFE(MODELE,IER)
      IF (IER.NE.0) THEN

        PINTTO = MODELE(1:8)//'.TOPOSE.PIN'
        CNSETO = MODELE(1:8)//'.TOPOSE.CNS'
        HEAVTO = MODELE(1:8)//'.TOPOSE.HEA'
        LONCHA = MODELE(1:8)//'.TOPOSE.LON'
        PMILTO = MODELE(1:8)//'.TOPOSE.PMI'
        BASLOC = MODELE(1:8)//'.BASLOC'
        LSN    = MODELE(1:8)//'.LNNO'
        LST    = MODELE(1:8)//'.LTNO'
        STANO  = MODELE(1:8)//'.STNO'

        LIGRMO = MODELE//'.MODELE'

C ----- REMPLISSAGE DES CHAMPS D'ENTREE
C
        LPAIN(1)  = 'PGEOMER'
        LCHIN(1)  = CHGEOM
        LPAIN(2) = 'PCONTRR'
        LCHIN(2) = SIGG
        LPAIN(3) = 'PPINTTO'
        LCHIN(3) = PINTTO
        LPAIN(4) = 'PHEAVTO'
        LCHIN(4) = HEAVTO
        LPAIN(5) = 'PLONCHA'
        LCHIN(5) = LONCHA
        LPAIN(6) = 'PCNSETO'
        LCHIN(6) = CNSETO
        LPAIN(7) = 'PBASLOR'
        LCHIN(7) = BASLOC
        LPAIN(8) = 'PLSN'
        LCHIN(8) = LSN
        LPAIN(9) = 'PLST'
        LCHIN(9) = LST
        LPAIN(10) = 'PSTANO'
        LCHIN(10) = STANO
        LPAIN(11) = 'PPMILTO'
        LCHIN(11) = PMILTO
C
C --- CHAMPS DE SORTIE
C
        LPAOUT(1) = 'PMATUUR'
        LCHOUT(1) = MATEL(1:15)//'.ME001'

        OPTION = 'RIGI_MECA_GE'

        CALL CALCUL('S',OPTION,LIGRMO,11,LCHIN,LPAIN,1,
     &              LCHOUT,LPAOUT,BASE,'OUI')
        CALL REAJRE(MATEL,LCHOUT(1),BASE)

      ELSEIF (IER.EQ.0) THEN

        LPAOUT(1) = 'PMATUUR'
        LCHOUT(1) = MATEL(1:8)//'.ME001'

        LIGRMO = MODELE//'.MODELE'
        LPAIN(1) = 'PGEOMER'
        LCHIN(1) = CHGEOM
        LPAIN(2) = 'PCONTRR'
        LCHIN(2) = SIGG
        LPAIN(3) = 'PCAORIE'
        LCHIN(3) = CHCARA(1)
        LPAIN(4) = 'PCADISK'
        LCHIN(4) = CHCARA(2)
        LPAIN(5) = 'PCAGNPO'
        LCHIN(5) = CHCARA(6)
        LPAIN(6) = 'PCACOQU'
        LCHIN(6) = CHCARA(7)
        LPAIN(7) = 'PEFFORR'
        LCHIN(7) = SIGG
        LPAIN(8) = 'PHARMON'
        LCHIN(8) = CHHARM
        LPAIN(9) = 'PNBSP_I'
        LCHIN(9) = CARA(1:8)//'.CANBSP'
        OPTION = 'RIGI_MECA_GE'
        CALL CALCUL('S',OPTION,LIGRMO,9,LCHIN,LPAIN,1,LCHOUT,
     &              LPAOUT,BASE,'OUI')
        CALL REAJRE(MATEL,LCHOUT(1),BASE)

      ENDIF

      CALL JEDEMA()
      END
