      SUBROUTINE MERIME(MODELZ,NCHAR,LCHAR,MATE,CARAZ,EXITIM,TIME,
     &                  COMPOR,MATELZ,NH,BASEZ)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER NCHAR,NH
      REAL*8 TIME
      CHARACTER*(*) MODELZ,CARAZ,MATELZ
      CHARACTER*8 MODELE,CARA
      CHARACTER*19 MATEL
      CHARACTER*(*) LCHAR(*),MATE,BASEZ,COMPOR
      CHARACTER*(1) BASE
      LOGICAL EXITIM
C ----------------------------------------------------------------------
C MODIF CALCULEL  DATE 08/11/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C                          DE MERIME...  PROSPER YOUP-LA-BOUM!

C     CALCUL DES MATRICES ELEMENTAIRES DE RIGIDITE MECA

C ----------------------------------------------------------------------
C IN  : MODELZ : NOM DU MODELE
C IN  : NCHAR  : NOMBRE DE CHARGES
C IN  : LCHAR  : LISTE DES CHARGES
C IN  : MATE   : CARTE DE MATERIAU
C IN  : CARAZ  : CHAMP DE CARAC_ELEM
C IN  : MATELZ : NOM DU MATR_ELEM RESULTAT
C IN  : EXITIM : VRAI SI L'INSTANT EST DONNE
C IN  : TIME   : INSTANT DE CALCUL
C IN  : NH     : NUMERO D'HARMONIQUE DE FOURIER
C IN  : BASEZ  : NOM DE LA BASE
C IN  : COMPOR : COMPOR POUR LES MULTIFIBRE (POU_D_EM)
C ----------------------------------------------------------------------
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      CHARACTER*32 JEXNUM,JEXNOM,JEXATR
C     ------------------------------------------------------------------
      CHARACTER*2 CODRET
      CHARACTER*8 K8B,LPAIN(25),LPAOUT(2),STATUT,NOMRES,NOMGD,KBID
      CHARACTER*16 OPTION,NOMCMD,TYPRES
      CHARACTER*19 NOMFON,CHVARC
      CHARACTER*19 PINTTO,CNSETO,HEAVTO,LONCHA,BASLOC,LSN,LST,STANO
      CHARACTER*19 PMILTO
      CHARACTER*24 LIGRMO,LIGRCH,LCHIN(25),LCHOUT(2)
      CHARACTER*24 CHGEOM,CHCARA(18),CHTEMP,CHTREF,CHHARM
      CHARACTER*24 CHCHAR,ARGU,CHTIME
      COMPLEX*16 CBID
      DATA CHVARC/'&&MERIME.CH_VARC_R'/

      CALL JEMARQ()
      MODELE = MODELZ
      CALL ASSERT(MODELE.NE.' ')
      CARA = CARAZ
      MATEL = MATELZ
      BASE = BASEZ

      CALL GETRES(NOMFON,TYPRES,NOMCMD)
      OPTION = 'RIGI_MECA'
      CALL MECHAM(OPTION,MODELE,NCHAR,LCHAR,CARA,NH,CHGEOM,CHCARA,
     &            CHHARM,ICODE)

      CALL MECHPE(NCHAR,LCHAR,CHCHAR)

      IF (.NOT.EXITIM) TIME = 0.D0
      CHTIME = '&&MERIME.CHAMP_INST'
      CALL MECACT('V',CHTIME,'MODELE',MODELE//'.MODELE','INST_R',1,
     &            'INST',IBID,TIME,CBID,KBID)


      IF (NOMCMD.EQ.'MECA_STATIQUE'.OR.NOMCMD.EQ.'CALC_MATR_ELEM') THEN
        CALL VRCINS(MODELE,MATE,CARA,TIME,CHVARC,CODRET)
      END IF


      CALL MEMARE(BASE,MATEL,MODELE,MATE,CARA,OPTION)
C     SI LA RIGIDITE EST CALCULEE SUR LE MODELE, ON ACTIVE LES S_STRUC:
      IF (ICODE.EQ.0 .OR. ICODE.EQ.2) THEN
        CALL JEVEUO(MATEL//'.RERR','E',IAREFE)
        ZK24(IAREFE-1+3) (1:3) = 'OUI'
      END IF

      CALL JEEXIN(MATEL//'.RELR',IRET1)
      IF (IRET1.GT.0) CALL JEDETR(MATEL//'.RELR')

      ILIRES = 0

      LPAOUT(1) = 'PMATUUR'
      LCHOUT(1) = MATEL(1:8)//'.ME001'
      LPAOUT(2) = 'PMATUNS'
      LCHOUT(2) = MATEL(1:8)//'.ME002'
      LIGRMO = MODELE//'.MODELE'

C  ---VERIFICATION DE L'EXISTENCE D'UN MODELE X-FEM-------
      CALL EXIXFE(MODELE,IER)

      IF (IER.NE.0) THEN

C  ---  CAS DU MODELE X-FEM-----------

        ILIRES=ILIRES+1
        PINTTO = MODELE(1:8)//'.TOPOSE.PIN'
        CNSETO = MODELE(1:8)//'.TOPOSE.CNS'
        HEAVTO = MODELE(1:8)//'.TOPOSE.HEA'
        LONCHA = MODELE(1:8)//'.TOPOSE.LON'
        PMILTO = MODELE(1:8)//'.TOPOSE.PMI'
        BASLOC = MODELE(1:8)//'.BASLOC'
        LSN    = MODELE(1:8)//'.LNNO'
        LST    = MODELE(1:8)//'.LTNO'
        STANO  = MODELE(1:8)//'.STNO'

C ----- REMPLISSAGE DES CHAMPS D'ENTREE
C
        LPAIN(1)  = 'PGEOMER'
        LCHIN(1)  = CHGEOM
        LPAIN(2)  = 'PMATERC'
        LCHIN(2)  = MATE
        LPAIN(3) = 'PPINTTO'
        LCHIN(3) = PINTTO
        LPAIN(4) = 'PHEAVTO'
        LCHIN(4) = HEAVTO
        LPAIN(5) = 'PLONCHA'
        LCHIN(5) = LONCHA
        LPAIN(6) = 'PCNSETO'
        LCHIN(6) = CNSETO
        LPAIN(7) = 'PBASLOR'
        LCHIN(7) = BASLOC
        LPAIN(8) = 'PLSN'
        LCHIN(8) = LSN
        LPAIN(9) = 'PLST'
        LCHIN(9) = LST
        LPAIN(10) = 'PSTANO'
        LCHIN(10) = STANO
        LPAIN(11) = 'PPMILTO'
        LCHIN(11) = PMILTO

        CALL CALCUL('S',OPTION,LIGRMO,11,LCHIN,LPAIN,1,LCHOUT,LPAOUT,
     &              BASE,'OUI')
        CALL REAJRE(MATEL,LCHOUT(1),BASE)

      ELSEIF (ICODE.EQ.0 .AND. IER.EQ.0) THEN

C----- CAS DU MODELE FEM CLASSIQUE---------------

        LPAIN(1) = 'PGEOMER'
        LCHIN(1) = CHGEOM
        LPAIN(2) = 'PMATERC'
        LCHIN(2) = MATE
        LPAIN(3) = 'PCAORIE'
        LCHIN(3) = CHCARA(1)
        LPAIN(4) = 'PCADISK'
        LCHIN(4) = CHCARA(2)
        LPAIN(5) = 'PCAGNPO'
        LCHIN(5) = CHCARA(6)
        LPAIN(6) = 'PCACOQU'
        LCHIN(6) = CHCARA(7)
        LPAIN(7) = 'PCASECT'
        LCHIN(7) = CHCARA(8)
        LPAIN(8) = 'PCAARPO'
        LCHIN(8) = CHCARA(9)
        LPAIN(9) = 'PHARMON'
        LCHIN(9) = CHHARM
        LPAIN(10) = 'PPESANR'
        LCHIN(10) = CHCHAR
        LPAIN(11) = 'PGEOME2'
        LCHIN(11) = CHGEOM
        LPAIN(12) = ' '
        LCHIN(12) = ' '
        LPAIN(13) = 'PCAGNBA'
        LCHIN(13) = CHCARA(11)
        LPAIN(14) = 'PCAMASS'
        LCHIN(14) = CHCARA(12)
        LPAIN(15) = 'PCAPOUF'
        LCHIN(15) = CHCARA(13)
        LPAIN(16) = 'PCAGEPO'
        LCHIN(16) = CHCARA(5)
        LPAIN(17) = 'PVARCPR'
        LCHIN(17) = CHVARC
        LPAIN(18) = 'PTEMPSR'
        LCHIN(18) = CHTIME
        LPAIN(19) = 'PNBSP_I'
        LCHIN(19) = CHCARA(16)
        LPAIN(20) = 'PFIBRES'
        LCHIN(20) = CHCARA(17)
        LPAIN(21) = 'PCOMPOR'
        LCHIN(21) = COMPOR
        LPAIN(22) = 'PCINFDI'
        LCHIN(22) = CHCARA(15)
        CALL CALCUL('S',OPTION,LIGRMO,22,LCHIN,LPAIN,2,LCHOUT,LPAOUT,
     &              BASE,'OUI')
        CALL REAJRE(MATEL,LCHOUT(1),BASE)
        CALL REAJRE(MATEL,LCHOUT(2),BASE)
        ILIRES = ILIRES +2
      END IF

      DO 10 ICHA = 1,NCHAR
        LIGRCH = LCHAR(ICHA) (1:8)//'.CHME.LIGRE'
        ARGU = LCHAR(ICHA) (1:8)//'.CHME.LIGRE.LIEL'
        CALL JEEXIN(ARGU,IRET)
        IF (IRET.LE.0) GO TO 10
        LCHIN(1) = LCHAR(ICHA) (1:8)//'.CHME.CMULT'
        ARGU = LCHAR(ICHA) (1:8)//'.CHME.CMULT.DESC'
        CALL JEEXIN(ARGU,IRET)
        IF (IRET.LE.0) GO TO 10

        LPAIN(1) = 'PDDLMUR'
        ILIRES=ILIRES+1
        CALL CODENT(ILIRES,'D0',LCHOUT(1) (12:14))
        OPTION = 'MECA_DDLM_R'
        CALL CALCUL('S',OPTION,LIGRCH,1,LCHIN,LPAIN,1,LCHOUT,LPAOUT,
     &              BASE,'OUI')
        CALL REAJRE(MATEL,LCHOUT(1),BASE)
   10 CONTINUE

C     -- DESTRUCTION DES RESUELEM NULS :
      CALL REDETR(MATEL)

      CALL DETRSD('CHAMP_GD',CHTIME)

      CALL JEDEMA()
      END
