      SUBROUTINE NBPTCA(LIGREL,OPTION,PARAM,OBNBPT,OBNBNO)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 05/10/2005   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C RESPONSABLE VABHHTS J.PELLET
C A_UTIL
      IMPLICIT NONE
      CHARACTER*(*) LIGREL,OPTION,PARAM,OBNBPT,OBNBNO
C ------------------------------------------------------------------
C BUT: CREER L'OBJET OBNBPT QUI CONTIENDRA LE NOMBRE DE POINTS
C      DE DISCRETISATION (POUR LES MAILLES D'UN LIGREL)
C      POUR LE CHAMP ASSOCIE A UN PARAMETRE D'UNE OPTION
C ------------------------------------------------------------------
C     ARGUMENTS:
C LIGREL  IN/JXIN  K19 : LIGREL
C OPTION  IN       K16 : NOM D'UNE OPTION DE CALCUL
C PARAM   IN       K8  : NOM D'UN PARAMETRE DE OPTION
C OBNBPT  IN/JXOUT K24 : OBJET QUI CONTIENDRA LES NOMBRES DE POINTS
C OBNBNO  IN/JXOUT K24 : OBJET QUI CONTIENDRA LES NOMBRES DE NOEUDS
C ------------------------------------------------------------------
C REMARQUES :
C  CETTE ROUTINE PEUT ETRE UTILISEE PAR EXEMPLE POUR DETERMINER LES
C  NOMBRE DE POINTS DE GAUSS D'UN MODELE MECANIQUE NON-LINEAIRE:
C  OPTION = 'RAPH_MECA' + PARAM='PCONTMR'

C  L'OBJET CREE EST UN VECTEUR D'ENTIERS DIMENSIONNE AU NOMBRE DE
C  MAILLES DU MAILLAGE : V(IMA) : NBPT(MAILLE_IMA)
C  LES MAILLES TARDIVES SONT IGNOREES.
C-----------------------------------------------------------------------

C---- COMMUNS NORMALISES  JEVEUX
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32,JEXNOM,JEXNUM,JEXATR
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C     ------------------------------------------------------------------
      INTEGER IBID,IRET,NBMA,IMA,JCESD,JNBPT,JNBNO,IACNX1,ILCNX1,NBNO
      CHARACTER*1 KBID
      CHARACTER*8 MA
      CHARACTER*19 CEL,CES
C     ------------------------------------------------------------------
      CALL JEMARQ()
      CEL = '&&NBPTCA.CEL'
      CES = '&&NBPTCA.CES'

      CALL DISMOI('F','NOM_MAILLA',LIGREL,'LIGREL',IBID,MA,IBID)
      CALL DISMOI('F','NB_MA_MAILLA',MA,'MAILLAGE',NBMA,KBID,IBID)
      CALL WKVECT(OBNBPT,'V V I',NBMA,JNBPT)
      CALL WKVECT(OBNBNO,'V V I',NBMA,JNBNO)
      CALL JEVEUO(MA//'.CONNEX','L',IACNX1)
      CALL JEVEUO(JEXATR(MA//'.CONNEX','LONCUM'),'L',ILCNX1)

      CALL ALCHML(LIGREL,OPTION,PARAM,'V',CEL,IRET,' ')
      IF (IRET.NE.0) THEN
C       - IL N'Y A RIEN A FAIRE : NBPT(IMA)=0
      ELSE
        CALL CELCES(CEL,'V',CES)
        CALL JEVEUO(CES//'.CESD','L',JCESD)
        DO 10,IMA = 1,NBMA
          ZI(JNBPT-1+IMA) = ZI(JCESD-1+5+4* (IMA-1)+1)
          NBNO = ZI(ILCNX1+IMA) - ZI(ILCNX1-1+IMA)
          ZI(JNBNO-1+IMA) = NBNO
   10   CONTINUE

      END IF


      CALL DETRSD('CHAM_ELEM',CEL)
      CALL DETRSD('CHAM_ELEM_S',CES)

      CALL JEDEMA()
      END
