      SUBROUTINE PJLIGR(MAIL2,NDIM,LIGRMO)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 18/03/2011   AUTEUR BERARD A.BERARD 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
C RESPONSABLE BERARD A.BERARD
C
C
      IMPLICIT NONE
      CHARACTER*8  MAIL2
C
C ----------------------------------------------------------------------
C
C COMMANDE PROJ_CHAMP
C
C PROJECTION DE CHAMPS - CREATION DU LIGREL
C *  *                               ****
C
C ----------------------------------------------------------------------
C
C IN MAIL2  : NOM DU MAILLAGE
C IN NDIM : DIMENSION DU PROBLEME
C OUT LIGRMO : LIGREL CREE
C ----------------------------------------------------------------------
C
C CREATION DU LIGREL DU PSEUDO-MODELE
C
C
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
C
      CHARACTER*32       JEXNUM
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
C
      INTEGER      IMA,NBMA,IBID
      INTEGER      JNBNO,JAD,JLGRF
      CHARACTER*8  K8BID
      CHARACTER*19 LIGRMO
      INTEGER      ITYEL2

      INTEGER IER, JTYPMA, JDIMT, NDIM, NTOT, ICOL
      INTEGER JTYP

      CHARACTER*16 NOMTY

C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()


C
C INITIALISATION DU PSEUDO-LIGREL ASSOCIE AU MAILLAGE
C

C
C --- DESTRUCTION DU LIGREL S'IL EXISTE
C
      CALL DETRSD('LIGREL',LIGRMO)
C
C --- INFO SUR LE MAILLAGE 
C

      CALL DISMOI('F','NB_MA_MAILLA',MAIL2,'MAILLAGE',NBMA,K8BID,IER)
C
C --- CREATION DE .NOMA + ATTRIBUT DOCU
C
      CALL WKVECT(LIGRMO//'.LGRF','V V K8',2,JLGRF)
      ZK8(JLGRF-1+1) = MAIL2
      CALL JEECRA(LIGRMO//'.LGRF','DOCU',IBID,'MECA')
C
C --- CREATION DE L'OBJET .LIEL: ON LE CREE AU MAX. AUTANT DE LIEL
C --- QUE DE MAILLES
C
C --- DANS UN PREMIER PASSAGE, ON DETERMINE NTOT,
C       NOMBRE TOTAL DE MAILLES UTILES

      CALL JEVEUO(MAIL2(1:8)//'.TYPMAIL','L',JTYPMA)

      NTOT=0
      DO 55,IMA = 1,NBMA
        CALL JEVEUO(JEXNUM('&CATA.TM.TMDIM',ZI(JTYPMA-1+IMA)),'L',JDIMT)
        
        IF (ZI(JDIMT).EQ.NDIM) THEN
          NTOT=NTOT+1
        ENDIF

 55   CONTINUE


C
C --- CREATION  COLLECTION
C

      CALL JECREC(LIGRMO//'.LIEL','V V I','NU','CONTIG','VARIABLE',
     &            NTOT)

      CALL JEECRA(LIGRMO//'.LIEL','LONT',2*NTOT,K8BID)


C --- ICOL EST LE COMPTEUR DE REMPLISSAGE DU .LIEL
C --- ON REMPLIT LE .LIEL EN CONTIGU
C       MAIS IMA NE FAIT PAS DU CONTIGU
C       (CAR TRI SUIVANT LA DIMENSION TOPOLOGIQUE)


      ICOL=0

      DO 90 IMA = 1,NBMA

C --- TRI SUR LES MAILLES UTILES

        CALL JEVEUO(MAIL2(1:8)//'.TYPMAIL','L',JTYP)
        CALL JEVEUO(JEXNUM('&CATA.TM.TMDIM',ZI(JTYP-1+IMA)),'L',JDIMT)



        IF (ZI(JDIMT).EQ.NDIM) THEN
          ICOL=ICOL+1
C        ENDIF

        CALL JENUNO(JEXNUM('&CATA.TM.NOMTM',ZI(JTYP-1+IMA)),NOMTY)
        CALL PJTYMA(NDIM, NOMTY, ITYEL2)

C
C --- PAS D'EF AFFECTE SUR LA MAILLE !
C
        IF (ITYEL2.EQ.0) THEN
          CALL U2MESS('F','CALCULEL5_31')
        ELSE


C --- REMPLISSAGE DU LIGREL
C
C --- CREATION OBJET DE LA COLLECTION
C
        CALL JECROC(JEXNUM(LIGRMO//'.LIEL',ICOL))
        CALL JEECRA(JEXNUM(LIGRMO//'.LIEL',ICOL),'LONMAX',2,K8BID)
        CALL JEVEUO(JEXNUM(LIGRMO//'.LIEL',ICOL),'E',JAD)

          ZI(JAD  ) = IMA
          ZI(JAD+1) = ITYEL2

        ENDIF

      ENDIF
C FIN BOUCLE MAILLES UTILES



   90 CONTINUE


C
C --- ADAPTATION DE .LIEL
C

      CALL ADALIG(LIGRMO)

C
C --- PAS DE NOEUDS TARDIFS
C
      CALL WKVECT(LIGRMO//'.NBNO','V V I',1,JNBNO)
      ZI(JNBNO-1+1) = 0
C
C --- CREATION DE L'OBJET .REPE
C
      CALL CORMGI('V',LIGRMO)

C
C --- INITIALISATION DU LIGREL (OBJETS PRNM/PRNS)
C

      CALL INITEL(LIGRMO)

C
C --- AFFICHAGE
C
      CALL JEDEMA()

      END
