      SUBROUTINE PJNGCH(CHAM1Z,CHAM2Z,CORRES,BASE)
      IMPLICIT NONE
      CHARACTER*(*) CHAM1Z,CHAM2Z,CORRES,BASE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 02/02/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE PELLET J.PELLET
C----------------------------------------------------------------------
C BUT : PROJETER UN CHAM_NO D'UN MAILLAGE SUR UN AUTRE POUR LES
C       METHODES NUAGE_DEG_0 ET NUAGE_DEG_1

C ARGUMENTS :
C  CHAM1 : IN/JXIN  CHAMP QUE L'ON VEUT PROJETER
C  CHAM2 : IN/JXOUT CHAMP RESULTAT DE LA PROJECTION
C  CORRES: IN/JXIN  SD_CORRESP_2_MAILLA
C  BASE  : IN    G/V : BASE DE CREATION POUR CHAM2
C----------------------------------------------------------------------
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      CHARACTER*32 JEXNOM,JEXNUM
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER IBID,NX,JXXK1,JNGI1,JNGI2,IEQ,NBOCC,NBEQ,IOC,JVALE
      INTEGER NB1,NB2,IDEC1,IDEC2,JLNO1,JLNO2
      CHARACTER*1 TYPE
      CHARACTER*8 KBID,NOMA1,NOMA2,CNREF,NOMA3,K8
      CHARACTER*16 CORR16,METHOD
      CHARACTER*19 NUAGE1,NUAGE2,CHAM1,CHAM2
      CHARACTER*24 LNO1,LNO2


C----------------------------------------------------------------------
      CALL JEMARQ()
      CORR16=CORRES
      CHAM1=CHAM1Z
      CHAM2=CHAM2Z

      CALL JEVEUO(CORR16//'.PJXX_K1','L',JXXK1)
      NOMA1=ZK24(JXXK1-1+1)
      NOMA2=ZK24(JXXK1-1+2)
      METHOD=ZK24(JXXK1-1+3)
      CNREF=ZK24(JXXK1-1+4)
      CALL ASSERT(METHOD(1:10).EQ.'NUAGE_DEG_')

      CALL CHPVER('F',CHAM1,'NOEU','*',IBID)
      CALL CHPVER('F',CNREF,'NOEU','*',IBID)
      CALL DISMOI('F','NOM_MAILLA',CHAM1,'CHAMP',IBID,NOMA3,IBID)
      CALL ASSERT(NOMA3.EQ.NOMA1)
      CALL DISMOI('F','NOM_MAILLA',CNREF,'CHAMP',IBID,NOMA3,IBID)
      CALL ASSERT(NOMA3.EQ.NOMA2)


C     C'EST LE MAILLAGE MAILLA1 QUI IMPOSE LA DIMENSION D'ESPACE DES
C     DEUX NUAGES :
      NX=3
      CALL DISMOI('F','Z_CST',NOMA1,'MAILLAGE',IBID,K8,IBID)
      IF (K8.EQ.'OUI')NX=2

      CALL JEVEUO(CORR16//'.PJNG_I1','L',JNGI1)
      NBOCC=ZI(JNGI1-1+1)
      IF (NBOCC.GT.0) CALL JEVEUO(CORR16//'.PJNG_I2','L',JNGI2)

C     -- CREATION DE CHAM2 VIERGE :
      CALL COPISD('CHAMP_GD','G',CNREF,CHAM2)
      CALL JELIRA(CHAM2//'.VALE','LONMAX',NBEQ,KBID)
      CALL JELIRA(CHAM2//'.VALE','TYPE',IBID,TYPE)
      CALL ASSERT(TYPE.EQ.'R')
      CALL JEVEUO(CHAM2//'.VALE','E',JVALE)
      IF (TYPE.EQ.'R') THEN
        DO 10 IEQ=0,NBEQ-1
          ZR(JVALE+IEQ)=0.D0
   10   CONTINUE
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF

      NUAGE1='&&NUAGE1'
      NUAGE2='&&NUAGE2'

      IF (NBOCC.GT.0) THEN
        LNO1='&&OP0166.LNO1'
        LNO2='&&OP0166.LNO2'
        IDEC1=1+NBOCC
        IDEC2=1+NBOCC
        DO 20 IOC=1,NBOCC
          NB1=ZI(JNGI1-1+1+IOC)
          NB2=ZI(JNGI2-1+1+IOC)
          CALL WKVECT(LNO1,'V V I',NB1,JLNO1)
          CALL WKVECT(LNO2,'V V I',NB2,JLNO2)
          CALL JACOPO(NB1,'I',JNGI1+IDEC1,JLNO1)
          CALL JACOPO(NB2,'I',JNGI2+IDEC2,JLNO2)

          CALL CHPNUA(NX,CHAM1,LNO1,NUAGE1)
          CALL CHPNUA(NX,CHAM2,LNO2,NUAGE2)
          CALL PRONUA(METHOD,NUAGE1,NUAGE2)
          CALL NUACHP(NUAGE2,LNO2,CHAM2)
          CALL DETRSD('NUAGE',NUAGE1)
          CALL DETRSD('NUAGE',NUAGE2)
          CALL JEDETR(LNO1)
          CALL JEDETR(LNO2)
          IDEC1=IDEC1+NB1
          IDEC2=IDEC2+NB2
   20   CONTINUE

      ELSE
        CALL CHPNUA(NX,CHAM1,' ',NUAGE1)
        CALL CHPNUA(NX,CHAM2,' ',NUAGE2)
        CALL PRONUA(METHOD,NUAGE1,NUAGE2)
        CALL NUACHP(NUAGE2,' ',CHAM2)
        CALL DETRSD('NUAGE',NUAGE1)
        CALL DETRSD('NUAGE',NUAGE2)
      ENDIF

   30 CONTINUE
      CALL JEDEMA()
      END
