      SUBROUTINE PJNGCO(CORRES,NOMA1,NOMA2,METHOD,CNREF,BASE)
      IMPLICIT NONE
      CHARACTER*(*) CORRES,NOMA1,NOMA2,METHOD,CNREF,BASE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 02/02/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE PELLET J.PELLET
C----------------------------------------------------------------------
C BUT : CREER LA SD CORRESP_2_MAILLA SI METHODE='NUAGE_DEG_0/1'

C ARGUMENTS :
C  CORRES : IN/JXOUT  SD_CORRESP_2_MAILLA A CONSTRUIRE
C  NOMA1  : IN/JXIN   SD_MAILLAGE "1"
C  NOMA2  : IN/JXIN   SD_MAILLAGE "2"
C  METHOD : IN        METHODE CHOISIE POUR LA PROJECTION
C  CNREF  : IN/JXIN   SD_CHAM_NO "MODELE"
C  BASE   : IN   G/V  BASE DE CREATION POUR CORRES
C----------------------------------------------------------------------
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      CHARACTER*32 JEXNOM,JEXNUM
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
      CHARACTER*8 NOMA3
      CHARACTER*16 CORR16
      CHARACTER*24 LNO1,LNO2
      CHARACTER*4 NUM,KBID
      CHARACTER*1 BAS1
      INTEGER NBOCC,JNGI1,JNGI2,IOC,JNB12,LON1,LON2,NB1,NB2,IDEC1
      INTEGER IDEC2,JLNO1,JLNO2,JXXK1,IBID
C----------------------------------------------------------------------

      CALL JEMARQ()
      CALL ASSERT(METHOD.EQ.'NUAGE_DEG_0' .OR. METHOD.EQ.'NUAGE_DEG_1')
      CORR16=CORRES
      BAS1=BASE
      CALL ASSERT(BAS1.EQ.'G' .OR. BAS1.EQ.'V')

      CALL WKVECT(CORR16//'.PJXX_K1',BAS1//' V K24',5,JXXK1)
      ZK24(JXXK1-1+1)=NOMA1
      ZK24(JXXK1-1+2)=NOMA2
      ZK24(JXXK1-1+3)=METHOD
      ZK24(JXXK1-1+4)=CNREF

      CALL GETFAC('VIS_A_VIS',NBOCC)
      CALL ASSERT(NBOCC.LE.999)

      CALL DISMOI('F','NOM_MAILLA',CNREF,'CHAMP',IBID,NOMA3,IBID)
      CALL ASSERT(NOMA3.EQ.NOMA2)


      IF (NBOCC.EQ.0) THEN
        CALL WKVECT(CORR16//'.PJNG_I1',BAS1//' V I',1,JNGI1)
        ZI(JNGI1-1+1)=0
        GOTO 50

      ENDIF

C      -- ON CALCULE LES LISTES DE NOEUDS DANS DES LISTES TEMPORAIRES :
      DO 10 IOC=1,NBOCC
        CALL CODENT(IOC,'D0',NUM)
        LNO1='&&PJNGCO.'//NUM//'.LNO1'
        CALL UTNUAV(NOMA1,1,IOC,LNO1)
        LNO2='&&PJNGCO.'//NUM//'.LNO2'
        CALL UTNUAV(NOMA2,2,IOC,LNO2)
   10 CONTINUE


C      -- ON RECOPIE LES LISTES DANS .PJNG_I1/2 :
      CALL WKVECT('&&PJNGCO.NB1NB2','V V I',2*NBOCC,JNB12)
      LON1=0
      LON2=0
      DO 20 IOC=1,NBOCC
        CALL CODENT(IOC,'D0',NUM)
        LNO1='&&PJNGCO.'//NUM//'.LNO1'
        LNO2='&&PJNGCO.'//NUM//'.LNO2'
        CALL JELIRA(LNO1,'LONMAX',NB1,KBID)
        CALL JELIRA(LNO2,'LONMAX',NB2,KBID)
        ZI(JNB12-1+2*(IOC-1)+1)=NB1
        ZI(JNB12-1+2*(IOC-1)+2)=NB2
        LON1=LON1+NB1
        LON2=LON2+NB2
   20 CONTINUE

      CALL WKVECT(CORR16//'.PJNG_I1',BAS1//' V I',1+NBOCC+LON1,JNGI1)
      ZI(JNGI1-1+1)=NBOCC
      CALL WKVECT(CORR16//'.PJNG_I2',BAS1//' V I',1+NBOCC+LON2,JNGI2)
      ZI(JNGI2-1+1)=NBOCC
      IDEC1=1+NBOCC
      IDEC2=1+NBOCC
      DO 30 IOC=1,NBOCC
        CALL CODENT(IOC,'D0',NUM)
        LNO1='&&PJNGCO.'//NUM//'.LNO1'
        LNO2='&&PJNGCO.'//NUM//'.LNO2'
        NB1=ZI(JNB12-1+2*(IOC-1)+1)
        NB2=ZI(JNB12-1+2*(IOC-1)+2)
        CALL JEVEUO(LNO1,'L',JLNO1)
        CALL JEVEUO(LNO2,'L',JLNO2)
        CALL JACOPO(NB1,'I',JLNO1,JNGI1+IDEC1)
        CALL JACOPO(NB2,'I',JLNO2,JNGI2+IDEC2)
        IDEC1=IDEC1+NB1
        IDEC2=IDEC2+NB2
        ZI(JNGI1-1+1+IOC)=NB1
        ZI(JNGI2-1+1+IOC)=NB2
   30 CONTINUE



C        -- MENAGE :
      DO 40 IOC=1,NBOCC
        CALL CODENT(IOC,'D0',NUM)
        LNO1='&&PJNGCO.'//NUM//'.LNO1'
        LNO2='&&PJNGCO.'//NUM//'.LNO2'
        CALL JEDETR(LNO1)
        CALL JEDETR(LNO2)
   40 CONTINUE

   50 CONTINUE
      CALL JEDEMA()
      END
