      SUBROUTINE QINTZZ(MODELE,LIGREL,MATEZ,SIGMAP,SIGMAD,
     &                  SIGNOP,SIGNOD,RESU)
      IMPLICIT NONE
      CHARACTER*(*) MODELE,LIGREL,MATEZ,SIGMAP,SIGMAD
      CHARACTER*(*) SIGNOP,SIGNOD,RESU
      CHARACTER*6   CHTEMP
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 08/11/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2006  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
C     BUT:
C         CALCUL DE L'ESTIMATEUR D'ERREUR QUANTITE D'INTERET AVEC LA
C         METHODE DE ZHU-ZIENKIEWICZ.
C
C                 OPTION : 'ERRE_QIZZ'
C
C
C     ARGUMENTS:
C     ----------
C
C      ENTREE :
C-------------
C IN   MODELE : NOM DU MODELE
C IN   MATEZ  : NOM DU CONCEPT MATERIAU
C IN   CHTEMP : NOM DU CHAMP DE TEMPERATURE
C IN   SIGMAP : NOM DU CHAMP DE CONTRAINTES PB.PRIMAL (CHAM_ELEM_SIEF_R)
C IN   SIGMAD : NOM DU CHAMP DE CONTRAINTES PB.DUAL (CHAM_ELEM_SIEF_R)
C IN   SIGNOP : NOM DU CHAMP DE CONTRAINTES LISSEES POUR LE PB. PRIMAL
C IN   SIGNOD : NOM DU CHAMP DE CONTRAINTES LISSEES POUR LE PB. DUAL
C
C
C      SORTIE :
C-------------
C OUT  RESU   : NOM DU CHAM_ELEM_ERREUR PRODUIT
C               SI RESU EXISTE DEJA, ON LE DETRUIT.
C
C ......................................................................

      INTEGER IBID

      CHARACTER*8 LCHAR,LPAIN(7),LPAOUT(1),K8BID
      CHARACTER*16 OPTION
      CHARACTER*24 LCHIN(7),LCHOUT(1),CHGEOM,MATE

      LOGICAL EXIGEO

      COMPLEX*16 CBID

C DEB-------------------------------------------------------------------
C
      CHTEMP = '&&TEMP'
      CALL MECACT('V',CHTEMP,'LIGREL',LIGREL,'TEMP_R',1,'TEMP',
     &                                        IBID,0.0D0,CBID,K8BID)

      MATE = MATEZ
      LCHAR = ' '
      CALL MEGEOM(MODELE,LCHAR,EXIGEO,CHGEOM)
      IF (.NOT.EXIGEO) CALL U2MESS('F','CALCULEL2_81')

      IF (MATE.EQ.' ') CALL U2MESS('F','CALCULEL4_66')

      LPAIN(1) = 'PGEOMER'
      LCHIN(1) = CHGEOM
      LPAIN(2) = 'PMATERC'
      LCHIN(2) = MATE
      LPAIN(3) = 'PSIEFP_R'
      LCHIN(3) = SIGMAP
      LPAIN(4) = 'PSIEFD_R'
      LCHIN(4) = SIGMAD
      LPAIN(5) = 'PTEMPER'
      LCHIN(5) = CHTEMP
      LPAIN(6) = 'PSIGMAP'
      LCHIN(6) = SIGNOP
      LPAIN(7) = 'PSIGMAD'
      LCHIN(7) = SIGNOD

      LPAOUT(1) = 'PERREUR'
      LCHOUT(1) = RESU
      OPTION = 'ERRE_QIZZ'
      CALL CALCUL('S',OPTION,LIGREL,7,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'G',
     &               'OUI')

   10 CONTINUE
      END
