      SUBROUTINE RESTHE(LIGREL,EVOL,CHTEMM,CHTEMP,CHFLUM,
     &  CHFLUP,MATE,VALTHE,INSOLD,INST,RESU,NIVEAU,IFM,NIV,MA,
     &  CARTEF,NOMGDF,CARTEH,NOMGDH,CARTET,NOMGDT,CARTES,NOMGDS,
     &  CHGEOM,CHSOUR,PSOURC,IAUX)
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 07/12/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE  BOITEAU O.BOITEAU
C TOLE CRP_21
C-----------------------------------------------------------------------
C    - FONCTION REALISEE:  CALCUL DE L'ESTIMATEUR D'ERREUR EN RESIDU
C                          SUR LE PROBLEME THERMIQUE
C
C
C     LES NOMS QUI SUIVENT SONT LES PREFIXES UTILISATEUR K8:
C IN LIGREL : NOM DU LIGREL
C IN EVOL   : LOGICAL=TRUE SI CALCUL TRANSITOIRE, FALSE SINON
C IN CHTEMM : NOM DU CHAMP DE TEMPERATURE A T-
C IN CHTEMP : NOM DU CHAMP DE TEMPERATURE A T+
C IN CHFLUM : NOM DU CHAMP DU FLUX DE TEMPERATURE A T-
C IN CHFLUP : NOM DU CHAMP DU FLUX DE TEMPERATURE A T+
C IN MATE   : NOM DU CONCEPT CHAMP_MATERIAU
C IN VALTHE : VALEUR DU PARAMETRE THETA
C IN INSOLD : INSTANT CORRESPONDANT AU CALCUL PRECEDENT
C IN INST   : INSTANT CORRESPONDANT AU CALCUL ACTUEL
C IN NIVEAU : NIVEAU DE CALCUL DE L'ESTIMATEUR
C IN IFM/NIV: NIVEAU IMPRESSION
C IN MA     : NOM DU MAILLAGE
C IN CARTEF/NOMGDF: INFO SUR LE FLUX RETENU
C IN CARTEH/NOMGDH: INFO SUR L'ECHANGE RETENU
C IN CARTET/NOMGDT: INFO SUR LA TEMP_EXT RETENUE
C IN CARTES/NOMGDS: INFO SUR LA SOURCE RETENUE
C IN CHGEOM : CHAMP GEOMETRIE
C IN CHSOUR : CHAMP SOURCE
C IN PSOURC : NOM DU PARAMETRE ASSOCIE A SOURCE
C IN IAUX   : NUME_ORDRE
C OUT RESU   : NOM DU CHAM_ELEM_ERREUR PRODUIT
C              SI RESU EXISTE DEJA,ON LE DETRUIT.
C
C   -------------------------------------------------------------------
C     SUBROUTINES APPELLEES:
C       JEVEUX:JEMARQ,JEDEMA,JEDETR,MEGEOM,DISMOI,EXISD,ETENCA,MECACT,
C              JEVEUO,JELIRA,JEXNUM,WKVECT.
C       ELEMENTS FINIS:CALCUL,RESVOI.
C
C     FONCTIONS INTRINSEQUES:
C       AUCUNE.
C   -------------------------------------------------------------------
C     ASTER INFORMATIONS:
C       22/06/01 (OB): CREATION EN S'INSPIRANT DE RESLOC.F.
C       22/08/02 (OB): MODIFICATION DU A SEPARATION DE RESTHE, EN UNE
C          PARTIE PRELIMINAIRE (RESTH2) HORS DE LA BOUCLE EN TEMPS ET
C          UNE PARTIE (RESTHE) CALCUL DEPENDANT DU TEMPS.
C          RAJOUT DE L'OBJET '&&RESTHE.JEVEUO' POUR AMELIORER LES
C          PERFORMANCES DE RESTHE/CALCUL/TE0003.
C----------------------------------------------------------------------
C CORPS DU PROGRAMME
      IMPLICIT NONE

C DECLARATION PARAMETRES D'APPELS
      INTEGER      NIVEAU,IFM,NIV,IAUX
      REAL*8       VALTHE,INSOLD,INST
      LOGICAL      EVOL
      CHARACTER*8  MA,PSOURC
      CHARACTER*19 CARTEF,CARTEH,CARTET,CARTES,NOMGDF,NOMGDH,NOMGDT,
     &             NOMGDS
      CHARACTER*24 CHTEMM,CHTEMP,CHFLUM,CHFLUP,RESU,LIGREL,MATE,CHGEOM,
     &             CHSOUR

C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------

C DECLARATION VARIABLES LOCALES
      INTEGER NBCMP,NBIN,NBOUT,ICMP,IAREPE,MCELD,MCELV,PCELD,PCELV,
     &        IGD,IADEF,IAVAF,NCMPF,IADEH,IAVAH,NCMPH,NCMPT,IADET,IAVAT,
     &        NBJEVE,IJEVEO
      CHARACTER*1 BASE
      CHARACTER*8 LPAIN(9),LPAOUT(1),LICMP(19)
      CHARACTER*19 KBID
      CHARACTER*24 LCHIN(9),LCHOUT(1),KCMP(19),CHAREV
      CHARACTER*32 JEXNUM
      REAL*8 RCMP
      COMPLEX*16 CCMP

      CALL JEMARQ()

C RECHERCHE DES ADRESSES POUR OBTENIR FLUXM/P SUR LES VOISINS
      CALL JEVEUO(LIGREL(1:19)//'.REPE','L',IAREPE)

      IF (IAUX.GT.1) THEN
        CALL JEVEUO(CHFLUM(1:19)//'.CELD','L',MCELD)
        CALL JEVEUO(CHFLUM(1:19)//'.CELV','L',MCELV)
      ENDIF
      CALL JEVEUO(CHFLUP(1:19)//'.CELD','L',PCELD)
      CALL JEVEUO(CHFLUP(1:19)//'.CELV','L',PCELV)

C RECHERCHE DES ADRESSES POUR LES CHARGES SUR LES SEGMENTS ET DE
C LEURS NOMBRES DE COMPOSANTES AU NIVEAU INFO (GRANDEUR PREMIERE)
      IF (CARTEF.NE.' ') THEN
        CALL JEVEUO(CARTEF//'.DESC','L',IADEF)
        CALL JEVEUO(CARTEF//'.VALE','L',IAVAF)
        IGD = ZI(IADEF)
        CALL JELIRA(JEXNUM('&CATA.GD.NOMCMP',IGD),'LONMAX',NCMPF,KBID)
      ENDIF
      IF (CARTEH.NE.' ') THEN
        CALL JEVEUO(CARTEH//'.DESC','L',IADEH)
        CALL JEVEUO(CARTEH//'.VALE','L',IAVAH)
        IGD = ZI(IADEH)
        CALL JELIRA(JEXNUM('&CATA.GD.NOMCMP',IGD),'LONMAX',NCMPH,KBID)
        CALL JEVEUO(CARTET//'.DESC','L',IADET)
        CALL JEVEUO(CARTET//'.VALE','L',IAVAT)
        IGD = ZI(IADET)
        CALL JELIRA(JEXNUM('&CATA.GD.NOMCMP',IGD),'LONMAX',NCMPT,KBID)
      ENDIF

C STOCKAGE DE CES DONNEES DANS UN VECTEUR D'ENTIER DONT LE NOM SERA
C TRANSMIS VIA LA CARTE
      NBJEVE = 14
      CALL WKVECT('&&RESTHE.JEVEUO',' V V I',NBJEVE,IJEVEO)
      ZI(IJEVEO) = NIVEAU
      ZI(IJEVEO+1) = IFM
      ZI(IJEVEO+2) = NIV
      ZI(IJEVEO+3) = IAREPE
      ZI(IJEVEO+4) = MCELD
      ZI(IJEVEO+5) = MCELV
      ZI(IJEVEO+6) = PCELD
      ZI(IJEVEO+7) = PCELV
      ZI(IJEVEO+8) = IAVAF
      ZI(IJEVEO+9) = NCMPF
      ZI(IJEVEO+10) = IAVAH
      ZI(IJEVEO+11) = NCMPH
      ZI(IJEVEO+12) = IAVAT
      ZI(IJEVEO+13) = NCMPT

C CONSTITUTION DES CARTES REPRESENTANT LES CHARGEMENTS SURFACIQUES---
C LA REPRESENTATION DE DONNEES PAR CARTE PERMETTANT DE TRANSFERER DES
C DONNEES GLOBALES AU NIVEAU DES CALCULS ELEMENTAIRES.
C NBRE ET VECTEURS DES COMPOSANTES DE LA CARTE
C CALCULS PRELIMINAIRES
      NBCMP = 19
      IF (EVOL) THEN
        CHAREV = 'EVOL'
      ELSE
        CHAREV = ' '
      ENDIF
      LICMP(1) = 'Z1'
      LICMP(2) = 'Z2'
      LICMP(3) = 'Z3'
      LICMP(4) = 'Z4'
      LICMP(5) = 'Z5'
      LICMP(6) = 'Z6'
      LICMP(7) = 'Z7'
      LICMP(8) = 'Z8'
      LICMP(9) = 'Z9'
      LICMP(10) = 'Z10'
      LICMP(11) = 'Z11'
      LICMP(12) = 'Z12'
      LICMP(13) = 'Z13'
      LICMP(14) = 'Z14'
      LICMP(15) = 'Z15'
      LICMP(16) = 'Z16'
      LICMP(17) = 'Z17'
      LICMP(18) = 'Z18'
      LICMP(19) = 'Z19'
      KCMP(1) = MA
      KCMP(2) = LIGREL
      KCMP(3) = CHFLUM
      KCMP(4) = CHFLUP
      KCMP(5) = CARTEF
      KCMP(6) = NOMGDF
      KCMP(7) = CARTEH
      KCMP(8) = NOMGDH
      KCMP(9) = CARTET
      KCMP(10) = NOMGDT
      KCMP(11) = CARTES
      KCMP(12) = NOMGDS
      WRITE(KCMP(13),'(F19.8)')VALTHE
      WRITE(KCMP(14),'(F19.8)')INSOLD
      WRITE(KCMP(15),'(F19.8)')INST
      KCMP(16) = CHAREV
      WRITE(KCMP(17),'(I24)')IJEVEO
C DEUX DERNIERES COMPOSANTES REDONDANTES POUR PLUS TARD
      KCMP(18) = MA
      KCMP(19) = MA


C CARTE NOMMEE &&RESTHER.CHARGE SUR LE MODELE LIGREL.
      BASE = 'V'
      CALL MECACT(BASE,'&&RESTHER.CHARGE','MODELE',LIGREL,'NEUT_K24',
     &            NBCMP,LICMP,ICMP,RCMP,CCMP,KCMP)

C LANCEMENT DES CALCULS ELEMENTAIRES-----------------------------------
      LPAIN(1) = 'PGEOMER'
      LCHIN(1) =  CHGEOM
      LPAIN(2) = 'PFLUX_M'
      LCHIN(2) =  CHFLUM
      LPAIN(3) = 'PFLUX_P'
      LCHIN(3) =  CHFLUP
      LPAIN(4) =  PSOURC
      LCHIN(4) =  CHSOUR
      LPAIN(5) = 'PMATERC'
      LCHIN(5) =  MATE
      LPAIN(6) = 'PCHARG'
      LCHIN(6) = '&&RESTHER.CHARGE'
      LPAIN(7) = 'PVOISIN'
      LCHIN(7) = '&&RESTHER.VOISIN'
      LPAIN(8) = 'PTEMP_M'
      LCHIN(8) =  CHTEMM
      LPAIN(9) = 'PTEMP_P'
      LCHIN(9) =  CHTEMP
      NBIN = 9

      LPAOUT(1) = 'PERREUR'
      LCHOUT(1) =  RESU
      NBOUT = 1

      CALL CALCUL('S','ERTH_ELEM',LIGREL,NBIN,LCHIN,LPAIN,NBOUT,LCHOUT,
     &             LPAOUT,'G','OUI')

      CALL JEDETR('&&RESTHE.JEVEUO')
      CALL JEDEMA()

      END
