      SUBROUTINE TECAEL(IADZI,IAZK24)
      IMPLICIT NONE

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 28/07/2008   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE                            VABHHTS J.PELLET
C     ARGUMENTS:
C     ----------
      INTEGER IADZI,IAZK24
C     -----------------------------------------------------------------
C     SORTIES:
C     IADZI EST L'ADRESSE D'UN VECTEUR D'ENTIERS  CONTENANT :
C     DIM(V)=4+NBNO
C        V(1) : NUMERO DE LA MAILLE
C        V(2) : NOMBRE DE NOEUDS DE LA MAILLE (NBNO)
C        V(2+   1) : NUMERO DU 1ER NOEUD DE LA MAILLE
C        ...
C        V(2+NBNO) : NUMERO DU DER NOEUD DE LA MAILLE
C        V(2+NBNO +1) : NUMERO DU GREL
C        V(2+NBNO +2) : NUMERO DE L'ELEMENT DANS LE GREL

C     IAZK24 EST L'ADRESSE D'UN VECTEUR DE K24 CONTENANT :
C     DIM(V)=8+NBNO
C        V(1) : NOM DU MAILLAGE       (K8)
C        V(2) : NOM DU LIGREL         (K19)
C        V(3) : NOM DE LA MAILLE      (K8)
C        V(3  +1) : NOM DU 1ER NOEUD DE LA MAILLE (K8)
C        ...
C        V(3+NBNO) : NOM DU DER NOEUD DE LA MAILLE (K8)
C        V(3+NBNO+1): TYPE_ELEMENT(K16)
C        V(3+NBNO+2): OPTION QUE L'ON CALCULE (K16)
C        V(3+NBNO+3): TYPE_MAILLE ASSOCIE AU TYPE_ELEMENT(K8)
C        V(3+NBNO+4): PHENOMENE ASSOCIE AU TYPE_ELEMENT(K16)
C        V(3+NBNO+5): NOM DE LA MODELISATION ASSOCIEE AU
C                     TYPE_ELEMENT(K16)

C    REMARQUE :
C   SI LA MAILLE EST TARDIVE SON NOM EST CONVENTIONELLEMENT : ' '
C   SI UN NOEUD EST TARDIF   SON NOM EST CONVENTIONELLEMENT : ' '


C     -----------------------------------------------------------------

      INTEGER        NBGR,IGR,NBELGR,JCTEAT,LCTEAT,IAWLOC,IAWLO2,IAWTYP
      COMMON /CAII06/NBGR,IGR,NBELGR,JCTEAT,LCTEAT,IAWLOC,IAWLO2,IAWTYP
      COMMON /CAII08/IEL
      COMMON /CAII10/ICAELI,ICAELK
      COMMON /CAII03/IAMACO,ILMACO,IAMSCO,ILMSCO,IALIEL,ILLIEL

      CHARACTER*16 OPTION,NOMTE,NOMTM,PHENO,MODELI
      COMMON /CAKK01/OPTION,NOMTE,NOMTM,PHENO,MODELI
      INTEGER IALIEL,IAMACO,IAMSCO,ICAELI,ICAELK,IEL,ILLIEL,ILMACO
      INTEGER ILMSCO,IMA,INO,NNO,NUNO

C---------------- COMMUNS NORMALISES  JEVEUX  --------------------------
      CHARACTER*32 JEXNUM
      COMMON /IVARJE/ZI(1)
      COMMON /RVARJE/ZR(1)
      COMMON /CVARJE/ZC(1)
      COMMON /LVARJE/ZL(1)
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      INTEGER ZI
      REAL*8 ZR
      COMPLEX*16 ZC
      LOGICAL ZL
      CHARACTER*8 ZK8,MA,NOMMA,NOMNO
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
C ---------------- FIN COMMUNS NORMALISES  JEVEUX  --------------------


C     RECUPERATION DU NUMERO DE LA MAILLE ET DU NOMBRE DE NOEUDS :
C     ------------------------------------------------------------
      MA = ZK24(ICAELK-1+1)

      IMA = ZI(IALIEL-1+ZI(ILLIEL+IGR-1)+IEL-1)
      IF (IMA.GT.0) THEN
        NNO = ZI(ILMACO-1+IMA+1) - ZI(ILMACO-1+IMA)
        ZI(ICAELI-1+1) = IMA
        ZI(ICAELI-1+2) = NNO
        CALL JENUNO(JEXNUM(MA//'.NOMMAI',IMA),NOMMA)
        ZK24(ICAELK-1+3) = NOMMA
      ELSE
        NNO = ZI(ILMSCO-1-IMA+1) - ZI(ILMSCO-1-IMA) - 1
        ZI(ICAELI-1+1) = IMA
        ZI(ICAELI-1+2) = NNO
        ZK24(ICAELK-1+3) = ' '
      END IF

      ZK24(ICAELK-1+3+NNO+1) = NOMTE
      ZK24(ICAELK-1+3+NNO+2) = OPTION
      ZK24(ICAELK-1+3+NNO+3) = NOMTM
      ZK24(ICAELK-1+3+NNO+4) = PHENO
      ZK24(ICAELK-1+3+NNO+5) = MODELI

C     RECUPERATION DES NUMEROS GLOBAUX DES NOEUDS :
C     ---------------------------------------------
      DO 10,INO = 1,NNO
        IF (IMA.GT.0) THEN
          NUNO = ZI(IAMACO-1+ZI(ILMACO+IMA-1)+INO-1)
        ELSE
          NUNO = ZI(IAMSCO-1+ZI(ILMSCO-IMA-1)+INO-1)
        END IF
        ZI(ICAELI-1+2+INO) = NUNO

        IF (NUNO.GT.0) THEN
          CALL JENUNO(JEXNUM(MA//'.NOMNOE',NUNO),NOMNO)
          ZK24(ICAELK-1+3+INO) = NOMNO
        ELSE
          ZK24(ICAELK-1+3+INO) = ' '
        END IF
   10 CONTINUE

      ZI(ICAELI-1+2+NNO+1) = IGR
      ZI(ICAELI-1+2+NNO+2) = IEL

      IADZI = ICAELI
      IAZK24 = ICAELK

   20 CONTINUE

      END
