      SUBROUTINE UTINTC(ZRINO2,ZRINO1,ZRJNO2,ZRJNO1,X3,Y3,INST,INSOLD,
     &                  K8CART,LTHETA,NSOMM,VALFP,VALFM,IFM,NIV,OPTION)
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 11/02/2002   AUTEUR BOITEAU O.BOITEAU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C RESPONSABLE BOITEAU O.BOITEAU
C-----------------------------------------------------------------------
C    - FONCTION REALISEE:  UTILITAIRE D'INTERPOLATION 2D DE CHARGE 
C                          POUR AERER TE0003
C
C   COORDONNEES POINTS D'INTERPOLATION
C IN ZRINO2/1 : ABSCISSE/ORDONNEE POINT DE DEPART DE L'ARETE INO
C IN ZRJNO2/1 : ABSCISSE/ORDONNEE POINT EXTREME DE L'ARETE JNO
C IN X3/Y3    : ABSCISSE/ORDONNEE POINT MILIEU DE L'ARETE MNO
C IN INST/INSOLD : INSTANT + / INSTANT -
C IN K8CART   : CHAMP JEVEUX A INTERPOLER
C IN LTHETA   : LOGICAL = TRUE SI THETA DIFFERENT DE 1
C IN NSOMM    : INDICATEUR DU NOMBRE DE SOMMETS PAR ARETE
C IN IFM/NIV/OPTION  : PARAMETRES D'AFFICHAGE
C OUT VALFP/M : VALEUR DU CHAMP RESULTAT AU INSTANTS +/- ET
C               AUX POINTS CI-DESSUS
C   -------------------------------------------------------------------
C     SUBROUTINES APPELLEES:
C       FOINTE.
C
C     FONCTIONS INTRINSEQUES:
C       AUCUNE.
C   -------------------------------------------------------------------
C     ASTER INFORMATIONS:
C       03/07/01 (OB): CREATION POUR SIMPLIFIER TE0003.F.
C----------------------------------------------------------------------
C CORPS DU PROGRAMME
      IMPLICIT NONE

C DECLARATION PARAMETRES D'APPELS
      INTEGER NSOMM,IFM,NIV,OPTION
      REAL*8 ZRINO2,ZRINO1,ZRJNO2,ZRJNO1,X3,Y3,INST,INSOLD,VALFP(9),
     &       VALFM(9)
      CHARACTER*8 K8CART
      LOGICAL LTHETA
      
C DECLARATION VARIABLES LOCALES
      INTEGER ICODE
      REAL*8 VALPAR(3)
      CHARACTER*8 NOMPAR(3) 

C INIT
      NOMPAR(1) = 'X'
      NOMPAR(2) = 'Y'
      NOMPAR(3) = 'INST'
      
C INTERPOLATION CHAMP K8CART A L'INSTANT +     
      VALPAR(1) = ZRINO2
      VALPAR(2) = ZRINO1
      VALPAR(3) = INST
      CALL FOINTE('FM',K8CART,3,NOMPAR,VALPAR,VALFP(1),ICODE)
      VALPAR(1) = ZRJNO2
      VALPAR(2) = ZRJNO1
      CALL FOINTE('FM',K8CART,3,NOMPAR,VALPAR,VALFP(2),ICODE)
      IF (NSOMM.EQ.3) THEN
        VALPAR(1) = X3
        VALPAR(2) = Y3
        CALL FOINTE('FM',K8CART,3,NOMPAR,VALPAR,VALFP(3),ICODE)
      ENDIF
      IF (LTHETA) THEN

C INTERPOLATION CHAMP K8CART A L'INSTANT -    
        VALPAR(1) = ZRINO2
        VALPAR(2) = ZRINO1
        VALPAR(3) = INSOLD
        CALL FOINTE('FM',K8CART,3,NOMPAR,VALPAR,VALFM(1),ICODE)
        VALPAR(1) = ZRJNO2
        VALPAR(2) = ZRJNO1
        CALL FOINTE('FM',K8CART,3,NOMPAR,VALPAR,VALFM(2),ICODE)
        IF (NSOMM.EQ.3) THEN
          VALPAR(1) = X3
          VALPAR(2) = Y3
          CALL FOINTE('FM',K8CART,3,NOMPAR,VALPAR,VALFM(3),
     &                ICODE)
        ENDIF
      ENDIF
      
C AFFICHAGES
      IF (NIV.EQ.2) THEN
        IF (NSOMM.EQ.3) THEN
          WRITE(IFM,*)' X    ',ZRINO2,ZRJNO2,X3
          WRITE(IFM,*)' Y    ',ZRINO1,ZRJNO1,Y3
          IF (OPTION.EQ.1) THEN
            WRITE(IFM,*)' VALFP ',VALFP(1),VALFP(2),VALFP(3)
          ELSE IF (OPTION.EQ.2) THEN
            WRITE(IFM,*)' VALHP ',VALFP(1),VALFP(2),VALFP(3)
          ELSE
            WRITE(IFM,*)' VALTP ',VALFP(1),VALFP(2),VALFP(3)
          ENDIF
          IF (LTHETA) WRITE(IFM,*)'     M ',
     &      VALFM(1),VALFM(2),VALFM(3)
        ELSE
          WRITE(IFM,*)' X    ',ZRINO2,ZRJNO2
          WRITE(IFM,*)' Y    ',ZRINO1,ZRJNO1
          IF (OPTION.EQ.1) THEN
            WRITE(IFM,*)' VALFP ',VALFP(1),VALFP(2)
          ELSE IF (OPTION.EQ.2) THEN
            WRITE(IFM,*)' VALHP ',VALFP(1),VALFP(2)
          ELSE
            WRITE(IFM,*)' VALTP ',VALFP(1),VALFP(2)
          ENDIF
          IF (LTHETA) WRITE(IFM,*)'     M ',VALFM(1),VALFM(2)
        ENDIF          
      ENDIF
      
      END
