      SUBROUTINE UTNBNV(TYPMAV,NBSV,NBNV)
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 08/02/2008   AUTEUR MACOCCO K.MACOCCO 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE BOITEAU O.BOITEAU
C-----------------------------------------------------------------------
C    - FONCTION REALISEE:  UTILITAIRE CALCULANT LE TYPE DE FACE VOISINE
C                          ET SON NBRE DE SOMMETS. POUR AERER TE0003
C
C IN TYPMAV  : NOM DE LA MAILLE VOISINE.
C OUT NBSV   : TYPE DE MAILLE VOISINE (POUR 2D, TRAITEMENT MAILLE SYM.).
C OUT NBNV   : NOMBRE DE NOEUDS.
C   -------------------------------------------------------------------
C
C     FONCTIONS INTRINSEQUES:
C       AUCUNE.
C   -------------------------------------------------------------------
C     ASTER INFORMATIONS:
C       25/09/01 (OB): CREATION POUR SIMPLIFIER TE0003.F.
C----------------------------------------------------------------------
C CORPS DU PROGRAMME
      IMPLICIT NONE

C DECLARATION PARAMETRES D'APPELS
      INTEGER NBNV,NBSV
      CHARACTER*8 TYPMAV

C DECLARATION VARIABLES LOCALES
      CHARACTER*1 NOEUV
      CHARACTER*2 FORMV

C INIT.
      FORMV = TYPMAV(1:2)
      NOEUV = TYPMAV(5:5)

C DETERMINATION DE NBNV ET NBSV (EN 2D)

C TRIANGLE
      IF ((FORMV.EQ.'TR').OR.(FORMV.EQ.'TL')) THEN
        NBSV = 3
        CALL ASSERT(NOEUV.EQ.'3'.OR.NOEUV.EQ.'6')
        IF ( NOEUV.EQ.'3') THEN
          NBNV = 3
        ELSE IF ( NOEUV.EQ.'6') THEN
          NBNV = 6
        ENDIF
C QUADRANGLE
      ELSE IF ((FORMV.EQ.'QU').OR.(FORMV.EQ.'QL')) THEN
        NBSV = 4
        CALL ASSERT(NOEUV.EQ.'4'.OR.NOEUV.EQ.'8'.OR.NOEUV.EQ.'9')
        IF ( NOEUV.EQ.'4') THEN
          NBNV = 4
        ELSE IF ( NOEUV.EQ.'8') THEN
          NBNV = 8
        ELSE IF (NOEUV.EQ.'9') THEN
          NBNV = 9
        ENDIF
C HEXAEDRE
      ELSE IF ( FORMV.EQ.'HE') THEN
        CALL ASSERT(TYPMAV(5:5).EQ.'8'.OR.TYPMAV(5:6).EQ.'20'.
     &              OR.TYPMAV(5:6).EQ.'27')
        IF (TYPMAV(5:5).EQ.'8') THEN
          NBNV = 8
        ELSE IF (TYPMAV(5:6).EQ.'20') THEN
          NBNV = 20
        ELSE IF (TYPMAV(5:6).EQ.'27') THEN
          NBNV = 27
        ENDIF
C PENTAEDRE
      ELSE IF ( FORMV.EQ.'PE') THEN
        CALL ASSERT(TYPMAV(6:6).EQ.'6'.OR.TYPMAV(6:7).EQ.'15')
        IF (TYPMAV(6:6).EQ.'6') THEN
          NBNV = 6
        ELSE IF (TYPMAV(6:7).EQ.'15') THEN
          NBNV = 15
        ENDIF
C TETRAEDRE
      ELSE IF ( FORMV.EQ.'TE') THEN
        CALL ASSERT(TYPMAV(6:6).EQ.'4'.OR.TYPMAV(6:7).EQ.'10')
        IF (TYPMAV(6:6).EQ.'4') THEN
          NBNV = 4
        ELSE IF (TYPMAV(6:7).EQ.'10') THEN
          NBNV = 10
        ENDIF
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF

      END
