      SUBROUTINE UTVOIS(TYPMAC,LMAJ,NBF,NSOMF,POINC1,POINC2,
     &                  ELREFE,NDEGRE)
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 29/09/2009   AUTEUR GNICOLAS G.NICOLAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE BOITEAU O.BOITEAU
C TOLE CRP_21
C-----------------------------------------------------------------------
C    - FONCTION REALISEE:  CALCUL DES CARACTERISTIQUES DES MAILLES
C                          VOISINES POUR AERER TE0003 ET RECUPERATION
C                          DES ADRESSES JEVEUX DE LEUR GEOMETRIE/FFORME
C
C IN TYPMAC  : TYPE DE L'ELEMENT COURANT.
C IN LMAJ    : FLAG EGALE A TRUE SI ON A UNE SOURCE NON NULLE.
C OUT NBF    : NBRE D'ARETES (EN 2D) OU DE FACES (EN 3D)
C OUT NSOMF  : NBRE DE NOEUDS SOMMETS DE L'ARETE (EN 2D) OU DE(S)
C              (LA) FACE(S) (EN 3D).
C OUT POINC1/2 : POIDS DE NEWTON-COTES (POUR LES ARETES EN 2D)
C OUT ELREFE : TYPE D'ARETES OU DE(S) FACE(S)
C OUT NDEGRE   : DEGRE D'INTERPOLATION
C   -------------------------------------------------------------------
C     SUBROUTINES APPELLEES:
C       JEVEUX: JEEXIN,JEVEUO.
C     FONCTIONS INTRINSEQUES:
C       AUCUNE.
C   -------------------------------------------------------------------
C     ASTER INFORMATIONS:
C       20/09/01 (OB): CREATION POUR SIMPLIFIER TE0003.F.
C       05/02/02 (OB): EXTENSION AUX EFS LUMPES.
C       03/07/09 (GN): DEPLACEMENT DU 3D
C----------------------------------------------------------------------
C CORPS DU PROGRAMME
      IMPLICIT NONE

C DECLARATION PARAMETRES D'APPELS
      INTEGER NBF,NSOMF,NDEGRE
      REAL*8 POINC1,POINC2
      LOGICAL LMAJ
      CHARACTER*8 ELREFE,TYPMAC

C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------

C DECLARATION VARIABLES LOCALES
      CHARACTER*1 NOEU
      CHARACTER*2 FORM

      ELREFE = '        '
C               12345678
C
C CAS 2D
C
        FORM = TYPMAC(1:2)
C CALCUL NBRE ARETES
        CALL ASSERT(FORM.EQ.'TR'.OR.FORM.EQ.'QU')
        IF (FORM.EQ.'TR') THEN
          NBF = 3
        ELSE IF (FORM.EQ.'QU') THEN
          NBF = 4
        ENDIF
        NOEU = TYPMAC(5:5)
C CALCUL NBRE SOMMETS ARETES ET POIDS DE NEWTON-COTES DE L'ARETE
        CALL ASSERT(NOEU.EQ.'6' .OR. NOEU.EQ.'8' .OR. NOEU.EQ.'9'.OR.
     &              NOEU.EQ.'3' .OR. NOEU.EQ.'4')
        IF (NOEU.EQ.'6' .OR. NOEU.EQ.'8' .OR. NOEU.EQ.'9') THEN
          NSOMF = 3
          NDEGRE = 2
          ELREFE = 'SEG3  '
C INIT. POIDS DE NEWTON-COTES (POINTS EXTREMES 1/POINT CENTRAL 2)
          POINC1 = 1.D0/3.D0
          POINC2 = 4.D0/3.D0
        ELSE IF (NOEU.EQ.'3' .OR. NOEU.EQ.'4') THEN
          NSOMF = 2
          NDEGRE = 1
          ELREFE = 'SEG2  '
          POINC1 = 1.D0
          POINC2 = 0.D0
        ENDIF
C

C MAUVAIS CALCUL EN P1 SI FORCE VOLUMIQUE NON NULLE
      IF ((NDEGRE.EQ.1).AND.LMAJ) CALL U2MESS('A','CALCULEL5_34')
      END
