      SUBROUTINE VETRTH(MODELE,CHARGE,INFCHA,CARELE,MATE,INST,CHTN,CHTI,
     &                  CHLAPM,CHLAPP,VERES)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 08/11/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*24 MODELE,CHARGE,INFCHA,CARELE,INST,CHTN,CHTI,CHLAPM,
     &             CHLAPP,VERES,MATE
C ----------------------------------------------------------------------
C CALCUL DES VECTEURS ELEMENTAIRES - SECOND MEMBRE DU PROBLEME TRANSPORT
C                                    EN THERMIQUE NON LINEAIRE -

C IN  MODELE  : NOM DU MODELE
C IN  CHARGE  : LISTE DES CHARGES
C IN  INFCHA  : INFORMATIONS SUR LES CHARGES
C IN  CARELE  : CHAMP DE CARA_ELEM
C IN  MATE    : CHAMP DE MATERIAU
C IN  INST    : CARTE CONTENANT LA VALEUR DU TEMPS ET AUTRES PARAMETRES
C IN  CHTN    : CHAMP DE TEMPERATURE A L'INSTANT PRECEDENT
C IN  CHTI    : I EME ITERE DU CHAMP DE TEMPERATURE
C IN  CHLAPM  : I EME ITERE DU CHAMP DES FONCTIONS ENTHALPIE
C OUT CHLAPP  : I+1 EME ITERE DU CHAMP DES FONCTIONS ENTHALPIE
C OUT VERES   : VECTEURS ELEMENTAIRES (SECOND MEMBRE)

C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------

      CHARACTER*32 JEXNUM,JEXNOM,JEXR8,JEXATR
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
      CHARACTER*1 C1
      CHARACTER*8 NOMCHA,LPAIN(7),LPAOUT(4),K8BID,NEWNOM
      CHARACTER*16 OPTION
      CHARACTER*24 LIGRMO,LCHIN(7),LCHOUT(4)
      CHARACTER*24 CHVITE,CARTE,CONVCH,CHGEOM,CHCARA(18),CHHARM
      INTEGER IRET,JVITES
      LOGICAL EXIGEO,EXICAR,EXIMAT

C DEB ------------------------------------------------------------------
      CALL JEMARQ()
      NEWNOM = '.0000000'
      LIGRMO = MODELE(1:8)//'.MODELE'
      CALL JEEXIN(CHARGE,IRET)
      IF (IRET.NE.0) THEN
        CALL JELIRA(CHARGE,'LONMAX',NCHAR,K8BID)
        CALL JEVEUO(CHARGE,'L',JCHAR)
        CALL JEVEUO(INFCHA,'L',JINF)
      ELSE
        NCHAR = 0
      END IF

      CALL MEGEOM(MODELE,'      ',EXIGEO,CHGEOM)
      CALL MECARA(CARELE,EXICAR,CHCARA)

      LPAOUT(1) = 'PVECTTR'
      LPAOUT(2) = 'PLAGRP '
      LPAOUT(3) = 'PRESIDU'
      LPAIN(1) = 'PGEOMER'
      LCHIN(1) = CHGEOM
      LPAIN(2) = 'PMATERC'
      LCHIN(2) = MATE
      LPAIN(3) = 'PTEMPSR'
      LCHIN(3) = INST
      LPAIN(4) = 'PTEMPER'
      LCHIN(4) = CHTN
      LPAIN(5) = 'PTEMPEI'
      LCHIN(5) = CHTI
      LPAIN(6) = 'PLAGRM '
      LCHIN(6) = CHLAPM

C --- TERME VOLUMIQUE PROVENANT DU COMPORTEMENT

      ICONV = 0
      CHVITE = ' '
      OPTION = 'CHAR_THER_TNL'
      LCHOUT(2) = CHLAPP
      LPAIN(7) = 'PVITESR'

      DO 10 ICHAR = 1,NCHAR
        NOMCHA = ZK24(JCHAR+ICHAR-1) (1:8)
        CONVCH = NOMCHA//'.CHTH'//'.CONVE'//'.VALE'
        CALL JEEXIN(CONVCH,IRET)
        IF (IRET.GT.0) THEN
          ICONV = ICONV + 1
          IF (ICONV.GT.1) CALL U2MESS('F','CALCULEL3_72')
          CALL JEVEUO(CONVCH,'L',JVITES)
          CHVITE = ZK8(JVITES)
        END IF
   10 CONTINUE
      IF (ICONV.EQ.0) CALL U2MESS('F','CALCULEL5_38')
      LCHIN(7) = CHVITE

      CALL GCNCO2(NEWNOM)
      LCHOUT(1) = '&&VETRTH.'//NEWNOM(2:8)
      CALL CORICH('E',LCHOUT(1),-1,IBID)
      CALL GCNCO2(NEWNOM)
      LCHOUT(3) = '&&VETRTH.'//NEWNOM(2:8)
      CALL CORICH('E',LCHOUT(3),-1,IBID)
      CALL CALCUL('S',OPTION,LIGRMO,7,LCHIN,LPAIN,3,LCHOUT,LPAOUT,'V',
     &               'OUI')
      CALL REAJRE(VERES,LCHOUT(3),'V')

C --- TERME SURFACIQUE PROVENANT DES CONDITIONS AUX LIMITES

      LPAOUT(1) = 'PRESIDU'
      LPAIN(2) = 'PFLUXNL'
      IF (NCHAR.GT.0) THEN
        DO 20 ICHA = 1,NCHAR
          LCHIN(2) = ZK24(JCHAR+ICHA-1) (1:8)//'.CHTH.FLUNL.DESC'
          CALL JEEXIN(LCHIN(2),IRET)
          IF (IRET.NE.0) THEN
            OPTION = 'CHAR_THER_FLUTNL'
            CALL GCNCO2(NEWNOM)
            LCHOUT(1) = '&&VETRTH.'//NEWNOM(2:8)
            CALL CORICH('E',LCHOUT(1),-1,IBID)
            CALL CALCUL('S',OPTION,LIGRMO,5,LCHIN,LPAIN,1,LCHOUT,LPAOUT,
     &                  'V','OUI')
            CALL REAJRE(VERES,LCHOUT(1),'V')
          END IF
          LCHIN(2) = ZK24(JCHAR+ICHA-1) (1:8)//'.CHTH.T_EXT.DESC'
          CALL JEEXIN(LCHIN(2),IRET)
          IF (IRET.NE.0) THEN
            LPAOUT(1) = 'PRESIDU'
            C1 = 'R'
            IF (ZI(JINF+NCHAR+ICHA).GT.1) THEN
              C1 = 'F'
            END IF
            OPTION = 'RESI_THER_COEH_'//C1
            LPAIN(4) = 'PCOEFH'//C1
            LCHIN(4) = ZK24(JCHAR+ICHA-1) (1:8)//'.CHTH.COEFH'
            CALL GCNCO2(NEWNOM)
            LCHOUT(1) = '&&VETRTH.'//NEWNOM(2:8)
            CALL CORICH('E',LCHOUT(1),-1,IBID)
            CALL CALCUL('S',OPTION,LIGRMO,5,LCHIN,LPAIN,1,LCHOUT,LPAOUT,
     &                  'V','OUI')
            CALL REAJRE(VERES,LCHOUT(1),'V')
          END IF
   20   CONTINUE
      END IF
C FIN ------------------------------------------------------------------
      CALL JEDEMA()
      END
