      SUBROUTINE MEMVER(ACTION,PREC,ARRET,TITRE)
      IMPLICIT NONE
      CHARACTER*(*) ACTION,ARRET,TITRE
      REAL*8 PREC,PRECS
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF DEBUG  DATE 26/07/2010   AUTEUR LEFEBVRE J-P.LEFEBVRE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE PELLET J.PELLET
C   BUT: VERIFIER QU'IL N'Y A PAS DE FUITE MEMOIRE DANS UN
C        PROGRAMME FORTRAN
C---------------------------------------------------------------------
C IN  ACTION : /'MESURE' : ON MESURE LA MEMOIRE TOTALE =
C              MEMOIRE LIBRE + MEMOIRE JEVEUX DYNAMIQUE ALLOUEE
C              /'VERIF' : ON VERIFIE QUE LA MEMOIRE TOTALE N'A PAS
C              BOUGE DEPUIS L'APPEL A "MESURE"
C IN  PREC : PRECISION SOUHAITEE POUR LA COMPARAISON.
C            PREC EST DONNE POUR 'MESURE'. IL EST STOCKE.
C            ET IL EST UTILISE POUR ACTION='VERIF'
C IN  ARRET  (K2)
C   ARRET(1:1) :
C     /'F' : ERREUR FATALE SI FUITE MEMOIRE > PREC
C     /' ' : NE S'ARRETE PAS EN CAS DE FUITE
C   ARRET(2:2) :
C     /'I' : IMPRIME LES 2 VALEURS COMPAREES AINSI QUE LEUR DIFFERENCE
C     /' ' : N'IMPRIME RIEN
C IN  TITRE : CHAINE DE CARACTERES IMPRIMEE AU DEBUT DES LIGNES
C            SI ARRET(2:2)='I'
C----------------------------------------------------------------------
 
      REAL*8 RVAL(9),TMAX,MTOTS,MTOT
      SAVE MTOTS,PRECS

      CALL ASSERT(ACTION.EQ.'MESURE' .OR. ACTION.EQ.'VERIF')
      IF (ACTION.EQ.'MESURE')PRECS=2.D0*PREC

      CALL ASSERT(ARRET(1:1).EQ.'F' .OR. ARRET(1:1).EQ.' ')
      CALL ASSERT(ARRET(2:2).EQ.'I' .OR. ARRET(2:2).EQ.' ')

      CALL MEMRES('NON','NON',' ',PRECS,TMAX)
      CALL JEINFO(RVAL)
      MTOT=TMAX+RVAL(3)

      IF (ACTION.EQ.'MESURE') THEN
        MTOTS=MTOT
      ELSE
        IF (ARRET(2:2).EQ.'I') THEN
          WRITE (6,9000)'<MEMVER> MTOTS,MTOT,DIFF=',TITRE,
     &      MTOTS,MTOT,MTOTS-MTOT
        ENDIF
        IF (ARRET(1:1).EQ.'F') CALL ASSERT(MTOTS-MTOT.LT.PRECS)
      ENDIF

 9000 FORMAT (2(A,1X),3(F15.3,1X))
      END
