      SUBROUTINE BRBAGL(ZIMAT,NMNBN,NMPLAS,NMDPLA,NMDDPL,NMZEF,NMZEG
     &           ,NMIEF,NMPROX,DEPSP,DDISSI,DC1,DC2,DTG,BBOK,
     &            NORMM,NORMN)
 
        IMPLICIT  NONE
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 19/05/2009   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C     INTEGRE LA LOI DE COMPORTEMENT GLRC_DAMAGE POUR UN INCREMENT
C     DE DEFORMATION DEPS DEFINIT DANS LE REPERE D ORTHOTROPIE
C
C IN  ZIMAT : ADRESSE DE LA LISTE DE MATERIAU CODE
C IN  DC1 : MATRICE ELASTIQUE + CONSTANTES DE PRAGER EN MEMBRANCE
C IN  DC2 : MATRICE ELASTIQUE + CONSTANTES DE PRAGER EN FLEXION
C IN  DTG : MATRICE TANGENTE
C IN  NORMM : NORME SUR LA FONCTION MP = F(N)
C IN  NORMN : NORME SUR LA FONCTION MP = F(N)
C
C IN/OUT NMNBN : FORCE - BACKFORCE
C IN/OUT NMPLAS : MOMENTS LIMITES DE PLASTICITE
C IN/OUT NMDPLA : DERIVEES DES MOMENTS LIMITES DE PLASTICITE
C IN/OUT NMDDPL : DERIVEES SECONDES DES MOMENTS LIMITES DE PLASTICITE
C IN/OUT NMZEF : ZERO ADIMENSIONNEL POUR LE CRITERE F
C IN/OUT NMZEG : ZERO ADIMENSIONNEL POUR LE CRITERE G
C IN/OUT NMIEF : NMIEF > 0 : NBN HORS DE LA ZONE DE DEFINITION DE MP
C IN/OUT NMPROX : NMPROX > 0 : NBN DANS ZONE DE CRITIQUE
C IN/OUT DEPSP : INCREMENT DE DEFORMATION DANS LE REPERE ORTHO
C IN/OUT DDISSI : INCREMENT DE DISSIPATION
C
C OUT BBOK : CRITERE DE CV DE L ALGO BRINGBACK

      LOGICAL BBOK

C      INTEGER NEWPRO(2)
      INTEGER NMIEF, NEWIEF, NMPROX(2), ZIMAT
      INTEGER NCRIT, NCRNEW, NBB,IER,I,J,CRITNU,IPARA(4)
      INTEGER NBBMAX

      REAL*8  NMNBN(6), NEWNBN(6)
      REAL*8  NMPLAS(2,3), NEWPLA(2,3)
      REAL*8  NMDPLA(2,2), NEWDPL(2,2)
      REAL*8  NMDDPL(2,2), NEWDDP(2,2)
      REAL*8  NMZEF, NEWZEF
      REAL*8  NMZEG, NEWZEG , NEWZFG(2)
      REAL*8  DEPSP(6), DDISSI,NORMM,NORMN
      REAL*8  DC1(6,6),DC2(6,6),DTG(6,6)
      REAL*8  DEPSLO(6), DEPSBB(6), F1, F2, DDISBB, FPLASS

      NBB = 0
      NBBMAX = 1000
      BBOK = .FALSE.

      CALL R8INIR(6,0.0D0,DEPSLO,1)

C     ATTENTION : NCRIT DOIT ETRE SUPERIEUR A ZERO
C     CELA SIGNIFIE QUE (M-BACKM) N EST PAS 
C     DANS LE CRITERE DE PLASTICITE
C      NCRIT = CRITNU(ZIMAT,NMNBN,NMDPLA,DEPSLO,DTG,NORMM)
      NCRIT = CRITNU(ZIMAT,NMNBN,DEPSLO,DTG,NORMM)

      DO 190, NBB = 1, NBBMAX

C       NEWZFG(1) = NEWZEF
C       NEWZFG(2) = NEWZEG
        IPARA(1) = ZIMAT
        IPARA(2) = NCRIT
C       IPARA(3) = NEWIEF
C       IPARA(4) = IER

C     CALCUL DU NOUVEAU MOMENT
C     DE L INCREMENT DE COURBURE PLASTIQUE ET DE LA DISSIPATION
          CALL DNDISS(IPARA,NMNBN,NMPLAS,NMDPLA,NMDDPL
     &               ,NMPROX,DEPSLO,NEWNBN,NEWPLA,NEWDPL
     &               ,NEWDDP,NEWZFG,DEPSBB
     &               ,DDISBB,DC1,DC2,DTG,NORMM,NORMN)

        ZIMAT  = IPARA(1)
        NCRIT  = IPARA(2)
        NEWIEF = IPARA(3)
        IER    = IPARA(4)
        NEWZEF = NEWZFG(1)
        NEWZEG = NEWZFG(2)

        IF (IER .GT. 0) GOTO 200

C     MISE A JOUR DES VARIABLE
        DO 125, J = 1,6
          NMNBN(J) = NEWNBN(J)
 125    CONTINUE

        DO 140, J = 1,3
          DO 130, I = 1,2
            NMPLAS(I,J) = NEWPLA(I,J)
 130      CONTINUE
 140    CONTINUE

        DO 160, J = 1,2
          DO 150, I = 1,2
            NMDPLA(I,J) = NEWDPL(I,J)
            NMDDPL(I,J) = NEWDDP(I,J)
 150      CONTINUE
 160    CONTINUE

        NMZEF = NEWZEF
        NMZEG = NEWZEG
        NMIEF = NEWIEF

C        DO 170, J = 1,2
C          NMPROX(J) = NEWPRO(J)
C 170    CONTINUE

        DO 180, J = 1,6
          DEPSP(J) = DEPSP(J) + DEPSBB(J)
 180    CONTINUE

        DDISSI = DDISSI + DDISBB

C     CALCUL DES CRITERES DE PLASTICITE F
        F1 = FPLASS(NMNBN,NMPLAS,1)
        F2 = FPLASS(NMNBN,NMPLAS,2)

        IF ( F1 .LT. NMZEF
     &      .AND. F2 .LT. NMZEF
     &      .AND. (F1 .GT. -NMZEF .OR. F2 .GT. -NMZEF)
     &      )   THEN

C     NMNBN PROCHE DE LA SURFACE DE PLASTICITE
          BBOK = .TRUE.
          GOTO 200
        ENDIF

C     CALCUL DU PREDICTEUR ELASTIQUE ET DU NOMBRE DE CRITERES ACTIVES
C        NCRNEW = CRITNU(ZIMAT,NMNBN,NMDPLA,DEPSLO,DTG,NORMM)
        NCRNEW = CRITNU(ZIMAT,NMNBN,DEPSLO,DTG,NORMM)

C     SI NCRNEW = 0 CELA VEUT DIRE QUE MBACKM EST DANS LE VOLUME ELAST
C     ON UTILISE LE CRITERE DU PAS PRECEDENT
C     POUR CALCULER LA COURBURE PLASTIQUE
C     C EST POURQUOI NCRIT N EST PAS MIS A JOUR
        IF (NCRNEW  .GT.  0) THEN
          NCRIT = NCRNEW
        ENDIF
190   CONTINUE

200   CONTINUE

      END
