      SUBROUTINE CAETHM(NOMTE,AXI,PERMAN,VF,TYPVF,
     &                  TYPMOD,MODINT,MECANI,PRESS1,PRESS2,TEMPE,
     &                  DIMDEP,DIMDEF,DIMCON,NMEC,NP1,NP2,NDIM,NNO,
     &                  NNOS,NNOM,NFACE,
     &                  NPI,NPG,NDDLS,NDDLM,NDDLFA,NDDLK,DIMUEL,
     &                  IPOIDS,IVF,IDFDE,IPOID2,IVF2,IDFDE2,NPI2,JGANO)
C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C ======================================================================
C MODIF ELEMENTS  DATE 08/02/2011   AUTEUR GRANET S.GRANET 
C RESPONSABLE GRANET S.GRANET
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C TOLE CRP_21
C ======================================================================
C ======================================================================
C --- BUT : PREPARATION DU CALCUL SUR UN ELEMENT THM -------------------
C ======================================================================
C
C IN NOMTE   : NOM DU TYPE D'ELEMENT 
C IN AXI     : AXI ?
C OUT PERMAN : MODELISATION HM PERMAMENTE ?
C OUT TYPMOD : TYPE DE MODELISATION (AXI DPLAN 3D)
C OUT MODINT : METHODE D'INTEGRATION (CLASSIQUE,LUMPEE(D),REDUITE(R) ?)
C OUT MECANI : TABLEAU INFO SUR MECANIQUE
C OUT PRESS1 : TABLEAU INFO SUR HYDRAULIQUE CONSTITUANT 1
C OUT PRESS2 : TABLEAU INFO SUR HYDRAULIQUE CONSTITUANT 2
C OUT TEMPE  : TABLEAU INFO SUR THERMIQUE
C OUT DIMDEP : DIMENSION DES DEPLACEMENTS GENERALISES
C OUT DIMDEF : DIMENSION DES DEFORMATIONS GENERALISEES
C OUT DIMCON : DIMENSION DES CONTRAINTES GENERALISEES
C OUT NMEC   : NOMBRE DE COMPOSANTES DU VECTEUR DEPLACEMENT
C OUT NP1    : 1 SI IL Y A UNE EQUATION POUR P1, 0 SINON
C OUT NP2    : 1 SI IL Y A UNE EQUATION POUR P2, 0 SINON
C OUT NDIM   : DIMENSION DU PROBLEME (2 OU 3)
C OUT NNO    : NOMBRE DE NOEUDS DE L'ELEMENT
C OUT NNOS   : NOMBRE DE NOEUDS SOMMETS DE L'ELEMENT
C OUT NFACE  : NB FACES AU SENS BORD DE DIMENSION DIM-1 NE SERT QU EN VF
C OUT NNOM   : NB NOEUDS MILIEUX DE FACE OU D ARRETE NE SERT QU EN EF
C OUT NPI    : NOMBRE DE POINTS D'INTEGRATION DE L'ELEMENT
C OUT NPG    : NOMBRE DE POINTS DE GAUSS     POUR CLASSIQUE(=NPI)
C                        SOMMETS             POUR LUMPEE   (=NPI=NNOS)
C                        POINTS DE GAUSS     POUR REDUITE  (<NPI)
C OUT NDDLS  : NOMBRE DE DDL SUR LES SOMMETS
C OUT NDDLM  : NB DDL SUR LES MILIEUX FACE OU D ARRETE NE SERT QU EN EF
C OUT NDDLFA    NB DE DDL SUR LES FACES DE DIM DIM-1 NE SERT QU EN VF
C OUT NDDLK  : NOMBRE DE DDL SUR LA MAILLE (BULL OU VF)
C OUT DIMUEL : NOMBRE DE DDL TOTAL DE L'ELEMENT
C OUT IPOIDS : ADRESSE DU TABLEAU POIDS POUR FONCTION DE FORME P2
C OUT IVF    : ADRESSE DU TABLEAU DES FONCTIONS DE FORME P2
C OUT IDFDE  : ADRESSE DU TABLEAU DES DERIVESS DES FONCTIONS DE FORME P2
C OUT IPOID2 : ADRESSE DU TABLEAU POIDS POUR FONCTION DE FORME P1
C OUT IVF2   : ADRESSE DU TABLEAU DES FONCTIONS DE FORME P1
C OUT IDFDE2 : ADRESSE DU TABLEAU DES DERIVESS DES FONCTIONS DE FORME P1
C OUT JGANO  : ADRESSE DANS ZR DE LA MATRICE DE PASSAGE
C              GAUSS -> NOEUDS
C OUT TYPVF   TYPE DE VF : 1  = TPFA (FLUX A DEUX POINTS)
C                          2  = SUSHI AVEC VOISIN DECENTRE MAILLE (SUDM)
C                          3  = SUSHI AVEC VOISIN DECENTRE ARETE (SUDA)
C                          4  = SUSHI AVEC VOISIN CENTRE  (SUC)
C CORPS DU PROGRAMME
      IMPLICIT NONE

C DECLARATION PARAMETRES D'APPELS
      LOGICAL       AXI, PERMAN,VF
      INTEGER       TYPVF 
      INTEGER       MECANI(5),PRESS1(7),PRESS2(7),TEMPE(5),DIMUEL
      INTEGER       NDIM,NNO,NNOS,NNOM
      INTEGER       DIMDEP,DIMDEF,DIMCON,NMEC,NP1,NP2
      INTEGER       NPG,NPI,NDDLS,NDDLM,NDDLK,IPOIDS,IVF,IDFDE
      INTEGER       IPOID2,IVF2,IDFDE2,NPI2,JGANO,NFACE,NDDLFA
      CHARACTER*3   MODINT
      CHARACTER*8   TYPMOD(2)
      CHARACTER*16  NOMTE
    

C --- INITIALISATIONS --------------------------------------------------
C ======================================================================
      TYPMOD(2) = '        '
C ======================================================================
C --- TYPE DE MODELISATION? AXI/DPLAN/3D ET HM TRANSI/PERM -------------
C ======================================================================
      CALL TYPTHM(NOMTE,AXI,PERMAN,VF,TYPVF,TYPMOD,NDIM)
C ======================================================================
C --- SELECTION DU TYPE D'INTEGRATION ----------------------------------
C ======================================================================
      IF(.NOT.VF) THEN
       CALL MODTHM(NOMTE,MODINT)
      ELSE
       MODINT = 'CLA'
      ENDIF
C ======================================================================
C --- INITIALISATION DES GRANDEURS GENERALISEES SELON MODELISATION -----
C ======================================================================
      CALL GRDTHM(NOMTE,PERMAN,VF,NDIM,MECANI,PRESS1,PRESS2,TEMPE,
     >            DIMDEP,DIMDEF,DIMCON,NMEC,NP1,NP2)      
C     &           JGANO)
C ======================================================================
C --- ADAPTATION AU MODE D'INTEGRATION ---------------------------------
C --- DEFINITION DE L'ELEMENT (NOEUDS, SOMMETS, POINTS DE GAUSS) -------
C ======================================================================
      CALL ITGTHM(VF,TYPVF,MODINT,MECANI,PRESS1,PRESS2,TEMPE,NDIM,NNO,
     >                  NNOS,NNOM,NFACE,NPI,NPG,
     >                  NDDLS,NDDLK,NDDLM,NDDLFA,DIMUEL,
     >                  IPOIDS,IVF,IDFDE,IPOID2,IVF2,IDFDE2,NPI2,JGANO)
C ======================================================================
      END
