      SUBROUTINE CARAPO(SECT,GEOM,ORIEN,XL,PGL,ITYPE,
     & A,XIY,XIZ,XJX,ALFAY,ALFAZ,EY,EZ,A2,XIY2,XIZ2,XJX2,ALFAY2,ALFAZ2)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 29/09/2006   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER ITYPE
      REAL*8       A   ,  XIY ,  XIZ ,  ALFAY ,  ALFAZ ,  XJX ,  EZ,  EY
      REAL*8       A2  ,  XIY2,  XIZ2,  ALFAY2,  ALFAZ2,  XJX2,  XL
      REAL*8       PGL(3,3),SECT(*),GEOM(6),ORIEN(3)
C
C     RECUPERATION DES CARACTERISTIQUES GEOMETRIQUES POUR
C     LES ELEMENTS DE POUTRE 'MECA_POU_D_E/D_T'
C        'MECA_POU_D_E' : POUTRE DROITE D'EULER       (SECTION VARIABLE)
C        'MECA_POU_D_T' : POUTRE DROITE DE TIMOSHENKO (SECTION VARIABLE)
C
C IN  SECT   : R8 : VECTEUR CONTENANT LES CARACTERISTIQUES
C IN  GEOM   : R8 : COORDONNES DES NOEUDS
C IN  ORIEN  : R8 : ORIENTATION 3 ANGLE NAUTIQUES
C OUT XL     : R8 : LONGUEUR DE L'ELEMENT
C OUT PGL    : R8 : MATRICE (3,3) DE ROTATION
C OUT ITYPE  : IS : TYPE DE VARIATION DE SECTION
C
      ITYPE =  NINT(SECT(23))
C     --- SECTION INITIALE ---
      A     =  SECT(1)
      XIY   =  SECT(2)
      XIZ   =  SECT(3)
      ALFAY =  SECT(4)
      ALFAZ =  SECT(5)
      XJX   =  SECT(8)
C     --- SECTION FINALE ---
      A2     = SECT(12)
      XIY2   = SECT(13)
      XIZ2   = SECT(14)
      ALFAY2 = SECT(15)
      ALFAZ2 = SECT(16)
      EY     = -(SECT(6)+SECT(17))/2.D0
      EZ     = -(SECT(7)+SECT(18))/2.D0
      XJX2   = SECT(19)
C
      XL = SQRT( (GEOM(4)-GEOM(1))**2
     &  + (GEOM(5)-GEOM(2))**2 + (GEOM(6)-GEOM(3))**2)
      IF( XL .EQ. 0.D0 ) THEN
         CALL U2MESS('F','ELEMENTS_17')
      ENDIF
C
      CALL MATROT ( ORIEN , PGL )
      END
