      FUNCTION CRITNU(ZIMAT,NMNBN,DEPS,DTG,NORMM)
       IMPLICIT NONE
C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 19/05/2009   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
C     DEFINIT LE NOMBRE DE CRITERE DE PLASTICITE ACTIVE
C
C IN  ZIMAT : ADRESSE DE LA LISTE DE MATERIAU CODE
C IN  NMNBN : FORCE - BACKFORCE
C IN  DEPS : INCREMENT DE DEFORMATION DANS LE REPERE ORTHO
C IN  DTG : MATRICE ELASTIQUE
C IN  NORMM : NORME SUR LA FONCTION MP = F(N)
C
C OUT CRITNU : NOMBRE DE CRITERE DE PLASTICITE ACTIVE

      INTEGER CRITNU, ZIMAT, NMPRIF, J

      REAL*8 NMNBN(6), NPRNBN(6), NMPRPL(2,3), NMPRZF, NMPRZG
      REAL*8 DEPS(6), DTG(6,6),F1ELAS, F2ELAS, G1ELAS, G2ELAS, NORMM
      REAL*8 CP(6), FPLASS, GPLASS

C     PREDICTION ELASTIQUE
      CALL MATMUL(DTG,DEPS,6,6,1,CP)

C     TENSEUR DES CONTRAINTES TESTS
      DO 10, J = 1,6
        NPRNBN(J) = NMNBN(J) + CP(J)
 10   CONTINUE

C     CALCUL DES MOMENTS LIMITES DE PLASTICITE
      CALL MPPFFN(ZIMAT,NPRNBN,NMPRPL,NMPRZF,NMPRZG,NMPRIF,NORMM)

      IF(NMPRIF  .GT.  0) THEN
         CRITNU=-1
         CALL U2MESS('A','ELEMENTS_21')
         GOTO 20
      ENDIF

C     CALCUL DES CRITERES DE PLASTICITE F
      F1ELAS = FPLASS(NPRNBN,NMPRPL,1)
      F2ELAS = FPLASS(NPRNBN,NMPRPL,2)

C     CALCUL DES CONDITIONS DE PLASTICITE G
      G1ELAS = GPLASS(NPRNBN,NMPRPL,1)
      G2ELAS = GPLASS(NPRNBN,NMPRPL,2)

      IF ((F1ELAS .GT. 0).OR.(G1ELAS .GT. 0)) THEN
        IF ((F2ELAS .GT. 0).OR.(G2ELAS .GT. 0)) THEN
          CRITNU = 12
        ELSE
          CRITNU = 1
        ENDIF
      ELSEIF ((F2ELAS .GT. 0).OR.(G2ELAS .GT. 0)) THEN
        CRITNU = 2
      ELSE
        CRITNU = 0
      ENDIF

 20   CONTINUE
      END
