      SUBROUTINE DAMAGE (CURVVP,BEND,K,DMAX,DAM,TANMRP,
     &                   ALPHA,BETA,GAMMA)

        IMPLICIT  NONE
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 19/05/2009   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C     CALCUL L EVOLUTION DES VARIABLES D ENDOMMAGEMENT AINSI QUE LES
C     TERMES DE LA MATRICE TANGENT LIEES A L EVOLUTION DE L ENDO
C
C IN  CURVVP : VALEURS PROPRES DU TENSEUR DES COURBURES ELASTIQUES
C IN  BEND : FLEXION POSITIVE (1) OU NEGATIVE (-1)
C IN  K : SEUIL D ENDOMMAGEMENT
C IN  DMAX : ENDOMMAGEMNT MAXIMAL
C IN  ALPHA : PARAMETRE  MATERIAU
C IN  BETA : PARAMETRE  MATERIAU
C IN  GAMMA : PARAMETRE  MATERIAU
C
C OUT DAM : ENDOMMAGEMENT
C OUT TANMRP : TERME DE LA MATRICE TANGENTE LIEE A L ENDOMMAGEMENT


      INTEGER BEND

      REAL*8 CURVVP(2),K,DMAX,ALPHA,BETA,GAMMA 
      REAL*8 DAM, TANMRP(3,3)
      REAL*8 TRCURV,XTR,XVP(2),W,DAMTST,COEF

      TRCURV = CURVVP(1)+CURVVP(2)

      XTR = 0.D0

      CALL R8INIR(2,0.0D0,XVP,1)

C     EVALUATION DES FONCTIONS HEAVISIDE H(tr(k**e)), H(K_i**e)
      IF (TRCURV*BEND .GT. 0.D0) XTR = ALPHA * TRCURV
      IF (CURVVP(1)*BEND .GT. 0.D0) XVP(1) = BETA * CURVVP(1)
      IF (CURVVP(2)*BEND .GT. 0.D0) XVP(2) = BETA * CURVVP(2)

      W= XTR * TRCURV + XVP(1) * CURVVP(1) + XVP(2) * CURVVP(2)

      DAMTST = (SQRT((1.D0-GAMMA)/K*W)-1.D0)

      CALL R8INIR(3*3,0.0D0,TANMRP,1)

      IF (DAMTST  .GT.  DAM) THEN
C     CONDITION POUR QUE L EVOLUTION DE L ENDOMMAGEMENT SOIT POSITIVE
        IF (DAMTST .GE. DMAX ) THEN
C     A T ON ATTEINT L ENDOMMAGEMENT MAX
          DAM=DMAX
        ELSE
          DAM=DAMTST
          COEF = 2.D0*(GAMMA-1.D0)/((1.D0+DAM)*W)
          TANMRP(1,1) = COEF * (XTR + XVP(1))**2
          TANMRP(2,2) = COEF * (XTR + XVP(2))**2
          TANMRP(1,2) = COEF * (XTR + XVP(1)) * (XTR + XVP(2))
          TANMRP(2,1) = TANMRP(1,2)
        ENDIF
      ENDIF

      END
