      SUBROUTINE DDMPFN(ZIMAT,NMNBN,NMDDPL)
       IMPLICIT  NONE
C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 19/05/2009   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C======================================================================
C
C     RECUPERE LES VALEURS DES DERIVEES SECONDES
C     DES MOMENTS LIMITES DE PLASTICITE
C     NMDDPL = df/dn(n)
C
C IN  ZIMAT : ADRESSE DE LA LISTE DE MATERIAU CODE
C IN  NMNBN : FORCE - BACKFORCE
C
C OUT NMDDPL : DERIVEES SECONDES DES MOMENTS LIMITES DE PLASTICITE

      INTEGER I,IER0,IER1,IER2,ZIMAT

      REAL*8 NMNBN(6), NMDDPL(2,2)

      CHARACTER*8 NOMRES(4),DOMRES(4),DDMRES(4)

      NOMRES(1) = 'FMEX1'
      NOMRES(2) = 'FMEX2'
      NOMRES(3) = 'FMEY1'
      NOMRES(4) = 'FMEY2'

      DOMRES(1) = 'DFMEX1'
      DOMRES(2) = 'DFMEX2'
      DOMRES(3) = 'DFMEY1'
      DOMRES(4) = 'DFMEY2'

      DDMRES(1) = 'DDFMEX1'
      DDMRES(2) = 'DDFMEX2'
      DDMRES(3) = 'DDFMEY1'
      DDMRES(4) = 'DDFMEY2'

      DO 10, I=1,2
        CALL CDNFON(ZIMAT,DDMRES(2*(I-1)+1),NMNBN(I),0,
     &                 NMDDPL(1,I),IER0)

        IF (IER0 .GT. 0) THEN
          CALL CDNFON(ZIMAT,DOMRES(2*(I-1)+1),NMNBN(I),1,
     &                 NMDDPL(1,I),IER1)

          IF (IER1 .GT. 0) THEN
            CALL CDNFON(ZIMAT,NOMRES(2*(I-1)+1),NMNBN(I),2,
     &                 NMDDPL(1,I),IER2)

            IF (IER2 .EQ. 3) THEN
              CALL U2MESS('F','ELEMENTS_24')
            ENDIF
          ENDIF
        ENDIF

        CALL CDNFON(ZIMAT,DDMRES(2*I),NMNBN(I),0,
     &                 NMDDPL(2,I),IER0)

        IF (IER0 .GT. 0) THEN
          CALL CDNFON(ZIMAT,DOMRES(2*I),NMNBN(I),1,
     &                 NMDDPL(2,I),IER1)

          IF (IER1 .GT. 0) THEN
            CALL CDNFON(ZIMAT,NOMRES(2*I),NMNBN(I),2,
     &                 NMDDPL(2,I),IER2)

             IF (IER2 .EQ. 3) THEN
               CALL U2MESS('F','ELEMENTS_24')
             ENDIF
          ENDIF
        ENDIF
 10   CONTINUE

      END
