      SUBROUTINE DELOGL(JZR,VLOC)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 25/02/2008   AUTEUR BOYERE E.BOYERE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2008  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
C     ------------------------------------------------------------------
C      ROUTINE DE CALCUL UN VECTEUR VLOC DANS LE REPERE LOCAL D'UN
C      ELEMENT DE TYPE POUTRE A PARTIR DE SES COORDONNEES DANS LE
C      REPERE GLOBAL VGLOB
C     ------------------------------------------------------------------
C
C     JZR    :  INDICE DE LA PREMIERE COMPOSANTE DE VLOC DANS ZR 
C     VLOC   :  TABLEAU DES COMPOSANTES DE VGLOB DANS LE REPERE LOCAL
C
      IMPLICIT NONE
C
C     A PRIORI LA DIMENSION DE VLOC EST 12 ???
C
      INTEGER JZR
      REAL *8 VLOC(*)
C
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
C
C --------- VARIABLES LOCALES ------------------------------------------
C
      REAL*8  DEUX
      INTEGER NNOC, NCC, NNO, NC
      INTEGER LSECT, ITYPE, LX, LRCOU, LORIEN
      REAL*8  XL, RAD, ANGARC, ANGS2
      REAL*8  PGL(3,3),PGL1(3,3),PGL2(3,3)
C
C     FONCTIONS 
C
      REAL*8 TRIGOM 
C
C ----------------------------------------------------------------------
C
      DEUX = 2.D0
      NNOC = 1
      NCC = 6
      NNO = 2
      NC = 6
C
C     --- RECUPERATION DES CARACTERISTIQUES GENERALES DES SECTIONS ---
C
      CALL JEVECH('PCAGNPO','L',LSECT)
      LSECT = LSECT - 1
      ITYPE = NINT(ZR(LSECT+23))
C
C     --- RECUPERATION DES COORDONNEES DES NOEUDS ---
C
      CALL JEVECH('PGEOMER','L',LX)
      LX = LX - 1
      XL = SQRT((ZR(LX+4)-ZR(LX+1))**2+ (ZR(LX+5)-ZR(LX+2))**2+
     &     (ZR(LX+6)-ZR(LX+3))**2)
      IF (ITYPE.EQ.10) THEN
        CALL JEVECH('PCAARPO','L',LRCOU)
        RAD = ZR(LRCOU)
        ANGARC = ZR(LRCOU+1)
        ANGS2 = TRIGOM('ASIN',XL/(DEUX*RAD))
        XL = RAD*ANGS2*DEUX
      END IF
C
C     --- MATRICE DE ROTATION PGL
C
      CALL JEVECH('PCAORIE','L',LORIEN)
      IF (ITYPE.EQ.10) THEN
        CALL MATRO2(ZR(LORIEN),ANGARC,ANGS2,PGL1,PGL2)
      ELSE
        CALL MATROT(ZR(LORIEN),PGL)
      END IF
C
C      --- CALCUL DU VECTEUR DANS LE REPERE LOCAL ---
C
      IF (ITYPE.EQ.10) THEN
        CALL UTPVGL(NNOC,NCC,PGL1,ZR(JZR),VLOC)
        CALL UTPVGL(NNOC,NCC,PGL2,ZR(JZR+6),VLOC(7))
      ELSE
        CALL UTPVGL(NNO,NC,PGL,ZR(JZR),VLOC)
      END IF
C
      END
