      SUBROUTINE DGELAS (EB, NUB, H, B, A, EM, NUM, EF, NUF, ICISAI)

      IMPLICIT   NONE

      INTEGER ICISAI

      REAL*8 EB, NUB, B, A, H
      REAL*8 EM, NUM, EF, NUF

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 03/01/2011   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE SFAYOLLE S.FAYOLLE
C ----------------------------------------------------------------------
C
C BUT : DETERMINATION DES PARAMETRES ELASTIQUES
C
C IN:
C       EB     : MODULE D YOUNG DU BETON
C       NUB    : COEFF DE POISSON DU BETON
C       H      : EPAISSEUR DE LA PLAQUE
C       B      : SECTIONS DES ACIERS
C       A      : 
C OUT:
C       EM     : MODULE D YOUNG EN MEMBRANE
C       EF     : MODULE D YOUNG EN FLEXION
C       EMC    : MODULE D YOUNG EN MEMBRANE POUR LE CISAILLEMENT
C       NUM    : COEFF DE POISSON EN MEMBRANE
C       NUF    : COEFF DE POISSON EN FLEXION
C       NUMC   : COEFF DE POISSON EN MEMBRANE POUR LE CISAILLEMENT
C ----------------------------------------------------------------------

C - DETERMINATION DES PARAMETRES ELASTIQUES EN MEMBRANE
      IF (ICISAI .EQ. 0) THEN
C - PAR ESSAI DE TRACTION
        EM = B/H + EB*(B+EB*H)/((1.D0-NUB**2)*B+EB*H)
        NUM = NUB*EB*H/((1.D0-NUB**2)*B+EB*H)
      ELSE
C - PAR ESSAI DE CISAILLEMENT PUR DANS LE PLAN
        EM = EB + B*(1.D0-NUB)/H
        NUM = NUB + B*(1.D0-NUB**2)/EB/H
      ENDIF

C - DETERMINATION DES PARAMETRES ELASTIQUES EN FLEXION
      EF = EB*(EB*H+12.D0*A)/(EB*H+12.D0*A*(1.D0-NUB**2))+12.D0*A/H
      NUF = NUB*EB*H/(EB*H+12.D0*A*(1.D0-NUB**2))

      END
