      SUBROUTINE DI2EPX(A,D)

      IMPLICIT NONE
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 19/05/2009   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C======================================================================
C
C     DIAGONALISATION D'UNE MATRICE SYMETRIQUE 2x2
C
C IN  A : MATRICE SYM 2x2 SOUS FORME VECTORIEL 3x1 (A11,A22,A12)**t
C
C OUT D : MATRICE DIAG 2x2 SOUS FORME VECTORIEL 2x1 (D1,D2)**t

      REAL*8 A(3), D(2), ZERO
      REAL*8 AUX, DELTA, RDELTA, B, NORME

      ZERO = 1.D-10

C     CALCUL DU (DELTA SUR QUATRE) DU POLYNOME CARACT DE LA MATRICE
C     POLY CARC = det(X*I-A) = X**2-X*(A(1)+A(2))+A(1)*A(2)-A(3)**2
C     DELTA / 4 = (A(1)-A(2))**2 / 4 + A(3)**2

      AUX = (A(1)-A(2))*(A(1)-A(2))
      AUX = 0.25D0 * AUX
      DELTA = AUX + A(3)*A(3)

      NORME=ABS(A(1))+ABS(A(2))+ABS(A(3))

C     CALCUL DE RACINE(DELTA/4)
      IF(DELTA .GE. ZERO * NORME**2) THEN
        RDELTA = SQRT(DELTA)
      ELSE
        RDELTA=0.D0
      ENDIF

C     CALCUL DES TERMES DE LA MATRICE DIAGONALISEE
      B = 0.5D0 * (A(1)+A(2))
      D(1) = B + RDELTA
      D(2) = B - RDELTA

      END
