      SUBROUTINE DICOR4 (K0,SIM,SIP,PI,UI,TI,DXU1,DXU2,DRYU1,DRYU2,
     &                   NU1,NU2,MU1,MU2,FEQ1,C1,DBAR2,UU,TT,DUR,DRYR,
     &                   P2,UTOT,TTOT,DNSDU,DMSDT,DNSDT,
     &                   DNSDU2,DMSDT2,DNSDT2)
C ----------------------------------------------------------------------
      IMPLICIT NONE
      REAL*8 K0(78),SIM(12),SIP(12),PI,UI,TI,DXU1,DXU2,DRYU1,DRYU2
      REAL*8 NU1,NU2,MU1,MU2,FEQ1,C1,DBAR2,UU,TT,DUR,DRYR
      REAL*8 P2,UTOT,TTOT,DNSDU,DMSDT,DNSDT,DNSDU2,DMSDT2,DNSDT2
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 29/09/2006   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C TOLE CRP_21
C
C     UTILITAIRE POUR LE COMPORTEMENT CORNIERE.
C
C ----------------------------------------------------------------------
C
C IN  : K0     : COEFFICIENTS DE RAIDEUR TANGENTE
C       SIM    : EFFORTS GENERALISES PRECEDENTS
C       SIP    : EFFORTS GENERALISES COURANTS
C       PI     :
C       UI     :
C       TI     :
C       DXU$   : DEPLACEMENT ULTIME POUR LE MECANISME $ (1 OU 2)
C       DRYU$  : ROTATION ULTIME POUR LE MECANISME $
C       NU$    : EFFORT ULTIME POUR LE MECANISME $
C       MU$    : MOMENT ULTIME POUR LE MECANISME $
C       FEQ1   : FORCE EQUIVALENTE POUR LE MECANISME 1
C       C1     : PARAMETRE DE NON-LINEARITE DU MECANISME 1
C       DBAR2  : COEFFICIENT DE LA RELATION DU MECANISME 2
C       UU     :
C       TT     :
C       DUR    : INCREMENT DE DEPLACEMENT
C       DRYR   : INCREMENT DE ROTATION
C
C OUT : SIP    : EFFORTS GENERALISES COURANTS
C       P2     :
C       UTOT   :
C       TTOT   :
C       DNSDU  :
C       DMSDT  :
C       DNSDT  :
C       DNSDU2 :
C       DMSDT2 :
C       DNSDT2 :
C
C**************** DECLARATION DES VARIABLES LOCALES ********************
C
      REAL*8 UBR1,UBR2,TBR1,TBR2,UB1,UB2,TB1,TB2,ZNB1,ZNB2,ZMB1,ZMB2
      REAL*8 FEQ2,P2B,UR2,TR2,U2,T2,UPI,TPI
C
C************ FIN DES DECLARATIONS DES VARIABLES LOCALES ***************
C
      CALL U2MESS('I','ELEMENTS_25')
C ICI UI=UI-VARIM4 ET TI=TI-VARIM5
CC ON REMPLACE APRES UI PAR UU-DUR ET TI PAR TT-DRYR
      IF (PI.NE.0.D0) THEN
         UBR1 = UI/DXU1/PI
         TBR1 = TI/DRYU1/PI
      ELSE
         UBR1 = SIP(7)/NU1/FEQ1
         TBR1 = SIP(11)/MU1/FEQ1
      ENDIF
      FEQ1 = SQRT(UBR1**2+TBR1**2)
      UBR1 = UBR1/FEQ1
      TBR1 = TBR1/FEQ1
      UB1 = UBR1*DXU1
      TB1 = TBR1*DRYU1
      UPI = UB1*PI
      TPI = TB1*PI
      ZNB1 = C1*UBR1
      ZMB1 = C1*TBR1
C
      ZNB2 = ZNB1*NU1/NU2
      ZMB2 = ZMB1*MU1/MU2
      FEQ2 = SQRT(ZNB2**2+ZMB2**2)
      P2B = FEQ2**2/(1.D0-FEQ2)/DBAR2
      UBR2 = P2B*ZNB2/FEQ2
      TBR2 = P2B*ZMB2/FEQ2
      UB2 = UBR2*DXU2
      TB2 = TBR2*DRYU2
      FEQ2 = SQRT ( (SIP(7)/NU2)**2 + (SIP(11)/MU2)**2 )
      P2 = FEQ2**2/(1.D0-FEQ2)/DBAR2
      UR2 = P2*SIP(7)/NU2/FEQ2
      TR2 = P2*SIP(11)/MU2/FEQ2
      U2 = UR2*DXU2
      T2 = TR2*DRYU2
C
      UTOT = U2+UB1-UB2+UU-DUR-UPI
      TTOT = T2+TB1-TB2+TT-DRYR-TPI
C
      IF (DUR.NE.0.D0)  DNSDU2 = SIP(7)/UTOT
      IF (DUR.EQ.0.D0)  DNSDU2 = K0(1)
      IF (DRYR.NE.0.D0) DMSDT2 = SIP(11)/TTOT
      IF (DRYR.EQ.0.D0) DMSDT2 = K0(15)
      DNSDT2 = 0.D0
C
      SIP(7) = DNSDU2*UU
      SIP(11) = DMSDT2*TT
      SIP(1) = -SIP(7)
      SIP(5) = -SIP(11)
C
      CALL DICOR3 (K0,DUR,DRYR,SIM,SIP,DNSDU,DMSDT,DNSDT)
C ----------------------------------------------------------------------
C
 9999 CONTINUE
      END
