      FUNCTION DPOLYN(N,COEF,X)

       IMPLICIT NONE
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 19/05/2009   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C     EVALUE LA DERIVEE DU POLYNOME
C     Y = A1 + A2 * X + ... + A(N+1) * X**N
C     SOIT DY/DX = A2 + ... + N * A(N+1) * X**(N-1)
C
C IN  N : DEGRE DU POLYNOME
C IN  A : COEFFICIENT DU POLYNOME
C IN  X : VALEUR DE X OU EST EVALUE LE POLYNOME
C
C OUT DPOLYN : EVALUATION DE LA DERIVEE DU POLYNOME A X

      INTEGER N, I
      REAL*8 X, COEF(N+1), DPOLYN

C     INITIALISATION DE LA VARIABLE MAIS AUSSI VALEUR DE
C     LA DERIVEE POUR UN POLYNOME DE DEGRE 0
      DPOLYN=0.D0

      IF (N .GT. 0) THEN
        DO 10, I = 1, N
          DPOLYN = X*DPOLYN + (N-I-1)*COEF(N-I)
 10     CONTINUE
      ENDIF

      END
