      SUBROUTINE DXSIGV (FAMI,NOMTE, XYZL , PGL , IC,
     +                   INIV, DEPL,SIGTOT)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 04/05/2011   AUTEUR MACOCCO K.MACOCCO 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
      CHARACTER*4  FAMI
      CHARACTER*16 NOMTE
      REAL*8       XYZL(3,1) , PGL(3,1)
      INTEGER      IC,INIV
      REAL*8       DEPL(1)
      REAL*8       SIGTOT(1)
C     ------------------------------------------------------------------
C --- CONTRAINTES 'VRAIES' (I.E. SIGMA_MECA - SIGMA_THERM)
C --- AUX POINTS DE CALCUL POUR LES ELEMENTS COQUES A
C --- FACETTES PLANES : DST, DKT, DSQ, DKQ, Q4G
C     ------------------------------------------------------------------
C     IN  NOMTE        : NOM DU TYPE D'ELEMENT
C     IN  XYZL(3,NNO)  : COORDONNEES DES CONNECTIVITES DE L'ELEMENT
C                        DANS LE REPERE LOCAL DE L'ELEMENT
C     IN  PGL(3,3)     : MATRICE DE PASSAGE DU REPERE GLOBAL AU REPERE
C                        LOCAL
C     IN  IC           : NUMERO DE LA COUCHE
C     IN  INIV         : NIVEAU DANS LA COUCHE (-1:INF , 0:MOY , 1:SUP)
C     IN  DEPL(1)      : VECTEUR DES DEPLACEMENTS AUX NOEUDS
C     OUT SIGTOT(1)    : CONTRAINTES VRAIES AUX POINTS
C                        DE CALCUL
C                          (I.E. SIGMA_MECA - SIGMA_THERMIQUES)
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
C
      INTEGER    I
      REAL*8     SIGTH(24)
C
C --- CALCUL DES CONTRAINTES D'ORIGINE MECANIQUE
C --- AUX POINTS DE CALCUL
C     --------------------
      CALL DXSIGM(FAMI,NOMTE, XYZL, PGL, IC, INIV, DEPL,SIGTOT)
C
C --- CALCUL DES CONTRAINTES D'ORIGINE THERMIQUE
C --- AUX POINTS DE CALCUL
C     --------------------
      CALL DXSIGT(NOMTE, XYZL, PGL, IC, INIV, SIGTH)
C
C --- CALCUL DES CONTRAINTES 'VRAIES'
C --- AUX POINTS DE CALCUL
C     ------------------------
      DO 10 I =1, 24
            SIGTOT(I) = SIGTOT(I) - SIGTH(I)
 10   CONTINUE
C
      END
