      SUBROUTINE GDDYNG (KP,NNO,EN,X0SK,RMKM1,RMK,OMKM1,OMPKM1,OMK,
     &                   OMPK, X0SEC,RGMKM,RGMK,OMGKM,OMPGKM,OMGK,OMPGK)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 02/10/95   AUTEUR GIBHHAY A.Y.PORTABILITE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C FONCTION: POUR UN ELEMENT DE POUTRE EN GRAND DEPLACEMENT, CALCULE
C           CERTAINES GRANDEURS DYNAMIQUES AUX POINTS DE GAUSS.
C
C     IN  : KP        : NUMERO DU POINT DE GAUSS
C           NNO       : NOMBRE DE NOEUDS
C           EN        : FONCTIONS DE FORME
C           X0SK      : DERIVEE SECONDE ACTUALISEE DU DEPLACEMENT
C           RMKM1     : INCREMENT DE ROTATION ENTRE L'INSTANT N  ET
C                       L'ITER. I   DE L'INSTANT N+1
C           RMK       : INCREMENT DE ROTATION ENTRE L'INSTANT N  ET
C                       L'ITER. I+1 DE L'INSTANT N+1
C           OMKM1     : VITESSE      ANGULAIRE, A L'ITERATION I
C           OMPKM1    : ACCELERATION ANGULAIRE, A L'ITERATION I
C           OMK       : VITESSE      ANGULAIRE, A L'ITERATION I+1
C           OMPK      : ACCELERATION ANGULAIRE, A L'ITERATION I+1
C
C     OUT, AU POINT DE GAUSS NUMERO KP:
C           X0SEC     : DERIVEE SECONDE ACTUALISEE DU DEPLACEMENT
C           RGMKM     : INCREMENT DE ROTATION ENTRE L'INSTANT N  ET
C                       L'ITER. I   DE L'INSTANT N+1
C           RGMK      : INCREMENT DE ROTATION ENTRE L'INSTANT N  ET
C                       L'ITER. I+1 DE L'INSTANT N+1
C           OMGKM     : VITESSE      ANGULAIRE, A L'ITERATION I
C           OMPGKM    : ACCELERATION ANGULAIRE, A L'ITERATION I
C           OMGK      : VITESSE      ANGULAIRE, A L'ITERATION I+1
C           OMPGK     : ACCELERATION ANGULAIRE, A L'ITERATION I+1
C ------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 EN(3,2),X0SK(3,3),RMKM1(3,3),RMK(3,3),OMKM1(3,3),
     &OMPKM1(3,3),OMK(3,3),OMPK(3,3),    X0SEC(3),RGMKM(3),RGMK(3),
     &OMGKM(3),OMPGKM(3),OMGK(3),OMPGK(3)
C
C
      ZERO = 0.D0
      DO 1 KC=1,3
      X0SEC (KC) = ZERO
      RGMKM (KC) = ZERO
      RGMK(KC) = ZERO
      OMGKM (KC) = ZERO
      OMPGKM (KC) = ZERO
      OMGK  (KC) = ZERO
      OMPGK (KC) = ZERO
    1 CONTINUE
      DO 12 KC=1,3
      DO 11 NE=1,NNO
      X0SEC (KC) = X0SEC (KC) + EN(NE,KP)*X0SK  (KC,NE)
      RGMKM (KC) = RGMKM (KC) + EN(NE,KP)*RMKM1 (KC,NE)
      RGMK  (KC) = RGMK  (KC) + EN(NE,KP)*RMK (KC,NE)
      OMGKM (KC) = OMGKM (KC) + EN(NE,KP)*OMKM1 (KC,NE)
      OMPGKM (KC) = OMPGKM (KC) + EN(NE,KP)*OMPKM1 (KC,NE)
      OMGK  (KC) = OMGK  (KC) + EN(NE,KP)*OMK (KC,NE)
      OMPGK (KC) = OMPGK (KC) + EN(NE,KP)*OMPK(KC,NE)
   11 CONTINUE
   12 CONTINUE
 9999 CONTINUE
      END
