      SUBROUTINE GDFINT (KP,NNO,AJACOB,PJACOB,EN,ENPRIM,X0PG,PN,PM,
     &                   FINT )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 02/10/95   AUTEUR GIBHHAY A.Y.PORTABILITE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C FONCTION: POUR UN ELEMENT DE POUTRE EN GRAND DEPLACEMENT, CALCULE LA
C           CONTRIBUTION DU POINT DE GAUSS NUMERO KP AUX FORCES INTERNES
C
C     IN  : KP        : NUMERO DU POINT DE GAUSS
C           NNO       : NOMBRE DE NOEUDS DE L'ELEMENT
C           AJACOB    : JACOBIEN
C           PJACOB    : POIDS * JACOBIEN
C           EN        : FONCTIONS DE FORME
C           ENPRIM    : DERIVEES DES FONCTIONS DE FORME
C           X0PG      : DERIVEES DES COORDONNEES PAR RAP. A L'ABS. CURV.
C           PN        : RESULTANTE DES FORCES AU PT DE GAUSS EN AX.GENE.
C           PM        : MOMENT RESULTANT AU PT DE GAUSS EN AXES GENERAUX
C
C     OUT : FINT      : FORCES INT. (CUMUL DES CONTRIB. DES PTS DE GAUS)
C ------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 EN(3,2),ENPRIM(3,2),X0PG(3),PN(3),PM(3),FINT(6,3),
     &B(6,6),BT(6,6),VECT(6),FORS(6)
C
      DO 11 NE=1,NNO
        CALL GDMB (NE,KP,AJACOB,EN,ENPRIM,X0PG, B)
        CALL TRANSP (B,6,6,6, BT,6)
        DO 1 I=1,3
          VECT(I) = PN(I)
          VECT(3+I) = PM(I)
1       CONTINUE
        CALL PROMAT (BT,6,6,6,VECT,6,6,1, FORS)
        DO 5 K=1,6
          FINT(K,NE) = FINT(K,NE) + PJACOB*FORS(K)
5       CONTINUE
11    CONTINUE
 9999 CONTINUE
      END
