      SUBROUTINE GDMUPS (NE,KP,AJACOB,EN,ENPRIM,   UPS)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 02/10/95   AUTEUR GIBHHAY A.Y.PORTABILITE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C FONCTION: POUR UN ELEMENT DE POUTRE EN GRAND DEPLACEMENT, CALCULE LA
C           CONTRIBUTION DU NOEUD NE A LA MATRICE UPSILON AU POINT DE
C           GAUSS KP. CETTE MATRICE UPSILON INTERVIENT DANS LA RIGIDITE
C           GEOMETRIQUE COMME LA MATRICE DE DEFORMATION B INTERVIENT
C           DANS LA RIGIDITE MATERIELLE.
C
C     IN  : NE        : NUMERO DU NOEUD
C           KP        : NUMERO DU POINT DE GAUSS
C           AJACOB    : JACOBIEN
C           EN        : FONCTIONS DE FORME
C           ENPRIM    : DERIVEES DES FONCTIONS DE FORME
C
C     OUT : UPS       : MATRICE 9*6
C ------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 EN(3,2),ENPRIM(3,2),UPS(9,6)
C
      ZERO = 0.D0
      UN   = 1.D0
      DO 2 J=1,6
      DO 1 I=1,9
      UPS(I,J) = ZERO
    1 CONTINUE
    2 CONTINUE
      UNSURJ = UN / AJACOB
      FORM   = EN(NE,KP)
      FORMPR = UNSURJ * ENPRIM(NE,KP)
      DO 3 I=1,6
      UPS(I,I) = FORMPR
    3 CONTINUE
      DO 4 I=1,3
      UPS(6+I,3+I) = FORM
    4 CONTINUE
 9999 CONTINUE
      END
