      SUBROUTINE GIMPGS ( RESULT, NNOFF, ABSC, GS, NUMERO, GI,
     &                    NDEG, NDIMTE, GTHI, EXTIM, TIME, IORDR, UNIT )
      IMPLICIT  NONE
C ......................................................................
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 05/09/2006   AUTEUR REZETTE C.REZETTE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C     - FONCTION REALISEE:  IMPRESSION DU TAUX DE RESTITUTION D'ENERGIE
C                           LOCAL SUIVANT LA METHODE CHOISIE
C  ENTREE
C
C    RESULT       --> NOM UTILISATEUR DU RESULTAT ET TABLE
C    NNOFF        --> NOMBRE DE NOEUDS DU FOND DE FISSURE
C    ABSC         --> ABSCISSES CURVILIGNES
C    GS           --> VALEURS DE G(S)
C    NUMERO       --> NUMERO DE LA METHODE   1 : THETA-LEGENDRE
C                                            2 : THETA-LAGRANGE
C                                            3 : LAGRANGE-LAGRANGE
C    UNIT         --> UNITE DU FICHIER D'AFFICHAGE
C    GI           --> VALEURS DES GI=<G,THETAI>
C    NDEG         --> DEGRE DU POLYNOME DE LEGENDRE
C    GTHI         --> VALEURS DES G ELEMENTAIRES AVANT LISSAGE
C    EXTIM        --> .TRUE. => TIME EXISTE
C    TIME         --> INSTANT DE CALCUL A IMPRIMER
C    IORDR        --> NUMERO D'ORDRE A IMPRIMER
C ......................................................................
C
      INTEGER         NNOFF, UNIT, NUMERO, NDEG, IORDR, I, I1,NDIMTE
      REAL*8          GS(1), GTHI(1), GI(1), TIME, ABSC(*)
      LOGICAL         EXTIM
      CHARACTER*8     RESULT
C ......................................................................
C
      WRITE(UNIT,*)
C
      IF (NUMERO.EQ.1) THEN
         WRITE(UNIT,555) NDEG
      ELSE IF (NUMERO.EQ.2) THEN
         WRITE(UNIT,556) NDEG
      ELSE IF (NUMERO.EQ.3) THEN
         WRITE(UNIT,557)
      ELSE IF (NUMERO.EQ.4) THEN
         WRITE(UNIT,558)
      ELSE IF (NUMERO.EQ.5) THEN
         WRITE(UNIT,559)
      ENDIF

      WRITE(UNIT,666)
      WRITE(UNIT,*)
C
      IF ( NUMERO .NE. 1 ) THEN
        WRITE(UNIT,770)
        WRITE(UNIT,*)
        WRITE(UNIT,*) ' NOEUD    GELEM(THETAI)'
        WRITE(UNIT,*)
        IF ( NUMERO .EQ. 5 ) THEN
          DO 20 I=1,NDIMTE
            WRITE(UNIT,110) I,GTHI(I)
20        CONTINUE
        ELSE
          DO 21 I=1,NNOFF
            WRITE(UNIT,110) I,GTHI(I)
21       CONTINUE
        ENDIF
        WRITE(UNIT,*)
      ENDIF
C
      IF ( (NUMERO.EQ.1) .OR. (NUMERO.EQ.2) ) THEN
        WRITE(UNIT,777)
        WRITE(UNIT,*)
        DO 10 I=1,NDEG+1
           I1 = I-1
           WRITE(UNIT,*) 'DEGRE ',I1,' : ',GI(I)
10      CONTINUE
        WRITE(UNIT,*)
      ENDIF
C
      IF(EXTIM) THEN
        WRITE(UNIT,*) '          INSTANT : ',TIME
        WRITE(UNIT,*) '          +++++++'
      ELSE IF (IORDR.NE.0) THEN
        WRITE(UNIT,*) '          NUMERO D''ORDRE : ',IORDR
        WRITE(UNIT,*) '          ++++++++++++++'
      ENDIF
      WRITE(UNIT,*)
      WRITE(UNIT,*)  'TAUX DE RESTITUTION D''ENERGIE LOCAL : ',RESULT
      WRITE(UNIT,*)
      WRITE(UNIT,*)  ' ABSC_CURV       G(S)'
      WRITE(UNIT,*)
      DO 30 I=1,NNOFF
         WRITE(UNIT,111) ABSC(I), GS(I)
30    CONTINUE
      WRITE(UNIT,*)
C
110   FORMAT(1X,I2,6X,D11.5)
111   FORMAT(1X,2(D11.5,4X))
555   FORMAT('THETA_LEGENDRE  G_LEGENDRE (DEGRE ',I2,')')
556   FORMAT('THETA_LAGRANGE  G_LEGENDRE (DEGRE ',I2,')')
557   FORMAT('THETA_LAGRANGE  G_LAGRANGE')
558   FORMAT('THETA_LAGRANGE  G_LAGRANGE_NO_NO')
559   FORMAT('THETA_LAGRANGE_REGU  G_LAGRANGE_REGU')
666   FORMAT(37('*'))
770   FORMAT('VALEURS DE G ELEMENTAIRES AVANT LISSAGE :')
777   FORMAT('COEF DE G(S) DANS LA BASE DE POLYNOMES DE LEGENDRE :')
C
      END
