      SUBROUTINE GLEGEN(NBRE,LOBJ2,XL,ABSGAM,LEGEN)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 21/02/96   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     ------------------------------------------------------------------
C
C FONCTION REALISEE:
C
C      CALCUL DES VALEURS DES POLYNOMES DE LEGENDRE
C
C     ------------------------------------------------------------------
C ENTREE:
C        NBRE       : DEGRE DES POLYNOMES DE LEGENDRE
C        LOBJ2      : NOMBRE DE NOEUDS SUR GAMMA0
C        XL         : LONGUEUR DE LA FISSURE
C        ABSGAM     : ABSCISSES CURVILIGNES
C
C SORTIE:
C        LEGEN      : VALEURS DES POLYNOMES DE LEGENDRE
C     ------------------------------------------------------------------
C
C
      INTEGER           LOBJ2,NBRE,IADABS,IADRT,IADPO
C
      REAL*8            XL,S1,COEF
C
C---------------- COMMUNS NORMALISES  JEVEUX  --------------------------
      COMMON/IVARJE/ZI(1)
      COMMON/RVARJE/ZR(1)
      COMMON/CVARJE/ZC(1)
      COMMON/LVARJE/ZL(1)
      COMMON/KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      INTEGER ZI
      REAL*8 ZR
      COMPLEX*16 ZC
      LOGICAL ZL
      CHARACTER*8  ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32,JEXNOM,JEXNUM
      CHARACTER*80 ZK80
C---------------- FIN COMMUNS NORMALISES  JEVEUX  ----------------------
      CHARACTER*24 ABSGAM
      REAL*8 LEGEN(1)
C
C   POLYNOMES DE LEGENDRE
C
      PLEG2(X) = (3.D0*X*X-1.D0)/2.D0
      PLEG3(X) = X*(5.D0*X*X-3.D0)/2.D0
      PLEG4(X) = (35.D0*X**4-30.D0*X*X+3.D0)/8.D0
      PLEG5(X) = X*(63.D0*X**4-70.D0*X*X+15.D0)/8.D0
      PLEG6(X) = (231.D0*X**6-315.D0*X**4+105.D0*X*X-5.D0)/16.D0
      PLEG7(X) = X*(429.D0*X**6-693.D0*X**4+315.D0*X*X-35.D0)/16.D0
C
      CALL JEMARQ()
      CALL JEVEUO(ABSGAM,'L',IADABS)
C
C CALCUL DES MODULES DES CHAMPS THETA = POLYNOMES DE LEGENDRE
C
      CALL WKVECT('&&LEGEND.VALPOL','V V R8',(NBRE+1)*LOBJ2,IADPO)
C
C COEFFICIENTS POUR LES 2 PREMIERS POLYNOMES
C
      COF1 = SQRT(1.D0/XL)
      COF2 = SQRT(3.D0/XL)
C
      DO 1 I=1,LOBJ2
        ZR(IADPO + I - 1) = 1.D0
        LEGEN(I) = COF1*ZR(IADPO + I - 1)
        IF(NBRE.NE.0) THEN
          ZR(IADPO + LOBJ2 + I - 1) = -1+2*ZR(IADABS + I - 1)/XL
          LEGEN(LOBJ2 + I) = COF2*ZR(IADPO + LOBJ2 + I - 1)
        ENDIF
1     CONTINUE
C
      IF(NBRE.GE.2) THEN
         COEF  = SQRT(5.D0/XL)
         DO 3 J=1,LOBJ2
           S1  = -1+2*ZR(IADABS + J - 1)/XL
           LEGEN( 2*LOBJ2 + J ) = COEF*PLEG2(S1)
3        CONTINUE
      ENDIF
C
      IF(NBRE.GE.3) THEN
         COEF  = SQRT(7.D0/XL)
         DO 4 J=1,LOBJ2
           S1  = -1+2*ZR(IADABS + J - 1)/XL
           LEGEN( 3*LOBJ2 + J ) = COEF*PLEG3(S1)
4        CONTINUE
      ENDIF
C
      IF(NBRE.GE.4) THEN
         COEF  = SQRT(9.D0/XL)
         DO 5 J=1,LOBJ2
           S1  = -1+2*ZR(IADABS + J - 1)/XL
           LEGEN( 4*LOBJ2 + J ) = COEF*PLEG4(S1)
5        CONTINUE
      ENDIF
C
      IF(NBRE.GE.5) THEN
         COEF  = SQRT(11.D0/XL)
         DO 6 J=1,LOBJ2
           S1  = -1+2*ZR(IADABS + J - 1)/XL
           LEGEN( 5*LOBJ2 + J ) = COEF*PLEG5(S1)
6        CONTINUE
      ENDIF
C
      IF(NBRE.GE.6) THEN
         COEF  = SQRT(13.D0/XL)
         DO 7 J=1,LOBJ2
           S1  = -1+2*ZR(IADABS + J - 1)/XL
           LEGEN( 6*LOBJ2 + J ) = COEF*PLEG6(S1)
7        CONTINUE
      ENDIF
C
      IF(NBRE.GE.7) THEN
         COEF  = SQRT(15.D0/XL)
         DO 8 J=1,LOBJ2
           S1  = -1+2*ZR(IADABS + J - 1)/XL
           LEGEN( 7*LOBJ2 + J ) = COEF*PLEG7(S1)
8        CONTINUE
      ENDIF
C
      CALL JEDETR('&&LEGEND.VALPOL')
      CALL JEDEMA()
      END
