      FUNCTION GPLASS (NMNBN,NMPLAS,BEND)

      IMPLICIT NONE

C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 19/05/2009   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C     CALCUL DES CONDITIONS DE PLASTICITE G
C
C IN  NMNBN : FORCE - BACKFORCE
C IN  NMPLAS : MOMENTS LIMITES DE PLASTICITE
C IN  BEND : SIGNE DE LA FLEXION (1 POSITIVE, 2 NEGATIVE)
C
C OUT GPLASS : CONDITIONS DE PLASTICITE G

      INTEGER BEND

      REAL*8 GPLASS, NMNBN(6), NMPLAS(2,3)
      REAL*8 X, Y, COEF

      X = NMNBN(4)-NMPLAS(BEND,1)
      Y = NMNBN(5)-NMPLAS(BEND,2)

      COEF = 1.001D0

      IF (BEND .EQ. 1) THEN
        GPLASS = MAX(COEF*X + Y, X/COEF + Y)
      ELSE
        GPLASS = MAX(-COEF*X - Y,-X/COEF - Y)
      ENDIF

      END
