      SUBROUTINE  HPLASS(NMNBN,NMPLAS,NMDPLA,NMDDPL,BEND,HPLAS)

      IMPLICIT NONE

C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 19/05/2009   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C======================================================================
C
C     CALCUL LA MATRICE HESSIENNE DU CRITERE DE PLASTICITE
C
C IN  NMNBN : MOMENT DE RAPPEL
C IN  NMPLAS : MOMENTS LIMITES DE PLASTICITE
C IN  NMDPLA : DERIVEES DES MOMENTS LIMITES DE PLASTICITE
C IN  NMDDPL : DERIVEES SECONDES DES MOMENTS LIMITES DE PLASTICITE
C IN  BEND : SIGNE DE LA FLEXION (1 POSITIVE, 2 NEGATIVE)
C
C OUT HPLAS : MATRICE HESSIENNE DU CRITERE DE PLASTICITE

      INTEGER BEND

      REAL*8 HPLAS(6,*), NMNBN(6), NMPLAS(2,3)
      REAL*8 NMDPLA(2,2), NMDDPL(2,2)

      CALL R8INIR(6*6,0.D0,HPLAS,1)

      HPLAS(1,1) = NMDDPL(BEND,1)*(NMNBN(5)-NMPLAS(BEND,2))
      HPLAS(2,2) = NMDDPL(BEND,2)*(NMNBN(4)-NMPLAS(BEND,1))
      HPLAS(2,1) = -NMDPLA(BEND,1)*NMDPLA(BEND,2)
      HPLAS(1,2) = HPLAS(2,1)
      HPLAS(5,1) = NMDPLA(BEND,1)
      HPLAS(1,5) = NMDPLA(BEND,1)
      HPLAS(4,2) = NMDPLA(BEND,2)
      HPLAS(2,4) = NMDPLA(BEND,2)
      HPLAS(4,5) = -1.D0
      HPLAS(5,4) = -1.D0
      HPLAS(6,6) = 2.D0

      END
