      SUBROUTINE INDRAD(OPTION,COMPOR,LIGREL,CHSIG1,CHSIG2,
     &                  CHVAR1,CHVAR2,CHELE2,CHELEM)
      IMPLICIT NONE
      CHARACTER*(*) OPTION,COMPOR,LIGREL,CHSIG1,CHSIG2
      CHARACTER*(*) CHVAR1,CHVAR2,CHELE2,CHELEM
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 01/02/2011   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
C     BUT:
C       CALCUL DES INDICATEURS LOCAUX DE DECHARGE
C       ET DE PERTE DE RADIALITE
C
C
C     ARGUMENTS:
C     ----------
C
C      ENTREE :
C-------------
C IN   RESU     : NOM DE LA SD_RESULTAT
C IN   OPTION   : OPTION DE CALCUL
C IN   COMPOR   : CARTE DE COMPORTEMENT
C IN   LIGREL   : LIGREL DU MODELE
C IN   CHSIG1   : CONTRAINTES AUX PTS. DE GAUSS A L'INSTANT T
C IN   CHSIG2   : CONTRAINTES AUX PTS. DE GAUSS A L'INSTANT T+DT
C IN   CHVAR1   : VARIABLES INTERNES AUX PTS. DE GAUSS A L'INSTANT T
C IN   CHVAR2   : VARIABLES INTERNES AUX PTS. DE GAUSS A L'INSTANT T+DT
C
C      SORTIE :
C-------------
C OUT  CHELEM   : NOM DU CHAMP DES INDICATEURS LOCAUX
C
C ......................................................................
C
      INTEGER NBIN,NBOUT

      CHARACTER*8 LPAIN(5),LPAOUT(1)
      CHARACTER*24 LCHIN(5),LCHOUT(1)
C
C ----------------------------------------------------------------------
C
      IF (OPTION.EQ.'DERA_ELGA') THEN
C
        LPAIN(1) = 'PCONTMR'
        LCHIN(1) = CHSIG1
        LPAIN(2) = 'PCONTPR'
        LCHIN(2) = CHSIG2
        LPAIN(3) = 'PVARIMR'
        LCHIN(3) = CHVAR1
        LPAIN(4) = 'PVARIPR'
        LCHIN(4) = CHVAR2
        LPAIN(5) = 'PCOMPOR'
        LCHIN(5) = COMPOR
C
        NBIN = 5
C
        LPAOUT(1) = 'PDERAPG'
        LCHOUT(1) = CHELEM
C
        NBOUT = 1
C
      ELSE IF (OPTION.EQ.'DERA_ELNO') THEN
C
        LPAIN(1) = 'PDERAPG'
        LCHIN(1) = CHELE2
C
        NBIN = 1
C
        LPAOUT(1) = 'PDERANO'
        LCHOUT(1) = CHELEM
C
        NBOUT = 1
C
      ELSE
C      
        CALL ASSERT(.FALSE.)
C
      ENDIF
C
      CALL CALCUL('C',OPTION,LIGREL,NBIN,LCHIN,LPAIN,
     &            NBOUT,LCHOUT,LPAOUT,'G','OUI')
C
      END
