      SUBROUTINE KCOUDE (NBRDDL,POIDS,B,C,K)
      IMPLICIT NONE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 30/11/1999   AUTEUR JMBHH01 J.M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C ......................................................................
C
C    - FONCTION REALISEE:  CALCUL DE LA MATRICES K
C
C    - ARGUMENTS :
C         ENTREE :     NBRDDL  : NBRE DES DDL
C                      POIDS   : PRODUITS DES DIFFERENTS POIDS
C                                D'INTEGRATION ET DU JACOBIEN
C                      B       : MATRICE DE DEFORMATION
C                      C       : MATRICE DE COMPORTEMENT
C         SORTIE :     K       : MATRICE DE RIGIDITE
C
C ......................................................................
C
      INTEGER            I,J, NBRDDL
CJMP      PARAMETER (NBRDDL=63)
      REAL*8             B(4,NBRDDL),C(4,4),K(NBRDDL,NBRDDL),POIDS
      REAL*8 C11B1I,C12B1I,C13B1I,C21B2I,C31B3I,C32B3I,C22B2I,C23B2I
      REAL*8 C33B3I,C44B4I,CB1J,CB2J,CB3J
C
C
C CALCUL DE LA MATRICE DE RIGIDITE K
C
C
      DO 10 I=1, NBRDDL
         C11B1I=C(1,1)* B(1,I)
         C12B1I=C(1,2)* B(1,I)
         C13B1I=C(1,3)* B(1,I)
         C21B2I=C(2,1)* B(2,I)
         C31B3I=C(3,1)* B(3,I)
         C32B3I=C(3,2)* B(3,I)
         C22B2I=C(2,2)* B(2,I)
         C23B2I=C(2,3)* B(2,I)
         C33B3I=C(3,3)* B(3,I)
         C44B4I=C(4,4)* B(4,I)
         CB1J=C11B1I+C21B2I+C31B3I
         CB2J=C22B2I+C12B1I+C32B3I
         CB3J=C13B1I+C23B2I+C33B3I
         DO 20 J=1, I
         K(I,J) = K(I,J) +(
     &             CB1J*B(1,J)+CB2J*B(2,J)+CB3J*B(3,J)+C44B4I*B(4,J)
     &           ) *POIDS
         K(J,I) = K(I,J)
20       CONTINUE
10    CONTINUE
C
C FIN DU CALCUL DE LA MATRICE DE RIGIDITE
C
C
9999  CONTINUE

      END
