      SUBROUTINE MAGLRC (ZIMAT,MATR,DELAS,ECR)
      IMPLICIT NONE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 19/05/2009   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
C     CHARACTER*32 JEXNUM,JEXNOM,JEXR8,JEXATR
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------

      INTEGER I, JCOQU, ICACOQ, ZIMAT

      REAL*8 MATR(*), DELAS(6,6), R8B
      REAL*8 VALRES(15), VGLOB(3), EPAIS
      REAL*8 ECR(*), ALPH, BETA, VEL, R8DGRD

      CHARACTER*2 CODRES(15)
      CHARACTER*8 NOMRES(15)
      CHARACTER*16 PHENOM

      CALL R8INIR(6*6,0.0D0,DELAS,1)
      PHENOM = 'GLRC_DAMAGE'
      IF(PHENOM . NE . 'GLRC_DAMAGE' ) THEN
        CALL U2MESK('F','ELEMENTS2_32',1,PHENOM)
      ENDIF

C     EPAISSEUR
      CALL JEVECH('PCACOQU','L',JCOQU)
      EPAIS = ZR(JCOQU)
      NOMRES(1)  = 'EPAIS'
      CALL RCVALA(ZIMAT,' ',PHENOM,0,' ',R8B,1,NOMRES,
     &              VALRES,CODRES,'FM')
      IF(VALRES(1) .NE. EPAIS) THEN
        VALRES(2) = EPAIS
        CALL U2MESG('F','ELEMENTS5_42',0,' ',0,0,2,VALRES)
      ENDIF

C     ELAS

      NOMRES(1)  = 'E'
      NOMRES(2)  = 'NU'

      CALL RCVALA(ZIMAT,' ','ELAS            ',0,' ',R8B,2,NOMRES,
     &              VALRES,CODRES,'FM')
      MATR(6) = VALRES(1)
      MATR(7) = VALRES(2)

C     GLRC_DAMAGE

C     MATRICE ELASTIQUE MEMBRANE/CISAILLEMENT

      NOMRES(1)  = 'BN11'
      NOMRES(2)  = 'BN12'
      NOMRES(3)  = 'BN22'
      NOMRES(4)  = 'BN33'
      NOMRES(5)  = 'BT1'
      NOMRES(6)  = 'BT2'
      NOMRES(7)  = 'BM11'
      NOMRES(8)  = 'BM12'
      NOMRES(9)  = 'BM22'
      NOMRES(10) = 'BM33'

      CALL RCVALA(ZIMAT,' ',PHENOM,0,' ',R8B,10,NOMRES,
     &                 VALRES,CODRES,'FM')

      MATR(1)  = 1.0D0
      MATR(2)  = VALRES(1)
      MATR(3)  = VALRES(2)
      MATR(4)  = VALRES(3)
      MATR(5)  = VALRES(4)
      DELAS(4,4) = VALRES(7)
      DELAS(4,5)  = VALRES(8)
      DELAS(5,4)  = DELAS(4,5)
      DELAS(5,5)  = VALRES(9)
      DELAS(6,6)  = VALRES(10)
      MATR(14) = VALRES(5) 
      MATR(15) = VALRES(6) 

C     SEUILS ET PENTES

      NOMRES(1)  = 'MF1'
      NOMRES(2)  = 'MF2'
      NOMRES(3)  = 'QP1'
      NOMRES(4)  = 'QP2'
      NOMRES(5)  = 'GAMMA'

      CALL RCVALA( ZIMAT,' ',PHENOM,0,' ',R8B,5,NOMRES,
     &                 VALRES,CODRES,'FM')

      MATR(8)  = VALRES(1)
      MATR(9)  = VALRES(2)
      MATR(10) = VALRES(3)
      MATR(11) = VALRES(4)
      MATR(12) = VALRES(5) 

C     PARAMETRES TENSEUR DE PRAGER
C     MEMBRANE
      NOMRES(1)  = 'C1N1'
      NOMRES(2)  = 'C1N2'
      NOMRES(3)  = 'C1N3'
      NOMRES(4)  = 'C2N1'
      NOMRES(5)  = 'C2N2'
      NOMRES(6)  = 'C2N3'

      CALL RCVALA( ZIMAT,' ',PHENOM,0,' ',R8B,6,NOMRES,
     &                 VALRES,CODRES,'FM')

      MATR(16) = VALRES(1)
      MATR(17) = VALRES(2)
      MATR(18) = VALRES(3)
      MATR(22) = VALRES(4)
      MATR(23) = VALRES(5) 
      MATR(24) = VALRES(6) 

C     FLEXION

      NOMRES(1)  = 'C1M1'
      NOMRES(2)  = 'C1M2'
      NOMRES(3)  = 'C1M3'
      NOMRES(4)  = 'C2M1'
      NOMRES(5)  = 'C2M2'
      NOMRES(6)  = 'C2M3'

      CALL RCVALA( ZIMAT,' ',PHENOM,0,' ',R8B,6,NOMRES,
     &                 VALRES,CODRES,'FM')

      MATR(19) = VALRES(1)
      MATR(20) = VALRES(2)
      MATR(21) = VALRES(3)
      MATR(25) = VALRES(4)
      MATR(26) = VALRES(5) 
      MATR(27) = VALRES(6) 

      DELAS(1,1) = MATR(2)
      DELAS(1,2) = MATR(3)
      DELAS(2,1) = DELAS(1,2)
      DELAS(2,2) = MATR(4)
      DELAS(3,3) = MATR(5)

      CALL JEVECH('PCACOQU','L',ICACOQ)
      ALPH = ZR(ICACOQ+1)*R8DGRD()
      BETA = ZR(ICACOQ+2)*R8DGRD()

      VGLOB(1) = COS(BETA)*COS(ALPH)
      VGLOB(2) = COS(BETA)*SIN(ALPH)
      VGLOB(3) = -SIN(BETA)
      VEL = VGLOB(1)*VGLOB(1) + VGLOB(2)*VGLOB(2)
      VEL = VEL + VGLOB(3)*VGLOB(3)
      VEL = SQRT(VEL)
      DO 80, I = 1,3
        ECR(10 + I)  = VGLOB(I)/VEL
  80  CONTINUE

      END
