      SUBROUTINE MATVEC (NORDRE,AMAT,NOMBV,V1,V2,   VECRES)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 29/09/2006   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 AMAT(*),V1(*),V2(*),VECRES(*)
      REAL*8 VSOM(9)
C ---------------------------------------------
C     BUT:   POUR LES ELEMENTS DE CABLE, CALCUL DU PRODUIT DE LA MATRICE
C            AMAT D'ORDRE NORDRE PAR:
C            . SI NOMBV=1, LE VECTEUR V1;
C            . SI NOMBV=2, LA SOMME DES VECTEURS V1 ET V2.
C            LE VECTEUR RESULTAT EST MIS DANS VECRES.
C     IN: NORDRE
C         AMAT
C         NOMBV
C         V1
C         V2
C     OUT: VECRES
C ---------------------------------------------
C
      ZERO = 0.D0
      IF (NOMBV.EQ.1) THEN
        DO 1 I=1,NORDRE
          VSOM(I) = V1(I)
    1   CONTINUE
      ELSE IF (NOMBV.EQ.2) THEN
        DO 2 I=1,NORDRE
          VSOM(I) = V1(I) + V2(I)
    2   CONTINUE
      ELSE
        CALL U2MESS('F','ELEMENTS2_34')
      ENDIF
      K = 0
      DO 12 I=1,NORDRE
        VECRES(I) = ZERO
        DO 11 J=1,NORDRE
          K = K + 1
          VECRES(I) = VECRES(I) + AMAT(K) * VSOM(J)
   11   CONTINUE
   12 CONTINUE
      END
