      SUBROUTINE MMFORM(NDIM  ,NOMMAE,NOMMAM,NNE   ,NNM   ,
     &                  XPC   ,YPC   ,XPR   ,YPR   ,FFE   ,
     &                  DFFE  ,DDFFE ,FFM   ,DFFM  ,DDFFM ,
     &                  FFL   ,DFFL  ,DDFFL )
C     
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 22/12/2009   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*8 NOMMAE,NOMMAM 
      REAL*8      XPC,YPC,XPR,YPR  
      INTEGER     NDIM,NNE,NNM
      REAL*8      FFE(9),DFFE(2,9),DDFFE(3,9)       
      REAL*8      FFM(9),DFFM(2,9),DDFFM(3,9)   
      REAL*8      FFL(9),DFFL(2,9),DDFFL(3,9)   
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - UTILITAIRE)
C
C CALCUL DES FONCTIONS DE FORME ET DE LEUR DERIVEES EN UN POINT 
C DE L'ELEMENT DE REFERENCE
C
C ----------------------------------------------------------------------
C
C
C IN  NDIM   : DIMENSION DU MODELE
C IN  NOMMAE : NOM DE LA MAILLE ESCLAVE
C IN  NOMMAM : NOM DE LA MAILLE MAITRE
C IN  XPC    : POINT DE CONTACT SUIVANT KSI1
C IN  YPC    : POINT DE CONTACT SUIVANT KSI2 
C IN  XPR    : PROJECTION DU POINT DE CONTACT SUIVANT KSI1
C IN  YPR    : PROJECTION DU POINT DE CONTACT SUIVANT KSI2 
C OUT FFE    : FONCTIONS DE FORMES ESCLAVES
C OUT DFFE   : DERIVEES PREMIERES DES FONCTIONS DE FORME ESCLAVES
C OUT DDFFE  : DERIVEES SECONDES DES FONCTIONS DE FORME ESCLAVES
C OUT FFM    : FONCTIONS DE FORMES MAITRES
C OUT DFFM   : DERIVEES PREMIERES DES FONCTIONS DE FORME MAITRES
C OUT DDFFM  : DERIVEES SECONDES DES FONCTIONS DE FORME MAITRES
C OUT FFL    : FONCTIONS DE FORMES LAGR. 
C OUT DFFL   : DERIVEES PREMIERES DES FONCTIONS DE FORME LAGR.
C OUT DDFFL  : DERIVEES SECONDES DES FONCTIONS DE FORME LAGR. 
C
C ----------------------------------------------------------------------
C
      INTEGER I
C
C ----------------------------------------------------------------------
C
C
C --- FONCTIONS DE FORMES ET DERIVEES POUR LES DDL ESCLAVES
C
      CALL MMFONF(NDIM  ,NNE   ,NOMMAE,XPC   ,YPC   ,
     &            FFE   ,DFFE  ,DDFFE )
C  
C --- FONCTIONS DE FORMES ET DERIVEES POUR LES DDL MAITRES
C
      CALL MMFONF(NDIM  ,NNM   ,NOMMAM,XPR   ,YPR   ,
     &            FFM   ,DFFM  ,DDFFM )
C  
C --- FONCTIONS DE FORMES ET DERIVEES POUR LES DDL DE LAGRANGE
C
      DO 10 I=1,9
        FFL(I)     = FFE(I)
        DFFL(1,I)  = DFFE(1,I)
        DFFL(2,I)  = DFFE(2,I)
        DDFFL(1,I) = DDFFE(1,I)
        DDFFL(2,I) = DDFFE(2,I) 
        DDFFL(3,I) = DDFFE(3,I)
  10  CONTINUE

      END
