      SUBROUTINE MMLAG2(NDIM  ,NBDM  ,NNL   ,JDEPDE,TYPBAR,
     &                  TYPRAC,DLAGRC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 22/12/2009   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INTEGER      NBDM,NNL,NDIM
      INTEGER      JDEPDE
      INTEGER      TYPBAR,TYPRAC
      REAL*8       DLAGRC
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - UTILITAIRE)
C
C CALCUL DES INCREMENTS - LAGRANGE DE CONTACT
C MODIFICATION BARSOUM/RACCORD
C
C ----------------------------------------------------------------------
C
C
C DEPDEL - INCREMENT DE DEPLACEMENT DEPUIS DEBUT DU PAS DE TEMPS
C GEOMAx - GEOMETRIE ACTUALISEE GEOM_INIT + DEPMOI 
C
C
C IN  NBDM   : NB DE DDL DE LA MAILLE ESCLAVE
C                NDIM = 2 -> NBDM = DX/DY/LAGR_C/LAGR_F1
C                NDIM = 3 -> NBDM = DX/DY/DZ/LAGR_C/LAGR_F1/LAGR_F2
C IN  NNL    : NOMBRE DE NOEUDS LAGRANGE 
C IN  JDEPDE : ADRESSE JEVEUX POUR DEPDEL
C IN  TYPBAR : ARETE OU POINT EN FOND DE FISSURE
C               1 - ARETE 1-2
C               2 - ARETE 2-3
C               3 - ARETE 3-4
C               4 - ARETE 4-1
C               5 - NOEUD 1
C               6 - NOEUD 2
C IN  TYPRAC : ARETE SUR LAQUELLE UN NOEUD MILIEU EST A LINEARISER
C               1 - ARETE 1-2
C               2 - ARETE 2-3
C               3 - ARETE 3-4
C               4 - ARETE 4-1
C OUT DLAGRC : INCREMENT DEPDEL DU LAGRANGIEN DE CONTACT
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER   INOC
      REAL*8    DLAGCN(9)
C
C ----------------------------------------------------------------------
C 
      CALL JEMARQ()
C
C --- LAGRANGE DE CONTACT AUX NOEUDS
C
      DO 10 INOC = 1,NNL
        DLAGCN(INOC) = ZR(JDEPDE+(INOC-1)*NBDM+NDIM)
 10   CONTINUE
C
C --- MODIFICATIONS DES LAGR. CONTACT. NODAUX POUR FOND_FISSURE
C
      IF (TYPBAR.EQ.1) THEN
        DLAGRC    = 0.5D0*(DLAGCN(1)+DLAGCN(2))
      ELSEIF (TYPBAR.EQ.2) THEN
        DLAGRC    = 0.5D0*(DLAGCN(2)+DLAGCN(3))
      ELSEIF (TYPBAR.EQ.3) THEN
        DLAGRC    = 0.5D0*(DLAGCN(3)+DLAGCN(4))
      ELSEIF (TYPBAR.EQ.4) THEN
        DLAGRC    = 0.5D0*(DLAGCN(1)+DLAGCN(4))
      ELSEIF (TYPBAR.EQ.5) THEN
        DLAGRC    = DLAGCN(2)
      ELSEIF (TYPBAR.EQ.6) THEN
        DLAGRC    = DLAGCN(1)  
      ELSEIF (TYPBAR.NE.0) THEN         
        CALL ASSERT(.FALSE.)
      ENDIF                    
C
C --- MODIFICATIONS DES LAGR. CONTACT. NODAUX POUR RACCORD LINE/QUAD 
C                        
      IF (TYPRAC.EQ.1) THEN
        DLAGRC    = 0.5D0*(DLAGCN(1)+DLAGCN(2))
      ELSEIF (TYPRAC.EQ.2) THEN
        DLAGRC    = 0.5D0*(DLAGCN(2)+DLAGCN(3))        
      ELSEIF (TYPRAC.EQ.3) THEN
        DLAGRC    = 0.5D0*(DLAGCN(3)+DLAGCN(4))
      ELSEIF (TYPRAC.EQ.4) THEN
        DLAGRC    = 0.5D0*(DLAGCN(1)+DLAGCN(4))
      ELSEIF (TYPRAC.NE.0) THEN         
        CALL ASSERT(.FALSE.)
      ENDIF
C
      CALL JEDEMA()
C
      END
