      SUBROUTINE MMLAGM(NBDM  ,NDIM  ,NNL   ,JDEPDE,FFL   ,
     &                  DLAGRC,DLAGRF)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 22/12/2009   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INTEGER      NBDM,NDIM,NNL
      INTEGER      JDEPDE
      REAL*8       FFL(9)
      REAL*8       DLAGRC,DLAGRF(2)
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - UTILITAIRE)
C
C CALCUL DES INCREMENTS - LAGRANGE DE CONTACT ET FROTTEMENT
C
C ----------------------------------------------------------------------
C
C
C DEPDEL - INCREMENT DE DEPLACEMENT DEPUIS DEBUT DU PAS DE TEMPS
C GEOMAx - GEOMETRIE ACTUALISEE GEOM_INIT + DEPMOI 
C
C
C IN  NBDM   : NB DE DDL DE LA MAILLE ESCLAVE
C                NDIM = 2 -> NBDM = DX/DY/LAGR_C/LAGR_F1
C                NDIM = 3 -> NBDM = DX/DY/DZ/LAGR_C/LAGR_F1/LAGR_F2
C IN  NDIM   : DIMENSION DU PROBLEME
C IN  NNL    : NOMBRE DE NOEUDS LAGRANGE 
C IN  JDEPDE : ADRESSE JEVEUX POUR DEPDEL
C IN  FFL    : FONCTIONS DE FORMES LAGR.
C OUT DLAGRC : INCREMENT DEPDEL DU LAGRANGIEN DE CONTACT
C OUT DLAGRF : INCREMENT DEPDEL DES LAGRANGIENS DE FROTTEMENT
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER   INOC,INOF
C
C ----------------------------------------------------------------------
C 
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DLAGRC    = 0.D0
      DLAGRF(1) = 0.D0
      DLAGRF(2) = 0.D0         
C
C --- LAGRANGE DE CONTACT AU POINT D'INTEGRATION
C
      DO 132 INOC = 1,NNL
        DLAGRC = DLAGRC  + FFL(INOC)*
     &                   ZR(JDEPDE+(INOC-1)*NBDM+(NDIM+1)-1)
132   CONTINUE   
C
C --- LAGRANGES DE FROTTEMENT AU POINT D'INTEGRATION
C
      DO 133 INOF = 1,NNL
        DLAGRF(1) = DLAGRF(1)  + FFL(INOF)*
     &              ZR(JDEPDE+(INOF-1)*NBDM+(NDIM+2)-1)
        IF (NDIM.EQ.3) THEN
          DLAGRF(2) = DLAGRF(2)  + FFL(INOF)*
     &                ZR(JDEPDE+(INOF-1)*NBDM+(NDIM+3)-1) 
        ENDIF    
133   CONTINUE      
C
      CALL JEDEMA()
C
      END
