      SUBROUTINE MMMVAS(NDIM  ,NNE   ,NNM   ,NNL   ,NBDM  ,
     &                  NBCPS ,VECTEE,VECTMM,VECTCC,VECTFF,
     &                  VTMP)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 22/12/2009   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INTEGER      NBDM,NDIM,NNL,NNE,NNM,NBCPS
      REAL*8       VECTCC(9)
      REAL*8       VECTFF(18)    
      REAL*8       VECTEE(27),VECTMM(27)
      REAL*8       VTMP(81)     
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - UTILITAIRE)
C
C ASSEMBLAGE DES VECTEURS
C
C ----------------------------------------------------------------------
C
C
C IN  NBDM   : NOMBRE DE CMP/NOEUD ESCLAVE DES DEPL+LAGR_C+LAGR_F
C IN  NDIM   : DIMENSION DU PROBLEME
C IN  NNL    : NOMBRE DE NOEUDS LAGRANGE 
C IN  NNE    : NOMBRE DE NOEUDS ESCLAVES
C IN  NNM    : NOMBRE DE NOEUDS MAITRES
C IN  NBCPS  : NOMBRE DE COMPOSANTES/NOEUD DES LAGR_C+LAGR_F
C IN  VECTEE : VECTEUR ELEMENTAIRE DEPL_E
C IN  VECTMM : VECTEUR ELEMENTAIRE DEPL_M
C IN  VECTCC : VECTEUR ELEMENTAIRE LAGR_C
C IN  VECTFF : VECTEUR ELEMENTAIRE LAGR_F
C OUT VTMP   : VECTEUR ELEMENTAIRE DE CONTACT/FROTTEMENT
C
C ----------------------------------------------------------------------
C
      INTEGER   II,JJ
      INTEGER   INOE,INOM,INOC,INOF,IDIM,ICMP
      INTEGER   NBCPF
C
C ----------------------------------------------------------------------
C


C --- DEPL_ESCL

      DO 70 INOE = 1,NNE
        DO 60 IDIM = 1,NDIM
          II = NBDM*(INOE-1)+IDIM
          JJ = NDIM*(INOE-1)+IDIM
          VTMP(II) = VTMP(II)+VECTEE(JJ)  
   60   CONTINUE
   70 CONTINUE

C --- DEPL_MAIT

      DO 71 INOM = 1,NNM
        DO 61 IDIM = 1,NDIM
          II = NBDM*NNE+NDIM*(INOM-1)+IDIM
          JJ = NDIM*(INOM-1)+IDIM
          VTMP(II) = VTMP(II)+VECTMM(JJ)  
   61   CONTINUE
   71 CONTINUE

C --- LAGR_C

      DO 72 INOC = 1,NNL
        II = NBDM*(INOC-1)+NDIM+1
        JJ = INOC
        VTMP(II) = VTMP(II)+VECTCC(JJ)   
  72  CONTINUE
  
C --- LAGR_F1/F2

      NBCPF  = NBCPS-1
      DO 73 INOF = 1,NNL
        DO 63 ICMP = 1,NBCPF
          II = NBDM*(INOF-1)+NDIM+1+ICMP
          JJ = NBCPF*(INOF-1)+ICMP
          VTMP(II) = VTMP(II)+VECTFF(JJ)  
   63   CONTINUE
   73 CONTINUE  

C
      END
