      SUBROUTINE NMNET1(ZIMAT,NMNBN,CNBN
     &           ,CPLAS,CZEF,CZEG,CIEF
     &           ,CDEPS,CDTG,CIER,CDEPSP,DC,NORMM)
        IMPLICIT  NONE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 19/05/2009   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C     CALCUL DE CNBN ET CDEPSP QUAND UN CRITERE PLASTIQUE EST ACTIVE
C
C IN  ZIMAT : ADRESSE DE LA LISTE DE MATERIAU CODE
C IN  NMNBN : FORCE - BACKFORCE
C IN  CDTG : MATRICE TANGENTE
C IN  DC : MATRICE ELASTIQUE + CONSTANTES DE PRAGER
C
C OUT CNBN : NOUVELLE FORCE - BACKFORCE
C OUT CPLAS : NOUVEAUX MOMENTS LIMITES DE PLASTICITE
C OUT CZEF : NOUVEAU ZERO ADIMENSIONNEL POUR LE CRITERE F
C OUT CZEG : NOUVEAU ZERO ADIMENSIONNEL POUR LE CRITERE G
C OUT CIEF : NOUVEAU CIEF > 0 : NBN HORS DE LA ZONE DE DEFINITION DE MP
C OUT CDEPS : NOUVEL INCREMENT DE DEFORMATION DANS LE REPERE ORTHO
C OUT CIER : NOUVEAU CODE ERREUR
C OUT CDEPSP : NOUVEL INCREMENT DE DEF PLASTIQUE DANS LE REPERE ORTHO
C OUT NORMM : NORME SUR LA FONCTION MP = F(N)

      INTEGER J, CIEF, ZIMAT, CIER

      REAL*8 NMNBN(6), CNBN(6), CPLAS(2,3), CZEF, CZEG, NORMM
      REAL*8 CDEPS(6), CDTG(6,6), CDEPSP(6), DC(6,6), CP(6), GPLASS

      CALL MATMUL(CDTG,CDEPS,6,6,1,CNBN)
      CALL MATMUL(DC,CDEPSP,6,6,1,CP)

      DO 10, J = 1,6
        CNBN(J) = NMNBN(J) + CNBN(J) - CP(J)
 10   CONTINUE

C     CALCUL DES MOMENTS LIMITES DE PLASTICITE
C     ET DES ZEROS DES CRITERES
      CALL MPPFFN(ZIMAT,CNBN,CPLAS,CZEF
     &            ,CZEG,CIEF,NORMM )

      IF(CIEF .GT. 0) THEN
        CIER=2
        GOTO  20
      ENDIF

      IF ( (GPLASS(CNBN,CPLAS,1)  .GT.  CZEG)
     &   .OR.(GPLASS(CNBN,CPLAS,2)  .GT.  CZEG)) THEN
        CIER=1
      ELSE
        CIER=0
      ENDIF

 20   CONTINUE

      END
