      SUBROUTINE NWTPOL(DEG,COEF,RAC)

      IMPLICIT NONE
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 19/05/2009   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C======================================================================
C
C     RECHERCHE DU ZERO D UN POLYNOME PAR LA METHODE DE NEWTON
C
C IN  DEG : DEGRE DU POLYNOME
C IN  COEF : COEFFICIENT DU POLYNOME
C
C OUT RAC : VALEUR DE LA RACINE TROUVEE

      INTEGER DEG, ITERMX, I
      REAL*8 COEF(DEG+1), RAC, DPOLYN
      REAL*8 RAC0, TOLE, FX, DFX, ERR, FX0, DPOLYH

      ITERMX = 10
      TOLE = 1.D-15

C     EVALUATION DU POLYNOME A X = RAC
      FX = DPOLYH(DEG,COEF,RAC)

      ERR = ABS(FX)
      RAC0 = RAC
      FX0 = FX

      DO 9, I = 1, ITERMX+1

C     CRITERE DE CONVERGENCE
        IF(ERR .LE. TOLE) GOTO 10

C     EVALUATION DE LA DERIVEE DU POLYNOME A X = RAC
        DFX = DPOLYN(DEG,COEF,RAC)

        IF (ABS(DFX) .LT. 1.D-12) THEN
          IF(ABS(FX0) .LT. ABS(FX))  RAC = RAC0
          GOTO 10
        ENDIF

        RAC = RAC - FX/DFX
        FX = DPOLYH(DEG,COEF,RAC)
        ERR = ABS(FX)
 9    CONTINUE

 10   CONTINUE

      END
