      SUBROUTINE PMFDGE(B,G,DEPL,ALPHA,DEGE)
      IMPLICIT NONE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 13/02/2007   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C -----------------------------------------------------------
C ---  CALCUL DES DEFORMATIONS GENERALISEES
C         DE L'ELEMENT POUTRE EULER (A LA POSITION X)
C --- IN : MATRICE B POUR LA POSITION CONSIDEREE
C --- IN : MATRICE G POUR LA POSITION CONSIDEREE (MODE INCOMPATIBLE)
C --- IN : DEPLACEMENTS DANS LE REPERE LOCAL (6 DDL PAR NOEUD)
C          DEPL(12)
C --- IN : ALPHA VARIABLE MODE INCOMPATIBLE
C --- OUT : DEFORMATIONS GENERALISEES A LA POSITION OU B EST CALCULEE
C          DEGE(6)
C           1 : DEFORMATION AXIALE
C           2 ET 3 : DISTORSION TRANCHANTE NULLE POUR EULER BERNOULLI
C           4 : ANGLE UNITAIRE DE TORSION
C           5 : COURBURE AUTOUR DE Y
C           6 : COURBURE AUTOUR DE Z
C -----------------------------------------------------------
      REAL*8 B(4),G,DEPL(12),ALPHA,DEGE(6)
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D+0)

C --- DEF. GENERALISEES DE L'ELEMENT POUTRE EULER A LA POSITION DE B
      DEGE(1)=(DEPL(7)-DEPL(1))*B(1)+G*ALPHA
      DEGE(2)=ZERO
      DEGE(3)=ZERO
      DEGE(4)=(DEPL(10)-DEPL(4))*B(1)
      DEGE(5)=B(4)*DEPL(11)+B(3)*DEPL(5)+B(2)*(DEPL(9)-DEPL(3))
      DEGE(6)=B(4)*DEPL(12)+B(3)*DEPL(6)+B(2)*(DEPL(2)-DEPL(8))

      END
