      SUBROUTINE PMFITS(NF,NCF,VF,VSIG,VS)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 29/09/2006   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2002  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
C -----------------------------------------------------------
C ---  INTEGRATION DES CONTRAINTES SUR LA SECTION
C      (CALCUL DES FORCES INTERIEURES)
C --- IN : FIBRES
C          NF : NOMBRE DE FIBRES
C          NCF: NOMBRE DE CARACTERISTIQUES SUR CHAQUE FIBRE
C          VF(1,*) : Y FIBRES
C          VF(2,*) : Z FIBRES
C          VF(3,*) : S FIBRES
C          VF(4-6,*) : AUTRES CARACTERISTIQUES
C          VSIG(*) : CONTRAINTE NORMALE DANS CHAQUE FIBRE
C
C --- OUT : SECTION
C          VS(1) : INT(SIG.DS)      = N0
C          VS(2) : INT(SIG.Y.DS)    = -MFZ0
C          VS(3) : INT(SIG.Z.DS)    = MFY0
C -----------------------------------------------------------
      INTEGER NF,NCF,I
      REAL*8 VF(NCF,NF),VSIG(NF),VS(3),ZERO,SIGSF
      PARAMETER (ZERO=0.0D+0)
      CHARACTER*2 KNCF

      DO 10 I=1,3
        VS(I)=ZERO
  10  CONTINUE

      IF (NCF.EQ.3)THEN
C --- ON A 3 CARACTERISTIQUES PAR FIBRE : Y, Z ET S
        DO 100 I=1,NF
          SIGSF=VSIG(I)*VF(3,I)
          VS(1)=VS(1)+SIGSF
          VS(2)=VS(2)+VF(1,I)*SIGSF
          VS(3)=VS(3)+VF(2,I)*SIGSF
100    CONTINUE
      ELSEIF(NCF.EQ.6)THEN
C --- ON A 6 CARACTERISTIQUES PAR FIBRE : Y, Z, S, IZ, IY ET IYZ
        CALL U2MESS('F','ELEMENTS2_41')
      ELSE
C --- ERREUR SUR NCARFIB
        CALL CODENT(NCF,'G',KNCF)
        CALL U2MESK('F','ELEMENTS2_40',1,KNCF)
      ENDIF


      END
