      SUBROUTINE PMFPTI(NUM,XL,XI,WI,B,G)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 13/02/2007   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2002  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
C -----------------------------------------------------------
C ---  POSITION ET POIDS DES POINTS DE GAUSS + MATRICE B
C         DE L'ELEMENT POUTRE EULER (HERMITE)
C --- IN : LONGUEUR DE L'ELEMENT XL
C --- IN : NUMERO DU POINT DE GAUSS
C --- OUT : XI POSITION DU POINT
C           WI POIDS DE CE POINT
C           B MATRICE B (4 VALEURS DIFFERENTES NON NULLES)
C -----------------------------------------------------------
      INTEGER NUM
      REAL*8 XL,XI,WI,B(4),G
      REAL*8 UN,DEUX,QUATRE,SIX,DOUZE
      PARAMETER (UN=1.D0,DEUX=2.D0,QUATRE=4.D0,SIX=6.D0,DOUZE=12.D0)
      REAL*8 XG(2),WG(2),XP(2)
      DATA XG /-.57735026918963D0,.57735026918963D0/
      DATA WG /1.D0 , 1.D0/
      DATA XP /0.D0 , 1.D0/

      IF(NUM.GT.0)THEN
C       NUM=1 OU 2 : POINTS DE GAUSS
        XI=(UN + XG(NUM))/ DEUX
C       LE JACOBIEN L/2 EST MIS DIRECTEMENT DANS LE POIDS
        WI=WG(NUM)*XL/DEUX
      ELSE
C       NUM=-1 OU -2 : NOEUDS
        XI=XP(-NUM)
      ENDIF
C     -- ON NE STOCKE PAS LES 0. DE LA MATRICE B,
C        ON NE CALCULE PAS LES OPPOSES
      B(1)=UN/XL
      B(2)=(-SIX+DOUZE*XI)/XL/XL
      B(3)=(-QUATRE+SIX*XI)/XL
      B(4)=(-DEUX+SIX*XI)/XL

      G=(-DEUX*XI+UN)*QUATRE/XL

      END
