      SUBROUTINE Q4GB ( CARAQ4, XYZL, IGAU, JACGAU, BMAT )
      IMPLICIT  NONE
      INTEGER   IGAU
      REAL*8    XYZL(3,1), CARAQ4(*), BMAT(8,1), JACGAU
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 14/10/2005   AUTEUR CIBHHLV L.VIVAN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C     ------------------------------------------------------------------
C --- CALCUL DE LA MATRICE (B) RELIANT LES DEFORMATIONS DU PREMIER 
C --- ORDRE AUX DEPLACEMENTS AU POINT D'INTEGRATION D'INDICE IGAU  
C --- POUR UN ELEMENT DE TYPE Q4G 
C --- (I.E. (EPS_1) = (B)*(UN))
C --- D'AUTRE_PART, ON CALCULE LE PRODUIT NOTE JACGAU = JACOBIEN*POIDS
C     ------------------------------------------------------------------
C     IN  XYZL(3,NNO)   : COORDONNEES DES CONNECTIVITES DE L'ELEMENT
C                         DANS LE REPERE LOCAL DE L'ELEMENT
C     IN  IGAU          : INDICE DU POINT D'INTEGRATION
C     OUT JACGAU        : PRODUIT JACOBIEN*POIDS AU POINT D'INTEGRATION
C                         COURANT
C     OUT BMAT(8,1)     : MATRICE (B) AU POINT D'INTEGRATION COURANT
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      CHARACTER*32       JEXNUM , JEXNOM , JEXR8 , JEXATR
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
      INTEGER  NDIM,NNO,NNOS,NPG,IPOIDS,ICOOPG,IVF,IDFDX,IDFD2,JGANO
      REAL*8   BM(3,8),  BF(3,12), BC(2,12), QSI, ETA, JACOB(5)
C ------------------------------------------------------------------
C
      CALL ELREF5(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,ICOOPG,
     +                                         IVF,IDFDX,IDFD2,JGANO)
C
C --- COORDONNEES DU POINT D'INTEGRATION COURANT :
C     ------------------------------------------
      QSI = ZR(ICOOPG-1+NDIM*(IGAU-1)+1)
      ETA = ZR(ICOOPG-1+NDIM*(IGAU-1)+2)
C
C --- CALCUL DE LA MATRICE JACOBIENNE ET DE SON DETERMINANT AU POINT
C --- D'INTEGRATION D'INDICE IGAU 
C     ---------------------------
      CALL JQUAD4 ( XYZL, QSI, ETA, JACOB )
C
C --- PRODUIT JACOBIEN*POIDS
C     ----------------------
      JACGAU = ZR(IPOIDS+IGAU-1)*JACOB(1)
C
C --- CALCUL DE LA MATRICE B_MEMBRANE NOTEE, ICI, (BM)
C     ------------------------------------------------
      CALL DXQBM ( QSI, ETA, JACOB(2), BM)
C
C --- CALCUL DE LA MATRICE B_FLEXION RELATIVE AUX INCONNUES W, BETAX
C --- ET BETAY.
C --- CETTE MATRICE EST IDENTIQUE A LA PARTIE DE LA MATRICE B_FLEXION
C --- DU DSQ OU L'ON NE TIENT COMPTE QUE DE L'INTERPOLATION LINEAIRE
C --- DES INCONNUES W, BETAX ET BETAY, CETTE MATRICE EST NOTEE (BFB)
C --- POUR LE DSQ.
C --- ON RAPPELLE QUE LE Q4G EST UN ELEMENT ISOPARAMETRIQUE EXPRIME
C --- EN COORDONNEES CARTESIENNES.
C     ----------------------------
      CALL DSQBFB ( QSI, ETA, JACOB(2), BF )
C
C --- CALCUL DE LA MATRICE B_CISAILLEMENT, NOTEE (BC) 
C     -----------------------------------------------
      CALL Q4GBC ( QSI, ETA, JACOB(2), CARAQ4, BC )
C
C --- AFFECTATION DE LA MATRICE B COMPLETE, NOTEE (BMAT) 
C --- AVEC LES MATRICES (BM), (BF) ET (BC)
C     ------------------------------------
      CALL BCOQAF ( BM, BF, BC, NNO, BMAT )
C
      END
