      SUBROUTINE Q4GMAS ( XYZL, OPTION, PGL, MAS, ENER )
      IMPLICIT NONE
      REAL*8         XYZL(3,*), PGL(*), MAS(*), ENER(*)
      CHARACTER*16   OPTION
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 04/04/2011   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.				
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C     ------------------------------------------------------------------
C     MATRICE MASSE DE L'ELEMENT DE PLAQUE Q4GAMMA (W LINEAIRE)
C     ------------------------------------------------------------------
C     IN  XYZL   : COORDONNEES LOCALES DES QUATRE NOEUDS
C     IN  OPTION : OPTION RIGI_MECA OU EPOT_ELEM
C     IN  PGL    : MATRICE DE PASSAGE GLOBAL/LOCAL
C     OUT MAS    : MATRICE DE RIGIDITE
C     OUT ENER   : TERMES POUR ENER_CIN (ECIN_ELEM)
C     ------------------------------------------------------------------
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
      INTEGER  I, J, K, INT, JCOQU, JDEPG, II(8),JJ(8),LL(16)
      INTEGER  NDIM,NNO,NNOS,NPG,IPOIDS,ICOOPG,IVF,IDFDX,IDFD2,JGANO
      REAL*8   FLEX(12,12),BC(2,12)
      REAL*8   MEMB(8,8), AMEMB(64), MEFL(8,12)
      REAL*8   WQ4(12), DEPL(24), MASLOC(300), MASGLO(300)
      REAL*8   RHO,EPAIS,ROE,CTOR,EXCENT,DETJ,WGT,ZERO,COEFM
      REAL*8   CARAQ4(25), JACOB(5), QSI, ETA
C     ------------------------------------------------------------------
      DATA (II(K),K=1,8)/1,10,19,28,37,46,55,64/
      DATA (JJ(K),K=1,8)/5,14,23,32,33,42,51,60/
      DATA (LL(K),K=1,16)/3,7,12,16,17,21,26,30,35,39,44,48,49,53,58,62/
C     ------------------------------------------------------------------
C
      CALL ELREF5(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,ICOOPG,
     &                                         IVF,IDFDX,IDFD2,JGANO)
C
      ZERO = 0.0D0

      CALL DXROEP(RHO,EPAIS)
      ROE = RHO*EPAIS

      CALL JEVECH('PCACOQU','L',JCOQU)
      CTOR   = ZR(JCOQU+3)
      EXCENT = ZR(JCOQU+4)
C
C --- ON NE CALCULE PAS ENCORE LA MATRICE DE MASSE D'UN ELEMENT
C --- DE PLAQUE EXCENTRE, ON S'ARRETE EN ERREUR FATALE :
C     ------------------------------------------------
      IF (EXCENT.NE.ZERO) THEN
        CALL U2MESS('F','ELEMENTS2_56')
      ENDIF

C     ----- CALCUL DES GRANDEURS GEOMETRIQUES SUR LE QUADRANGLE --------
      CALL GQUAD4(XYZL,CARAQ4)

      CALL R8INIR(144,ZERO,FLEX,1)
      CALL R8INIR( 96,ZERO,MEFL,1)

      DO 50 INT = 1,NPG

        QSI = ZR(ICOOPG-1+NDIM*(INT-1)+1)
        ETA = ZR(ICOOPG-1+NDIM*(INT-1)+2)

C        ----- CALCUL DU JACOBIEN SUR LE QUADRANGLE -------------------
        CALL JQUAD4(XYZL,QSI,ETA,JACOB)

C        ---- CALCUL DE LA MATRICE BC ----------------------------------
        CALL Q4GBC(QSI,ETA,JACOB(2),CARAQ4,BC)

C        ----- CALCUL DES FONCTIONS D'INTERPOLATION EN FLEXION ---------
        CALL Q4GNIW(QSI,ETA,CARAQ4,BC,WQ4)

        DETJ = JACOB(1)
        WGT = ZR(IPOIDS+INT-1)*DETJ*ROE

        DO 40 I = 1,12
          DO 30 J = 1,12
            FLEX(I,J) = FLEX(I,J) + WQ4(I)*WQ4(J)*WGT
   30     CONTINUE
   40   CONTINUE
   50 CONTINUE

C     ----- CALCUL DE LA MATRICE MASSE EN MEMBRANE ---------------------
      COEFM = CARAQ4(21)*ROE/9.D0
      DO 60 K = 1,64
        AMEMB(K) = 0.D0
   60 CONTINUE
      DO 70 K = 1,8
        AMEMB(II(K)) = 1.D0
        AMEMB(JJ(K)) = 0.25D0
   70 CONTINUE
      DO 80 K = 1,16
        AMEMB(LL(K)) = 0.5D0
   80 CONTINUE
      DO 90 K = 1,64
        MEMB(K,1) = COEFM*AMEMB(K)
   90 CONTINUE
C
      IF (( OPTION .EQ. 'MASS_MECA' ).OR.(OPTION.EQ.'M_GAMMA')) THEN
        CALL DXQLOC(FLEX,MEMB,MEFL,CTOR,MAS)
C
      ELSE IF (OPTION.EQ.'MASS_MECA_DIAG' .OR.
     &         OPTION.EQ.'MASS_MECA_EXPLI' ) THEN
        CALL DXQLOC(FLEX,MEMB,MEFL,CTOR,MASLOC)
        WGT = CARAQ4(21)*ROE
        CALL UTPSLG(4,6,PGL,MASLOC,MASGLO)
        CALL DIALUM(4,6,24,WGT,MASGLO,MAS)
C
      ELSE IF (OPTION.EQ.'ECIN_ELEM') THEN
        CALL JEVECH('PDEPLAR','L',JDEPG)
        CALL UTPVGL(4,6,PGL,ZR(JDEPG),DEPL)
        CALL DXQLOE(FLEX,MEMB,MEFL,CTOR,.FALSE.,DEPL,ENER)
      END IF
C
      END
