      SUBROUTINE TE0020(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 26/10/2011   AUTEUR MACOCCO K.MACOCCO 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
      CHARACTER*16 OPTION,NOMTE
C ----------------------------------------------------------------------
C     FONCTION REALISEE:  CALCUL DES CHAMELEM AUX NOEUDS A PARTIR DES
C     VALEURS AUX POINTS DE GAUSS (SIEF_ELNO VARI_ELNO)
C                         CALCUL DES CHAMELEM AUX POINTS DE GAUSS A
C     PARTIR DES VALEURS AUX NOEUDS ( SIEF_ELGA_ELNO VARI_ELGA_ELNO )
C     ELEMENTS 3D

C IN  OPTION : OPTION DE CALCUL
C IN  NOMTE  : NOM DU TYPE ELEMENT

C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------

      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------


      CHARACTER*24 CHTCTE
      REAL*8 S
      INTEGER JGANO,NPG,NNOS,NNO,NDIM
      INTEGER I,IC,ICHG,ICHN,JMAT,NCMP,NCMP2,JVAL,IRET,IDFDE
      INTEGER IPOIDS,IVF,LGPG1,LGPG2,ICOMPO,KP,K,JTAB(7)
      LOGICAL LTEATT
C DEB ------------------------------------------------------------------

      NCMP2 = 0
      IF (LTEATT(' ','INCO','OUI')) NCMP2 = 1

      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDE,JGANO)
      DO 10 I = 1,1
   10 CONTINUE




      IF (OPTION.EQ.'SIEF_ELNO  ') THEN
C     ---------------------------------------------
C       NCMP2 LE NOMBRE DE COMPOSANTES SUPPLEMENTAIRES DES CONTRAINTES
C       EN PARTICULIER EN THM
        NCMP = 6 + NCMP2
        CALL JEVECH('PCONTRR','L',ICHG)
        CALL JEVECH('PSIEFNOR','E',ICHN)


      ELSE IF (OPTION.EQ.'SIEF_ELGA_ELNO  ') THEN
C     ---------------------------------------------
        NCMP = 6 + NCMP2
        CALL JEVECH('PCONTRR','L',ICHN)
        CALL JEVECH('PSIEFGR','E',ICHG)
        LGPG1 = NCMP
        LGPG2 = NCMP


      ELSE IF (OPTION.EQ.'VARI_ELNO  ') THEN
C     ---------------------------------------------

        CALL JEVECH('PVARIGR','L',ICHG)
        CALL JEVECH('PVARINR','E',ICHN)

        CALL TECACH('OON','PVARIGR',7,JTAB,IRET)
        LGPG1 = MAX(JTAB(6),1)*JTAB(7)
        CALL TECACH('OON','PVARINR',7,JTAB,IRET)
        LGPG2 = MAX(JTAB(6),1)*JTAB(7)

        NCMP = LGPG1
      ELSE IF (OPTION.EQ.'VARI_ELGA_ELNO  ') THEN
C     ---------------------------------------------

        CALL JEVECH('PVARINR','L',ICHN)
        CALL JEVECH('PVARIGR','E',ICHG)

        CALL TECACH('OON','PVARINR',7,JTAB,IRET)
        LGPG1 = MAX(JTAB(6),1)*JTAB(7)
        CALL TECACH('OON','PVARIGR',7,JTAB,IRET)
        LGPG2 = MAX(JTAB(6),1)*JTAB(7)
        CALL ASSERT(LGPG1.EQ.LGPG2)
        NCMP = LGPG2
      END IF


      IF (OPTION(6:9).EQ.'ELNO') THEN
C     ---------------------------------------------

        CALL PPGAN2(JGANO,NCMP,ZR(ICHG),ZR(ICHN))

      ELSE
C     PASSAGE AUX POINTS DE GAUSS :
C     ---------------------------------------------

        DO 40 IC = 1,NCMP
          DO 30 KP = 1,NPG
            K = (KP-1)*NNO
            S = 0.D0
            DO 20 I = 1,NNO
              S = S + ZR(ICHN+LGPG1* (I-1)+IC-1)*ZR(IVF+K+I-1)
   20       CONTINUE
            ZR(ICHG+LGPG2* (KP-1)+IC-1) = S
   30     CONTINUE
   40   CONTINUE

      END IF

C FIN ------------------------------------------------------------------
      END
