      SUBROUTINE TE0229(OPTION,NOMTE)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*16 OPTION,NOMTE
C ......................................................................
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 02/02/2011   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C .  - FONCTION REALISEE:  CALCUL DES DEFORMATIONS AUX NOEUDS
C .                        COQUE 1D
C .
C .                        OPTIONS : 'EPSI_ELNO  '
C .                        ELEMENT: MECXSE3,METCSE3,METDSE3
C .  - ARGUMENTS:
C .      DONNEES:      OPTION       -->  OPTION DE CALCUL
C .                    NOMTE        -->  NOM DU TYPE ELEMENT
C ......................................................................
C --------- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C --------- FIN  DECLARATIONS NORMALISEES JEVEUX -----------------------

      CHARACTER*8 ELREFE
      REAL*8 R,COSA,SINA,COUR,JAC,CORREC,DFDX(3)
      REAL*8 EPS(5),X3,EP,ORD
      REAL*8 E11,E22,K11,K22,ESX3,DEFOPG(24)
      INTEGER I,K,KP,IGEOM,ICACO,IDEPL,IDEFOR
      INTEGER IVF,IDFDK,INUMCO
      INTEGER NNO,NPG,CODE

      CALL ELREF1(ELREFE)

      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDK,JGANO)

      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PCACOQU','L',ICACO)
      CALL JEVECH('PDEPLAR','L',IDEPL)
      CALL JEVECH('PNUMCOR','L',INUMCO)
      CALL JEVECH('PDEFORR','E',IDEFOR)

      CODE = ZI(INUMCO+1)
      EP = ZR(ICACO)
      CORREC = ZR(ICACO+2)
      ORD = 0.D0

      IF (CODE.LT.0) THEN
        X3 = ORD - EP/2.D0
      ELSE IF (CODE.GT.0) THEN
        X3 = ORD + EP/2.D0
      ELSE
        X3 = ORD
      END IF


      DO 30 KP = 1,NPG
        K = (KP-1)*NNO
        CALL DFDM1D(NNO,ZR(IPOIDS+KP-1),ZR(IDFDK+K),ZR(IGEOM),DFDX,COUR,
     &              JAC,COSA,SINA)
        DO 10 I = 1,5
          EPS(I) = 0.D0
   10   CONTINUE
        R = 0.D0
        DO 20 I = 1,NNO
          EPS(1) = EPS(1) + DFDX(I)*ZR(IDEPL+3*I-3)
          EPS(2) = EPS(2) + DFDX(I)*ZR(IDEPL+3*I-2)
          EPS(3) = EPS(3) + DFDX(I)*ZR(IDEPL+3*I-1)
          EPS(4) = EPS(4) + ZR(IVF+K+I-1)*ZR(IDEPL+3*I-3)
          EPS(5) = EPS(5) + ZR(IVF+K+I-1)*ZR(IDEPL+3*I-1)
          R = R + ZR(IVF+K+I-1)*ZR(IGEOM+2*I-2)
   20   CONTINUE
        E11 = EPS(2)*COSA - EPS(1)*SINA
        K11 = EPS(3)
        ESX3 = EPS(5) + EPS(1)*COSA + EPS(2)*SINA
        IF (NOMTE.EQ.'MECXSE3') THEN
          E22 = EPS(4)/R
          K22 = -EPS(5)*SINA/R
          DEFOPG(3*KP-1) = (E22+X3*K22)/ (1.D0+ (COSA*X3*CORREC/R))
        ELSE
          E22 = 0.D0
          K22 = 0.D0
          DEFOPG(3*KP-1) = 0.D0
        END IF
        DEFOPG(3*KP) = ESX3/ (1.D0+ (X3*COUR*CORREC))
        DEFOPG(3*KP-2) = (E11+X3*K11)/ (1.D0+ (X3*COUR*CORREC))
   30 CONTINUE


C     -- PASSAGE GAUSS -> NOEUDS :
      CALL PPGAN2(JGANO,3,DEFOPG,ZR(IDEFOR))

      END
