      SUBROUTINE TE0256(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 04/04/2006   AUTEUR CIBHHLV L.VIVAN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C.......................................................................
      IMPLICIT REAL*8 (A-H,O-Z)

C     BUT: CALCUL DES VECTEURS ELEMENTAIRES EN MECANIQUE
C          ELEMENTS ISOPARAMETRIQUES 1D

C          OPTION : 'CHAR_MECA_VNOR_F '

C     ENTREES  ---> OPTION : OPTION DE CALCUL
C          ---> NOMTE  : NOM DU TYPE ELEMENT
C.......................................................................

      CHARACTER*2 CODRET
      CHARACTER*8 NOMPAR(2)
      CHARACTER*16 NOMTE,OPTION
      REAL*8 POIDS,NX,NY,COEF,R8PI,PI,VALPAR(2)
      INTEGER IPOIDS,IVF,IDFDE,IGEOM,IVNOR
      INTEGER NDI,NNO,KP,NPG,IVECTU,IMATE,LDEC
      LOGICAL LAXI, LTEATT

C---------------- COMMUNS NORMALISES  JEVEUX  --------------------------
      COMMON /IVARJE/ZI(1)
      COMMON /RVARJE/ZR(1)
      COMMON /CVARJE/ZC(1)
      COMMON /LVARJE/ZL(1)
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      INTEGER ZI
      REAL*8 ZR
      COMPLEX*16 ZC
      LOGICAL ZL
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
C------------FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDE,JGANO)

      LAXI = .FALSE.
      IF (LTEATT(' ','AXIS','OUI')) LAXI = .TRUE.

      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PVECTUR','E',IVECTU)
      CALL JEVECH('PMATERC','L',IMATE)
      CALL JEVECH('PSOURCF','L',IVNOR)

      CALL RCVALA(ZI(IMATE),' ','FLUIDE',0,' ',R8B,1,'RHO',RHO,
     &             CODRET,'FM')

      DO 10 I = 1,2*NNO
        ZR(IVECTU+I-1) = 0.0D0
   10 CONTINUE

C     BOUCLE SUR LES POINTS DE GAUSS

      NOMPAR(1) = 'X'
      NOMPAR(2) = 'Y'
      DO 50 KP = 1,NPG
        LDEC = (KP-1)*NNO

C        COORDONNEES DU POINT DE GAUSS
        X = 0.D0
        Y = 0.D0
        DO 20 N = 0,NNO - 1
          X = X + ZR(IGEOM+2*N)*ZR(IVF+LDEC+N)
          Y = Y + ZR(IGEOM+2*N+1)*ZR(IVF+LDEC+N)
   20   CONTINUE

C        VALEUR DE LA VITESSE
        VALPAR(1) = X
        VALPAR(2) = Y
        CALL FOINTE('FM',ZK8(IVNOR),2,NOMPAR,VALPAR,VNORF,IER)
        NX = 0.0D0
        NY = 0.0D0

        CALL VFF2DN(NDIM,NNO,KP,IPOIDS,IDFDE,ZR(IGEOM),NX,NY,POIDS)

        IF (LAXI) THEN
          R = 0.D0
          DO 30 I = 1,NNO
            R = R + ZR(IGEOM+2* (I-1))*ZR(IVF+LDEC+I-1)
   30     CONTINUE
          POIDS = POIDS*R
        END IF

        DO 40 I = 1,NNO
          II = 2*I
          ZR(IVECTU+II-1) = ZR(IVECTU+II-1) -
     &                      POIDS*VNORF*RHO*ZR(IVF+LDEC+I-1)
   40   CONTINUE

   50 CONTINUE

   60 CONTINUE
      END
