      SUBROUTINE TE0359(OPTION,NOMTE)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 23/02/2011   AUTEUR LAVERNE J.LAVERNE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE LAVERNE J.LAVERNE

      IMPLICIT NONE
      CHARACTER*16 OPTION,NOMTE

C ----------------------------------------------------------------------
C    - FONCTION REALISEE:  PILOTAGE PRED_ELAS
C                          POUR LES ELEMENTS D'INTERFACE
C    - ARGUMENTS:
C        DONNEES:      OPTION       -->  OPTION DE CALCUL
C                      NOMTE        -->  NOM DU TYPE ELEMENT
C ----------------------------------------------------------------------
      CHARACTER*8 LIELRF(10)
      LOGICAL AXI
      INTEGER NNO1,NNO2,NPG,LGPG,NDIM,IRET,NTROU,IU(3,18),IM(3,9),IT(18)
      INTEGER IW,IVF1,IDF1,IGEOM,IMATE,IVF2,IDF2,NNOS,JGN,JTAB(7),N
      INTEGER IVARIM,ICOPIL,ICTAU,IDDLM,IDDLD,IDDL0,IDDL1,ICOMPO,ICAMAS
      REAL*8  ANG(24)
      
      LOGICAL LTEATT
      
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------


C - FONCTIONS DE FORME

      CALL ELREF2(NOMTE,2,LIELRF,NTROU)
      CALL ELREF4(LIELRF(1),'RIGI',NDIM,NNO1,NNOS,NPG,IW,IVF1,IDF1,JGN)
      CALL ELREF4(LIELRF(2),'RIGI',NDIM,NNO2,NNOS,NPG,IW,IVF2,IDF2,JGN)
      NDIM = NDIM + 1
      AXI = LTEATT(' ','AXIS','OUI') 

C - DECALAGE D'INDICE POUR LES ELEMENTS D'INTERFACE             
      CALL EIINIT(NOMTE,IU,IM,IT)

C --- ORIENTATION DE L'ELEMENT D'INTERFACE : REPERE LOCAL 
C     RECUPERATION DES ANGLES NAUTIQUES DEFINIS PAR AFFE_CARA_ELEM

      CALL JEVECH('PCAMASS','L',ICAMAS)
      IF (ZR(ICAMAS).EQ.-1.D0) CALL U2MESS('F','ELEMENTS5_47')

C     DEFINITION DES ANGLES NAUTIQUES AUX NOEUDS SOMMETS : ANG
      
      CALL EIANGL(NDIM,NNO2,ZR(ICAMAS+1),ANG)

C - PARAMETRES

      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PMATERC','L',IMATE)
      CALL JEVECH('PCOMPOR','L',ICOMPO)
      CALL JEVECH('PDEPLMR','L',IDDLM)
      CALL JEVECH('PDDEPLR','L',IDDLD)
      CALL JEVECH('PDEPL0R','L',IDDL0)
      CALL JEVECH('PDEPL1R','L',IDDL1)
      CALL JEVECH('PVARIMR','L',IVARIM)
      CALL JEVECH('PCDTAU', 'L',ICTAU)
      CALL JEVECH('PCOPILO','E',ICOPIL)

C    NOMBRE DE VARIABLES INTERNES
      CALL TECACH('OON','PVARIMR',7,JTAB,IRET)
      LGPG = MAX(JTAB(6),1)*JTAB(7)


C - PILOTAGE PRED_ELAS

      CALL PIPEEI(NDIM,AXI,NNO1,NNO2,NPG,ZR(IW),ZR(IVF1),ZR(IVF2),
     &  ZR(IDF2),ZR(IGEOM),ANG,ZI(IMATE),ZK16(ICOMPO),LGPG,
     &  ZR(IDDLM),ZR(IDDLD),ZR(IDDL0),ZR(IDDL1),ZR(ICTAU),
     &  ZR(IVARIM),IU,IM,ZR(ICOPIL))
      
      END
