      SUBROUTINE TE0371(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 13/09/2004   AUTEUR GREFFET N.GREFFET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C.......................................................................
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     BUT: CALCUL DES MATRICES DE RIGIDITE  ELEMENTAIRES EN MECANIQUE
C          ELEMENTS 2D DE COUPLAGE PESANTEUR-SURFACE LIBRE D'UN FLUIDE
C
C          OPTION : 'MASS_MECA'
C
C     ENTREES  ---> OPTION : OPTION DE CALCUL
C          ---> NOMTE  : NOM DU TYPE ELEMENT
C.......................................................................
      CHARACTER*8        ELREFE
      CHARACTER*2        CODRET
      CHARACTER*16       NOMTE,OPTION
      CHARACTER*24       CHVAL,CHCTE
      INTEGER            IGEOM,IMATE
      INTEGER            I,J,K,L,IK,IJKL,IDEC,JDEC,LDEC,KDEC,KCO,INO,JNO
      INTEGER            NBPG(10),NBFPG,NDIM,NNO,NPG2,IPG,NNOS,JGANO
      INTEGER            JIN,JVAL,IPOIDS,IVF,IDFRDE,IDFRDK,IMATUU
      REAL*8             A(2,2,27,27),SZ(27,27),RHO
      REAL*8             POIDS,DFRDE(1),DFRDK(1),COOR(1),JAC
      REAL*8             DXDE,DXDK,DYDE,DYDK
C
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      CHARACTER*32       JEXNUM , JEXNOM , JEXR8 , JEXATR
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
C
      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG2,IPOIDS,IVF,IDFRDE,JGANO)
C
      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PMATERC','L',IMATE)
      CALL JEVECH('PMATUUR','E',IMATUU)
C
      CALL RCVALA(ZI(IMATE),' ','FLUIDE',0,' ',R8B,1,'RHO',RHO,
     &            CODRET,'FM')
C
C     INITIALISATION DE LA MATRICE
C
      DO 112 K=1,2
         DO 112 L=1,2
            DO 112 I=1,NNO
            DO 112 J=1,I
                A(K,L,I,J) = 0.D0
112   CONTINUE
C
C    BOUCLE SUR LES POINTS DE GAUSS
C
      DO 113 IPG=1,NPG2
C
       KDEC = (IPG-1)*NNO*NDIM
       LDEC = (IPG-1)*NNO
C
       DXDE=0.D0
       DXDK=0.D0
       DYDE=0.D0
       DYDK=0.D0
       DO 100 I=1,NNO
        DXDE=DXDE+ZR(IGEOM+3*(I-1))*ZR(IDFRDE+KDEC+(I-1)*NDIM)
        DXDK=DXDK+ZR(IGEOM+3*(I-1))*ZR(IDFRDE+KDEC+(I-1)*NDIM+1)
        DYDE=DYDE+ZR(IGEOM+3*(I-1)+1)*ZR(IDFRDE+KDEC+(I-1)*NDIM)
        DYDK=DYDK+ZR(IGEOM+3*(I-1)+1)*ZR(IDFRDE+KDEC+(I-1)*NDIM+1)
100    CONTINUE
       JAC   = DXDE*DYDK-DXDK*DYDE
       POIDS = ABS(JAC)*ZR(IPOIDS+IPG-1)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C       CALCUL DU TERME RHO * PHI * Z      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
        DO 130 INO=1,NNO
           DO 140 JNO=1,INO
              A(1,2,INO,JNO) = A(1,2,INO,JNO) +
     &                         POIDS * RHO *
     &                         ZR(IVF+LDEC+INO-1) * ZR(IVF+LDEC+JNO-1)
140        CONTINUE
130      CONTINUE
113     CONTINUE
C
      DO 151 INO=1,NNO
        DO 152 JNO=1 ,INO
           A(2,1,INO,JNO) = A(1,2,INO,JNO)
152     CONTINUE
151   CONTINUE
C
C PASSAGE DU STOCKAGE RECTANGULAIRE AU STOCKAGE TRIANGULAIRE
C
      IJKL = 0
      IK = 0
      DO 160 K=1,2
         DO 160 L=1,2
            DO 160 I=1,NNO
                IK = ((2*I+K-3) * (2*I+K-2)) / 2
            DO 160 J=1,I
                IJKL = IK + 2 * (J-1) + L
                ZR(IMATUU+IJKL-1) = A(K,L,I,J)
160   CONTINUE
C
 9999 CONTINUE
      END
