      SUBROUTINE TE0410 ( OPTIOZ , NOMTZ )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 02/02/2011   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*(*)   OPTIOZ , NOMTZ
      CHARACTER*16    OPTION , NOMTE
C     ----------------------------------------------------------------
C     CALCUL DES OPTIONS DES ELEMENTS DE COQUE 3D
C                EPSI_ELNO
C                SIGM_ELNO
C                SIEF_ELGA
C                EFGE_ELNO
C
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      CHARACTER*32       JEXNUM , JEXNOM , JEXR8 , JEXATR
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
      PARAMETER (NPGT=10)
      INTEGER    NB1
      REAL*8     SIGTOT(6,9),EFFGT(8,9)
      REAL*8     MATEVN(2,2,NPGT), MATEVG(2,2,NPGT)
      CHARACTER*24  DESI , DESR
C DEB
C
      OPTION=OPTIOZ
      NOMTE=NOMTZ
C
      CALL JEVECH ('PGEOMER' , 'L' , JGEOM)
      CALL JEVETE('&INEL.'//NOMTE(1:8)//'.DESI',' ', LZI )
      NB2  =ZI(LZI-1+2)
      NPGSN=ZI(LZI-1+4)
C
      CALL JEVECH('PNBSP_I','L',JCOU)
      NBCOU=ZI(JCOU)
      CALL WKVECT('&&TE0410.SIGPG','V V R',162*NBCOU,JSIGPG)
      CALL VDXSIG(NOMTE,OPTION,ZR(JGEOM),NB1,NPGSR,SIGTOT,
     &            ZR(JSIGPG),EFFGT)
C
C --- DETERMINATION DES MATRICES DE PASSAGE DES REPERES INTRINSEQUES
C --- AUX NOEUDS ET AUX POINTS D'INTEGRATION DE L'ELEMENT
C --- AU REPERE UTILISATEUR :
C     ---------------------
      CALL VDREPE(NOMTE, MATEVN, MATEVG)
C
      IF ( OPTION(1:9) .EQ. 'EPSI_ELNO'.OR.
     &     OPTION(1:9) .EQ. 'SIGM_ELNO') THEN
           IF ( OPTION(1:9) .EQ. 'EPSI_ELNO') THEN
              CALL JEVECH('PDEFORR','L',JSIGM)
           ELSE IF ( OPTION(1:9) .EQ. 'SIGM_ELNO') THEN
              CALL JEVECH('PCONTRR','L',JSIGM)
           ENDIF
C
C --- PASSAGE DU VECTEUR DES CONTRAINTES OU DU VECTEUR DES DEFORMATIONS
C --- DEFINI AUX NOEUDS DE L'ELEMENT DU REPERE INTRINSEQUE AU
C --- REPERE UTILISATEUR :
C     ------------------
           CALL VDSIRO(NB2, MATEVN, SIGTOT, ZR(JSIGM))
C
      ELSE IF ( OPTION(1:9) .EQ. 'SIEF_ELGA'.OR.
     &          OPTION(1:9) .EQ. 'EFGE_ELNO') THEN
           IF ( OPTION(1:9) .EQ. 'SIEF_ELGA') THEN
              CALL JEVECH('PCONTRR','E',ICONTR)
C              NP=NPGSR
C
C --- STOCKAGE DU VECTEUR DES CONTRAINTES EN ELASTICITE 
C --- 1 COUCHE - 3 PTS DANS L'EPAISSEUR
C---- 162 = NPGSN*6(6 CONTRAINTES STOCKEES)*NPGE
C     ------------------------------------------------------
C
              DO 10 I = 1,NPGSN*18*NBCOU
                  ZR(ICONTR-1+I)=ZR(JSIGPG-1+I)
 10           CONTINUE

  
C
C --- PASSAGE DU VECTEUR DES EFFORTS GENERALISES OU DU VECTEUR
C --- DES DEFORMATIONS-COURBURES DEFINI AUX POINTS D'INTEGRATION 
C --- DE L'ELEMENT DU REPERE INTRINSEQUE AU REPERE UTILISATEUR :
C     --------------------------------------------------------
C
C             CALL VDEFRO(NP, MATEVG, EFFGT, ZR(JEFFG))
           ELSE IF ( OPTION(1:9) .EQ. 'EFGE_ELNO') THEN
              CALL JEVECH('PEFFORR','L',JEFFG)
C
C     CES CHAMPS SONT CALCULES AUX NB2 NOEUDS
C
              NP=NB2
C
C --- PASSAGE DU VECTEUR DES EFFORTS GENERALISES OU DU VECTEUR
C --- DES DEFORMATIONS-COURBURES DEFINI AUX NOEUDS 
C --- DE L'ELEMENT DU REPERE INTRINSEQUE AU REPERE UTILISATEUR :
C     --------------------------------------------------------
             CALL VDEFRO(NP, MATEVN, EFFGT, ZR(JEFFG))
           ENDIF
C
      ENDIF
      CALL JEDETR('&&TE0410.SIGPG')
C
      END
