      SUBROUTINE TE0475(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 08/12/2009   AUTEUR PROIX J-M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2007  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================

      IMPLICIT NONE
      CHARACTER*16 OPTION,NOMTE
C ......................................................................
C    - FONCTION REALISEE:  CALCULS DE SENSIBILITE
C                          ELEMENTS DKT DST
C    - ARGUMENTS:
C        DONNEES:      OPTION       -->  OPTION DE CALCUL
C                      NOMTE        -->  NOM DU TYPE ELEMENT
C ......................................................................
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      CHARACTER*32 JEXNUM,JEXNOM,JEXR8,JEXATR
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------


      CHARACTER*24 BLAN24
      PARAMETER ( BLAN24 = '                        ' )
      INTEGER LGPG,JTAB(7),IRET
      INTEGER NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDX,JGANO,I,J,IJ
      INTEGER IGEOM,IMATE,IMATSE
      INTEGER ICONTM,IVARIM,JNBSPI
      INTEGER IDEPLM,IDEPLP,ICOMPO,ICACOQ
      INTEGER IVECTU,ICONTP,IVARIP
      INTEGER ICONSM,IVARSM,IPSENS,IDEPSM,IDEPSP
      INTEGER ICONSP,IVARSP,ICPARS,ICARCR,ITEMPS
      REAL*8  XYZL(3,4),PGL(3,3),PLG(3,3)
      REAL*8  UL(6,4),DUL(6,4),VECGLO(6,4)
      REAL*8  US(6,4),DUS(6,4)

      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDX,JGANO)

C -- PARAMETRES EN ENTREE

      IF (OPTION.EQ.'MECA_SENS_MATE'.OR.OPTION.EQ.'MECA_SENS_CHAR'
     &.OR.OPTION.EQ.'MECA_SENS_EPAI' 
     &.OR.OPTION(1:14).EQ.'MECA_SENS_RAPH') THEN
        CALL JEVECH('PGEOMER','L',IGEOM)
        CALL JEVECH('PMATERC','L',IMATE)
        CALL JEVECH('PCOMPOR','L',ICOMPO)
        CALL JEVECH('PCACOQU','L',ICACOQ)
        CALL JEVECH('PNBSP_I','L',JNBSPI)
        CALL JEVECH('PDEPLMR','L',IDEPLM)
        CALL JEVECH('PDEPLPR','L',IDEPLP)
        CALL JEVECH('PCONTMS','L',ICONSM)
        CALL JEVECH('PVARIMS','L',IVARSM)
        CALL JEVECH('PCONTMR','L',ICONTM)
        CALL JEVECH('PVARIMR','L',IVARIM)
        CALL JEVECH('PARSENS','L',IPSENS)
        CALL JEVECH('PVARIPR','L',IVARIP)
        CALL JEVECH('PCONTPR','L',ICONTP)
        IF (ZK24(IPSENS).NE.BLAN24) THEN
          CALL JEVECH('PMATSEN','L',IMATSE)
        ELSE
          IMATSE = IMATE
        ENDIF
        CALL TECACH('OON','PVARIMR',7,JTAB,IRET)
        LGPG = MAX(JTAB(6),1)*JTAB(7)
        IF (OPTION(1:14).EQ.'MECA_SENS_RAPH') THEN
          CALL JEVECH('PDEPLMS','L',IDEPSM)
          CALL JEVECH('PDEPLPS','L',IDEPSP)
          CALL JEVECH('PCOPARS','L',ICPARS)
        ELSEIF (OPTION.EQ.'MECA_SENS_EPAI') THEN
          CALL JEVECH('PCARCRI','L',ICARCR)
          CALL JEVECH('PTEMPSR','L',ITEMPS)
        ENDIF
      ELSE
        CALL U2MESK('F','ALGORITH7_61',1,OPTION)
      ENDIF

C -- PARAMETRES EN SORTIE

      IF(OPTION.EQ.'MECA_SENS_MATE'.OR.OPTION.EQ.'MECA_SENS_CHAR'
     &  .OR.(OPTION.EQ.'MECA_SENS_EPAI')) THEN
        CALL JEVECH('PVECTUR','E',IVECTU)
        CALL JEVECH('PCONTPS','E',ICONSP)
      END IF

      IF (OPTION(1:14).EQ.'MECA_SENS_RAPH') THEN
        CALL JEVECH('PVARIPS','E',IVARSP)
        CALL JEVECH('PCONTPS','E',ICONSP)
      END IF

C -- HYPER-ELASTICITE

      IF (ZK16(ICOMPO+3) (1:9).EQ.'COMP_ELAS') THEN
        CALL U2MESK('F','SENSIBILITE_35', 1 ,ZK16(ICOMPO+3))

      ELSE

C -- HYPO-ELASTICITE

        IF (ZK16(ICOMPO+2) (6:10).EQ.'_REAC') THEN
          CALL U2MESK('F','SENSIBILITE_35', 1 ,ZK16(ICOMPO+2))
        END IF

        IF (ZK16(ICOMPO+2) (1:5).EQ.'PETIT') THEN
C
C   PASSAGE EN REPERE LOCAL POUR GEOM ET DEPL
C
          IF (NNO.EQ.3) THEN
            CALL DXTPGL(ZR(IGEOM),PGL)
          ELSE IF (NNO.EQ.4) THEN
            CALL DXQPGL(ZR(IGEOM),PGL)
          END IF
          CALL UTPVGL(NNO,3,PGL,ZR(IGEOM),XYZL)
C
          CALL UTPVGL(NNO,6,PGL,ZR(IDEPLM),UL)
          CALL UTPVGL(NNO,6,PGL,ZR(IDEPLP),DUL)
C
          IF (OPTION(1:14).EQ.'MECA_SENS_RAPH') THEN
            CALL UTPVGL(NNO,6,PGL,ZR(IDEPSM),US)
            CALL UTPVGL(NNO,6,PGL,ZR(IDEPSP),DUS)
          ENDIF
C
          CALL DKTSNL(NOMTE,OPTION,XYZL,ZI(IMATE),ZI(IMATSE),
     &                ZR(ICARCR),ZR(ITEMPS),
     &                ZK16(ICOMPO),ZR(ICACOQ),ZI(JNBSPI),LGPG,
     &                UL,DUL,ZR(ICONSM),ZR(IVARSM),
     &                ZR(ICONTM),ZR(IVARIM),ZK24(IPSENS),ZR(ICPARS),
     &                ZR(ICONTP),ZR(IVARIP),US,DUS,
     &                ZR(IVECTU),ZR(ICONSP),ZR(IVARSP))

          IF(OPTION.EQ.'MECA_SENS_MATE'.OR.
     &       OPTION.EQ.'MECA_SENS_EPAI'.OR.
     &       OPTION.EQ.'MECA_SENS_CHAR') THEN
C
C   PASSAGE EN REPERE GLOBAL POUR VECTU
C
            CALL UTPVLG(NNO,6,PGL,ZR(IVECTU),VECGLO)
            DO 1 I=1,NNO
            DO 1 J=1,6
              IJ=6*(I-1)+J
              ZR(IVECTU-1+IJ) = VECGLO(J,I)
1           CONTINUE
          ENDIF
C -- GRANDES DEFORMATIONS : FORMULATION SIMO - MIEHE

        ELSE IF (ZK16(ICOMPO+2)(1:10).EQ.'SIMO_MIEHE') THEN
          CALL U2MESK('F','SENSIBILITE_35', 1 ,ZK16(ICOMPO+2))

C -- GRANDES ROTATIONS ET PETITES DEFORMATIONS
        ELSE IF (ZK16(ICOMPO+2) .EQ.'GROT_GDEP') THEN
          CALL U2MESK('F','SENSIBILITE_35', 1 ,ZK16(ICOMPO+2))

        ELSE
          CALL U2MESK('F','ELEMENTS3_16',1,ZK16(ICOMPO+2))
        END IF

      END IF

      END
