      SUBROUTINE TE0488(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 03/11/2008   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
      CHARACTER*16 OPTION,NOMTE
C ----------------------------------------------------------------------
C     CALCUL DES COORDONNEES DES POINTS DE GAUSS
C     POUR LES ELEMENTS ISOPARAMETRIQUES 3D  ET LEURS ELEMENTS DE PEAU

C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------

      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------

      INTEGER JGANO,NNO,KP,IPOIDS,IVF,IGEOM
      INTEGER NPG,NNOS,ICOPG,INO,NDIM,IDFDE

      REAL*8 XX,YY,ZZ,RBID81(81),POIDS,COVA(3,3),METR(2,2),JAC
C DEB ------------------------------------------------------------------

      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDE,JGANO)

      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PCOORPG','E',ICOPG)

      DO 20 KP = 1,NPG
        XX = 0.D0
        YY = 0.D0
        ZZ = 0.D0
        DO 10 INO = 1,NNO
          XX = XX + ZR(IGEOM+3* (INO-1)+0)*ZR(IVF+ (KP-1)*NNO+INO-1)
          YY = YY + ZR(IGEOM+3* (INO-1)+1)*ZR(IVF+ (KP-1)*NNO+INO-1)
          ZZ = ZZ + ZR(IGEOM+3* (INO-1)+2)*ZR(IVF+ (KP-1)*NNO+INO-1)
   10   CONTINUE

        IF (NDIM.EQ.3) THEN
C         -- CAS DES ELEMENTS 3D
          CALL DFDM3D ( NNO, KP, IPOIDS, IDFDE,
     &                ZR(IGEOM),RBID81,RBID81,RBID81,POIDS)
        ELSEIF (NDIM.EQ.2) THEN
C         -- CAS DES ELEMENTS "PEAU" DE 3D
          CALL SUBACO(NNO,ZR(IDFDE+(KP-1)*NDIM*NNO),ZR(IGEOM),COVA)
          CALL SUMETR(COVA,METR,JAC)
          POIDS=JAC*ZR(IPOIDS-1+KP)
        ELSE
          CALL ASSERT(.FALSE.)
        ENDIF



        ZR(ICOPG+4*(KP-1)+0) = XX
        ZR(ICOPG+4*(KP-1)+1) = YY
        ZR(ICOPG+4*(KP-1)+2) = ZZ
        ZR(ICOPG+4*(KP-1)+3) = POIDS
   20 CONTINUE

      END
