      SUBROUTINE TE0518(OPTION,NOMTE)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 21/07/2009   AUTEUR LEBOUVIER F.LEBOUVIER 
C ======================================================================
C COPYRIGHT (C) 1991 - 2007  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================

      IMPLICIT NONE
      CHARACTER*16 OPTION,NOMTE
C ......................................................................
C   CALCUL DES COEFFICIENTS A0 ET A1 POUR LE PILOTAGE PAR CRITERE 
C   ELASTIQUE POUR LES ELEMENTS GRAD_VARI
C ......................................................................

      CHARACTER*8 TYPMOD(2),ELREFE,ELREF2
      CHARACTER*16 PILO

      INTEGER JGANO,NDIM,NNO,NNOB,NNOS,NPG,LGPG,JTAB(7),ITYPE
      INTEGER IW,IVF,IVFB,IDFDE,IDFDEB,JGANOB,IGEOM,IMATE
      INTEGER ICONTM,IVARIM,ICOPIL,IBORNE,ICTAU
      INTEGER IDDLM,IDDLD,IDDL0,IDDL1,ICOMPO,IRET

      CHARACTER*16 NOMELT
      LOGICAL LTEATT

      COMMON /FFAUTO/ NOMELT

C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------

      NOMELT = NOMTE




C PARAMETRES DE L'ELEMENT DE REFERENCE

      CALL ELREFV(NOMELT,'RIGI',NDIM,NNO,NNOB,NNOS,NPG,IW,IVF,IVFB,
     &            IDFDE,IDFDEB,JGANO,JGANOB)


C - TYPE DE MODELISATION

      IF (NOMTE(1:5).EQ.'MVCA_') THEN
        TYPMOD(1) = '3D      '
      ELSE IF (LTEATT(' ','AXIS','OUI')) THEN
        TYPMOD(1) = 'AXIS    '
      ELSE IF (LTEATT(' ','D_PLAN','OUI')) THEN
        TYPMOD(1) = 'D_PLAN  '
      ELSE
C       NOM D'ELEMENT ILLICITE
        CALL ASSERT(NOMTE(1:5).EQ.'MVCA_')
      END IF


C - PARAMETRES EN ENTREE

      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PMATERC','L',IMATE)
      CALL JEVECH('PCOMPOR','L',ICOMPO)
      CALL JEVECH('PDEPLMR','L',IDDLM)
      CALL JEVECH('PCONTMR','L',ICONTM)
      CALL JEVECH('PVARIMR','L',IVARIM)
      CALL JEVECH('PDDEPLR','L',IDDLD)
      CALL JEVECH('PDEPL0R','L',IDDL0)
      CALL JEVECH('PDEPL1R','L',IDDL1)
      CALL JEVECH('PTYPEPI','L',ITYPE)

      PILO = ZK16(ITYPE)
      IF (PILO.EQ.'PRED_ELAS') THEN
        CALL JEVECH('PCDTAU','L',ICTAU)
        CALL JEVECH('PBORNPI','L',IBORNE)
      END IF


C -- NOMBRE DE VARIABLES INTERNES

      CALL TECACH('OON','PVARIMR',7,JTAB,IRET)
      LGPG = MAX(JTAB(6),1)*JTAB(7)


C PARAMETRES EN SORTIE

      CALL JEVECH('PCOPILO','E',ICOPIL)

      

      CALL PIPEGV(ZK16(ITYPE),NDIM,NNO,NNOB,NNOB,NPG,IW,ZR(IVF),
     &  ZR(IVFB),ZR(IVFB),IDFDE,IDFDEB,ZR(IGEOM),TYPMOD,
     &  ZI(IMATE),ZK16(ICOMPO),LGPG,ZR(IDDLM),ZR(ICONTM),
     &  ZR(IVARIM),ZR(IDDLD),ZR(IDDL0),ZR(IDDL1),
     &  ZR(ICOPIL),ZR(ICTAU),IBORNE)

      END
