      SUBROUTINE TE0547(OPTION,NOMTE)
      IMPLICIT   NONE
      CHARACTER*16 OPTION,NOMTE

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 28/11/2011   AUTEUR TARDIEU N.TARDIEU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C ======================================================================
C RESPONSABLE MASSIN P.MASSIN
C
C ......................................................................
C
C       CALCUL DES COEFFICIENTS A0 ET A1 POUR LE PILOTAGE PAR
C      PREDICTION ELASTIQUE POUR LES ELEMENTS X_FEM EN CONTACT
C               SOUMIS A LA LOI COHESIVE CZM_EXP_REG
C
C  OPTION : 'PILO_PRED_XLAS' 
C
C  ENTREES  ---> OPTION : OPTION DE CALCUL
C           ---> NOMTE  : NOM DU TYPE ELEMENT
C
C......................................................................
C TOLE CRP_20
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX --------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX --------------------

      INTEGER      I,J,IBID,NFE,IER
      INTEGER      NDIM,DDLC,DDLS,NDDL
      INTEGER      NNO,NNOS,NNOM,NNOF
      INTEGER      IPOIDS,IVF,IDFDE,JGANO,DDLM
      INTEGER      IPOIDF,IVFF,IDFDEF,IADZI,IAZK24
      INTEGER      NPG,NPGF,NPTF,INTEG,SINGU
      INTEGER      NINTER,NFACE,CFACE(5,3)
      INTEGER      LACT(8),NLACT
      INTEGER      JINDCO,JDONCO,JLSN,JLST,IGEOM,JPTINT
      INTEGER      JAINT,JCFACE,JLONCH,JBASEC,ICOPIL,ICTAU       
      INTEGER      IDEPL0,IDEPL1,IDEPLM,IDDEPL,JCOHES,IMATE
      INTEGER      NFH,NFISS,CONTAC
      CHARACTER*8  ELREF,TYPMA,FPG,ELC,LAG,ELREFC
      CHARACTER*16 ENR
      REAL*8       RELA,RBID
      LOGICAL      NOEUD
C......................................................................
      CALL JEMARQ()
C
C-----------------------------------------------------------------------
C     INITIALISATIONS
C-----------------------------------------------------------------------
C
      CALL ELREF1(ELREF)
      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDE,JGANO)
C
C     INITIALISATION DES DIMENSIONS DES DDLS X-FEM
C
      CALL XTEINI(NOMTE,NFH,NFE,SINGU,DDLC,NNOM,DDLS,NDDL,
     &            DDLM,NFISS,CONTAC)
      CALL TECAEL(IADZI,IAZK24)
      TYPMA=ZK24(IAZK24-1+3+ZI(IADZI-1+2)+3)
C
C------------RECUPERATION DU TYPE DE CONTACT----------------------------
C
      NOEUD=.FALSE.
      CALL TEATTR (NOMTE,'C','XLAG',LAG,IER)
      CALL ASSERT(IER.EQ.0)
      IF (LAG(1:5).EQ.'NOEUD') NOEUD=.TRUE.
      CALL ELELIN(CONTAC,ELREF,ELREFC,IBID,IBID)
C
C-----------------------------------------------------------------------
C     RECUPERATION DES ENTREES / SORTIE
C-----------------------------------------------------------------------
C
      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PDEPLMR','L',IDEPLM)
      CALL JEVECH('PDDEPLR','L',IDDEPL)  
      CALL JEVECH('PDEPL0R','L',IDEPL0)
      CALL JEVECH('PDEPL1R','L',IDEPL1)
      CALL JEVECH('PINDCOI','L',JINDCO)
      CALL JEVECH('PDONCO','L',JDONCO)
      CALL JEVECH('PLSN','L',JLSN)
      CALL JEVECH('PLST','L',JLST)
      CALL JEVECH('PPINTER','L',JPTINT)
      CALL JEVECH('PAINTER','L',JAINT)
      CALL JEVECH('PCFACE','L',JCFACE)
      CALL JEVECH('PLONCHA','L',JLONCH)
      CALL JEVECH('PBASECO','L',JBASEC)
      CALL JEVECH('PCDTAU' ,'L',ICTAU)

      CALL TEATTR(NOMTE,'S','XFEM',ENR,IBID)          
      IF (ENR.EQ.'XHC') THEN
        RELA =  ZR(JDONCO-1+10)  
      ELSE
        RELA=0.0D0 
      ENDIF
      
      IF (NINT(RELA).EQ.1.OR.NINT(RELA).EQ.2) THEN
        CALL JEVECH('PMATERC','L',IMATE)
        CALL JEVECH('PCOHES' ,'L',JCOHES)
      ENDIF
C      
C RECUPERATIONS DES DONNEES SUR LA TOPOLOGIE DES FACETTES
C
      NINTER=ZI(JLONCH)
      NFACE=ZI(JLONCH-1+2)
      NPTF=ZI(JLONCH-1+3)
C
      DO 11 I=1,NFACE
        DO 12 J=1,NPTF
          CFACE(I,J)=ZI(JCFACE-1+NPTF*(I-1)+J)
 12     CONTINUE
 11   CONTINUE      
C
C SCHEMA D'INTEGRATION NUMERIQUE ET ELEMENT DE REFERENCE DE CONTACT
C DISCUSSION VOIR BOOK IV 18/10/2004 ET BOOK VI 06/07/2005
C
      INTEG = NINT(ZR(JDONCO-1+4))
      CALL XMINTE(NDIM,INTEG,FPG)
      IF (NDIM .EQ. 3) THEN
        ELC='TR3'
      ELSEIF (NDIM.EQ.2) THEN
        IF(CONTAC.LE.2) THEN
          ELC='SE2'
        ELSE
          ELC='SE3'
        ENDIF
      ENDIF
 
C RECUPERATION DU NOMBRE DE POINTS DE GAUSS NPGF      
      CALL ELREF4(ELC,FPG,IBID,NNOF,IBID,NPGF,IPOIDF,IVFF,IDFDEF,IBID)

C
C LISTE DES LAMBDAS ACTIFS
      IF(NOEUD) CALL XLACTI(TYPMA,NINTER,JAINT,CONTAC,LACT,NLACT)
C 
C PARAMETRES EN SORTIE
      CALL JEVECH('PCOPILO','E',ICOPIL)

      CALL PIPEFX(NNO   ,NNOS  ,NDIM  ,NPGF ,NPTF ,
     &            NFH   ,NDDL  ,DDLM  ,SINGU,DDLS ,
     &            FPG   ,ELREF ,ELREFC,ELC  ,CFACE,
     &            NFACE ,JPTINT,IGEOM ,JLSN ,JLST ,
     &            JBASEC,ZR(JCOHES),ZI(IMATE),ZR(IDEPLM),ZR(IDDEPL),
     &            ZR(IDEPL0),ZR(IDEPL1),ZR(ICTAU),ZI(JINDCO),ZR(ICOPIL))
C 
      CALL JEDEMA()
      END
