      SUBROUTINE TE0554(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 29/04/2004   AUTEUR JMBHH01 J.M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*16 OPTION,NOMTE
C ......................................................................

C     BUT: CALCUL DES VECTEURS ELEMENTAIRES EN MECANIQUE
C          CORRESPONDANT A UNE IMPEDANCE ANECHOIQUE
C          SUR DES FACES D'ELEMENTS ISOPARAMETRIQUES 2D

C          OPTION : 'IMPE_ABSO'

C    - ARGUMENTS:
C        DONNEES:      OPTION       -->  OPTION DE CALCUL
C                      NOMTE        -->  NOM DU TYPE ELEMENT
C ......................................................................

      CHARACTER*8 NOMRES(3)
      CHARACTER*2 CODRET(3)
      REAL*8 POIDS,NX,NY,VALRES(3),E,NU,LAMBDA,MU
      REAL*8 RHOCP,RHOCS
      REAL*8 RHO,TAUX,TAUY,NUX,NUY,SCAL,VNX,VNY,VTX,VTY,JAC
      INTEGER NNO,KP,NPG,IPOIDS,IVF,IDFDE,IGEOM
      INTEGER IVECTU,K,I,MATER

C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDE,JGANO)
      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PMATERC','L',IMATE)
      CALL JEVECH('PVITPLU','L',IVITE)
      CALL JEVECH('PVECTUR','E',IVECTU)

      DO 10 I = 1,2*NNO
        ZR(IVECTU+I-1) = 0.0D0
   10 CONTINUE

      MATER = ZI(IMATE)
      NOMRES(1) = 'E'
      NOMRES(2) = 'NU'
      NOMRES(3) = 'RHO'
      CALL RCVALA(MATER,' ','ELAS',0,' ',R8B,3,NOMRES,VALRES,
     &            CODRET,'FM')
      E = VALRES(1)
      IF (E.LT.1.D-1) GO TO 60
      NU = VALRES(2)
      RHO = VALRES(3)

      LAMBDA = E*NU/ (1.D0+NU)/ (1.D0-2.D0*NU)
      MU = E/2.D0/ (1.D0+NU)

      RHOCP = SQRT((LAMBDA+2.D0*MU)*RHO)
      RHOCS = SQRT(MU*RHO)

C    BOUCLE SUR LES POINTS DE GAUSS

      DO 50 KP = 1,NPG
        K = (KP-1)*NNO
        CALL VFF2DN(NDIM,NNO,KP,IPOIDS,IDFDE,ZR(IGEOM),NX,NY,POIDS)

        JAC = SQRT(NX*NX+NY*NY)
C        --- CALCUL DE LA NORMALE UNITAIRE ---

        NUX = NX/JAC
        NUY = NY/JAC

C        --- CALCUL DE V.N ---

        SCAL = 0.D0
        DO 20 I = 1,NNO
          II = 2*I - 1
          SCAL = SCAL + NUX*ZR(IVF+K+I-1)*ZR(IVITE+II-1)
          SCAL = SCAL + NUY*ZR(IVF+K+I-1)*ZR(IVITE+II+1-1)
   20   CONTINUE

C        --- CALCUL DE LA VITESSE NORMALE ET DE LA VITESSE TANGENCIELLE

        VNX = NUX*SCAL
        VNY = NUY*SCAL

        VTX = 0.D0
        VTY = 0.D0

        DO 30 I = 1,NNO
          II = 2*I - 1
          VTX = VTX + ZR(IVF+K+I-1)*ZR(IVITE+II-1)
          VTY = VTY + ZR(IVF+K+I-1)*ZR(IVITE+II+1-1)
   30   CONTINUE

        VTX = VTX - VNX
        VTY = VTY - VNY


C        --- CALCUL DU VECTEUR CONTRAINTE

        TAUX = RHOCP*VNX + RHOCS*VTX
        TAUY = RHOCP*VNY + RHOCS*VTY


C        --- CALCUL DU VECTEUR ELEMENTAIRE

        DO 40 I = 1,NNO
          II = 2*I - 1
          ZR(IVECTU+II-1) = ZR(IVECTU+II-1) +
     &                      TAUX*ZR(IVF+K+I-1)*POIDS*JAC
          ZR(IVECTU+II+1-1) = ZR(IVECTU+II+1-1) +
     &                        TAUY*ZR(IVF+K+I-1)*POIDS*JAC
   40   CONTINUE

   50 CONTINUE

   60 CONTINUE

      END
