      SUBROUTINE XTLAGC(TYPMAI,NDIM  ,NNC   ,JNN    ,
     &                  NDDLS ,NFACE ,CFACE ,JDEPDE,JPCAI  ,
     &                  FFC   ,NCONTA,DLAGRC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 21/12/2010   AUTEUR MASSIN P.MASSIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INTEGER      NDIM,NNC,JNN(3),JNDDL(2)
      INTEGER      JDEPDE,JPCAI
      REAL*8       FFC(9)
      CHARACTER*8  TYPMAI
      REAL*8       DLAGRC
      INTEGER      CFACE(5,3),NFACE,NCONTA
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE XFEMGG - CALCUL ELEM.)
C
C CALCUL DES INCREMENTS - LAGRANGE DE CONTACT
C
C ----------------------------------------------------------------------
C ROUTINE SPECIFIQUE A L'APPROCHE <<GRANDS GLISSEMENTS AVEC XFEM>>,
C TRAVAIL EFFECTUE EN COLLABORATION AVEC I.F.P.
C ----------------------------------------------------------------------
C
C
C DEPDEL - INCREMENT DE DEPLACEMENT DEPUIS DEBUT DU PAS DE TEMPS
C
C IN  NDIM   : DIMENSION DU MODELE
C IN  NNC    : NOMBRE DE NOEUDS DE CONTACT
C IN  NN     : NOMBRE DE NOEUDS 
C IN  NDDLS  : NOMBRE DE DDL SUR UN NOEUD SOMMET
C IN  NNS    : NOMBRE DE NOEUDS SOMMETS
C IN  JDEPDE : ADRESSE JEVEUX POUR DEPDEL
C IN  FFC    : FONCTIONS DE FORMES LAGR.
C IN  CFACE  : CONNECTIVIT DES NOEUDS DES FACETTES 
C IN  NFACE  : NUMRO DE LA FACETTE
C IN  JAINT  : ADRESSE DES INFORMATIONS CONCERNANT LES ARETES COUPES
C IN  TYPMAI : TYPE DE LA MAILLE
C OUT DLAGRC : INCREMENT DEPDEL DU LAGRANGIEN DE CONTACT
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER INO
      INTEGER IN,XOULA,PL,NN,NNS,NDDLS
C
C ----------------------------------------------------------------------
C 
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      NN = JNN(1)
      NNS= JNN(2)
C
      DLAGRC    = 0.D0
C 
C --- LAGRANGE DE CONTACT
C     
      DO 230 INO = 1,NNC
C --- XOULA NE SERT PLUS A RIEN AVEC LA FORMULATION NOEUDS SOMMETS !!!
        IN     = XOULA(CFACE ,NFACE ,INO   ,JPCAI ,TYPMAI,NCONTA)
        CALL XPLMA2(NDIM  ,NN    ,NNS   ,NDDLS ,IN    ,PL    )
        DLAGRC = DLAGRC+FFC(INO)*ZR(JDEPDE-1+PL+1-1)
 230  CONTINUE
C
      CALL JEDEMA() 
C
      END
