      SUBROUTINE XTLAGM(TYPMAI,NDIM  ,NNC   ,JNN    ,
     &                  NDDLS ,NFACE ,CFACE ,JDEPDE,JPCAI  ,
     &                  FFC   ,LFROTT,NCONTA,DLAGRC,DLAGRF)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 21/12/2010   AUTEUR MASSIN P.MASSIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INTEGER      NDIM,NNC,JNN(3),NDDLS,NCONTA
      INTEGER      JDEPDE,JPCAI
      REAL*8       FFC(9)
      CHARACTER*8  TYPMAI
      REAL*8       DLAGRC,DLAGRF(2)
      INTEGER      CFACE(5,3),NFACE
      LOGICAL      LFROTT
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE XFEMGG - CALCUL ELEM.)
C
C CALCUL DES INCREMENTS - LAGRANGE DE CONTACT ET FROTTEMENT
C
C ----------------------------------------------------------------------
C ROUTINE SPECIFIQUE A L'APPROCHE <<GRANDS GLISSEMENTS AVEC XFEM>>,
C TRAVAIL EFFECTUE EN COLLABORATION AVEC I.F.P.
C ----------------------------------------------------------------------
C
C
C DEPDEL - INCREMENT DE DEPLACEMENT DEPUIS DEBUT DU PAS DE TEMPS
C
C IN  NDIM   : DIMENSION DU MODELE
C IN  NNC    : NOMBRE DE NOEUDS DE CONTACT
C IN  NN     : NOMBRE DE NOEUDS 
C IN  NNS    : NOMBRE DE NOEUDS SOMMETS
C IN  NDDLS  : NOMBRE DE DDL SUR UN NOEUD SOMMET
C IN  JDEPDE : POINTEUR JEVEUX POUR DEPDEL
C IN  FFC    : FONCTIONS DE FORMES LAGR.
C IN  CFACE  : CONNECTIVIT DES NOEUDS DES FACETTES 
C IN  NFACE  : NUMRO DE LA FACETTE
C IN  JAINT  : ADRESSE DES INFORMATIONS CONCERNANT LES ARETES COUPES
C IN  TYPMAI : TYPE DE LA MAILLE
C IN  LFROTT : .TRUE. SI FROTTEMENT
C OUT DLAGRC : INCREMENT DEPDEL DU LAGRANGIEN DE CONTACT
C OUT DLAGRF : INCREMENT DEPDEL DES LAGRANGIENS DE FROTTEMENT
C
C ----------------------------------------------------------------------
C 
      CALL XTLAGC(TYPMAI,NDIM  ,NNC   ,JNN   ,
     &            NDDLS ,NFACE ,CFACE ,JDEPDE,JPCAI  ,
     &            FFC   ,NCONTA,DLAGRC)
C
      IF (LFROTT) THEN
        CALL XTLAGF(TYPMAI,NDIM  ,NNC   ,JNN   ,
     &              NDDLS ,NFACE ,CFACE ,JDEPDE,JPCAI  ,
     &              FFC   ,NCONTA,DLAGRF) 
      ENDIF    
C
      END
