      SUBROUTINE CALIR4(NOMA,LISREL,NONO2,INO2,V1,JCONB1,JCOCF1,JCONU1,
     &                  IDECA1,JCONB2,JCOCF2,JCONU2,IDECA2)
      IMPLICIT NONE
      CHARACTER*19 LISREL
      CHARACTER*8 NONO2,NOMA
      INTEGER INO2,JCONB1,JCOCF1,JCONU1,IDECA1
      INTEGER JCONB2,JCOCF2,JCONU2,IDECA2
      REAL*8 V1(3)
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 13/04/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE PELLET
C BUT : ECRIRE LES RELATIONS LINEAIRES LIANT 2 ROTATIONS D'UN NOEUD DE
C       COQUE AVEC LES TRANSLATIONS DE 2 NOEUDS "MASSIFS"
C       (AFFE_CHAR_MECA/LIAISON_MAIL + TYPE_RACCORD='COQUE_MASSIF'
C ======================================================================
C     ----------- COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      CHARACTER*32 JEXNOM,JEXNUM
C---------------- FIN COMMUNS NORMALISES  JEVEUX  ----------------------

      REAL*8 BETA
      CHARACTER*2 TYPLAG
      CHARACTER*4 FONREE
      CHARACTER*4 TYPCOE

      REAL*8 RBID,COEFR(165),DIRECT(3*165),COEF1,EPAIS
      REAL*8 MAT33(3,3)
      COMPLEX*16 CBID,BETAC
      CHARACTER*8 KBETA,NOEUD(165),DDL(165),NONO1
      INTEGER DIMENS(165),NBTERM
      INTEGER N1,N2,INO1,NUNO1,K,IDEC,RAC2
C ----------------------------------------------------------------------

      BETA=0.0D0
      BETAC=(0.0D0,0.0D0)
      KBETA=' '
      TYPCOE='REEL'
      FONREE='REEL'
      TYPLAG='12'

      N1=ZI(JCONB1-1+INO2)
      N2=ZI(JCONB2-1+INO2)
      NBTERM=3*(1+N1+N2)
C     -- L'EPAISSEUR EST LA NORME DE V1 :
      EPAIS=SQRT(V1(1)*V1(1)+V1(2)*V1(2)+V1(3)*V1(3))
      CALL ASSERT(NBTERM.LE.165)


      CALL BASE3N(V1,MAT33)


      DO 10,K=1,NBTERM
        DIMENS(K)=0
   10 CONTINUE


C     -- CALCUL DES COEFFICIENTS DE LA RELATION DR2=... :
C     ----------------------------------------------------
      NOEUD(1)=NONO2
      NOEUD(2)=NONO2
      NOEUD(3)=NONO2
      DDL(1)='DRX'
      DDL(2)='DRY'
      DDL(3)='DRZ'
      COEFR(1)=-1.D0*MAT33(1,2)
      COEFR(2)=-1.D0*MAT33(2,2)
      COEFR(3)=-1.D0*MAT33(3,2)

C     -- NOEUDS DE LA 1ERE MAILLE (CORRE1) :
      DO 20,INO1=1,N1
        NUNO1=ZI(JCONU1+IDECA1-1+INO1)
        COEF1=ZR(JCOCF1+IDECA1-1+INO1)
        CALL JENUNO(JEXNUM(NOMA//'.NOMNOE',NUNO1),NONO1)
        IDEC=3+3*(INO1-1)
        NOEUD(IDEC+1)=NONO1
        NOEUD(IDEC+2)=NONO1
        NOEUD(IDEC+3)=NONO1
        DDL(IDEC+1)='DX'
        DDL(IDEC+2)='DY'
        DDL(IDEC+3)='DZ'
        COEFR(IDEC+1)=-(COEF1*MAT33(1,3))/EPAIS
        COEFR(IDEC+2)=-(COEF1*MAT33(2,3))/EPAIS
        COEFR(IDEC+3)=-(COEF1*MAT33(3,3))/EPAIS
   20 CONTINUE

C     -- NOEUDS DE LA 2EME MAILLE (CORRE2) :
      DO 30,INO1=1,N2
        NUNO1=ZI(JCONU2+IDECA2-1+INO1)
        COEF1=ZR(JCOCF2+IDECA2-1+INO1)
        CALL JENUNO(JEXNUM(NOMA//'.NOMNOE',NUNO1),NONO1)
        IDEC=3+3*(N1+INO1-1)
        NOEUD(IDEC+1)=NONO1
        NOEUD(IDEC+2)=NONO1
        NOEUD(IDEC+3)=NONO1
        DDL(IDEC+1)='DX'
        DDL(IDEC+2)='DY'
        DDL(IDEC+3)='DZ'
        COEFR(IDEC+1)=+(COEF1*MAT33(1,3))/EPAIS
        COEFR(IDEC+2)=+(COEF1*MAT33(2,3))/EPAIS
        COEFR(IDEC+3)=+(COEF1*MAT33(3,3))/EPAIS
   30 CONTINUE

      CALL AFRELA(COEFR,CBID,DDL,NOEUD,DIMENS,DIRECT,NBTERM,BETA,BETAC,
     &            KBETA,TYPCOE,FONREE,TYPLAG,1.D-6,LISREL)
      CALL IMPREL('LIAISON_MAIL-COQUE_MASSIF',NBTERM,COEFR,DDL,NOEUD,
     &            BETA)



C     -- CALCUL DES COEFFICIENTS DE LA RELATION DR3=... :
C     ----------------------------------------------------
      NOEUD(1)=NONO2
      NOEUD(2)=NONO2
      NOEUD(3)=NONO2
      DDL(1)='DRX'
      DDL(2)='DRY'
      DDL(3)='DRZ'
      COEFR(1)=-1.D0*MAT33(1,3)
      COEFR(2)=-1.D0*MAT33(2,3)
      COEFR(3)=-1.D0*MAT33(3,3)

C     -- NOEUDS DE LA 1ERE MAILLE (CORRE1) :
      DO 40,INO1=1,N1
        NUNO1=ZI(JCONU1+IDECA1-1+INO1)
        COEF1=ZR(JCOCF1+IDECA1-1+INO1)
        CALL JENUNO(JEXNUM(NOMA//'.NOMNOE',NUNO1),NONO1)
        IDEC=3+3*(INO1-1)
        NOEUD(IDEC+1)=NONO1
        NOEUD(IDEC+2)=NONO1
        NOEUD(IDEC+3)=NONO1
        DDL(IDEC+1)='DX'
        DDL(IDEC+2)='DY'
        DDL(IDEC+3)='DZ'
        COEFR(IDEC+1)=+(COEF1*MAT33(1,2))/EPAIS
        COEFR(IDEC+2)=+(COEF1*MAT33(2,2))/EPAIS
        COEFR(IDEC+3)=+(COEF1*MAT33(3,2))/EPAIS
   40 CONTINUE

C     -- NOEUDS DE LA 2EME MAILLE (CORRE2) :
      DO 50,INO1=1,N2
        NUNO1=ZI(JCONU2+IDECA2-1+INO1)
        COEF1=ZR(JCOCF2+IDECA2-1+INO1)
        CALL JENUNO(JEXNUM(NOMA//'.NOMNOE',NUNO1),NONO1)
        IDEC=3+3*(N1+INO1-1)
        NOEUD(IDEC+1)=NONO1
        NOEUD(IDEC+2)=NONO1
        NOEUD(IDEC+3)=NONO1
        DDL(IDEC+1)='DX'
        DDL(IDEC+2)='DY'
        DDL(IDEC+3)='DZ'
        COEFR(IDEC+1)=-(COEF1*MAT33(1,2))/EPAIS
        COEFR(IDEC+2)=-(COEF1*MAT33(2,2))/EPAIS
        COEFR(IDEC+3)=-(COEF1*MAT33(3,2))/EPAIS
   50 CONTINUE

      CALL AFRELA(COEFR,CBID,DDL,NOEUD,DIMENS,DIRECT,NBTERM,BETA,BETAC,
     &            KBETA,TYPCOE,FONREE,TYPLAG,1.D-6,LISREL)
      CALL IMPREL('LIAISON_MAIL-COQUE_MASSIF',NBTERM,COEFR,DDL,NOEUD,
     &            BETA)



      END
