      SUBROUTINE CARACM(CHAR  ,NZOCO ,IFORM )
C      
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 22/12/2009   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2008  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C 
      IMPLICIT NONE
      CHARACTER*8  CHAR
      INTEGER      NZOCO
      INTEGER      IFORM
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES MAILLEES - LECTURE DONNEES)
C
C CREATION DES SDS DE DEFINITION DU CONTACT
C SDS DEDIEES AUX METHODES MAILLEES
C      
C ----------------------------------------------------------------------
C
C
C IN  CHAR   : NOM UTILISATEUR DU CONCEPT DE CHARGE
C IN  IFORM  : TYPE DE FORMULATION (DISCRET/CONTINU/XFEM)
C IN  NZOCO  : NOMBRE DE ZONES DE CONTACT
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      LOGICAL      LMAIL
      CHARACTER*24 DEFICO
      INTEGER      CFMMVD,ZTOLE ,ZDIRN ,ZMETH
      CHARACTER*24 METHCO,DIRAPP,TOLECO,DIRNOR
      INTEGER      JMETH ,JDIRAP,JTOLE,JDIRNO
      CHARACTER*24 JEUFO1,JEUFO2
      INTEGER      JJFO1 ,JJFO2      
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DEFICO = CHAR(1:8)//'.CONTACT' 
      LMAIL  = (IFORM.EQ.1).OR.(IFORM.EQ.2)   
C      
C --- CREATION DES SD DE BASE
C
      METHCO = DEFICO(1:16)//'.METHCO'      
      TOLECO = DEFICO(1:16)//'.TOLECO'       
      DIRAPP = DEFICO(1:16)//'.DIRAPP'
      DIRNOR = DEFICO(1:16)//'.DIRNOR'      
      JEUFO1 = DEFICO(1:16)//'.JFO1CO'
      JEUFO2 = DEFICO(1:16)//'.JFO2CO'         
C     
      ZTOLE  = CFMMVD('ZTOLE') 
      ZDIRN  = CFMMVD('ZDIRN') 
      ZMETH  = CFMMVD('ZMETH')         
C      
      CALL WKVECT(METHCO,'G V I' ,ZMETH*NZOCO  ,JMETH )
      CALL WKVECT(TOLECO,'G V R' ,ZTOLE*NZOCO  ,JTOLE )  
      IF (LMAIL) THEN
        CALL WKVECT(JEUFO1,'G V K8',NZOCO        ,JJFO1 )
        CALL WKVECT(JEUFO2,'G V K8',NZOCO        ,JJFO2 )
        CALL WKVECT(DIRAPP,'G V R' ,3*NZOCO      ,JDIRAP)
        CALL WKVECT(DIRNOR,'G V R' ,ZDIRN*NZOCO  ,JDIRNO)    
      ENDIF             
C
      CALL JEDEMA()
C
      END
