      SUBROUTINE CFLEMA(DEFICO,NSUCO  ,NMACO0,LISTMA,POINSM,
     &                  NMACO )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 29/09/2008   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2008  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INTEGER      NSUCO
      INTEGER      NMACO0,NMACO
      CHARACTER*24 DEFICO
      CHARACTER*24 LISTMA
      CHARACTER*24 POINSM
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES MAILLEES - LECTURE DONNEES - ELIMINATION)
C
C CREATION D'UNE LISTE DES MAILLES EN DOUBLES AU SEIN D'UNE SURFACE
C DE CONTACT
C      
C ----------------------------------------------------------------------
C
C 
C IN  DEFICO : NOM SD CONTACT DEFINITION
C IN  NSUCO  : NOMBRE TOTAL DE SURFACES DE CONTACT
C IN  NMACO0 : NOMBRE TOTAL DE MAILLES DES SURFACES
C OUT POINSM : POINTEUR MISE A JOUR POUR PSURMA
C OUT LISTMA : LISTE DES MAILLES RESTANTES (LONGUEUR NMACO
C OUT NMACO  : NOMBRE DE MAILLES AU FINAL 
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*24 CONTMA
      INTEGER      JMACO
      INTEGER      JINDMA,JELIMA
      INTEGER      JDECMA,JMA
      INTEGER      ISUCO,I,II,IMA1,IMA2,K
      INTEGER      ELIMMA,NBMA
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()    
C
C --- CREATION DES VECTEURS DE TRAVAIL TEMPORAIRES
C
      CALL WKVECT('&&CFLEMA.INDIMA','V V I',NMACO  ,JINDMA)
      CALL WKVECT(POINSM,'V V I',NSUCO+1,JELIMA)
C 
C --- ACCES AUX STRUCTURES DE DONNEES DE CONTACT
C 
      CONTMA = DEFICO(1:16)//'.MAILCO'
      CALL JEVEUO(CONTMA,'L',JMACO)
C
C --- INITIALISATIONS
C 
      ELIMMA = 0    
C
C --- REPERAGE DES MAILLES REDONDANTES POUR CHAQUE SURFACE
C 
      DO 110 ISUCO = 1,NSUCO
        ZI(JELIMA+ISUCO) = ZI(JELIMA+ISUCO-1)
        CALL CFNBSF(DEFICO,ISUCO ,'MAIL',NBMA ,JDECMA)
        DO 20 I = 1,NBMA
          IMA1 = ZI(JMACO+JDECMA+I-1)
          DO 10 II = 1,I - 1
            IMA2 = ZI(JMACO+JDECMA+II-1)
            IF (IMA1.EQ.IMA2) THEN
              ZI(JINDMA+JDECMA+I-1) = 1
              ZI(JELIMA+ISUCO)      = ZI(JELIMA+ISUCO) + 1
              ELIMMA                = ELIMMA + 1
              GO TO 20
            END IF
   10     CONTINUE
   20   CONTINUE
  110 CONTINUE
C
C --- RECOPIE DES MAILLES NON ELIMINES DANS TABLEAU DE TRAVAIL
C 
      NMACO  = NMACO0 - ELIMMA
      CALL WKVECT(LISTMA,'V V I',NMACO,JMA)
C
C --- TRAITEMENT DES MAILLES
C
      K = 0
      DO 120 I = 1,NMACO0
        IF (ZI(JINDMA+I-1).EQ.0) THEN
          K = K + 1
          ZI(JMA+K-1) = ZI(JMACO+I-1)
        ENDIF
  120 CONTINUE
      CALL ASSERT(K.EQ.NMACO)
C
C --- DESTRUCTION DES VECTEURS DE TRAVAIL TEMPORAIRES
C
      CALL JEDETR('&&CFLEMA.INDIMA')
C
      CALL JEDEMA()
      END
