      SUBROUTINE CFLENO(DEFICO,NSUCO  ,NNOCO0,LISTNO,POINSN,
     &                  NNOCO )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 07/10/2008   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2008  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS 
C
      IMPLICIT     NONE
      INTEGER      NSUCO
      INTEGER      NNOCO0,NNOCO
      CHARACTER*24 DEFICO
      CHARACTER*24 LISTNO
      CHARACTER*24 POINSN
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES MAILLEES - LECTURE DONNEES - ELIMINATION)
C
C CREATION D'UNE LISTE DES NOEUDS EN DOUBLE AU SEIN D'UNE SURFACE
C DE CONTACT
C      
C ----------------------------------------------------------------------
C
C 
C IN  DEFICO : NOM SD CONTACT DEFINITION
C IN  NSUCO  : NOMBRE TOTAL DE SURFACES DE CONTACT
C IN  NNOCO0 : NOMBRE TOTAL DE NOEUDS DES SURFACES
C OUT POINSN : POINTEUR MISE A JOUR POUR PSURNO
C               ZI(JELINO+ISUCO) - ZI(JELINO+ISUCO-1)
C                NOMBRE DE NOEUDS SUPPRIMES POUR LA SURFACE ISUCO
C OUT LISTNO : LISTE DES NOEUDS RESTANTES (LONGUEUR NNOCO
C OUT NNOCO  : NOMBRE DE NOEUDS AU FINAL 
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*24 CONTNO
      INTEGER      JNOCO
      INTEGER      JINDNO,JELINO
      INTEGER      JDECNO,JNO
      INTEGER      ISUCO,I,II,INO1,INO2,K
      INTEGER      ELIMNO,NBNO
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()    
C
C --- CREATION DES VECTEURS DE TRAVAIL TEMPORAIRES
C
      CALL WKVECT('&&CFLENO.INDINO','V V I',NNOCO  ,JINDNO)
      CALL WKVECT(POINSN,'V V I',NSUCO+1,JELINO)
C 
C --- ACCES AUX STRUCTURES DE DONNEES DE CONTACT
C 
      CONTNO = DEFICO(1:16)//'.NOEUCO'
      CALL JEVEUO(CONTNO,'L',JNOCO)
C
C --- INITIALISATIONS
C 
      ELIMNO = 0    
C
C --- REPERAGE DES NOEUDS REDONDANTS POUR CHAQUE SURFACE
C 
      DO 110 ISUCO = 1,NSUCO
        ZI(JELINO+ISUCO) = ZI(JELINO+ISUCO-1)
        CALL CFNBSF(DEFICO,ISUCO ,'NOEU',NBNO ,JDECNO)
        DO 20 I = 1,NBNO
          INO1 = ZI(JNOCO+JDECNO+I-1)
          DO 10 II = 1,I - 1
            INO2 = ZI(JNOCO+JDECNO+II-1)
            IF (INO1.EQ.INO2) THEN
              ZI(JINDNO+JDECNO+I-1) = 1
              ZI(JELINO+ISUCO)      = ZI(JELINO+ISUCO) + 1
              ELIMNO                = ELIMNO + 1
              GO TO 20
            END IF
   10     CONTINUE
   20   CONTINUE
  110 CONTINUE
C
C --- RECOPIE DES NOEUDS NON ELIMINES DANS TABLEAU DE TRAVAIL
C 
      NNOCO  = NNOCO0 - ELIMNO
      CALL WKVECT(LISTNO,'V V I',NNOCO,JNO)
C
C --- TRAITEMENT DES NOEUDS
C
      K = 0
      DO 120 I = 1,NNOCO0
        IF (ZI(JINDNO+I-1).EQ.0) THEN
          K = K + 1
          ZI(JNO+K-1) = ZI(JNOCO+I-1)
        ENDIF
  120 CONTINUE
      CALL ASSERT(K.EQ.NNOCO)
C
C --- DESTRUCTION DES VECTEURS DE TRAVAIL TEMPORAIRES
C
      CALL JEDETR('&&CFLENO.INDINO')
C
      CALL JEDEMA()
      END
