      SUBROUTINE CFLEQB(NOMA  ,DEFICO,NZOCO ,NNOQUA)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 14/09/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      CHARACTER*8  NOMA
      INTEGER      NZOCO,NNOQUA
      CHARACTER*24 DEFICO  
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES MAILLEES - LECTURE DONNEES - QUAD8)
C
C ECRITURE LISTE DES NOEUDS QUADRATIQUES
C OBJETS PNOQUA ET CONOQU
C      
C ----------------------------------------------------------------------
C
C 
C IN  NOMA   : NOM DU MAILLAGE
C IN  DEFICO : NOM SD CONTACT DEFINITION
C IN  NZOCO  : NOMBRE TOTAL DE ZONES DE CONTACT
C IN  NNOQUA : NOMBRE TOTAL DE NOEUDS QUADRATIQUES DES SURFACES
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*32 JEXNUM
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*24 PZONE
      INTEGER      JZONE
      CHARACTER*24 PNOQUA,CONOQU
      INTEGER      JNOQUA,JNOQU
      CHARACTER*24 CONTMA
      INTEGER      JMACO
      INTEGER      JDECMA,NUMMAI,POSMAI
      INTEGER      ISURF,IZONE,IMA,NUTYP,INOQUA,ISUCO
      INTEGER      INOQTO,JDECQU
      INTEGER      JDES
      INTEGER      NOMILI(3,4)
      INTEGER      NBSURF,NBMA,NBNOMI
      INTEGER      IATYMA,ITYPMA
      CHARACTER*8  NOMTM
      LOGICAL      MMINFL,LVERI
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ() 
C
C --- CREATION DES DEUX VECTEURS
C
      PNOQUA = DEFICO(1:16)//'.PNOEUQU'
      CONOQU = DEFICO(1:16)//'.NOEUQU'
      CALL WKVECT(PNOQUA,'V V I',NZOCO+1 ,JNOQUA)
      CALL WKVECT(CONOQU,'V V I',3*NNOQUA,JNOQU )   
C 
C --- ACCES AUX STRUCTURES DE DONNEES DE CONTACT
C 
      CONTMA = DEFICO(1:16)//'.MAILCO' 
      PZONE  = DEFICO(1:16)//'.PZONECO'
      CALL JEVEUO(CONTMA,'L',JMACO)  
      CALL JEVEUO(PZONE, 'L',JZONE)
C
C --- INITIALISATIONS
C 
      JDECQU  = 0
      CALL JEVEUO(NOMA(1:8)//'.TYPMAIL','L',IATYMA)
C
C --- LISTE DES NOEUDS MILIEUX POUR CHAQUE ZONE
C      
      DO 10 IZONE = 1,NZOCO 
C      
        INOQTO = 0 
C      
        LVERI  = MMINFL(DEFICO,'VERIF',IZONE )
        IF (LVERI) THEN
          GOTO 21
        ENDIF
C
C ----- NOMBRE DE SURFACES DE CONTACT
C        
        NBSURF = ZI(JZONE+IZONE) - ZI(JZONE+IZONE-1)
        CALL ASSERT(NBSURF.EQ.2)     
C      
        DO 20 ISUCO = 1,NBSURF
        
          ISURF  = NBSURF*(IZONE-1)+ISUCO
      
          CALL CFNBSF(DEFICO,ISURF ,'MAIL',NBMA  ,JDECMA)
              
          DO 30 IMA = 1,NBMA 
C
C --------- NUMERO MAILLE COURANTE
C
            POSMAI = JDECMA+IMA
            NUMMAI = ZI(JMACO+POSMAI-1)
C
C --------- TYPE MAILLE COURANTE
C          
            ITYPMA = IATYMA - 1 + NUMMAI
            NUTYP  = ZI(ITYPMA)       
            CALL JENUNO(JEXNUM('&CATA.TM.NOMTM',NUTYP),NOMTM)
C
C --------- CONNECTIVITE DE LA MAILLE
C 
            CALL JEVEUO(JEXNUM(NOMA(1:8)//'.CONNEX',NUMMAI),'L',JDES)
C
C --------- NOEUDS: SOMMET1-SOMMET2-MILIEU
C
            IF  (NOMTM(1:5).EQ.'QUAD8') THEN 
              NBNOMI    = 4
              NOMILI(1,1) = ZI(JDES+5-1)
              NOMILI(1,2) = ZI(JDES+6-1)
              NOMILI(1,3) = ZI(JDES+7-1)
              NOMILI(1,4) = ZI(JDES+8-1)        
              NOMILI(2,1) = ZI(JDES+1-1)
              NOMILI(2,2) = ZI(JDES+2-1)
              NOMILI(2,3) = ZI(JDES+3-1)
              NOMILI(2,4) = ZI(JDES+4-1) 
              NOMILI(3,1) = ZI(JDES+2-1)
              NOMILI(3,2) = ZI(JDES+3-1)
              NOMILI(3,3) = ZI(JDES+4-1)
              NOMILI(3,4) = ZI(JDES+1-1)
            ELSE
              NBNOMI = 0                            
            ENDIF
C
C --------- TABLEAU DES NOEUDS : SOMMET1-SOMMET2-MILIEU
C  
            IF  (NOMTM(1:5).EQ.'QUAD8') THEN
              DO 92 INOQUA = 1,NBNOMI 
                ZI(JNOQU+JDECQU+3*(INOQUA-1)+1-1) = NOMILI(1,INOQUA)   
                ZI(JNOQU+JDECQU+3*(INOQUA-1)+2-1) = NOMILI(2,INOQUA) 
                ZI(JNOQU+JDECQU+3*(INOQUA-1)+3-1) = NOMILI(3,INOQUA)
   92         CONTINUE
              JDECQU = JDECQU + 3*NBNOMI   
              INOQTO = INOQTO + 3*NBNOMI
            ENDIF    
C
  30      CONTINUE
  20    CONTINUE 
  21    CONTINUE
C
C ----- MISE A JOUR POINTEUR
C   
        ZI(JNOQUA+IZONE) = ZI(JNOQUA+IZONE-1)+INOQTO    
C
  10  CONTINUE  
C
      CALL JEDEMA()
      END
