      SUBROUTINE CFLEQC(NOMA  ,DEFICO,NZOCO ,NNOCO ,NSUCO ,
     &                  POINSN,INDINO,ELIMNO)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 14/09/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      CHARACTER*8  NOMA
      INTEGER      NZOCO,NNOCO,NSUCO
      CHARACTER*24 DEFICO
      CHARACTER*24 POINSN,INDINO
      INTEGER      ELIMNO
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES MAILLEES - LECTURE DONNEES - QUAD8)
C
C LSITE DES NOEUDS MILIEUX A ELIMINER
C      
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE 
C IN  DEFICO : NOM SD CONTACT DEFINITION
C IN  NZOCO  : NOMBRE TOTAL DE ZONES DE CONTACT
C IN  NNOCO  : NOMBRE TOTAL DE NOEUDS DE CONTACT
C IN  NSUCO  : NOMBRE TOTAL DE SURFACES DE CONTACT
C OUT ELIMNO : NOMBRE DE NOEUDS A ELIMINER
C OUT POINSN : POINTEUR MISE A JOUR POUR INDINO
C OUT INDINO : NOEUDS A ELIMINER POUR CHAQUE SURFACE
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*32 JEXNUM
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*24 PZONE
      INTEGER      JZONE
      CHARACTER*24 CONTMA,CONTNO,CONOQU,PNOQUA
      INTEGER      JMACO,JNOCO,JNOQU,JNOQUA
      INTEGER      JDECMA,NUMMAI,POSMAI
      INTEGER      ISURF,IZONE,IMA,INO,NUTYP,INOQUA,ISUCO
      INTEGER      NBSURF,NBMA,NBNOQ,NBNO
      INTEGER      IATYMA,ITYPMA
      CHARACTER*8  NOMTM
      LOGICAL      MMINFL,LVERI
      INTEGER      JINDNO,JELINO
      INTEGER      JDECNO,JDECQU
      INTEGER      POSNO,NUMNO1,NUMNO2
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()    
C
C --- CREATION DES SD
C
      CALL WKVECT(INDINO,'V V I',NNOCO  ,JINDNO)
      CALL WKVECT(POINSN,'V V I',NSUCO+1,JELINO)  
C 
C --- ACCES AUX STRUCTURES DE DONNEES DE CONTACT
C 
      CONOQU = DEFICO(1:16)//'.NOEUQU'
      CALL JEVEUO(CONOQU,'L',JNOQU )
      PNOQUA = DEFICO(1:16)//'.PNOEUQU'
      CALL JEVEUO(PNOQUA,'L',JNOQUA )
      CONTMA = DEFICO(1:16)//'.MAILCO'
      CONTNO = DEFICO(1:16)//'.NOEUCO'
      PZONE  = DEFICO(1:16)//'.PZONECO'
      CALL JEVEUO(CONTMA,'L',JMACO )
      CALL JEVEUO(CONTNO,'L',JNOCO )   
      CALL JEVEUO(PZONE, 'L',JZONE )
C
C --- INITIALISATIONS
C 
      ELIMNO = 0
      JDECQU = 0
      CALL JEVEUO(NOMA(1:8)//'.TYPMAIL','L',IATYMA)
C
C --- LISTE DES NOEUDS MILIEUX POUR CHAQUE ZONE
C         
      DO 10 IZONE = 1,NZOCO 
C      
        LVERI  = MMINFL(DEFICO,'VERIF',IZONE )
        IF (LVERI) THEN
          GOTO 21
        ENDIF
C
C ----- NOMBRE DE SURFACES DE CONTACT
C        
        NBSURF = ZI(JZONE+IZONE) - ZI(JZONE+IZONE-1)
        CALL ASSERT(NBSURF.EQ.2)      
C      
        DO 20 ISUCO = 1,NBSURF
          ISURF  = NBSURF*(IZONE-1)+ISUCO
          
          ZI(JELINO+ISURF) = ZI(JELINO+ISURF-1)
C
          CALL CFNBSF(DEFICO,ISURF ,'MAIL',NBMA  ,JDECMA)
              
          DO 30 IMA = 1,NBMA 
C
C --------- NUMERO MAILLE COURANTE
C
            POSMAI = JDECMA+IMA
            NUMMAI = ZI(JMACO+POSMAI-1)
C
C --------- TYPE MAILLE COURANTE
C          
            ITYPMA = IATYMA - 1 + NUMMAI
            NUTYP  = ZI(ITYPMA)       
            CALL JENUNO(JEXNUM('&CATA.TM.NOMTM',NUTYP ),NOMTM )
C
C --------- ELIMINATION DES NOEUDS MILIEUX DES ARETES DES QUAD8
C
            IF (NOMTM(1:5).EQ.'QUAD8') THEN 
              NBNOQ  = ZI(JNOQUA+IZONE) - ZI(JNOQUA+IZONE-1)
              JDECQU = ZI(JNOQUA+IZONE-1)     
              CALL CFNBSF(DEFICO,ISURF ,'NOEU',NBNO  ,JDECNO)
              NBNOQ  = NBNOQ/3    
              DO 70 INOQUA = 1,NBNOQ
                NUMNO1 = ZI(JNOQU+JDECQU+3*(INOQUA-1)+1-1)       
                DO 80 INO = 1,NBNO
                  POSNO  = JDECNO+INO
                  NUMNO2 = ZI(JNOCO+POSNO-1)
                  IF (NUMNO1.EQ.NUMNO2) THEN
                    IF (ZI(JINDNO+POSNO-1).EQ.0) THEN
                      ZI(JINDNO+POSNO-1) = 1
                      ZI(JELINO+ISURF)   = ZI(JELINO+ISURF)+1
                      ELIMNO             = ELIMNO + 1 
                    ENDIF
                  ENDIF
   80           CONTINUE
   70         CONTINUE
            ENDIF
  30      CONTINUE
  20    CONTINUE 
  21    CONTINUE
  10  CONTINUE 
C
      CALL ASSERT((2*NZOCO).EQ.NSUCO)   
C
      CALL JEDEMA()
      END
