      SUBROUTINE CRELRL (TYPCOZ, TYPVAZ, BASEZ, LISREZ)
      IMPLICIT REAL*8 (A-H,O-Z)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 19/06/2007   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      CHARACTER*1  BASE
      CHARACTER*4  TYPCOE, TYPVAL
      CHARACTER*19 LISREL
      CHARACTER*(*) TYPCOZ, TYPVAZ, BASEZ, LISREZ
C ------------------------------------------------------------
C     CREATION DE L'OBJET DE TYPE LISTE_DE_RELATIONS
C     DE NOM LISREL
C        LE NOM LISREL EST FOURNI EN ARGUMENT
C     SI L'OBJET LISREL EXISTE DEJA, ON LE DETRUIT
C                               PUIS ON LE RECREE
C
C     LA TAILLE DES VECTEURS CONTENANT LES COMPOSANTES
C     DES RELATIONS EST DIMENSIONNEE A LVECRL = 10000
C
C     LA TAILLE DES VECTEURS QUI CORRESPOND AUX NOMBRES
C     DE RELATIONS EST DIMENSIONNEE A NBRELA = 1000
C
C
C-------------------------------------------------------------
C TYPCOZ        - IN - K4  - : TYPE DES COEFFICIENTS DE LA RELATION
C               -    -     -   = 'REEL' OU 'COMP'
C-------------------------------------------------------------
C  TYPVAZ       - IN - K4  - : INDICATEUR DU TYPE DU SECOND MEMBRE
C               -    -     -     = 'REEL' OU 'COMP' OU 'FONC'
C-------------------------------------------------------------
C  BASEZ        - IN - K1  - : INDICATEUR DE LA BASE SUR LAQUELLE
C                              DOIT ETRE CREE L'OBJET DE TYPE
C                              LISTE_DE_RELATIONS
C-------------------------------------------------------------
C  LISREZ     - IN    - K19 - : NOM DE LA LISTE_RELA
C             - JXOUT -     -
C-------------------------------------------------------------
C
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX -----------
      CHARACTER*32       JEXNUM , JEXNOM , JEXR8 , JEXATR
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE /ZK8(1),ZK16(1),ZK24(1),ZK32(1), ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX -----------
C
      PARAMETER (LVECRL = 10000)
      PARAMETER (NBRELA = 1000)
C
      CALL JEMARQ()
C
C --- SI L'OBJET LISREL EXISTE , ON LE DETRUIT ---
C
      TYPCOE = TYPCOZ
      TYPVAL = TYPVAZ
      BASE   = BASEZ
      LISREL = LISREZ
C
      CALL JEEXIN(LISREL//'.RLCO' ,IRET)
      IF (IRET.NE.0) THEN
          CALL JEDETR(LISREL//'.RLCO')
          CALL JEDETR(LISREL//'.RLDD')
          CALL JEDETR(LISREL//'.RLNO')
          CALL JEDETR(LISREL//'.RLBE')
          CALL JEDETR(LISREL//'.RLNT')
          CALL JEDETR(LISREL//'.RLPO')
          CALL JEDETR(LISREL//'.RLNR')
          CALL JEDETR(LISREL//'.RLSU')
          CALL JEDETR(LISREL//'.RLTC')
          CALL JEDETR(LISREL//'.RLTV')
          CALL JEDETR(LISREL//'.RLBE')
          CALL JEDETR(LISREL//'.RLLA')
      ENDIF
C
C ---  VECTEUR DES COEFFICIENTS DES TERMES DES RELATIONS
C
      IF (TYPCOE.EQ.'COMP') THEN
          CALL WKVECT(LISREL//'.RLCO',BASE//' V C',LVECRL,IDCOEF)
      ELSE
          CALL WKVECT(LISREL//'.RLCO',BASE//' V R',LVECRL,IDCOEF)
      ENDIF
C
C ---  VECTEUR DES NOMS DES DDLS IMPLIQUES DANS LES RELATIONS
C
      CALL WKVECT(LISREL//'.RLDD',BASE//' V K8',LVECRL,IDDL)
C
C ---  VECTEUR DES NOMS DES NOEUDS IMPLIQUES DANS LES RELATIONS
C
      CALL WKVECT(LISREL//'.RLNO',BASE//' V K8',LVECRL,IDNOEU)
C
C ---  VECTEUR DES VALEURS DES SECONDS MEMBRES DE CHAQUE RELATION
C
      IF (TYPVAL.EQ.'REEL') THEN
          CALL WKVECT(LISREL//'.RLBE',BASE//' V R',NBRELA,IDBETA)
      ELSE IF (TYPVAL.EQ.'COMP') THEN
          CALL WKVECT(LISREL//'.RLBE',BASE//' V C',NBRELA,IDBETA)
      ELSE IF (TYPVAL.EQ.'FONC') THEN
          CALL WKVECT(LISREL//'.RLBE',BASE//' V K24',NBRELA,IDBETA)
      ENDIF
C
C ---  VECTEUR DES NOMBRES DE TERMES DE CHAQUE RELATION
C
      CALL WKVECT(LISREL//'.RLNT',BASE//' V I',NBRELA,IDTERM)
C
C ---  VECTEUR DES NOMBRES DE TERMES CUMULES DES RELATIONS
C ---  ( SERT DE POINTEUR DANS LES TABLEAUX RELATIFS AUX TERMES
C ---    DES RELATIONS)
C
      CALL WKVECT(LISREL//'.RLPO',BASE//' V I',NBRELA,IDPOIN)
C
C ---  VECTEUR D'INDICATEURS DE PRISE EN COMPTE DES RELATIONS
C ---  ( SERT A APPLIQUER LA REGLE DE SURCHARGE)
C
      CALL WKVECT(LISREL//'.RLSU',BASE//' V I',NBRELA,IDSURC)
C
C ---  VECTEUR DE K8 INDIQUANT LA POSITION DES LAGRANGE
C ---  ASSOCIES A LA RELATION COURANTE
C
      CALL WKVECT(LISREL//'.RLLA',BASE//' V K8',NBRELA,IDLAGR)
C
C ---  NOMBRE DE RELATIONS
C
      CALL WKVECT(LISREL//'.RLNR',BASE//' V I',1,IDNBRE)
      ZI(IDNBRE) = 0
C
C ---  TYPE DES COEFFICIENTS DES RELATIONS (TYPCOE)
C
      CALL WKVECT(LISREL//'.RLTC',BASE//' V K8',1,IDTYCO)
      ZK8(IDTYCO) = TYPCOE(1:4)//'    '
C
C ---  TYPE DES VALEURS DES RELATIONS (TYPVAL)
C
      CALL WKVECT(LISREL//'.RLTV',BASE//' V K8',1,IDTYVA)
      ZK8(IDTYVA) = TYPVAL(1:4)//'    '
C
      CALL JEDEMA()
      END
