      SUBROUTINE DISCFF(NBFONC,NOMFON,NBP1,NBP2,DISC,VALE)
      IMPLICIT REAL*8 (A-H,O-Z)
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 19/02/2008   AUTEUR MACOCCO K.MACOCCO 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C-----------------------------------------------------------------------
C     DISCRETISATION DES FONCTIONS DE FORME
C     APPELANT : SPECFF
C-----------------------------------------------------------------------
C IN  : NBFONC : NOMBRE DE FONCTIONS
C IN  : NOMFON : LISTE DES NOMS DES CONCEPTS DE TYPE FONCTION
C IN  : NBP1   : NOMBRE DE POINTS DE DISCRETISATION DES FONCTIONS SUR
C                L'INTERVALLE 0,L
C IN  : NBP2   : NOMBRE DE POINTS DE DISCRETISATION DES FONCTIONS SUR
C                L'INTERVALLE L,2L
C OUT : DISC   : VALEURS DU PARAMETRE SUR 0,2L   - DIM : NBP
C OUT : VALE   : TABLEAU DES VALEURS DES FONCTIONS SUR 0,2L
C                - DIM : (NBP,NBFONC)
C
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
C
      INTEGER      NBFONC,NBP1,NBP2
      CHARACTER*8  NOMFON(NBFONC)
      REAL*8       DISC(NBP1+NBP2),VALE(NBP1+NBP2,NBFONC)
C
      CHARACTER*24 FVALE,FPROL
C
C-----------------------------------------------------------------------
      CALL JEMARQ()
C
      NBP = NBP1 + NBP2
C
C-----1.VALEURS DU PARAMETRE : ON RETIENT LA DISCRETISATION DE LA
C-----  PREMIERE FONCTION DE FORME
C
      FVALE = NOMFON(1)//'           .VALE'
      CALL JEVEUO(FVALE,'L',IFABS)
      DO 10 IP = 1,NBP
        DISC(IP) = ZR(IFABS+IP-1)
  10  CONTINUE
C
C-----2.VALEURS DES FONCTIONS
C
C-----2.1.ON RECOPIE LES VALEURS DE LA PREMIERE FONCTION
C
      IFORD = IFABS + NBP
      DO 20 IP = 1,NBP
        VALE(IP,1) = ZR(IFORD+IP-1)
  20  CONTINUE
      CALL JELIBE(FVALE)
C
C-----2.2.ON INTERPOLE LES AUTRES FONCTIONS LE CAS ECHEANT
C
      IF (NBFONC.GT.1) THEN
C
        DO 30 IFO = 2,NBFONC
C
          FVALE = NOMFON(IFO)//'           .VALE'
          FPROL = NOMFON(IFO)//'           .PROL'
          CALL JEVEUO(FVALE,'L',IFABS)
          CALL JEVEUO(FPROL,'L',IFPRO)
          IFORD = IFABS + NBP
          CALL FOINTR(NOMFON(IFO),ZK24(IFPRO),NBP1,ZR(IFABS),ZR(IFORD),
     &                NBP1,DISC(1),VALE(1,IFO),IER1)
          CALL FOINTR(NOMFON(IFO),ZK24(IFPRO),NBP2,ZR(IFABS+NBP1),
     &                ZR(IFORD+NBP1),NBP2,DISC(NBP1+1),VALE(NBP1+1,IFO),
     &                IER2)
          IF (IER1.NE.0 .OR. IER2.NE.0) THEN
            CALL U2MESS('F','MODELISA4_40')
          ENDIF
          CALL JELIBE(FVALE)
          CALL JELIBE(FPROL)
C
  30    CONTINUE
C
      ENDIF
C
      CALL JEDEMA()
      END
