      SUBROUTINE FCTHYP(TYPFCT,X,Y)
      IMPLICIT NONE 
C
      REAL*8         X,Y
      CHARACTER*8    TYPFCT
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 16/06/2010   AUTEUR CARON A.CARON 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C        CALCUL DE ARGUMENT SINUS HYPERBOLIQUE ASINH
C                  ARGUMENT COSINUS HYPERBOLIQUE ACOSH
C                  DERIVEE ARGUMENT COSINUS HYPERBOLIQUE DACOSH
C                  DERIVEE ARGUMENT SINUS HYPERBOLIQUE DASINH
C     ENTREE
C       TYPFCT  : ALIAS DE LA FONCTION
C       X       : ABSCISSE DU POINT
C
C     SORTIE
C       Y       : VALEUR DE LA FONCTION
C......................................................................
C
      REAL*8      R8PREM
C
      IF    (TYPFCT.EQ.'ACOSH')   THEN
        CALL ASSERT((X*X-1).GE.R8PREM() .AND.
     &                    (X+SQRT(X*X-1)).GT.R8PREM())
        Y=LOG(X+SQRT(X*X-1))
      ELSEIF (TYPFCT.EQ.'ASINH')  THEN
        CALL ASSERT((X+SQRT(X*X+1)).GT.R8PREM())
        Y=LOG(X+SQRT(X*X+1))
      ELSEIF (TYPFCT.EQ.'DACOSH') THEN
        CALL ASSERT((X*X-1).GT.R8PREM())
        Y=1/SQRT(X*X-1)
      ELSEIF (TYPFCT.EQ.'DASINH') THEN
        Y=1/SQRT(X*X+1)
      END IF
C
      END
