      SUBROUTINE FFGRA1(NBFONC,IDEBIT,NBP1,NBP2,LONG,DISC,VALE)
      IMPLICIT REAL*8 (A-H,O-Z)
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 05/07/96   AUTEUR KXBADNG T.FRIOU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C-----------------------------------------------------------------------
C     DISCRETISATION DES FONCTIONS DE FORME GRAPPE1
C     APPELANT : SPECFF
C-----------------------------------------------------------------------
C IN  : NBFONC : NOMBRE DE FONCTIONS
C IN  : IDEBIT : INDICE CARACTERISTIQUE DU DEBIT DE REFERENCE
C IN  : NBP1   : NOMBRE DE POINTS DE DISCRETISATION DES FONCTIONS SUR
C                L'INTERVALLE 0,L
C IN  : NBP2   : NOMBRE DE POINTS DE DISCRETISATION DES FONCTIONS SUR
C                L'INTERVALLE L,2L
C IN  : LONG   : VALEUR DE LA LONGUEUR EXCITEE L
C OUT : DISC   : VALEURS DU PARAMETRE SUR 0,2L   - DIM : NBP
C OUT : VALE   : TABLEAU DES VALEURS DES FONCTIONS SUR 0,2L
C                - DIM : (NBP,NBFONC)
C
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
C
      INTEGER      NBFONC,IDEBIT,NBP1,NBP2
      REAL*8       LONG,DISC(NBP1+NBP2),VALE(NBP1+NBP2,NBFONC)
C
      INTEGER      NBTRON,IDEB(3),IFIN(3)
      REAL*8       XDEB(3),X0(3),COEF18(90),COEF30(90)
      REAL*8       LAMBDA
C
      PARAMETER   (NBTRON=3)
C
      DATA IDEB   / 1 , 35 , 68  /
      DATA IFIN   /34 , 67 , 100 /
C
      DATA XDEB   / .000000D+00, .337000D+00, .653999D+00/
      DATA X0     / .000000D+00, .405300D+00, .722800D+00/
C
      DATA (COEF18(I),I= 1,15) /
     & .892004D+01, .876767D-01, .101885D+01,-.864421D-01, .867667D-01,
     & .892004D+01,-.592371D+00,-.647456D+00, .110354D+00,-.607590D-01,
     & .892004D+01, .716904D+00, .678938D+00,-.781130D-01, .525716D-01/
      DATA (COEF18(I),I=16,30) /
     & .958117D+01,-.824166D-01, .722287D+00, .851556D-01,-.900713D-01,
     & .958117D+01,-.512911D+00,-.647767D+00,-.369576D-02, .255866D-01,
     & .958117D+01, .607072D+00, .744850D+00,-.966177D-03,-.149861D-01/
      DATA (COEF18(I),I=31,45) /
     & .104292D+02,-.315180D-01,-.670248D+00, .298443D-01,-.518046D-01,
     & .104292D+02, .105637D+00,-.255743D+00,-.147931D+00, .199660D+00,
     & .104292D+02, .393381D+00, .836201D+00, .166871D+00,-.186046D+00/
      DATA (COEF18(I),I=46,60) /
     & .121346D+02, .146509D-01, .422678D+00,-.147882D-01, .332653D-01,
     & .121346D+02, .373902D+00, .698009D+00, .216923D+00,-.167900D+00,
     & .121346D+02, .139962D-01, .498839D+00, .252902D+00,-.259762D+00/
      DATA (COEF18(I),I=61,75) /
     & .186172D+02,-.130075D+00,-.717144D+00, .129807D+00,-.130585D+00,
     & .186172D+02,-.963054D+00, .725669D-01, .891863D-02,-.593922D-02,
     & .186172D+02,-.550072D+00,-.592468D-01, .737335D-01,-.756190D-01/
      DATA (COEF18(I),I=76,90) /
     & .214486D+02, .192720D+00,-.746667D+00,-.185555D+00, .186725D+00,
     & .214486D+02, .616604D+00, .191943D+00, .958665D-01,-.986181D-01,
     & .214486D+02, .552441D+00, .395168D+00, .595057D-01,-.594600D-01/
C
      DATA (COEF30(I),I= 1,15) /
     & .862668D+01,-.328857D-01, .570796D+00, .323381D-01,-.468150D-01,
     & .862668D+01,-.376416D+00,-.610767D+00, .388797D-01, .500452D-01,
     & .862668D+01, .670443D+00, .688077D+00,-.798460D-01, .279372D-01/
      DATA (COEF30(I),I=16,30) /
     & .931612D+01,-.725227D-01, .691873D+00, .729040D-01,-.819260D-01,
     & .931612D+01,-.502377D+00,-.642044D+00, .129275D-01, .202009D-01,
     & .931612D+01, .619794D+00, .692713D+00,-.370607D-01, .180415D-01/
      DATA (COEF30(I),I=31,45) /
     & .102233D+02, .147741D-01,-.742058D+00,-.146033D-01,-.120140D-02,
     & .102233D+02, .290293D+00,-.192318D+00,-.164685D+00, .240156D+00,
     & .102233D+02, .369431D+00, .797258D+00, .159602D+00,-.186411D+00/
      DATA (COEF30(I),I=46,60) /
     & .119350D+02, .756823D-01, .457934D+00,-.761885D-01, .959711D-01,
     & .119350D+02, .329857D+00, .697145D+00, .202018D+00,-.158517D+00,
     & .119350D+02,-.476558D-01, .465654D+00, .260041D+00,-.275460D+00/
      DATA (COEF30(I),I=61,75) /
     & .178865D+02,-.197756D+00,-.100842D+01, .196719D+00,-.196414D+00,
     & .178865D+02,-.609465D+00, .974086D-01, .123622D+00,-.125797D+00,
     & .178865D+02,-.574084D+00,-.109550D-01, .456200D-01,-.494731D-01/
      DATA (COEF30(I),I=76,90) /
     & .198739D+02, .571860D+00,-.643644D+00,-.572587D+00, .573938D+00,
     & .198739D+02, .666135D+00, .365642D+00, .256218D+00,-.258155D+00,
     & .198739D+02, .336904D+00, .165036D+00,-.582536D-01, .594626D-01/
C
C-----------------------------------------------------------------------
C
      NBP = NBP1 + NBP2
C
C --- 1.VALEURS DU PARAMETRE
C
      DX = 1.D-2
      X  = DX
      DO 10 ITRON = 1,NBTRON
        DISC(IDEB(ITRON)) = XDEB(ITRON)
        DO 11 IP = IDEB(ITRON)+1,IFIN(ITRON)
          DISC(IP) = X
          X = X + DX
  11    CONTINUE
  10  CONTINUE
      DISC(NBP1) = LONG
C
      DO 20 IP = NBP1+1,NBP
        DISC(IP) = DISC(IP-NBP1) + LONG
  20  CONTINUE
C
C --- 2.VALEURS DES FONCTIONS
C
      NBMOD = NBFONC/2
C
      IF (IDEBIT.EQ.180) THEN
C
        DO 30 IMOD = 1,NBMOD
          DO 31 ITRON = 1,NBTRON
            LAMBDA = COEF18(15*(IMOD-1)+5*(ITRON-1)+1)
            COEF1  = COEF18(15*(IMOD-1)+5*(ITRON-1)+2)
            COEF2  = COEF18(15*(IMOD-1)+5*(ITRON-1)+3)
            COEF3  = COEF18(15*(IMOD-1)+5*(ITRON-1)+4)
            COEF4  = COEF18(15*(IMOD-1)+5*(ITRON-1)+5)
            XREF   = X0(ITRON)
            DO 32 IP = IDEB(ITRON),IFIN(ITRON)
              X = LAMBDA*(DISC(IP)-XREF)
              VALE(IP,IMOD) = COEF1*DBLE(COS(X))  + COEF2*DBLE(SIN(X))
     &                      + COEF3*DBLE(COSH(X)) + COEF4*DBLE(SINH(X))
              VALE(IP+NBP1,IMOD+NBMOD) = VALE(IP,IMOD)
  32        CONTINUE
  31      CONTINUE
          X = LAMBDA*(DISC(NBP1)-XREF)
          VALE(NBP1,IMOD) = COEF1*DBLE(COS(X)) + COEF2*DBLE(SIN(X))
     &                    + COEF3*DBLE(COSH(X)) + COEF4*DBLE(SINH(X))
          VALE(NBP,IMOD+NBMOD) = VALE(NBP1,IMOD)
  30    CONTINUE
C
      ELSE
C
        DO 40 IMOD = 1,NBMOD
          DO 41 ITRON = 1,NBTRON
            LAMBDA = COEF30(15*(IMOD-1)+5*(ITRON-1)+1)
            COEF1  = COEF30(15*(IMOD-1)+5*(ITRON-1)+2)
            COEF2  = COEF30(15*(IMOD-1)+5*(ITRON-1)+3)
            COEF3  = COEF30(15*(IMOD-1)+5*(ITRON-1)+4)
            COEF4  = COEF30(15*(IMOD-1)+5*(ITRON-1)+5)
            XREF   = X0(ITRON)
            DO 42 IP = IDEB(ITRON),IFIN(ITRON)
              X = LAMBDA*(DISC(IP)-XREF)
              VALE(IP,IMOD) = COEF1*DBLE(COS(X))  + COEF2*DBLE(SIN(X))
     &                      + COEF3*DBLE(COSH(X)) + COEF4*DBLE(SINH(X))
              VALE(IP+NBP1,IMOD+NBMOD) = VALE(IP,IMOD)
  42        CONTINUE
  41      CONTINUE
          X = LAMBDA*(DISC(NBP1)-XREF)
          VALE(NBP1,IMOD) = COEF1*DBLE(COS(X)) + COEF2*DBLE(SIN(X))
     &                    + COEF3*DBLE(COSH(X)) + COEF4*DBLE(SINH(X))
          VALE(NBP,IMOD+NBMOD) = VALE(NBP1,IMOD)
  40    CONTINUE
C
      ENDIF
C
      DO 50 IMOD = 1,NBMOD
        DO 51 IP = 1,NBP1
          VALE(IP+NBP1,IMOD) = 0.D0
          VALE(IP,IMOD+NBMOD) = 0.D0
  51    CONTINUE
  50  CONTINUE
C
      END
