      SUBROUTINE LIEXCO(CHAR  ,MOTFAC,NOMA  ,NOMO  ,NZOCO ,
     &                  NMACO ,NNOCO )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 23/09/2008   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      CHARACTER*8  CHAR
      CHARACTER*16 MOTFAC
      CHARACTER*8  NOMA,NOMO
      INTEGER      NZOCO,NMACO,NNOCO 
C     
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (TOUTES METHODES - LECTURE DONNEES)
C
C REMPLISSAGE DE LA LISTE DES MAILLES ET DES NOEUDS 
C      
C ----------------------------------------------------------------------
C
C
C IN  CHAR   : NOM UTILISATEUR DU CONCEPT DE CHARGE
C IN  MOTFAC : MOT-CLE FACTEUR (VALANT 'CONTACT')
C IN  NOMA   : NOM DU MAILLAGE
C IN  NOMO   : NOM DU MODELE
C IN  NZOCO  : NOMBRE DE ZONES DE CONTACT
C IN  NMACO  : NOMBRE TOTAL DE MAILLES DES SURFACES DE CONTACT
C IN  NNOCO  : NOMBRE TOTAL DE NOEUDS DES SURFACES DE CONTACT
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      JDECMA,JDECNO
      INTEGER      JLIST
      INTEGER      NBMAES,NBNOES
      INTEGER      NBMAMA,NBNOMA
      CHARACTER*24 DEFICO
      INTEGER      IZONE,ISUCO,IMA,INO
      CHARACTER*24 LISTME,LISTMM
      CHARACTER*24 LISTNE,LISTNM
      CHARACTER*24 CONTMA,CONTNO
      INTEGER      JMACO,JNOCO  
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DEFICO = CHAR(1:8)//'.CONTACT'
      ISUCO  = 1
C 
C --- ACCES AUX STRUCTURES DE DONNEES DE CONTACT
C 
      CONTMA = DEFICO(1:16)//'.MAILCO'
      CONTNO = DEFICO(1:16)//'.NOEUCO'          
C
C --- NOM DES SD TEMPORAIRES
C          
      LISTMM = '&&NBSUCO.MAIL.MAIT'
      LISTME = '&&NBSUCO.MAIL.ESCL'
      LISTNM = '&&NBSUCO.NOEU.MAIT'
      LISTNE = '&&NBSUCO.NOEU.ESCL'       
C
C --- CREATION DES SD 
C        
      CALL WKVECT(CONTMA,'G V I',NMACO,JMACO)
      CALL WKVECT(CONTNO,'G V I',NNOCO,JNOCO)                  
C
C --- BOUCLE SUR LES ZONES
C
      DO 100 IZONE = 1,NZOCO
C
C --- LECTURE DES MAILLES/NOEUDS
C      
        CALL LIRECO(CHAR  ,MOTFAC,NOMA  ,NOMO  ,IZONE ,
     &              LISTME,LISTMM,LISTNE,LISTNM,NBMAES,
     &              NBNOES,NBMAMA,NBNOMA)
C                             
C --- ON STOCKE LES MAILLES MAITRES
C     
        CALL CFNBSF(DEFICO,ISUCO,'MAIL',NBMAMA,JDECMA)
        CALL JEVEUO(LISTMM,'L',JLIST)
        DO 11 IMA = 1,NBMAMA
          ZI(JMACO+JDECMA-1+IMA) = ZI(JLIST+IMA-1)
   11   CONTINUE 
C                             
C --- ON STOCKE LES NOEUDS MAITRES
C  
        CALL CFNBSF(DEFICO,ISUCO,'NOEU',NBNOMA,JDECNO)   
        CALL JEVEUO(LISTNM,'L',JLIST)
        DO 21 INO = 1,NBNOMA
          ZI(JNOCO+JDECNO-1+INO) = ZI(JLIST+INO-1)
   21   CONTINUE 
C
        ISUCO = ISUCO + 1            
C                           
C --- ON STOCKE LES MAILLES ESCLAVES
C     
        CALL CFNBSF(DEFICO,ISUCO,'MAIL',NBMAES,JDECMA)
        CALL JEVEUO(LISTME,'L',JLIST)
        DO 10 IMA = 1,NBMAES
          ZI(JMACO+JDECMA-1+IMA) = ZI(JLIST+IMA-1)
   10   CONTINUE         
C                             
C --- ON STOCKE LES NOEUDS ESCLAVES
C  
        CALL CFNBSF(DEFICO,ISUCO,'NOEU',NBNOES,JDECNO)   
        CALL JEVEUO(LISTNE,'L',JLIST)
        DO 20 INO = 1,NBNOES
          ZI(JNOCO+JDECNO-1+INO) = ZI(JLIST+INO-1)
   20   CONTINUE   
C
        ISUCO = ISUCO + 1  
        
  100 CONTINUE 
C   
      CALL JEDETR(LISTME)
      CALL JEDETR(LISTMM) 
      CALL JEDETR(LISTNE)
      CALL JEDETR(LISTNM)  
C          
      CALL JEDEMA()
      END
