      SUBROUTINE LIMACO(CHAR  ,MOTFAC,NOMA  ,NOMO  ,NDIM  ,
     &                  NZOCO ,LIGRET)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 03/01/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*8  CHAR
      CHARACTER*8  NOMA
      CHARACTER*8  NOMO
      CHARACTER*16 MOTFAC
      CHARACTER*19 LIGRET
      INTEGER      NZOCO,NDIM
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (TOUTES METHODES - LECTURE DONNEES)
C
C LECTURE DES MAILLES DE CONTACT
C
C ----------------------------------------------------------------------
C
C
C IN  CHAR   : NOM UTILISATEUR DU CONCEPT DE CHARGE
C IN  NOMA   : NOM DU MAILLAGE
C IN  NOMO   : NOM DU MODELE
C IN  MOTFAC : MOT-CLE FACTEUR (VALANT 'CONTACT')
C IN  NDIM   : NOMBRE DE DIMENSIONS DU PROBLEME
C IN  NZOCO  : NOMBRE DE ZONES DE CONTACT
C OUT LIGRET : LIGREL D'ELEMENTS TARDIFS DU CONTACT
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*24 DEFICO
      INTEGER      CFDISI,IFORM
      INTEGER      INDQUA
      LOGICAL      LMAIL,LTFCM,CFDISL
      INTEGER      NSUCO,NMACO,NNOCO,NNOQUA
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DEFICO = CHAR(1:8)//'.CONTACT'
      NNOQUA = 0
      NSUCO  = 0
      NMACO  = 0
      NNOCO  = 0
      NNOQUA = 0
C
C --- TYPE DE FORMULATION (DISCRETE/CONTINUE/XFEM)
C
      IFORM  = CFDISI(DEFICO,'FORMULATION')
      LMAIL  = CFDISL(DEFICO,'FORMUL_MAILLEE')
C
C --- LECTURE DES MAILLES/NOEUDS DE CONTACT
C
      IF (LMAIL) THEN
C
C --- TRAITEMENT DU CAS DES MAILLES QUADRATIQUES
C --- INDQUA VAUT 0 SI LINEARISATION DES MAILLES QUADRATIQUES (CACOEQ)
C
        CALL QUADCO(CHAR  ,INDQUA)
C
C --- DETERMINATION DU NOMBRE TOTAL DE SURFACES
C
        CALL POINCO(CHAR  ,MOTFAC,NOMA  ,NZOCO ,NSUCO )
C
C --- STOCKAGE DES MAILLES ET NOEUDS DE CONTACT
C
        CALL LISTCO(CHAR  ,MOTFAC,NOMA  ,NOMO  ,NZOCO ,
     &              NMACO ,NNOCO )
C
C --- ELIMINATION DES MAILLES ET NOEUDS DE CONTACT EN DOUBLE
C
        CALL ELIMCO(CHAR  ,NOMA  ,NOMO  ,INDQUA,NZOCO ,
     &              NSUCO ,NMACO ,NNOCO ,NNOQUA)
C
C --- CONSTRUCTION DES CONNECTIVITES INVERSES
C
        CALL TABLCO(CHAR  ,NOMA  ,NSUCO ,NMACO ,NNOCO )     
C
C --- CONSTRUCTION DU VECTEUR D'INFORMATION PAR ZONE
C
        CALL DIMECZ(CHAR  ,NOMA  ,NZOCO ,IFORM )     
C
C --- CONSTRUCTION DU VECTEUR D'INFORMATION SUR LES LONGUEURS
C
        CALL DIMECO(CHAR  ,NDIM  ,NZOCO ,NSUCO ,NMACO ,
     &              NNOCO ) 
C
C --- TRAITEMENT MOT-CLEF SANS_GROUP_NO
C
        CALL SANSCO(CHAR  ,MOTFAC,NOMA  )
C
C --- TRAITEMENT MOT-CLEFS SPECIFIQUES FORMULATION CONTINUE
C
        IF (IFORM.EQ.2) THEN
          CALL SANSCC(CHAR  ,MOTFAC ,NOMA  )
        ENDIF
C
C --- RECHERCHE DE NOEUDS COMMUNS AUX SURFACES MAITRES ET ESCLAVES
C
        CALL CFNODB(CHAR  )
C
C --- VERIFICATION DE LA COHERENCE DES DIMENSIONS
C
        CALL CFBORD(CHAR  ,NOMA  )
C
C --- CONSTRUCTION DU TABLEAU POUR TYPE DE NOEUD
C
        CALL TYPECO(CHAR  ,NOMA  )
C
C --- CREATION DES RELATIONS LINEAIRES POUR MAILLES QUADRATIQUES
C
        IF (INDQUA.EQ.0) THEN
          CALL CACOEQ(CHAR  ,NOMA  )
        ENDIF
C
C --- RECUPERATION DES CARACTERISTIQUES DE POUTRE
C
        CALL CAPOCO(CHAR  ,MOTFAC)
C
C --- RECUPERATION DES CARACTERISTIQUES DE COQUE
C
        CALL CACOCO(CHAR  ,MOTFAC,NOMA  )
C
C --- VERIFICATION DES TANGENTES/NORMALES
C        
        CALL CHCKCO(CHAR  ,NOMA  ,NDIM  )
C
C --- AJOUT DES ELEMENTS TARDIFS
C
        IF (IFORM.EQ.2) THEN
          CALL MMPREL(CHAR  ,NOMA  ,NOMO  ,LIGRET)
        ENDIF
      ELSE
        IF (IFORM.EQ.3) THEN
          CALL LIMACX(CHAR  ,MOTFAC,NDIM  ,NZOCO)
          LTFCM  = CFDISL(DEFICO,'CONT_XFEM_GG')
          IF (LTFCM) THEN
            CALL XMACON(CHAR  ,NOMA  ,NOMO)
          ENDIF
          CALL XCONTA(CHAR  ,NOMA  ,NOMO  ,NDIM  )
        ELSE
          CALL ASSERT(.FALSE.)
        ENDIF
      ENDIF
C
      CALL JEDEMA()
      END
