      SUBROUTINE LIRECO(CHAR  ,MOTFAC,NOMA  ,NOMO  ,IZONE ,
     &                  LISTME,LISTMM,LISTNE,LISTNM,NBMAES,
     &                  NBNOES,NBMAMA,NBNOMA)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 14/10/2008   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2008  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      CHARACTER*8  CHAR
      CHARACTER*16 MOTFAC
      CHARACTER*8  NOMA,NOMO
      INTEGER      IZONE
      CHARACTER*24 LISTME,LISTMM
      CHARACTER*24 LISTNE,LISTNM       
      INTEGER      NBMAES,NBNOES
      INTEGER      NBMAMA,NBNOMA      
C     
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (TOUTES METHODES - LECTURE DONNEES)
C
C LECTURE DES SURFACES DE CONTACT
C      
C ----------------------------------------------------------------------
C
C
C IN  CHAR   : NOM UTILISATEUR DU CONCEPT DE CHARGE
C IN  MOTFAC : MOT-CLE FACTEUR (VALANT 'CONTACT')
C IN  NOMA   : NOM DU MAILLAGE
C IN  NOMO   : NOM DU MODELE
C IN  IZONE  : INDICE DE LA ZONE DE CONTACT
C I/O LISTME : NOM DE LA LISTE CONTENANT LES MAILLES ESCLAVES
C I/O LISTMM : NOM DE LA LISTE CONTENANT LES MAILLES MAITRES
C I/O LISTNE : NOM DE LA LISTE CONTENANT LES NOEUDS ESCLAVES
C I/O LISTNM : NOM DE LA LISTE CONTENANT LES NOEUDS MAITRES
C OUT NBMAES : NOMBRE DE MAILLES ESCLAVES
C OUT NBMAMA : NOMBRE DE MAILLES MAITRES
C OUT NBMAES : NOMBRE DE MAILLES ESCLAVES
C OUT NBMAMA : NOMBRE DE MAILLES MAITRES

C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      NBMOCL
      CHARACTER*8  K8BLA
      CHARACTER*16 LIMOCL(2),TYMOCL(2)     
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      NBMOCL = 2
      NBMAES = 0
      NBMAMA = 0
      NBNOES = 0
      NBNOMA = 0
      K8BLA  = ' '
C
C --- MAILLES 
C
      TYMOCL(1) = 'GROUP_MA'
      TYMOCL(2) = 'MAILLE'
C
C --- MAILLES ESCLAVES
C
      LIMOCL(1) = 'GROUP_MA_ESCL'
      LIMOCL(2) = 'MAILLE_ESCL'
      CALL RELIEM(K8BLA ,NOMA  ,'NU_MAILLE',MOTFAC,IZONE ,
     &            NBMOCL,LIMOCL,TYMOCL,LISTME,NBMAES) 
C
C --- MAILLES MAITRES
C
      LIMOCL(1) = 'GROUP_MA_MAIT'
      LIMOCL(2) = 'MAILLE_MAIT'
      CALL RELIEM(K8BLA ,NOMA  ,'NU_MAILLE',MOTFAC,IZONE ,
     &            NBMOCL,LIMOCL,TYMOCL,LISTMM,NBMAMA)      
C
C --- NOEUDS ESCLAVES
C
      LIMOCL(1) = 'GROUP_MA_ESCL'
      LIMOCL(2) = 'MAILLE_ESCL'
      CALL RELIEM(NOMO  ,NOMA  ,'NU_NOEUD',MOTFAC,IZONE ,
     &            NBMOCL,LIMOCL,TYMOCL,LISTNE,NBNOES)      
C
C --- NOEUDS MAITRES
C
      LIMOCL(1) = 'GROUP_MA_MAIT'
      LIMOCL(2) = 'MAILLE_MAIT'
      CALL RELIEM(NOMO  ,NOMA  ,'NU_NOEUD',MOTFAC,IZONE ,
     &            NBMOCL,LIMOCL,TYMOCL,LISTNM,NBNOMA)   
C
C --- MENAGES       
C          
      CALL JEDEMA()
      END
