      LOGICAL FUNCTION MMMAXI(MODELZ,LISMA ,NBMA)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 19/10/2010   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2007  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*8  MODELZ
      CHARACTER*24 LISMA
      INTEGER      NBMA
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - UTILITAIRE)
C
C CETTE FONCTION PERMET DE DETERMINER SI LES ELEMENTS D'UN GROUPE DE
C MAILLES DE CONTACT SONT TOUS AXISYMETRIQUES
C
C ----------------------------------------------------------------------
C
C
C IN  MODELE : NOM DU MODELE
C IN  LISMA  : LISTE DES MAILLES A VERIFIER
C IN  NBMA   : NOMBRE DE MAILLES CONTENU DANS LA LISTE LISMA
C OUT MMMAXI : .TRUE.  LE GROUPE DE MAILLE NE CONTIENT QUE DES ELEMENTS
C                      AXISYMETRIQUES
C              .FALSE. LE GROUPE DE MAILLE NE CONTIENT QUE DES ELEMENTS
C                      NON AXIS
C              ERREUR <F> LE GROUPE DE MAILLE CONTIENT UN MELANGE
C                         D'ELEMENT AXIS ET NON AXIS
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      CHARACTER*32 JEXNUM
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*8  NOMA,MODELE
      CHARACTER*16 NOTYPE,MAISUP
      CHARACTER*24 TYPELE
      REAL*8       ARMIN,PREC
      INTEGER      NUMAIL,NUTYEL
      INTEGER      IBID,IER,IMA
      INTEGER      NUMSUP,NBAXIS
      INTEGER      JMAISU,ILMAIL,ITYPEL,JCOOR
      LOGICAL      LTEATT
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      MODELE = MODELZ
      NBAXIS = 0
      MMMAXI = .FALSE.
      TYPELE = MODELE(1:8)//'.MAILLE'
      MAISUP = '&&MMMAXI.MAISUP'
      CALL DISMOI('F','NOM_MAILLA',MODELE,'MODELE',IBID  ,NOMA  ,IER   )
C
C --- RECUPERATION DE L'ARETE MINIMUM DU MAILLAGE POUR PRECISION
C
      PREC = 1.D-6*ARMIN(NOMA)
C
C --- RECHERCHE DES MAILLES 2D SUPPORTS DES MAILLES DE LISMA
C
      CALL JEVEUO(NOMA//'.COORDO    .VALE','L',JCOOR)
      CALL JEVEUO(LISMA ,'L',ILMAIL)
      CALL INFMUE()
      CALL UTMASU(NOMA,'2D',NBMA,ZI(ILMAIL),MAISUP,PREC,ZR(JCOOR),0,
     &            IBID)
      CALL INFBAV()
      CALL JEVEUO(MAISUP,'L',JMAISU)
C
C --- DETERMINATION DU TYPE DES MAILLES DE LISMA
C
      CALL JEVEUO(TYPELE,'L',ITYPEL)

      DO 100 IMA = 1,NBMA
         NUMSUP = ZI(JMAISU-1+IMA)
         IF (NUMSUP.NE.0) THEN
            NUTYEL = ZI(ITYPEL-1+NUMSUP)
            IF (NUTYEL.NE.0) THEN
               GOTO 50
            ENDIF
         ENDIF
         NUMAIL = ZI(ILMAIL-1+IMA)
         NUTYEL = ZI(ITYPEL-1+NUMAIL)
         IF (NUTYEL.EQ.0) THEN
            GO TO 100
         ENDIF
50       CONTINUE
         CALL JENUNO(JEXNUM('&CATA.TE.NOMTE',NUTYEL),NOTYPE)
         IF (LTEATT(NOTYPE,'AXIS','OUI')) THEN
            NBAXIS = NBAXIS +1
         ENDIF
100   CONTINUE
C
      IF (NBAXIS.EQ.NBMA) THEN
        MMMAXI = .TRUE.
      ELSEIF (NBAXIS.EQ.0) THEN
        MMMAXI = .FALSE.
      ELSE
        CALL U2MESS('F','CONTACT2_12')
      ENDIF
C
      CALL JEDETR(MAISUP)
      CALL JEDEMA()
C
      END
