      SUBROUTINE NBZOCO(MOTFAC,NOMA  ,IZONE ,JZONE ,NSUCO )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 22/09/2009   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      CHARACTER*8  NOMA
      CHARACTER*16 MOTFAC
      INTEGER      IZONE
      INTEGER      JZONE
      INTEGER      NSUCO
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES MAILLEES - LECTURE DONNEES)
C
C DETERMINATION DU NOMBRE DE SURFACES DE CONTACT 
C REMPLISSAGE DU POINTEUR ASSOCIE JZONE
C
C ----------------------------------------------------------------------
C
C
C IN  MOTFAC : MOT-CLE FACTEUR (VALANT 'CONTACT')
C IN  NOMA   : NOM DU MAILLAGE
C IN  IZONE  : INDICE POUR LIRE LES DONNEES DANS AFFE_CHAR_MECA
C IN  JZONE  : POINTEUR DES ZONES DE CONTACT
C I/O NSUCO  : REPERE DU NOMBRE DE SURFACES DE CONTACT POUR CETTE
C              ZONE DE CONTACT
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*8  K8BID
      INTEGER      NGMAIT,NGESCL,NMMAIT,NMESCL
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      NGMAIT = 0
      NGESCL = 0
      NMMAIT = 0
      NMESCL = 0
C
C --- DETERMINATION DU NOMBRE TOTAL DE SURFACES
C
      CALL GETVEM(NOMA,'GROUP_MA',MOTFAC,'GROUP_MA_MAIT',
     &            IZONE,1,0,K8BID,NGMAIT)
      CALL GETVEM(NOMA,'GROUP_MA',MOTFAC,'GROUP_MA_ESCL',
     &            IZONE,1,0,K8BID,NGESCL)
      CALL GETVEM(NOMA,'MAILLE',MOTFAC,'MAILLE_MAIT',
     &            IZONE,1,0,K8BID,NMMAIT)
      CALL GETVEM(NOMA,'MAILLE',MOTFAC,'MAILLE_ESCL',
     &            IZONE,1,0,K8BID,NMESCL)
C
C --- NOMBRE TOTAL DE SURFACES DE CONTACT
C
      IF (NGMAIT.NE.0) NSUCO = NSUCO + 1
      IF (NGESCL.NE.0) NSUCO = NSUCO + 1
      IF (NMMAIT.NE.0) NSUCO = NSUCO + 1
      IF (NMESCL.NE.0) NSUCO = NSUCO + 1
C
C --- MISE A JOUR DU POINTEUR SUR LES SURFACES DE CONTACT DE LA ZONE
C
      ZI(JZONE+IZONE) = NSUCO
C
      CALL JEDEMA()
      END
