      SUBROUTINE PACOA2(LISI1Z,LISI2Z,LONLI1,LONLI2,NOMA1Z,NOMA2Z,
     &                  LISO1Z,LISO2Z,LONLIS)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*(*) LISI1Z, LISI2Z, NOMA1Z, NOMA2Z, LISO1Z, LISO2Z
C---------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 06/04/2007   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C---------------------------------------------------------------------
C     BUT: TRIER 2 LISTES DE NOEUDS LISI1Z ET LISI2Z DE MANIERE A
C     METTRE EN VIS A VIS LES NOEUDS DES 2 LISTES. MAIS L'UNE DES 2
C     LISTES PEUT ETRE PLUS PETITE (CAS DES MAILLES POI1). ON CHERCHE
C     DONC LES NOEUDS DE LA PLUS GRANDE LISTE IMAGES DES NOEUDS DE LA
C     PLUS PETITE LISTE (INJECTION).
C     LES LISTES TRIEES OBTENUES A PARTIR DE LISI1Z ET LISI2Z
C     SONT RESPECTIVEMENT LISO1Z ET LISO2Z, LA CORRESPONDANCE
C     ENTRE LES NOEUDS DES 2 LISTES EST ASSUREE DE LA MANIERE
C     SUIVANTE :
C          POUR I =1, LONLIS = MIN(LONLI1,LONLI2)
C          LISO1Z(I) EST EN VIS-AVIS AVEC LISO2Z(I)
C
C     LES LISTES LISI1Z, LISI2Z, LISO1Z ET LISO2Z CONTIENNENT
C     LES NOMS DES NOEUDS (CE SONT DES LISTES DE K8).
C
C---------------------------------------------------------------------
C ARGUMENTS D'ENTREE:
C IN   LISI1Z     K24 : NOM DE LA 1ERE LISTE
C IN   LISI2Z     K24 : NOM DE LA 2EME LISTE
C IN   LONLI1     I   : LONGUEUR DE LA LISTE LISIZ1
C IN   LONLI2     I   : LONGUEUR DE LA LISTE LISIZ2
C IN   NOMA1Z     K8  : NOM DU MAILLAGE DE LA 1ERE LISTE
C IN   NOMA2Z     K8  : NOM DU MAILLAGE DE LA 2EME LISTE
C OUT  LISO1Z     K24 : NOM DE LA 1ERE LISTE TRIEE
C OUT  LISO2Z     K24 : NOM DE LA 2EME LISTE TRIEE
C OUT  LONLIS     I   : LONGUEUR COMMUNE DE LISO1Z ET LISO2Z
C
C---------------- COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER           ZI
      COMMON / IVARJE / ZI(1)
      REAL*8            ZR
      COMMON / RVARJE / ZR(1)
      COMPLEX*16        ZC
      COMMON / CVARJE / ZC(1)
      LOGICAL           ZL
      COMMON / LVARJE / ZL(1)
      CHARACTER*8       ZK8
      CHARACTER*16              ZK16
      CHARACTER*24                       ZK24
      CHARACTER*32                                ZK32
      CHARACTER*80                                         ZK80
      COMMON / KVARJE / ZK8(1), ZK16(1), ZK24(1), ZK32(1), ZK80(1)
      CHARACTER*32      JEXNOM, JEXNUM
C     ------- FIN COMMUNS NORMALISES  JEVEUX  --------------------------
      REAL*8        X1(3), X2(3)
      CHARACTER*8   NOMA1,NOMA2, M8BLAN
      CHARACTER*8   NOMNO1, NOMNO2, NOMO1, NOMO2
      CHARACTER*24  LISIN1, LISIN2, LISOU1, LISOU2
      CHARACTER*24 VALK(3)
      CHARACTER*24  NOEUM1,NOEUM2
      INTEGER LONLI1,LONLI2,LONLIS,IRET,IDLOU1,IDLOU2,IDLIN1,IDLIN2,INO1
      INTEGER IDLOU3,IDLOU4,LONMAX,IDLINV,I1,NUNO1,J2,I2,INO2,NUNO2,J1
C
      CALL JEMARQ()
      LISIN1  = LISI1Z
      LISIN2  = LISI2Z
      LISOU1  = LISO1Z
      LISOU2  = LISO2Z
      LONLIS  = MIN(LONLI1, LONLI2)
      NOMA1   = NOMA1Z
      NOMA2   = NOMA2Z
      NOEUM1 = NOMA1//'.NOMNOE'
      NOEUM2 = NOMA2//'.NOMNOE'
      M8BLAN  = '        '
C
      CALL JEEXIN(LISOU1,IRET)
      IF (IRET.NE.0) THEN
          CALL JEDETR(LISOU1)
      ENDIF
      CALL JEEXIN(LISOU1,IRET)
      IF (IRET.NE.0) THEN
          CALL JEDETR(LISOU1)
      ENDIF
C
C --- CREATION SUR LA VOLATILE DES LISTES DE K8 LISOU1 ET LISOU2
C --- DE LONGUEUR LONLIS
C
      CALL JEEXIN(LISOU1, IRET)
      IF (IRET.NE.0) THEN
          CALL JEDETR(LISOU1)
      ENDIF
      CALL JEEXIN(LISOU2, IRET)
      IF (IRET.NE.0) THEN
          CALL JEDETR(LISOU2)
      ENDIF
      CALL WKVECT(LISOU1,'V V K8',LONLIS,IDLOU1)
      CALL WKVECT(LISOU2,'V V K8',LONLIS,IDLOU2)
C
      CALL JEVEUO(LISIN1,'L',IDLIN1)
      CALL JEVEUO(LISIN2,'L',IDLIN2)
C
C --- VECTEURS DE TRAVAIL
C
      CALL WKVECT('&&PACOAP.LISOU3','V V K8',LONLIS,IDLOU3)
      CALL WKVECT('&&PACOAP.LISOU4','V V K8',LONLIS,IDLOU4)
      LONMAX = MAX(LONLI1,LONLI2)
      CALL WKVECT('&&PACOAP.LISINV','V V K8',LONMAX,IDLINV)
C
C --- CONSTITUTION DE LA PREMIERE CORRESPONDANCE ENTRE LES LISTES
C --- DE NOEUDS LISIN1 ET LISIN2 ENTRE NO1 DONNE ET NO2 SELON LE
C --- CRITERE : NO2 = NO DANS LISIN2 / D(NO1,NO2) = MIN D(NO1,NO)
C
      IF (LONLI1.LE.LONLI2) THEN
         DO 10 I1 = 1, LONLI1
           NOMNO1 = ZK8(IDLIN1+I1-1)
           CALL JENONU(JEXNOM(NOEUM1,NOMNO1),NUNO1)
           CALL PACOOR(NOMA1,NUNO1,0,X1)
           DMIN = R8GAEM()
           J2 = 0
           DO 20 I2 = 1, LONLI2
             NOMO2 = ZK8(IDLIN2+I2-1)
             CALL JENONU(JEXNOM(NOEUM2,NOMO2),INO2)
             CALL PACOOR(NOMA2,INO2,0,X2)
             D = PADIST( 3, X1, X2 )
             IF (D.LT.DMIN) THEN
               DMIN   = D
               NOMNO2 = NOMO2
               NUNO2  = INO2
               J2     = I2
             ENDIF
20         CONTINUE
C
           IF (J2.EQ.0) CALL U2MESK('F','MODELISA6_3',1,NOMNO1)
C
           IF (ZK8(IDLINV+J2-1).EQ.M8BLAN) THEN
               ZK8(IDLOU1+I1-1) = NOMNO1
               ZK8(IDLOU2+I1-1) = NOMNO2
               ZK8(IDLINV+J2-1) = NOMNO1
           ELSE
               VALK (1) = NOMNO2
               VALK (2) = NOMNO1
               VALK (3) = ZK8(IDLINV+J2-1)
               CALL U2MESG('F', 'MODELISA8_77',3,VALK,0,0,0,0.D0)
           ENDIF
10       CONTINUE
      ELSE
         DO 30 I2 = 1, LONLI2
           NOMNO2 = ZK8(IDLIN2+I2-1)
           CALL JENONU(JEXNOM(NOEUM2,NOMNO2),NUNO2)
           CALL PACOOR(NOMA2,NUNO2,0,X2)
           DMIN = R8GAEM()
           J1 = 0
           DO 40 I1 = 1, LONLI1
             NOMO1 = ZK8(IDLIN1+I1-1)
             CALL JENONU(JEXNOM(NOEUM1,NOMO1),INO1)
             CALL PACOOR(NOMA1,INO1,0,X1)

             D = PADIST( 3, X1, X2 )
             IF (D.LT.DMIN) THEN
               DMIN   = D
               NOMNO1 = NOMO1
               NUNO1  = INO1
               J1     = I1
             ENDIF
40         CONTINUE
C
           IF (J1.EQ.0) CALL U2MESK('F','MODELISA6_3',1,NOMNO2)
C
           IF (ZK8(IDLINV+J1-1).EQ.M8BLAN) THEN
               ZK8(IDLOU1+I2-1) = NOMNO1
               ZK8(IDLOU2+I2-1) = NOMNO2
               ZK8(IDLINV+J1-1) = NOMNO1
           ELSE
               VALK (1) = NOMNO2
               VALK (2) = NOMNO1
               VALK (3) = ZK8(IDLINV+J1-1)
               CALL U2MESG('F', 'MODELISA8_77',3,VALK,0,0,0,0.D0)
           ENDIF
30       CONTINUE
      ENDIF
C
      CALL JEDETR ('&&PACOAP.LISOU3')
      CALL JEDETR ('&&PACOAP.LISOU4')
      CALL JEDETR ('&&PACOAP.LISINV')
C
      CALL JEDEMA()
      END
