      SUBROUTINE QUADCO(CHAR  ,INDQUA)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 14/09/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE MABBAS M.ABBAS
C
      IMPLICIT     NONE
      CHARACTER*8  CHAR
      INTEGER      INDQUA
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (TOUTES METHODES - LECTURE DONNEES)
C
C TRAITEMENT DU CAS DES MAILLES QUADRATIQUES
C      
C ----------------------------------------------------------------------
C
C
C INDQUA VAUT 0 SI L'ON DOIT CONSIDERER LES NOEUDS MILIEUX A PART
C DANS CE CAS, PERMETTRA DE FAIRE LA LIAISON LINEAIRE DANS CACOEQ
C MASI UNIQUEMENT POUR LES QUAD8 EN SOLIDE.
C 
C
C IN  CHAR   : NOM UTILISATEUR DU CONCEPT DE CHARGE)
C OUT INDQUA : VAUT 0 LORSQUE L'ON DOIT TRAITER LES NOEUDS MILIEUX
C                     A PART
C              VAUT 1 LORSQUE L'ON DOIT TRAITER LES NOEUDS MILIEUX
C                     NORMALEMENT
C   
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      CFDISI,IFORM
      CHARACTER*24 DEFICO
      LOGICAL      CFDISL,LALLV,LPENAC,LGLISS         
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      INDQUA = 0
      DEFICO = CHAR(1:8)//'.CONTACT'  
C
C --- TYPES DE CONTACT
C      
      LALLV  = CFDISL(DEFICO,'ALL_VERIF')
      IFORM  = CFDISI(DEFICO,'FORMULATION') 
      LPENAC = CFDISL(DEFICO,'CONT_PENA')
      LGLISS = CFDISL(DEFICO,'CONT_DISC_GLIS')             
C
C --- TRAITEMENT DU CAS DES MAILLES QUADRATIQUES
C      
      INDQUA = 0
      IF (IFORM.EQ.1) THEN
        IF (LALLV.OR.LPENAC.OR.LGLISS) THEN
          INDQUA = 1
        ELSE
          INDQUA = 0
        ENDIF                                         
      ELSEIF (IFORM.EQ.2) THEN
        INDQUA = 1 
      ELSEIF (IFORM.EQ.3) THEN
        INDQUA = 1
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF
C
      CALL JEDEMA()
      END
