      SUBROUTINE SANSMA(CHAR  ,MOTFAC,NOMA  ,SANS  ,PSANS ,
     &                  NBMOCL,TYMOCL,LIMOCL)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 14/09/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2007  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C REPONSABLE
C
      IMPLICIT      NONE
      CHARACTER*8   CHAR
      CHARACTER*16  MOTFAC
      CHARACTER*24  SANS ,PSANS
      CHARACTER*8   NOMA
      INTEGER       NBMOCL
      CHARACTER*16  TYMOCL(NBMOCL),LIMOCL(NBMOCL)       
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES MAILLEES - LECTURE DONNEES)
C
C LECTURE DES MAILLES DANS LE MOT-CLEF <MOTGR/MOT> ET STOCKE DANS LA
C SD SANSMA/PSANS
C      
C ----------------------------------------------------------------------
C
C
C NB: ON ELIMINE LES MAILLES N'APPARTENANT PAS AUX SURFACES DE CONTACT
C 
C IN  CHAR   : NOM UTILISATEUR DU CONCEPT DE CHARGE
C IN  MOTFAC : MOT-CLE FACTEUR (VALANT 'CONTACT')
C IN  NOMA   : NOM DU MAILLAGE
C IN  NBMOCL : NOMBRE DE MOT-CLEFS A SCRUTER
C IN  LIMOCL : LISTE DES MOTS CLE A SCRUTER
C IN  TYMOCL : LISTE DES TYPES DE MOTS CLE A SCRUTER :
C               / 'GROUP_MA'
C               / 'GROUP_NO'
C               / 'MAILLE'
C               / 'NOEUD'
C OUT SANS   : LISTE DES MAILLES LUES DANS LES MOT-CLEFS
C OUT PSANS  : POINTEUR PAR ZONE DES MAILLES LUES DANS LES MOT-CLEFS
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      JSANS,JPSANS
      INTEGER      STOCMA 
      INTEGER      I,IZONE,LTRAV
      INTEGER      NUELIM,IELIM
      INTEGER      NBELIM,JTRAV      
      CHARACTER*24 LISTMA
      INTEGER      JELIM
      CHARACTER*24 DEFICO  
      INTEGER      CFDISI,NZOCO,NMACO  
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DEFICO = CHAR(1:8)//'.CONTACT'      
      NZOCO  = CFDISI(DEFICO,'NZOCO')
      NMACO  = CFDISI(DEFICO,'NMACO')
      LISTMA = '&&SANSMA.SANSMA'
C
C --- CREATION DES VECTEURS 
C
      LTRAV  = NZOCO*NMACO
      CALL WKVECT('&&SANSMA.TRAV','V V I',NMACO  ,JTRAV)
      CALL WKVECT(PSANS ,'G V I',NZOCO+1,JPSANS)
C
C --- INITIALISATIONS
C 
      ZI(JPSANS) = 0     
      STOCMA     = 0 
C
      DO 70 IZONE = 1,NZOCO
C
C --- LECTURE DES MAILLES DONNEES SOUS SANS_MAILLE OU SANS_GROUP_MA
C 
        CALL RELIEM(' '   ,NOMA  ,'NU_MAILLE',MOTFAC,IZONE ,
     &              NBMOCL,LIMOCL,TYMOCL     ,LISTMA,NBELIM)
        IF (NBELIM.GT.0) THEN
          CALL JEVEUO(LISTMA,'L',JELIM)
        ENDIF
C
C --- NOMBRE DE MAILLES A ELIMINER POUR LA ZONE APRES FILTRAGE
C
        IF (NBELIM.LT.0) THEN
          CALL ASSERT(.FALSE.)
        ENDIF     
C
C --- MISE A JOUR POINTEUR
C
        ZI(JPSANS+IZONE) = ZI(JPSANS+IZONE-1) + NBELIM 
C
C --- MISE A JOUR SD
C
        DO 100 IELIM = 1,NBELIM
          NUELIM = ZI(JELIM+IELIM-1)
          IF (NUELIM.NE.0) THEN
            ZI(JTRAV+STOCMA+IELIM-1) = NUELIM 
          ENDIF               
  100   CONTINUE 
C
        STOCMA = STOCMA + NBELIM    
        IF (STOCMA.GT.LTRAV) CALL ASSERT(.FALSE.)
C       
  70  CONTINUE
C
C --- CREATION DU VECTEUR
C  
      IF (STOCMA.EQ.0) THEN 
        CALL WKVECT(SANS ,'G V I',1       ,JSANS)
      ELSE
        CALL WKVECT(SANS ,'G V I',STOCMA  ,JSANS) 
C
C --- TRANSFERT DU VECTEUR
C
        DO 170 I = 1,STOCMA
          ZI(JSANS+I-1) = ZI(JTRAV+I-1)
          IF (ZI(JTRAV+I-1).EQ.0) CALL ASSERT(.FALSE.)
  170   CONTINUE
      ENDIF      
C
C --- DESTRUCTION DES VECTEURS DE TRAVAIL TEMPORAIRES
C
      CALL JEDETR(LISTMA)
      CALL JEDETR('&&SANSMA.TRAV'  )
C
      CALL JEDEMA()  
      END
