      SUBROUTINE SCALDF(NBFONC,NBP,NBMR,DISC,VALE,DEFM,B)
      IMPLICIT REAL*8 (A-H,O-Z)
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 05/07/96   AUTEUR KXBADNG T.FRIOU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C-----------------------------------------------------------------------
C     CALCUL DES PRODUITS SCALAIRES ENTRE LES DEFORMEES MODALES ET LES
C     FONCTIONS DE FORME ASSOCIEES A L'EXCITATION
C     APPELANT : SPECFF
C-----------------------------------------------------------------------
C IN  : NBFONC : NOMBRE DE FONCTIONS DE FORME ASSOCIEES A L'EXCITATION
C IN  : NBP    : NOMBRE DE POINTS DE DISCRETISATION DES FONCTIONS DE
C                FORME SUR L'INTERVALLE 0,2L
C IN  : NBMR   : NOMBRE DE MODES PRIS EN COMPTE
C IN  : DISC   : DISCRETISATION SUR LAQUELLE SONT CALCULEES LES
C                INTEGRALES DONNANT LES PRODUITS SCALAIRES
C                DIMENSION NBP
C IN  : VALE   : TABLEAU DES VALEURS DES FONCTIONS DE FORME (NBP,NBFONC)
C IN  : DEFM   : TABLEAU DES VALEURS DES DEFORMEES MODALES (NBP,NBMR)
C OUT : B      : MATRICE DES PRODUITS SCALAIRES (NBFONC,NBMR)
C
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
C
      INTEGER      NBFONC,NBP,NBMR
      REAL*8       DISC(NBP),VALE(NBP,NBFONC),DEFM(NBP,NBMR)
      REAL*8       B(NBFONC,NBMR)
C
C-----------------------------------------------------------------------
C
      DO 10 IMR = 1,NBMR
        DO 20 IFO = 1,NBFONC
          B(IFO,IMR) = 0.D0
          DO 30 IP = 1,NBP-1
            DX = DISC(IP+1) - DISC(IP)
            Y1 = VALE(IP,IFO)*DEFM(IP,IMR)
            Y2 = VALE(IP+1,IFO)*DEFM(IP+1,IMR)
            YY = Y1 + Y2
            B(IFO,IMR) = B(IFO,IMR) + YY * DX
  30      CONTINUE
          B(IFO,IMR) = B(IFO,IMR)/2.D0
  20    CONTINUE
  10  CONTINUE
      END
