       FUNCTION SPECT2 ( A, B, XLC,VITN,RHOE,DEFM,
     +                           F, TOL, IER,R1,ERR,NBP,IM,JM )
C------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 10/03/98   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C TOLE CRP_7
C-------------------------------------------------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
C                                 B  F2(X)
C DESCRIPTION : CALCULE DINTEG = S  S F(X,Y) DY   DX
C -----------                     A  F1(X)
C
C               (S EST LE SYMBOLE DE L'INTEGRALE).
C
C               TOL DONNE LE SEUIL DE CONVERGENCE RELATIVE.
C
C               F EST LA FONCTION A INTEGRER.
C               ELLE DOIT ETRE DECLAREE EXTERNAL DANS L'APPELANT.
C               SA SPECIFICATION EST :
C                        DOUBLE PRECISION FUNCTION F ( X, Y )
C                        DOUBLE PRECISION X, Y
C               L'INTEGRALE INTERNE EST EVALUEE PAR LA FONCTION DINTG2.
C               C'EST DONC DINTG2 QUI APPELLE F ET NON DINTEG.
C               F EST DONNEE EN ARGUMENT A DINTG2 PAR DINTEG.
C
C               A ET B DONNENT LES BORNES DE L'INTEGRALE EXTERNE.
C
C               F1 ET F2 DONNENT LES BORNES DE L'INTEGRALE INTERNE.
C               ELLES DOIVENT ETRE DECLAREE EXTERNAL DANS L'APPELANT.
C               LEURS SPECIFICATIONS SONT :
C                        DOUBLE PRECISION FUNCTION F1 ( X )
C                        DOUBLE PRECISION X
C                        DOUBLE PRECISION FUNCTION F2 ( X )
C                        DOUBLE PRECISION X
C
C AU RETOUR : IER=0 <==> L'INTEGRALE EXTERNE A CONVERGEE.
C ---------   IER=1 <==> L'INTEGRALE EXTERNE N'A PAS CONVERGEE.
C                        ON RENVOIT LA VALEUR AU PAS PRECEDENT ET
C                        L'ERREUR RELATIVE.
C             A, B ET TOL SONT INCHANGES.
C
C *****************   DECLARATIONS DES VARIABLES   ********************
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  -------------------------
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  -------------------------
C
C
C ARGUMENTS
C ---------
      INTEGER   IER
      REAL*8    VITN(NBP,*),DEFM(NBP,*),RHOE(NBP,*),A,B,TOL,XLC,R1,ERR
      REAL*8    F, SPECT3
      EXTERNAL  F
C
C VARIABLES LOCALES
C -----------------
      INTEGER INDEX, N1, N2, I, ARRET
      REAL*8 RES, XM, DX, X0, SOM, X
      REAL*8 W(127), COEFF(381)
C
C FONCTIONS
C ---------
C
C DATAS
C -----
      DATA (COEFF(I),I=  1, 20) /
     S     0.7745966692414834D0  ,    0.5555555555555556D0  ,
     S     0.8888888888888889D0  ,    0.2684880898683334D0  ,
     S     0.9604912687080203D0  ,    0.1046562260264673D0  ,
     S     0.4342437493468026D0  ,    0.4013974147759622D0  ,
     S     0.4509165386584741D0  ,    0.1344152552437842D0  ,
     S     0.5160328299707974D-1 ,    0.2006285293769890D0  ,
     S     0.9938319632127550D0  ,    0.1700171962994026D-1 ,
     S     0.8884592328722570D0  ,    0.9292719531512454D-1 ,
     S     0.6211029467372264D0  ,    0.1715119091363914D0  ,
     S     0.2233866864289669D0  ,    0.2191568584015875D0  /
C
      DATA (COEFF(I),I= 21, 40) /
     S     0.2255104997982067D0  ,    0.6720775429599070D-1 ,
     S     0.2580759809617665D-1 ,    0.1003142786117956D0  ,
     S     0.8434565739321106D-2 ,    0.4646289326175799D-1 ,
     S     0.8575592004999035D-1 ,    0.1095784210559246D0  ,
     S     0.9990981249676676D0  ,    0.2544780791561874D-2 ,
     S     0.9815311495537401D0  ,    0.1644604985438781D-1 ,
     S     0.9296548574297401D0  ,    0.3595710330712932D-1 ,
     S     0.8367259381688687D0  ,    0.5697950949412336D-1 ,
     S     0.7024962064915271D0  ,    0.7687962049900353D-1 ,
     S     0.5313197436443756D0  ,    0.9362710998126447D-1 /
C
      DATA (COEFF(I),I= 41, 60) /
     S     0.3311353932579768D0  ,    0.1056698935802348D0  ,
     S     0.1124889431331866D0  ,    0.1119568730209535D0  ,
     S     0.1127552567207687D0  ,    0.3360387714820773D-1 ,
     S     0.1290380010035127D-1 ,    0.5015713930589954D-1 ,
     S     0.4217630441558855D-2 ,    0.2323144663991027D-1 ,
     S     0.4287796002500773D-1 ,    0.5478921052796287D-1 ,
     S     0.1265156556230068D-2 ,    0.8223007957235930D-2 ,
     S     0.1797855156812827D-1 ,    0.2848975474583355D-1 ,
     S     0.3843981024945553D-1 ,    0.4681355499062801D-1 ,
     S     0.5283494679011652D-1 ,    0.5597843651047632D-1 /
C
      DATA (COEFF(I),I= 61, 80) /
     S     0.9998728881203576D0  ,    0.3632214818455307D-3 ,
     S     0.9972062593722220D0  ,    0.2579049794685688D-2 ,
     S     0.9886847575474295D0  ,    0.6115506822117246D-2 ,
     S     0.9721828747485818D0  ,    0.1049824690962132D-1 ,
     S     0.9463428583734029D0  ,    0.1540675046655950D-1 ,
     S     0.9103711569570043D0  ,    0.2059423391591271D-1 ,
     S     0.8639079381936905D0  ,    0.2586967932721475D-1 ,
     S     0.8069405319502176D0  ,    0.3107355111168796D-1 ,
     S     0.7397560443526948D0  ,    0.3606443278078257D-1 ,
     S     0.6629096600247806D0  ,    0.4071551011694432D-1 /
C
      DATA (COEFF(I),I= 81,100) /
     S     0.5771957100520458D0  ,    0.4491453165363220D-1 ,
     S     0.4836180269458410D0  ,    0.4856433040667320D-1 ,
     S     0.3833593241987303D0  ,    0.5158325395204846D-1 ,
     S     0.2777498220218243D0  ,    0.5390549933526606D-1 ,
     S     0.1682352515522075D0  ,    0.5548140435655936D-1 ,
     S     0.5634431304659279D-1 ,    0.5627769983125430D-1 ,
     S     0.5637762836038472D-1 ,    0.1680193857410387D-1 ,
     S     0.6451900050175737D-2 ,    0.2507856965294977D-1 ,
     S     0.2108815245726633D-2 ,    0.1161572331995513D-1 ,
     S     0.2143898001250387D-1 ,    0.2739460526398143D-1 /
C
      DATA (COEFF(I),I=101,120) /
     S     0.6326073193626335D-3 ,    0.4111503978654693D-2 ,
     S     0.8989275784064136D-2 ,    0.1424487737291677D-1 ,
     S     0.1921990512472777D-1 ,    0.2340677749531401D-1 ,
     S     0.2641747339505826D-1 ,    0.2798921825523816D-1 ,
     S     0.1807395644453884D-3 ,    0.1289524082610417D-2 ,
     S     0.3057753410175531D-2 ,    0.5249123454808859D-2 ,
     S     0.7703375233279742D-2 ,    0.1029711695795636D-1 ,
     S     0.1293483966360737D-1 ,    0.1553677555584398D-1 ,
     S     0.1803221639039129D-1 ,    0.2035775505847216D-1 ,
     S     0.2245726582681610D-1 ,    0.2428216520333660D-1 /
C
      DATA (COEFF(I),I=121,140) /
     S     0.2579162697602423D-1 ,    0.2695274966763303D-1 ,
     S     0.2774070217827968D-1 ,    0.2813884991562715D-1 ,
     S     0.9999824303548916D0  ,    0.5053609520786252D-4 ,
     S     0.9995987996719107D0  ,    0.3777466463269847D-3 ,
     S     0.9983166353184074D0  ,    0.9383698485423815D-3 ,
     S     0.9957241046984072D0  ,    0.1681142865421470D-2 ,
     S     0.9914957211781061D0  ,    0.2568764943794020D-2 ,
     S     0.9853714995985204D0  ,    0.3572892783517300D-2 ,
     S     0.9771415146397057D0  ,    0.4671050372114322D-2 ,
     S     0.9666378515584166D0  ,    0.5843449875835640D-2 /
C
      DATA (COEFF(I),I=141,160) /
     S     0.9537300064257611D0  ,    0.7072489995433555D-2 ,
     S     0.9383203977795929D0  ,    0.8342838753968158D-2 ,
     S     0.9203400254700124D0  ,    0.9641177729702537D-2 ,
     S     0.8997448997769400D0  ,    0.1095573338783790D-1 ,
     S     0.8765134144847053D0  ,    0.1227583056008277D-1 ,
     S     0.8506444947683503D0  ,    0.1359157100976555D-1 ,
     S     0.8221562543649804D0  ,    0.1489364166481518D-1 ,
     S     0.7910849337998484D0  ,    0.1617321872957772D-1 ,
     S     0.7574839663805136D0  ,    0.1742193015946417D-1 ,
     S     0.7214230853700989D0  ,    0.1863184825613879D-1 /
C
      DATA (COEFF(I),I=161,180) /
     S     0.6829874310910792D0  ,    0.1979549504809750D-1 ,
     S     0.6422766425097595D0  ,    0.2090585144581202D-1 ,
     S     0.5994039302422429D0  ,    0.2195636630531782D-1 ,
     S     0.5544951326319325D0  ,    0.2294096422938775D-1 ,
     S     0.5076877575337166D0  ,    0.2385405210603854D-1 ,
     S     0.4591300119898323D0  ,    0.2469052474448768D-1 ,
     S     0.4089798212298887D0  ,    0.2544576996546477D-1 ,
     S     0.3574038378315322D0  ,    0.2611567337670610D-1 ,
     S     0.3045764415567140D0  ,    0.2669662292745036D-1 ,
     S     0.2506787303034832D0  ,    0.2718551322962479D-1 /
C
      DATA (COEFF(I),I=181,200) /
     S     0.1958975027111002D0  ,    0.2757974956648187D-1 ,
     S     0.1404242331525602D0  ,    0.2787725147661370D-1 ,
     S     0.8445404008371088D-1 ,    0.2807645579381725D-1 ,
     S     0.2818464894974569D-1 ,    0.2817631903301660D-1 ,
     S     0.2818881418019236D-1 ,    0.8400969287051933D-2 ,
     S     0.3225950025087868D-2 ,    0.1253928482647488D-1 ,
     S     0.1054407622853764D-2 ,    0.5807861659977567D-2 ,
     S     0.1071949000625193D-1 ,    0.1369730263199072D-1 ,
     S     0.3163038905577009D-3 ,    0.2055751989327344D-2 ,
     S     0.4494637892032068D-2 ,    0.7122438686458387D-2 /
C
      DATA (COEFF(I),I=201,220) /
     S     0.9609952562363883D-2 ,    0.1170338874765700D-1 ,
     S     0.1320873669752913D-1 ,    0.1399460912761908D-1 ,
     S     0.9059242831838712D-4 ,    0.6447620408298260D-3 ,
     S     0.1528876705087616D-2 ,    0.2624561727404430D-2 ,
     S     0.3851687616639871D-2 ,    0.5148558478978178D-2 ,
     S     0.6467419831803687D-2 ,    0.7768387777921991D-2 ,
     S     0.9016108195195643D-2 ,    0.1017887752923608D-1 ,
     S     0.1122863291340805D-1 ,    0.1214108260166830D-1 ,
     S     0.1289581348801211D-1 ,    0.1347637483381652D-1 ,
     S     0.1387035108913984D-1 ,    0.1406942495781358D-1 /
C
      DATA (COEFF(I),I=221,240) /
     S     0.2234303854547696D-4 ,    0.1888639812523945D-3 ,
     S     0.4691849097155527D-3 ,    0.8405714326197546D-3 ,
     S     0.1284382471895813D-2 ,    0.1786446391758630D-2 ,
     S     0.2335525186057160D-2 ,    0.2921724937917820D-2 ,
     S     0.3536244997716778D-2 ,    0.4171419376984079D-2 ,
     S     0.4820588864851268D-2 ,    0.5477866693918951D-2 ,
     S     0.6137915280041385D-2 ,    0.6795785504882773D-2 ,
     S     0.7446820832407591D-2 ,    0.8086609364788860D-2 ,
     S     0.8710965079732087D-2 ,    0.9315924128069395D-2 ,
     S     0.9897747524048750D-2 ,    0.1045292572290601D-1 /
C
      DATA (COEFF(I),I=241,260) /
     S     0.1097818315265891D-1 ,    0.1147048211469387D-1 ,
     S     0.1192702605301927D-1 ,    0.1234526237224384D-1 ,
     S     0.1272288498273238D-1 ,    0.1305783668835305D-1 ,
     S     0.1334831146372518D-1 ,    0.1359275661481240D-1 ,
     S     0.1378987478324094D-1 ,    0.1393862573830685D-1 ,
     S     0.1403822789690862D-1 ,    0.1408815951650830D-1 ,
     S     0.9999958664005165D0  ,    0.8822702694609804D-5 ,
     S     0.9999445736539534D0  ,    0.5403992347935378D-4 ,
     S     0.9997604612201292D0  ,    0.1357078405902732D-3 ,
     S     0.9993803390481119D0  ,    0.2492143139346697D-3 /
C
      DATA (COEFF(I),I=261,280) /
     S     0.9987456144372444D0  ,    0.3897452481631715D-3 ,
     S     0.9978053544968644D0  ,    0.5542953186526136D-3 ,
     S     0.9965141459148629D0  ,    0.7402828044420028D-3 ,
     S     0.9948315028006219D0  ,    0.9453615168885046D-3 ,
     S     0.9927213442827886D0  ,    0.1167484117433308D-2 ,
     S     0.9901513704007702D0  ,    0.1404907995655566D-2 ,
     S     0.9870925279540341D0  ,    0.1656112728154507D-2 ,
     S     0.9835186575786327D0  ,    0.1919712971013880D-2 ,
     S     0.9794062816708627D0  ,    0.2194406925363840D-2 ,
     S     0.9747344597524027D0  ,    0.2478958226657568D-2 /
C
      DATA (COEFF(I),I=281,300) /
     S     0.9694846595024592D0  ,    0.2772195764593451D-2 ,
     S     0.9636406215698121D0  ,    0.3073018434702578D-2 ,
     S     0.9571882161098610D0  ,    0.3380397991086920D-2 ,
     S     0.9501152975212949D0  ,    0.3693377917025651D-2 ,
     S     0.9424115651910831D0  ,    0.4011068724075023D-2 ,
     S     0.9340684361577258D0  ,    0.4332640968092983D-2 ,
     S     0.9250789329070757D0  ,    0.4657317299756855D-2 ,
     S     0.9154375871557650D0  ,    0.4984364564765539D-2 ,
     S     0.9051403588132616D0  ,    0.5313086605187057D-2 ,
     S     0.8941845683355590D0  ,    0.5642818101384444D-2 /
C
      DATA (COEFF(I),I=301,320) /
     S     0.8825688402473419D0  ,    0.5972919565508166D-2 ,
     S     0.8702930555481139D0  ,    0.6302773449085759D-2 ,
     S     0.8573583108862322D0  ,    0.6631781242901888D-2 ,
     S     0.8437668826727086D0  ,    0.6959361409390423D-2 ,
     S     0.8295221946374014D0  ,    0.7284947980553807D-2 ,
     S     0.8146287876551374D0  ,    0.7607989665719057D-2 ,
     S     0.7990922909608414D0  ,    0.7927949334294849D-2 ,
     S     0.7829193941182830D0  ,    0.8244303763032868D-2 ,
     S     0.7661178193037601D0  ,    0.8556543561307690D-2 ,
     S     0.7486962936169366D0  ,    0.8864173209482494D-2 /
C
      DATA (COEFF(I),I=321,340) /
     S     0.7306645212421813D0  ,    0.9166711163560788D-2 ,
     S     0.7120331553622520D0  ,    0.9463689993830065D-2 ,
     S     0.6928137697791147D0  ,    0.9754656536317411D-2 ,
     S     0.6730188302304185D0  ,    0.1003917204405684D-1 ,
     S     0.6526616654100175D0  ,    0.1031681233094762D-1 ,
     S     0.6317564377111942D0  ,    0.1058716790488520D-1 ,
     S     0.6103181137151864D0  ,    0.1084984408933731D-1 ,
     S     0.5883624344476625D0  ,    0.1110446113400693D-1 ,
     S     0.5659058854236544D0  ,    0.1135065431598060D-1 ,
     S     0.5429656664983115D0  ,    0.1158807403304395D-1 /
C
      DATA (COEFF(I),I=341,360) /
     S     0.5195596615374570D0  ,    0.1181638589083024D-1 ,
     S     0.4957064079187615D0  ,    0.1203527078527956D-1 ,
     S     0.4714250658716589D0  ,    0.1224442498161199D-1 ,
     S     0.4467353876620285D0  ,    0.1244356019071404D-1 ,
     S     0.4216576866261633D0  ,    0.1263240364354208D-1 ,
     S     0.3962128060576159D0  ,    0.1281069816387736D-1 ,
     S     0.3704220879500782D0  ,    0.1297820223953740D-1 ,
     S     0.3443073415994380D0  ,    0.1313469009196015D-1 ,
     S     0.3178908120684767D0  ,    0.1327995174393053D-1 ,
     S     0.2911951485182467D0  ,    0.1341379308511010D-1 /
C
      DATA (COEFF(I),I=361,381) /
     S     0.2642433724109268D0  ,    0.1353603593495621D-1 ,
     S     0.2370588455898297D0  ,    0.1364651810257129D-1 ,
     S     0.2096652382431812D0  ,    0.1374509344300190D-1 ,
     S     0.1820864967592522D0  ,    0.1383163190950643D-1 ,
     S     0.1543468114813781D0  ,    0.1390601960132546D-1 ,
     S     0.1264705843723020D0  ,    0.1396815880651694D-1 ,
     S     0.9848239659811920D-1 ,    0.1401796803945661D-1 ,
     S     0.7040697604285518D-1 ,    0.1405538207264996D-1 ,
     S     0.4226916476536360D-1 ,    0.1408035196255366D-1 ,
     S     0.1409388641078246D-1 ,    0.1409284506916041D-1 ,
     S     0.1409440709009618D-1 /
C
C *****************    DEBUT DU CODE EXECUTABLE    *********************
C
      IER = 0
      ERR = 0.D0
      RES = 0.0D0
      IF ( ABS(A-B) .LT. 1.0D-30 ) THEN
         SPECT2 = RES
         GOTO 9999
      END IF
C
      XM = ( A + B ) / 2.0D0
      DX = ( B - A ) / 2.0D0
      X0 = SPECT3 ( XM, A,B, F, TOL, COEFF,XLC,VITN,DEFM,
     +              RHOE,NBP,IM,JM )
      R1 = (X0+X0) * DX
      INDEX = 0
      N1    = 0
      N2    = 1
      SOM   = 0.0D0
C
C --- REPETER ...
C
   10 CONTINUE
      N1 = N1 + N2
      DO 20 I = N2, N1
         INDEX = INDEX + 1
         X  = COEFF(INDEX) * DX
         W(I) = SPECT3( XM+X, A, B, F, TOL, COEFF,XLC,VITN,
     S                  DEFM,RHOE,NBP,IM,JM ) +
     S          SPECT3( XM-X, A, B, F, TOL, COEFF,XLC,VITN,
     S                  DEFM,RHOE,NBP,IM,JM )
         INDEX = INDEX + 1
         SOM = SOM + COEFF(INDEX)*W(I)
   20 CONTINUE
      N2 = N1 + 1
      INDEX = INDEX + 1
      RES = ( SOM + COEFF(INDEX)*X0 ) * DX
C
C --- TEST DE CONVERGENCE.
C
      IF ( ABS(RES-R1) .LE. ABS(R1*TOL) ) THEN
         IER = 0
         ARRET = 1
      ELSE
         IER = 1
         IF ( N1 .GE. 127 ) THEN
            ARRET = 1
            ERR = ABS((RES-R1)/R1)*100.D0
         ELSE
            ARRET = 0
            R1 = RES
            SOM = 0.0D0
            DO 22 I = 1, N1
               INDEX = INDEX + 1
               SOM = SOM + COEFF(INDEX)*W(I)
   22       CONTINUE
         END IF
      END IF
C
C --- JUSQUE ARRET = 1.
C
      IF ( ARRET .EQ. 0 ) GO TO 10
C
      SPECT2 = RES
C
 9999 CONTINUE
      END
