      SUBROUTINE SURFCL(CHAR,NOMA,IFM)
C      
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 14/09/2010   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2007  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C TOLE CRP_20
C 
      IMPLICIT NONE
      CHARACTER*8 CHAR
      CHARACTER*8 NOMA
      INTEGER     IFM
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES MAILLEES - AFFICHAGE DONNEES)
C
C AFFICHAGE LES INFOS CONTENUES DANS LA SD CONTACT POUR LES FORMULATIONS
C MAILLEES (DISCRETE ET CONTINUE MAIS PAS XFEM)
C      
C ----------------------------------------------------------------------
C
C
C IN  CHAR   : NOM UTILISATEUR DU CONCEPT DE CHARGE
C IN  NOMA   : NOM DU MAILLAGE
C IN  IFM    : UNITE D'IMPRESSION
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*32 JEXNUM
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      CFMMVD,ZDIRN
      INTEGER      NDIM,NZOCO,NSUCO,NMACO
      INTEGER      CFDISI,NNOCO,NMANO,NNOMA
      INTEGER      NTNOE,NTMAE,NTNOEC,NTMAEC
      INTEGER      NTNOM,NTMAM,NTNOMC,NTMAMC      
      INTEGER      NTPC,NTPT
      INTEGER      IZONE,K,NSNO,INO,JDEC,NUMNOE
C
      CHARACTER*24 DEFICO
C      
      CHARACTER*8  CHAIN1,CHAIN2,K8BID
C
      CHARACTER*24 PZONE,PSURMA,PSURNO,CONTMA,CONTNO
      INTEGER      JZONE,JSUMA ,JSUNO ,JMACO ,JNOCO 
      CHARACTER*24 MANOCO,PMANO ,NOMACO,PNOMA 
      INTEGER      JMANO ,JPOMA ,JNOMA ,JPONO
      CHARACTER*24 PSANS ,SANSNO      
      INTEGER      JPSANS,JSANS 
      CHARACTER*24 NOEUMA
      INTEGER      JNOMNO      
C
      CHARACTER*24 DIRAPP,DIRNOR
      INTEGER      JDIRAP,JDIRNO
      CHARACTER*24 JEUFO1,JEUFO2
      INTEGER      JJFO1,JJFO2
C
      INTEGER      ILISS
      INTEGER      MMINFI,INORM,ITYPA,IVECM,IVECE,IAPPA
      LOGICAL      MMINFL,LCOQU,LPOUT    
      REAL*8       MMINFR  
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ  
C
C --- INITIALISATIONS
C
      DEFICO = CHAR(1:8)//'.CONTACT'  
C
C --- ACCES SD DU MAILLAGE
C
      NOEUMA = NOMA(1:8)//'.NOMNOE'                             
C   
C --- COMMUNS AVEC FORM. MAILLEES (DISCRET ET CONTINUE MAIS PAS XFEM)
C  
      PZONE  = DEFICO(1:16)//'.PZONECO'    
      PSURMA = DEFICO(1:16)//'.PSUMACO'
      PSURNO = DEFICO(1:16)//'.PSUNOCO'
      CONTMA = DEFICO(1:16)//'.MAILCO'
      CONTNO = DEFICO(1:16)//'.NOEUCO'
      MANOCO = DEFICO(1:16)//'.MANOCO'
      PMANO  = DEFICO(1:16)//'.PMANOCO'
      NOMACO = DEFICO(1:16)//'.NOMACO'
      PNOMA  = DEFICO(1:16)//'.PNOMACO'
      SANSNO = DEFICO(1:16)//'.SSNOCO'
      PSANS  = DEFICO(1:16)//'.PSSNOCO'  
      JEUFO1 = DEFICO(1:16)//'.JFO1CO'
      JEUFO2 = DEFICO(1:16)//'.JFO2CO'             
      DIRAPP = DEFICO(1:16)//'.DIRAPP'
      DIRNOR = DEFICO(1:16)//'.DIRNOR'  
C
      CALL JEVEUO(PZONE, 'L',JZONE)    
      CALL JEVEUO(PSURMA,'L',JSUMA)
      CALL JEVEUO(PSURNO,'L',JSUNO) 
      CALL JEVEUO(CONTMA,'L',JMACO)
      CALL JEVEUO(CONTNO,'L',JNOCO)       
      CALL JEVEUO(MANOCO,'L',JMANO)
      CALL JEVEUO(PMANO, 'L',JPOMA)
      CALL JEVEUO(NOMACO,'L',JNOMA)
      CALL JEVEUO(PNOMA, 'L',JPONO)
      CALL JEVEUO(PSANS, 'L',JPSANS)
      CALL JEVEUO(SANSNO,'L',JSANS)   
      CALL JEVEUO(JEUFO1,'L',JJFO1)
      CALL JEVEUO(JEUFO2,'L',JJFO2)
      CALL JEVEUO(DIRAPP,'L',JDIRAP)
      CALL JEVEUO(DIRNOR,'L',JDIRNO)        
C
      ZDIRN  = CFMMVD('ZDIRN')        
C
C --- INITIALISATIONS
C    
      NDIM   = CFDISI(DEFICO,'NDIM'  )  
      NZOCO  = CFDISI(DEFICO,'NZOCO' ) 
      NSUCO  = CFDISI(DEFICO,'NSUCO' ) 
      NMACO  = CFDISI(DEFICO,'NMACO' ) 
      NNOCO  = CFDISI(DEFICO,'NNOCO' )
      NTMAE  = CFDISI(DEFICO,'NTMAE' )      
      NTNOE  = CFDISI(DEFICO,'NTNOE' )
      NTMAEC = CFDISI(DEFICO,'NTMAEC')      
      NTNOEC = CFDISI(DEFICO,'NTNOEC')  
      NTMAM  = CFDISI(DEFICO,'NTMAM' )      
      NTNOM  = CFDISI(DEFICO,'NTNOM' )
      NTMAMC = CFDISI(DEFICO,'NTMAMC')      
      NTNOMC = CFDISI(DEFICO,'NTNOMC')   
      NTPC   = CFDISI(DEFICO,'NTPC'  ) 
      NTPT   = CFDISI(DEFICO,'NTPT'  )        
C
C --- CREATION VECTEURS TEMPORAIRES
C      
      CALL WKVECT('&&SURFCL.TRAVNO','V V K8',NZOCO*NNOCO,JNOMNO)
C 
C --- IMPRESSIONS POUR L'UTILISATEUR
C 
      WRITE (IFM,*)      
      WRITE (IFM,*) '<CONTACT> INFOS GENERALES SUR LES FORMULATIONS'//
     &              ' MAILLEES'      
      WRITE (IFM,*) 
C
C --- PARAMETRES GENERAUX D'APPARIEMENT
C
      WRITE (IFM,*) '<CONTACT> ... PARAMETRES GENERAUX APPARIEMENT'
      
      ILISS  = CFDISI(DEFICO,'LISSAGE')
      
      WRITE (IFM,1070) 'LISSAGE  ',ILISS
      
      DO 9 IZONE = 1,NZOCO 
        INORM  = MMINFI(DEFICO,'NORMALE'    ,IZONE )
        IAPPA  = MMINFI(DEFICO,'APPARIEMENT',IZONE )
        ITYPA  = MMINFI(DEFICO,'TYPE_APPA'  ,IZONE )
        IVECM  = MMINFI(DEFICO,'VECT_MAIT'  ,IZONE )
        IVECE  = MMINFI(DEFICO,'VECT_ESCL'  ,IZONE )
        LCOQU  = MMINFL(DEFICO,'DIST_COQUE' ,IZONE )
        LPOUT  = MMINFL(DEFICO,'DIST_POUTRE',IZONE )
        
        
        WRITE (IFM,*) '<CONTACT> ...... ZONE : ',IZONE  
        WRITE (IFM,1070) 'APPARIEMENT     ',IAPPA      
        WRITE (IFM,1070) 'NORMALE         ',INORM
        WRITE (IFM,1070) 'TYPE_APPA       ',ITYPA
        
        IF (ITYPA.EQ.1) THEN
          WRITE (IFM,1072) 'DIRE_APPA       ',
     &          ZR(JDIRAP+3*(IZONE-1)),
     &          ZR(JDIRAP+3*(IZONE-1)+1),
     &          ZR(JDIRAP+3*(IZONE-1)+2)
        ENDIF
        
        WRITE (IFM,1070) 'VECT_MAIT       ',IVECM
        
        IF (IVECM.EQ.1) THEN
          WRITE (IFM,1072) 'MAIT_FIXE       ',
     &          ZR(JDIRNO+ZDIRN*(IZONE-1)),
     &          ZR(JDIRNO+ZDIRN*(IZONE-1)+1),
     &          ZR(JDIRNO+ZDIRN*(IZONE-1)+2)
        ENDIF        
        IF (IVECM.EQ.2) THEN
          WRITE (IFM,1072) 'MAIT_VECT_Y     ',
     &          ZR(JDIRNO+ZDIRN*(IZONE-1)),
     &          ZR(JDIRNO+ZDIRN*(IZONE-1)+1),
     &          ZR(JDIRNO+ZDIRN*(IZONE-1)+2)
        ENDIF          
        WRITE (IFM,1070) 'VECT_ESCL       ',IVECE
        IF (IVECE.EQ.1) THEN
          WRITE (IFM,1072) 'ESCL_FIXE       ',
     &          ZR(JDIRNO+ZDIRN*(IZONE-1)+3),
     &          ZR(JDIRNO+ZDIRN*(IZONE-1)+4),
     &          ZR(JDIRNO+ZDIRN*(IZONE-1)+5)
        ENDIF        
        IF (IVECE.EQ.2) THEN
          WRITE (IFM,1072) 'ESCL_VECT_Y     ',
     &          ZR(JDIRNO+ZDIRN*(IZONE-1)+3),
     &          ZR(JDIRNO+ZDIRN*(IZONE-1)+4),
     &          ZR(JDIRNO+ZDIRN*(IZONE-1)+5)
        ENDIF 
C
C --- IMPRESSIONS POUR LES POUTRES
C 
        IF (LPOUT) THEN
          WRITE (IFM,*) '<CONTACT> ... JEU SUPP. PAR DIST_POUT'
        END IF
C 
C --- IMPRESSIONS POUR LES COQUES
C 
        IF (LCOQU) THEN
          WRITE (IFM,*) '<CONTACT> ... JEU SUPP. PAR DIST_COQUE'
        END IF

        WRITE (IFM,1071) 'TOLE_PROJ_EXT   ',
     &                    MMINFR(DEFICO,'TOLE_PROJ_EXT',IZONE )
        WRITE (IFM,1071) 'TOLE_APPA       ',
     &                    MMINFR(DEFICO,'TOLE_APPA'    ,IZONE )     
C 
C --- IMPRESSIONS SANS_GROUP_NO
C      
        WRITE (IFM,*) '<CONTACT> ... NOEUDS EXCLUS '

        NSNO  = ZI(JPSANS+IZONE) - ZI(JPSANS+IZONE-1)
        IF (NSNO.EQ.0) THEN
          WRITE (IFM,*) '<CONTACT> ...... PAS DE NOEUDS DE TYPE '//
     &                  'SANS_GROUP_NO A EXCLURE'
        ELSE
          WRITE (IFM,*) '<CONTACT> ...... NOMBRE DE NOEUDS DE TYPE '//
     &                 'SANS_GROUP_NO A EXCLURE: ',NSNO
C        
          JDEC = ZI(JPSANS+IZONE-1)
          DO 801 INO = 1,NSNO
            NUMNOE = ZI(JSANS+JDEC+INO-1)
            CALL JENUNO(JEXNUM(NOEUMA,NUMNOE),ZK8(JNOMNO+INO-1))
  801     CONTINUE   
C  
          WRITE (IFM,1040) '     LISTE DES NOEUDS  : '
          WRITE (IFM,1050) (ZK8(JNOMNO+INO-1), INO = 1,NSNO)          
        ENDIF     
     
  9   CONTINUE 
C 
 1040 FORMAT (' <CONTACT> ...... ',A25)       
 1050 FORMAT ((' <CONTACT> ...... ',17X,4(A8,1X)))   
 1070 FORMAT (' <CONTACT> ...... PARAM. : ',A16,' - VAL. : ',I5)
 1071 FORMAT (' <CONTACT> ...... PARAM. : ',A16,' - VAL. : ',E12.5)
 1072 FORMAT (' <CONTACT> ...... PARMA. : ',A16,' - VAL. : ',E12.5,
     &        E12.5,E12.5)     
C 
C --- IMPRESSIONS POUR LES JEUX SUPPS
C 
      WRITE (IFM,*) '<CONTACT> ... JEU SUPP.' 
      DO 21 IZONE = 1,NZOCO
        CHAIN1 = ZK8(JJFO1+IZONE-1)
        CHAIN2 = ZK8(JJFO2+IZONE-1)

        IF ((CHAIN1.NE.' ').OR.(CHAIN2.NE.' ')) THEN
          WRITE (IFM,*) '<CONTACT> ... JEU SUPP. SUR ZONE ',IZONE
        ENDIF           
        IF (CHAIN1.NE.' ') THEN
          WRITE (IFM,1031) CHAIN1
        ENDIF
        IF (CHAIN2.NE.' ') THEN
          WRITE (IFM,1032) CHAIN2
        ENDIF             
 21   CONTINUE      
C          
 1031 FORMAT (' <CONTACT> ...... TYPE FONC. SUR ESCLAVE : ',A8) 
 1032 FORMAT (' <CONTACT> ...... TYPE FONC. SUR MAITRE  : ',A8)     
C 
C --- IMPRESSIONS GLOBALES (TOUTES ZONES)
C 
      WRITE (IFM,*)      
      WRITE (IFM,*) '<CONTACT> INFOS SPECIFIQUES SUR LES FORMULATIONS'//
     &              ' MAILLEES'
      WRITE (IFM,*) 
C       
      WRITE (IFM,*) '<CONTACT> DIMENSION DE L''ESPACE   : ',
     &               NDIM
      WRITE (IFM,*) '<CONTACT> NBRE ZONES DE CONTACT   : ', 
     &               NZOCO
      WRITE (IFM,*) '<CONTACT> NBRE SURF. DE CONTACT   : ', 
     &               NSUCO
      WRITE (IFM,*) '<CONTACT> NBRE MAIL. DE CONTACT   : ',
     &               NMACO
      WRITE (IFM,*) '<CONTACT> NBRE NOEU. DE CONTACT   : ',
     &               NNOCO
      WRITE (IFM,*) '<CONTACT> NBRE NOEU. ESCL. TOTAL  : ', 
     &               NTNOE,' DONT CALCUL ',NTNOEC
      WRITE (IFM,*) '<CONTACT> NBRE MAIL. ESCL. TOTAL  : ', 
     &               NTMAE,' DONT CALCUL ',NTMAEC
      WRITE (IFM,*) '<CONTACT> NBRE NOEU. MAIT. TOTAL  : ', 
     &               NTNOM,' DONT CALCUL ',NTNOMC
      WRITE (IFM,*) '<CONTACT> NBRE MAIL. MAIT. TOTAL  : ', 
     &               NTMAM,' DONT CALCUL ',NTMAMC    
     
     
      WRITE (IFM,*) '<CONTACT> NBRE PT. CONTACT TOTAL  : ', 
     &               NTPT,' DONT CALCUL ',NTPC  
C         
C --- NOEUDS/MAILLES DES SURFACES 
C           
      CALL SURFLL(DEFICO,NOMA  ,IFM   ,NZOCO ,NMACO ,
     &            NNOCO )
C
C --- IMPRESSIONS GLOBALES (TOUTES ZONES)
C 
      WRITE (IFM,*)      
      WRITE (IFM,*) '<CONTACT> INFOS SPECIFIQUES SUR LES FORMULATIONS'//
     &              ' MAILLEES - NIVEAU DEVELOPPEUR'
      WRITE (IFM,*) 
C
      WRITE (IFM,1080) 'PZONE  : '
      WRITE (IFM,1060) (ZI(JZONE+K), K = 0,NZOCO)

      WRITE (IFM,1080) 'PSURMA : '
      WRITE (IFM,1060) (ZI(JSUMA+K), K = 0,NSUCO)

      WRITE (IFM,1080) 'PSURNO : '
      WRITE (IFM,1060) (ZI(JSUNO+K), K = 0,NSUCO)

      WRITE (IFM,1080) 'CONTMA : '
      WRITE (IFM,1060) (ZI(JMACO+K-1), K = 1,NMACO)

      WRITE (IFM,1080) 'CONTNO : '
      WRITE (IFM,1060) (ZI(JNOCO+K-1), K = 1,NNOCO)
C  
 1060 FORMAT ((' <CONTACT> ',9X,6(I7,1X)))    
 1080 FORMAT (' <CONTACT> ',A9)
C 
      WRITE (IFM,*)      
      WRITE (IFM,*) '<CONTACT> INFOS SPECIFIQUES SUR LES FORMULATIONS'//
     &              ' MAILLEES - CONNECTIVITES INVERSES'
      WRITE (IFM,*) 
      CALL JELIRA(MANOCO,'LONUTI',NMANO,K8BID)
      CALL JELIRA(NOMACO,'LONUTI',NNOMA,K8BID)
      
      
C  
      WRITE (IFM,*) '<CONTACT> NBRE CONNEC. INV        : ',
     &               NMANO
      WRITE (IFM,*) '<CONTACT> NNOMA                   : ', 
     &               NNOMA
C
      WRITE (IFM,2080) 'MANOCO : '
      WRITE (IFM,2060) (ZI(JMANO+K-1), K = 1,NMANO)
      WRITE (IFM,2080) 'PMANO  : '
      WRITE (IFM,2060) (ZI(JPOMA+K), K = 0,NNOCO)
      WRITE (IFM,2080) 'NOMACO : '
      WRITE (IFM,2060) (ZI(JNOMA+K-1), K = 1,NNOMA)
      WRITE (IFM,2080) 'PNOMA  : '
      WRITE (IFM,2060) (ZI(JPONO+K), K = 0,NMACO)
      WRITE (IFM,*)
C
 2060 FORMAT ((' <CONTACT> ',9X,6(I7,1X)))
 2080 FORMAT (' <CONTACT> ',A9)
C
C --- MENAGE
C
      CALL JEDETR('&&SURFCL.TRAVNO') 
C
      CALL JEDEMA
      END
