      SUBROUTINE XLAGSC(NDIM  ,NBNO  ,NBARTO,MXAR  ,ALGOLA,JTABNO,
     &                  JTABIN,JTABCR,FISS ,EXILI ,
     &                  NLISEQ,NLISRL,NLISCO)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 13/04/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2007  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT NONE
      INTEGER      JTABNO,JTABIN,JTABCR
      INTEGER      NBNO,NBARTO,NDIM,MXAR
      INTEGER      ALGOLA
      CHARACTER*19  NLISEQ,NLISRL,NLISCO
      CHARACTER*8   FISS
      LOGICAL      EXILI
C      
C ----------------------------------------------------------------------
C
C ROUTINE XFEM (PREPARATION)
C
C CHOIX DE L'ESPACE DES LAGRANGES POUR LE CONTACT: 
C                    (VOIR BOOK VI 15/07/05) 
C    - DETERMINATION DES NOEUDS
C    - CREATION DES RELATIONS DE LIAISONS ENTRE LAGRANGE
C
C ----------------------------------------------------------------------
C
C
C IN  MXAR   : NOMBRE MAXIMUM D'ARETES COUPEES PAR LA FISSURE
C IN  JTABNO : ADRESSE DU TABLEAU DES NOEUDS EXTREMITES ET NOEUD MILIEU
C IN  JTABIN : ADRESSE DU TABLEAU DES COORDONNEES DES NOEUDS MILIEU
C IN  NBNO   : NOMBRE DE NOEUDS DU MAILLAGE
C IN  FISS   : NOM DE LA FISSURE
C IN  ALGOLA : TYPE DE CREATION DES RELATIONS DE LIAISONS ENTRE LAGRANGE
C I/O NBARTO : IN   NOMBRE D'ARETES INITIALES
C              OUT  NOMBRE D'ARETES COUPEES
C IN  MXAR   : NOMBRE MAXIMUM D'ARETES COUPEES PAR LA FISSURE
C IN  EXILI  : .FALSE. SI MAILLAGE QUADRATIQUE
C OUT NLISRL : LISTE REL. LIN. POUR V1 ET V2
C OUT NLISCO : LISTE REL. LIN. POUR V1 ET V2
C OUT NLISEQ : LISTE REL. LIN. POUR V2 SEULEMENT
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*19  PICKNO
      INTEGER       JPINO
      INTEGER       NBPINO
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C     
      PICKNO = '&&XLAGSP.PICKNO'
C
C --- CREATION DES LISTES DES RELATIONS DE LIAISONS ENTRE LAGRANGE
C 
      IF (ALGOLA.EQ.1) THEN
C
C --- CREATION TABLEAU DES NOEUDS EXTREMITES ET NOEUD MILIEU
C
        CALL WKVECT(PICKNO,'V V I',MXAR,JPINO)
C        
C --- SELECTION DES NOEUDS
C
        CALL XSELLA(FISS,NBNO  ,NBARTO,ZI(JTABNO),
     &              ZI(JPINO),NBPINO)
C
C --- CREATION DES LISTES DES RELATIONS DE LIAISONS ENTRE LAGRANGE
C
        CALL XRELL1(ZI(JTABNO),NDIM  ,NBARTO,ZR(JTABIN),EXILI,
     &              ZI(JPINO), NBPINO,NLISEQ,NLISRL,NLISCO)
C
C --- MENAGE
C
        CALL JEDETR(PICKNO)

      ELSEIF (ALGOLA.EQ.2) THEN
C
C --- CREATION DES LISTES DES RELATIONS DE LIAISONS ENTRE LAGRANGE
C
        CALL XRELL2(ZI(JTABNO),NDIM  ,NBARTO,ZR(JTABIN),
     &              ZR(JTABCR),EXILI ,NLISEQ,NLISRL,NLISCO)
      ENDIF
C
      CALL JEDEMA()
      END
