      SUBROUTINE XLMAIL(NOMA  ,FISS  ,NMAEN1,NMAEN2,NMAEN3,
     &                  JMAEN1,JMAEN2,JMAEN3,NFON,JFON,NBFOND,JBAS,
     &                  JFISDE,JFISAR,NDIM)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 04/02/2008   AUTEUR GALENNE E.GALENNE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2007  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT NONE
      CHARACTER*8  FISS,NOMA
      INTEGER      NMAEN1,NMAEN2,NMAEN3
      INTEGER      JMAEN1,JMAEN2,JMAEN3
      INTEGER      NFON
      INTEGER      JFON
      INTEGER      NBFOND
      INTEGER      JBAS
      INTEGER      JFISDE,JFISAR,NDIM
C      
C ----------------------------------------------------------------------
C
C ROUTINE XFEM (CREATION DES SD)
C
C CREATION SD SUR MAILLAGE XFEM
C
C ----------------------------------------------------------------------
C
C
C IN  FISS   : NOM DE LA FISSURE 
C IN  NOMA   : NOM DU MAILLAGE
C IN  NMAEN1 : NOMBRE DE MAILLES 'HEAVISIDE'
C IN  NMAEN2 : NOMBRE DE MAILLES 'CRACKTIP'
C IN  NMAEN3 : NOMBRE DE MAILLES 'HEAVISIDE-CRACKTIP'
C IN  JMAEN1 : POINTEUR SUR MAILLES 'HEAVISIDE'
C IN  JMAEN2 : POINTEUR SUR MAILLES 'CRACKTIP'
C IN  JMAEN3 : POINTEUR SUR MAILLES 'HEAVISIDE-CRACKTIP'
C IN  NFON   : NOMBRE DE POINTS DE FOND DE FISSURE
C IN  JFON   : POINTEUR SUR POINTS DE FOND DE FISSURE
C IN  JBAS   : POINTEUR SUR DIRECTION DE PROPAGATION
C IN  NBFOND : NOMBRE DE FONDS DE FISSURES DETECTES
C IN  JFISDE : POINTEUR SUR DEBUT DU FOND DE FISSURE
C IN  JFISAR : POINTEUR SUR ARRIVEE DU FOND DE FISSURE
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      XXMMVD,ZXIND  
      CHARACTER*24 XINDIC,XHEAV,XCTIP,XHECT,XFONFI,XFONMU,XBASFO
      INTEGER      JINDIC,JMA1,JMA2,JMA3,JFO,JFOMU,JBA
      INTEGER      I,K  
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- ACCES AUX OBJETS
C      
      XINDIC = FISS(1:8)//'.MAILFISS .INDIC'
      XHEAV  = FISS(1:8)//'.MAILFISS  .HEAV'
      XCTIP  = FISS(1:8)//'.MAILFISS  .CTIP'
      XHECT  = FISS(1:8)//'.MAILFISS  .HECT'
      XFONFI = FISS(1:8)//'.FONDFISS'
      XBASFO = FISS(1:8)//'.BASEFOND'
      XFONMU = FISS(1:8)//'.FONDMULT'  
C
      ZXIND  = XXMMVD('ZXIND')       
C
C --- CREATION D'UN INDICATEUR : PRESENCE GR_ENR (0 OU 1) +  NMAEN
C
      CALL WKVECT(XINDIC,'G V I',ZXIND,JINDIC)
C
C --- ENREGISTREMENT DES GROUP_MA 'HEAVISIDE' 
C
      IF (NMAEN1.NE.0) THEN
        CALL WKVECT(XHEAV,'G V I',NMAEN1,JMA1)
        ZI(JINDIC)   = 1
        ZI(JINDIC+1) = NMAEN1
        DO 810 I=1,NMAEN1
           ZI(JMA1-1+I) = ZI(JMAEN1-1+I)
 810    CONTINUE     
      ENDIF
C
C --- ENREGISTREMENT DES GROUP_MA 'CRACKTIP' 
C      
      IF (NMAEN2.NE.0) THEN
        CALL WKVECT(XCTIP,'G V I',NMAEN2,JMA2)
        ZI(JINDIC+2) = 1
        ZI(JINDIC+3) = NMAEN2
        DO 820 I=1,NMAEN2
           ZI(JMA2-1+I) = ZI(JMAEN2-1+I)
 820    CONTINUE
      ENDIF
C
C --- ENREGISTREMENT DES GROUP_MA ''HEAVISIDE-CRACKTIP' 
C      
      IF (NMAEN3.NE.0) THEN
        CALL WKVECT(XHECT,'G V I',NMAEN3,JMA3)
        ZI(JINDIC+4) = 1
        ZI(JINDIC+5) = NMAEN3
        DO 830 I=1,NMAEN3
           ZI(JMA3-1+I) = ZI(JMAEN3-1+I)
 830    CONTINUE
      ENDIF
C
C --- ENREGISTREMENT DES COORD ET DES ABS CURV
C
      IF (NFON.NE.0) THEN
        CALL WKVECT(XFONFI,'G V R',4*NFON,JFO)
        DO 840 I=1,NFON
          DO 850 K=1,4
            ZR(JFO-1+4*(I-1)+K) = ZR(JFON-1+4*(I-1)+K)
 850      CONTINUE
 840    CONTINUE
      
        CALL WKVECT(XBASFO,'G V R',2*NDIM*NFON,JBA)
        DO 940 I=1,NFON
          DO 950 K=1,NDIM
            ZR(JBA-1+2*NDIM*(I-1)+K) = ZR(JBAS-1+2*NDIM*(I-1)+K)
            ZR(JBA-1+2*NDIM*(I-1)+K+NDIM) = 
     &                           ZR(JBAS-1+2*NDIM*(I-1)+K+NDIM)
 950      CONTINUE
 940    CONTINUE

      ENDIF
C
C --- ENREGISTREMENT DES FONDS MULTIPLES
C
      IF (NBFOND.NE.0) THEN
        CALL WKVECT(XFONMU,'G V I',2*NBFOND,JFOMU)
        DO 860 I=1,NBFOND
          ZI(JFOMU-1+2*(I-1)+1) = ZI(JFISDE-1+I)
          ZI(JFOMU-1+2*(I-1)+2) = ZI(JFISAR-1+I)
 860    CONTINUE
      ENDIF
C
      CALL JEDEMA()
      END
