      SUBROUTINE XLORIE(FISS,NDIM,GEOFIS,DGA,NOEUD,VECT1,VECT2)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 21/09/2009   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2007  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT NONE
      INTEGER     NDIM
      REAL*8      DGA,DPA,NOEUD(3),VECT1(3),VECT2(3)
      CHARACTER*8 FISS
      CHARACTER*16 GEOFIS
C      
C ----------------------------------------------------------------------
C
C ROUTINE XFEM (CREATION DES SD)
C
C LECTURE DONNEES ORIENTATION FOND DE FISSURE - CREATION XCARFO
C
C ----------------------------------------------------------------------
C
C
C OUT FISS   : NOM DE LA SD FISS_XFEM 
C                 FISS//'.CARAFOND'    
C IN  NDIM   : DIMENSION DE L'ESPACE    
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      I,IBID,IOCC,IOCC2,IR,IN,NCOUCH
      REAL*8       PFI(3),VOR(3),ORI(3),RAYON,NORME
      CHARACTER*16 K16BID,TYPENR
      CHARACTER*24 XCARFO
      INTEGER      JCARAF
      INTEGER      XXMMVD,ZXCAR
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- CREATION DU VECTEUR DE STOCKAGE
C
      ZXCAR  = XXMMVD('ZXCAR') 
      XCARFO = FISS(1:8)//'.CARAFOND'
      CALL WKVECT(XCARFO,'G V R',ZXCAR,JCARAF)
C
C --- REMPLISSAGE DU VECTEUR DE STOCKAGE
C   
C     TYPE ENRICHISSEMENT (TOPOLOGIQUE OU GEOMETRIQUE)
      CALL GETVTX(' ','TYPE_ENRI_FOND',1,1,1,TYPENR,IBID)   
      CALL ASSERT(TYPENR.EQ.'TOPOLOGIQUE'.OR.TYPENR.EQ.'GEOMETRIQUE')
      IF (TYPENR.EQ.'TOPOLOGIQUE') THEN
        RAYON  = 0.D0
        NCOUCH = 0
      ELSEIF (TYPENR.EQ.'GEOMETRIQUE') THEN
        CALL GETVR8(' ','RAYON_ENRI',1,1,1,RAYON,IR)   
        CALL GETVIS(' ','NB_COUCHES',1,1,1,NCOUCH,IN)   
        IF (IR.EQ.0) THEN
          RAYON = 0.D0
          IF (NCOUCH.GT.7) CALL U2MESI('A','XFEM_5',1,NCOUCH)
        ELSEIF (IR.EQ.1) THEN
C         ON NE PEUT PAS DEFINIR DE REGLE "EXCLUS" DANS LE CAPY
C         SINON, DANS LE CAS OU ON NE RENSEIGNE RIEN, IL Y A ERREUR
          IF (IN.EQ.1) CALL U2MESS('F','XFEM_17')
          IF (RAYON.LE.0.D0) CALL U2MESS('F','XFEM_6')
          NCOUCH = 0
        ENDIF
      ENDIF

C      WRITE(6,*) 'RAYON  = ',RAYON
C      WRITE(6,*) 'NCOUCH = ',NCOUCH

      CALL ASSERT(RAYON*NCOUCH.EQ.0.D0)

C     ATTENTION, ON NE PEUT PAS TRANSFORMER NCOUCH EN RAYON EQUIVALENT 
C     ICI CAR EN CAS DE PROPAGATION AVEC PROPA_XFEM, LE RAYON EQUIVALENT
C     NE SERAIT PAS RE-ACTUALISE. IL FAUT STOCKER RAYON ET NCOUCH ET NE 
C     CALCULER LE RAYON EQUIVALENT QU'AU DERNIER MOMENT (XENRCH)
      ZR(JCARAF-1+1  ) = RAYON
      ZR(JCARAF-1+2) = NCOUCH
C
      CALL GETFAC('ORIE_FOND',IOCC)

C     ORIENTATION AUTOMATIQUE      
      IF (IOCC .EQ. 0) THEN
      
        IF (NDIM .EQ. 3) THEN
          CALL GETVTX('DEFI_FISS','FORM_FISS',1,1,1,K16BID,IOCC2)
          IF ( IOCC2 .EQ. 0 ) THEN
            CALL U2MESS('F','XFEM_20')
          ELSE
C           CONSTRUCTION AUTO DES DONNEES ORIENTATION DU FOND   
            CALL XLORIA(ZR(JCARAF-1+3),GEOFIS,DGA,NOEUD,VECT1,VECT2)
          ENDIF  
        ENDIF 

C     ORIENTATION UTILISATEUR     
      ELSEIF (IOCC .EQ. 1) THEN
      
        IF (NDIM .EQ. 2) CALL U2MESS('F','XFEM_21')
        CALL GETVR8('ORIE_FOND','PFON_INI' ,1,1,3,PFI,IBID)
        CALL GETVR8('ORIE_FOND','VECT_ORIE',1,1,3,VOR,IBID)
        CALL GETVR8('ORIE_FOND','POINT_ORIG',1,1,3,ORI,IBID)

C       NORMALISATION VECT_ORIE
        IF (NDIM .EQ. 3) THEN
          CALL NORMEV(VOR,NORME)
          IF (NORME.LT.1.D-10) CALL U2MESS('F','XFEM2_25')
        ENDIF   
         
        DO 100 I = 1,3
          ZR(JCARAF-1+2+I) = VOR(I)
          ZR(JCARAF-1+5+I) = ORI(I)
          ZR(JCARAF-1+8+I) = PFI(I)
 100    CONTINUE
 
C       INFO SUR ORIENTATION (UTILISATEUR=0, AUTO=1) 
        ZR(JCARAF-1+12) = 0.D0
        
      ELSE
      
        CALL U2MESS('F','XFEM_22')
        
      ENDIF      
C
      CALL JEDEMA()
      END
