      SUBROUTINE XVERMO(NFISS,FISS,MOD)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 10/08/2010   AUTEUR GENIAUT S.GENIAUT 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT NONE
      INTEGER      NFISS
      CHARACTER*8  FISS(NFISS),MOD
C      
C ----------------------------------------------------------------------
C
C ROUTINE XFEM (VERIFICATION DES SD)
C
C VERIFICATION QUE LES FISSURES SONT TOUTES DEFINIES A PARTIR DU MODELE
C EN ENTREE DE MODI_MODELE_XFEM
C
C ----------------------------------------------------------------------
C
C IN  NFISS  : NOMBRE DE FISSURES
C IN  FISS   : LISTE DES NOMS DES FISSURES
C IN  MOD    : NOM DU MODELE EN ENTREE DE MODI_MODELE_XFEM
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      IFISS,IB
      CHARACTER*8  MODF,VALK(3)
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
      DO 10 IFISS = 1,NFISS

C       RECUPERATION DU MODELE ASSOCIE A LA FISSURE COURANTE
        CALL DISMOI('F','NOM_MODELE',FISS(IFISS),'FISS_XFEM',IB,MODF,IB)
      
C       VERIFICATION DE LA COHERENCE
        IF (MOD.NE.MODF) THEN
          VALK(1)=FISS(IFISS)
          VALK(2)=MODF
          VALK(3)=MOD
          CALL U2MESK('F','XFEM_39',3,VALK) 
        ENDIF
      
 10   CONTINUE

      CALL JEDEMA()
      END
