      SUBROUTINE RVINVT ( TENSOR, VONM, TRES, TRAC, DETR )
      IMPLICIT NONE
      REAL*8              TENSOR(*), VONM, TRES, TRAC, DETR
C
C*********************************************************************
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF POSTRELE  DATE 23/09/2005   AUTEUR CIBHHLV L.VIVAN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C   OPERATION REALISEE
C   ------------------
C
C     CALCUL DES QUANTITES DE VON MISES ET TRESCA POUR UN TENSEUR
C     3X3 A 2 INDICE
C
C   ARGUMENT EN ENTREE
C   ------------------
C
C     TENSOR : TABLEAU REPRESENTANT LE TENSEUR SYMETRIQUE, ORGANISE
C              COMME SUIT :   XX, YY, ZZ, XY, XZ, YZ
C
C   ARGUMENT EN SORTIE
C   ------------------
C
C     VONM : QUANTITE DE VON MISES
C            VONM = (3*T(I,J)*T(I,J)/2)**0.5)
C
C     TRES : QUANTITE DE TRESCA
C            SOIT L(I) LA IEME VALEUR PROPRE DU TENSEUR
C            TRES = MAX( L(I) - L(J) )
C
C     TRAC : TRACE DU TENSEUR
C
C     DETR : DETERMINANT DU TENSEUR
C
C*********************************************************************
C
      INTEGER   I, NBVP
      REAL*8    T(6), EQUI(6), UNSUR3, R8VIDE
C
      VONM = 0.0D0
      TRES = 0.0D0
      DETR = 0.0D0
      TRAC = 0.0D0
C
      DO 10, I = 1, 6, 1
         IF ( TENSOR(I) .EQ. R8VIDE() ) THEN
            T(I) = 0.D0
         ELSE
            T(I) = TENSOR(I)
         ENDIF
 10   CONTINUE
C
      UNSUR3 = 1.0D0/3.0D0
      NBVP = 3
C
      CALL FGEQUI ( T, 'SIGM', NBVP, EQUI )
      TRES = EQUI(2)
C
      CALL RVDET3 ( T, DETR )
C
      DO 20, I = 1, 3 ,1
         TRAC = TRAC + T(I)
 20   CONTINUE
C
      DO 30, I = 1, 3 ,1
         T(I) = T(I) - TRAC*UNSUR3
 30   CONTINUE
C
      CALL RSVNMI ( T, VONM )
C
      END
