      SUBROUTINE COLELT(NBNODE, MAXNOD, NBTYMA, NBMAIL, NBNOMA, NUCONN)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 14/02/2011   AUTEUR GREFFET N.GREFFET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE GREFFET N.GREFFET
      IMPLICIT NONE
C
C      COLELT --   LECTURE DES NUMEROS DES ELEMENTS, DE LEUR TYPE,
C                  DE LEUR NUMERO DE GROUPE, DU NOMBRE DE LEURS
C                  CONNECTIVITES ET DE LEURS CONNECTIVITES
C
C   ARGUMENT        E/S  TYPE         ROLE
C    MAXNOD         IN    I         NOMBRE MAXIMUM DE NOEUDS POUR
C                                   UNE MAILLE DONNEE
C    NBTYMA         IN    I         NOMBRE  DE TYPES DE MAILLES
C    NBMAIL         OUT   I         NOMBRE TOTAL DE MAILLES
C    NBNOMA         IN    I         NOMBRE DE NOEUDS DE LA MAILLE
C                                    POUR UN TYPE DE MAILLE DONNEE
C    NUCONN         IN    I         PASSAGE DE LA NUMEROTATION DES NDS
C                                     D'UNE MAILLE : ASTER -> GMSH
C
C.========================= DEBUT DES DECLARATIONS ====================
C -----  ARGUMENTS
      INTEGER MAXNOD,NBTYMA,NBMAIL,NBNOMA(NBTYMA),NUCONN(15,32),NBNODE
C -----  VARIABLES LOCALES
           CHARACTER*8 K8BID
           LOGICAL     EXISGR
C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
      CHARACTER*32 JEXNUM
C
      INTEGER JNUMA, JTYPMA, JNBNMA, JNOMA, JNBMAG, JNBTYM, JGROMA
      INTEGER JINDMA, JDETR, IJ, ICURGR, NBGROU, INDGRO, IMA
      INTEGER ITYP, INO, NODE, I, INDMAX, JGR
C
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
C.========================= DEBUT DU CODE EXECUTABLE ==================
      CALL JEMARQ()
C
C --- INITIALISATION :
C     --------------
      K8BID   = '        '
C
C --- LECTURE DU NOMBRE D'ELEMENTS :
C     ----------------------------
      NBMAIL = NBNODE
C
C --- CREATION DE VECTEURS DE TRAVAIL :
C     -------------------------------
      CALL JEDETR('&&PRECOU.NUMERO.MAILLES')
      CALL JEDETR('&&PRECOU.TYPE.MAILLES')
CFH    CALL JEDETR('&&PRECOU.GROUPE.MAILLES')
      CALL JEDETR('&&PRECOU.NBNO.MAILLES')
      CALL JEDETR('&&PRECOU.CONNEC.MAILLES')
      CALL JEDETR('&&PRECOU.NBMA.GROUP_MA')
      CALL JEDETR('&&PRECOU.NBTYP.MAILLES')
      CALL JEDETR('&&PRECOU.LISTE.GROUP_MA')
      CALL JEDETR('&&PRECOU.INDICE.GROUP_MA')
C
C --- VECTEUR DES NUMEROS DES MAILLES
      CALL WKVECT('&&PRECOU.NUMERO.MAILLES','V V I',NBMAIL,JNUMA)
C --- VECTEUR DU TYPE DES MAILLES
      CALL WKVECT('&&PRECOU.TYPE.MAILLES','V V I',  NBMAIL,JTYPMA)
C --- VECTEUR DU NUMERO DE GROUPE DES MAILLES
CFH      CALL WKVECT('&&PRECOU.GROUPE.MAILLES','V V I',NBMAIL,JGROMA)
      CALL JEVEUO('&&PRECOU.GROUPE.MAILLES','L',JGROMA)
C --- VECTEUR DU NOMBRE DE CONNECTIVITES DES MAILLES
      CALL WKVECT('&&PRECOU.NBNO.MAILLES','V V I',  NBMAIL,JNBNMA)
C --- VECTEUR DES CONNECTIVITES DES MAILLES
      CALL WKVECT('&&PRECOU.CONNEC.MAILLES','V V I',MAXNOD*NBMAIL,JNOMA)
C --- VECTEUR DU NOMBRE DE MAILLES POUR UN GROUPE DE MAILLES
      CALL WKVECT('&&PRECOU.NBMA.GROUP_MA','V V I', NBMAIL,JNBMAG)
C --- VECTEUR DU NOMBRE DE MAILLES PAR TYPE DE MAILLES
      CALL WKVECT('&&PRECOU.NBTYP.MAILLES','V V I', NBTYMA,JNBTYM)
C --- CREATION DU VECTEUR FAISANT CORRESPONDRE LES INDICES AUX
C --- NUMEROS DES GROUPES DE MAILLES :
      CALL WKVECT('&&PRECOU.INDICE.GROUP_MA','V V I',NBMAIL,JINDMA)
C --- INDICATION DE DESTRUCTION DES NOEUDS
      CALL JEVEUO('&&PRECOU.DETR.NOEUDS','E',JDETR)
C
C
C --- LECTURE DES ENREGISTREMENTS RELATIFS AUX MAILLES ET AFFECTATION
C --- DES VECTEURS DE TRAVAIL :
C     -----------------------
      IJ     = 0
      
C --- ICURGR : NUMERO DU GROUPE COUPLE
C     NBGROU : NBRE DE GROUPES TROUVES
C     INDGRO : INDICE DU GROUPE
      ICURGR = 0
      NBGROU = 0
      INDGRO = 0
      DO 10 IMA = 1, NBMAIL
C
C NUMERO DE LA MAILLE
        ZI(JNUMA  - 1 + IMA)  = IMA
C TYPE DE LA MAILLE (TOUJOURS UN POINT)
        ZI(JTYPMA - 1 + IMA)  = 15
C NOMBRE DE NOEUDS PAR MAILLE (TOUJOURS UN POINT)
        ZI(JNBNMA - 1 + IMA)  = 1
C NUMERO DES NOEUDS DE LA MAILLE (TOUJOURS UN POINT)
        ZI(JNOMA  - 1 + IJ+1) = IMA
C
C      INDICATION DES NOEUDS QUI NE SONT PAS ORPHELINS
        ITYP = ZI(JTYPMA+IMA-1)
        DO 12 INO = 1,NBNOMA(ITYP)
          NODE = ZI(JNOMA+IJ+NUCONN(ITYP,INO)-1)
          ZI(JDETR+NODE) = 1
 12     CONTINUE

        IF (ICURGR.NE.ZI(JGROMA+IMA-1)) THEN
          ICURGR = ZI(JGROMA+IMA-1)
          EXISGR = .FALSE.
          DO 20 I = 1, NBGROU
C CAS_VIV ICURGR=0 et ZI(JINDMA+I-1)=1
            IF (ICURGR.EQ.ZI(JINDMA+I-1)) THEN
              EXISGR = .TRUE.
              INDGRO = I
              GOTO 30
            ENDIF
  20      CONTINUE
  30      CONTINUE
          IF (.NOT.EXISGR) THEN
            NBGROU = NBGROU + 1
            INDGRO = NBGROU
            ZI(JINDMA+INDGRO-1) = ZI(JGROMA+IMA-1)
          ENDIF
        ENDIF
CMH
        INDGRO = 1
CMH
        ZI(JNBMAG+INDGRO-1) = ZI(JNBMAG+INDGRO-1) + 1
      
        IJ = IJ + ZI(JNBNMA+IMA-1)
        ZI(JNBTYM+ZI(JTYPMA+IMA-1)-1) = ZI(JNBTYM+ZI(JTYPMA+IMA-1)-1)+1
  10  CONTINUE
C
      INDMAX = NBGROU
CMH
C      INDMAX = 1
CMH
      CALL JEECRA('&&PRECOU.INDICE.GROUP_MA','LONUTI',INDMAX,K8BID)
C
C --- CREATION DE LA COLLECTION DES GROUPES DE MAILLES :
C     ------------------------------------------------
      CALL JECREC('&&PRECOU.LISTE.GROUP_MA','V V I','NU','CONTIG',
     +            'VARIABLE',INDMAX)
      CALL JEECRA('&&PRECOU.LISTE.GROUP_MA','LONT',NBMAIL,K8BID)
C
      DO 40 I = 1, INDMAX
          CALL JEECRA(JEXNUM('&&PRECOU.LISTE.GROUP_MA',I),
     +               'LONMAX',ZI(JNBMAG+I-1),K8BID)
          ZI(JNBMAG+I-1) = 0
  40  CONTINUE
C
C --- AFFECTATION DES OBJETS RELATIFS AUX GROUPES DE MAILLES :
C     ------------------------------------------------------
C --- ICURGR : NUMERO DU GROUPE COUPLE
C     NBGROU : NBRE DE GROUPES TROUVES
C     INDGRO : INDICE DU GROUPE
      ICURGR = 0
      NBGROU = 0
      INDGRO = 0
      DO 50 IMA = 1, NBMAIL
        IF (ICURGR.NE.ZI(JGROMA+IMA-1)) THEN
          ICURGR = ZI(JGROMA+IMA-1)
          EXISGR = .FALSE.
          DO 60 I = 1, NBGROU
            IF (ICURGR.EQ.ZI(JINDMA+I-1)) THEN
              EXISGR = .TRUE.
              INDGRO = I
              GOTO 70
            ENDIF
  60      CONTINUE
  70      CONTINUE
          IF (.NOT.EXISGR) THEN
            NBGROU = NBGROU + 1
            INDGRO = NBGROU
          ENDIF
        ENDIF
CMH
C	INDGRO = 1
CMH	
        ZI(JNBMAG+INDGRO-1) = ZI(JNBMAG+INDGRO-1) + 1
C
        ZI(JINDMA+INDGRO-1) = ZI(JGROMA+IMA-1)
        CALL JEVEUO(JEXNUM('&&PRECOU.LISTE.GROUP_MA',INDGRO),'E',JGR)
        ZI(JGR+ZI(JNBMAG+INDGRO-1)-1) = ZI(JNUMA+IMA-1)
  50  CONTINUE
C
      CALL JEDEMA()
C
C.============================ FIN DE LA ROUTINE ======================
      END
