      SUBROUTINE FGDOMG(METHOD,NOMMAT,NOMNAP,NOMFON,VALMIN,
     &                  VALMAX,NCYC,DOMMAG)
C       ================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
C
      CHARACTER*(*)      METHOD
      CHARACTER*8        NOMMAT,NOMNAP,NOMFON
      REAL*8             VALMIN(*),VALMAX(*),DOMMAG
      INTEGER            NCYC
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 26/11/2007   AUTEUR ANGLES J.ANGLES 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C       ----------------------------------------------------------------
C       CALCUL DU DOMMAGE PAR DIFFERENTES METHODES
C       ----------------------------------------------------------------
C       IN  METHOD  METHODE DE CALCUL  DE DOMMAGE EMPLOYEE
C                       /WOHLER
C                       /MANSON_COFFIN
C                       /TAHERI_MANSON
C                       /TAHERI_MIXTE
C           NOMMAT  NOM DU CHAM_MATER
C           NOMNAP  NOM DE LA NAPPE POUR LOI DE TAHERI
C           NOMFON  NOM DE LA FONCTION POUR LOI DE TAHERI
C           CYCLE   TABLE DES CYCLES DETECTES (INDICES DEB ET FIN)
C           NCYC    NOMBRE  DE  CYCLE
C       OUT DOMMAG  VALEUR DU DOMMAGE
C       ----------------------------------------------------------------
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
      CHARACTER*2   CODWO,CODBA,CODHS
      CHARACTER*8   CARA
      CHARACTER*10  PHENO
      CHARACTER*16  K16B
      LOGICAL       LKE,LHAIGH
C
      DOMMAG = 0.D0
      PHENO = 'FATIGUE'
      CALL WKVECT ('&&FGDOMG.DOMMAG','V V R',NCYC,IVDOME)
      LKE    = .FALSE.
      LHAIGH = .FALSE.
      IVKE   = 0
      IVCORR = 0
C
      IF(METHOD.EQ.'WOHLER') THEN
        CARA = 'WOHLER'
        CALL RCPARE(NOMMAT,PHENO,CARA,CODWO)
        CARA = 'A_BASQUI'
        CALL RCPARE(NOMMAT,PHENO,CARA,CODBA)
        CARA = 'A0'
        CALL RCPARE(NOMMAT,PHENO,CARA,CODHS)
        IF(CODWO.EQ.'OK') THEN
          CALL FGDOWH(NOMMAT,NCYC,VALMIN,VALMAX,LKE,
     &          ZR(IVKE),LHAIGH,ZR(IVCORR),ZR(IVDOME))
        ELSEIF(CODBA.EQ.'OK') THEN
          CALL FGDOBA(NOMMAT,NCYC,VALMIN,VALMAX,
     &               LKE,ZR(IVKE),LHAIGH,ZR(IVCORR),ZR(IVDOME))
        ELSEIF(CODHS.EQ.'OK') THEN
          CALL FGDOHS(NOMMAT,NCYC,VALMIN,VALMAX,LKE,
     &               ZR(IVKE),LHAIGH,ZR(IVCORR),ZR(IVDOME))
        ENDIF
      ELSEIF(METHOD.EQ.'MANSON_COFFIN') THEN
        CALL FGDOMA(NOMMAT,NCYC,VALMIN,VALMAX,ZR(IVDOME))
      ELSEIF(METHOD.EQ.'TAHERI_MANSON') THEN
        CALL FGTAEP(NOMMAT,NOMFON,NOMNAP,NCYC,VALMIN,
     &                VALMAX,ZR(IVDOME))
      ELSEIF(METHOD.EQ.'TAHERI_MIXTE') THEN
        CALL FGTAES(NOMMAT,NOMNAP,NCYC,VALMIN,VALMAX,
     &                ZR(IVDOME))
      ELSE
        K16B = METHOD(1:16)
        CALL U2MESK('F','PREPOST_4',1,K16B)
      ENDIF
C
      DO 100 I=1,NCYC
        DOMMAG = DOMMAG + ZR(IVDOME+I-1)
  100 CONTINUE
C
      CALL JEDETR('&&FGDOMG.DOMMAG')
      END
