      SUBROUTINE FGTAHE(KDOMM,NBCYCL,EPSMIN,EPSMAX,DOM)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*(*)     KDOMM
      REAL*8                   EPSMIN(*),EPSMAX(*)
      REAL*8                   DOM(*)
      INTEGER                  NBCYCL
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 21/09/2009   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C     -----------------------------------------------------------------
C     ROUTINE CHAPEAU POUR LE CALCUL DU DOMMAGE PAR LOIS DE TAHERI
C     ------------------------------------------------------------------
C IN  KDOMM  : K   : LOI DE DOMMAGE TAHERI_MANSON/TAHERI_MIXTE
C IN  NBCYCL : I   : NOMBRE DE CYCLES
C IN  EPSMIN : R   : DEFORMATIONS MINIMALES DES CYCLES
C IN  EPSMAX : R   : DEFORMATIONS MAXIMALES DES CYCLES
C OUT DOM    : R   : VALEURS DES DOMMAGES ELEMENTAIRES
C     ------------------------------------------------------------------
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER          ZI
      COMMON  /IVARJE/ ZI(1)
      REAL*8           ZR
      COMMON  /RVARJE/ ZR(1)
      COMPLEX*16       ZC
      COMMON  /CVARJE/ ZC(1)
      LOGICAL          ZL
      COMMON  /LVARJE/ ZL(1)
      CHARACTER*8      ZK8
      CHARACTER*16            ZK16
      CHARACTER*24                    ZK24
      CHARACTER*32                            ZK32
      CHARACTER*80                                    ZK80
      COMMON  /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
C
C
      CHARACTER*2   CODWO,CODMA,CODBA,CODHS,CODRET(3)
      CHARACTER*8   NOMMAT,NOMFO1,NOMNAP,CARA
      CHARACTER*16  PHENO,PHENOM
C
      CALL JEMARQ()
C
C --- CALCUL DU DOMMAGE ELEMENTAIRE DE TAHERI_MANSON_COFFIN
C
      IF(KDOMM(1:13).EQ.'TAHERI_MANSON') THEN
        CALL GETVID(' ','MATER',1,1,0,NOMMAT,NBVAL)
        IF(NBVAL.EQ.0) CALL U2MESS('F','FATIGUE1_8')
        CALL GETVID(' ','TAHERI_FONC',1,1,0,NOMFO1,NBVAL)
        IF(NBVAL.EQ.0) CALL U2MESS('F','FATIGUE1_9')
        CALL GETVID(' ','TAHERI_NAPPE',1,1,0,NOMNAP,NBVAL)
        IF(NBVAL.EQ.0) CALL U2MESS('F','FATIGUE1_10')
        CALL GETVID(' ','MATER',1,1,1,NOMMAT,NBVAL)
        PHENO = 'FATIGUE'
        CALL RCCOME (NOMMAT,PHENO,PHENOM,CODRET(1))
        IF(CODRET(1).EQ.'NO') CALL U2MESS('F','FATIGUE1_24')
        CARA = 'MANSON_C'
        CALL RCPARE(NOMMAT,PHENO,CARA,CODMA)
        IF(CODMA.NE.'OK') THEN
          CALL U2MESS('F','FATIGUE1_11')
        ENDIF
        CALL GETVID(' ','TAHERI_FONC',1,1,1,NOMFO1,NBVAL)
        CALL GETVID(' ','TAHERI_NAPPE',1,1,1,NOMNAP,NBVAL)
        CALL FGTAEP(NOMMAT,NOMFO1,NOMNAP,NBCYCL,EPSMIN,EPSMAX,
     &      DOM)
      ENDIF
C
C --- CALCUL DU DOMMAGE ELEMENTAIRE DE TAHERI_MIXTE
C
      IF(KDOMM(1:14).EQ.'TAHERI_MIXTE') THEN
        CALL GETVID(' ','MATER',1,1,0,NOMMAT,NBVAL)
        IF(NBVAL.EQ.0) CALL U2MESS('F','FATIGUE1_12')
        CALL GETVID(' ','TAHERI_NAPPE',1,1,0,NOMNAP,NBVAL)
        IF(NBVAL.EQ.0) CALL U2MESS('F','FATIGUE1_10')
        CALL GETVID(' ','MATER',1,1,1,NOMMAT,NBVAL)
        PHENO = 'FATIGUE'
        CALL RCCOME (NOMMAT,PHENO,PHENOM,CODRET(1))
        IF(CODRET(1).EQ.'NO') CALL U2MESS('F','FATIGUE1_24')
        CARA = 'MANSON_C'
        CALL RCPARE(NOMMAT,PHENO,CARA,CODMA)
        CARA = 'WOHLER'
        CALL RCPARE(NOMMAT,PHENO,CARA,CODWO)
        CARA = 'A_BASQUI'
        CALL RCPARE(NOMMAT,PHENO,CARA,CODBA)
        CARA = 'A0'
        CALL RCPARE(NOMMAT,PHENO,CARA,CODHS)
        IF(CODMA.NE.'OK') THEN
          CALL U2MESS('F','FATIGUE1_13')
        ENDIF
        IF(CODWO.NE.'OK'.AND.CODBA.NE.'OK'.AND.CODHS.NE.'OK') THEN
          CALL U2MESS('F','FATIGUE1_14')
        ENDIF
        CALL GETVID(' ','TAHERI_NAPPE',1,1,1,NOMNAP,NBVAL)
        CALL FGTAES(NOMMAT,NOMNAP,NBCYCL,EPSMIN,EPSMAX,DOM)
      ENDIF
C
      CALL JEDEMA()
      END
