      SUBROUTINE GILIG0 ( NFIC, NBOBLU, NBOBNO, NBOBO, NIV )
      IMPLICIT   NONE
      INTEGER    NFIC, NBOBLU, NBOBNO, NBOBO, NIV
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 29/09/2006   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
C     BUT: LIRE LES N LIGNES DES POINTS DU MAILLAGE GIBI :
C                 ( PROCEDURE SAUVER)
C
C     IN: NFIC   : UNITE DE LECTURE
C
C ----------------------------------------------------------------------
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX --------------------
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX --------------------
C
      INTEGER       IAOBNO, IAOBNU, NBFOIS, NBREST, ICOJ, I, J,
     &              IANOOB, IADSOB, IACUEL, NBNOM, NBNUM, NBELE
C     ------------------------------------------------------------------
C
      CALL JEMARQ()
C
      IF ( NIV .EQ. 3 ) THEN
         NBNOM =  8
         NBNUM = 16
      ELSE
         NBNOM =  8
         NBNUM = 10
      ENDIF
      NBOBO = NBOBLU
      IF ( NBOBO .GT. 99999) THEN
        CALL U2MESS('F','PREPOST_57')
      ENDIF
C
C     --- ON LIT LES OBJETS NOMMES:
C
      CALL WKVECT ( '&&GILIRE.OBJET_NOM', 'V V K8', NBOBNO, IAOBNO )
      CALL WKVECT ( '&&GILIRE.OBJET_NUM', 'V V I' , NBOBNO, IAOBNU )
C
      NBFOIS = NBOBNO / NBNOM
      NBREST = NBOBNO - NBNOM*NBFOIS
      ICOJ = 0
      DO 10 I = 1 , NBFOIS
         READ(NFIC,1007) (ZK8(IAOBNO-1+J),J=ICOJ+1,ICOJ+NBNOM)
         ICOJ = ICOJ + NBNOM
 10   CONTINUE
      IF ( NBREST .GT. 0 ) THEN
         READ(NFIC,1007) (ZK8(IAOBNO-1+J),J=ICOJ+1,ICOJ+NBREST)
      ENDIF
C
      NBFOIS = NBOBNO / NBNUM
      NBREST = NBOBNO - NBNUM*NBFOIS
      ICOJ = 0
      DO 12 I = 1 , NBFOIS
         IF ( NIV .EQ. 3 ) THEN
            READ(NFIC,1009) (ZI(IAOBNU-1+J),J=ICOJ+1,ICOJ+NBNUM)
         ELSE
            READ(NFIC,1008) (ZI(IAOBNU-1+J),J=ICOJ+1,ICOJ+NBNUM)
         ENDIF
            ICOJ = ICOJ + NBNUM
 12   CONTINUE
      IF ( NBREST .GT. 0 ) THEN
         IF ( NIV .EQ. 3 ) THEN
            READ(NFIC,1009) (ZI(IAOBNU-1+J),J=ICOJ+1,ICOJ+NBREST)
         ELSE
            READ(NFIC,1008) (ZI(IAOBNU-1+J),J=ICOJ+1,ICOJ+NBREST)
         ENDIF
      ENDIF
C
C     -- ON CREE L'OBJET .NOMOBJ QUI CONTIENDRA 2 K8 POUR CHAQUE OBJET:
C        1--> 'OBJNPQ' : SUFFIXE POUR LES OBJETS JEVEUX CREES DS GILIOB
C        2--> '      ' (OU TYPE_MAILLE ( SEG2,CUB8,...) )
C
      CALL WKVECT ( '&&GILIRE.NOMOBJ', 'V V K8', 2*NBOBO, IANOOB )
C
C     -- ON CREE L'OBJET .DESCOBJ
C        QUI CONTIENDRA 4 ENTIER POUR CHAQUE OBJET:
C        1--> NBSOOB : NOMBRE DE SOUS-OBJETS DE L'OBJET.
C        2--> NBREF  : NOMBRE DE REFERENCES.
C        3--> NBNO   : NOMBRE DE NOEUD DU TYPE_MAILLE.
C        4--> NBELEM : NOMBRE DE MAILLES DANS L'OGJET.
C
      CALL WKVECT ( '&&GILIRE.DESCOBJ', 'V V I', 4*NBOBO, IADSOB )
C
C     -- ON CREE L'OBJET .CUMUL_ELE
C        QUI CONTIENDRA 1 ENTIER POUR CHAQUE OBJET:
C        1--> ICUEL  : NOMBRE CUMULE DES MAILLES CONTENUES DANS LES
C             OBJETS DE NUMEROS INFERIEURS A IOBJ.
C
      CALL WKVECT ( '&&GILIRE.CUMUL_ELE', 'V V I', NBOBO+1, IACUEL )
C
C
      ZI(IACUEL-1+1) = 0
      DO 20 I = 1 , NBOBO
         CALL GILIO2 ( NFIC, I, NBELE, NIV )
         ZI(IACUEL-1+I+1) = ZI(IACUEL-1+I) + NBELE
 20   CONTINUE
C
 1007  FORMAT ( 8(1X,A8) )
 1008  FORMAT ( 1X,10(I7,1X) )
 1009  FORMAT ( 16(1X,I4) )
C
      CALL JEDEMA()
C
      END
