      SUBROUTINE IRMAEN(IFIEN,NOMA,NDIM,NNO,COORDO,NBMA,CONNEX,
     &     NOMAI,NONOE,POINT,TYPMA,TYPEL,NOMAEN,PERMUT,
     &     MAXNOD,LMOD,LMASU,NBGRM,NOGM)
      IMPLICIT REAL*8 (A-H,O-Z)
C
      INTEGER     IFIEN,NDIM,NNO,NBMA,MAXNOD,NBGRM
      INTEGER     CONNEX(*),POINT(*),TYPMA(*),TYPEL(*),PERMUT(MAXNOD,*)
      CHARACTER*8 NOMA,NOMAI(*),NONOE(*),NOMAEN(*),NOGM(*)
      REAL*8      COORDO(*)
      LOGICAL     LMASU,LMOD
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 19/10/2010   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C--------------------------------------------------------------------
C BUT :   ECRITURE DU MAILLAGE SUR FICHIER GEOMETRIE ENSIGHT
C     ENTREE:
C       NOMA   : NOM DU MAILLAGE A IMPRIMER
C       IFIEN  : NUMERO D'UNITE LOGIQUE ASSOCIE AU FICHIER GEOMETRIE
C       NDIM   : DIMENSION DU PROBLEME (2  OU 3)
C       NNO    : NOMBRE DE NOEUDS DU MAILLAGE
C       COORDO : VECTEUR DES COORDONNEES DES NOEUDS
C       NBMA   : NOMBRE DE MAILLES DU MAILLAGE
C       CONNEX : CONNECTIVITES
C       NOMAI  : NOMS DES MAILLES
C       NONOE  : NOMS DES NOEUDS
C       POINT  : POINTEUR DANS LES CONNECTIVITES
C       TYPMA  : TYPES DES MAILLES
C       TYPEL  : TYPES DES ELEMENTS FINIS AFFECTES AUX MAILLES
C       NOMAEN : TABLEAU DIMENSIONNE AU NOMBRE DE TYPES DE MAILLES ASTER
C                DONNANT LE NOM ENSIGHT DES MAILLES
C                (NOM='NONEXIST' SI LA MAILLE N'EXISTE PAS DANS ENSIGHT)
C       PERMUT : TABLEAU DIMENSIONNE AU NOMBRE DE TYPES DE MAILLES ASTER
C                DONNANT LES PERMUTATIONS DES NOEUDS DE CHAQUE MAILLE
C                POUR LA RENUMEROTATION DANS ENSIGHT
C       MAXNOD : NOMBRE MAXI DE NOEUDS POUR UN TYPE_MAILLE
C       LMOD   : LOGIQUE INDIQUANT SI IMPRESSION MODELE OU MAILLAGE
C       LMASU  : LOGIQUE INDIQUANT SI MAILLAGE ISSU D'I-DEAS
C       GROUPES DE MAILLES:
C         NBGRM: NOMBRE DE GROUPES DE MAILLES
C         NOGM : NOM DES GROUPES DE MAILLES
C
C     ----------- COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER           ZI
      COMMON / IVARJE / ZI(1)
      REAL*8            ZR
      COMMON / RVARJE / ZR(1)
      COMPLEX*16        ZC
      COMMON / CVARJE / ZC(1)
      LOGICAL           ZL
      COMMON / LVARJE / ZL(1)
      CHARACTER*8       ZK8
      CHARACTER*16              ZK16
      CHARACTER*24                       ZK24
      CHARACTER*32                                ZK32
      CHARACTER*80                                         ZK80
      COMMON / KVARJE / ZK8(1), ZK16(1), ZK24(1), ZK32(1), ZK80(1)
      CHARACTER*32 JEXNUM,JEXNOM
C     ------------------------------------------------------------------
      REAL*8  R(3),BIDON,RCSF
      INTEGER NODENS(32),NODAST(32),LGNOGM
      CHARACTER*8 KBID,NOMAST,NOMENS
C     - COMPTEURS POUR CONNAITRE LE NOMBRE DE MAILLES DE CHAQUE TYPE
C       ENSIGHT, POUR LE MAILLAGE (NBMATY), LES GPES DE MAILLES (NMTGM)
      PARAMETER (NBTYME=11)
      INTEGER NBMATY(NBTYME),NBMTGM(NBTYME),NBMTMX
C     - NOMS DES TYPES DE MAILLES ENSIGHT, NBRE DE NOEUDS/MAILLE ASSOCIE
      LOGICAL LPEN15,LQUAD9,LTRIA7
      CHARACTER*8 NOTYMA(NBTYME)
      DATA NOTYMA/'bar2','bar3','tria3','tria6','quad4','quad8',
     &            'tetra4','tetra10','hexa8','hexa20','penta6'/
C     - LES PENTA15 SONT REDUITS A DES PENTA6, LES QUAD9 A DES QUAD8
C ---------------------------------------------------------------------
C
C     --- ECRITURE DES COORDONNEES DES NOEUDS
      CALL JEMARQ()
      LTRIA7=.FALSE.
      LQUAD9=.FALSE.
      LPEN15=.FALSE.
      NDIM=3
      WRITE(IFIEN,'(A)') 'node id given'
      WRITE(IFIEN,'(A)') 'element id given'
      WRITE(IFIEN,'(A)') 'coordinates'
      WRITE(IFIEN,'(I8)') NNO
      DO 5 I=1,NNO
C       - ON ECRIT QUOIQU'IL ARRIVE 3 COORDONNEES
        DO 6 M=1,NDIM
          R(M)=COORDO(3*(I-1)+M)
    6   CONTINUE
C       - RECUPERATION DU NUMERO DU NOEUD
        IF(LMASU) THEN
          CALL LXLIIS(NONOE(I)(3:8),INO,IER)
        ELSE
          INO=I
        ENDIF
        WRITE(IFIEN,'(I8,3(1PE12.5))') INO,(R(ICOOR), ICOOR=1,NDIM)
    5 CONTINUE
C
C     --- PREPARATION DE L'ECRITURE DES MAILLES :
C         * MESSAGE D'ERREUR SI MAILLE NON DISPONIBLE DANS ENSIGHT
C         * DECOMPTE DU NOMBRE DE MAILLES DE CHAQUE TYPE ENSIGHT
C         * ALLOCATION OBJET DE TAILLE NBTYME*NBMAX_MAILLES_DE_MEME_TYPE
C         * PUIS TRI DES MAILLES SUIVANT LEUR TYPE DANS L'ORDRE
C           DE NOTYMA (ON DEFINIT LE TABLEAU '&&IRMAEN.TRIMAI')
      DO 7 I=1,NBTYME
        NBMATY(I)=0
    7 CONTINUE
      DO 10 IMA=1,NBMA
C       - RECUPERATION DU TYPE DE LA MAILLE ET DE SON NOMBRE DE NOEUDS
        ITYPE=TYPMA(IMA)
        IPOIN=POINT(IMA)
        NNOE=POINT(IMA+1)-IPOIN
C       - SI LMOD=.TRUE. ALORS IMPRESSION DU MODELE
C         => ON REGARDE SI UN ELEMENT FINI EST AFFECTE A LA MAILLE
C         => SI OUI LA MAILLE SERA IMPRIMEE SINON ELLE SERA IGNOREE
        IF ( LMOD ) THEN
           IF ( TYPEL(IMA) .EQ. 0 ) GOTO 10
        ENDIF
        NOMENS=NOMAEN(ITYPE)
        IF(NOMENS.EQ.'NONEXIST') THEN
          IF(NNOE.EQ.1) THEN
            CALL U2MESS('A','PREPOST2_71')
          ELSE
            CALL JENUNO(JEXNUM('&CATA.TM.NOMTM',ITYPE),NOMAST)
            CALL U2MESK('A','PREPOST2_72',1,NOMAST)
          ENDIF
        ELSEIF(NOMENS.EQ.'bar2') THEN
          NBMATY( 1)=NBMATY( 1)+1
        ELSEIF(NOMENS.EQ.'bar3') THEN
          NBMATY( 2)=NBMATY( 2)+1
        ELSEIF(NOMENS.EQ.'tria3') THEN
          NBMATY( 3)=NBMATY( 3)+1
C        ELSEIF(NOMENS.EQ.'tria6') THEN
        ELSEIF((NOMENS.EQ.'tria6').OR.(NOMENS.EQ.'tria7')) THEN
          NBMATY( 4)=NBMATY( 4)+1
          IF(NOMENS.EQ.'tria7') LTRIA7=.TRUE.
        ELSEIF(NOMENS.EQ.'quad4') THEN
          NBMATY( 5)=NBMATY( 5)+1
        ELSEIF((NOMENS.EQ.'quad8').OR.(NOMENS.EQ.'quad9')) THEN
          NBMATY( 6)=NBMATY( 6)+1
          IF(NOMENS.EQ.'quad9') LQUAD9=.TRUE.
        ELSEIF(NOMENS.EQ.'tetra4') THEN
          NBMATY( 7)=NBMATY( 7)+1
        ELSEIF(NOMENS.EQ.'tetra10') THEN
          NBMATY( 8)=NBMATY( 8)+1
        ELSEIF(NOMENS.EQ.'hexa8') THEN
          NBMATY( 9)=NBMATY( 9)+1
        ELSEIF(NOMENS.EQ.'hexa20') THEN
          NBMATY(10)=NBMATY(10)+1
        ELSEIF((NOMENS.EQ.'penta6').OR.(NOMENS.EQ.'penta15')) THEN
          NBMATY(11)=NBMATY(11)+1
          IF(NOMENS.EQ.'penta15') LPEN15=.TRUE.
        ENDIF
   10 CONTINUE
      IF(LTRIA7) THEN
        CALL U2MESS('A','PREPOST2_73')
      ENDIF
      IF(LQUAD9) THEN
        CALL U2MESS('A','PREPOST2_74')
      ENDIF
      IF(LPEN15) THEN
        CALL U2MESS('A','PREPOST2_75')
      ENDIF
      NBMTMX=NBMATY(1)
      DO 11 I=2,NBTYME
        IF(NBMATY(I).GT.NBMTMX) THEN
          NBMTMX=NBMATY(I)
        ENDIF
   11 CONTINUE
C
C     --- DESTRUCTION ET ALLOCATION DE ZONES DE TRAVAIL
C         LE NOMBRE MAX DE MAILLES DE MEME TYPE EST EN FIN DE VECTEUR
      CALL JEEXIN('&&IRMAEN.TRIMAI',IRET)
      IF(IRET.NE.0) CALL JEDETR('&&IRMAEN.TRIMAI')
      CALL WKVECT('&&IRMAEN.TRIMAI','V V I',NBMTMX*NBTYME+1,JTRIMA)
      CALL JEVEUO('&&IRMAEN.TRIMAI','E',JTRIMA)
      ZI(JTRIMA-1+NBMTMX*NBTYME+1)=NBMTMX
      ITRI1 =0
      ITRI2 =0
      ITRI3 =0
      ITRI4 =0
      ITRI5 =0
      ITRI6 =0
      ITRI7 =0
      ITRI8 =0
      ITRI9 =0
      ITRI10=0
      ITRI11=0
      DO 12 IMA=1,NBMA
        ITYPE=TYPMA(IMA)
        IF ( LMOD ) THEN
           IF ( TYPEL(IMA) .EQ. 0 ) GOTO 12
        ENDIF
        NOMENS=NOMAEN(ITYPE)
        IF(NOMENS.NE.'NONEXIST') THEN
          IF(NOMENS.EQ.'bar2') THEN
            ITRI1 =ITRI1 +1
            ZI(JTRIMA-1+ 0*NBMTMX+ITRI1 )=IMA
          ELSEIF(NOMENS.EQ.'bar3') THEN
            ITRI2 =ITRI2 +1
            ZI(JTRIMA-1+ 1*NBMTMX+ITRI2 )=IMA
          ELSEIF(NOMENS.EQ.'tria3') THEN
            ITRI3 =ITRI3 +1
            ZI(JTRIMA-1+ 2*NBMTMX+ITRI3 )=IMA
C          ELSEIF(NOMENS.EQ.'tria6') THEN
          ELSEIF((NOMENS.EQ.'tria6').OR.(NOMENS.EQ.'tria7')) THEN
            ITRI4 =ITRI4 +1
            ZI(JTRIMA-1+ 3*NBMTMX+ITRI4 )=IMA
          ELSEIF(NOMENS.EQ.'quad4') THEN
            ITRI5 =ITRI5 +1
            ZI(JTRIMA-1+ 4*NBMTMX+ITRI5 )=IMA
          ELSEIF((NOMENS.EQ.'quad8').OR.(NOMENS.EQ.'quad9')) THEN
            ITRI6 =ITRI6 +1
            ZI(JTRIMA-1+ 5*NBMTMX+ITRI6 )=IMA
          ELSEIF(NOMENS.EQ.'tetra4') THEN
            ITRI7 =ITRI7 +1
            ZI(JTRIMA-1+ 6*NBMTMX+ITRI7 )=IMA
          ELSEIF(NOMENS.EQ.'tetra10') THEN
            ITRI8 =ITRI8 +1
            ZI(JTRIMA-1+ 7*NBMTMX+ITRI8 )=IMA
          ELSEIF(NOMENS.EQ.'hexa8') THEN
            ITRI9 =ITRI9 +1
            ZI(JTRIMA-1+ 8*NBMTMX+ITRI9 )=IMA
          ELSEIF(NOMENS.EQ.'hexa20') THEN
            ITRI10=ITRI10+1
            ZI(JTRIMA-1+ 9*NBMTMX+ITRI10)=IMA
          ELSEIF((NOMENS.EQ.'penta6').OR.(NOMENS.EQ.'penta15')) THEN
            ITRI11=ITRI11+1
            ZI(JTRIMA-1+10*NBMTMX+ITRI11)=IMA
          ENDIF
        ENDIF
   12 CONTINUE
C
C     --- ECRITURE DES CONNECTIVITES
C
C     - ECRITURE D'UNE PREMIERE PART CONTENANT TOUS LES ELEMENTS DEFINIS
      WRITE(IFIEN,'(A)') 'part 1'
      WRITE(IFIEN,'(A)') 'TOUS LES ELEMENTS DU MAILLAGE '//NOMA
      CALL JEVEUO('&&IRMAEN.TRIMAI','L',JTRIMA)
      DO 16 ITYENS=1,NBTYME
        IF(NBMATY(ITYENS).NE.0) THEN
          WRITE(IFIEN,'(A)') NOTYMA(ITYENS)
          WRITE(IFIEN,'(I8)') NBMATY(ITYENS)
          DO 20 I=1,NBMATY(ITYENS)
            IMA=ZI(JTRIMA-1+ (ITYENS-1)*NBMTMX+I)
            ITYPE=TYPMA(IMA)
            IPOIN=POINT(IMA)
            NNOE=POINT(IMA+1)-POINT(IMA)
C           - PERMUTATION EVENTUELLE DES NOEUDS
            DO 21 J=1,NNOE
              NODAST(J)=CONNEX(IPOIN-1+J)
              IENS=PERMUT(J,ITYPE)
              NODENS(IENS)=NODAST(J)
   21       CONTINUE
C           - RECHERCHE DES NUMEROS DE LA MAILLE ET DES NOEUDS
            IF(LMASU) THEN
              CALL LXLIIS(NOMAI(IMA)(3:8),IMAE,IER)
              DO 22 J=1,NNOE
                CALL LXLIIS(NONOE(NODENS(J))(3:8),NODENS(J),IER)
   22         CONTINUE
            ELSE
              IMAE = IMA
            ENDIF
            IF(ITYENS.EQ.1) THEN
              WRITE(IFIEN,'(3I8)')  IMAE,(NODENS(K),K=1,2)
            ELSEIF((ITYENS.EQ.2).OR.(ITYENS.EQ.3)) THEN
              WRITE(IFIEN,'(4I8)')  IMAE,(NODENS(K),K=1,3)
            ELSEIF((ITYENS.EQ.5) .OR.(ITYENS.EQ.7)) THEN
              WRITE(IFIEN,'(5I8)')  IMAE,(NODENS(K),K=1,4)
            ELSEIF((ITYENS.EQ.4) .OR.(ITYENS.EQ.11)) THEN
C            - LES PENTA15 EVENTUELS SONT REDUITS A DES PENTA6
C              EN N'ECRIVANT QUE LES NOEUDS SOMMETS (LES 6 1ERS)
              WRITE(IFIEN,'(7I8)')  IMAE,(NODENS(K),K=1,6)
            ELSEIF((ITYENS.EQ.6) .OR.(ITYENS.EQ.9)) THEN
C            - LES QUAD9 EVENTUELS SONT REDUITS A DES QUAD8
C              EN N'ECRIVANT QUE LES NOEUDS SOMMETS (LES 8 1ERS)
              WRITE(IFIEN,'(9I8)')  IMAE,(NODENS(K),K=1,8)
            ELSEIF(ITYENS.EQ.8) THEN
              WRITE(IFIEN,'(11I8)') IMAE,(NODENS(K),K=1,10)
            ELSEIF(ITYENS.EQ.10) THEN
              WRITE(IFIEN,'(21I8)') IMAE,(NODENS(K),K=1,20)
            ENDIF
   20     CONTINUE
        ENDIF
   16 CONTINUE
      CALL JEDETR('&&IRMAEN.TRIMAI')
C
C     --- TRAITEMENT DES GROUPES DE MAILLES
C         IGM2 COMPTEUR DE GROUPE DE MAILLES => NUMERO DES PARTS
C         POUR CHAQUE GROUPE DE MAILLES :
C         * DECOMPTE DU NBRE DE MAILLES DE CHAQUE TYPE ENSIGHT
C         * ALLOCATION OBJET DE TAILLE NBTYME*NBMAX_MAILLES_DE_MEME_TYPE
C         * PUIS TRI DES MAILLES SUIVANT LEUR TYPE DANS L'ORDRE
C           DE NOTYMA (ON DEFINIT LE TABLEAU '&&IRMAEN.TRIGMA')
      IGM2=1
      CALL JEEXIN('&&IRMAEN.MAGR',IRET)
      IF(IRET.NE.0) CALL JEDETR('&&IRMAEN.MAGR')
      CALL JEEXIN('&&IRMAEN.TRIGMA',IRET)
      IF(IRET.NE.0) CALL JEDETR('&&IRMAEN.TRIGMA')
      DO 754 IGM = 1,NBGRM
C       - ON RECUPERE LE NBRE DE MAILLES DU GROUPE, LE POINTEUR ASSOCIE
        CALL JEVEUO(JEXNUM(NOMA//'.GROUPEMA',IGM),'L',IAGRMA)
        CALL JELIRA(JEXNUM(NOMA//'.GROUPEMA',IGM),'LONUTI',NBM,KBID)
        CALL WKVECT('&&IRMAEN.MAGR','V V I',NBM,JMAGR)
        NBM2=0
        DO 755 I=1,NBTYME
          NBMTGM(I)=0
  755   CONTINUE
        DO 756 JM=1,NBM
          IMAGM=ZI(IAGRMA-1+JM)
          IF ( LMOD ) THEN
             IF ( TYPEL(IMAGM) .EQ. 0 ) GOTO 756
          ENDIF
C           - SI IMPRESSION AVEC MODELE ON IGNORE LES MAILLES
C             POUR LESQUELLES AUCUN ELEMENT FINI N'EST AFFECTE
          ITYPE=TYPMA(IMAGM)
          NOMENS=NOMAEN(ITYPE)
          IF(NOMENS.NE.'NONEXIST') THEN
C           - ON IGNORE LES MAILLES NON EXISTANTES POUR ENSIGHT
            NBM2=NBM2+1
            ZI(JMAGR-1+NBM2)=IMAGM
            IF(NOMENS.EQ.'bar2') THEN
              NBMTGM( 1)=NBMTGM( 1)+1
            ELSEIF(NOMENS.EQ.'bar3') THEN
              NBMTGM( 2)=NBMTGM( 2)+1
            ELSEIF(NOMENS.EQ.'tria3') THEN
              NBMTGM( 3)=NBMTGM( 3)+1
C            ELSEIF(NOMENS.EQ.'tria6') THEN
            ELSEIF((NOMENS.EQ.'tria6').OR.(NOMENS.EQ.'tria7')) THEN
              NBMTGM( 4)=NBMTGM( 4)+1
            ELSEIF(NOMENS.EQ.'quad4') THEN
              NBMTGM( 5)=NBMTGM( 5)+1
            ELSEIF((NOMENS.EQ.'quad8').OR.(NOMENS.EQ.'quad9')) THEN
              NBMTGM( 6)=NBMTGM( 6)+1
            ELSEIF(NOMENS.EQ.'tetra4') THEN
              NBMTGM( 7)=NBMTGM( 7)+1
            ELSEIF(NOMENS.EQ.'tetra10') THEN
              NBMTGM( 8)=NBMTGM( 8)+1
            ELSEIF(NOMENS.EQ.'hexa8') THEN
              NBMTGM( 9)=NBMTGM( 9)+1
            ELSEIF(NOMENS.EQ.'hexa20') THEN
              NBMTGM(10)=NBMTGM(10)+1
            ELSEIF((NOMENS.EQ.'penta6').OR.(NOMENS.EQ.'penta15')) THEN
              NBMTGM(11)=NBMTGM(11)+1
            ENDIF
          ENDIF
  756   CONTINUE
        IF(NBM2.NE.0) THEN
          CALL JEVEUO('&&IRMAEN.MAGR','L',JMAGR)
          NBMTMX=NBMTGM(1)
          DO 757 I=2,NBTYME
            IF(NBMTGM(I).GT.NBMTMX) THEN
              NBMTMX=NBMTGM(I)
            ENDIF
  757     CONTINUE
C
C         - LE NOMBRE MAXIMUM DE MAILLES DE MEME TYPE DANS LE GROUPE DE
C           MAILLES EST MIS EN FIN DE VECTEUR
          CALL WKVECT('&&IRMAEN.TRIGMA','V V I',NBMTMX*NBTYME+1,JTRIGM)
          CALL JEVEUO('&&IRMAEN.TRIGMA','E',JTRIGM)
          ZI(JTRIGM-1+NBMTMX*NBTYME+1)=NBMTMX
          ITRI1 =0
          ITRI2 =0
          ITRI3 =0
          ITRI4 =0
          ITRI5 =0
          ITRI6 =0
          ITRI7 =0
          ITRI8 =0
          ITRI9 =0
          ITRI10=0
          ITRI11=0
          DO 758 JM2=1,NBM2
            IMAGM=ZI(JMAGR-1+JM2)
            ITYPE=TYPMA(IMAGM)
            NOMENS=NOMAEN(ITYPE)
            IF(NOMENS.EQ.'bar2') THEN
              ITRI1 =ITRI1 +1
              ZI(JTRIGM-1+ 0*NBMTMX+ITRI1 )=IMAGM
            ELSEIF(NOMENS.EQ.'bar3') THEN
              ITRI2 =ITRI2 +1
              ZI(JTRIGM-1+ 1*NBMTMX+ITRI2 )=IMAGM
            ELSEIF(NOMENS.EQ.'tria3') THEN
              ITRI3 =ITRI3 +1
              ZI(JTRIGM-1+ 2*NBMTMX+ITRI3 )=IMAGM
C            ELSEIF(NOMENS.EQ.'tria6') THEN
            ELSEIF((NOMENS.EQ.'tria6').OR.(NOMENS.EQ.'tria7')) THEN
              ITRI4 =ITRI4 +1
              ZI(JTRIGM-1+ 3*NBMTMX+ITRI4 )=IMAGM
            ELSEIF(NOMENS.EQ.'quad4') THEN
              ITRI5 =ITRI5 +1
              ZI(JTRIGM-1+ 4*NBMTMX+ITRI5 )=IMAGM
            ELSEIF((NOMENS.EQ.'quad8').OR.(NOMENS.EQ.'quad9')) THEN
              ITRI6 =ITRI6 +1
              ZI(JTRIGM-1+ 5*NBMTMX+ITRI6 )=IMAGM
            ELSEIF(NOMENS.EQ.'tetra4') THEN
              ITRI7 =ITRI7 +1
              ZI(JTRIGM-1+ 6*NBMTMX+ITRI7 )=IMAGM
            ELSEIF(NOMENS.EQ.'tetra10') THEN
              ITRI8 =ITRI8 +1
              ZI(JTRIGM-1+ 7*NBMTMX+ITRI8 )=IMAGM
            ELSEIF(NOMENS.EQ.'hexa8') THEN
              ITRI9 =ITRI9 +1
              ZI(JTRIGM-1+ 8*NBMTMX+ITRI9 )=IMAGM
            ELSEIF(NOMENS.EQ.'hexa20') THEN
              ITRI10=ITRI10+1
              ZI(JTRIGM-1+ 9*NBMTMX+ITRI10)=IMAGM
            ELSEIF((NOMENS.EQ.'penta6').OR.(NOMENS.EQ.'penta15')) THEN
              ITRI11=ITRI11+1
              ZI(JTRIGM-1+10*NBMTMX+ITRI11)=IMAGM
            ENDIF
  758     CONTINUE
C
C         - ECRITURE DES CONNECTIVITES DU GROUPE DE MAILLES
          IGM2=IGM2+1
          WRITE(IFIEN,'(A,I4)') 'part ',IGM2
          LGNOGM=LXLGUT(NOGM(IGM))
          WRITE(IFIEN,'(A)') 'GROUPE DE MAILLES '//NOGM(IGM)(1:LGNOGM)
          CALL JEVEUO('&&IRMAEN.TRIGMA','L',JTRIGM)
          DO 760 ITYENS=1,NBTYME
            IF(NBMTGM(ITYENS).NE.0) THEN
              WRITE(IFIEN,'(A)') NOTYMA(ITYENS)
              WRITE(IFIEN,'(I8)') NBMTGM(ITYENS)
              DO 762 I=1,NBMTGM(ITYENS)
                IMAGM=ZI(JTRIGM-1+ (ITYENS-1)*NBMTMX+I)
                ITYPE=TYPMA(IMAGM)
                IPOIN=POINT(IMAGM)
                NNOE=POINT(IMAGM+1)-POINT(IMAGM)
                DO 763 J=1,NNOE
                  NODAST(J)=CONNEX(IPOIN-1+J)
                  IENS=PERMUT(J,ITYPE)
                  NODENS(IENS)=NODAST(J)
  763           CONTINUE
C               - RECHERCHE DES NUMEROS DE LA MAILLE ET DES NOEUDS
                IF(LMASU) THEN
                  CALL LXLIIS(NOMAI(IMAGM)(3:8),IMAE,IER)
                  DO 764 J=1,NNOE
                    CALL LXLIIS(NONOE(NODENS(J))(3:8),
     &                    NODENS(J),IER)
  764             CONTINUE
                ELSE
                  IMAE = IMAGM
                ENDIF
                IF(ITYENS.EQ.1) THEN
                  WRITE(IFIEN,'(3I8)')  IMAE,(NODENS(K),K=1,2)
                ELSEIF((ITYENS.EQ.2).OR.(ITYENS.EQ.3)) THEN
                  WRITE(IFIEN,'(4I8)')  IMAE,(NODENS(K),K=1,3)
                ELSEIF((ITYENS.EQ.5) .OR.(ITYENS.EQ.7)) THEN
                  WRITE(IFIEN,'(5I8)')  IMAE,(NODENS(K),K=1,4)
                ELSEIF((ITYENS.EQ.4) .OR.(ITYENS.EQ.11)) THEN
C                 - LES PENTA15 EVENTUELS SONT REDUITS A DES PENTA6
C                   EN N'ECRIVANT QUE LES NOEUDS SOMMETS (LES 6 1ERS)
                  WRITE(IFIEN,'(7I8)')  IMAE,(NODENS(K),K=1,6)
                ELSEIF((ITYENS.EQ.6) .OR.(ITYENS.EQ.9)) THEN
C                 - LES QUAD9 EVENTUELS SONT REDUITS A DES QUAD8
C                   EN N'ECRIVANT QUE LES NOEUDS SOMMETS (LES 8 1ERS)
                  WRITE(IFIEN,'(9I8)')  IMAE,(NODENS(K),K=1,8)
                ELSEIF(ITYENS.EQ.8) THEN
                  WRITE(IFIEN,'(11I8)') IMAE,(NODENS(K),K=1,10)
                ELSEIF(ITYENS.EQ.10) THEN
                  WRITE(IFIEN,'(21I8)') IMAE,(NODENS(K),K=1,20)
                ENDIF
  762         CONTINUE
            ENDIF
  760     CONTINUE
          CALL JEDETR('&&IRMAEN.TRIGMA')
        ENDIF
        CALL JEDETR('&&IRMAEN.MAGR')
  754 CONTINUE
      CLOSE(IFIEN)
 9999 CONTINUE
      CALL JEDEMA()
      END
