      SUBROUTINE LRCMLE ( IDFIMD, NOCHMD,
     &                    NBCMFI, NBVATO, NUMPT, NUMORD,
     &                    TYPENT, TYPGEO,
     &                    NTVALE, NOMPRF,
     &                    CODRET )
C_____________________________________________________________________
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 11/05/2011   AUTEUR SELLENET N.SELLENET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE SELLENET N.SELLENET
C ======================================================================
C     LECTURE D'UN CHAMP - FORMAT MED - LECTURE
C     -    -       -              -     --
C-----------------------------------------------------------------------
C      ENTREES:
C        IDFIMD : IDENTIFIANT DU FICHIER MED
C        NOCHMD : NOM MED DU CHAMP A LIRE
C        NBCMFI : NOMBRE DE COMPOSANTES DANS LE FICHIER      .
C        NBVATO : NOMBRE DE VALEURS TOTAL (VALEUR DE MFNVAL)
C        NUMPT  : NUMERO DE PAS DE TEMPS
C        NUMORD : NUMERO D'ORDRE DU CHAMP
C        TYPENT : TYPE D'ENTITE AU SENS MED
C        TYPGEO : TYPE DE SUPPORT AU SENS MED
C      SORTIES:
C        NOMPRF : NOM DU PROFIL ASSOCIE
C        NTVALE : TABLEAU QUI CONTIENT LES VALEURS LUES
C        CODRET : CODE DE RETOUR (0 : PAS DE PB, NON NUL SI PB)
C_____________________________________________________________________
C
      IMPLICIT NONE
C
C 0.1. ==> ARGUMENTS
C
      INTEGER IDFIMD
      INTEGER NBCMFI, NBVATO, NUMPT, NUMORD
      INTEGER TYPENT, TYPGEO
      INTEGER CODRET
C
      CHARACTER*(*) NOCHMD, NOMPRF
      CHARACTER*64 NOMLOC
      CHARACTER*(*) NTVALE
C
C 0.2. ==> COMMUNS
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX --------------------------
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
C     -----  FIN  COMMUNS NORMALISES  JEVEUX --------------------------
C
C 0.3. ==> VARIABLES LOCALES
C
C
      INTEGER EDFUIN
      PARAMETER (EDFUIN=0)
      INTEGER EDALL
      PARAMETER (EDALL=0)
      INTEGER EDCOMP
      PARAMETER (EDCOMP=2)
C
      INTEGER IFM, NIVINF
C
      INTEGER ADVALE, IPROF, NBPROF, N, TAIPRO, NIP
C
      CHARACTER*8 SAUX08
C
C====
C 1. PREALABLES
C====
C
C 1.1. ==> RECUPERATION DU NIVEAU D'IMPRESSION
C
      CALL INFNIV ( IFM, NIVINF )
C
      IF ( NIVINF.GT.1 ) THEN
         WRITE(IFM,*) 'NB CMP :',NBCMFI,'  NB TOTAL VALEURS :',NBVATO
      ENDIF
C
C====
C 2. LECTURE DU NOM DU PROFIL
C====
C
      CALL MFPRLO( IDFIMD, NOCHMD, NUMPT, NUMORD, TYPENT, TYPGEO,
     &             NOMPRF, NOMLOC, NBPROF, CODRET )
      DO 10, IPROF = 1, NBPROF
        CALL MFNNOP( IDFIMD, NOCHMD, TYPENT, TYPGEO, NUMPT,
     &               NUMORD, IPROF, NOMPRF, EDCOMP, TAIPRO,
     &               NOMLOC, NIP, N, CODRET )
  10  CONTINUE
C
C====
C 3. LECTURE DU CHAMP DANS UN TABLEAU TEMPORAIRE
C====
C
      CALL WKVECT ( NTVALE, 'V V R', NBCMFI*NBVATO, ADVALE )
C
      CALL MFCHRL ( IDFIMD, NOCHMD, ZR(ADVALE),
     &              EDFUIN, EDALL, NOMPRF, EDCOMP,
     &              TYPENT, TYPGEO,
     &              NUMPT,  NUMORD, CODRET)
C
      IF ( CODRET.NE.0 ) THEN
        SAUX08='MFCHRL  '
        CALL U2MESG('F','DVP_97',1,SAUX08,1,CODRET,0,0.D0)
      ENDIF
C
      END
