      SUBROUTINE MDNOFA ( NUMFAM, NOGRF, NBGF, NBFAEX, NOFAEX, NOMFAM )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 11/05/2011   AUTEUR SELLENET N.SELLENET 
C RESPONSABLE SELLENET N.SELLENET
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C  ENTREES :
C     NUMFAM = NUMERO DE LA FAMILLE
C     NOGRF  = NOMS DES GROUPES D ENTITES DE LA FAMILLE
C     NBGF   = NOMBRE DE GROUPES DE LA FAMILLE
C     NBFAEX = NOMBRE DE FAMILLES EXISTANTES POUR CETTE SERIE
C     NOFAEX = NOMS DES FAMILLES DEJA CREEES
C  SORTIES :
C     NOMFAM = NOM DE LA FAMILLE
C     ------------------------------------------------------------------
C
C    LE NOM DE LA FAMILLE SERA LA CONCATENATION DES NOMS DES GROUPES.
C    ON PLACE UN '_' ENTRE DEUX NOMS
C    EXEMPLE :
C       GROUPE 1 : 'HAUT'
C       GROUPE 2 : 'FACE_X'
C       FAMILLE ==> 'HAUT_FACE_X'
C                    12345678901234567890123456789012
C
C     SI ON N'A PAS LA PLACE, ON MET UN NOM ARBITRAIRE
C
      IMPLICIT NONE
C
C 0.1. ==> ARGUMENTS
C
      INTEGER NUMFAM
      INTEGER NBGF
      INTEGER NBFAEX
      CHARACTER*(*) NOGRF(*)
      CHARACTER*(*) NOMFAM
      CHARACTER*(*) NOFAEX(*)
C
C 0.2. ==> COMMUNS
C
C 0.3. ==> VARIABLES LOCALES
C
      INTEGER IAUX, JAUX
      INTEGER IDEB, IFIN
      INTEGER LGNOFA, LGNOFX
C
      CHARACTER*8 SAUX08
C
      LOGICAL ACORRI
C
      INTEGER LXLGUT
C
C====
C 1. ON INITIALISE AVEC DES ' '
C====
C
      LGNOFX = LEN(NOMFAM)
      DO 11 , IAUX = 1 , LGNOFX
        NOMFAM(IAUX:IAUX) = ' '
   11 CONTINUE
C
C====
C 2. CALCUL DE LA TAILLE NECESSAIRE A LA CONCATENATION
C====
C
      LGNOFA = 0
      DO 21 , IAUX = 1 , NBGF
        LGNOFA = LGNOFA + LXLGUT(NOGRF(IAUX))
        IF ( IAUX.LT.NBGF ) THEN
          LGNOFA = LGNOFA + 1
        ENDIF
   21  CONTINUE
C
C====
C 2. ON A LA PLACE : FABRICATION DU NOM
C====
C
      IF ( LGNOFA.LE.LGNOFX ) THEN
C
        IFIN = 0
        DO 31 , IAUX = 1 , NBGF
          JAUX = LXLGUT(NOGRF(IAUX))
          IDEB = IFIN + 1
          IFIN = IFIN + JAUX
          NOMFAM(IDEB:IFIN) = NOGRF(IAUX)(1:JAUX)
          IF ( IAUX.LT.NBGF ) THEN
            IFIN = IFIN + 1
            NOMFAM(IFIN:IFIN) = '_'
          ENDIF
   31   CONTINUE
C
C====
C 4. SINON, C'EST UN NOM ARBITRAIRE, CONSTRUIT AVEC LE NUMERO DE
C    LA FAMILLE
C====
C
      ELSE
C
C                      12345678
        NOMFAM(1:8) = 'FAMILLE_'
C
        CALL CODENT ( NUMFAM,'G',SAUX08 )
C
        JAUX = LXLGUT(SAUX08)
        NOMFAM(9:8+JAUX) = SAUX08(1:JAUX)
C
      ENDIF
C
C====
C 5. MEMORISATION DU NOM DANS LE TABLEAU
C====
C
      NOFAEX(NBFAEX+1) = NOMFAM
C
      END
