      SUBROUTINE NUMEOK(ACCES,ILU,RLU,LISTRZ,LISTIZ,PRECIS,CRIT,EPSI,
     +                  ASTOCK)
      IMPLICIT  NONE
      LOGICAL ASTOCK
      CHARACTER*(*) ACCES,LISTRZ,LISTIZ,CRIT
      INTEGER ILU,PRECIS
      REAL*8 RLU,EPSI
C----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 21/07/99   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C----------------------------------------------------------------------

C      VERIFICATION : LA VALEUR DU NUMERO D'ORDRE, DE L'INSTANT OU DE
C                     LA FREQUENCE EST-ELLE CELLE ATTENDUE ?

C IN  : ACCES  : K10  : TYPE D'ACCES
C IN  : ILU    : I    : VALEUR ENTIERE LUE DANS LE DATASET
C IN  : RLU    : R    : VALEUR REELLE LUE DANS LE DATASET
C IN  : LISTRZ : K19  : NOM DE L'OBJET CONTENANT LA LISTE DES INSTANTS
C                       OU DES FREQUENCES A LIRE
C IN  : LISTIZ : K19  : NOM DE L'OBJET CONTENANT LA LISTE DES
C                       NUMEROS D'ORDRE A LIRE
C IN  : PRECIS : I    : INDICATEUR DE VERIFICATION DE LA PRECISION
C IN  : CRIT   : K8   : CRITERE (RELATIF OU ABSOLU)
C IN  : EPSI   : R    : PRECISION
C OUT : ASTOCK : L    : .TRUE.  ON STOCKE LES RESULTATS
C                       .FALSE. ON NE STOCKE PAS LES RESULTATS
C----------------------------------------------------------------------

C     ----- DEBUT COMMUNS NORMALISES  JEVEUX --------------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      CHARACTER*32 JEXNUM,JEXNOM,JEXR8,JEXATR
C     -----  FIN  COMMUNS NORMALISES  JEVEUX --------------------------
      REAL*8 TREF
      INTEGER JLIST,NBORDR,IORD
      INTEGER I
      CHARACTER*19 LISTIS,LISTR8
      CHARACTER*8 K8B

      CALL JEMARQ()

      ASTOCK = .FALSE.
      LISTIS = LISTIZ
      LISTR8 = LISTRZ

C- TOUT_ORDRE

      IF (ACCES.EQ.'TOUT_ORDRE') THEN
        ASTOCK = .TRUE.
        GO TO 70
      END IF

C- NUME_ORDRE

      IF (ACCES.EQ.'NUME_ORDRE') THEN
        CALL JEVEUO(LISTIS//'.VALE','L',JLIST)
        CALL JELIRA(LISTIS//'.VALE','LONMAX',NBORDR,K8B)
        DO 10 I = 1,NBORDR
          IF (ILU.EQ.ZI(JLIST-1+I)) THEN
            ASTOCK = .TRUE.
            GO TO 70
          END IF
   10   CONTINUE
      END IF

C- INST

      IF (ACCES.EQ.'INST') THEN
        CALL JEVEUO(LISTR8//'.VALE','L',JLIST)
        CALL JELIRA(LISTR8//'.VALE','LONMAX',NBORDR,K8B)
        DO 20 I = 1,NBORDR
          IF (RLU.EQ.ZR(JLIST)) THEN
            ASTOCK = .TRUE.
            GO TO 70
          END IF
   20   CONTINUE
      END IF

C- LIST_INST

      IF (ACCES.EQ.'LIST_INST') THEN
        CALL JEVEUO(LISTR8//'.VALE','L',JLIST)
        CALL JELIRA(LISTR8//'.VALE','LONMAX',NBORDR,K8B)
        DO 30 I = 1,NBORDR
          IF (ILU.EQ.ZR(JLIST)) THEN
            ASTOCK = .TRUE.
            GO TO 70
          END IF
   30   CONTINUE
      END IF

C- FREQ

      IF (ACCES.EQ.'FREQ') THEN
        CALL JEVEUO(LISTR8//'.VALE','L',JLIST)
        CALL JELIRA(LISTR8//'.VALE','LONMAX',NBORDR,K8B)
        DO 40 I = 1,NBORDR
          IF (ILU.EQ.ZR(JLIST)) THEN
            ASTOCK = .TRUE.
            GO TO 70
          END IF
   40   CONTINUE
      END IF

C- LIST_FREQ

      IF (ACCES.EQ.'LIST_FREQ') THEN
        CALL JEVEUO(LISTR8//'.VALE','L',JLIST)
        CALL JELIRA(LISTR8//'.VALE','LONMAX',NBORDR,K8B)
        DO 50 I = 1,NBORDR
          IF (ILU.EQ.ZR(JLIST)) THEN
            ASTOCK = .TRUE.
            GO TO 70
          END IF
   50   CONTINUE
      END IF

C- VERIFICATION DE LA PRECISION ET DU CRITERE ---

      IF (PRECIS.NE.0) THEN
        IF (ACCES.NE.'TOUT_ORDRE' .AND. ACCES.NE.'NUME_ORDRE') THEN
          DO 60 IORD = 1,NBORDR
            TREF = ZR(JLIST+IORD-1)
            IF (CRIT(1:4).EQ.'RELA') THEN
              IF (ABS(TREF-RLU).LE.ABS(EPSI*RLU)) THEN
                ASTOCK = .TRUE.
                GO TO 70
              END IF
            ELSE IF (CRIT(1:4).EQ.'ABSO') THEN
              IF (ABS(TREF-RLU).LE.ABS(EPSI)) THEN
                ASTOCK = .TRUE.
                GO TO 70
              END IF
            END IF
   60     CONTINUE
        END IF
      END IF

   70 CONTINUE

      CALL JEDEMA()

      END
