      SUBROUTINE RSMENA(RESU)
      IMPLICIT   NONE
      CHARACTER*(*) RESU
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 28/06/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2010  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE PELLET J.PELLET
C     ------------------------------------------------------------------
C BUT : DETRUIRE LES OBJETS JEVEUX INUTILISES DANS UNE SD_RESULTAT
C     ------------------------------------------------------------------
C
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      CHARACTER*32 JEXNUM,JEXNOM
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
C
C 0.3. ==> VARIABLES LOCALES
C
      INTEGER N1,N2,K,JLIST,NBCON,IBID,NBORDR,JORDR,JCOCHE
      INTEGER I,NBNOSY,JTACH,J,IRET,IERD,I1,JRS24
      CHARACTER*8 KBID,TYCH,RES8
      CHARACTER*16 NOMSYM
      CHARACTER*19 RES19,NOCO19
      CHARACTER*24 CHAM,NOOBJ
      REAL*8 R8B
      COMPLEX*16 C16B
C     ------------------------------------------------------------------
      CALL JEMARQ()
      RES19=RESU
      RES8=RESU

C--------------------------------------------------------
C     IL FAUT DERUIRE :
C         * LES PROF_CHNO INUTILISES
C         * LES EXCIT INUTILISES
C         * LES LIGREL INUTILISES
C--------------------------------------------------------

C     0. CREATION DE 1 OBJET :
C     * LOBJ : LISTE DES OBJETS EXISTANT DANS LA SD_RESULTAT
      CALL JELSTC('G',RES8,1,0,KBID,N1)
      CALL WKVECT('&&RSMENA.LOBJ','V V K24',-N1,JLIST)
      CALL JELSTC('G',RES8,1,-N1,ZK24(JLIST),N2)


C     1. LES PROF_CHNO :
C     ------------------

C     1.1 LISTE DES PROF_CHNO EXISTANTS
      CALL JECREO('&&RSMENA.DICO','V N K24')
      CALL JEECRA('&&RSMENA.DICO','NOMMAX',N2,KBID)
      NBCON=0
      DO 10,K=1,N2
        NOOBJ=ZK24(JLIST-1+K)
        IF (NOOBJ(20:24).EQ.'.DEEQ') THEN
          NBCON=NBCON+1
          NOCO19=NOOBJ(1:19)
          CALL JECROC(JEXNOM('&&RSMENA.DICO',NOCO19))
        ENDIF
   10 CONTINUE
      IF (NBCON.EQ.0)GOTO 50

C     1.2 ON "COCHE" LES  PROF_CHNO REFERENCES :
      CALL JELIRA(RES19//'.DESC','NOMMAX',NBNOSY,KBID)
      CALL RSORAC(RES19,'LONUTI',IBID,R8B,KBID,C16B,R8B,KBID,NBORDR,1,
     &            IBID)
      CALL WKVECT('&&RSMENA.NUME_ORDRE','V V I',NBORDR,JORDR)
      CALL RSORAC(RES19,'TOUT_ORDRE',IBID,R8B,KBID,C16B,R8B,KBID,
     &            ZI(JORDR),NBORDR,IBID)
      CALL WKVECT('&&RSMENA.COCHE','V V I',NBCON,JCOCHE)

      DO 30 I=1,NBNOSY
        CALL JENUNO(JEXNUM(RES19//'.DESC',I),NOMSYM)
        CALL JEVEUO(JEXNUM(RES19//'.TACH',I),'E',JTACH)
        DO 20 J=1,NBORDR
          IF (ZK24(JTACH+J-1)(1:1).EQ.' ')GOTO 20
          CALL RSEXCH(RES19,NOMSYM,ZI(JORDR-1+J),CHAM,IRET)
          CALL ASSERT(IRET.EQ.0)
          CALL DISMOI('F','TYPE_CHAMP',CHAM,'CHAMP',IBID,TYCH,IERD)
          IF (TYCH.NE.'NOEU')GOTO 30
          CALL DISMOI('F','PROF_CHNO',CHAM,'CHAMP',IBID,NOCO19,IERD)
          CALL JENONU(JEXNOM('&&RSMENA.DICO',NOCO19),I1)
          CALL ASSERT(I1.GT.0 .AND. I1.LE.NBCON)
          ZI(JCOCHE-1+I1)=1
   20   CONTINUE
   30 CONTINUE

C     1.2 ON DETRUIT LES  PROF_CHNO NON REFERENCES :
      DO 40,K=1,NBCON
        IF (ZI(JCOCHE-1+K).EQ.0) THEN
          CALL JENUNO(JEXNUM('&&RSMENA.DICO',K),NOCO19)
          CALL DETRSD('PROF_CHNO',NOCO19)
        ENDIF
   40 CONTINUE
   50 CONTINUE



C     2. LES LISTE_CHARGE (EXCIT) :
C     ------------------------------
      CALL JEDETR('&&RSMENA.DICO')
      CALL JEDETR('&&RSMENA.COCHE')

C     2.1 LISTE DES LISTE_CHARGE EXISTANTS
      CALL JECREO('&&RSMENA.DICO','V N K24')
      CALL JEECRA('&&RSMENA.DICO','NOMMAX',N2,KBID)
      NBCON=0
      DO 60,K=1,N2
        NOOBJ=ZK24(JLIST-1+K)
        IF (NOOBJ(20:24).EQ.'.LCHA') THEN
          NBCON=NBCON+1
          NOCO19=NOOBJ(1:19)
          CALL JECROC(JEXNOM('&&RSMENA.DICO',NOCO19))
        ENDIF
   60 CONTINUE
      IF (NBCON.EQ.0)GOTO 90

C     2.2 ON "COCHE" LES  LISTE_CHARGE REFERENCES :
      CALL JELIRA(RES19//'.RS24','LONMAX',N1,KBID)
      CALL JEVEUO(RES19//'.RS24','L',JRS24)
      CALL WKVECT('&&RSMENA.COCHE','V V I',NBCON,JCOCHE)

      DO 70 I=1,N1
        IF (ZK24(JRS24+I-1)(14:19).NE.'.EXCIT')GOTO 70
        NOCO19=ZK24(JRS24+I-1)(1:19)
        CALL JENONU(JEXNOM('&&RSMENA.DICO',NOCO19),I1)
        CALL ASSERT(I1.GT.0 .AND. I1.LE.NBCON)
        ZI(JCOCHE-1+I1)=1
   70 CONTINUE

C     2.3 ON DETRUIT LES  LISTE_CHARGE NON REFERENCES :
      DO 80,K=1,NBCON
        IF (ZI(JCOCHE-1+K).EQ.0) THEN
          CALL JENUNO(JEXNUM('&&RSMENA.DICO',K),NOCO19)
          CALL DETRSD('LISTE_CHARGES',NOCO19)
        ENDIF
   80 CONTINUE
   90 CONTINUE



C     3. LES LIGREL REFERENCES PAR LES CHAM_ELEM
C        (CALC_ELEM + GROUP_MA)
C     ------------------------------
      CALL JEDETR('&&RSMENA.DICO')
      CALL JEDETR('&&RSMENA.COCHE')

C     3.1 LISTE DES LIGREL EXISTANTS
      CALL JECREO('&&RSMENA.DICO','V N K24')
      CALL JEECRA('&&RSMENA.DICO','NOMMAX',N2,KBID)
      NBCON=0
      DO 100,K=1,N2
        NOOBJ=ZK24(JLIST-1+K)
        IF (NOOBJ(20:24).EQ.'.LIEL') THEN
          NBCON=NBCON+1
          NOCO19=NOOBJ(1:19)
          CALL JECROC(JEXNOM('&&RSMENA.DICO',NOCO19))
        ENDIF
  100 CONTINUE
      IF (NBCON.EQ.0)GOTO 140

C     3.2 ON "COCHE" LES LIGREL REFERENCES :
      CALL WKVECT('&&RSMENA.COCHE','V V I',NBCON,JCOCHE)

      DO 120 I=1,NBNOSY
        CALL JENUNO(JEXNUM(RES19//'.DESC',I),NOMSYM)
        CALL JEVEUO(JEXNUM(RES19//'.TACH',I),'E',JTACH)
        DO 110 J=1,NBORDR
          IF (ZK24(JTACH+J-1)(1:1).EQ.' ')GOTO 110
          CALL RSEXCH(RES19,NOMSYM,ZI(JORDR-1+J),CHAM,IRET)
          CALL ASSERT(IRET.EQ.0)
          CALL DISMOI('F','TYPE_CHAMP',CHAM,'CHAMP',IBID,TYCH,IERD)
          IF (TYCH(1:2).NE.'EL')GOTO 120
          CALL DISMOI('F','NOM_LIGREL',CHAM,'CHAMP',IBID,NOCO19,IERD)
          CALL JENONU(JEXNOM('&&RSMENA.DICO',NOCO19),I1)
          IF (I1.GT.0 .AND. I1.LE.NBCON) ZI(JCOCHE-1+I1)=1
  110   CONTINUE
  120 CONTINUE

C     3.2 ON DETRUIT LES LIGREL NON REFERENCES :
      DO 130,K=1,NBCON
        IF (ZI(JCOCHE-1+K).EQ.0) THEN
          CALL JENUNO(JEXNUM('&&RSMENA.DICO',K),NOCO19)
          CALL DETRSD('LIGREL',NOCO19)
        ENDIF
  130 CONTINUE
  140 CONTINUE



C     -- MENAGE :
C     -----------
      CALL JEDETR('&&RSMENA.LOBJ')
      CALL JEDETR('&&RSMENA.DICO')
      CALL JEDETR('&&RSMENA.NUME_ORDRE')
      CALL JEDETR('&&RSMENA.COCHE')

      CALL JEDEMA()
      END
