      SUBROUTINE SSINGU (NOMAIL,NELEM,NBR,LIGRMO,ALPHA,RE,HE,CHELEM)
      IMPLICIT NONE
      INTEGER NELEM,NBR(NELEM)
      REAL*8  ALPHA(NELEM),RE(NELEM),HE(NELEM)
      CHARACTER*8 NOMAIL
      CHARACTER*24 LIGRMO,CHELEM
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 16/09/2008   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2005  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
C     BUT:
C         STOCKAGE DE LA SINGULARITE (ALPHA), DU RAPPORT DE TAILLE (RE)
C         ET DE LA NOUVELLE TAILLE (TAILLE) DES ELEMENTS DANS CHELEM
C         OPTION : 'SING_ELEM'
C
C
C     ARGUMENTS:
C     ----------
C
C      ENTREE :
C-------------
C IN   NOMAIL       : NOM DU MAILLAGE
C IN   NELEM        : NOMBRE D ELEMENTS FINIS DU MAILLAGE
C IN   NBR(NELEM)   : NOMBRE DE COMPOSANTES A STOCKER PAR EF
C      3 SI EF SURFACIQUES EN 2D OU VOLUMIQUES EN 3D
C      0 SINON
C IN   LIGRMO       : NOM DU LIGREL DU MODELE
C IN   ALPHA(NELEM) : DEGRE DE LA SINGULARITE
C IN   RE(NELEM)    : RAPPORT ENTRE ANCIENNE ET NOUVELLE TAILLE
C IN   HE(NELEM)    : NOUVELLE TAILLE
C IN   CHELEM       : CHAM_ELEM QUI VA CONTENIR LE DEGRE ET LA TAILLE
C
C      SORTIE :
C-------------
C
C ......................................................................
C
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
C
      INTEGER JCESC,JCESD,JCESL,JCESV,IAD1,IAD2,IAD3
      INTEGER NBCMP,NCMP1,NCMP2,NCMP3
      INTEGER ICMP,INEL,NNCP,IBID
      CHARACTER*8 K8BID,NOMPAZ,LICMP(3)
      CHARACTER*16 OPTI
      CHARACTER*19 CHSING

      CALL JEMARQ()

C 1 - CREATION D UN CHAM_ELEM_S CHSING

      CHSING='&&SINGUE.SING'
      NOMPAZ='SING_R'
      LICMP(1)='DEGRE'
      LICMP(2)='RAPPORT'
      LICMP(3)='TAILLE'
      CALL CESCRE('V',CHSING,'ELEM',NOMAIL,NOMPAZ,3,LICMP,-1,-1,NBR)

C 2 - STOCKAGE DANS CHSING DE ALPHA ET RE

      CALL JEVEUO(CHSING//'.CESC','L',JCESC)
      CALL JELIRA(CHSING//'.CESC','LONMAX',NBCMP,K8BID)
      CALL JEVEUO(CHSING//'.CESD','L',JCESD)
      CALL JEVEUO(CHSING//'.CESL','E',JCESL)
      CALL JEVEUO(CHSING//'.CESV','E',JCESV)

      DO 10 ICMP=1,NBCMP
        IF (ZK8(JCESC+ICMP-1)(1:5).EQ.'DEGRE')  NCMP1=ICMP
        IF (ZK8(JCESC+ICMP-1)(1:7).EQ.'RAPPORT') NCMP2=ICMP
        IF (ZK8(JCESC+ICMP-1)(1:6).EQ.'TAILLE') NCMP3=ICMP
 10   CONTINUE

      DO 20 INEL=1,NELEM
        CALL CESEXI('C',JCESD,JCESL,INEL,1,1,NCMP1,IAD1)
        CALL CESEXI('C',JCESD,JCESL,INEL,1,1,NCMP2,IAD2)
        CALL CESEXI('C',JCESD,JCESL,INEL,1,1,NCMP3,IAD3)
        IF ((-IAD1).GT.0) THEN
          ZL(JCESL-IAD1-1)=.TRUE.
          ZR(JCESV-IAD1-1)= ALPHA(INEL)
        ENDIF
        IF ((-IAD2).GT.0) THEN
          ZL(JCESL-IAD2-1)=.TRUE.
          ZR(JCESV-IAD2-1)= 1.D0/RE(INEL)
        ENDIF
        IF ((-IAD3).GT.0) THEN
          ZL(JCESL-IAD3-1)=.TRUE.
          ZR(JCESV-IAD3-1)= HE(INEL)
        ENDIF
 20   CONTINUE

C 3 - TRANSFORMATION DU CHAM_ELEM_S EN CHAM_ELEM

      OPTI='SING_ELEM'
      NOMPAZ='PSING_R'

      CALL CESCEL(CHSING,LIGRMO(1:19),OPTI,NOMPAZ,'NON',NNCP,'G',
     &            CHELEM(1:19),'F',IBID)

      CALL DETRSD('CHAM_ELEM_S',CHSING)

      CALL JEDEMA()

      END
