      SUBROUTINE STATPU ( NBOBST,NBPT,TEMPS,FCHO,VGLI,IADH,
     &                    WK1,WK2,WK3,IWK4,
     &                    IDEBUT,NBLOC,NBVAL,IFIRES,INOE,IMPR, PUSURN )
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 16/12/2004   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C-----------------------------------------------------------------------
C     CALCUL DE LA PUISSANCE D'USURE AU SENS D'ARCHARD
C
C IN  : NBOBST : NB DE NOEUDS DE CHOC
C IN  : NBPT   : NB DE PAS DE TEMPS TEMPORELS ARCHIVES
C IN  : TEMPS  : INSTANTS DE CALCUL
C IN  : FCHO   : VECTEUR DES FORCES DE CHOC
C IN  : VGLI   : VECTEUR DES VITESSES DE GLISSEMENT
C IN  : NBLOC  : NB DE BLOCS POUR LE MOYENNAGE
C IN  : INOE   : NUMERO DE NOEUD TRAITE
C IN  : IMPR   : IMPRESSION
C OUT : PUSURN : PUISSANCE D'USURE MOYENNEE
C-----------------------------------------------------------------------
      IMPLICIT REAL *8 (A-H,O-Z)
      REAL*8   TEMPS(*), FCHO(*), VGLI(*), WK1(*), WK2(*), WK3(*)
      INTEGER  IWK4(*),IADH(*)
C
      PUSURN = 0.D0
      CALL DCOPY(NBPT,FCHO(3*(INOE-1)+1),3*NBOBST,WK1,1)
      CALL DCOPY(NBPT,VGLI(3*(INOE-1)+2),3*NBOBST,WK2,1)
      CALL DCOPY(NBPT,VGLI(3*(INOE-1)+3),3*NBOBST,WK3,1)
C     CALL DCOPY(NBPT,IADH(1*(INOE-1)+1),NBOBST,IWK4,1)
      DO 5 I = 1,NBPT
         IWK4(I) = IADH(1*(INOE-1)+1+(I-1)*NBOBST)
 5    CONTINUE
      DO 10 IBL = 1,NBLOC
         CALL PUSURE(NBVAL,WK1((IBL-1)*NBVAL+IDEBUT),
     &   WK2((IBL-1)*NBVAL+IDEBUT),WK3((IBL-1)*NBVAL+IDEBUT),
     &   IWK4((IBL-1)*NBVAL+IDEBUT),TEMPS((IBL-1)*NBVAL+IDEBUT),PUSEE)
         PUSURN = PUSURN + PUSEE
CC       --- IMPRESSION DE LA PUISSANCE D USURE ---
        IF (IMPR.EQ.2) CALL IMPUS(IFIRES,IBL,PUSEE)
 10   CONTINUE
      PUSURN = PUSURN / NBLOC
      IF (IBL.GT.1 .AND. IMPR.EQ.2) CALL IMPUS ( IFIRES,0,PUSURN )
C
      END
