      SUBROUTINE XPOFON(MODELE,MAXFEM,MFTOT,NFTOT,NFCOMF,NGFON)
      IMPLICIT NONE
      
      CHARACTER*8  MODELE,MAXFEM
      INTEGER      MFTOT,NFTOT,NFCOMF,NGFON
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 22/02/2011   AUTEUR MACOCCO K.MACOCCO 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C     BUT : RECUPERER POUR L'IMPRESSION LES CARACTERISTIQUES DES FONDS
C           DE FISSURE 
C   IN
C       MODELE : MODELE FISSURE
C       MAXFEM : MAILLAGE FISSURE
C   OUT
C       MFTOT  : NOMBRE TOTAL DE MAILLES DE FONDS DE FISSURES
C       NFTOT  : NOMBRE TOTAL DE NOEUDS DE FONDS DE FISSURES
C       NFCOMF : NOMBRE TOTAL DE CONNEXIONS DANS LES MAILLES
C       NGFON  : NOMBRE TOTAL DE FOND DE FISSURES
C     =================================================================
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      CHARACTER*32 JEXNUM,JEXNOM
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
C     ------------------------------------------------------------------
      INTEGER      JNOM,JTAIL,JNFOND,JBNFMU
      INTEGER      IBID,IRET,IFISS,IFON
      INTEGER      NDIM,NFISS,NFOND,NBNOL
      CHARACTER*8  K8B,FISS,MO,MALINI
      CHARACTER*19 K19B,NOMTA1,NOMTA2
      CHARACTER*24 NOM
      

C     INITIALISATIONS  
      MFTOT = 0
      NFTOT = 0
      NFCOMF = 0
      NGFON = 0      

C     RECUPERATION DU NOMBRE DE FISSURES      
      MO = MODELE
      NOM = MO//'.FISS                   '
      CALL JEVEUO(NOM,'L',JNOM)
      CALL JELIRA(NOM,'LONUTI',NFISS,K8B)
C
C     RECUPERATION DES CARACTERISTIQUES DU MAILLAGE INITIAL      
      CALL DISMOI('F','NOM_MAILLA',MO,'MODELE',IBID,MALINI,IRET)
      CALL DISMOI('F','DIM_GEOM',MO,'MODELE',NDIM,K8B,IRET)
C
      IF (NDIM.EQ.2) THEN
C
        DO 10 IFISS=1,NFISS
          FISS = ZK8(JNOM)
          CALL JEEXIN( FISS//'.FONDFISS',IRET)
          IF (IRET.NE.0) THEN
            CALL LTNOTB ( FISS,'NB_FOND_FISS',NOMTA1)
            CALL JEVEUO(NOMTA1//'.0001','L',JNFOND)
            NFOND  = ZI(JNFOND)
            NGFON  = NGFON + NFOND
            NFTOT  = NFTOT + NFOND
            MFTOT  = MFTOT + NFOND        
            NFCOMF = NFCOMF + NFOND
          ENDIF        
 10        CONTINUE
 
      ELSEIF (NDIM.EQ.3) THEN
C
        DO 11 IFISS=1,NFISS
C
          FISS = ZK8(JNOM)
          CALL JEEXIN( FISS//'.FONDFISS',IRET)
          IF (IRET.NE.0) THEN
C
            CALL JEVEUO(FISS//'.FONDMULT','L',JBNFMU)
C
            CALL LTNOTB(FISS,'NB_FOND_FISS',NOMTA1)
            CALL JEVEUO(NOMTA1//'.0001','L',JNFOND)
C
            CALL LTNOTB(FISS,'FOND_FISS',NOMTA2)
            CALL JEVEUO(NOMTA2//'.TBNP','L',JTAIL)
C
            NFOND = ZI(JNFOND)
            NGFON = NGFON + NFOND
            DO 20 IFON=1,NFOND
              NBNOL = ZI(JBNFMU + 2*IFON -1) - ZI(JBNFMU + 2*IFON -2)
              IF (NBNOL.NE.0) THEN
                MFTOT = MFTOT + NBNOL
                NFCOMF = NFCOMF + 2*(NBNOL)
              ELSE
C               SI MAILLE POI1 EN 3D
                MFTOT = MFTOT + 1
                NFCOMF = NFCOMF + 1
              ENDIF
  20        CONTINUE
            NFTOT = NFTOT + ZI(JTAIL + 1)
C
          ENDIF
  11    CONTINUE
      ENDIF
      
      END
