      SUBROUTINE SS2MME(NOMO  ,MOTFAZ,VESSTR,BASE)
C      
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF SOUSTRUC  DATE 06/07/2009   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT NONE
      CHARACTER*8   NOMO
      CHARACTER*19  VESSTR
      CHARACTER*1   BASE
      CHARACTER*(*) MOTFAZ
C      
C ----------------------------------------------------------------------
C
C PREPARER LE VECT_ELEM DANS LE CAS DE SOUS-STRUCTURES
C
C      
C ----------------------------------------------------------------------
C
C IN  NOMO   : NOM DU MODELE
C IN  MOTFAC : MOT-CLEF FACTEUR DECRIVANT LES SOUS-STRUCTURES
C IN  BASE   : BASE DE CREATION DU VECT_ELEM
C I/O VESSTR : NOM DU VECT_ELEM
C                OUT : VESSTR EST (EVENTUELLEMENT) ENRICHI DE 
C                L'OBJET .RELC
C
C -------------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ----------------
C
      CHARACTER*32 JEXNUM,JEXNOM
      INTEGER ZI
      COMMON /IVARJE/ ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C -------------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ----------------
C
      CHARACTER*8  NOMA  ,K8BID ,NOSMA ,NOMCAS,NOMACR
      INTEGER      NBSSA ,NBSMA ,N1    ,N2    ,NBOC
      INTEGER      IAREFR,IALMAI,IALSCH,IMAS  ,IASSSA,IAMACR
      INTEGER      IER0  ,IOC   ,I     ,IBID  ,IERD  ,IRET
      CHARACTER*16 MOTFAC,VALK(2)     
C      
C ----------------------------------------------------------------------
C      
      CALL JEMARQ()
C      
      MOTFAC = MOTFAZ
      CALL GETFAC(MOTFAC,NBOC  )
      IF (NBOC.EQ.0) GO TO 9999
C
C --- INITIALISATIONS
C
      CALL DISMOI('F','NOM_MAILLA'  ,NOMO,'MODELE',IBID ,NOMA,IERD)
      CALL DISMOI('F','NB_SS_ACTI'  ,NOMO,'MODELE',NBSSA,K8BID,IERD)
      CALL DISMOI('F','NB_SM_MAILLA',NOMO,'MODELE',NBSMA,K8BID,IERD)
C
      IF (NBSSA.EQ.0) THEN
        CALL U2MESS('F','SOUSTRUC_24')
      END IF
C
      CALL JEVEUO(NOMO//'.MODELE    .SSSA','L',IASSSA)
      CALL JEVEUO(NOMA//'.NOMACR','L',IAMACR)
C
      CALL JEVEUO(VESSTR(1:19)//'.RERR','E',IAREFR)
      ZK24(IAREFR-1+3)='OUI_SOUS_STRUC'
C
      CALL JECREC(VESSTR(1:19)//'.RELC',BASE//' V I','NO','CONTIG',
     &             'CONSTANT',NBOC)
      CALL JEECRA(VESSTR(1:19)//'.RELC','LONMAX',NBSMA,K8BID)
C
      CALL WKVECT('&&SS2MME.LMAI','V V K8',NBSMA,IALMAI)
C
C --- BOUCLE SUR LES CAS_DE_CHARGE
C 
      IER0   = 0
      DO 10 IOC= 1,NBOC
C
        CALL GETVTX(MOTFAC,'CAS_CHARGE',IOC,1,1,NOMCAS,N1)
        CALL JECROC(JEXNOM(VESSTR(1:19)//'.RELC',NOMCAS))
        CALL JEVEUO(JEXNOM(VESSTR(1:19)//'.RELC',NOMCAS),'E',IALSCH)
C
C       -- CAS : TOUT: 'OUI' 
C       
        CALL GETVTX(MOTFAC,'TOUT',IOC   ,1     ,1     ,
     &              K8BID ,N1)
        IF (N1.EQ.1) THEN
          DO 1 I=1,NBSMA
            IF (ZI(IASSSA-1+I).EQ.1) ZI(IALSCH-1+I)=1
 1        CONTINUE
          GO TO 5
        END IF
C
C       -- CAS : MAILLE: L_MAIL
C       
        CALL GETVTX(MOTFAC,'SUPER_MAILLE',IOC   ,1     ,0     ,
     &              K8BID ,N2)
        IF (-N2.GT.NBSMA) THEN
          CALL U2MESS('F','SOUSTRUC_25')
        ELSE  
          CALL GETVTX(MOTFAC,'SUPER_MAILLE',IOC   ,1     ,NBSMA  ,
     &                ZK8(IALMAI),N2)
        ENDIF
        DO 2 I=1,N2
          NOSMA  = ZK8(IALMAI-1+I)
          CALL JENONU(JEXNOM(NOMA//'.SUPMAIL',NOSMA),IMAS)
          IF (IMAS.EQ.0) THEN
            VALK(1) = NOSMA
            VALK(2) = NOMA
            CALL U2MESK('F','SOUSTRUC_26', 2 ,VALK)
          ELSE
            ZI(IALSCH-1+IMAS)=1
          END IF
 2      CONTINUE
C
C       -- ON VERIFIE QUE LES VECTEURS ELEMENTAIRES SONT CALCULES
C 
 5      CONTINUE
        DO 3 I=1,NBSMA
          IF (ZI(IALSCH-1+I).NE.0) THEN 
            CALL JENUNO(JEXNUM(NOMA//'.SUPMAIL',I),NOSMA)
            IF (ZI(IASSSA-1+I).NE.1) THEN
              CALL U2MESK('F','SOUSTRUC_27',1,NOSMA)
            ENDIF  
C
            NOMACR = ZK8(IAMACR-1+I)
            CALL JEEXIN(JEXNOM(NOMACR//'.LICA',NOMCAS),IRET)
            IF (IRET.EQ.0) THEN
               IER0    = 1
               VALK(1) = NOSMA
               VALK(2) = NOMCAS
               CALL U2MESK('E','SOUSTRUC_28', 2 ,VALK)
            END IF
          ENDIF
 3      CONTINUE
C
 10   CONTINUE
C
      IF (IER0.EQ.1) CALL U2MESS('F','SOUSTRUC_29')
C
      CALL JEDETR('&&SS2MME.LMAI')
C
 9999 CONTINUE
      CALL JEDEMA()
      END
