      SUBROUTINE SSDMU1(DREF,CRIT,PREC,GEO1,GEO2,ICONF)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF SOUSTRUC  DATE 29/09/2006   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
C     ARGUMENTS:
C     ----------
      CHARACTER*(*) CRIT
      REAL*8 PREC,GEO1(3),GEO2(3),DREF
      CHARACTER*8   CRIT2
      REAL*8 DIST,A1,A2,A3
      INTEGER ICONF
C ----------------------------------------------------------------------
C     BUT:
C        - DETERMINER SI DEUX NOEUDS DE COORDONEES GEO1 ET GEO2
C          SONT CONFONDUS GEOMETRIQUEMENT.
C
C     IN:
C        DREF : DISTANCE DE REFERENCE POUR LE CRITERE RELATIF
C      CRIT : CRITERE : 'RELATIF' OU 'ABSOLU'
C      PREC : PRECISION
C      GEO1 : GEOMETRIE DU 1ER NOEUD
C      GEO2 : GEOMETRIE DU 2EM NOEUD
C
C     OUT:
C       ICONF: 0 --> LES 2 NOEUDS SONT CONFONDUS. (1 SINON)
C ----------------------------------------------------------------------
C
C
      CRIT2=CRIT
      A1= GEO1(1)-GEO2(1)
      A2= GEO1(2)-GEO2(2)
      A3= GEO1(3)-GEO2(3)
      DIST= SQRT(A1**2+A2**2+A3**2)
C
      ICONF=1
      IF (CRIT2(1:6).EQ.'ABSOLU') THEN
        IF (DIST.LE.PREC) ICONF=0
      ELSE IF (CRIT2(1:7).EQ.'RELATIF') THEN
        IF (DIST.LE.PREC*DREF) ICONF=0
      ELSE
        CALL U2MESK('F','ALGORITH3_42',1,CRIT2)
      END IF
C
      END
