      SUBROUTINE ONERRF(SET, GET, LONG)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF SUPERVIS  DATE 04/04/2011   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
      IMPLICIT NONE
C RESPONSABLE COURTOIS M.COURTOIS
C     ----------------------------------------------------------------
C     QUE FAIT-ON EN CAS D'ERREUR <F> ?
C        VEXCF = 0 == ARRET AVEC ABORT
C        VEXCF = 1 == EXCEPTION FATALE (SUPPRESSION DU CONCEPT COURANT)
C        VEXCF = 2 == EXCEPTION SURE (ON VALIDERA LE CONCEPT COURANT)
C
C     POUR DEFINIR LE COMPORTEMENT EN CAS D'ERREUR : SET EN IN
C     POUR RECUPERER LA VALEUR COURANTE : SET=' ', GET, LONG EN OUT
C
C IN  SET : VALEUR DU NOUVEAU COMPORTEMENT (ABORT OU EXCEPTION)
C OUT GET : VALEUR ACTUELLE DU COMPORTEMENT
C OUT LEN : LONGUEUR DE GET EN SORTIE
C
C     VINI CONTIENT LA VALEUR FIXEE PAR DEBUT (INITIALISER AU 1ER APPEL)
C     ----------------------------------------------------------------
      CHARACTER*(*)     SET
      CHARACTER*16           GET
      INTEGER                     LONG
C     ----------------------------------------------------------------
      INTEGER          LXLGUT
      INTEGER          VEXCF, VINI
      SAVE             VEXCF, VINI
      DATA VEXCF       /  0 /
      DATA VINI        / -1 /
C     ----------------------------------------------------------------
C
C     SI DANS DEBUT, ON A CHOISI ABORT, ON Y RESTE
      IF ( VINI .EQ. 0 ) THEN
         GET='ABORT'
         GOTO 99
      ENDIF
C
      GET = SET
C --- L'INITIALISATION EST FAITE PAR UN PREMIER APPEL AVEC SET<>' '
C
C --- ON RECUPERE LA VALEUR ACTUELLE
      IF     (SET(1:1) .EQ. ' ') THEN
C        ON RETOURNE LA VALEUR COURANTE
         IF     (VEXCF .EQ. 0) THEN
            GET='ABORT'
         ELSEIF (VEXCF .EQ. 1) THEN
            GET='EXCEPTION'
         ELSEIF (VEXCF .EQ. 2) THEN
            GET='EXCEPTION+VALID'
         ELSE
            WRITE(6,*) 'ERREUR DE PROGRAMMATION : ONERRF NUMERO 1'
            CALL JEFINI('ERREUR')
         ENDIF
C
C --- ON POSITIONNE LA VALEUR
      ELSEIF (SET .EQ. 'INIT') THEN
C        PERMET DE REMETTRE LA VALEUR INITIALE
         VEXCF=VINI

      ELSEIF (SET .EQ. 'EXCEPTION+VALID') THEN
C        EXCEPTION EN CAS D'ERREUR ET VALIDATION DU CONCEPT COURANT
         VEXCF=2

      ELSEIF (SET .EQ. 'EXCEPTION') THEN
C        EXCEPTION EN CAS D'ERREUR ET SUPPRESSION DU CONCEPT COURANT
         VEXCF=1

      ELSEIF (SET .EQ. 'ABORT') THEN
C        "CALL ABORT" EN CAS D'ERREUR
         VEXCF=0

      ELSE
C        PAS D'ASSERT ICI (RECURSIVITE)
         WRITE(6,*) 'ERREUR DE PROGRAMMATION : ONERRF NUMERO 2'
         CALL JEFINI('ERREUR')
      ENDIF
C
   99 CONTINUE
      LONG = LXLGUT(GET)
C
      IF ( VINI.LT.0 .AND. SET(1:1).NE.' ') THEN
         VINI = VEXCF
      ENDIF
C
      END
