      SUBROUTINE ANGVEC(V1,V2,ANGLE)
      IMPLICIT NONE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 18/10/2005   AUTEUR JMBHH01 J.M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2005  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C     CALCUL DE L'ANGLE ENTRE DEUX VECTEURS EN 3D.
C     IN : V1(3)
C     IN : V2(3)
C     OUT : ANGLE
C     ATTENTION L'ORDRE V1, V2 EST IMPORTANT POUR LE SIGNE DE ANGLE
C     L'ANGLE RETOURNE EST COMPRIS ENTRE -PI ET PI (ATAN2)

      REAL*8 V1(3),V2(3),ANGLE,COSPHI,SINPHI,V1V2(3),NV1,NV2,NORM(3),NV3
      INTEGER I
      
      CALL NORMEV(V1,NV1)
      CALL NORMEV(V2,NV2)
      COSPHI = 0.D0
      DO 10 I=1,3
         COSPHI = COSPHI + V1(I)*V2(I)
 10   CONTINUE
      CALL PROVEC ( V1 , V2 , NORM)
      CALL NORMEV ( NORM,NV3)
      CALL PROVEC ( V1 , V2 , V1V2)
      SINPHI = 0.D0      
      DO 20 I=1,3
         SINPHI = SINPHI + NORM(I)*V1V2(I)
 20   CONTINUE
      ANGLE= ATAN2(SINPHI,COSPHI)  
      END
