      SUBROUTINE EULNAU(ANGEUL,ANGNAU)
      IMPLICIT NONE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 05/09/2006   AUTEUR JOUMANA J.EL-GHARIB 
C ======================================================================
C COPYRIGHT (C) 1991 - 2006  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C     PASSAGE DES ANGLES D'EULER AUX ANGLES NAUTIQUES
C     IN : ANGEUL(3) : 3 ANGLES D'EULER EN DEGRES
C     OUT : ANGNAU(3) : 3 ANGLES NAUTIQUES EN DEGRES

      REAL*8 ANGNAU(3),PN(3,3),PE(3,3),ANGEUL(3),XL(3),YL(3),ZL(3)
      REAL*8 COSTHE,R8DGRD
      REAL*8 XG(3),YG(3),ZG(3),X1(3),COSPHI,PHI,SINPHI,ZLZG(3),SINTHE
      REAL*8 COSPH1,XGX1(3),R8MIEM,PSI,THETA,COEF,R8PI,COSPSI,SINPSI
      INTEGER I

      PSI  =ANGEUL(1)*R8DGRD()
      THETA=ANGEUL(2)*R8DGRD()
      PHI  =ANGEUL(3)*R8DGRD()
      COSPHI=COS(PHI)
      COSPSI=COS(PSI)
      COSTHE=COS(THETA)
      SINPHI=SIN(PHI)
      SINPSI=SIN(PSI)
      SINTHE=SIN(THETA)

C     MATRICE ROTATION ASSOCIEE AUX ANGLES D'EULER
      PE(1,1)= COSPHI *COSPSI - SINPHI *COSTHE *SINPSI
      PE(2,1)= COSPHI *SINPSI + SINPHI *COSTHE *COSPSI
      PE(3,1)= SINPHI *SINTHE
      PE(1,2)= -SINPHI *COSPSI - COSPHI *COSTHE *SINPSI
      PE(2,2)= -SINPHI *SINPSI + COSPHI *COSTHE *COSPSI
      PE(3,2)= COSPHI *SINTHE
      PE(1,3)= SINTHE *SINPSI
      PE(2,3)= -SINTHE *COSPSI
      PE(3,3)= COSTHE
C     EXPRESSION DES VECTEURS DE LA BASE LOCALE DANS LE REPERE LOCAL
      DO 1 I=1,3
         XG(I)=PE(I,1)
         YG(I)=PE(I,2)
C         ZG(I)=PE(I,3)
   1  CONTINUE     

      CALL ANGVXY(XG, YG, ANGNAU)

      IF(ANGNAU(1).LT.0.D0) ANGNAU(1)=ANGNAU(1)+2.0D0*R8PI()
      IF(ANGNAU(2).LT.0.D0) ANGNAU(2)=ANGNAU(2)+2.0D0*R8PI()
      IF(ANGNAU(3).LT.0.D0) ANGNAU(3)=ANGNAU(3)+2.0D0*R8PI()

      ANGNAU(1)=ANGNAU(1)/R8DGRD()
      ANGNAU(2)=ANGNAU(2)/R8DGRD()
      ANGNAU(3)=ANGNAU(3)/R8DGRD()

      
      END
