      SUBROUTINE INITIA(NEQ   ,LGROT ,INDRO ,CHAMRO,CHAMIN)
C      
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 17/01/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      LOGICAL  LGROT
      INTEGER  NEQ,INDRO(*)
      REAL*8   CHAMRO(*),CHAMIN(*)    
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME - UTILITAIRE)
C
C INITIALISE UN CHAM_NO EN TENANT COMPTE DES GRANDES ROTATIONS
C      
C ----------------------------------------------------------------------
C 
C
C IN  NEQ    : LONGUEUR DES CHAM_NO
C IN  LGROT  : TRUE  S'IL Y A DES DDL DE GRDE ROTATION
C                       FALSE SINON
C IN  INDRO  : VECTEUR DONNANT LE TYPE DES DDL:
C                 0: TRANSLATION OU PETITE ROTATION
C                 1: GRANDE ROTATION
C IN  CHAMRO  : CHAM_NO DONNE
C OUT CHAMIN  : CHAM_NO INITIALISE
C 
C    SI LGROT=FALSE:  ZERO
C    SI LGROT=TRUE :  ZERO POUR LES DDL DE TRANSLATION OU DE
C                      PETITE ROTATION
C                      LA VALEUR DE MME RANG EXTRAITE DE CHAMRO
C                      POUR LES DDL DE GRANDE ROTATION
C      
C ----------------------------------------------------------------------
C 
      REAL*8  ZERO
      INTEGER I
C      
C ----------------------------------------------------------------------
C 
      ZERO = 0.D0
      IF (.NOT.LGROT) THEN
        DO 10 I=1,NEQ
          CHAMIN(I) = ZERO
10      CONTINUE
      ELSE
        DO 20 I=1,NEQ
          IF (INDRO(I).EQ.0) THEN
            CHAMIN(I) = ZERO
          ELSE IF (INDRO(I).EQ.1) THEN
            CHAMIN(I) = CHAMRO(I)
          ELSE
            CALL ASSERT(.FALSE.)
          ENDIF
20      CONTINUE
      ENDIF
      END
