      SUBROUTINE MODOPT ( RESUCO, LESOPT, NBOPT )
      IMPLICIT   NONE
      INTEGER             NBOPT
      CHARACTER*8         RESUCO
      CHARACTER*24        LESOPT
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 19/05/2011   AUTEUR MACOCCO K.MACOCCO 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
C    CETTE ROUTINE AJOUTE DES OPTIONS DE CALCUL DANS CALC_ELEM SI
C    CELLES-CI ONT ETE OMISES :
C
C    SI EPTU_ELNO ALORS EPSI_ELGA
C    SI EPTQ_ELNO ALORS EPEQ_ELGA
C    SI SITQ_ELNO ALORS SIEQ_ELGA
C    SI ERZ1_ELEM ALORS SIEF_ELGA PUIS SIZ1_NOEU
C    SI SIZ1_NOEU ALORS SIEF_ELGA
C    SI ERZ2_ELEM ALORS SIEF_ELGA PUIS SIZ2_NOEU
C    SI SIZ2_NOEU ALORS SIEF_ELGA
C    SI DERA_ELNO ALORS DERA_ELGA
C
C ----------------------------------------------------------------------
C     ----- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      INTEGER           ZI
      COMMON / IVARJE / ZI(1)
      REAL*8            ZR
      COMMON / RVARJE / ZR(1)
      COMPLEX*16        ZC
      COMMON / CVARJE / ZC(1)
      LOGICAL           ZL
      COMMON / LVARJE / ZL(1)
      CHARACTER*8       ZK8
      CHARACTER*16              ZK16
      CHARACTER*24                       ZK24
      CHARACTER*32                                ZK32
      CHARACTER*80                                         ZK80
      COMMON / KVARJE / ZK8(1), ZK16(1), ZK24(1), ZK32(1), ZK80(1)
C     ----- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
      INTEGER       N1, JOPT, IEPSI, IERZ1, IERZ2, INOZ1, INOZ2, JOPT2,
     &              I, J, NBOPT2, INDK16,IEPEQ,ISIEQ, IRET, IDERA
      CHARACTER*8   K8B
      CHARACTER*16  TYSD
      CHARACTER*24  LESOP2
C DEB ------------------------------------------------------------------
C
      CALL JEMARQ()
C
      CALL GETTCO ( RESUCO, TYSD )
C
      CALL GETVTX ( ' ', 'OPTION', 1,1,0, K8B, N1 )
      NBOPT = -N1
      CALL WKVECT ( LESOPT, 'V V K16', NBOPT, JOPT )
      CALL GETVTX (' ', 'OPTION'  , 1, 1, NBOPT, ZK16(JOPT), N1)
C
      IEPSI = INDK16( ZK16(JOPT), 'EPTU_ELNO', 1, NBOPT )
C
      IEPEQ = INDK16( ZK16(JOPT), 'EPTQ_ELNO', 1, NBOPT )
C
      ISIEQ = INDK16( ZK16(JOPT), 'SITQ_ELNO', 1, NBOPT )
C
      IERZ1 = INDK16( ZK16(JOPT), 'ERZ1_ELEM', 1, NBOPT )
C
      IERZ2 = INDK16( ZK16(JOPT), 'ERZ2_ELEM', 1, NBOPT )
C
      INOZ1 = INDK16( ZK16(JOPT), 'SIZ1_NOEU', 1, NBOPT )
C
      INOZ2 = INDK16( ZK16(JOPT), 'SIZ2_NOEU', 1, NBOPT )
C
      IDERA = INDK16( ZK16(JOPT), 'DERA_ELGA', 1, NBOPT )
C
      IF ( IEPSI+IERZ1+IERZ2+INOZ1+INOZ2+IDERA .EQ. 0 ) GOTO 9999
C
      LESOP2 = '&&OP0058.NEW_OPTION'
      CALL JEDUPO ( LESOPT , 'V', LESOP2 , .FALSE. )
      CALL JEDETR ( LESOPT )
      CALL WKVECT ( LESOPT , 'V V K16' , NBOPT+3 , JOPT )
      CALL JEVEUO ( LESOP2 , 'L', JOPT2 )
C
      NBOPT2 = 1
C
      IF (IEPSI.NE.0) THEN
        ZK16(JOPT+NBOPT2-1) = 'EPSI_ELGA'
        NBOPT2 = NBOPT2 + 1
        ZK16(JOPT+NBOPT2-1) = 'EPTU_ELNO'
        NBOPT2 = NBOPT2 + 1
      ENDIF
C
      IF (IDERA.NE.0) THEN
        ZK16(JOPT+NBOPT2-1) = 'DERA_ELGA'
        NBOPT2 = NBOPT2 + 1
        ZK16(JOPT+NBOPT2-1) = 'DERA_ELNO'
        NBOPT2 = NBOPT2 + 1
      ENDIF
C
      IF (IEPEQ.NE.0 ) THEN
         ZK16(JOPT+NBOPT2-1) = 'EPEQ_ELGA'
         NBOPT2 = NBOPT2 + 1
         ZK16(JOPT+NBOPT2-1) = 'EPTQ_ELNO'
         NBOPT2 = NBOPT2 + 1
      ENDIF
C
      IF (ISIEQ.NE.0 ) THEN
         ZK16(JOPT+NBOPT2-1) = 'SIEQ_ELGA'
         NBOPT2 = NBOPT2 + 1
         ZK16(JOPT+NBOPT2-1) = 'SITQ_ELNO'
         NBOPT2 = NBOPT2 + 1
      ENDIF
         NBOPT2 = NBOPT2 - 1

C
      IF( ( IERZ1 .NE. 0 ).OR.
     &          ( IERZ2 .NE. 0 ).OR.
     &          ( INOZ1 .NE. 0 ).OR.
     &          ( INOZ2 .NE. 0 )) THEN
        IF ( TYSD .EQ. 'EVOL_ELAS' ) THEN
           CALL RSCHEX ( RESUCO, 'SIEF_ELGA', IRET )
           IF ( IRET .EQ. 0 ) THEN
              CALL U2MESS('A','UTILITAI2_52')
              NBOPT2 = NBOPT2 + 1
              ZK16(JOPT+NBOPT2-1) = 'SIEF_ELGA'
           ENDIF
        ENDIF
      ENDIF
C
      IF ( IERZ1 .NE. 0 ) THEN
         NBOPT2 = NBOPT2 + 1
         ZK16(JOPT+NBOPT2-1) = 'SIZ1_NOEU'
         NBOPT2 = NBOPT2 + 1
         ZK16(JOPT+NBOPT2-1) = 'ERZ1_ELEM'
      ENDIF
C
      IF ( IERZ2 .NE. 0 ) THEN
         NBOPT2 = NBOPT2 + 1
         ZK16(JOPT+NBOPT2-1) = 'SIZ2_NOEU'
         NBOPT2 = NBOPT2 + 1
         ZK16(JOPT+NBOPT2-1) = 'ERZ2_ELEM'
      ENDIF
C
      DO 10 I = 1 , NBOPT
         DO 12 J = 1 , NBOPT2
            IF ( ZK16(JOPT2+I-1) .EQ. ZK16(JOPT+J-1) ) GOTO 10
 12      CONTINUE
         NBOPT2 = NBOPT2 + 1
         ZK16(JOPT+NBOPT2-1) = ZK16(JOPT2+I-1)
 10   CONTINUE
C
      NBOPT = NBOPT2
      CALL JEDETR ( LESOP2 )
C
 9999 CONTINUE
      CALL JEDEMA()
      END
