      SUBROUTINE NAUEUL(ANGNAU,ANGEUL)
      IMPLICIT NONE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 05/09/2006   AUTEUR JOUMANA J.EL-GHARIB 
C ======================================================================
C COPYRIGHT (C) 1991 - 2005  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C     PASSAGE DES ANGLES NAUTIQUES AUX ANGLES D'EULER
C     IN : ANGNAU(3) : 3 ANGLES NAUTIQUES
C     OUT : ANGEUL(3) : 3 ANGLES D'EULER ENTRE 0 ET 2PI

      REAL*8 ANGNAU(3),PN(3,3),PE(3,3),ANGEUL(3),XL(3),YL(3),ZL(3)
      REAL*8 XG(3),YG(3),ZG(3),X1(3),COSPHI,PHI,SINPHI,ZLZG(3)
      REAL*8 COSPH1,XGX1(3),R8MIEM,PHI1,PHI2,COEF,R8PI,NV3
      INTEGER I

C     MATRICE ROTATION ASSOCIEE AUX ANGLES NAUTIQUES 
     
      CALL MATROT(ANGNAU,PN)
      
C     3 VECTEURS UNITAIRES DE BASE
     
      CALL R8INIR(3,0.D0, XL,1)
      CALL R8INIR(3,0.D0, YL,1)
      CALL R8INIR(3,0.D0, ZL,1)
      XL(1)=1.D0
      YL(2)=1.D0
      ZL(3)=1.D0

C     EXPRESSION DES COORDONNEES DES 3 VECTEURS DE LA BASE LOCALE
C     DANS LE REPERE GLOBAL      
      CALL UTPVLG ( 1 , 3 , PN , XL , XG )
      CALL UTPVLG ( 1 , 3 , PN , YL , YG )
      CALL UTPVLG ( 1 , 3 , PN , ZL , ZG )

C     CALCUL DE X1       
      CALL PROVEC ( ZL , ZG , ZLZG)
      
      CALL NORMEV ( ZLZG,NV3)
      IF (NV3.LT.R8MIEM()) THEN
          DO 20 I=1,3
             X1(I)=XG(I)
 20       CONTINUE
      ELSE
          DO 30 I=1,3
             X1(I)=ZLZG(I)
 30        CONTINUE
      ENDIF
      
C     PREMIER ANGLE D'EULER : PHI1 (OU PSI )
      CALL ANGROT(XL,X1,ZL,PHI1)       
C     DEUXIEME ANGLE D'EULER : PHI (OU THETA)
      CALL ANGROT(ZL,ZG,X1,PHI)
C     DEUXIEME ANGLE D'EULER : PHI2 (OU PHI)
      CALL ANGROT(X1,XG,ZG,PHI2)

      ANGEUL(1)=PHI1
      ANGEUL(2)=PHI
      ANGEUL(3)=PHI2
      IF(ANGEUL(1).LT.0.D0) ANGEUL(1)=ANGEUL(1)+2.0D0*R8PI()
      IF(ANGEUL(2).LT.0.D0) ANGEUL(2)=ANGEUL(2)+2.0D0*R8PI()
      IF(ANGEUL(3).LT.0.D0) ANGEUL(3)=ANGEUL(3)+2.0D0*R8PI()

      
      END
