      SUBROUTINE PSNOCO ( MOTFAC, IOCC, NOSIMP, TYPERR,
     >                    NBPASE, NOSTNC, CODRET )
C
C     PARAMETRES SENSIBLES - RECUPERATION DES NOMS COMPOSES
C     *          *                            **  **
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 04/04/2007   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C RESPONSABLE GNICOLAS G.NICOLAS
C ----------------------------------------------------------------------
C     POUR LA COMMANDE EN COURS, SOUS LE MOT-CLE FACTEUR MOTFAC,
C     ON A (EVENTUELLEMENT) DEFINI DES PARAMETRES DE SENSIBILITE AVEC
C     LE MOT-CLE SIMPLE HABITUEL.
C     CE PROGRAMME RETOURNE :
C     . LE NOMBRE DE PARAMETRES SENSIBLES
C     . UN TABLEAU CONTENANT DES COUPLES (NOM COMPOSE, NOM DU PARAMETRE
C       SENSIBLE), LE NOM COMPOSE ETANT BATI A PARTIR D'UN NOM SIMPLE
C       DONNE
C     CELA EST APPLICABLE AU COURS DU TRAITEMENT D'UNE COMMANDE
C ----------------------------------------------------------------------
C IN  MOTFAC  : NOM DU MOT CLE FACTEUR ASSOCIE
C               CHAINE BLANCHE POUR LE MOT-CLE SIMPLE SEUL
C IN  IOCC    : NUMERO D'OCCURENCE DU MOT-CLE FACTEUR
C IN  NOSIMP  : NOM SIMPLE
C IN  TYPERR  : COMPORTEMENT EN CAS D'ERREUR :
C               0 : ON RESSORT AVEC LE CODE DE RETOUR CODRET
C               NON NUL : ERREUR FATALE
C OUT NBPASE  : NOMBRE DE PARAMETRES DE SENSIBILITE / NOMS COMPOSES
C OUT NOSTNC  : STRUCTURE QUI CONTIENT LES NBPASE COUPLES
C               (NOM COMPOSE, NOM DU PARAMETRE SENSIBLE)
C               ELLE EST ALLOUEE DANS SENSNC
C OUT CODRET  : CODE DE RETOUR, 0 SI TOUT VA BIEN, NON NUL SINON
C ----------------------------------------------------------------------
C
      IMPLICIT   NONE
C
C 0.1. ==> ARGUMENTS
C
      INTEGER IOCC, NBPASE
      INTEGER TYPERR, CODRET
C
      CHARACTER*(*) MOTFAC, NOSIMP, NOSTNC
C
C 0.2. ==> COMMUNS
C
C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------
C
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
C
C 0.3. ==> VARIABLES LOCALES
C
      CHARACTER*6 NOMPRO
      PARAMETER ( NOMPRO = 'PSNOCO' )
C
      CHARACTER*08 SAUX08
      CHARACTER*13 INPSCO
C
C====
C 1. LECTURE DES PARAMETRES DU MOT-CLE PILOTANT LA SENSIBILITE
C    ON RECUPERE :
C    . LE NOMBRE DE PARAMETRES, NBPASE
C    . LA STRUCTURE QUI MEMORISE LES NOMS SIMPLES ET COMPOSES, INPSCO
C====
C
C               12   345678   90123
      INPSCO = '&&'//NOMPRO//'_PSCO'
C               12   345678
      SAUX08 = '&&'//NOMPRO
      CALL PSLECT ( MOTFAC, IOCC, SAUX08, NOSIMP, TYPERR,
     >              NBPASE, INPSCO, CODRET )
C
C====
C 2. S'IL Y A DES PARAMETRES SENSIBLES, ON RECUPERE LA LISTE DES NOMS
C    COMPOSES
C====
C
      IF ( CODRET.EQ.0 ) THEN
C
      IF ( NBPASE.GT.0 ) THEN
C
        CALL SENSNC ( NOSIMP, NBPASE, INPSCO, NOSTNC )
C
      ENDIF
C
      ENDIF
C
C====
C 3. MENAGE
C====
C
      CALL JEDETC ( ' ', INPSCO, 1 )
C
      END
