      SUBROUTINE PSTYSE ( NBPASE, INPSCO, NOPASE,
     &                    TYPESE, TYPEPS,
     &                    NBMOSI, LIMOSI, LIVALE, LIMOFA )
C
C     PARAMETRES SENSIBLES - TYPE DE SENSIBILITE
C     *          *           **      **
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 07/10/2008   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE GNICOLAS G.NICOLAS
C ----------------------------------------------------------------------
C RECUPERE LE TYPE DE SENSIBILITE ET LES MOTS-CLES CORRESPONDANTS
C ----------------------------------------------------------------------
C IN  NBPASE  : NOMBRE DE PARAMETRES SENSIBLES
C IN  INPSCO  : STRUCTURE CONTENANT LA LISTE DES NOMS
C               VOIR LA DEFINITION DANS SEGICO
C IN  NOPASE  : NOM DU PARAMETRE SENSIBLE
C OUT TYPESE  : TYPE DE SENSIBILITE GENERIQUE
C               -1 : DERIVATION EULERIENNE (VIA UN CHAMP THETA)
C                1 : CALCUL INSENSIBLE
C                2 : CONDITION AUX LIMITES DE DIRICHLET
C                3 : PARAMETRE MATERIAU
C                4 : CARACTERISTIQUE ELEMENTAIRE (COQUES, ...)
C                0 : AUTRE TYPE, DEPENDANT DE LA COMMANDE
C OUT TYPEPS  : TYPE DE SENSIBILITE POUR CE PARAMETRE
C OUT NBMOSI  : NOMBRE DE MOTS-CLES SIMPLES CONCERNES
C OUT LIMOSI  : NOM DE LA STRUCTURE K80 CONTENANT LES MOTS_CLES SIMPLES
C OUT LIVALE  : NOM DE LA STRUCTURE K80 CONTENANT LES VALEURS ASSOCIEES
C OUT LIMOFA  : LA STRUCTURE K80 CONTENANT LES MOTS-CLES FACTEURS
C ----------------------------------------------------------------------
C  PSTYSE --> PSTYPR, POUR RECUPERER DANS LA STRUCTURE D'ARCHIVAGE :
C                     1. LE TYPE DE SENSIBILITE GENERIQUE
C                     2. LES MOT-CLES SIMPLES
C                     3. LES VALEURS
C                     4. LES MOT-CLES FACTEURS
C
C     ARBORESCENCE DE LA GESTION DES PARAMETRES SENSIBLES :
C  NTTYSE --!
C  METYSE --> PSTYSE --> PSTYPR --> SEGICO
C
C  NTTYSE --!
C  METYSE --> PSTYSS --> PSREMC --> SEMECO
C                    --> PSTYST
C ----------------------------------------------------------------------
C
      IMPLICIT   NONE
C
C 0.1. ==> ARGUMENTS
C
      INTEGER NBPASE, TYPESE, NBMOSI
C
      CHARACTER*24 TYPEPS
      CHARACTER*(*) NOPASE, LIMOSI, LIVALE, LIMOFA
      CHARACTER*(*) INPSCO
C
C 0.2. ==> COMMUNS
C
C 0.3. ==> VARIABLES LOCALES
C
      CHARACTER*6 NOMPRO
      PARAMETER ( NOMPRO = 'PSTYSE' )
C
      INTEGER NBTYPA
      PARAMETER ( NBTYPA = 2 )
C
      INTEGER IAUX
      INTEGER TYPARA
C
      CHARACTER*16 TYPASE, TYPARF(NBTYPA)
C
C                    1234567890123456    1234567890123456
      DATA TYPARF / 'THETA_GEOM      ', 'PARA_SENSI      ' /
C
C====
C 1. PREALABLES
C====
C
C 1.2. ==> TYPE DU CONCEPT PARAMETRE SENSIBLE
C
      CALL GETTCO ( NOPASE, TYPASE )
C
      DO 12 , IAUX = 1 , NBTYPA
C
        IF ( TYPASE.EQ.TYPARF(IAUX) ) THEN
          TYPARA = IAUX
          GOTO 121
        ENDIF
C
   12 CONTINUE
C
      CALL U2MESK('A','SENSIBILITE_71', 1, NOPASE)
      CALL U2MESK('A','SENSIBILITE_73', 1, TYPASE)
      CALL U2MESK('A','SENSIBILITE_95', 0, NOMPRO )
      DO 122 , IAUX = 1 , NBTYPA
        CALL U2MESK('A','SENSIBILITE_73', 1, TYPARF(IAUX) )
  122 CONTINUE
      CALL ASSERT(.FALSE.)
C
  121 CONTINUE
C
C====
C 2. TYPE DE SENSIBILITE
C====
C
      IF ( TYPARA.EQ.1 ) THEN
C
        TYPESE = -1
C
      ELSEIF ( TYPARA.EQ.2 ) THEN
C
        CALL PSTYPR ( NBPASE, INPSCO, NOPASE,
     &                TYPEPS, NBMOSI, LIMOSI, LIVALE, LIMOFA )
C
        IF ( TYPEPS.EQ.' ' ) THEN
          TYPESE = 1
        ELSEIF ( TYPEPS.EQ.'DIRICHLE' ) THEN
          TYPESE = 2
        ELSEIF ( TYPEPS.EQ.'MATERIAU' ) THEN
          TYPESE = 3
        ELSEIF ( TYPEPS.EQ.'CARAELEM' ) THEN
          TYPESE = 4
        ELSE
          TYPESE = 0
        ENDIF
C
      ENDIF
C
      END
