      SUBROUTINE PSTYSS ( MBMCSR, NBMC, COREFE, MCSREF,
     >                    NBMOCL, LIVALE, NOPASE,
     >                    STYPSE )
C
C     PARAMETRE SENSIBLE - TYPE DE SENSIBILITE - SOUS-TYPE
C     *         *          **                    *  *
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 16/05/2007   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2002  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE GNICOLAS G.NICOLAS
C ----------------------------------------------------------------------
C IN  MBMCSR  : NOMBRE DE MOTS-CLES SIMPLES DE REFERENCE
C IN  NBMC    : NOMBRE DE MOTS-CLES EQUIVALENTS
C IN  COREFE  : LISTE DES CODES DE REFERENCE
C IN  MCSREF  : LISTE DES MOTS-CLES SIMPLES DE REFERENCE, A LA SUITE LES
C               UNS DES AUTRES
C IN  NBMOCL  : NOMBRE DE MOTS-CLES A TRAITER
C IN  LIVALE  : LA STRUCTURE K80 CONTENANT LES VALEURS CONCERNEES
C IN  NOPASE  : NOM DU PARAMETRE SENSIBLE
C IN/OUT STYPSE  : SOUS-TYPE DE SENSIBILITE
C ----------------------------------------------------------------------
C  PSTYSE --> PSGEMC, POUR RECUPERER DANS LA STRUCTURE D'ARCHIVAGE :
C                     1. LE NOMBRE DE MOTS-CLES SIMPLES ASSOCIES
C                     2. LES MOTS-CLES SIMPLES
C                     3. LES VALEURS
C                     4. LES MOTS-CLES FACTEURS
C  PSTYSE --> PSTYST, POUR RECUPERER DANS LA STRUCTURE D'ARCHIVAGE :
C                     1. LE SOUS-TYPE CORRESPONDANT PARMI CEUX DECRITS
C                        DANS COREFE
C
C ----------------------------------------------------------------------
C     ARBORESCENCE DE LA GESTION DES PARAMETRES SENSIBLES :
C  NTTYSE --!
C  METYSE --> PSTYSE --> PSTYPR --> SEGICO
C
C  NTTYSE --!
C  METYSE --> PSTYSS --> PSGEMC --> SEMECO
C                    --> PSTYST
C ----------------------------------------------------------------------
C
      IMPLICIT   NONE

C 0.1. ==> ARGUMENTS
C
      INTEGER MBMCSR, NBMC(MBMCSR), NBMOCL
C
      CHARACTER*(*) LIVALE, NOPASE
      CHARACTER*24 COREFE(MBMCSR), MCSREF(*)
      CHARACTER*24 STYPSE

C 0.1. ==> COMMUNS
C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------

C 0.3. ==> VARIABLES LOCALES
C
      CHARACTER*6 NOMPRO
      PARAMETER ( NOMPRO = 'PSTYSS' )
C
      INTEGER IAUX, JAUX
      INTEGER ADVALE
      INTEGER NBMOS1
      CHARACTER*24 LIMOS1, LIVAL1, LIMOF1
      CHARACTER*8 K8B
      INTEGER ADMOS1, ADVAL1, ADMOF1
C
      CALL JEMARQ()
C====
C 1. APPEL DU PROGRAMME DE BASE
C====
C                12   345678   9012345678901234
      LIMOS1  = '&&'//NOMPRO//'_LIMOS1         '
      LIVAL1  = '&&'//NOMPRO//'_LIVAL1         '
      LIMOF1  = '&&'//NOMPRO//'_LIMOF1         '
C
      CALL JEVEUO ( LIVALE, 'L', ADVALE )
C
      DO 11 , IAUX = 1 , NBMOCL
C
        NBMOS1 = 0
        CALL PSGEMC( ZK80(ADVALE+IAUX-1), NOPASE, NBMOS1, K8B, K8B, K8B)
C
        IF ( NBMOS1.GT.0 ) THEN
C
          CALL WKVECT ( LIMOS1,'V V K80',NBMOS1, ADMOS1 )
          CALL WKVECT ( LIVAL1,'V V K80',NBMOS1, ADVAL1 )
          CALL WKVECT ( LIMOF1,'V V K80',NBMOS1, ADMOF1 )
          CALL PSGEMC( ZK80(ADVALE+IAUX-1), NOPASE, NBMOS1,
     >                 ZK80(ADMOS1), ZK80(ADVAL1), ZK80(ADMOF1))
C
          DO 111 , JAUX = 1 , NBMOS1
            CALL PSTYST ( MBMCSR, NBMC, COREFE, MCSREF,
     >                    NBMOS1, LIMOS1, LIVAL1, LIMOF1,
     >                    STYPSE )
  111     CONTINUE
          CALL JEDETR ( LIMOS1 )
          CALL JEDETR ( LIVAL1 )
          CALL JEDETR ( LIMOF1 )
C
        ENDIF
C
   11 CONTINUE
C
      CALL JEDEMA()
C
      END
