      SUBROUTINE QUAVRO(QUATER,THETA )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 23/09/2008   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C TOLE CRP_6
C
       IMPLICIT NONE
       REAL*8   QUATER(4),THETA(3)
C 
C ----------------------------------------------------------------------
C
C ROUTINE UTILITAIRE (QUATERNION)
C
C CALCULE LE VECTEUR-ROTATION THETA CORRESPONDANT AU QUATERNION
C QUATER
C      
C ----------------------------------------------------------------------
C 
C       
C IN  QUATER : QUATERNION
C OUT THETA  : VECTEUR ROTATION
C      
C ----------------------------------------------------------------------
C
      REAL*8  RESTE,ZERO,EPSIL,DEUX,COEF
      REAL*8  PI,R8PREM
      REAL*8  DDOT
      REAL*8  PROSCA,ANORX
      INTEGER I
C      
C ----------------------------------------------------------------------
CC
      ZERO   = 0.D0
      EPSIL  = R8PREM( )**2
      DEUX   = 2.D0
      PI = 3.14159265D0
C
      PROSCA = DDOT(3,QUATER,1,QUATER,1)
      ANORX  = SQRT(PROSCA)
      IF (ANORX.GT.1.D0) ANORX = 1.D0
      IF (ANORX.LT.EPSIL) THEN
        DO 1 I=1,3
          THETA(I) = ZERO
1       CONTINUE
        GOTO 9999
      ENDIF
      RESTE = ASIN(ANORX)
C
      IF (QUATER(4).LT.ZERO) RESTE = PI - RESTE
C
      COEF = DEUX*RESTE/ANORX
C
      DO 10 I=1,3
        THETA(I) = COEF * QUATER(I)
10    CONTINUE
 9999 CONTINUE
      END
