      SUBROUTINE RSAGSD(NOMSD,ILONG)
      IMPLICIT   NONE
      INTEGER ILONG
      CHARACTER*(*) NOMSD
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 20/09/2010   AUTEUR LEFEBVRE J-P.LEFEBVRE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE VABHHTS J.PELLET
C       REDIMENSIONNEMENT D'UNE STRUCTURE DE DONNEES "RESULTAT-COMPOSE"
C       (LA TAILLE EST DOUBLEE SI LA LONGEUR VAUT 0)
C       LA SD RESTE INCHANGEE SI ELLE EXISTE ET SI LA TAILLE DEMANDEE 
C       EST INFERIEURE OU EGALE A L'ACTUELLE
C ----------------------------------------------------------------------
C IN  : NOMSD  : NOM DE LA STRUCTURE "RESULTAT" A AGRANDIR
C IN  : ILONG  : NOUVELLE LONGUEUR DE LA S.D.
C ----------------------------------------------------------------------
C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------
      CHARACTER*32 JEXNUM,JEXNOM
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
C ----------------------------------------------------------------------
      INTEGER IUNDEF,ISNNEM,IRET,IBID,NBCHAM,NBORDR,NBORLU,NEWNB,NEWORD,
     &        NEWORL,JTACHG,JTACHV,JORDRG,I,J,K,JORDRV,NBAC,NBPA,NBPARA,
     &        JPA,IPARA,ILEN,ILOTY,JPARAV,JPARA,IATAVA,NBPR,NEWNBT
      REAL*8 RUNDEF,R8VIDE
      INTEGER N1, N2, KK,IER1
      LOGICAL DEJFAI
      CHARACTER*4 TYPE,TYPACC
      CHARACTER*24 VALK(2)
      CHARACTER*24 NOMOBJ
      CHARACTER*8 K8B
      CHARACTER*16 NOPARA
      CHARACTER*19 NOMD2,NOMPAR
C ----------------------------------------------------------------------
      CALL JEMARQ()
      NOMD2 = NOMSD
      RUNDEF = R8VIDE()
      IUNDEF = ISNNEM()

      IF (ILONG.LT.0) CALL U2MESS('F','UTILITAI4_29')
      CALL JEEXIN(NOMD2//'.DESC',IRET)
      IF (IRET.EQ.0) CALL U2MESK('F','UTILITAI_40',1,NOMD2)

      CALL JELIRA(NOMD2//'.DESC','NOMMAX',NBCHAM,K8B)
      CALL JELIRA(NOMD2//'.ORDR','LONMAX',NBORDR,K8B)
      CALL JELIRA(NOMD2//'.ORDR','LONUTI',NBORLU,K8B)
      IF (ILONG.EQ.0) THEN
        NEWNB = 2*NBORDR
      ELSE
        NEWNB = ILONG
      END IF
      IF ( NEWNB.LE.NBORDR ) GOTO 9999
      NEWORD = MIN(NEWNB,NBORDR)
      NEWORL = MIN(NEWNB,NBORLU)


C    -- LE .DESC, .NOVA, .TAVA ---
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C     CES OBJETS NE SONT PAS MODIFIES



C     -- LE .TACH ET LE .ORDR ---
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CALL JEVEUO(NOMD2//'.TACH','L',JTACHG)
      CALL WKVECT('&&RSAGSD.TACH','V V K24',NEWORD*NBCHAM,JTACHV)
      CALL JEVEUO(NOMD2//'.ORDR','L',JORDRG)
      CALL WKVECT('&&RSAGSD.ORDR','V V I',MAX(NEWORL,1),JORDRV)
      DO 10 I = 0,NEWORL - 1
        ZI(JORDRV+I) = ZI(JORDRG+I)
   10 CONTINUE
      DO 30 I = 0,NBCHAM - 1
        DO 20 J = 0,NEWORD - 1
          ZK24(JTACHV+J+I*NEWORD) = ZK24(JTACHG+J+I*NBORDR)
   20   CONTINUE
   30 CONTINUE
      CALL JEDETR(NOMD2//'.TACH')
      CALL JEDETR(NOMD2//'.ORDR')
      CALL JECREC(NOMD2//'.TACH','G V K24','NU','CONTIG','CONSTANT',
     &            NBCHAM)
      CALL JEECRA(NOMD2//'.TACH','LONMAX',NEWNB,' ')
      CALL JEVEUO(NOMD2//'.TACH','E',JTACHG)
      DO 40,K = 1,NBCHAM
        CALL JECROC(JEXNUM(NOMD2//'.TACH',K))
   40 CONTINUE

      CALL WKVECT(NOMD2//'.ORDR','G V I',NEWNB,JORDRG)
      CALL JEECRA(NOMD2//'.ORDR','LONUTI',NEWORL,' ')

      DO 50 I = 0,NEWORL - 1
        ZI(JORDRG+I) = ZI(JORDRV+I)
   50 CONTINUE
      DO 70 I = 0,NBCHAM - 1
        DO 60 J = 0,NEWORD - 1
          ZK24(JTACHG+J+I*NEWNB) = ZK24(JTACHV+J+I*NEWORD)
   60   CONTINUE
   70 CONTINUE

      CALL JEDETR('&&RSAGSD.TACH')
      CALL JEDETR('&&RSAGSD.ORDR')



C     -- LES PARAMETRES :
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


      NOMOBJ=NOMD2//'.RSPR'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,K8B)
        N2=N1/NBORDR
        CALL ASSERT(N1.EQ.N2*NBORDR)
        CALL JUVECA(NOMOBJ,N2*NEWNB)
        CALL JEVEUO(NOMOBJ,'E',JPARA)
        DO 1, KK=N2*NBORDR+1, N2*NEWNB
          ZR(JPARA-1+KK)=RUNDEF
 1      CONTINUE
      ENDIF


      NOMOBJ=NOMD2//'.RSPC'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,K8B)
        N2=N1/NBORDR
        CALL JUVECA(NOMOBJ,N2*NEWNB)
        CALL JEVEUO(NOMOBJ,'E',JPARA)
        DO 2, KK=N2*NBORDR+1, N2*NEWNB
          ZC(JPARA-1+KK) = DCMPLX(RUNDEF,RUNDEF)
 2      CONTINUE
      ENDIF


      NOMOBJ=NOMD2//'.RSPI'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,K8B)
        N2=N1/NBORDR
        CALL JUVECA(NOMOBJ,N2*NEWNB)
        CALL JEVEUO(NOMOBJ,'E',JPARA)
        DO 3, KK=N2*NBORDR+1, N2*NEWNB
          ZI(JPARA-1+KK)=IUNDEF
 3      CONTINUE
      ENDIF


      NOMOBJ=NOMD2//'.RSP8'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,K8B)
        N2=N1/NBORDR
        CALL JUVECA(NOMOBJ,N2*NEWNB)
      ENDIF


      NOMOBJ=NOMD2//'.RS16'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,K8B)
        N2=N1/NBORDR
        CALL JUVECA(NOMOBJ,N2*NEWNB)
      ENDIF


      NOMOBJ=NOMD2//'.RS24'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,K8B)
        N2=N1/NBORDR
        CALL JUVECA(NOMOBJ,N2*NEWNB)
      ENDIF


      NOMOBJ=NOMD2//'.RS32'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,K8B)
        N2=N1/NBORDR
        CALL JUVECA(NOMOBJ,N2*NEWNB)
      ENDIF


      NOMOBJ=NOMD2//'.RS80'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,K8B)
        N2=N1/NBORDR
        CALL JUVECA(NOMOBJ,N2*NEWNB)
      ENDIF

 9999 CONTINUE

      CALL JEDEMA()

      END
