      SUBROUTINE RSUTN1 ( RESU, NOPARA, MOTCLE, IOCC, OBJVEU, NBORDR )
      IMPLICIT   NONE
      INTEGER          IOCC, NBORDR
      CHARACTER*16     NOPARA
      CHARACTER*(*)    RESU, MOTCLE, OBJVEU
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 20/02/2007   AUTEUR LEBOUVIER F.LEBOUVIER 
C ======================================================================
C COPYRIGHT (C) 1991 - 2005  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C     RECUPERATION DES NUMEROS D'ORDRE DANS UNE STRUCTURE DE DONNEES
C     DE TYPE "RESULTAT" A PARTIR D'UN NOM SYMBOLIQUE ET DES VARIABLES
C     D'ACCES UTILISATEUR
C     ------------------------------------------------------------------
C IN  : RESU   : NOM DE LA STRUCTURE DE DONNEES
C IN  : NOPARA : NOM SYMBOLIQUE DU CHAMP
C IN  : MOTCLE : NOM DU MOT CLE FACTEUR
C IN  : IOCC   : NUMERO D'OCCURENCE
C OUT : OBJVEU : NOM JEVEUX DU VECTEUR ZI POUR ECRIRE LA LISTE DES NUME
C OUT : NBORDR : NOMBRE DE NUMERO D'ORDRE VALIDE POUR LE NOPARA
C     ------------------------------------------------------------------
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C     ----- FIN COMMUNS NORMALISES  JEVEUX  ----------------------------
      INTEGER       IRET, II, IORDR, LORDR, JORDR, NP, NC, IRANG,
     &              NBACC, NBPAR, LACCE, NBTORD
      REAL*8        PREC
      CHARACTER*8   K8B, CRIT
      CHARACTER*16  K16B
      CHARACTER*19  CHAM19
      CHARACTER*24  KNUME
      CHARACTER*24 VALK(2)
C     ------------------------------------------------------------------
      CALL JEMARQ()
C
C     --- LECTURE DE LA PRECISION ET DU CRITERE ---
C
      CALL GETVR8 ( MOTCLE, 'PRECISION', IOCC,1,1, PREC, NP )
      CALL GETVTX ( MOTCLE, 'CRITERE'  , IOCC,1,1, CRIT, NC )
C
C     --- RECUPERATION DES NUMEROS D'ORDRE ---
C
      KNUME = '&&RSUTN1.NUME_ORDR'
      CALL RSUTNU ( RESU, MOTCLE, IOCC, KNUME, NBTORD, PREC, CRIT, IRET)
      IF ( IRET .NE. 0 ) THEN
         K8B = RESU
         CALL U2MESK('F','UTILITAI4_49',1,K8B)
      ENDIF
      CALL JEVEUO ( KNUME, 'L', LORDR )
C
C     --- VERIFICATION QUE LE NOPARA EXISTE DANS LA SD RESULTAT ---
C
      CALL RSNOPA ( RESU, 1, '&&RSUTN1.PARA.ACCES', NBACC, NBPAR )
      CALL JEEXIN ( '&&RSUTN1.PARA.ACCES', IRET )
      IF ( IRET .GT. 0 ) THEN
         CALL JEVEUO ( '&&RSUTN1.PARA.ACCES', 'L', LACCE )
          DO 10 IORDR = 1 , NBPAR
             IF ( NOPARA .EQ. ZK16(LACCE+IORDR-1) ) GOTO 12
 10      CONTINUE
         K8B = RESU
         VALK (1) = NOPARA
         VALK (2) = K8B
         CALL U2MESG('F', 'UTILITAI6_84',2,VALK,0,0,0,0.D0)
 12      CONTINUE
      ELSE
         CALL U2MESS('F','UTILITAI4_50')
      ENDIF
      CALL JEDETR ( '&&RSUTN1.PARA.ACCES' )
C
      II = 0
      DO 20 IORDR = 1,NBTORD
         CALL RSUTRG ( RESU, ZI(LORDR+IORDR-1), IRANG )
         IF (IRANG.EQ.0) GOTO 20
         II = II + 1
 20   CONTINUE
      IF ( II .EQ. 0 ) THEN
         CALL U2MESK('F','UTILITAI4_51',1,NOPARA)
      ENDIF
C
C     --- LISTE DES NUMEROS D'ORDRE ---
C
      NBORDR = 0
      CALL WKVECT ( OBJVEU, 'V V I', II, JORDR )
      DO 30 IORDR = 1,NBTORD
         CALL RSUTRG ( RESU, ZI(LORDR+IORDR-1), IRANG )
         IF (IRANG.NE.0) THEN
            NBORDR = NBORDR + 1
            ZI(JORDR+NBORDR-1) = ZI(LORDR+IORDR-1)
         ENDIF
 30   CONTINUE
C
      CALL JEDETR('&&RSUTN1.NUME_ORDR')
C
      CALL JEDEMA()
      END
