      SUBROUTINE SENSNC ( NOSIMP, NBPASE, INPSCO, NOSTNC )
C
C     SENSIBILITE - NOM DES STRUCTURES - NOMS COMPOSES
C     **            *       *            *    *
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 04/04/2007   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2002  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE GNICOLAS G.NICOLAS
C ----------------------------------------------------------------------
C     POUR LA STRUCTURE ACTIVE MEMORISANT LES DIVERS NOMS, CE PROGRAMME
C     RETOURNE LA LISTE DE TOUS LES NOMS COMPOSES A PARTIR D'UN NOM
C     SIMPLE ET DES PARAMETRES DE SENSIBILITE ARCHIVES
C     CELA EST APPLICABLE AU COURS DU TRAITEMENT D'UNE COMMANDE
C     A PRIORI, CE PROGRAMME NE DOIT ETRE APPELE QUE PAR UN AUTRE PSXXXX
C ----------------------------------------------------------------------
C IN  NOSIMP  : NOM SIMPLE
C IN  NBPASE  : NOMBRE DE PARAMETRES DE SENSIBILITE
C IN  INPSCO  : STRUCTURE CONTENANT LA LISTE DES NOMS
C               SA TAILLE ET SON CONTENU SONT DEFINIS DANS SEGICO
C OUT NOSTNC  : STRUCTURE QUI CONTIENT LES NBPASE COUPLES
C               (NOM COMPOSE, NOM DU PARAMETRE SENSIBLE)
C               ELLE EST ALLOUEE ICI
C
C ----------------------------------------------------------------------
C
      IMPLICIT   NONE
C
C 0.1. ==> ARGUMENTS
C
      INTEGER NBPASE
C
      CHARACTER*(*) NOSIMP, NOSTNC
      CHARACTER*(*) INPSCO
C
C 0.2. ==> COMMUNS
C
C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------
C
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------
C
C 0.3. ==> VARIABLES LOCALES
C
C
      INTEGER TYPEST
C
      INTEGER NBPSCO, ADSTNC
      INTEGER IAUX, JAUX, KAUX
C
      CHARACTER*08 SAUX08
      CHARACTER*24 SAUX24, NOMSTR
C
C====
C 1. RECHERCHE DU TYPE DE STRUCTURE CHOISIE
C====
C
C 1.1. ==> NOMBRE D'INFORMATIONS MEMORISEES
C
      CALL SEGICO ( 2,
     &              SAUX08, IAUX, SAUX24, SAUX24,
     &              INPSCO, NBPSCO, JAUX )
C
C 1.2. ==> POUR LE CAS NOMINAL, ON EXPLORE LES NOMS MEMORISES ET
C          ON LES COMPARE A CELUI VOULU
C
      TYPEST = -1
C
      DO 12 , KAUX = 3 , NBPSCO
C
        IAUX = 0
        JAUX = KAUX
C
        CALL PSNSLE ( INPSCO, IAUX, JAUX, NOMSTR )
C
        IF ( NOMSTR.EQ.NOSIMP ) THEN
          TYPEST = JAUX
        ENDIF
C
   12 CONTINUE
C
      IF ( TYPEST.LT.0 ) THEN
C
        CALL U2MESS('F','SENSIBILITE_81')
C
      ENDIF
C
C====
C 2. ECRITURE DES NOMS COMPOSES
C====
C
C 2.1. ==> ALLOCATION DE LA STRUCTURE
C
      IAUX = 2*NBPASE
      CALL WKVECT ( NOSTNC, 'V V K24', IAUX, ADSTNC )
C
C 2.2. ==> ECRITURE DU NOM COMPOSE ET DU PARAMETRE
C
      DO 22 , IAUX = 1 , NBPASE
C
        JAUX = IAUX
        KAUX = TYPEST
        CALL PSNSLE ( INPSCO, JAUX, KAUX, NOMSTR )
        ZK24(ADSTNC+2*IAUX-2) = NOMSTR
C
        KAUX = 1
        CALL PSNSLE ( INPSCO, JAUX, KAUX, NOMSTR )
        ZK24(ADSTNC+2*IAUX-1) = NOMSTR
C
   22 CONTINUE
C
      END
