      SUBROUTINE UTACLI(X, LISTE, INDMAX, TOLE, INDICE)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 21/02/2011   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================

      IMPLICIT NONE
      INTEGER  INDMAX, INDICE
      REAL*8   X, LISTE(0:INDMAX-1), TOLE

C ----------------------------------------------------------------------
C               RECHERCHE DANS UNE LISTE DE REELS MONOTONE
C ----------------------------------------------------------------------
C IN  X      : REEL RECHERCHE
C IN  LISTE  : LISTE (0:INDMAX-1) DE TAILLE INDMAX
C IN  INDMAX : INDICE MAXIMUM DANS LA LISTE
C IN  TOLE   : TOLERANCE ABSOLUE AUTORISEE
C OUT INDICE : INDICE DU REEL LE PLUS PROCHE DANS LE SEUIL DE TOLERANCE
C               INDICE = -1 : REEL NON TROUVE
C ----------------------------------------------------------------------

      INTEGER I
      REAL*8  DELTA, DELMIN
C ----------------------------------------------------------------------


C    RECHERCHE DU PREMIER INDICE CORRESPONDANT
      DO 10 I = 0, INDMAX-1
        DELTA = ABS(X-LISTE(I))
        IF (DELTA .LE. TOLE) GOTO 100
 10   CONTINUE

C    AUCUN INDICE TROUVE
      INDICE = -1
      GOTO 9999

C    RECHERCHE DE L'INDICE OPTIMAL (CARACTERE MONOTONE DE LA LISTE)
 100  CONTINUE
      INDICE = I
      DELMIN = DELTA
      DO 110 I = INDICE+1, INDMAX-1
        DELTA = ABS(X-LISTE(I))
        IF (DELTA.GT.DELMIN) GOTO 9999
        DELMIN = DELTA
        INDICE = I
 110  CONTINUE


 9999 CONTINUE
      END
