      SUBROUTINE UTTCPR (NOMMES,NBV,TEMPS)
      IMPLICIT NONE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 08/02/2010   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2009  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE PELLET J.PELLET
      CHARACTER *(*)  NOMMES
      INTEGER NBV
      REAL*8 TEMPS(NBV)
C ----------------------------------------------------------------------
C ROUTINE DE MESURE DU TEMPS CPU.
C BUT : RECUPERER LES VALEURS D'UNE MESURE DE TEMPS
C
C IN  NOMMES    : NOM IDENTIFIANT LA MESURE
C
C IN  NBV       : DIMENSION DU TABLEAU TEMPS
C OUT TEMPS     : TABLEAU CONTENANT LES MESURES
C ----------------------------------------------------------------------
C    TEMPS(1) TEMPS CPU RESTANT EN SECONDES
C    TEMPS(2) NOMBRE D'APPEL A DEBUT/FIN
C    TEMPS(3) TEMPS CPU TOTAL
C    TEMPS(4) TEMPS CPU MOYEN
C    TEMPS(5) TEMPS CPU USER TOTAL
C    TEMPS(6) TEMPS CPU SYSTEME
C    TEMPS(7) TEMPS ELAPSED
C
C RQUE : LES VALEURS STOCKEES SONT ACCUMUEES VIA UTTCPU
C ----------------------------------------------------------------------
C---------------- COMMUNS NORMALISES  JEVEUX  --------------------------
      COMMON /IVARJE/ZI(1)
      COMMON /RVARJE/ZR(1)
      COMMON /CVARJE/ZC(1)
      COMMON /LVARJE/ZL(1)
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      INTEGER ZI
      REAL*8 ZR
      COMPLEX*16 ZC
      LOGICAL ZL,LJEV
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32,JEXNOM
      CHARACTER*80 ZK80
C---------------- COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER INDI ,JVALMS,K


C     -- COMMONS POUR MESURE DE TEMPS :
      INTEGER  MTPNIV ,INDMAX
      PARAMETER (INDMAX=5)
      CHARACTER*80 SNOLON(INDMAX)
      REAL*8 VALMES(INDMAX*7),VALMEI(INDMAX*7)
      COMMON /MESTP1/  MTPNIV
      COMMON /MESTP2/ SNOLON
      COMMON /MESTP3/ VALMES,VALMEI
C ----------------------------------------------------------------------

C     1. CALCUL DE INDI ET LJEV :
C     -------------------------------
C     -- POUR CERTAINES MESURES, ON NE PEUT PAS FAIRE DE JEVEUX :
C        ON GARDE ALORS LES INFOS DANS LES COMMON MESTPX
      IF (NOMMES.EQ.'CPU.MEMD.1') THEN
         INDI=1
      ELSEIF (NOMMES.EQ.'CPU.MEMD.2') THEN
         INDI=2
      ELSE
         LJEV=.TRUE.
         CALL JENONU(JEXNOM('&&UTTCPU.NOMMES',NOMMES),INDI)
         IF (INDI.EQ.0) GOTO 9999
         GOTO 9998
      ENDIF
      CALL ASSERT(INDI.LE.INDMAX)
      LJEV=.FALSE.


C     2. RECUPERATION DES TEMPS :
C     -------------------------------
9998  CONTINUE
      IF (LJEV) THEN
        CALL JEVEUO('&&UTTCPU.VALMES','L',JVALMS)
        DO 1, K=1,NBV
          TEMPS(K)= ZR(JVALMS-1+7*(INDI-1)+K)
1       CONTINUE
      ELSE
        DO 2, K=1,NBV
          TEMPS(K)= VALMES(7*(INDI-1)+K)
2       CONTINUE
      ENDIF


9999  CONTINUE
      END
